<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John Vargas <jhonvargas@telesat.com.co>                     |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
// $Id: config.inc.php,v 1.4 2004/07/10 22:11:33 jhonvargas Exp $

/**
 * Archivo de configuracin bsica para 
 * El Sistema Manejador de Contenido CMS
 */
define('PATH_CMS', './');

// Incluir librerias de Phrame 
include('lib/phrame/include.php');

// Incluir librerias necesarias de Pear 
require_once "System.php";
require_once "Config.php";
require_once "File.php";
//require_once "Mail.php";
require_once 'DB/Pager.php';
require_once "Mail/Queue.php"; // incluye Mail.php y mime.php
//require_once 'lib/Mail/mime.php';
require_once "lib/HTTP/Request.php";
require_once 'Log.php';

// Incluir librerias propias del sistema
require_once 'lib/DB/DataObjectCMS.php'; // DataObject para DB Objeto-Relacioanl
require_once "lib/util.php"; // Metodos utiles
require_once "lib/image.php"; // Manipula imagenes
require_once "lib/generador.php"; // Genera sitios

// Idioma por defecto para el sistema
define('IDIOMA_DEFECTO','Espa&ntilde;ol');

// Numero de paginas a mostrar en busquedas
define ('MAXPAGES', 10);

// Nmero de registros a mostrar por pgina en las bsquedas
define ('NUM_REGISTROS', 20);

// Rutas de mdulos del sistema
define('PATH_SISTEMA','src/sistema/');
define('PATH_PROYECTO',PATH_SISTEMA);
define('PATH_CONTACTOS','src/contactos/');
define('PATH_PRODUCTOS','src/productos/');
define('PATH_CONTENIDO','src/contenido/');
define('PATH_FOTO_ALBUM','src/foto_album/');
define('PATH_HOJAS_DE_VIDA','src/hojas_de_vida/');
define('PATH_MENUS','src/menu/');
define('PATH_EVENTOS','src/eventos/');
define('PATH_DIRECTORIO','src/directorio/');
define('PATH_FORO','src/foro/');
define('PATH_CUESTIONARIOS','src/cuestionarios/');
define('PATH_DISENO','src/diseno/');
define('PATH_CONTRATOS','src/contratos/');
define('PATH_CINES','src/cines/');
define('PATH_NEWSLETTER','src/newsletter/');

/** Mapping **/
include('config/mappings.php');

// Objeto Mapping global
$go_map =& new CmsMap;

/** Incluir Modelo del sistema (Clases fachada de los modulos) **/
include(PATH_SISTEMA . 'modelo/fachada_sistema.php');
include(PATH_CONTENIDO . 'modelo/fachada_contenido.php');
include(PATH_MENUS . 'modelo/fachada_menus.php');


if (file_exists(PATH_CONTACTOS . 'modelo/fachada_contactos.php'))
    include(PATH_CONTACTOS . 'modelo/fachada_contactos.php');

if (file_exists(PATH_PRODUCTOS . 'modelo/fachada_productos.php'))
    include(PATH_PRODUCTOS . 'modelo/fachada_productos.php');

if (file_exists(PATH_FOTO_ALBUM . 'modelo/fachada_foto_album.php'))
    include(PATH_FOTO_ALBUM . 'modelo/fachada_foto_album.php');

if (file_exists(PATH_HOJAS_DE_VIDA . 'modelo/fachada_hojas_de_vida.php'))
    include(PATH_HOJAS_DE_VIDA . 'modelo/fachada_hojas_de_vida.php');

if (file_exists(PATH_EVENTOS . 'modelo/fachada_eventos.php'))
    include(PATH_EVENTOS . 'modelo/fachada_eventos.php');

if (file_exists(PATH_DIRECTORIO . 'modelo/fachada_directorio.php'))
    include(PATH_DIRECTORIO . 'modelo/fachada_directorio.php');

if (file_exists(PATH_FORO . 'modelo/fachada_foro.php'))
    include(PATH_FORO . 'modelo/fachada_foro.php');

if (file_exists(PATH_CUESTIONARIOS . 'modelo/fachada_cuestionarios.php'))
    include(PATH_CUESTIONARIOS . 'modelo/fachada_cuestionarios.php');

if (file_exists(PATH_DISENO . 'modelo/fachada_diseo.php'))
    include(PATH_DISENO . 'modelo/fachada_diseo.php');
	
if (file_exists(PATH_CONTRATOS . 'modelo/fachada_contratos.php'))
    include(PATH_CONTRATOS . 'modelo/fachada_contratos.php');	
	
if (file_exists(PATH_CINES . 'modelo/fachada_cines.php'))
    include(PATH_CINES . 'modelo/fachada_cines.php');	

if (file_exists(PATH_NEWSLETTER . 'modelo/fachada_newsletter.php'))
    include(PATH_NEWSLETTER . 'modelo/fachada_newsletter.php');

// Archivo de configuracion de minisitios
define('CONFIG_MINISITIOS','config/minisitios_config.inc.php');

// Configuracion esencial para conectarse a la base de datos por DataObject
$options = &PEAR::getStaticProperty('DB_DataObject','options');

include("configDB.php");

// Modulos por defecto para sitios
$modulos_default = array("contenido", "menu");
define ('ID_SITIO', '1');
define('URL_SITIO', 'sitio');

// Permisos para los rolres de los usuarios
define ('LEER', 1);
define ('ALIMENTAR', 2);
define ('EDITAR', 4);
define ('ADMINISTRAR', 8);

define ('CSS_SITEFILE', 'html/sitio/estilo.css');

?>