----------------------------------------------------------------
-- Creacin de datos iniciales de Azucar CMS                  --
-- Fecha: Febrero 01 de 2005                                  --
-- Autor: Camilo Torres C                                     --
----------------------------------------------------------------

----------------------------------------------------------
--  Datos iniciales para crear el sitio y administrarlo --
----------------------------------------------------------

INSERT INTO sis_portales (url, num_usuarios) VALUES ('sitio', '10');

INSERT INTO sis_portal_versiones (id_objeto, id_idioma, nombre) 
SELECT id_objeto, 1, 'sitio' FROM sis_portales;

INSERT INTO sis_contactos (nombres, email) VALUES ('User admin', '');

INSERT INTO sis_usuarios (id_contenedor, password,id_contacto, nombre) 
SELECT p.id_objeto,'21232f297a57a5a743894a0e4a801fc3', c.id_contacto, 'admin'
FROM sis_portales p, sis_contactos c;

INSERT INTO sis_roles (tipo, id_usuario, id_objeto) 
SELECT 15, u.id_objeto, p.id_objeto
FROM sis_usuarios u, sis_portales p;

-- Tipos de modulos del sistema

INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Contactos', 'Cree y administre los formularios de contacto de su sitio.', 'contactos', 'cnt');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Cuestionarios', 'Cree nuevos cuestionarios y analize los resultados de los que ya han sido publicados.', 'cuestionarios', 'cue');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Empleados', 'Administre el directorio de empleados y modifique el organigrama.', 'directorio', 'dir');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Eventos', 'Aada eventos al calendario.', 'eventos', 'eve');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Foro', 'Cree nuevos foros y administre los existentes.  Determine palabras censuradas y borre mensajes ofensivos.', 'foro', 'for');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Foto Album', 'Cree nuevas colecciones de imagenes y administre las que ya existen.', 'foto_album', 'fot');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Hoja de Vida', NULL, 'hojas_de_vida', 'hdv');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Menu','Modifique los enlaces y submens que tiene el men del sitio.', 'menu', 'men');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Pginas', 'Modifique el texto y las imgenes de las pginas informativas de su sitio.', 'contenido', 'art');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Catlogo', 'Administre las categoras y productos de su catalogo.', 'productos', 'prd');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Contratacin', 'Cree nuevas licitaciones y administre las existentes. Analice los proponentes y sus comentarios.', 'contratos', 'gel');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Diseo Grfico', 'Modifique el diseo y apariencia de sus pginas.', 'diseno', 'dis');
INSERT INTO sis_tipo_modulo (nombre, descripcion, carpeta, prefijo) VALUES ('Cines', 'Programa y modifique las peliculas y teatros de la cartelera de cine.', 'cines', 'cin');

-------------------------
-- Idiomas del sistema --
-------------------------

INSERT INTO sis_idiomas (id_idioma, nombre, enctype) VALUES (1, 'Espa&ntilde;ol', 'es_ES');
INSERT INTO sis_idiomas (id_idioma, nombre, enctype) VALUES (2, 'English', 'en_EN');
INSERT INTO sis_idiomas (id_idioma, nombre, enctype) VALUES (3, 'Fran&ccedil;ais', 'fr_FR');
INSERT INTO sis_idiomas (id_idioma, nombre, enctype) VALUES (4, 'Deutsch', 'de_DE');
INSERT INTO sis_idiomas (id_idioma, nombre, enctype) VALUES (5, 'Portugu&ecirc;s', 'pt_PT');


-- Idioma por defecto (Espaol)
INSERT INTO sitio_idioma (id_sitio, id_idioma) VALUES (1, 1);
-----------------------------------
-- Estilos definidos del sistema --
-----------------------------------

INSERT INTO sis_estilos_textos VALUES (1, 'verdana', '#FFFFFF', 10, '#006699', '#000033');
INSERT INTO sis_estilos_textos VALUES (2, 'verdana', '#000000', 10, '#99CC00', '#CCCCCC');
INSERT INTO sis_estilos_textos VALUES (3, 'verdana', '#FFFFFF', 10, '#FF9900', '#FF3300');
INSERT INTO sis_estilos_textos VALUES (4, 'verdana', '#333333', 10, '#CCCCCC', NULL);
INSERT INTO sis_estilos_textos VALUES (5, 'verdana', '#99CC00', 10, '#336600', '#003300');
INSERT INTO sis_estilos_textos VALUES (6, 'verdana', '#333333', 10, '#FFCC00', NULL);
INSERT INTO sis_estilos_textos VALUES (7, 'verdana', '#CC0000', 10, '#FF9900', NULL);
INSERT INTO sis_estilos_textos VALUES (8, 'verdana', '#FFFFFF', 10, '#990000', NULL);
INSERT INTO sis_estilos_textos VALUES (9, 'arial', '#FFFFFF', 10, '#000000', NULL);
INSERT INTO sis_estilos_textos VALUES (10, 'arial', '#000000', 10, '', NULL);
INSERT INTO sis_estilos_textos VALUES (11, 'arial', '#FFFFFF', 10, '#0066CC', NULL);
INSERT INTO sis_estilos_textos VALUES (12, 'verdana', '#FFFFFF', 10, '#333333', NULL);
INSERT INTO sis_estilos_textos VALUES (13, 'verdana', '#000000', 10, '#FFCC00', '#000000');
INSERT INTO sis_estilos_textos VALUES (14, 'verdana', '#000000', 10, '#FFFFFF', NULL);
INSERT INTO sis_estilos_textos VALUES (15, 'verdana', '#000000', 10, '#CCCCCC', '#666666');
INSERT INTO sis_estilos_textos VALUES (16, 'arial', '#FFFFFF', 10, '#003399', NULL);
INSERT INTO sis_estilos_textos VALUES (17, 'verdana', '#99CC00', 10, '#000000', '#CCCCCC');
INSERT INTO sis_estilos_textos VALUES (18, 'arial', '#FFFFFF', 10, '#FF6600', NULL);
INSERT INTO sis_estilos_textos VALUES (19, 'verdana', '#FFFFFF', 10, '#FF6600', '#FF9900');
INSERT INTO sis_estilos_textos VALUES (20, 'verdana', '#CCCCCC', 10, '#666666', '#CCCCCC');
INSERT INTO sis_estilos_textos VALUES (21, 'arial', '#FFFFFF', 10, '#339900', NULL);
INSERT INTO sis_estilos_textos VALUES (22, 'verdana', '#336600', 10, '#99CC00', '#336600');
INSERT INTO sis_estilos_textos VALUES (23, 'arial', '#FFFFFF', 10, '#666666', NULL);
INSERT INTO sis_estilos_textos VALUES (24, 'verdana', '#FFCC00', 10, '#000000', '#FFCC00');
INSERT INTO sis_estilos_textos VALUES (25, 'arial', '#000000', 10, '#FFFFFF', NULL);
INSERT INTO sis_estilos_textos VALUES (26, 'arial', '#FFFFFF', 10, '#FF0000', NULL);
INSERT INTO sis_estilos_textos VALUES (27, 'arial', '#FFFFFF', 10, '#FFCC00', NULL);

---------------------------------
-- Hojas de estilo del sistema --
---------------------------------

INSERT INTO sis_hojas_estilos (id_contenedor,  h4,  boton, menu , menu_over, nombre) VALUES (1,  14,  1, 16, 11, 'clasico');
INSERT INTO sis_hojas_estilos (id_contenedor,  h4,  boton, menu , menu_over, nombre) VALUES ( 1,  12,  2, 17, 9, 'futurista');
INSERT INTO sis_hojas_estilos (id_contenedor,  h4,  boton, menu , menu_over, nombre) VALUES (1,  13,  3, 19, 18, 'juvenil');
INSERT INTO sis_hojas_estilos (id_contenedor,  h4,  boton, menu , menu_over, nombre) VALUES (1, 14, 15, 20, 25, 'moderno');
INSERT INTO sis_hojas_estilos (id_contenedor,  h4,  boton, menu , menu_over, nombre) VALUES (1,  14,  5, 22, 21, 'ecologico');
INSERT INTO sis_hojas_estilos (id_contenedor,  h4,  boton, menu , menu_over, nombre) VALUES (1,  15,13, 24, 23, 'industrial');
INSERT INTO sis_hojas_estilos (id_contenedor,  h4,  boton, menu , menu_over, nombre) VALUES (1,  14,  8, 14, 26, 'calido');
INSERT INTO sis_hojas_estilos (id_contenedor,  h4,  boton, menu , menu_over, nombre) VALUES (1,  14,  7, 14, 27, 'arena');

-----------------------
-- Paises en espaol --
-----------------------

INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Espaa', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Emiratos rabes Unidos', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Afganist&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Albania', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Alemania', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Andorra', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Angola', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Antigua y Barbuda', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Antillas Holandesas', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Arabia Saudita', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Argelia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Argentina', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Armenia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Aruba', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Australia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Austria', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Azerbaiy&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Bahamas', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Bahrein', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Bangladesh', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Barbados', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('B&eacute;lgica', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Belice', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Benin', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Bielorrusia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Birmania', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Bolivia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Bosnia-Herzegovina', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Botsuana', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Brasil', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Brunei Darussalam', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Bulgaria', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Burkina Faso', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Burundi', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('But&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Cabo Verde', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Camboya', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Camer&uacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Canad&aacute;', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Chad', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Chile', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('China', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Chipre', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Ciudad del Vaticano', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Colombia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Congo', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Corea del Norte', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Corea del Sur', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Costa de Marfil', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Costa Rica', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Croacia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Cuba', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Dinamarca', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Dominica', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Ecuador', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Egipto', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('El Salvador', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Eslovaquia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Eslovenia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Estados Federados de Micronesia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Estados Unidos de Am&eacute;rica', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Estonia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Etiop&iacute;a', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Filipinas', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Finlandia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Fiyi', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Francia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Gab&oacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Gambia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Georgia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Ghana', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Grecia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Grenada', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Guatemala', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Guinea', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Guinea Ecuatorial', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Hait&iacute;', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Holanda', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Honduras', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Hungr&iacute;a', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('India', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Indonesia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Irak', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Ir&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Irlanda', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Islandia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Islas Marshall', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Islas Mauricio', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Islas Salom&oacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Israel', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Italia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Jamaica', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Jap&oacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Jordania', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Kazajst&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Kenia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Kirguist&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Kiribati', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Kuwait', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Lesotho', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Letonia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('L&iacute;bano', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Liberia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Libia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Lituania', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Luxemburgo', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Madagascar', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Malasia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Malawi', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Maldivas', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Mali', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Malta', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Marruecos', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Mauritania', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('M&eacute;xico', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Moldavia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('M&oacute;naco', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Mongolia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Mozambique', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Namibia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Nepal', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Nicaragua', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Niger', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Nigeria', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Noruega', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Nueva Zelanda', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Om&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Pakist&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Panam&aacute;', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Pap&uacute;a Nueva Guinea', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Paraguay', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Per&uacute;', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Polonia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Portugal', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Puerto Rico', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Qatar', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Reino Unido', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Rep&uacute;blica Centroafricana', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Rep&uacute;blica Checa', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Rep&uacute;blica Democr&aacute;tica del Congo', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Rep&uacute;blica Dominicana', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Ruanda', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Ruman&iacute;a', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Rusia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Sahara Occidental', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('San Crist&oacute;bal y Nieves', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('San Vicente y las Granadinas', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Santa Luc&iacute;a', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Senegal', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Serbia y Montenegro', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Seychelles', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Sierra Leona', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Singapur', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Siria', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Somalia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Sri Lanka', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Sud&aacute;frica', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Sud&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Suecia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Suiza', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Swazilandia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Tadjikist&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Tailandia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Taiwan', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Tanzania', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Timor Oriental', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Togo', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Tonga', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Trinidad y Tobago', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('T&uacute;nez', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Turkmenist&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Turqu&iacute;a', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Tuvalu', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Ucrania', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Uganda', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Uruguay', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Uzbekist&aacute;n', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Vanuatu', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Venezuela', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Vietnam', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Yemen', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Yibouti', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Zambia', 1);
INSERT INTO sis_paises (nombre, id_idioma) VALUES ('Zimbabwe', 1);

---------------------------------------
-- Actividades econmicas en espaol --
---------------------------------------

INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Talleres de Joyera', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Almacenes de Motos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Almacenes Veterinarios', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Alquiler de Equipos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Alquiler de Pantallas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Aluminios', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Arrendamiento Vehculos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Artesanas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Artculos Mdicos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Asesoras en Diseo', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Asesoras en Procesos Maderables', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Autoedicin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Automatizacin de Equipos Grficos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Automviles', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cajas de Cartn', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cajas para Baterias', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cmaras para Reproduccin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Canchas de Minigolf', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Caricaturistas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Celulares', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Centros de Acondicionamiento Fisico', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cermica Refractaria Industrial', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Chivas Tursticas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cocina Europea', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cocinas Elctricas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Colegios para Adultos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Comidas Rpidas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Compraventas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Compraventas de carros', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Comunicaciones', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cortadoras de Vidrio', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cursos de Internet', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Cursos para Pr oblemas de Aprendizaje', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Discotecas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Dispensadores de Cinta', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Empacadoras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Equipos Mdicos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Equipos para Curado Ultavioleta (UV)', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Equipos para Formas Continuas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Equipos para Lotera', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Equipos para transporte de Combustible de Aviacin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Escritores', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Escuelas de Buceo', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Escuelas de Criminologa', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Escuelas de Disc-jockeys', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Escuelas de Natacin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Escuelas Tcnicas de Urgencias Medicas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Exportadores de Minerales', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Exposicin por Lser', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Fertilidad', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Fibras Vegetales', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Formas Separables', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Fotocomponedoras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Fotografa Arquitectnica', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Funerarias', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Gastronoma', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Gel Refrigerante', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Gimnasios', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Guas de Turismo Cultural y Ecolgico', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Herramientas para Corte de Vidrio', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Iluminacin para Espectculos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Ilustradores', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Impresin de Cds', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Informtica Especializada', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Ingeniera de Trnsito', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Inmobiliarias', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Insoladora de Planchas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Instituciones tcnicas no formales', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Instituciones tcnicas profesionales', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Instituciones tecnolgicas profesionales', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Insumos para Almanaques', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Laboratorios Ambientales', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Libros Especializados', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Luces para Discotecas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Mantenimiento de Inmuebles', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Mantenimiento de Muebles', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Marcas y Logotipos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Mecnicos en Equipos para Artes Grficas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Muebles Inoxidables', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Msica Clsica', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Negocios', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Nutricin Celular', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Oficinas Virtuales', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Overoles', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Paint Ball', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Palas Mecnicas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Palos para Pinchos o Chuzos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Pantallas de Plasma', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Pantuflas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Paos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Parapsicologa', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Peleteras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Perchas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Perfiles de Lmina', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Persianas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Pieles', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Pijamas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Pinturas para Cueros', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Pinturas para Tela', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Plisados', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Ponchos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Porcelanas para Laboratorios', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Postgrados', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Prendas Blindadas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Prensas Flexogrficas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Prensas para Tipografa', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Procesadores para Planchas Flexogrficas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Productos Agropecuarios', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Productos Farmacuticos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Propiedad Industrial', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Protectores para Colchn', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Psicologos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Pulpa para Papel', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Pupitres', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Rampas Niveladoras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Rastrillos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Refrigeracin Mdica o Farmacutica', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Renovadoras de Camisas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Reparacin de Artculos de Cuero', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Reparacin de Limpiaparabrisas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Reparacin de Lneas Telefnicas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Reparacin de Techos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Repetidoras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Repuestos para Automotores', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Retoque Digital', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Revisin Tecnomecnica', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Ropa para Cama', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Ropa para Invierno', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Rotativas Comerciales', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Rotativas para Peridicos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Ruanas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Salud', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Salvavidas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sastrera Eclesistica', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sastrera Militar', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sastreras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Selectores de Canal para T.V.', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sellos para Envases', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Semillas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Semilleros', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Semilleros Plsticos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Seminarios de Actualizacin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Servicio de Dorado de Cantos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Servicios de Impresin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sillas para Auditorios', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sillas Universitaras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sistemas de Control Industrial', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sistematizacin de Notas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sobrantes de Textiles', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Sombrereras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Suteres', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tableros', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tacones', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tarjetas de Acceso a Internet', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tarrinas de Aluminio', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tecnologa', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telares', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telas Asflticas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telas Encauchadas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telas para Colchones', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telas para Cortinas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telas para Muebles y Decoracin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telas para pared', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telefona IP', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telescopios', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Termografa', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Textos Escolares', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tiendas Naturistas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tierra para Jardines', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tijeras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Toallas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Toldillos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Toldos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Transporte Aereo', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Transporte martimo', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Transporte terrestre', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Tulas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Universidades', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Vehculos Elctricos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Venta de Ganado', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Viveros ', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Zapato', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Consultora y Servicios Generales para la Empresa', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Electrodomsticos, Audio y Video', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Energa', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Industria de la Construccin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Industria del Envase y el Embalaje', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Industria Farmacutica, Belleza y Servicios Mdicos', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Industria Qumica', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Industria Textil y Prendas de Vestir', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Informtica', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Madera, Mueble y Decoracin', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Maquinaria, Equipamiento y Herramientas', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Material de Precisin e Instrumental para Medicina', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Material Elctrico y Electrnico', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Metalurgia y Trabajo del Metal', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Ocio, Deporte y Juguetes', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Papel, Imprenta y Fotografa', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Telecomunicaciones', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Transporte e Industria', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Peluqueras', 1);
INSERT INTO sis_actividades_economicas (nombre, id_idioma) VALUES ('Peluqueras', 1);

-- Actualizar la hoja de estilo de un sitio, por defecto moderno
UPDATE sis_portales SET id_hoja_estilo = sis_hojas_estilos.id_objeto
FROM sis_hojas_estilos WHERE sis_hojas_estilos.nombre = 'clasico';

-- Listado de paises en el idioma Ingles.
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Afghanistan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Albania'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Algeria'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'American Samoa'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Andorra'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Angola'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Anguilla'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Antarctica'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Antigua and Barbuda'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Argentina'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Armenia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Aruba'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Australia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Austria'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Azerbaijan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bahamas'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bahrain'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bangladesh'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Barbados'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Belarus'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Belgium'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Belize'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Benin'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bermuda'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bhutan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bolivia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bosnia and Herzegovina'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Botswana'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bouvet Island'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Brazil'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'British Indian Ocean Territory'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Brunei'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Bulgaria'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Burkina Faso'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Burundi'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cambodia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cameroon'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Canada'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cape Verde'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cayman Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Central African Republic'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Chad'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Chile'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'China'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Christmas Island'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cocos &#40;Keeling&#41; Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Colombia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Comoros'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Congo'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cook Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Costa Rica'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cte d&#39;Ivoire'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Croatia &#40;Hrvatska&#41;'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cuba'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Cyprus'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Czech Republic'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Congo &#40;DRC&#41;'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Denmark'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Djibouti'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Dominica'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Dominican Republic'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'East Timor'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Ecuador'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Egypt'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'El Salvador'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Equatorial Guinea'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Eritrea'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Estonia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Ethiopia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Falkland Islands &#40;Islas Malvinas&#41;'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Faroe Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Fiji Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Finland'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'France'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'French Guiana'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'French Polynesia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'French Southern and Antarctic Lands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Gabon'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Gambia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Georgia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Germany'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Ghana'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Gibraltar'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Greece'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Greenland'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Grenada'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Guadeloupe'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Guam'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Guatemala'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Guinea'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Guinea-Bissau'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Guyana'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Haiti'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Heard Island and McDonald Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Honduras'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Hong Kong SAR'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Hungary'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Iceland'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'India'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Indonesia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Iran'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Iraq'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Ireland'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Israel'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Italy'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Jamaica'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Japan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Jordan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Kazakhstan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Kenya'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Kiribati'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Korea'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Kuwait'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Kyrgyzstan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Laos'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Latvia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Lebanon'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Lesotho'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Liberia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Libya'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Liechtenstein'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Lithuania'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Luxembourg'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Macao SAR'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Macedonia, Former Yugoslav Republic of'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Madagascar'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Malawi'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Malaysia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Maldives'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Mali'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Malta'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Marshall Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Martinique'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Mauritania'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Mauritius'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Mayotte'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Mexico'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Micronesia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Moldova'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Monaco'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Mongolia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Montserrat'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Morocco'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Mozambique'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Myanmar'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Namibia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Nauru'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Nepal'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Netherlands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Netherlands Antilles'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'New Caledonia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'New Zealand'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Nicaragua'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Niger'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Nigeria'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Niue'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Norfolk Island'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'North Korea'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Northern Mariana Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Norway'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Oman'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Pakistan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Palau'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Panama'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Papua New Guinea'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Paraguay'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Peru'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Philippines'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Pitcairn Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Poland'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Portugal'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Puerto Rico'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Qatar'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Reunion'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Romania'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Russia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Rwanda'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Samoa'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'San Marino'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'So Tom and Prncipe'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Saudi Arabia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Senegal'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Serbia and Montenegro'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Seychelles'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Sierra Leone'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Singapore'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Slovakia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Slovenia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Solomon Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Somalia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'South Africa'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'South Georgia and the South Sandwich Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', '" selected>Spain'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Sri Lanka'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'St. Helena'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'St. Kitts and Nevis'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'St. Lucia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'St. Pierre and Miquelon'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'St. Vincent and the Grenadines'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Sudan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Suriname'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Svalbard and Jan Mayen'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Swaziland'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Sweden'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Switzerland'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Syria'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Taiwan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Tajikistan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Tanzania'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Thailand'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Togo'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Tokelau'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Tonga'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Trinidad and Tobago'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Tunisia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Turkey'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Turkmenistan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Turks and Caicos Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Tuvalu'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Uganda'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Ukraine'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'United Arab Emirates'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'United Kingdom'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'United States'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'United States Minor Outlying Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Uruguay'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Uzbekistan'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Vanuatu'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Vatican City'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Venezuela'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Viet Nam'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Virgin Islands &#40;British&#41;'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Virgin Islands'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Wallis and Futuna'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Yemen'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Zambia'); 
INSERT INTO sis_paises (id_idioma, nombre) VALUES ('2', 'Zimbabwe'); 


---------------------------------------------------------------------
---------------------------------------------------------------------

CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '

 DECLARE

    id_tipo_modulo INTEGER;

	id_objeto_seq INTEGER;

 BEGIN

	 -- Seleccionar el id del modulo tipo ARTICULO 
	SELECT id_tipo INTO id_tipo_modulo FROM sis_tipo_modulo WHERE prefijo = ''cnt'';

	-- Insertar el registro como datos modulo 
	INSERT INTO cnt_datos_modulos_contactos 
	(id_contenedor, id_tipo, nombre, descripcion, num_forms, acceso_BD, num_users) VALUES 
	(1, id_tipo_modulo, ''Contactos'', ''Descripcion del mdulo de Contactos'', ''10'', ''1'', ''100'');  
	
	-- Insertar tipo de identificacion por defecto
	INSERT INTO sis_tipo_identificacion (nombre) VALUES (''cc'');
	INSERT INTO sis_tipo_identificacion (nombre) VALUES (''nit'');  
	
	RETURN 1;
 end;

 ' LANGUAGE 'plpgsql';

SELECT create_data();

DROP FUNCTION create_data();
CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '
 DECLARE
      	id_tipo_modulo INTEGER;
	id_objeto_seq INTEGER;
 BEGIN
	-- Seleccionar el id del modulo tipo ARTICULO
      	SELECT id_tipo INTO id_tipo_modulo 
      	FROM sis_tipo_modulo 
	WHERE prefijo = ''art'';

	-- Insertar el regsitro como datos modulo
	INSERT INTO art_datos_modulos_articulos (id_contenedor, id_tipo, nombre, descripcion, limite_categorias, limite_articulos)
	VALUES (1, id_tipo_modulo, ''Pginas'', ''Cree, modifique o elimine las pginas del sitio y todo su contenido.'', ''10'', ''50'');

	-- Seleccionar el id que se le asign al datos modulos
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;

	--  Insertar la categoria raiz
	INSERT INTO art_categorias_articulos (id_contenedor, id_modulo) VALUES (id_objeto_seq, id_objeto_seq);

	-- Seleccionar el id asignado a la categoria
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;
	
	-- Insertar la versin de la categoria raiz
	INSERT INTO art_categorias_articulos_versiones (id_objeto, nombre, descripcion, id_idioma) 
	VALUES (id_objeto_seq, ''Pginas'', ''Categora principal'', 1);

	-- Insertar las plantillas de categoria resumen
	INSERT INTO art_plantillas_categorias (id_plantilla, tipo) 
	VALUES (0, ''foto_texto'');
	INSERT INTO art_plantillas_categorias (id_plantilla, tipo) 
	VALUES (1, ''texto_foto'');
	INSERT INTO art_plantillas_categorias (id_plantilla, tipo) 
	VALUES (2, ''lista'');

      RETURN 1;
 end;
 ' LANGUAGE 'plpgsql';

SELECT create_data();

DROP FUNCTION create_data();
CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '
 DECLARE
   id_tipo_modulo INTEGER;
   id_objeto_seq INTEGER;

   id_modulo_ctr INTEGER;
 BEGIN
   SELECT id_tipo INTO id_tipo_modulo 
   FROM sis_tipo_modulo 
   WHERE prefijo = ''gel'';

   INSERT INTO gel_datos_modulos_contratos (id_contenedor, id_tipo, nombre, descripcion)
   VALUES (1, id_tipo_modulo, ''Contratacin'', ''Sistema de Gobierno en Lnea.'');
 
   -- Seleccionar el id que se le asign al datos modulos
   SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;

-- Insertar la pgina correspondiente al contrato
   INSERT INTO gel_contratos_pagina (id_contenedor, id_modulo) 
   VALUES (id_objeto_seq, id_objeto_seq);

   -- Seleccionar el id que se le asign al datos modulos
   SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;
	
   -- Insertar la versin de la pgina correspondiente al contrato
   INSERT INTO gel_contratos_pagina_versiones (id_objeto, nombre, descripcion, id_idioma) 
   VALUES (id_objeto_seq, ''Contratos'', ''Contratacin en lnea'', 1);

   INSERT INTO gel_tipos_contratos (id_tipo_contrato, nombre) 
   VALUES (1, ''Licitaciones y concursos pblicos'');
   INSERT INTO gel_tipos_contratos (id_tipo_contrato, nombre) 
   VALUES (2, ''Contratacin directa'');

   INSERT INTO gel_estados (id_estado, nombre) 
   VALUES (1, ''Borrador de pliegos'');
   INSERT INTO gel_estados (id_estado, nombre) 
   VALUES (2, ''Pliegos definitivos'');
   INSERT INTO gel_estados (id_estado, nombre) 
   VALUES (3, ''Adjudicado'');   
      
   INSERT INTO gel_tipos_archivos (id_tipo_archivo, nombre) 
   VALUES (1, ''Borrador de pliegos'');   
   INSERT INTO gel_tipos_archivos (id_tipo_archivo, nombre) 
   VALUES (2, ''Pliegos definitivos'');   
   INSERT INTO gel_tipos_archivos (id_tipo_archivo, nombre) 
   VALUES (3, ''Convocatoria de veedura ciudadana'');   
   INSERT INTO gel_tipos_archivos (id_tipo_archivo, nombre) 
   VALUES (4, ''Adendos'');   
   INSERT INTO gel_tipos_archivos (id_tipo_archivo, nombre) 
   VALUES (5, ''Informe de evaluacin'');   
   INSERT INTO gel_tipos_archivos (id_tipo_archivo, nombre) 
   VALUES (6, ''Acta de adjudicacin'');   
   INSERT INTO gel_tipos_archivos (id_tipo_archivo, nombre) 
   VALUES (7, ''Pliego de condiciones'');   
   INSERT INTO gel_tipos_archivos (id_tipo_archivo, nombre) 
   VALUES (8, ''Acta de audiencia aclaratoria'');   

  RETURN 1;
 END;
' LANGUAGE 'plpgsql';

SELECT create_data();

DROP FUNCTION create_data();

---------------------------------------------------------------------
---------------------------------------------------------------------

CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '

 DECLARE

    id_tipo_modulo INTEGER;

	id_objeto_seq INTEGER;

 BEGIN

	-- Seleccionar el id del modulo tipo ARTICULO 
	SELECT id_tipo INTO id_tipo_modulo FROM sis_tipo_modulo WHERE prefijo = ''cue'';

	-- Insertar el registro como datos modulo 
	INSERT INTO cue_datos_modulos_cuestionarios 
	(id_contenedor, id_tipo, nombre, descripcion, num_cues, num_pregs) VALUES 
	(1, id_tipo_modulo, ''Cuestionarios'', ''Descripcion del mdulo de Cuestionarios'', ''10'', ''10'');

	-- Insertar los datos iniciales de cue_tipos_preguntas
	INSERT INTO cue_tipos_preguntas (id_idioma, nombre)	VALUES (1, ''Seleccin Mltiple'');
	INSERT INTO cue_tipos_preguntas (id_idioma, nombre)	VALUES (1, ''Abierta'');
	INSERT INTO cue_tipos_preguntas (id_idioma, nombre)	VALUES (1, ''Si/No'');
	INSERT INTO cue_tipos_preguntas (id_idioma, nombre)	VALUES (1, ''Combinada'');
	INSERT INTO cue_tipos_preguntas (id_idioma, nombre)	VALUES (1, ''Texto'');
	
	RETURN 1;
 end;

 ' LANGUAGE 'plpgsql';

SELECT create_data();

DROP FUNCTION create_data();
CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '
 DECLARE
      	id_tipo_modulo INTEGER;
	id_objeto_seq INTEGER;
 BEGIN
	-- Seleccionar el id del modulo tipo ARTICULO
      	SELECT id_tipo INTO id_tipo_modulo 
      	FROM sis_tipo_modulo 
	WHERE prefijo = ''dir'';

	-- Insertar el regsitro como datos modulo
	INSERT INTO dir_datos_modulos_directorio (id_contenedor, id_tipo, nombre, descripcion, num_empleados)
	VALUES (1, id_tipo_modulo, ''Empleados'', ''Organigrama y directorio de empleados.'', ''100'');

	-- Seleccionar el id que se le asign al datos modulos
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;
	
	-- Insertar la pgina correspondiente al directorio
	INSERT INTO dir_directorio (id_contenedor, id_modulo) 
	VALUES (id_objeto_seq, id_objeto_seq);

	-- Seleccionar el id que se le asign al datos modulos
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;
	
	-- Insertar la versin de la pgina correspondiente al directorio
	INSERT INTO dir_directorio_versiones (id_objeto, nombre, descripcion, id_idioma) 
	VALUES (id_objeto_seq, ''Directorio'', ''Directorio de empleados'', 1);
      RETURN 1;
 end;
 ' LANGUAGE 'plpgsql';

SELECT create_data();

DROP FUNCTION create_data();
CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '
 DECLARE
      	id_tipo_modulo INTEGER;
	id_objeto_seq INTEGER;
 BEGIN
	-- Seleccionar el id del modulo tipo ARTICULO
      	SELECT id_tipo INTO id_tipo_modulo 
      	FROM sis_tipo_modulo 
	WHERE prefijo = ''eve'';

	-- Insertar el regsitro como datos modulo
	INSERT INTO eve_datos_modulos_eventos (id_contenedor, id_tipo, nombre, descripcion, limite_categorias)
	VALUES (1, id_tipo_modulo, ''Eventos'', ''Aada eventos al calendario.'', ''10'');

	-- Seleccionar el id que se le asign al datos modulos
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;

	--  Insertar la categoria raiz
	INSERT INTO eve_categorias (id_contenedor, id_modulo) VALUES (id_objeto_seq, id_objeto_seq);

	-- Seleccionar el id asignado a la categoria
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;
	
	-- Insertar la versin de la categoria raiz
	INSERT INTO eve_categorias_versiones (id_objeto, nombre, descripcion, id_idioma) 
	VALUES (id_objeto_seq, ''Eventos'', ''Categora principal'', 1);
      RETURN 1;
 end;
 ' LANGUAGE 'plpgsql';

SELECT create_data();

DROP FUNCTION create_data();
CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '
 DECLARE
      	id_tipo_modulo INTEGER;
	id_objeto_seq INTEGER;
 BEGIN
	-- Seleccionar el id del modulo tipo ARTICULO
      	SELECT id_tipo INTO id_tipo_modulo 
      	FROM sis_tipo_modulo 
	WHERE prefijo = ''fot'';

	-- Insertar el regsitro como datos modulo
	INSERT INTO fot_datos_modulos_foto_album (id_contenedor, id_tipo, nombre, descripcion,	limite_categorias, limite_colecciones,limite_imagenes)
	VALUES (1, id_tipo_modulo, ''Foto Album'', ''Cree nuevas colecciones de imagenes y administre las que ya existen.'', ''10'', ''10'', ''50'');
      RETURN 1;
 end;
 ' LANGUAGE 'plpgsql';

SELECT create_data();

DROP FUNCTION create_data();
CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '

 DECLARE

      	id_tipo_modulo INTEGER;

	id_objeto_seq INTEGER;

 BEGIN

	 -- Seleccionar el id del modulo tipo ARTICULO 
	SELECT id_tipo INTO id_tipo_modulo FROM sis_tipo_modulo WHERE prefijo = ''men'';
 

	-- Insertar el regsitro como datos modulo 
	INSERT INTO men_datos_modulos_menus (id_contenedor, id_tipo, nombre, descripcion)
	VALUES (1, id_tipo_modulo, ''Menu Principal'', ''Descripcion del mdulo de Men'');  
	 

	-- Seleccionar el id que se le asign al datos modulos 
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;
	 

	-- Insertar la caegoria raiz
	INSERT INTO men_menus (id_contenedor, id_modulo) VALUES (id_objeto_seq, id_objeto_seq);
 

	-- Seleccionar el id asignado a la categoria 
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;


	-- Insertar la versin de la categoria raiz 
	INSERT INTO men_items_versiones (id_objeto, nombre, descripcion, id_idioma) 
	VALUES (id_objeto_seq, ''Menu Principal'', ''Categora principal'', 1);
      RETURN 1;

 end;

 ' LANGUAGE 'plpgsql';



SELECT create_data();



DROP FUNCTION create_data();CREATE OR REPLACE FUNCTION create_data() RETURNS INTEGER AS '
 DECLARE
      	id_tipo_modulo INTEGER;
	id_objeto_seq INTEGER;
 BEGIN
	-- Seleccionar el id del modulo tipo ARTICULO
      	SELECT id_tipo INTO id_tipo_modulo 
      	FROM sis_tipo_modulo 
	WHERE prefijo = ''prd'';

	-- Insertar el regsitro como datos modulo
	INSERT INTO prd_datos_modulos_productos (id_contenedor, id_tipo, nombre, descripcion, limite_categorias, limite_productos)
	VALUES (1, id_tipo_modulo, ''Catalogo'', ''Administre las categoras y productos de su catalogo.'', ''10'', ''100'');

	-- Seleccionar el id que se le asign al datos modulos
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;

	--  Insertar la categoria raiz
	INSERT INTO prd_categorias_productos (id_contenedor, id_modulo) VALUES (id_objeto_seq, id_objeto_seq);

	-- Seleccionar el id asignado a la categoria
	SELECT currval(''sis_objetos_protegidos_id_objeto_seq'') INTO id_objeto_seq;
	
	-- Insertar la versin de la categoria raiz
	INSERT INTO prd_categorias_productos_versiones (id_objeto, nombre, descripcion, id_idioma) 
	VALUES (id_objeto_seq, ''Catalogo'', ''Categora principal'', 1);
      RETURN 1;
 end;
 ' LANGUAGE 'plpgsql';

SELECT create_data();

DROP FUNCTION create_data();
