﻿/*
 * Creación de menú dinámico - AzúcarCMS
 * http://azucarcms.sourceforge.net
 * 
 * Flash MX 2004, ActionScript 2.0
 * @author John A. Vargas <jhonvargas@telesat.com.co>
 */
 
/*
 * Contruye recursivamente el menú 
 * @param array itemsMenu Arreglo con los items del menú 
 */
function crear_menu(padreClip, itemsMenu, posX, posY, prof)
{ 
	var y = posX + _root.clip_item._y;
	var x = posY + _root.clip_item._x;
			
	for (var i = 0; i < itemsMenu.length; i++) {
		var itemNodo = itemsMenu[i];
		var valorNodo = itemNodo.firstChild.firstChild;
		var tipoNodo = itemNodo.attributes["tipo"];
		
		// Hacemos una copia del item que quedé mas abajo.
		nombreClip = "clip" + _root.num_clip + '_' + prof;
		_root.clip_item.duplicateMovieClip(nombreClip, _root.num_clip++);
		objClip = _root[nombreClip];
		objClip.stop();
		objClip._y = y + i * 40;
		objClip._x = x;
		objClip.tipo = tipoNodo; 
		objClip.padre = padreClip;
				
		objClip._visible = false;//(prof == 1);
		
		// Asignamos el nombre al item
		objClip.nombreItem.text = valorNodo;
		objClip.nombreItem._visible = false;
		if (prof == 1)
			_root.wait(objClip, i + 1);

		switch (tipoNodo) { 
			case 'menu':
				nombreMenu = "menu" + _root.num_clip + '_' + prof;			
				objClip.subMenu = nombreMenu;
				objClip.listaItems = new Array(itemNodo.lastChild.childNodes.length);
				
				_root.clipMenu.duplicateMovieClip(nombreMenu, _root.num_clip++);
				
				for (var k = 0; k < itemNodo.lastChild.childNodes.length; k++)
					objClip.listaItems[k] = "clip" + (k + _root.num_clip) + '_' + (prof + 1);
				
				objMenu = _root[nombreMenu];
				objMenu.stop();
				objMenu._visible = false;
				
				_root.crear_menu(nombreMenu, itemNodo.lastChild.childNodes, objMenu._x, objMenu._y, prof + 1);
			break;
			default: 
				objClip.urlItem = itemNodo.lastChild.firstChild;						
			break;
		}
	}
}

/*
 * Inicia el movieClip mc dentro de n segundos
 * Tomado de http://www.actionscript.org/forums/archive/index.php3/t-37008.html
 *
 * @param MovieClip mc clip de pelicula que va a iniciar
 * @param int n Número de segundos que se debe esperar para inciar mc
 */
function wait(mc, n) {
	mc.gotoAndStop(1);
	var myInterval = setInterval(function () {
				mc._visible = true;
				mc.gotoAndPlay(1);
				clearInterval(myInterval);
			}, n * 100); // stop for n seconds
}

/*
 * Hace visible el subMenu menu, sacando de lista los items.
 *
 * @param string menu Nombre del subMenu a mostrar.
 * @param array lista Listado de items que contiene el subMenu.
 * @param int x Posición x del subMenu.
 * @param int y Posición y del subMenu.
 */
function mostrar(menu, lista, x, y){	
	_root[menu]._y = y - 3;
	_root[menu]._x = x + 170 - _root.clip_item._x;
	_root[menu]._height = lista.length * 40 + 5;
	_root[menu]._visible = true;
	_root[menu].gotoAndPlay(1);
	_root[menu]._lista = lista;
	
	for (var k = 0; k < lista.length; k++) { 
		_root[lista[k]]._y = y + k * 35
		_root[lista[k]]._x = _root[menu]._x + _root.clip_item._x + 1;
		_root[lista[k]].nombreItem._visible = false;
		_root.wait(_root[lista[k]], k);
	}
}

function ocultar(nombreClip, listaItems)
{ 
	if (!_root.visibles[nombreClip]) {
		_root[nombreClip]._visible = false;
		_root[nombreClip].gotoAndStop(1);
		
		for (var k = 0; k < listaItems.length; k++) {
			_root[listaItems[k]]._visible = false;
			_root[listaItems[k]].gotoAndStop();
			_root[listaItems[k]].nombreItem._visible = false;
		}
	}
}

function wait_ocultar(nombreClip, listaItems) { 
	var myInterval = setInterval(function () {
				_root.ocultar(nombreClip, listaItems);
				clearInterval(myInterval);
			}, 500); // stop for n seconds
}

// Oculta todos los subMenus, excepto a si mismo y a los ancestros.
function ocultarTodos(mc)
{
	// Listar todos los subMenus para ser ocultados
	for (var menu in _root.visibles) {
		_root.visibles[menu] = false;
	}
	
	// Mostrarse a si mismo y los ancestros
	_root.ancestrosVisibles(mc);
	
	// Ocultar subMenus
	for (var menu in _root.visibles) {
		_root.ocultar(menu, _root[menu]._lista);
	}
}

function ancestrosVisibles(mc)
{
	_root.visibles[mc._name] = true;
	while (mc.nodoPadre != '')
		ancestrosVisibles(mc.nodoPadre);
}