<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// |                                                                      |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
//
/**
 * Esta clase implementa las funciones necesarias para generacion de sitios
 * tanto de portales como de minisitios
 * +-
 * @package  Util
 * @version  $Id: generador.php,v 1.1 2004/06/01 20:26:05 mlmanyoma Exp $
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */

class Generador
{	
	// Atributos (Propiedades del objeto)
	var $sitio;
	var $path_sitio = null;

	/*
	 * Metodo constructor de la clase
	 * @param int $id_sitio Identificador del sitio a generar
	 *        string $dir Directorio donde el sitio ser generado
	 *
	 * @author John A. Vargas
	 * @access public
	 */
	function Generador($id_sitio, $dir)
	{
	 	$sitio = new Sis_sitios; 
		$sitio->get($id_sitio); // Obtener el objeto Sitio
		
		// Obtener el sitio especializado (Minisitio o portal)
		$this->sitio = $sitio->get_hijo();
		
		if ($this->sitio->url == "") return;
		
		// Crear la ruta donde se ubicaran los archivos del portal
		$this->path_sitio =  $dir . $this->sitio->url; 
	}

	/*
	 * Genera un portal
	 *
	 * @author John A. Vargas
	 * @access public
	 */
	 function generar_portal($template = true)
	 { 
		$path_vistas = $this->path_sitio . '/vistas';
		$path_template = PATH_SISTEMA . 'vistas/template';
		
		if (file_exists($this->path_sitio))
			exec("rm -rf " . $this->path_sitio);

		mkdir ($this->path_sitio, 0755); // Crear el directorio del portal
		mkdir ($path_vistas,  0755); // Crear el directorio de vistas
		//mkdir ($path_controlador,  0755); // Crear el directorio de vistas
			
		// Hoja de estilos
		$this->__generar_hoja_estilo();
		
		// Creacin de la vista inicial del portal
		copy ($path_template.'/tpl_index.html' , $path_vistas . '/index.html');
		copy ($path_template.'/tpl_foot.html' , $path_vistas . '/foot_public.html');
				
		// Copiar archivos de Phrame
		copy ('src/sistema/vistas/template/tpl_inicio.html', $this->path_sitio . '/index.php'); // El que muestra las vistas
		
		copy ('phrame.php', $this->path_sitio . '/phrame.php'); // El que ejecuta las acciones
		copy ($path_template.'/tpl_include.html', $this->path_sitio . '/include.php');

		/** EDITAR ARCHIVO DE CONFIGURACION **/
		$this->__generar_config(); 
		$this->__generar_cabecera($template); 
	 }
	 
	/*
	 * Genera el archivo de configuracin para el portal
	 *
	 * @author John A. Vargas
	 * @access private
	 */
	 function __generar_config()
	 {	
		global $modulos_default;
		
		$path_template = PATH_SISTEMA . 'vistas/template';
	 	$archivo_config = $this->path_sitio . "/config.inc.php";

		// Datos generalea de configuracion
		$nombre_portal = $this->sitio->nombre;
		$nombre_host = NOMBRE_HOST . $this->path_sitio;
		$url = $this->sitio->url;
		
		//Modulos del portal
		$datos_modulos = new Sis_datos_modulos;
		$datos_modulos->id_contenedor = $this->sitio->id_objeto;
		$datos_modulos->find();
		$define_modulos = $include_fachada = "";
		
		while ($datos_modulos->fetch()) {
			$tipo = new Sis_tipo_modulo;
			$tipo->get($datos_modulos->getid_tipo());
			$constante = strtoupper ($tipo->getcarpeta()); 
			
			if (!in_array($tipo->getcarpeta(), $modulos_default)) {
				$modulo = $tipo->getcarpeta();
				$define_modulos .= "define(\'PATH_$constante\', PATH_CMS . \'src/$modulo/\');\n";
				$include_fachada .= "include(PATH_$constante . \'modelo/fachada_$modulo.php\');\n";
			}
		}
		
		$template_config = $path_template.'/tpl_config.php'; 
		$contenido_config = addslashes(implode("\n",file($template_config))); 
	
		$go_map = '$go_map';
		$options = '$options';
		$meses = '$meses';
		$conf = '$conf';
		$log = '$log';
		
		$idioma = new Sis_idiomas;
		$idioma->get("nombre", IDIOMA_DEFECTO);
		$idioma_defecto = "define('IDIOMA_DEFECTO','{$idioma->enctype}')";
		$identificador_sitio = "define('ID_SITIO','".$_SESSION['sitio']['id_objeto']."')";
	
		eval("\$contenido_HTML = \"$contenido_config\"; "); 

		File::writeLine($archivo_config, stripslashes($contenido_HTML)); 
	 }
		
    /**
 	 * Genera los archivos planos de HTML para el sitio creado
     *
     * @param bool $temporal Bandera que me dioce si el sitio a
	 *             crear es o no temporal
	 * @author  John A. Vargas
     * @access  public
     */   
	function generar_minisitio ($temporal)
	{	
		global $log;
		
		if (file_exists($this->path_sitio))
			exec("rm -rf " . $this->path_sitio);

		mkdir( $this->path_sitio, 0755);
		
		// Crear el directorio de imagenes
		mkdir($this->path_sitio . "/imagenes" , 0755);
		
		if (!$temporal) {
			File::writeLine($this->path_sitio . "/index.html", "<script>location = 'ms_home.php'</script>");
			if ($dir == "tmp/") 
				$_SESSION['url_temp'] = $this->path_sitio;
				
		}
		
		$fp = new File();
		$this->__generar_hoja_estilo();
		
		/****  CABECERA DEL SITIO *****/
		Fachada_Minisitios::generar_cabecera($this->sitio->id_objeto,$this->path_sitio);
		
			
		if (!$temporal)	{
				
			/************************** Generacion de articulos *************************/
			$articulo = new Art_articulos;
			$query = "SELECT art.* 
					  FROM {$articulo->__table} art, art_categorias_articulos cat, art_datos_modulos_articulos dat
					  WHERE art.id_contenedor = cat.id_objeto
					  AND cat.id_contenedor = dat.id_objeto
					  AND dat.id_contenedor = '$id_sitio' "; 
			$articulo->query($query); 
			while($articulo->fetch()) {
				Fachada_contenido::generar_articulo($this->path_sitio, $articulo->id_objeto, "tpl_articulo.html");
					print_r($articulo);
				}
		
			/**************************** CATALOGO ****************************/
			
			Fachada_Productos::generar_catalogo($this->sitio->id_objeto, $this->path_sitio , "ms_catalogo.php");
				
			/*************************** FORMULARIO DE CONTACTENOS ****************/
			$usuario = new Sis_usuarios;
			$rol = new Sis_roles;
			$rol->get(" id_objeto = '$id_sitio' "); 
			$usuario->get($rol->id_usuario);
			
			$contacto = new Sis_contactos;
			$contacto->get($usuario->id_contacto);
			
			Fachada_Contactos::generar_formulario($this->path_sitio, "ms_contactenos.php",$contacto->email);		
		
			$log->log("Generacin de HTML: minisitio {$sitio->nombre} en url {$sitio->url}", LOG_INFO);
		}
				
	}
		
    /**
 	 * Genera La hoja de estilo para el sitio
     *
	 * @author  John A. Vargas
     * @access  private
     */   	
	function __generar_hoja_estilo()
	{
		$archivo_estilo = $this->path_sitio . "/estilos.css";
		File::writeLine($archivo_estilo, File::readAll("estilos.css") . "\n\n");
		File::writeLine($archivo_estilo, "/******* ESTILOS DEL MINISITIO *******/\n\n");
		
		// Obtenemos la hoja de estilo del minisitio
		$hoja_estilo = new Sis_hojas_estilos;
		$hoja_estilo->get($this->sitio->id_hoja_estilo); 
				
		$objeto_base = new Sis_objetos_protegidos;
		$atributos_base = array_keys($objeto_base->toArray());
		$estilos_array = $hoja_estilo->toArray();
		$contenido_estilo = '';
	
		// Por cada estilo se genera su codigo en CSS
		foreach ($estilos_array as $estilo => $valor) {
		
			// Solo se genera un estilo por cada atributo
			// que no sea un atributo heredado de ObjetoProtegido
			if (!in_array($estilo, $atributos_base) && $hoja_estilo->$estilo) {
				$estilo_texto = new Sis_estilos_textos;
				$estilo_texto->get($hoja_estilo->$estilo);
				
				$contenido_estilo .= ".ms_".$estilo." { \n";
				$contenido_estilo .= " background-color: " . $estilo_texto->color_fondo . ";\n";
				$contenido_estilo .= " font-family: " . $estilo_texto->fuente .";\n";
				$contenido_estilo .= " font-size: " . $estilo_texto->tamagno ."px;\n";
				$contenido_estilo .= " color: " . $estilo_texto->color_fuente .";\n";
				$contenido_estilo .= " border: " . $estilo_texto->borde .";\n";	
				$contenido_estilo .= " text-decoration: none;\n";
				$contenido_estilo .= " }\n\n";
								
				if ($estilo == "cabecera") {
					$contenido_estilo .= ".ms_slogan { \n";
					$contenido_estilo .= " font-family: " . $estilo_texto->fuente .";\n";
					$contenido_estilo .= " font-size: " . $estilo_texto->tamagno ."px;\n";
					$contenido_estilo .= " color: " . $estilo_texto->color_fuente .";\n";
					$contenido_estilo .= " border: " . $estilo_texto->borde .";\n";	
					$contenido_estilo .= " text-decoration: none;\n";
					$contenido_estilo .= " }\n\n";
									
				} // Fin if cabecera
			} // Fin if in_array
			
			File::writeLine($archivo_estilo, $contenido_estilo, FILE_MODE_WRITE);
		} // Fin foreach estilos
	}
	
	/*
	 * Genera la cabecera de un sitio
	 *
	 * @acces private
	 * @author John A. Vargas
	 */
	function __generar_cabecera($temporal = true)
	{
		global $modulos_default;
	
		$path_template = PATH_SISTEMA . 'vistas/template';
		$path_vistas = $this->path_sitio . '/vistas/';
		$session = '$_SESSION["mensaje_ingreso"]';
		System::mkdir ($this->path_sitio . "/lib");
				
		// Idiomas del sitio 
		$sitio_idioma = new Sitio_idioma;
		$sitio_idioma->id_sitio = $this->sitio->id_objeto;
		$sitio_idioma->find();
		
		while ($sitio_idioma->fetch()) {				
			// Cabecera del portal (fondo, logo y slogan)
			$cabecera = new Sis_portal_versiones;
			$cabecera->id_objeto = $this->sitio->id_objeto;
			$cabecera->id_idioma = $sitio_idioma->id_idioma;
			if (!$cabecera->find(true))
				Fachada_Sistema::crear_version(&$cabecera, $id_idioma);
		
			$idioma = new Sis_idiomas;
			$idioma->get($sitio_idioma->id_idioma);
			$path_idioma = $path_vistas . $idioma->enctype;
			System::mkdir ($path_idioma);
			$archivo_cabecera = $path_idioma . "/head_public.html";
			copy ($path_template.'/tpl_index.html' , $path_idioma . '/index.html');
					
			$cabecera->slogan = nl2br($cabecera->slogan);
		
			/*** Tamao de la imagen ***/
			$image = new Imagen ($cabecera->logotipo, "imagenes_cont/" . $this->sitio->url); 
	
			if ($image->width < 130) $widthtd = 130;
			$image->rezise(130, 650); 
			if ($image->width >= 130) $widthtd = $image->width;
								
			// Modulos del Portal 
			
			/* (Se usar menu con javascript --> Modulo Menu)
			$template_menu = "$path_template/tpl_menu.html"; 
			$contenido_menu = addslashes(implode("\n",file($template_menu))); 
			$menu_HTML = "";*/
			
			$datos_modulos = new Sis_datos_modulos;
			$datos_modulos->setid_contenedor($this->sitio->id_objeto);
			$datos_modulos->find();
			while ($datos_modulos->fetch()) {
				$tipo = new Sis_tipo_modulo;
				$tipo->get($datos_modulos->getid_tipo());
				
				// Generamos cada modulo
				if (!in_array($tipo->getcarpeta(), $modulos_default) && $temporal) {
					$clase = "Fachada_" . ucwords($tipo->getcarpeta());
					$generar = "generar_" . $tipo->getcarpeta();
					
					$fch_modulo = new $clase; 
					if (method_exists ( $fch_modulo, $generar))
						$enlace = $fch_modulo->$generar($this->sitio->id_objeto, $path_idioma, $idioma);
					// Se comenta Porque ya se usar el menu con javascript --> Modulo Menu
					//eval("\$menu_HTML .= \"$contenido_menu\"; ");// echo $menu_HTML;
				}
				
			}
				
			// Generar menu
			$path_menu = $path_idioma . "/menu/";
			System::mkdir ($path_menu);
			Fachada_Menus::generar_menus($path_menu, $idioma);
			
			Fachada_contenido::generar_contenido($this->sitio->id_objeto, $path_idioma, $idioma);
		
			// Idiomas del portal
			$template_idioma = "$path_template/tpl_idioma.html"; 
			$contenido_menu = addslashes(implode("\n",file($template_idioma))); 
			$idiomas = Fachada_Sistema::lista_idiomas($this->sitio->id_objeto);
			$menu_HTML = "";
			if ($temporal)
				foreach ($idiomas as $v) {
					$nombre_idioma = $v['nombre'];
					$enctype = $v['enctype']; 
					$uri = '<?= array_pop(explode("/",$vista))?>';
					eval("\$menu_HTML .= \"$contenido_menu\"; ");
				}
	
			// Se escribe el contenido del articulo
			$template_cabecera = "$path_template/tpl_head.html"; 
			$contenido_cabecera = addslashes(implode("\n",file($template_cabecera))); 
			$contenido_cabecera = str_replace ("?"," #?# ",$contenido_cabecera);
	
			eval("\$contenido_HTML = \"$contenido_cabecera\"; ");
			$contenido_HTML = str_replace (" #?# ", "?", $contenido_HTML);
		
			File::writeLine($archivo_cabecera, stripslashes($contenido_HTML)); 
		}// fin del while de idiomas
	}
}

?>