<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// |                                                                      |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
//
/**
 * Esta clase implementa las funciones necesarias para generacion de sitios
 * tanto de portales como de minisitios
 * 
 * @package  Util
 * @version  $Id: image.php,v 1.1 2004/06/01 20:26:05 mlmanyoma Exp $
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
 
class Imagen {
	var $name;
	var $directory;
	var $path;
	var $width, $height, $type, $dimension;
	var $prefix;
	var $exist;

	function Imagen ($name = "",$directory = "") {
		if (!is_dir ($directory) && $directory != "")
			mkdir ($directory, 0775);	
			

			$this->path = $directory."/".$name;
				
        if (file_exists ($this->path)) {
			$this->name       	= $name;
			$this->directory  	= $directory;
			$this->exist	    = TRUE;
			$size        		= GetImageSize($this->path);
			$this->width  		= $size [0];
			$this->height		= $size [1];
			$this->type       	= $size [2];
			$this->dimension 	= $size [3];
		} else {
			$this->name 		= $name;
			$this->directory 	= $directory;
			$this->exist    	= FALSE;
			$this->width	 	= 0;
			$this->heigth   	= 0;
			$this->type      	= "";
		}
	}

    /**
 	 * Copia una imagen de un directorio al otro
     *
     * @param   array $imagen Hash con los datos del archivo imagen
	 *          string $path ruta donde se copiara la imagen
     *
	 * @author  Camilo Torres
     * @access  public
     */    
	function rezise($max_height, $max_width)
	{
        if ($max_width  &&  ($this->width > $max_width))
       {
        	$this->height  =  round($this->height * $max_width / $this->width);
			$this->width =  $max_width;
        } 
        
		if ($max_height  &&  ($this->height > $max_height))
        {
            $this->width   =  round($this->width * $max_height / $this->height);
            $this->height  =  $max_height;
        }
	}
    
    /**
 	 * Copia una imagen de un directorio al otro
     *
     * @param   array $imagen Hash con los datos del archivo imagen
	 *          string $path ruta donde se copiara la imagen
     *
	 * @author  Camilo Torres
     * @access  public
     */    	
	function copiar_imagen($imagen, $name_image){
		$mensaje = "";
        $formatos_permitidos = array(".gif", ".jpg", ".png");
            if ($imagen['size'] > 100000){
                $mensaje = "El tama&ntilde;o del archivo excede el valor permitido.";
            }
            
            if  (($imagen['name'] != "") and  (in_array(substr($imagen['name'], -4), $formatos_permitidos))){
                if (is_uploaded_file($imagen['tmp_name']))
                    copy($imagen['tmp_name'], $name_image);
                else
                    $mensaje = "Error al copiar el archivo";
            }        
            else
                $mensaje = "El tipo de archivo no es valido";

		$_SESSION['mensaje'] = $mensaje;
        return 1;
    
    }

}