<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// |                                                                      |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                     |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
//
/**
 * Esta clase implementa funciones utiles para proposito general
 * 
 * @package  Util
 * @version  $Id: util.php,v 1.3 2004/06/08 21:08:45 jhonvargas Exp $
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
 
class Util
{
    /**
	 * Este metodo modifica una cadena rempazando las tildes, ees
	 * y espacios en blanco
     *
     * @access public
     * @return  string cadena ya modificada
     */
	function fuera($cadena)
	{
		$cadena = str_replace ("", "a", $cadena);
		$cadena = str_replace ("", "a", $cadena);
		$cadena = str_replace ("", "e", $cadena);
		$cadena = str_replace ("", "e", $cadena);
		$cadena = str_replace ("", "i", $cadena);
		$cadena = str_replace ("", "i", $cadena);
		$cadena = str_replace ("", "o", $cadena);
		$cadena = str_replace ("", "o", $cadena);
		$cadena = str_replace ("", "u", $cadena);
		$cadena = str_replace ("", "u", $cadena);
		$cadena = str_replace ("", " ", $cadena);
		$cadena = str_replace ("", "N", $cadena);
		$cadena = str_replace ("", "", $cadena);
		$cadena = str_replace ("&", "Y", $cadena);
		$cadena = str_replace ("~", "", $cadena);
		$cadena = str_replace ("?", "", $cadena);
		$cadena = str_replace ("=", "", $cadena);
		$cadena = str_replace (" ", "_", $cadena);
		
		return $cadena;
	}
	
	function fecha_actual()
	{
		setlocale (LC_TIME , $_SESSION['sis_idioma']['enctype']);
		echo strftime("%d") . ' de ' . strftime("%B") . ' de ' . strftime("%Y");
	}

	function copiar_archivo($archivo, $name_archivo){
		$mensaje = "";
        $formatos_permitidos = array(".doc", ".rtf");
            if ($archivo['size'] > 1500000){
                $mensaje = "El tama&ntilde;o del archivo excede el valor permitido.";
            }
            
            if  (($archivo['name'] != "") and  (in_array(substr($archivo['name'], -4), $formatos_permitidos))){
                if (is_uploaded_file($archivo['tmp_name']))
                    copy($archivo['tmp_name'], $name_archivo);
                else{
                    $mensaje = "Error al copiar el archivo";
					return 0;
				}
            }        
            else{
                $mensaje = "El tipo de archivo no es valido";
				return 0;
			}

		$_SESSION['mensaje'] = $mensaje;
        return 1;
    
    }
	
	/*
	 * Menciona la el nmero de items encontrados y 
	 * desde donde hasta donde muestra los registros.
	 *
	 * @param array Hash con los datos del paginador 
	 * @return string Cadena con el mensaje cabecera de la lista
	 */
	function encontrados($data)
	{
		if (!$data)
			$mensaje = "No se encontraron registros!!<br>";
		else {
			$mensaje =  '<br>Encontrados <b>'.$data['numrows'].'</b> registros ';
    		if ($data['numrows'] > constant("NUM_REGISTROS")) {
    			$mensaje .= 'Mostrando desde <b>'.$data['from'].'</b>';
	    		$mensaje .= ' hasta <b>'.$data['to'].'</b><br>';
            }
		}
		
		return $mensaje;
	}
	
	/*
	 * Menciona la lista de pginas para mostrar los
	 * demas registros encontrados.
	 *
	 * @param array Hash con los datos del paginador 
	 * @return string Cadena con la lista de links para las pginas.
	 */
	function paginar($data)
	{
	   /** Mantener los datos de bsqueda **/
		$link_array = array(); 
		foreach ($_SESSION[_FORM]->_values as $k => $v)
			array_push($link_array, "$k=$v");
		$url .= "phrame.php?" . implode('&',$link_array);	
		
		if ($data['numrows'] > constant("NUM_REGISTROS")) {
			$link = '<a href="'.$url.'&from='.$data['prev'].'" class="ident">&lt;</a>&nbsp;&nbsp;';
	
			foreach($data['pages'] as $i => $from) { 
				$link .= '&nbsp;<a href="'.$url.'&from='.$from.'" class="ident">';
				$link .= ($i == $data['current']) ? "<u>$i</u>" : $i ;
				$link .= '</a>&nbsp;';
			 }
			 
			$link .= '&nbsp;&nbsp;<a href="'.$url.'&from='.$data['next'].'" class="ident">&gt;</a>';
		} else {
			return "";
		}
		
		return $link;
	}
	
	/*
	 * Menciona la el nmero de items encontrados y 
	 * desde donde hasta donde muestra los registros.
	 *
	 * @param array Hash con los datos del paginador 
	 * @return string Cadena con el mensaje cabecera de la lista
	 */
	function encontrados_enviar($data)
	{
		if (!$data)
			$mensaje = "No se encontraron registros!!<br>";
		else {
			$mensaje =  '<br>Encontrados <b>'.$data['numrows'].'</b> registros ';
    		if ($data['numrows'] > constant("NUM_REGISTROS")) {
	    		$mensaje .= 'Mostrando desde <b>'.$data['from'].'</b>';
		    	$mensaje .= ' hasta <b>'.$data['to'].'</b><br>';
            }
		}
		
		return $mensaje;
	}
    
    /*
	 * Menciona la lista de pginas para mostrar los
	 * demas registros encontrados.
	 *
	 * @param array Hash con los datos del paginador 
	 * @return string Cadena con la lista de links para las pginas.
	 */
	function paginar_enviar($data)
	{
	   /** Mantener los datos de bsqueda **/
        $link = Util::encontrados_enviar($data);
		$link_array = array(); 
		foreach ($_SESSION[_FORM]->_values as $k => $v)
			array_push($link_array, "$k=$v");
		$url .= "phrame.php?" . implode('&',$link_array);	
		
		if ($data['numrows'] > constant("NUM_REGISTROS")) {
			$link .= '<a href="'.$url.'&from='.$data['prev'].'" class="ident" onClick="document.forma.submit();">&lt;</a>&nbsp;&nbsp;';
	
			foreach($data['pages'] as $i => $from) { 
				$link .= '&nbsp;<a href="'.$url.'&from='.$from.'" class="ident" onClick="document.forma.submit();">';
				$link .= ($i == $data['current']) ? "<u>$i</u>" : $i ;
				$link .= '</a>&nbsp;';
			 }
			 
			$link .= '&nbsp;&nbsp;<a href="'.$url.'&from='.$data['next'].'" class="ident" onClick="document.forma.submit();">&gt;</a>';
		}
		return $link;
	}
	
	/*
	 * Esta funcion reemplaza vocales con tildes por 
	 * su equivalente en cdigo HTML 
	 *
	 * @param string $cadena Cadena con las vocales y/o consonantes a reemplazar
	 * @return string Cadena con tags HTML
	 * @author John A. Vargas
	 */
	 function poner_tildes($cadena)
	 {
		$cadena = str_replace ("", "&aacute;", $cadena);
		$cadena = str_replace ("", "&aacute;", $cadena);
		$cadena = str_replace ("", "&eacute;", $cadena);
		$cadena = str_replace ("", "&eacute;", $cadena);
		$cadena = str_replace ("", "&iacute;", $cadena);
		$cadena = str_replace ("", "&iacute;", $cadena);
		$cadena = str_replace ("", "&oacute;", $cadena);
		$cadena = str_replace ("", "&oacute;", $cadena);
		$cadena = str_replace ("", "&uacute;", $cadena);
		$cadena = str_replace ("", "&uacute;", $cadena);
		$cadena = str_replace ("", "&Ntilde;", $cadena);
		$cadena = str_replace ("", "&ntilde;", $cadena);
		
		return $cadena;	
	 }
	
	/*
	 * Esta funcion  es para mantener un log de todas las acciones
	 * ejecutadas en el sistema CMS.
	 * 
	 * Se llevara un registro del sitio, usuario, modulo y accin
	 *
	 * @author John A. Vargas
	 * @param string $modulo Modulo en que se esta trabajando
	 *        string $accion Accion que se esta ejecutando
	 *        string $mensaje Mensaje al ejecutar la accion
	 * @access public
	 * @static
	 */ 
	 function log($modulo, $accion, $mensaje)
	 {			
		$request = "http://www.telesat.com.co/demoshosting/log_cms/log_cms.php?";
		$request .= "sitio=" . NOMBRE_PORTAL;
		
		if (isset($_SESSION['usuario']['nombre']))
			$request .= "&usuario=" . $_SESSION['usuario']['nombre'];
			
		$request .= "&modulo=" . Util::fuera($modulo);
		$request .= "&accion=" . Util::fuera($accion);
		$request .= "&mensaje=" . Util::fuera($mensaje);
		$req =& new HTTP_Request($request);
		
		if (!PEAR::isError($req->sendRequest())) {
			$conf = array('mode' => 0600, 'timeFormat' => '%X %x');
			$log  = &Log::singleton('file', PATH_CMS . 'tmp/cms.log', 'CMS', $conf, LOG_INFO);
			$log->log("Error: No se pudo conectar con http://www.telesat.com.co/demoshosting/log_cms => " .  $req->getResponseCode());			$log->log($request);
			$log->close();
		}echo  $req->getResponseBody();
	 }

	/*
	 * Esta funcion  es para mantener un log de todas las acciones
	 * ejecutadas en el sistema CMS.
	 * 
	 * Se llevara un registro del sitio, usuario, modulo y accin
	 *
	 * @author John A. Vargas
	 * @param string $modulo Modulo en que se esta trabajando
	 *        string $accion Accion que se esta ejecutando
	 *        string $mensaje Mensaje al ejecutar la accion
	 * @access public
	 * @static
	 */ 
	 function cms_usuarios($login, $password)
	 {			/*
	 	$request = "http://www.dominio.com/cms_usuarios.php?";
		
		$request .= "&login=" . $login;
		$request .= "&password=" . $password;
		$req =& new HTTP_Request($request);
		$req->sendRequest(); 
		return $req->getResponseBody();*/
		return 2;
	 }

}
?>
