<?php
/*
 * Crea una nueva pelicula
 *
 * @package  Cines
 * @version  1
 * @author   John Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
class crear_peliculaAction extends Action
{
    /**
     * Ejecutar la accin
     *
     * @access    public
     * @param    ActionMapping    $actionMapping
     * @param    ActionForm        $actionForm
     * @return    ActionForward
     */
    function perform($actionMapping, $actionForm)
	{ 
		$res = Fachada_Cines::crear_pelicula($actionForm->get('titulo_espanol'),
											 $actionForm->get('titulo_original'),
											 $actionForm->get('tag_line'),
											 $actionForm->get('id_genero'),
											 $actionForm->get('id_clasificacion'),
											 $actionForm->get('id_calificacion'),
											 $actionForm->get('reparto'),
											 $actionForm->get('director'),
											 $actionForm->get('sinopsis'),
											 $actionForm->get('alquiler'),
											 $actionForm->get('estreno'),
											 $actionForm->get('destacado'),
											 $actionForm->get('imagen'),
											 $actionForm->get('pagina_oficial'));
		
		if ($res) {
			// Crear la encuesta
			$id_cuestionario = Fachada_Cuestionarios::crear_cuestionario('Encuesta ' . $actionForm->get('titulo_espanol'),'');
			$id_pregunta = Fachada_Cuestionarios::get_id_pregunta_encuesta($id_cuestionario, '4','');
			
			// Adicionar las opciones
			Fachada_Cuestionarios::editar_pregunta('votacin', // nombre pregunta
												   '', // texto 0
												   '', // texto 1
												   '', // columnas
												   '', // filas 
									 			   't', // requerida
												   array('Perversa', 'Ah...', 'Aguanta', 'Bacana', 'Buensima'), // Opcin
												   '', // pregunta_abierta
												   $id_cuestionario, // Identificador del cuestionario
												   '1', // Tipo pregunta
												   $id_pregunta, // Identificador
												   array('0', '0', '0', '0', '0'));		
			Fachada_Cines::asignar_encuesta($res, $id_cuestionario);
		
			$pelicula = Fachada_Cines::mostrar_pelicula($res);
			$_SESSION['pelicula'] = $pelicula;

			$mensaje = "ELa pelicula se cre con xito!";
		} else {
			$mensaje = "Problemas al crear la pelicula, Por favor contacte al admnistrador!";
		}
		$_SESSION['mensaje'] = $mensaje;

        return $actionMapping->get('editar');
    }
}
?>
