<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.3.1                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |          Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
//
// Clase Fachada que genera los archivo correspondientes al mdulo de cines
//

/**
 * @package  Cines
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.3.1
 */

class Generador_cines
{     
	/**
 	 * Genera la pgina inicial de cines
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */
	 function generar_principal()
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/'; 
		$template_cines = PATH_CINES . "vistas/templates/tpl_cines.html";

	 	$pagina_cine = new Cin_paginas;
		$modulo = new Cin_datos_modulos_cines;
		$modulo->id_contenedor = $id_sitio;
		$pagina_cine->joinAdd($modulo);
		$pagina_cine->selectAs();
		$pagina_cine->find(true);

	 	$pagina = 'pagina_' . $pagina_cine->id_objeto . '.php';
		$archivo_cines = "$path_sitio/$pagina";

		// Articulo de pelicula recomendada
		$articulo = new Art_articulos_versiones;
		$articulo->id_idioma = $_SESSION['sis_idiomas']['id_idioma'];
		$articulo->id_objeto = $modulo->id_articulo;
		$articulo->find(true);
		
		// Se escribe la cabecera del portal
		$include = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		
		Generador_cines::generar_lista_busqueda();
		File::writeLine($archivo_cines, $include, FILE_MODE_WRITE);

		// Generacion del bloque de recomendado
		$archivo_recomendado = Generador_cines::generar_bloque_recomendado($articulo);
		$bloque_recomendado = "<? include ('$archivo_recomendado') ?>";
		
		// Generar bloques de destacados en cartelera
		$tpl_cartelera_destacado = Generador_cines::generar_destacados_cartelera();
		Generador_cines::generar_cartelera($pagina);
		
		// Generar bloques de estrenos destacados 
		$tpl_estreno_destacado = Generador_cines::generar_estrenos_destacados();
		Generador_cines::generar_estreno($pagina);
		
		// Generar bloques de estrenos destacados 
		$tpl_alquiler_destacado = Generador_cines::generar_alquiler_destacados();
		Generador_cines::generar_alquilar($pagina);

		// Leemos el codigo del template
		$contenido_cines = addslashes(implode("\n",file($template_cines)));

		// Evaluo el codigo PHP que hay en el template
		eval("\$contenido_HTML = \"$contenido_cines\"; ");
		
		// Se escribe en el archivo
		File::writeLine($archivo_cines, stripslashes($contenido_HTML));

		// Se escribe el pie del portal
		File::writeLine($archivo_cines, '<? include("vistas/foot_public.php") ?>');
		File::close($archivo_cines, FILE_MODE_WRITE);
	 }
	 
	/**
 	 * Genera el bloque de articulo recomandado para cine
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */
	 function generar_bloque_recomendado($articulo)
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/'; 
		$template_bloque = PATH_CINES . "vistas/templates/tpl_recomendado.html";
		$archivo_bloque = "$path_sitio/bloque_recomendado.html";
		
		$imagen_articulo = '<?= PATH_IMAGES ?>articulos/' . $articulo->imagen;
		$imagen = new Imagen($articulo->imagen, 'imagenes_cont/sitio/articulos');	
		$imagen->rezise(176, 285);
			
		// Se escribe el contenido del bloque
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		eval("\$contenido_HTML = \"$contenido_bloque\"; ");
		File::writeLine($archivo_bloque, stripslashes($contenido_HTML), FILE_MODE_WRITE);
		File::close($archivo_bloque);
		
		return 'vistas/' . $_SESSION['sis_idioma']['enctype'] . '/bloque_recomendado.html';
	 }
	 
	/**
 	 * Genera el bloque de articulo recomandado para cine
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */
	 function generar_destacados_cartelera()
	 {
		$template_bloque = PATH_CINES . "vistas/templates/tpl_cartelera_destacado.php";
	 	
		$film = new Cin_peliculas;
		$funcion = new Cin_funciones;
		$film->destacado = 1;
		$film->joinAdd($funcion);
		$film->selectAdd();
		$film->selectAdd('DISTINCT(cin_peliculas.id_pelicula), cin_peliculas.*');
		$film->find();
		
		$lista_peliculas = new ArrayList;
		while ($film->fetch())
			$lista_peliculas->add($film);

		include ($template_bloque);
		
		return $contenido_HTML;
	 }
	 
	/**
 	 * Genera el bloque de estreno destacado  
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */
	 function generar_estrenos_destacados()
	 {
		$template_bloque = PATH_CINES . "vistas/templates/tpl_estreno_destacado.html";
		
		$pelicula = new Cin_peliculas;
		$genero = new Cin_generos;
		$pelicula->estreno = 1;
		$pelicula->destacado = 1;
		$pelicula->joinAdd($genero);
		$pelicula->find();
		
		$contenido_HTML = '';
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		while ($pelicula->fetch()) {
			$imagen_pelicula = '<?= PATH_IMAGES ?>cines/' . $pelicula->imagen;
			$imagen = new Imagen($pelicula->imagen, 'imagenes_cont/sitio/cines');	
			$imagen->rezise(94, 68);
			
			$pelicula->reparto = substr($pelicula->reparto, 0, 40);
			eval("\$contenido_HTML .= \"$contenido_bloque\"; ");
			$contenido_HTML .= '<br clear="all">';
		}	
		
		return $contenido_HTML;
	 }
	 
	/**
 	 * Genera el bloque de alquileres destacados
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */
	 function generar_alquiler_destacados()
	 {
		$template_bloque = PATH_CINES . "vistas/templates/tpl_alquilar_destacado.html";
		
		$pelicula = new Cin_peliculas;
		$genero = new Cin_generos;
		$pelicula->alquilar = 1;
		$pelicula->destacado = 1;
		$pelicula->joinAdd($genero);
		$pelicula->find();
		
		$contenido_HTML = '';
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		while ($pelicula->fetch()) {
			$imagen_pelicula = '<?= PATH_IMAGES ?>cines/' . $pelicula->imagen;
			$imagen = new Imagen($pelicula->imagen, 'imagenes_cont/sitio/cines');	
			$imagen->rezise(94, 68);
			
			$pelicula->reparto = substr($pelicula->reparto, 0, 40);
			eval("\$contenido_HTML .= \"$contenido_bloque\"; ");
			$contenido_HTML .= '<br clear="all">';
		}	
		
		return $contenido_HTML;
	 }
	 
	/**
 	 * Genera cartelera
     *
	 * @author John A. Vargas
     * @access public
	 * @static
     */
	 function generar_cartelera($pagina)
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/'; 
		$template_cartelera = PATH_CINES . "vistas/templates/tpl_cartelera.html";
	 	$archivo_cartelera = "$path_sitio/cartelera.php";
		
		$pelicula = new Cin_peliculas;
		$funcion = new Cin_funciones;
		$pelicula->joinAdd($funcion);
		$pelicula->selectAdd();
		$pelicula->selectAdd('DISTINCT(cin_peliculas.id_pelicula), cin_peliculas.*');
		$pelicula->find();
		
		// Se escribe la cabecera del portal
		$include = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_cartelera, $include, FILE_MODE_WRITE);
		
		$tpl_cartelera = '';
		$i = 0;
		while ($pelicula->fetch()) { 
			$template_bloque = PATH_CINES . "vistas/templates/tpl_bloque_cartelera";
			$template_bloque .= ($i % 4 == 0 || ($i + 1) % 4 == 0) ? '1.html' : '2.html';
			$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
			
			$pelicula->reparto = substr($pelicula->reparto, 0, 40);
			eval("\$tpl_cartelera .= \"$contenido_bloque\"; ");
			
			if (++$i % 2 == 0) {
				$tpl_cartelera .= '<br clear="all"><br>';
			}
		}			

		$contenido_cartelera = addslashes(implode("\n",file($template_cartelera)));
		
		// Evaluo el codigo PHP que hay en el template
		eval("\$contenido_HTML = \"$contenido_cartelera\"; ");
		
		// Se escribe en el archivo
		File::writeLine($archivo_cartelera, stripslashes($contenido_HTML));

		// Se escribe el pie del portal
		File::writeLine($archivo_cartelera, '<? include("vistas/foot_public.php") ?>');
		File::close($archivo_cartelera, FILE_MODE_WRITE);
	 }
	 
	/**
 	 * Genera detalle de la pelicula
     *
	 * @author John A. Vargas
     * @access public
	 * @static
     */
	 function generar_pelicula($id_pelicula)
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/'; 
		$template_pelicula = PATH_CINES . "vistas/templates/tpl_pelicula.html";
	 	$archivo_pelicula = "$path_sitio/pelicula_$id_pelicula.php";
		
		$pelicula = new Cin_peliculas;
		$genero = new Cin_generos;
		$pelicula->id_pelicula = $id_pelicula;
		$clasificacion = new Cin_clasificaciones;
		$calificacion = new Cin_calificaciones;
		$pelicula->joinAdd($genero);
		$pelicula->joinAdd($clasificacion);
		$pelicula->joinAdd($calificacion);
		$pelicula->selectAs($genero, "gen_%s");
		$pelicula->selectAs($clasificacion, "cla_%s");
		$pelicula->selectAs($calificacion, "cal_%s");
		$pelicula->find(true);
		
		$imagen_pelicula = '<?= PATH_IMAGES ?>cines/' . $pelicula->imagen;
		$imagen = new Imagen($pelicula->imagen, 'imagenes_cont/sitio/cines');	
		$imagen->rezise(199, 134);
		
		// Se escribe la cabecera del portal
		$include = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_pelicula, $include, FILE_MODE_WRITE);
		
		$funcion = new Cin_funciones;
		$teatro = new Cin_teatros;
		$funcion->id_pelicula = $id_pelicula;
		$funcion->joinAdd($teatro);
		$funcion->selectAs($teatro, "te_%s");
		$funcion->find();
		
		$contenido_funciones = '';
		$i = 0;
		while ($funcion->fetch()) { 
			$template_funcion = PATH_CINES . "vistas/templates/tpl_funcion.html";
			$contenido_funcion = addslashes(implode("\n",file($template_funcion)));
			
			$pelicula->reparto = substr($pelicula->reparto, 0, 40);
			eval("\$contenido_funciones .= \"$contenido_funcion\"; ");
			$contenido_funciones .= '<br clear="all"><br>';
		}			

		$contenido_pelicula = addslashes(implode("\n",file($template_pelicula)));
		$contenido_encuesta = Generador_Cines::generar_encuesta($pelicula->id_encuesta, $id_pelicula);
			 	$pagina_cine = new Cin_paginas;
		$modulo = new Cin_datos_modulos_cines;

		// Referencia a la pgina de cines
		$modulo->id_contenedor = $id_sitio;
		$pagina_cine->joinAdd($modulo);
		$pagina_cine->selectAs();
		$pagina_cine->find(true);
	 	$pagina = 'pagina_' . $pagina_cine->id_objeto . '.php';

		// Articulo de pelicula recomendada
		$articulo = new Art_articulos_versiones;
		$articulo->id_idioma = $_SESSION['sis_idiomas']['id_idioma'];
		$articulo->id_objeto = $modulo->id_articulo;
		$articulo->find(true);
		
		// Evaluo el codigo PHP que hay en el template
		eval("\$contenido_HTML = \"$contenido_pelicula\"; ");
		
		// Se escribe en el archivo
		File::writeLine($archivo_pelicula, stripslashes($contenido_HTML));

		// Se escribe el pie del portal
		File::writeLine($archivo_pelicula, '<? include("vistas/foot_public.php") ?>');
		File::close($archivo_pelicula, FILE_MODE_WRITE);
	 }
	 
	/**
 	 * Genera estrenos
     *
	 * @author John A. Vargas
     * @access public
	 * @static
     */
	 function generar_estreno($pagina)
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/'; 
		$template_estreno = PATH_CINES . "vistas/templates/tpl_estreno.html";
	 	$archivo_estreno = "$path_sitio/estreno.php";
		
		$pelicula = new Cin_peliculas;
		$pelicula->estreno = 1;
		$pelicula->find();
		
		// Se escribe la cabecera del portal
		$include = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_estreno, $include, FILE_MODE_WRITE);
		
		$tpl_estreno = '';
		$i = 0;
		while ($pelicula->fetch()) { 
			$template_bloque = PATH_CINES . "vistas/templates/tpl_bloque_estreno.html";
			$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		
			$imagen_pelicula = '<?= PATH_IMAGES ?>cines/' . $pelicula->imagen;
			$imagen = new Imagen($pelicula->imagen, 'imagenes_cont/sitio/cines');	
			$imagen->rezise(199, 134);
			
			$pelicula->reparto = substr($pelicula->reparto, 0, 40);
			eval("\$tpl_estreno .= \"$contenido_bloque\"; ");
			
			$tpl_estreno .= '<br clear="all"><br>';
		}			

		$contenido_estreno = addslashes(implode("\n",file($template_estreno)));
		
		// Evaluo el codigo PHP que hay en el template
		eval("\$contenido_HTML = \"$contenido_estreno\"; ");
		
		// Se escribe en el archivo
		File::writeLine($archivo_estreno, stripslashes($contenido_HTML));

		// Se escribe el pie del portal
		File::writeLine($archivo_estreno, '<? include("vistas/foot_public.php") ?>');
		File::close($archivo_estreno, FILE_MODE_WRITE);
	 }
	 
	/**
 	 * Genera alquilar
     *
	 * @author John A. Vargas
     * @access public
	 * @static
     */
	 function generar_alquilar($pagina)
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/'; 
		$template_alquilar = PATH_CINES . "vistas/templates/tpl_alquilar.html";
	 	$archivo_alquilar = "$path_sitio/alquilar.php";
		
		$pelicula = new Cin_peliculas;
		$pelicula->alquilar = 1;
		$pelicula->find();
		
		// Se escribe la cabecera del portal
		$include = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_alquilar, $include, FILE_MODE_WRITE);
		
		$tpl_alquilar = '';
		$i = 0;
		while ($pelicula->fetch()) { 
			$template_bloque = PATH_CINES . "vistas/templates/tpl_bloque_alquilar.html";
			$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		
			$imagen_pelicula = '<?= PATH_IMAGES ?>cines/' . $pelicula->imagen;
			$imagen = new Imagen($pelicula->imagen, 'imagenes_cont/sitio/cines');	
			$imagen->rezise(199, 134);
			
			$pelicula->reparto = substr($pelicula->reparto, 0, 40);
			eval("\$tpl_alquilar .= \"$contenido_bloque\"; ");
			
			$tpl_alquilar .= '<br clear="all"><br>';
		}			

		$contenido_estreno = addslashes(implode("\n",file($template_alquilar)));
		
		// Evaluo el codigo PHP que hay en el template
		eval("\$contenido_HTML = \"$contenido_estreno\"; ");
		
		// Se escribe en el archivo
		File::writeLine($archivo_alquilar, stripslashes($contenido_HTML));

		// Se escribe el pie del portal
		File::writeLine($archivo_alquilar, '<? include("vistas/foot_public.php") ?>');
		File::close($archivo_alquilar, FILE_MODE_WRITE);
	 }
	 
	/**
 	 * Genera la encuesta de votacin para una pelicula
     *
	 * @author John A. Vargas
     * @access public
	 * @static
     */
	 function generar_encuesta($id_encuesta, $id_pelicula)
	 {		
		$template_encuesta = PATH_CINES . "vistas/templates/tpl_encuesta.html";
		
		// Buscamos los cuestionarios del sitio (id_sitio)
		$encuesta = new Cue_cuestionarios;
		$pregunta = new Cue_preguntas;
		$posibles_respuestas = new Cue_posibles_respuestas;
		$respuesta_version = new Cue_posibles_respuestas_versiones;
		
		$encuesta->get($id_encuesta);
		
		$pregunta->id_cuestionario = $id_encuesta;
		$posibles_respuestas->joinAdd($pregunta);
		$posibles_respuestas->joinAdd($respuesta_version);
		$posibles_respuestas->orderBy('numero');
		$posibles_respuestas->find();
		
		$lista_respuestas = array();
		while ($posibles_respuestas->fetch())
			array_push($lista_respuestas, $posibles_respuestas);
		
		$contenido_encuesta = addslashes(implode("\n",file($template_encuesta)));
		
		// Evaluo el codigo PHP que hay en el template
		eval("\$contenido_HTML = \"$contenido_encuesta\"; ");
		
		return $contenido_HTML;
	 }
	 
	/**
 	 * Genera la encuesta de votacin para una pelicula
     *
	 * @author John A. Vargas
     * @access public
	 * @static
     */
	 function generar_lista_busqueda()
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/'; 
	 	$archivo_lista = "$path_sitio/lista_busqueda.php";
		
	 	// Generacion de lista de teatros
		$template_teatros = PATH_CINES . "vistas/templates/tpl_lista_teatros.php";
		$lista_teatros = Fachada_Cines::listar_teatros();
		include ($template_teatros);
		File::writeLine($archivo_lista, stripslashes($contenido_HTML), FILE_MODE_WRITE);
		
		// Generacin de lista de peliculas
		$template_peliculas = PATH_CINES . "vistas/templates/tpl_lista_peliculas.php";
		$pelicula = new Cin_peliculas;
		$pelicula->orderBy('titulo_espanol');
		$pelicula->find();
		$lista_peliculas = array();
		while ($pelicula->fetch())
			array_push($lista_peliculas, $pelicula->toArray());

		include ($template_peliculas);
		File::writeLine($archivo_lista, stripslashes($contenido_HTML));
		
		File::close(archivo_lista, FILE_MODE_WRITE);
	 }	 
	 
	/**
 	 * Genera cartelera
     *
	 * @author John A. Vargas
     * @access public
	 * @static
     */
	 function generar_teatro($id_teatro)
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/'; 
		$template_cartelera = PATH_CINES . "vistas/templates/tpl_cartelera.html";
	 	$archivo_teatro = "$path_sitio/teatro_$id_teatro.php";
		
		$pelicula = new Cin_peliculas;
		$funcion = new Cin_funciones;
		$funcion->id_teatro = $id_teatro;
		$pelicula->joinAdd($funcion);
		$pelicula->selectAdd();
		$pelicula->selectAdd('DISTINCT(cin_peliculas.id_pelicula), cin_peliculas.*');
		$pelicula->find();
		
		// Se escribe la cabecera del portal
		$include = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_teatro, $include, FILE_MODE_WRITE);
		
		$tpl_cartelera = '';
		$i = 0;
		while ($pelicula->fetch()) { 
			$template_bloque = PATH_CINES . "vistas/templates/tpl_bloque_cartelera";
			$template_bloque .= ($i % 4 == 0 || ($i + 1) % 4 == 0) ? '1.html' : '2.html';
			$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
			
			$pelicula->reparto = substr($pelicula->reparto, 0, 40);
			eval("\$tpl_cartelera .= \"$contenido_bloque\"; ");
			
			if (++$i % 2 == 0) {
				$tpl_cartelera .= '<br clear="all"><br>';
			}
		}			

		$contenido_cartelera = addslashes(implode("\n",file($template_cartelera)));
		
		// Evaluo el codigo PHP que hay en el template
		eval("\$contenido_HTML = \"$contenido_cartelera\"; ");
		
		// Se escribe en el archivo
		File::writeLine($archivo_teatro, stripslashes($contenido_HTML));

		// Se escribe el pie del portal
		File::writeLine($archivo_teatro, '<? include("vistas/foot_public.php") ?>');
		File::close($archivo_teatro, FILE_MODE_WRITE);
	 }
	/*
	 * Genera todo el modulo de cines
	 *
	 * @static
	 */
	function generar_cines()
	{
		Generador_cines::generar_principal();
		
		$modulo = new Cin_datos_modulos_cines;
		$modulo->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
			
		// Generacin de teatro.
		$teatro = new Cin_teatros;
		$teatro->id_contendor = $modulo->id_objeto;
		$teatro->find();
		while ($teatro->fetch())
			Generador_cines::generar_teatro($teatro->id_teatro);
		
		// Generacin de pelicula.
		$pelicula = new Cin_peliculas;
		$pelicula->id_contendor = $modulo->id_objeto;
		$pelicula->find();
		while ($pelicula->fetch())
			Generador_cines::generar_pelicula($pelicula->id_pelicula);
	}
}
?>