<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |          Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
//
// Clase Fachada que maneja el paquete Cines
//

		/**** MODELO (Conjunto de clases DataObject) ****/
require_once PATH_CINES . 'modelo/Cin_datos_modulos_cines.php';
require_once PATH_CINES . 'modelo/Cin_paginas.php';
require_once PATH_CINES . 'modelo/Cin_paginas_versiones.php';
require_once PATH_CINES . 'modelo/Cin_teatros.php';
require_once PATH_CINES . 'modelo/Cin_calificaciones.php';
require_once PATH_CINES . 'modelo/Cin_clasificaciones.php';
require_once PATH_CINES . 'modelo/Cin_generos.php';
require_once PATH_CINES . 'modelo/Cin_peliculas.php';
require_once PATH_CINES . 'modelo/Cin_funciones.php';
require_once PATH_CINES . 'modelo/Generador_cines.php';

		/**** CONTROLADOR (Phrame: acciones, formas y mapping) ****/
// Mapeamiento
include(PATH_CINES . 'controlador/mappings.php');

// Formularios
require_once PATH_CINES . 'controlador/forms/crear_clasificacionForm.php';
require_once PATH_CINES . 'controlador/forms/crear_calificacionForm.php';
require_once PATH_CINES . 'controlador/forms/crear_generoForm.php';
require_once PATH_CINES . 'controlador/forms/crear_teatroForm.php';

// Acciones
require_once PATH_CINES . 'controlador/actions/mostrar_clasificacionAction.php';
require_once PATH_CINES . 'controlador/actions/crear_clasificacionAction.php';
require_once PATH_CINES . 'controlador/actions/modificar_clasificacionAction.php';
require_once PATH_CINES . 'controlador/actions/eliminar_clasificacionAction.php';
require_once PATH_CINES . 'controlador/actions/mostrar_calificacionAction.php';
require_once PATH_CINES . 'controlador/actions/crear_calificacionAction.php';
require_once PATH_CINES . 'controlador/actions/modificar_calificacionAction.php';
require_once PATH_CINES . 'controlador/actions/eliminar_calificacionAction.php';
require_once PATH_CINES . 'controlador/actions/mostrar_generoAction.php';
require_once PATH_CINES . 'controlador/actions/crear_generoAction.php';
require_once PATH_CINES . 'controlador/actions/modificar_generoAction.php';
require_once PATH_CINES . 'controlador/actions/eliminar_generoAction.php';
require_once PATH_CINES . 'controlador/actions/listar_teatrosAction.php';
require_once PATH_CINES . 'controlador/actions/crear_teatroAction.php';
require_once PATH_CINES . 'controlador/actions/mostrar_teatroAction.php';
require_once PATH_CINES . 'controlador/actions/modificar_teatroAction.php';
require_once PATH_CINES . 'controlador/actions/ver_creacion_peliculaAction.php';
require_once PATH_CINES . 'controlador/actions/crear_peliculaAction.php';
require_once PATH_CINES . 'controlador/actions/modificar_peliculaAction.php';
require_once PATH_CINES . 'controlador/actions/buscar_peliculaAction.php';
require_once PATH_CINES . 'controlador/actions/mostrar_peliculaAction.php';
require_once PATH_CINES . 'controlador/actions/adicionar_funcionAction.php';
require_once PATH_CINES . 'controlador/actions/mostrar_funcionesAction.php';
require_once PATH_CINES . 'controlador/actions/modificar_funcionAction.php';
require_once PATH_CINES . 'controlador/actions/eliminar_funcionAction.php';
require_once PATH_CINES . 'controlador/actions/mostrar_arbol_recomendarAction.php';
require_once PATH_CINES . 'controlador/actions/recomendar_articulo_cineAction.php';

/**
 * @package  Cines
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
class Fachada_Cines
{      	
		   /******** FUNCIONES *********/
    /** Eliminar una funcin
     *
	 * @param int $id_funcion Identificador de la clasificacin.
	 * @return int Nmero de calificaciones eliminadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function eliminar_funcion($id_funcion)
	{
		$funcion = new Cin_funciones;
		$funcion->get($id_funcion);
		$res = $funcion->delete();
		
		Generador_cines::generar_pelicula($funcion->id_pelicula);
		Generador_cines::generar_teatro($funcion->id_teatro);
		Generador_cines::generar_principal();
		
		return $res;
	}
	
    /**
     * Modifica una funcin
     *
	 * @param strinf $funcion Horarios de la funcin.
	 * @param date $fecha_inicio Fecha que inicia la funcin.
	 * @param date $fecha_fin Fecha que finaliza la funcin.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function modificar_funcion($id_funcion, $horario,
							   $fecha_inicio, $fecha_fin)     
	{
		$funcion = new Cin_funciones;
		$funcion->get($id_funcion);
		
		$funcion->horario = $horario;
		$funcion->desde = $fecha_inicio;
		$funcion->hasta = $fecha_fin;
		$res = $funcion->update(); 
		
		Generador_cines::generar_pelicula($funcion->id_pelicula);
		Generador_cines::generar_teatro($funcion->id_teatro);
		Generador_cines::generar_principal();
		
		return $res;
	}
	
    /**
     * Crea una nueva funcion
     *
	 * @param int $id_teatro Identificador del teatro.
	 * @param int $id_pelicula Identificador de la pelicula.
	 * @param strinf $funcion Horarios de la funcin.
	 * @param date $fecha_inicio Fecha que inicia la funcin.
	 * @param date $fecha_fin Fecha que finaliza la funcin.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function adicionar_funcion($id_teatro, $id_pelicula, $horario,
							   $fecha_inicio, $fecha_fin)
	{
		$funcion = new Cin_funciones;
		$funcion->id_teatro = $id_teatro;
		$funcion->id_pelicula = $id_pelicula;
		$metodo = ($funcion->find(true)) ? 'update' : 'insert';
		
		$funcion->horario = $horario;
		$funcion->desde = $fecha_inicio;
		$funcion->hasta = $fecha_fin;
		$res = $funcion->$metodo();
		
		Generador_cines::generar_pelicula($funcion->id_pelicula);
		Generador_cines::generar_teatro($funcion->id_teatro);
		Generador_cines::generar_principal();
			
		return $res;
	}  
	
    /**
     * Crea una lista de las clasificaciones
     *
	 * @param int $id_pelicula Identificador de la pelicula.
	 * @param int $id_teatro Identificador del teatro.
     * @return  array Lista de funciones existentes
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function listar_funciones($id_pelicula, $id_teatro)
	{
		$funcion = new Cin_funciones;
		$pelicula = new Cin_peliculas;
		$teatro = new Cin_teatros;
		
		if ($id_pelicula != '')
			$funcion->id_pelicula = $id_pelicula;
			
		if ($id_teatro != '')
			$funcion->id_teatro = $id_teatro;
				
		$funcion->joinAdd($pelicula);
		$funcion->joinAdd($teatro);		
		$funcion->orderBy('hasta');
		$funcion->find();

		$lista = new ArrayList;
		while ($funcion->fetch())
			$lista->add(get_object_vars($funcion));
		
		return $lista->toArray();
	}  

	
		/********* PELICULAS *********/
    /**
     * Bsqueda de peliculas
     *
	 * @param string $nombre Nombre de la pelicula.
	 * @param boolean $alquilar Peliculas para alquilar.
	 * @param boolean $estreno Peliculas para estrenar.
	 * @param boolean $cartelera Peliculas para cartelera.
	 * @param boolean $destacado Peliculas para destacado.
	 * @return array Lista de peliculas encontradas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function buscar_pelicula($nombre, $alquilar, $estreno, $cartelera, $destacado)
	{
		$pelicula = new Cin_peliculas;
		
		// Asignar criterios de bsqueda
		if ($nombre != '') 
			$pelicula->whereAdd("LOWER(titulo_espanol) LIKE LOWER('%$nombre%')");
		
		if ($alquilar != '') 
			$pelicula->alquilar = 1;
		
		if ($estreno != '') 
			$pelicula->estreno = 1;
		
		if ($destacado != '') 
			$pelicula->destacado = 1;
			
				// Paginar los resultados de bsqueda
		if ($from == '') $from = 0; 
		$data = DB_Pager::getData($from, NUM_REGISTROS, $pelicula->count(), MAXPAGES);

		$pelicula->limit($from, NUM_REGISTROS);
		$pelicula->orderBy('titulo_espanol'); 
		$pelicula->find();
	
		$lista_peliculas = new ArrayList;
		while ($pelicula->fetch()) 
			$lista_peliculas->add($pelicula->toArray());

		return array('lista' => $lista_peliculas->toArray(), 'data' => $data);	
	}
	
    /**
     * Modifica los datos de una pelicula.
     *
	 * @param int $id_pelicula Identificador de la pelicula.
	 * @param string $titulo_espanol Titulo en espaol de la nueva pelicula.
	 * @param string $titulo_original Titulo original de la nueva pelicula.
	 * @param string $tag_line Frase distintiva de la pelicula.
	 * @param int $id_genero Identificador del gnero de la pelicula.
	 * @param int $id_clasificacion Identificador de la clasificacin.
	 * @param int $id_calificacion Identificador de la calificacin.
	 * @param string $reparto Reparto de la pelicula.
	 * @param string $director Director de la pelicula.
	 * @param string $sinopsis Sinopsis.
	 * @param boolean $alquiler Si es de alquiler.
	 * @param boolean $estreno Si esta en estreno.
	 * @param boolean $destacado si es destacado.
	 * @param array $imagen Imagen de la pelicula.
	 * @return int Nmero de peliculas actualizadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function modificar_pelicula($id_pelicula, $titulo_espanol, $titulo_original, 
							$tag_line, $id_genero, $id_clasificacion, 
							$id_calificacion, $reparto, $director, $sinopsis, 
							$alquiler, $estreno, $destacado, $imagen, $pagina_oficial)     
	{
		$pelicula = new Cin_peliculas;
		$pelicula->get($id_pelicula);
		
		// Copiar el archivo imagenes
		$directorio_sitio = 'imagenes_cont/' . $_SESSION['sitio']['url'] . '/';
		if (!file_exists($directorio_sitio))
			mkdir ($directorio_sitio);
			
		$directorio_cine = $directorio_sitio . 'cines/';
		if (!file_exists($directorio_cine))
			mkdir ($directorio_cine);
			
		if (file_exists($imagen['tmp_name']) && $imagen['tmp_name'] != '') {
			$name_imagen = time() . $imagen['name'];
			Imagen::copiar_imagen($imagen, $directorio_cine . $name_imagen);
			
			// Borrar la imagen anterior
			if (file_exists($directorio_cine . $pelicula->imagen) && $pelicula->imagen != '')
				@unlink($directorio_cine . $pelicula->imagen);
				
			$pelicula->imagen = $name_imagen;
		}
		
		// Actualizar el registro	
		$pelicula->titulo_espanol = $titulo_espanol;
		$pelicula->titulo_original = $titulo_original;
		$pelicula->tag_line = $tag_line;
		$pelicula->id_genero = $id_genero;
		$pelicula->id_clasificacion = $id_clasificacion;
		$pelicula->id_calificacion = $id_calificacion;
		$pelicula->reparto = $reparto;
		$pelicula->director = $director;
		$pelicula->sinopsis = $sinopsis;
		$pelicula->alquilar = $alquiler;
		$pelicula->estreno = $estreno;
		$pelicula->destacado = $destacado;
		$pelicula->pagina_oficial = $pagina_oficial;
		$res = $pelicula->update(); 
		
		// Generar pgina inicial de cines
		Generador_cines::generar_principal();
		Generador_cines::generar_pelicula($id_pelicula);
		
		return $res;
	}
	
    /**
      * Crea una nueva pelicula
     *
	 * @param string $titulo_espanol Titulo en espaol de la nueva pelicula.
	 * @param string $titulo_original Titulo original de la nueva pelicula.
	 * @param string $tag_line Frase distintiva de la pelicula.
	 * @param int $id_genero Identificador del gnero de la pelicula.
	 * @param int $id_clasificacion Identificador de la clasificacin.
	 * @param int $id_calificacion Identificador de la calificacin.
	 * @param string $reparto Reparto de la pelicula.
	 * @param string $director Director de la pelicula.
	 * @param string $sinopsis Sinopsis.
	 * @param boolean $alquiler Si es de alquiler.
	 * @param boolean $estreno Si esta en estreno.
	 * @param boolean $destacado si es destacado.
	 * @param array $imagen Imagen de la pelicula.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function crear_pelicula($titulo_espanol, $titulo_original, $tag_line, 
							$id_genero, $id_clasificacion, $id_calificacion, 
							$reparto, $director, $sinopsis, $alquiler, 
							$estreno, $destacado, $imagen, $pagina_oficial)
	{
		$pelicula = new Cin_peliculas;
		
		// Copiar el archivo imagenes
		$directorio_sitio = 'imagenes_cont/' . $_SESSION['sitio']['url'] . '/';
		if (!file_exists($directorio_sitio))
			mkdir ($directorio_sitio);
			
		$directorio_cine = $directorio_sitio . 'cines/';
		if (!file_exists($directorio_cine))
			mkdir ($directorio_cine);
			
		if (file_exists($imagen['tmp_name']) && $imagen['tmp_name'] != '') {
			$name_imagen = time() . $imagen['name'];
			Imagen::copiar_imagen($imagen, $directorio_cine . $name_imagen);
			$pelicula->imagen = $name_imagen;
		} 
	
		$modulo = new Cin_datos_modulos_cines;
		$modulo->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		
		// Insertar el registro	
		$pelicula->titulo_espanol = $titulo_espanol;
		$pelicula->titulo_original = $titulo_original;
		$pelicula->tag_line = $tag_line;
		$pelicula->id_genero = $id_genero;
		$pelicula->id_clasificacion = $id_clasificacion;
		$pelicula->id_calificacion = $id_calificacion;
		$pelicula->reparto = $reparto;
		$pelicula->director = $director;
		$pelicula->sinopsis = $sinopsis;
		$pelicula->alquilar = $alquiler;
		$pelicula->estreno = $estreno;
		$pelicula->destacado = $destacado;
		$pelicula->pagina_oficial = $pagina_oficial;
		$pelicula->id_contenedor = $modulo->id_objeto;
		$res = $pelicula->insert();
		
		Generador_cines::generar_pelicula($pelicula->id_pelicula);
		Generador_cines::generar_principal();
			
		return $res;
	}  
	
    /**
     * Muestra informacin de la pelicula
     *
     * @return  array Lista de peliculaes existentes
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function mostrar_pelicula($id_pelicula)
	{
		$pelicula = new Cin_peliculas;
		$pelicula->get($id_pelicula);
					
		return $pelicula->toArray();
	}  
	
		/********* TEATROS *********/
    /**
     * Eliminar una teatro
     *
	 * @param int $id_teatro Identificador de la clasificacin.
	 * @return int Nmero de calificaciones eliminadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function eliminar_teatro($id_teatro)
	{
		$teatro = new Cin_teatros;
		$teatro->get($id_teatro);
		$res = $teatro->delete();
		
		Generador_cines::generar_teatro($id_teatro);
		Generador_cines::generar_principal();
		
		return $res;
	}
	
    /**
     * Modificar la informacin de un teatro
     *
	 * @param int $id_teatro Identificador de la teatro.
	 * @param string $nombre Nombre del nuevo teatro.
	 * @param string $ciudad Nombre de la ciudad del teatro
	 * @param string $zona Nombre de la zona del teatro
	 * @param string $direccion Direccin del teatro.
	 * @param string $telefono Nmero telefnico del teatro.
	 * @param string $tarifa Tarifa de precios.
	 * @param boolean $reserva Indica si el teatro soporta o no reservas
	 * @return int Nmero de teatros actualizadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function modificar_teatro($id_teatro, $nombre, $ciudad, $zona, 
							  $direccion, $telefono, $tarifa, $reserva)
	{
		$teatro = new Cin_teatros;
		$teatro->get($id_teatro);
		$teatro->nombre = $nombre;
		$teatro->ciudad = $ciudad;
		$teatro->zona = $zona;
		$teatro->direccion = $direccion;
		$teatro->telefono = $telefono;
		$teatro->tarifa = $tarifa;
		$teatro->reserva = $reserva;
		$res = $teatro->update();
		
		Generador_cines::generar_teatro($id_teatro);
		Generador_cines::generar_principal();
		
		return $res;
	}  
	
    /**
      * Crea una nueva teatro
     *
	 * @param string $nombre Nombre del nuevo teatro.
	 * @param string $ciudad Nombre de la ciudad del teatro
	 * @param string $zona Nombre de la zona del teatro
	 * @param string $direccion Direccin del teatro.
	 * @param string $telefono Nmero telefnico del teatro.
	 * @param string $tarifa Tarifa de precios.
	 * @param boolean $reserva Indica si el teatro soporta o no reservas
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function crear_teatro($nombre, $ciudad, $zona, $direccion,
	                      $telefono, $tarifa, $reserva)
	{
		$modulo = new Cin_datos_modulos_cines;
		$modulo->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		
		$teatro = new Cin_teatros;
		$teatro->nombre = $nombre;
		$teatro->ciudad = $ciudad;
		$teatro->zona = $zona;
		$teatro->direccion = $direccion;
		$teatro->telefono = $telefono;
		$teatro->tarifa = $tarifa;
		$teatro->reserva = $reserva;
		$teatro->id_contenedor = $modulo->id_objeto;
		$res = $teatro->insert();
		
		Generador_cines::generar_teatro($res);
		Generador_cines::generar_principal();
			
		return $res;
	}  
	
    /**
      * Lista los teatros
     *
     * @return  array Lista de teatroes existentes
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function listar_teatros()
	{
		$teatro = new Cin_teatros;
		$teatro->orderBy('nombre');
		$teatro->find();
		
		$lista = new ArrayList;
		while ($teatro->fetch())
			$lista->add($teatro->toArray());
			
		return $lista->toArray();
	}  
	
    /**
      * Crea una lista de las clasificaciones
     *
	 * @param int $id_teatro Identificador del teatro a mostrar
     * @return  array Hash de los atributos del objeto teatro
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function mostrar_teatro($id_teatro)
	{
		$teatro = new Cin_teatros;
		$teatro->get($id_teatro);
			
		return $teatro->toArray();
	}  
	
		/********* GENEROS *********/
    /**
     * Eliminar una gnero
     *
	 * @param int $id_genero Identificador de la clasificacin.
	 * @return int Nmero de calificaciones eliminadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function eliminar_genero($id_genero)
	{
		$genero = new Cin_generos;
		$genero->get($id_genero);
		$res = $genero->delete();
		
		return $res;
	}
	
    /**
     * Cambiar el nombre de una gnero
     *
	 * @param int $id_clasificacion Identificador de la gnero.
	 * @param string $nombre Nombre de la nueva gnero.
	 * @return int Nmero de gneros actualizadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function modificar_genero($id_genero, $nombre)     
	{
		$genero = new Cin_generos;
		$genero->get($id_genero);
		$genero->nombre = $nombre;
		$res = $genero->update(); 
		
		return $res;
	}
	
    /**
      * Crea una nueva genero
     *
	 * @param string $nombre Nombre de la nueva clasificacion
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function crear_genero($nombre)
	{
		$genero = new Cin_generos;
		$genero->nombre = $nombre;
		$res = $genero->insert();
			
		return $res;
	}  
	
    /**
      * Crea una lista de las clasificaciones
     *
     * @return  array Lista de generoes existentes
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function mostrar_genero()
	{
		$genero = new Cin_generos;
		$genero->orderBy('nombre');
		$genero->find();
		
		$lista = new ArrayList;
		while ($genero->fetch())
			$lista->add($genero->toArray());
			
		return $lista->toArray();
	}  
	
	   /********* CALIFICACIONES *********/
    /**
     * Eliminar una calificacin
     *
	 * @param int $id_calificacion Identificador de la clasificacin.
	 * @return int Nmero de calificaciones eliminadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function eliminar_calificacion($id_calificacion)
	{
		$calificacion = new Cin_calificaciones;
		$calificacion->get($id_calificacion);
		$res = $calificacion->delete();
		
		return $res;
	}
	
    /**
     * Cambiar el nombre de una calificacin
     *
	 * @param int $id_clasificacion Identificador de la calificacin.
	 * @param string $nombre Nombre de la nueva calificacin.
	 * @return int Nmero de calificacines actualizadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function modificar_calificacion($id_calificacion, $nombre)     
	{
		$calificacion = new Cin_calificaciones;
		$calificacion->get($id_calificacion);
		$calificacion->nombre = $nombre;
		$res = $calificacion->update(); 
		
		return $res;
	}
	
    /**
      * Crea una nueva calificacion
     *
	 * @param string $nombre Nombre de la nueva clasificacion
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function crear_calificacion($nombre)
	{
		$calificacion = new Cin_calificaciones;
		$calificacion->nombre = $nombre;
		$res = $calificacion->insert();
			
		return $res;
	}  
	
    /**
      * Crea una lista de las clasificaciones
     *
     * @return  array Lista de calificaciones existentes
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function mostrar_calificacion()
	{
		$calificacion = new Cin_calificaciones;
		$calificacion->orderBy('nombre');
		$calificacion->find();
		
		$lista = new ArrayList;
		while ($calificacion->fetch())
			$lista->add($calificacion->toArray());
			
		return $lista->toArray();
	}  
	
	   	/********* CLASIFICACIONES *********/
    /**
      * Crea una lista de las clasificaciones
     *
     * @return  array Lista de clasificados existentes
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function mostrar_clasificacion()
	{
		$clasificacion = new Cin_clasificaciones;
		$clasificacion->orderBy('nombre');
		$clasificacion->find();
		
		$lista = new ArrayList;
		while ($clasificacion->fetch())
			$lista->add($clasificacion->toArray());
			
		return $lista->toArray();
	}     
	
    /**
      * Crea una nueva clasificacion
     *
	 * @param string $nombre Nombre de la nueva clasificacion
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function crear_clasificacion($nombre)
	{
		$clasificacion = new Cin_clasificaciones;
		$clasificacion->nombre = $nombre;
		
		$res = $clasificacion->insert();
			
		return $res;
	}  
	
    /**
     * Cambiar el nombre de una clasificacin
     *
	 * @param int $id_clasificacion Identificador de la clasificacin.
	 * @param string $nombre Nombre de la nueva clasificacion.
	 * @return int Nmero de clasificacione actualizadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function modificar_clasificacion($id_clasificacion, $nombre)     
	{
		$clasificacion = new Cin_clasificaciones;
		$clasificacion->get($id_clasificacion);
		$clasificacion->nombre = $nombre;
		$res = $clasificacion->update(); 
		
		return $res;
	}
	
    /**
     * Eliminar una clasificacin
     *
	 * @param int $id_clasificacion Identificador de la clasificacin.
	 * @return int Nmero de clasificaciones eliminadas.
	 * @author John A. Vargas
     * @access public
	 * @static
     */       
	function eliminar_clasificacion($id_clasificacion)
	{
		$clasificacion = new Cin_clasificaciones;
		$clasificacion->get($id_clasificacion);
		$res = $clasificacion->delete();
		
		return $res;
	}

    /**
 	 * Construye una cadena para el arbol javascript de categorias y productos
     *
     * @param   int $id_objeto Identificador de la categoria a listar
	 * @param   string $cadena cadena con las categorias y articulos a listar
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function construir_arbol($id_objeto, $cadena = '', $id_usuario) {
        $categoria = new Art_categorias_articulos;
		$categoria->get($id_objeto);
		$categoria_versiones = new  Art_categorias_articulos_versiones;
		$categoria_versiones->id_objeto = $id_objeto;
		$categoria_versiones->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		if (!$categoria_versiones->find(true))
			Fachada_Sistema::crear_version(&$categoria_versiones, $_SESSION['sis_idioma']['id_idioma']);
	
		// Verificar permiso de acceso
		$usa = Fachada_Sistema::traer_permiso($id_usuario, $id_objeto) & ALIMENTAR;
		$permiso = Fachada_Sistema::chequear_permiso($id_usuario, $id_objeto, ALIMENTAR); 
		
		$perfiles = new ArrayList();
		$perfiles->add('es_alimentador=' . Fachada_Sistema::chequear_permiso($id_usuario, $id_objeto, ALIMENTAR));
		$perfiles->add('es_editor=' . Fachada_Sistema::chequear_permiso($id_usuario, $id_objeto, EDITAR));
		$perfiles->add('es_admin=' . Fachada_Sistema::chequear_permiso($id_usuario, $id_objeto, ADMINISTRAR));
		$perfil = implode('&', $perfiles->toArray());
		$nombre_categoria = addslashes($categoria_versiones->nombre);
		
		if ($permiso || $usa) {
			$cadena .= "['<b>$nombre_categoria</b>', 'javascript:void(0)', 'contenido_mod'";
			$categoria = new Art_categorias_articulos;
			$categoria->id_contenedor = $id_objeto;
			$categoria->orderBy("id_objeto");
			$categoria->find(); 
			while($categoria->fetch()){
				$child_id = $categoria->id_objeto;
					$cadena .= ", ";
				Fachada_Cines::construir_arbol($child_id, &$cadena, $id_usuario);
			}
 		}
		
        $articulo = new Art_articulos;
		$articulo->id_contenedor = $id_objeto;
        $articulo->find();
       while($articulo->fetch()){ 
	   		// Obtener la version del articulo en el idioma de sesion
      	  	$articulo_versiones = new Art_articulos_versiones;
			$articulo_versiones->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			$articulo_versiones->id_objeto = $articulo->id_objeto;
			if (!$articulo_versiones->find(true))
				Fachada_Sistema::crear_version(&$articulo_versiones, $_SESSION['sis_idioma']['id_idioma']);
				
			// Obtener el permiso necesario para alimentar el articulo	
			$permiso_art = Fachada_Sistema::chequear_permiso($id_usuario, $articulo_versiones->id_objeto, ALIMENTAR); 
			$nombre_articulo = addslashes($articulo_versiones->nombre);
			if ($permiso_art)
	   			$cadena .= ",['$nombre_articulo', 'index.php?view=src/cines/vistas/blank.php&id_articulo={$articulo->id_objeto}', '_parent']";
        }
		if ($permiso || $usa)
	        $cadena .= "]";
        return;
    }

    /**
 	 * Recomandar en articulo para el mdulo
     *
     * @param   int $id_articulo Identificador del articulo a recomendar
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */  
	function recomendar_articulo($id_articulo)
	{
		$modulo = new Cin_datos_modulos_cines;
		$modulo->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		$modulo->id_articulo = $id_articulo;
		$res = $modulo->update();
		
		Generador_cines::generar_principal();
		
		return $res;
	}

    /**
 	 * Asignar encuesta a pelicula
     *
     * @param   int $id_pelicula Identificador de la pelicula
	 * @param   int $id_encuesta Identificador de la encuesta
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */ 
	 function asignar_encuesta($id_pelicula, $id_encuesta)
	 {
	 	$pelicula = new Cin_peliculas;
		$pelicula->get($id_pelicula);
		$pelicula->id_encuesta = $id_encuesta;
		$pelicula->update();
	 }
}
?>