<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */

/*
 * Es la accion que hace la busuqeda de usuarios en el sistema
 *
 * @package  Contactos
 * @version  1
 * @author   Junior Tello <rtello@telesat.com.co>
 * @since    PHP 4.1.2
 */
class cnt_crear_formulario_contactosAction extends Action
{
	/**
	 * Ejecuta la accion
	 *
	 * @access	public
	 * @param	ActionMapping	$actionMapping
	 * @param	ActionForm		$actionForm
	 * @return	ActionForward
	 */
	function perform($actionMapping, $actionForm) {
	
		$_SESSION['cnt_mensaje'] = null;
		$id_formulario = Fachada_Contactos::crear_formulario_contactos($actionForm->get('nombre'),$actionForm->get('email'),
							$actionForm->get('id_cuestionario'));
		Fachada_Contactos::cargar_limites( ); // recargamos los limites porque el num_forms cambia
		
		if ($id_formulario) {
			$_SESSION['cnt_mensaje'] .= "\\nEl formulario ha sido creado";
			$actionForward = $actionMapping->get('exito');
			$path  = $actionForward->getPath();
			$path .= '&id_formulario='.$id_formulario;
			$actionForward->setPath($path);
			return $actionForward;
		}
		
		$_SESSION['cnt_mensaje'] .= "\\nNO se pudo crear el formulario";
		$actionForward = $actionMapping->get('fracaso');
		return $actionForward;
	}
}
?>