<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */

/*
 * Es la accion que hace la busuqeda de usuarios en el sistema
 *
 * @package  Contactos
 * @version  1
 * @author   Junior Tello <rtello@telesat.com.co>
 * @since    PHP 4.1.2
 */
class cnt_eliminar_categorias_contactoAction extends Action
{
	/**
	 * Ejecuta la accion
	 *
	 * @access	public
	 * @param	ActionMapping	$actionMapping
	 * @param	ActionForm		$actionForm
	 * @return	ActionForward
	 */
	function perform($actionMapping, $actionForm) {
		$_SESSION['cnt_mensaje'] = "";
		// Vemos si se puede eliminar los contactos del arreglo de id_contactos recibido
		if (Fachada_Contactos::eliminar_categorias_contacto( $actionForm->get('eliminar'),$actionForm->get('id_contacto') ))
			$_SESSION['cnt_mensaje'] .= "\\nLas categorias seleccionadas del contacto han sido borradas";
		else
			$_SESSION['cnt_mensaje'] .= "\\nError: Las categorias del contacto NO pudieron ser borradas";
		
		// cargamos las categorias de contactos en general y las del contacto en cuestion
		$_SESSION['cnt_categorias_contacto'] = Fachada_Contactos::cargar_categorias_contacto($actionForm->get('id_contacto'));
		$_SESSION['cnt_lista_categorias'] = Fachada_Contactos::cargar_categorias_contactos( );
		
		$actionForward = $actionMapping->get('exito');
		$path  = $actionForward->getPath();
		$path .= '&id_contacto='.$actionForm->get('id_contacto');
		$actionForward->setPath($path);
		return $actionForward;
	}
}
?>