<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */
 /**
 * Generador de los formularios de contactos
 *
 * @package Contactos
 * @version 1.1
 * @author Junior Tello <rtello@telesat.com.co> 
 * @since   PHP 4.1.2
 */
 class Generar_contactos {
	/*
	 * Se encarga de genrar los formularios de contactos
	 * 
	 * @param  int  $id_formulario identificador del formulario en la base de datos
	 *
	 * @return void no devuelve nada.
	 */
	function generar_contactos($id_formulario = 0) {
		
		/**** Generar todo el mdulo cuestionarios *****/
		if (!$id_formulario) {
			$modulo = new cnt_datos_modulos_contactos;
			$modulo->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
				
			// Generacin de categorias.
			$formularios = new cnt_formularios;
			$formularios->id_contenedor = $modulo->id_objeto;
			$formularios->find();
			while ($formularios->fetch())
				Generar_contactos::generar_contactos($formularios->id_objeto);
				
			return true;
		}
		/******************/
		
		// vemos que el id_formulario no sea vaco
		if ($id_formulario == "")
			return false;
		$path_idioma = "html/" . $_SESSION['sitio']['url']."/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$idioma = new Sis_idiomas;
		$idioma->get($_SESSION['sis_idioma']['id_idioma']);
		$id_sitio = $_SESSION['sitio']['id_objeto'];
		
		// Buscamos el id_pagina para nombrar el archivo de contactenos
		$formulario = new Cnt_formularios;
		$formulario->get($id_formulario);
		$archivo = "pagina_" . $formulario->id_objeto . ".php";
		$archivo_formulario = $path_idioma . "/" . $archivo;
		$contenido = '';
		// Cargamos arreglo $campos con los nombres de los campos del formulario
		$campos[] = "nombres";$campos[] = "apellido1";$campos[] = "apellido2";
		$campos[] = "tipo_id";$campos[] = "id";$campos[] = "email";
		$campos[] = "sexo";$campos[] = "empresa";$campos[] = "cargo";
		$campos[] = "tel_1";$campos[] = "tel_2";$campos[] = "celular";
		$campos[] = "fax";$campos[] = "dir_1";$campos[] = "dir_2";
		$campos[] = "cod_postal";$campos[] = "id_pais";$campos[] = "region";
		$campos[] = "ciudad";$campos[] = "observaciones";
		$campos_obj = $campos;
		// Cargamos arreglo $campos_obj con los nombres de los campos de la tabla cnt_contactos_externos
		$campos_obj[3] = "tipo_identificacion";$campos_obj[4] = "identificacion";$campos_obj[9] = "telefono1";
		$campos_obj[10] = "telefono2";$campos_obj[13] = "direccion1";$campos_obj[14] = "direccion2";
		$campos_obj[15] = "codigo_postal";//$campos_obj[19] = null;
		// Cargamos arreglo $campos con los nombres de los campos del formulario
		$campos_name[] = "NOMBRES";$campos_name[] = "PRIMER_APELLIDO";$campos_name[] = "SEGUNDO_APELLIDO";
		$campos_name[] = "TIPO_DE_IDENTIFICACION";$campos_name[] = "IDENTIFICACION";$campos_name[] = "EMAIL";
		$campos_name[] = "SEXO";$campos_name[] = "EMPRESA";$campos_name[] = "CARGO";
		$campos_name[] = "TELEFONO1";$campos_name[] = "TELEFONO2";$campos_name[] = "CELULAR";
		$campos_name[] = "FAX";$campos_name[] = "DIRECCION1";$campos_name[] = "DIRECCION2";
		$campos_name[] = "CODIGO_POSTAL";$campos_name[] = "PAIS";$campos_name[] = "REGION";
		$campos_name[] = "CIUDAD";$campos_name[] = "OBSERVACIONES"; // Observaciones lo metemos aunque no est en la base de datos.
		
		// Cargamos la tabla cnt_comportamiento_campos para saber que campos se muestra y los obligatorios.
		$comp_campos = new Cnt_comportamiento_campos;
		$comp_campos->get($formulario->id_objeto);//print_r($comp_campos);exit();
		// Buscamos el encabezado del formulario que es el campo text_pre de cnt_formularios_versiones
		$formulario_v = new Cnt_formularios_versiones;
		$formulario_v->id_objeto = $formulario->id_objeto;
		$formulario_v->id_idioma = $idioma->id_idioma;
		if(!$formulario_v->find(true))  // Con esto ya tenemos $formulario_v->text_pre
			Fachada_Sistema::crear_version(&$formulario_v, $idioma->id_idioma);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////// Aqui se agregan las funciones y el archivo template del formulario /////////////////////////////////////
		require_once "src/contactos/vistas/tpl_contactos.php"; /////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		// Formamos el encabezado del formulario.
		Fachada_Contactos::cargar__paises__tipo_id( $idioma->id_idioma ); //echo "296 ";print_r($this->cnt_paises);exit();
		$contenido .= addslashes(get_campo("head0","","",$idioma->enctype,'',$formulario->id_cuestionario));
		// Ingresamos el titulo o nombre del formulario de contactos
		$contenido .= addslashes($formulario_v->nombre);
		$contenido .= addslashes(get_campo("head1","","",$idioma->enctype,'',$formulario->id_cuestionario));
		// Ingresamos el texto que va antes del formulario
		$contenido .= $formulario_v->text_pre;
		
		if ($formulario->id_cuestionario == "") {
			$contenido .= addslashes(get_campo("head2","","",$idioma->enctype,'',''));
		} else {
			$contenido .= addslashes(get_campo("head2_cue","","",$idioma->enctype,'',$formulario->id_cuestionario));
		}
		$contenido_campos = ""; $contenido_campos_obligatorios = "";
		
		// Se genera el contenido chequeando cada campo y formando una cadena con cdigo PHP y HTML.
		// cargamos el orden en que van los campos
		$orden_campos = new Cnt_orden_campos;
		$orden_campos->get($id_formulario);
		$orden_campos->id_formulario = "";
		$oc = $orden_campos->toArray(); // creamos el arreglo $oc con el orden de los campos
		unset($oc['id_formulario']); // hacemos esto para que el id_formulario no entre en el orden de campos
		
		//for ($i=0; $i < sizeof($campos); $i++) {
		for ($i=1; $i < sizeof($campos)+1; $i++) {
			foreach ($oc as $key => $ac) {
				if ($i == $ac) {
					// Si el campo no es obligatorio M=Mostrar, O=Obligatorio, E=Esconder
					if ($comp_campos->$key == 'M' || ($comp_campos->$key != 'O' && $comp_campos->$key != 'E')) {
						$contenido_campos .= addslashes(get_campo($key,$_SESSION['cnt_paises'],$_SESSION['cnt_tipo_id'],$idioma->enctype,'',''));
					} else if ($comp_campos->$key == 'O') { // el campo es obligatorio
						$contenido_campos .= addslashes(get_campo($key,$_SESSION['cnt_paises'],$_SESSION['cnt_tipo_id'],$idioma->enctype,'O',''));
						$contenido_campos_obligatorios .= build_form($key);
					}
//echo "comp: i:$i ac:$ac ...";echo $key;echo " _ ";echo $comp_campos->$key;echo "<br>\n";
					break;
				}
			}
		}//exit;
		// escribimos los campos obligatorios del formulario
		$contenido .= $contenido_campos_obligatorios;
		if ($formulario->id_cuestionario == "") {
			$contenido .= addslashes(get_campo("head3","","",$idioma->enctype,'',''));
		} else {
			$contenido .= addslashes(get_campo("head3_cue","","",$idioma->enctype,'',$formulario->id_cuestionario));
		}
		
		$contenido .= $idioma->enctype . "/" . $archivo . '">';
		$contenido .= $contenido_campos;
		// aqui ingresamos el id_formulario como el campo id_cuestionario
		$contenido .= addslashes(get_campo("id_formulario","","",$idioma->enctype,'',$formulario->id_objeto));
		$contenido .= addslashes(get_campo("foot1","","",$idioma->enctype,'',$formulario_v->nombre));
		// Ingresamos el texto que va despus del formulario
		$contenido .= $formulario_v->text_post;
		$contenido .= addslashes(get_campo("foot2","","",$idioma->enctype,'',''));
		
		// Se escribe la cabecera del portal
		$data = explode("/",$path_idioma);
		array_shift($data);
		array_shift($data);
		$vistas = implode("/",$data); 
		
		$contenido = str_replace("imagenes_cont", "imagenes_cont", $contenido);
		$contenido = str_replace("documentos/", "imagenes_cont/", $contenido);
		
		File::writeLine($archivo_formulario, stripslashes($contenido), FILE_MODE_WRITE);
		File::close ($archivo_formulario, FILE_MODE_WRITE);
		
		return true;
	}
}
?>