<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.3.3                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |		  John Vargas <jhonvargas@telesat.com.co>                     |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
// $Id: fachada_contactos.php,v 1.9 2004/06/28 23:27:41 rtello Exp $
//
// Clase Fachada que maneja el paquete contactos
//

// Clases necesarias
// MODELO
require_once PATH_CONTACTOS . 'modelo/Cnt_categorias_contactos.php';
require_once PATH_CONTACTOS . 'modelo/Cnt_contactos_externos.php';
require_once PATH_CONTACTOS . 'modelo/Cnt_datos_modulos_contactos.php';
require_once PATH_CONTACTOS . 'modelo/Cnt_formularios.php';
require_once PATH_CONTACTOS . 'modelo/Cnt_formularios_versiones.php';
require_once PATH_CONTACTOS . 'modelo/Cnt_comportamiento_campos.php';
require_once PATH_CONTACTOS . 'modelo/Cnt_orden_campos.php';
require_once PATH_CONTACTOS . 'modelo/Cnt_contactos_x_categorias.php';
// CONTROLADOR
// Mapping 
include(PATH_CONTACTOS . 'controlador/mappings.php');
// Genenerador
include(PATH_CONTACTOS . 'modelo/Generar_contactos.php');
// clases necesarias
include(PATH_CONTACTOS . 'controlador/forms/cnt_adicionar_contactoForm.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_limitesAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_adicionar_categoriaAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_modificar_categoriaAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_eliminar_categoriaAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_crear_contactoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_categorias_contactosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_crear_contactoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_crear_formulario_contactosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_adicionar_contactoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_buscar_contactosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_mostrar_buscar_contactosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_crear_excelAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_modificar_contactenosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_modificar_contactenosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_modificar_contactoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_modificar_contactoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_eliminar_contactosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_formularios_contactosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_eliminar_formulariosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_cuestionarios_contactosAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_subir_campoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_bajar_campoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_categorias_contactoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_adicionar_categoria_contactoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_eliminar_categorias_contactoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_cargar_mail_masivoAction.php');
include(PATH_CONTACTOS . 'controlador/actions/cnt_enviar_mail_masivoAction.php');
/**
 * Esta clase tiene los mtodos para la creacin, interaccin y administracin de los contactos 
 * y formularios de contactos del sitio.
 *
 * @package  Contactos
 * @version  1
 * @author   Junior Tello <rtello@telesat.com.co>
 * @since    PHP 4.3.3
 */

class Fachada_Contactos {
	
	/*
	 * Ingresa en la sesion los limites del modulo
	 *
	 * @return bool true.
	 */
	function cargar_limites( ) {
		$dm_contactos = new Cnt_datos_modulos_contactos;
		if (!$dm_contactos->get('id_contenedor',$_SESSION['sitio']['id_objeto'])) {
			$_SESSION['cnt_mensaje'] .= "Error: NO se encontr el dato mdulo del sitio";
			return false; 
		}
		$_SESSION['limites']['cnt_num_forms'] = $dm_contactos->num_forms;
		$_SESSION['limites']['cnt_acceso_BD'] = $dm_contactos->acceso_bd;
		// calculamos el numero de formularios de contactos del usuario
		$formularios = new Cnt_formularios;
		$formularios->id_contenedor = $dm_contactos->id_objeto;
		$_SESSION['limites']['cnt_num_forms_site'] = $formularios->find(); // almacenamos el numero de formularios
//echo $_SESSION['limites']['cnt_num_forms'] . $_SESSION['limites']['cnt_acceso_BD'] .
//$_SESSION['limites']['cnt_num_forms_site'];exit;
		return true;
	}
	
	/*
	 * Administracin.
	 * Crea la fila que identifica a los contactos del sitio en la tabla
	 * datos modulos contactos
	 *
	 * @param string  $nombre           nombre del formulario
	 * @param int     $id_cuestionario  identificador del cuestionario en la base de datos
	 *
	 * @return bool true si crea el formulario, false en caso contrario.
	 */
	function crear_formulario_contactos($nombre,$email,$id_cuestionario) {
		// NO se ha logueado en el sitio
		if ( !isset($_SESSION['sitio']['id_objeto']) || $_SESSION['sitio']['id_objeto'] == "" ) {
			return false;
		}
		// NO tiene email
		if ( $nombre == "" || $email == "" ) {
			$_SESSION['cnt_mensaje'] = "Error: Debe escribir un email y nombre para el formulario";
			return false;
		}
		// Chequeamos que no se pase del limite de formularios
		Fachada_Contactos::cargar_limites();
		if ($_SESSION['limites']['cnt_num_forms_site'] >= $_SESSION['limites']['cnt_num_forms']) {
			$_SESSION['cnt_mensaje'] = "NO puede crear el formulario porque se ha pasado del nmero lmite de formularios que puede crear";
			return false;
		}
		// Cuando se crea el sitio se llena la fila de la tabla cnt_datos_modulos_contactos con el id_objeto del sitio
		// por lo tanto, buscamos el id_objeto en Cnt_datos_modulos_contactos que tenga de id_contenedor el id_objeto del sitio
		$dm_contactos = new Cnt_datos_modulos_contactos;
		if (!$dm_contactos->get('id_contenedor',$_SESSION['sitio']['id_objeto'])) {
			$_SESSION['cnt_mensaje'] .= "Error: NO se encontr el dato mdulo del sitio";
			return false; 
		}
		// creamos la fila en la tabla cnt_formularios
		$formulario = new Cnt_formularios;
		$formulario->id_contenedor = $dm_contactos->id_objeto;
		$formulario->id_modulo = $dm_contactos->id_objeto;
		$formulario->email = $email;
		// ingresamos el id_cuestionario en el formulario si el usuario ha escogido uno
		if ($id_cuestionario != "")
			$formulario->id_cuestionario = $id_cuestionario;
		$id1 = $formulario->insert();
		// creamos la fila en la tabla cnt_formularios_versiones
		$formulario_v = new Cnt_formularios_versiones;
		$formulario_v->id_objeto = $formulario->id_objeto;
		$formulario_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$formulario_v->nombre = $nombre;  // el nombre del formulario
		$id2 = $formulario_v->insert();
		// creamos la fila en la tabla cnt_comportamiento_campos
		$comp_campos = new Cnt_comportamiento_campos;
		$comp_campos->id_formulario = $formulario->id_objeto;
		$id3 = $comp_campos->insert();
		// seteamos el orden de los campos del formulario
		$ord_campos = new Cnt_orden_campos;
		$ord_campos->id_formulario = $formulario->id_objeto;
		$id4 = $ord_campos->insert();
//echo "asdf: $id";print_r($_SESSION['sitio']);print_r($dm_contactos);
		Generar_contactos::generar_contactos($formulario->id_objeto);
		
		if ($id1 > 0 && $id2 > 0 && $id3 > 0 && $id4 > 0) return $formulario->id_objeto;
		
		return false;
	}
	
	/*
	 * Carga el listado de formularios de contctos
	 *
	 * @return array si se carga el formulario.
	 */
	function cargar_formularios_contactos() {
		// Buscamos el id_objeto de datos modulos contactos
		$dm_contactos = new Cnt_datos_modulos_contactos;
		$dm_contactos->get('id_contenedor',$_SESSION['sitio']['id_objeto']);
		
		// creacion de versiones
		$formulario = new Cnt_formularios;
		$formulario->id_contenedor = $dm_contactos->id_objeto;
		$formulario->find();
		while ($formulario->fetch()) { // print_r($formulario);exit();
			$formulario_v = new Cnt_formularios_versiones;
			$formulario_v->id_objeto = $formulario->id_objeto;
			$formulario_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			if (!$formulario_v->find(true))
				Fachada_Sistema::crear_version(&$formulario_v, $_SESSION['sis_idioma']['id_idioma']);
		}
	
		// Buscamos los formularios del sitio en la tabla de formularios
		$formulario = new Cnt_formularios;
		$formulario_v = new Cnt_formularios_versiones;
		$formulario->id_contenedor = $dm_contactos->id_objeto;
		$formulario_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$formulario->joinAdd($formulario_v);
		$formulario->orderBy('formulario_v_nombre');
		$formulario->selectAs();
		$formulario->selectAs($formulario_v, 'formulario_v_%s');
		$formulario->find();
		while ($formulario->fetch()) // print_r($formulario);exit();
			$formularios_contactos[] = $formulario;		
		
		// Falta generar el formulario
		return $formularios_contactos;
	}
	
	/*
	 * Adiciona una nueva categoria de contactos
	 *
	 * @return bool true si la crea y false en caso contrario.
	 */
	function adicionar_categoria($nombre) {
		// Si el $nombre es vacio devuelve falso
		if ($nombre == "") return false;
		
		$categorias = new Cnt_categorias_contactos;
		$categorias->nombre = $nombre;
		$id = $categorias->insert();
		
		
		if ($id1 > 0) Util::log('Contactos', 'Adicionar Categoria', 'Se adiciono la categoria');
		else Util::log('Contactos', 'Adicionar Categoria', 'No se adiciono la categoria');
		// Devuelve true o false segun si se cre o no la categoria
		return ($id > 0);
	}
	
	/*
	 * Adiciona una nueva categoria de contactos
	 *
	 * @return bool true si la crea y false en caso contrario.
	 */
	function modificar_categoria($id_categoria, $nombre) {
		// Si el $nombre es vacio devuelve falso
		if ($nombre == "") return false;
		
		$categorias = new Cnt_categorias_contactos;
		$categorias->get($id_categoria);
		$categorias->nombre = $nombre;
		$id = $categorias->update();
		
		if ($id > 0) Util::log('Contactos', 'Modificar Categoria', 'Se modifico la categoria');
		else Util::log('Contactos', 'Modificar Categoria', 'No se modifico la categoria');
		// Devuelve true o false segun si se cre o no la categoria
		return ($id > 0);
	}
	
	/*
	 * Adiciona una nueva categoria de contactos
	 *
	 * @return bool true si la crea y false en caso contrario.
	 */
	function eliminar_categoria($id_categoria) {
		
		$categorias = new Cnt_categorias_contactos;
		$categorias->get($id_categoria);
		$id = $categorias->delete();
		
		if ($id > 0) Util::log('Contactos', 'Eliminar Categoria', 'Se elimino la categoria');
		else Util::log('Contactos', 'Eliminar Categoria', 'No se elimino la categoria');
		// Devuelve true o false segun si se cre o no la categoria
		return ($id > 0);
	}
	
	/*
	 * Carga el listado de categorias de contactos
	 *
	 * @return array si se carga el formulario.
	 */
	function cargar_categorias_contactos() {
		// Buscamos el contenido de la tabla cnt_categorias_contactos
		$categorias = new Cnt_categorias_contactos;
		$categorias->find();
		
		while ($categorias->fetch()) // print_r($formulario);exit();
			$cat_contactos[] = $categorias;
		
		// Devolvemos el contenido de la tabla cnt_categorias_contactos
		return $cat_contactos;
	}
	
	/*
	 * Elimina un conjunto de formularios
	 *
	 * @param array   $arr_id_formularios  arreglo de identificadores de formularios
	 *
	 * @return bool true si se elimina el formulario, false en caso contrario.
	 */
	function eliminar_formularios($arr_id_formularios) { 
		// Borramos cada uno de los id_formularios que vienen en el arreglo recibido
		$formulario = new Cnt_formularios;
		$tam_arra = sizeof($arr_id_formularios);
		$path = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'] . "/";
		$arr_id_cuestionarios = array();
//echo $path."pagina_".$arr_id_formularios[0].".php";exit;
		if (!$tam_arra) {
			$_SESSION['cnt_mensaje'] = "\\nDebe seleccionar al menos un formulario para eliminar";
			return false;
		} elseif ($tam_arra == 1) {
			$formulario->whereAdd('id_objeto ='.$arr_id_formularios[0]);
			// Poner el id_formulario de contactos externos en NULL
			$formulario2 = new Cnt_contactos_externos;
			$formulario2->id_formulario = 'NULL';
			$formulario2->whereAdd('id_formulario ='.$arr_id_formularios[0]);
			$formulario2->update();//print_r($formulario2);exit();
			// Eliminamos la pgina
			unlink($path."pagina_".$arr_id_formularios[0].".php");
			// lo borramos del men (conexion entre id_objeto de menu y el id_pagina del formulario)
			$men_ei = new Men_enlaces_internos;
			$men_ei->id_pagina = $arr_id_formularios[0];
			if ($men_ei->find(true)) // si est en el men
				Fachada_Menus::eliminar_item($men_ei->id_objeto); // se borra del men
			// Ahora eliminamos el cuestionario anexo si tiene cuestionario anexo
			if (in_array("Cuestionarios", $_SESSION['modulos'])) { // Si est instalado el mdulo de Cuestionarios
				$formulario3 = new Cnt_formularios;
				$formulario3->get($arr_id_formularios[0]);
				if ($formulario3->id_cuestionario != "") { // si tiene cuestionario anexo lo eliminamos
					$arr_id_cuestionarios[] = $formulario3->id_cuestionario;
				}
			}
		} else // es ms de un formulario de contactos
			for ($i=0; $i < $tam_arra; $i++) {
				$formulario->whereAdd('id_objeto ='.$arr_id_formularios[$i], 'OR');
				// Poner el id_formulario de contactos externos en NULL
				$formulario2 = new Cnt_contactos_externos;
				$formulario2->id_formulario = 'NULL';
				$formulario2->whereAdd('id_formulario ='.$arr_id_formularios[$i]);
				$formulario2->update();
				// Eliminamos la pgina
				unlink($path."pagina_".$arr_id_formularios[$i].".php");
				// lo borramos del men (conexion entre id_objeto de menu y el id_pagina del formulario)
				$men_ei = new Men_enlaces_internos;
				$men_ei->id_pagina = $arr_id_formularios[$i];
				if ($men_ei->find(true)) // si est en el men
					Fachada_Menus::eliminar_item($men_ei->id_objeto); // se borra del men
				// Ahora ingresamos el id_cuestionario al arreglo de cuestionarios
				if (in_array("Cuestionarios", $_SESSION['modulos'])) { // Si est instalado el mdulo de Cuestionarios
					$formulario3 = new Cnt_formularios;
					$formulario3->get($arr_id_formularios[$i]);
					if ($formulario3->id_cuestionario != "") { // si tiene cuestionario anexo lo eliminamos
						$arr_id_cuestionarios[] = $formulario3->id_cuestionario;
					}
				}
			}
		
		$id1 = $formulario->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		// Ahora eliminamos los cuestionarios anexos si existen
		if (in_array("Cuestionarios", $_SESSION['modulos'])) { // Si est instalado el mdulo de Cuestionarios
			if (sizeof($arr_id_cuestionarios)) { // si el existe al menos un cuestionario anexo lo eliminamos
				Fachada_Cuestionarios::eliminar_cuestionarios($arr_id_cuestionarios);
			}
		}
		
		if ($id1 > 0) Util::log('Contactos', 'Eliminar Formularios', 'Se elimino los formularios');
		else Util::log('Contactos', 'Eliminar Formularios', 'No se elimino los formularios');

		return ($id1 > 0);
	}
	
	/*
	 * Administracin.
	 * Carga los campos paises y tipo_id del formulario de contactos en el momento de generar el sitio.
	 *
	 * @param int  $old_id_idioma  identificador del idioma
	 *
	 * @return array arreglo con los datos de los paises.
	 */
	function cargar__paises__tipo_id( $old_id_idioma ) {
		// vaciamos los arreglos
		$_SESSION['cnt_paises'] = null;
		$_SESSION['cnt_tipo_id'] = null;
		// Cargar la lista de paises
		$paises = new Sis_paises;
		// El idioma #1 queda como idioma por default (Espaol).
		($old_id_idioma == "")? $id_idioma = 1 : $id_idioma = $old_id_idioma;
		$paises->id_idioma = $id_idioma;
		$paises->orderBy('nombre');
		$paises->find();
		while($paises->fetch()) {
			$_SESSION['cnt_paises']['id_paises'][] = $paises->id_paises;
			$_SESSION['cnt_paises']['nombre'][] = $paises->nombre;
		}
		
		// Cargar la lista de tipos de identificacin
		$tipo_identificacion = new Sis_tipo_identificacion;
		$tipo_identificacion->find();
		while($tipo_identificacion->fetch()) {
			$_SESSION['cnt_tipo_id']['nombre'][] = $tipo_identificacion->nombre;
		}
//echo "tipo_id:\n<br>";print_r($_SESSION['cnt_tipo_id']);echo "cnt_paises:\n<br>";print_r($_SESSION['cnt_paises']);exit();
		return $_SESSION['cnt_paises'];
	}
	
	
    /**
     * Generado.
	 * Crea un contacto externo, aqui no va el campo observaciones.
     *
     * @param string $nombres       nombres del contacto
     * @param string $apellido1     primer apellido
     * @param string $apellido2     segundo apellido
     * @param string $tipo_id       tipo de identificacin
     * @param int    $id            nmero de identificacin
     * @param string $email         email
     * @param string $sexo          sexo
     * @param string $empresa       empresa
     * @param string $cargo         cargo del contacto
     * @param int    $telefono1     telefono #1
     * @param int    $telefono2     telefono #2
     * @param int    $celular       celular
     * @param int    $fax           fax
     * @param string $direccion1    direccin #1
     * @param string $direccion2    direccin #2
     * @param int    $codigo_postal cdigo postal
     * @param string $id_pais       identificador del pais
     * @param string $region        region
     * @param string $id_ciudad     identificador de la ciudad
     * @param string $id_formulario identificador del formulario
	 *
	 * @return object el objeto contacto con los datos del mismo.
     */
    function adicionar_contacto ($nombres, $apellido1, $apellido2, $tipo_id, $id,
								$email, $sexo, $empresa, $cargo, $tel_1, $tel_2,
								$celular, $fax, $dir_1, $dir_2, $cod_postal, $id_pais,
								$region, $ciudad, $id_formulario, $ip, $id_categoria) {
		
        $datos_modulo = new Cnt_datos_modulos_contactos; 
		$id_sitio = constant("ID_SITIO");
		if (!$id_sitio || $id_sitio == "")
			$id_sitio = $_SESSION['sitio']['id_objeto']; // si esta desde la administracin
//echo "id_sitio: ".$id_sitio;exit();
        if (!$id_sitio) { 
            $_SESSION['cnt_mensaje'] .= "\\nError: este sitio no existe en la base de datos"; 
            return false; // NO hay datos del sitio en la sesion. 
        } else { 
            $datos_modulo->id_contenedor = $id_sitio; 
            $datos_modulo->find(true); 
        }
        $contacto = new Cnt_contactos_externos;
        
        $contacto->nombres = $nombres;
        $contacto->apellido1 = $apellido1;
        $contacto->apellido2 = $apellido2;
		$contacto->tipo_identificacion = $tipo_id;
		$contacto->identificacion = $id;
        $contacto->email = $email;
        $contacto->sexo = $sexo;
        $contacto->empresa = $empresa;
        $contacto->cargo = $cargo;
        $contacto->telefono1 = $tel_1;
        $contacto->telefono2 = $tel_2;
        $contacto->celular = $celular;
        $contacto->fax = $fax;
        $contacto->direccion1 = $dir_1;
        $contacto->direccion2 = $dir_2;
        $contacto->codigo_postal = $cod_postal;
        $contacto->id_pais = $id_pais;
        $contacto->region = $region;
        $contacto->ciudad = $ciudad;
		$contacto->ip = $ip;
		$contacto->nombre_formulario = "Administracion";
		
		if ($id_formulario != "") {
			$contacto->id_formulario = $id_formulario;
			$formulario_v = new Cnt_formularios_versiones; 
			$formulario_v->id_objeto = $datos_modulo->id_objeto;
			$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			if (!$id_idioma) $id_idioma = 1;
			$formulario_v->id_idioma = $id_idioma;
			$formulario_v->id_objeto = $id_formulario;
			if ($formulario_v->find(true))
				$contacto->nombre_formulario = $formulario_v->nombre;
		}
		
		$contacto->id_contenedor = $datos_modulo->id_objeto;
//echo "ASDFASDFASDF".constant("ID_SITIO");print_r($datos_modulo);print_r($contacto);exit;
        $id = $contacto->insert();//print_r();exit;
		// Si inserto el contacto correctamente
		if ($id > 0) { 
			Util::log('Contactos', 'Adicionar Contactos', 'Se adiciono el contacto');
			// si el id_categoria no es null entonces lo ingresamos en la base de datos
			if (isset($id_categoria) && $id_categoria != "") { //echo "si entro";exit;
				$cnt_cat = new Cnt_contactos_x_categorias;
				$cnt_cat->id_categoria = $id_categoria;
				$cnt_cat->id_contacto = $contacto->id_contacto;
				$cnt_cat->insert();
//echo "id: ".$id;print_r($contacto);print_r($cnt_cat);exit;
			}
		}
		else {Util::log('Contactos', 'Adicionar Contactos', 'No se adiciono el contacto');}
		if (!($id > 0)) {return false;}
//echo "asdf: ".$id_formulario;print_r($contacto);exit();
		return ($contacto->id_contacto);
	}
	
    /**
     * Generado.
	 * Construye el contenido el email que se le envia al administrador del sistema cuando se
	 * adiciona un nuevo contacto
     *
     * @param string $nombres       nombres del contacto
     * @param string $apellido1     primer apellido
     * @param string $apellido2     segundo apellido
     * @param string $tipo_id       tipo de identificacin
     * @param int    $id            nmero de identificacin
     * @param string $email         email
     * @param string $sexo          sexo
     * @param string $empresa       empresa
     * @param string $cargo         cargo del contacto
     * @param int    $telefono1     telefono #1
     * @param int    $telefono2     telefono #2
     * @param int    $celular       celular
     * @param int    $fax           fax
     * @param string $direccion1    direccin #1
     * @param string $direccion2    direccin #2
     * @param int    $codigo_postal cdigo postal
     * @param string $id_pais       identificador del pais
     * @param string $region        region
     * @param string $id_ciudad     identificador de la ciudad
     * @param string $id_formulario identificador del formulario
	 *
	 * @return string la cadena con el contenido del mensaje que ira en el email.
     */
    function construir_contenido_mail_creacion_contacto ($nombres, $apellido1, $apellido2, $tipo_id, $id,
								$email, $sexo, $empresa, $cargo, $tel_1, $tel_2,
								$celular, $fax, $dir_1, $dir_2, $cod_postal, $id_pais,
								$region, $ciudad, $id_formulario, $observaciones ) {
		
		if (!isset($id_formulario) || $id_formulario == "")
			return "";
		
        // capturamos el comportamiento de los campos de este formulario
		$compo = new Cnt_comportamiento_campos;
		$compo->get($id_formulario);
		if (!$compo->find(true))
			return "";
		// capturamos el idioma...
		// Si estamos en el generado no existe $_SESSION['sis_idioma']['id_idioma']
		if (!isset($_SESSION['sis_idioma']['id_idioma']) or $_SESSION['sis_idioma']['id_idioma'] == "") {
			$idioma = new Sis_idiomas;
			$idioma->get('enctype', $_SESSION['lang']);
			$_SESSION['sis_idioma'] = $idioma->toArray();
//print_r($_SESSION['sis_idioma']);exit;
		} else {
			$idioma = new Sis_idiomas;
			$idioma->get($_SESSION['sis_idioma']['id_idioma']);
		}
		// incluimos las definiciones de rotulos segn el idioma
		require_once "../../src/contactos/vistas/".$idioma->enctype.".php";
        
		$mensaje = "\n";
		if ($sexo == 'M') $sexo = MASCULINO;
		elseif ($sexo == 'F') $sexo = FEMENINO;
		// capturamos el nombre del pais
		$paises = new Sis_paises;
		$paises->id_paises = $id_pais;
		$paises->find(true);
		$pais = $paises->nombre;
		// Si el campo no est oculto entonces lo ingresamos en el contenido del email
        if ($compo->nombres != 'E')             $mensaje .= NOMBRES . ': ' . $nombres . "\n";
        if ($compo->apellido1 != 'E')           $mensaje .= PRIMER_APELLIDO . ': ' . $apellido1 . "\n";
        if ($compo->apellido2 != 'E')           $mensaje .= SEGUNDO_APELLIDO . ': ' . $apellido2 . "\n";
		if ($compo->tipo_identificacion != 'E') $mensaje .= TIPO_DE_IDENTIFICACION . ': ' . $tipo_id . "\n";
		if ($compo->identificacion != 'E')      $mensaje .= IDENTIFICACION . ': ' . $id . "\n";
        if ($compo->email != 'E')               $mensaje .= EMAIL . ': ' . $email . "\n";
        if ($compo->sexo != 'E')                $mensaje .= SEXO . ': ' . $sexo . "\n";
        if ($compo->empresa != 'E')             $mensaje .= EMPRESA . ': ' . $empresa . "\n";
        if ($compo->cargo != 'E')               $mensaje .= CARGO . ': ' . $cargo . "\n";
        if ($compo->telefono1 != 'E')           $mensaje .= TELEFONO1 . ': ' . $tel_1 . "\n";
        if ($compo->telefono2 != 'E')           $mensaje .= TELEFONO2 . ': ' . $tel_2 . "\n";
        if ($compo->celular != 'E')             $mensaje .= CELULAR . ': ' . $celular . "\n";
        if ($compo->fax != 'E')                 $mensaje .= FAX . ': ' . $fax . "\n";
        if ($compo->direccion1 != 'E')          $mensaje .= DIRECCION1 . ': ' . $dir_1 . "\n";
        if ($compo->direccion2 != 'E')          $mensaje .= DIRECCION2 . ': ' . $dir_2 . "\n";
        if ($compo->codigo_postal != 'E')       $mensaje .= CODIGO_POSTAL . ': ' . $cod_postal . "\n";
        if ($compo->id_pais != 'E')             $mensaje .= PAIS . ': ' . $pais . "\n";
        if ($compo->region != 'E')              $mensaje .= REGION . ': ' . $region . "\n";
        if ($compo->ciudad != 'E')              $mensaje .= CIUDAD . ': ' . $ciudad . "\n";
		$mensaje .= OBSERVACIONES . ': ' . $observaciones . "\n";
//echo "california: ".$mensaje;exit;
		return $mensaje;
	}
	
    /**
	 * Generado.
     * Envia un mail que informa de la creacin del contacto al email del sitio.
     *
     * @param   string $from           email del contacto
     * @param   string $asunto         asunto del mensaje a enviar
     * @param   string $mensaje        Texto del mensaje
     * @param   string $id_formulario  identificador del formulario
	 *
     * @access  public
	 * @author Junior Tello
     * @return boolean dice si el usuario a ingresar es vlido.
     */
	function enviar_mail_creacion_contacto($from, $asunto, $mensaje, $id_formulario) {
		// Buscamos el mail del formulario para ponerlo en el From
		$formularios = new Cnt_formularios;
		$formularios->get($id_formulario); // ya tenemos el email ($formularios->email)
		
		if( $formularios->email == '' ) {
			$_SESSION['cnt_mensaje'] .= "\\nError: No se encontr el email al que v este formulario";
			return false; // No se encontr el email del sitio.
		}
		
		$recipients = $formularios->email;
		$headers['From']    = $from;
		$headers['To']      = $formularios->email;
		$headers['Subject'] = $asunto;
		$body = $mensaje;
		
		// Create the mail object using the Mail::factory method
		$mail_object =& Mail::factory('mail');
		$temp = $mail_object->send($recipients, $headers, $body);
		
		return true;
	}
	
	
    /**
 	 * Busca contactos en el sistema
     *
	 * @param int    $from          el limite inicial de la bsqueda
     * @param string $nombres       nombres de los usuarios 
	 * @param string $apellidos     apellidos de los usuarios 
     * @param string $email         direccin electrnica del usuario
     * @param int    $pais          identificador del pais
     * @param string $region        region, departamento, provincia, estado
     * @param string $ciudad        ciudad
     * @param string $telefono      telefono
     * @param int    $id_sitio      identificador del sitio en la base de datos
     * @param int    $id_formulario identificador del formulario en la base de datos
     *
	 * @author  John A. Vargas
	 *          Junior Tello <rtello@telesat.com.co>
	 * @return array Arreglo asociativo con la lista de usuarios y los datos de paginacion
     * @access public
	 * @static
     */    
	 function buscar_contactos($from, $nombres, $apellidos, $email, $pais, $region, $ciudad, $id_categoria, $id_sitio, $id_formulario) {
		$contacto = new Cnt_contactos_externos;
		$dm_contactos = new Cnt_datos_modulos_contactos;
		
		// Capturamos el identificador de los contactos del sitio
		$dm_contactos->id_contenedor = $_SESSION['sitio']['id_objeto'];
		$dm_contactos->find(true); // Ya tenemos el $dm_contactos->id_objeto
		
		// Datos de contacto
		if ($id_formulario != '')
			$contacto->whereAdd("id_formulario=".$id_formulario);
		
		if ($nombres != '')
			$contacto->whereAdd("LOWER(nombres) LIKE LOWER('%$nombres%')");
		
		if ($apellidos != '') {
			$contacto->whereAdd("(LOWER(apellido1) LIKE LOWER('%$apellidos%')");
			$contacto->whereAdd("LOWER(apellido2) LIKE LOWER('%$apellidos%') )",'OR');
		}
		
		if ($email != '')
			$contacto->whereAdd("LOWER(email) LIKE LOWER('%$email%')");	
		
		if ($pais != '')
			$contacto->whereAdd("id_pais=$pais");	
		
		if ($region != '')
			$contacto->whereAdd("LOWER(region) LIKE LOWER('%$region%')");
		
		if ($ciudad != '')
			$contacto->whereAdd("LOWER(ciudad) LIKE LOWER('%$ciudad%')");
		
		if ($id_categoria != '')
			$contacto->whereAdd("id_categoria=$id_categoria");
		
		// Hacemos la bsqueda de contactos
		$contacto->whereAdd('id_contenedor = '.$dm_contactos->id_objeto);
		$contacto->find();
		
		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0; 
		$data = DB_Pager::getData($from, NUM_REGISTROS, $contacto->count(), MAXPAGES);
		
		$contacto->limit($from, NUM_REGISTROS);
		$contacto->orderBy('apellido1'); 
		$contacto->find();//echo "QUE PIERNOTAS";print_r($contacto);exit();
		
		$lista_contactos = array();
		while ($contacto->fetch()) 
			array_push($lista_contactos, get_object_vars ($contacto));
		
		return array('lista' => $lista_contactos, 'data' => $data);
	}
	
	/*
	 * Carga los datos del contacto a modificar
	 *
	 * @param int $id_contacto identificador del contacto en la base de datos
	 *
	 * @return object devuelve el objeto contacto con los datos del contacto conforme a la tabla contactos externos
	 */
	function cargar_modificar_contacto( $id_contacto ) {
		// Cargamos la informacin del contacto de la base de datos
		$contacto = new Cnt_contactos_externos;
		$contacto->get($id_contacto);
		
		// Cargamos los paises y el tipo de identificacin
		Fachada_Contactos::cargar__paises__tipo_id( $_SESSION['sis_idioma']['id_idioma'] );
//echo "tipo_id:\n<br>";print_r($_SESSION['cnt_tipo_id']);echo "cnt_paises:\n<br>";print_r($_SESSION['cnt_paises']);exit();


		return $contacto;
	}
	
	/*
	 * Carga las categorias del contacto a modificar
	 *
	 * @param int $id_contacto identificador del contacto en la base de datos
	 *
	 * @return array devuelve el arreglo arr_cnt_cat con las categorias del contacto
	 */
	function cargar_categorias_contacto($id_contacto) {
		// Cargamos la informacin del contacto de la base de datos
		$cnt_cat = new Cnt_contactos_x_categorias;
		$categorias = new Cnt_categorias_contactos;
		$cnt_cat->whereAdd('id_contacto = '.$id_contacto);
		$cnt_cat->joinAdd($categorias); // hacemos join con categorias
		$cnt_cat->selectAs(); // seleccionamos el campo nombre en categorias
		$cnt_cat->selectAs(array('nombre'), 'cat_%s','Cnt_categorias_contactos');
		$cnt_cat->find();//print_r($cnt_cat);exit;
		$i = 0;
		while($cnt_cat->fetch()) {
			$arreglini = $cnt_cat->toArray(); //print_r($arreglini);exit;
			$arr_cnt_cat[$i] = $arreglini; //print_r($arr_cnt_cat);
			$i++;
		} //exit;
		// devolvemos el arreglo con las categorias del contacto
		return $arr_cnt_cat;
	}
	
	/*
	 * Modifica el contacto
     *
     * @param int    $id_contacto         identificador del contacto
     * @param string $nombres             nombres del contacto
     * @param string $apellido1           primer apellido
     * @param string $apellido2           segundo apellido
     * @param string $tipo_identificacion tipo de identificacin
     * @param int    $identificacion      nmero de identificacin
     * @param string $email               email
     * @param string $sexo                sexo
     * @param string $empresa             empresa
     * @param string $cargo               cargo del contacto
     * @param int    $telefono1           telefono #1
     * @param int    $telefono2           telefono #2
     * @param int    $celular             celular
     * @param int    $fax                 fax
     * @param string $direccion1          direccin #1
     * @param string $direccion2          direccin #2
     * @param int    $cod_postal          cdigo postal
     * @param string $id_pais             identificador del pais
     * @param string $region              region
     * @param string $ciudad              identificador de la ciudad
	 *
	 * @return bool true si modific el contacto, false en caso contrario.
	 */
	function modificar_contacto($id_contacto, $nombres, $apellido1, $apellido2, $tipo_identificacion, $identificacion,
								$email, $sexo, $empresa, $cargo, $telefono1, $telefono2,
								$celular, $fax, $direccion1, $direccion2, $cod_postal, $id_pais,
								$region, $ciudad) {
		
        $contacto = new Cnt_contactos_externos;
		$contacto->get($id_contacto);
        
        $contacto->nombres = $nombres;
        $contacto->apellido1 = $apellido1;
        $contacto->apellido2 = $apellido2;
		$contacto->tipo_identificacion = $tipo_identificacion;
		$contacto->identificacion = $identificacion;
        $contacto->email = $email;
        $contacto->sexo = $sexo;
        $contacto->empresa = $empresa;
        $contacto->cargo = $cargo;
        $contacto->telefono1 = $telefono1;
        $contacto->telefono2 = $telefono2;
        $contacto->celular = $celular;
        $contacto->fax = $fax;
        $contacto->direccion1 = $direccion1;
        $contacto->direccion2 = $direccion2;
        $contacto->codigo_postal = $cod_postal;
        $contacto->id_pais = $id_pais;
        $contacto->region = $region;
        $contacto->ciudad = $ciudad;
//echo "ASDFASDFASDF".constant("ID_SITIO");print_r($datos_modulo);print_r($contacto);
        $id = $contacto->update();
		
		if ($id > 0) Util::log('Contactos', 'Modificar Contacto', 'Se modifico el contacto');
		else Util::log('Contactos', 'Modificar Contacto', 'No se modifico el contacto');
		return ($id > 0);
	}
	
	/*
	 * Carga los datos para modificar el formulario de contctos
	 *
     * @param int   $id_formulario identificador del formulario
	 *
	 * @return object objeto comportamiento que tiene los datos del comportamiento del formulario.
	 */
	function cargar_modificar_contactenos($id_formulario) {
		// Buscamos el formulario de contactenos del sitio en la base de datos
		$formulario = new Cnt_formularios;
		$formulario->get($id_formulario);
		$comportamiento = new Cnt_comportamiento_campos;
		$comportamiento->get($formulario->id_objeto);
		// Asignamos a $comportamiento los campos que faltan de $formulario
		$comportamiento->form_email = $formulario->email;
		$formulario_v = new Cnt_formularios_versiones;
		$formulario_v->id_objeto = $formulario->id_objeto;
		$formulario_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		if (!$formulario_v->find(true))
			Fachada_Sistema::crear_version(&$formulario_v,$_SESSION['sis_idioma']['id_idioma']);
		$comportamiento->text_pre = $formulario_v->text_pre;
		$comportamiento->text_post = $formulario_v->text_post;
		$comportamiento->id_cuestionario = $formulario->id_cuestionario;
		$comportamiento->nombre = $formulario_v->nombre;
		// Asignamos a $comportamiento el contenido de la table cnt_orden_campos
		$orden_campos = new Cnt_orden_campos;
		$orden_campos->get($formulario->id_objeto);
		$comportamiento->orden_campos = $orden_campos->toArray();
		
		// Se incluye el editor wysiwyg version 2.0
		$_SESSION['contenido_HTML'] = null;
		for($i = 0; $i < 2; $i++) {
			$contenido = ($i) ? $formulario_v->text_post : $formulario_v->text_pre;
			$contenido = str_replace('"',"'",$contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,'',$contenido);
			$contenido = stripslashes($contenido);
			$_SESSION['contenido_HTML'][$i] = $contenido;
		}
		
		return $comportamiento;
	}
	
	/*
	 * Modifica el formulario de contctos
	 *
     * @param int   $id_formulario   identificador del formulario
     * @param int   $form_email      email al que llega el texto del formulario
     * @param int   $text_pre        texto que va al inicio del formulario
     * @param int   $text_post       texto que va en la parte de abajo del formulario
     * @param int   $id_cuestionario identificador del cuestionario que est enlazado al formulario de contactos.
	 *
	 * @return bool true si se modific el formulario de contactos, false en caso contrario.
	 */
	function modificar_contactenos($formul_name,$id_formulario, $nombres, $apellido1, $apellido2, $tipo_identificacion, $identificacion,
								$email, $sexo, $empresa, $cargo, $telefono1, $telefono2, $celular, $fax, $id_pais,
								$region, $ciudad, $direccion1, $direccion2, $cod_postal, $observaciones, $form_email, $text_pre, $text_post) {
		
        $comportamiento = new Cnt_comportamiento_campos;
		$comportamiento->get($id_formulario);
//echo "id_CUE: ".$id_cuestionario;exit();//print_r($comportamiento);exit();
        $comportamiento->nombres = $nombres;
        $comportamiento->apellido1 = $apellido1;
        $comportamiento->apellido2 = $apellido2;
		$comportamiento->tipo_identificacion = $tipo_identificacion;
		$comportamiento->identificacion = $identificacion;
        $comportamiento->email = $email;
        $comportamiento->sexo = $sexo;
        $comportamiento->empresa = $empresa;
        $comportamiento->cargo = $cargo;
        $comportamiento->telefono1 = $telefono1;
        $comportamiento->telefono2 = $telefono2;
        $comportamiento->celular = $celular;
        $comportamiento->fax = $fax;
        $comportamiento->direccion1 = $direccion1;
        $comportamiento->direccion2 = $direccion2;
        $comportamiento->codigo_postal = $cod_postal;
		$comportamiento->observaciones = $observaciones;
        $comportamiento->id_pais = $id_pais;
        $comportamiento->region = $region;
        $comportamiento->ciudad = $ciudad;
        $id1 = $comportamiento->update();
		
		// Buscamos el formulario de contactenos del sitio en la base de datos
		$formulario = new Cnt_formularios;
		$formulario->get($id_formulario);
		$formulario_v = new Cnt_formularios_versiones;
		$formulario_v->id_objeto = $formulario->id_objeto;
		$formulario_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$formulario_v->find(true);
		
		// ingresamos los datos de las otras dos tablas
		$formulario->email = $form_email;
		// modificamos el cuestionario del formulario si es el id_cuestionario enviado no es vaco
		$id2 = $formulario->update();  //print_r($formulario);exit();
		$formulario_v->nombre = $formul_name;
		$formulario_v->text_pre = $text_pre;
		$formulario_v->text_post = $text_post;
		$id3 = $formulario_v->update();
		
		//Generamos los formularios de contactos
		Generar_contactos::generar_contactos($formulario->id_objeto);
		if ($id1 > 0 && $id2 > 0 && $id3 > 0) Util::log('Contactos', 'Modificar Contactenos', 'Se modifico el formulario');
		else Util::log('Contactos', 'Modificar Contactenos', 'No se modifico el formulario');
//print_r($comportamiento);print_r($formulario);print_r($formulario_v);exit();
		return ($id1 > 0 && $id2 > 0 && $id3 > 0);
	}
	
	/*
	 * Elimina contactos... si el contacto tiene respuestas en un cuestionario,
	 * esas respuestas sern eliminadas tambin.
	 *
     * @param  array $arr_id_contactos arreglo de identificadores de contactos a eliminar.
	 *
	 * @return bool  true si se elimin el contacto, false en caso contrario.
	 */
	function eliminar_contactos( $arr_id_contactos ) {
//print_r($arr_id_contactos);exit();
		// Borramos cada uno de los id_contactos que vienen en el arreglo recibido
		$contacto = new Cnt_contactos_externos;
		for ($i=0; $i < sizeof($arr_id_contactos); $i++) {
			$contacto->whereAdd('id_contacto ='.$arr_id_contactos[$i], 'OR');
		}
		$id = $contacto->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		
		if ($id > 0) Util::log('Contactos', 'Eliminar Contactos', 'Se elimino el formulario');
		else Util::log('Contactos', 'Eliminar Contactos', 'No se elimino el formulario');
		return $id;
	}
	
	/*
	 * Sube una casilla el campo especificado.
	 *
     * @param  int  $id_formulario idenficador del formulario.
     * @param  int  $nom_campo nombre del campo que se va a subir una casilla.
	 *
	 * @return bool true si se subi el campo, false en caso contrario.
	 */
	function subir_campo($id_formulario,$nom_campo) {
		// Borramos cada uno de los id_contactos que vienen en el arreglo recibido
		$orden_campos = new Cnt_orden_campos;
		$orden_campos->get($id_formulario);
		$arr_campos = $orden_campos->toArray(); //print_r($arr_campos);exit;
		$arr_campos['id_formulario'] = 0; // hacemos esto para que el id_formulario no entre en el orden de campos
//print_r($arr_campos);print_r($keys_oc);exit;
		// si es el primer campo ya no se puede subir mas
		if ($orden_campos->$nom_campo == 1) {
			$_SESSION['cnt_mensaje'] .= "\\nEl primer campo no se puede subir ms";
			return false;
		}
		$num_campo = $orden_campos->$nom_campo;//echo "num_campo: ".$num_campo;exit;
		// restamos uno al numero de orden del campo
		$orden_campos->$nom_campo = $num_campo - 1;
		// sumamos uno al campo que estaba arriba de $nom_campo
		foreach ($arr_campos as $key => $ac) { //echo "$key $ac\n";
			if ($ac == ($num_campo - 1))
				$orden_campos->$key = $ac + 1;//echo "entrini";exit;
		}
		$id = $orden_campos->update();
		
		if ($id > 0) Util::log('Contactos', 'Subir Campoo', 'Se subio el campo');
		else Util::log('Contactos', 'Subir Campoo', 'No se subio el campo');
		return ($id > 0);
	}
	
	/*
	 * Baja una casilla el campo especificado.
	 *
     * @param  int  $id_formulario idenficador del formulario.
     * @param  int  $nom_campo nombre del campo que se va a bajar una casilla.
	 *
	 * @return bool true si se baj el campo, false en caso contrario.
	 */
	function bajar_campo($id_formulario,$nom_campo) {
		// Borramos cada uno de los id_contactos que vienen en el arreglo recibido
		$orden_campos = new Cnt_orden_campos;
		$orden_campos->get($id_formulario);
		$arr_campos = $orden_campos->toArray(); //print_r($arr_campos);exit;
		$arr_campos['id_formulario'] = 0; // hacemos esto para que el id_formulario no entre en el orden de campos
		$numero_de_campos = sizeof($arr_campos) - 1;
//print_r($arr_campos);print_r($keys_oc);exit;
		// si es el ultimo campo ya no se puede bajar mas
		if ($orden_campos->$nom_campo == $numero_de_campos) {
			$_SESSION['cnt_mensaje'] .= "\\nEl ltimo campo no se puede bajar ms";
			return false;
		}
		$num_campo = $orden_campos->$nom_campo; //echo "num_campo: ".$num_campo;exit;
		// sumamos uno al nmero de orden del campo
		$orden_campos->$nom_campo = $num_campo + 1;
		// restamos uno al campo que estaba arriba de $nom_campo
		foreach ($arr_campos as $key => $ac) { //echo "$key $ac\n";
			if ($ac == ($num_campo + 1))
				$orden_campos->$key = $ac - 1;//echo "entrini";exit;
		}
		$id = $orden_campos->update();
		
		if ($id > 0) Util::log('Contactos', 'Subir Campoo', 'Se subio el campo');
		else Util::log('Contactos', 'Subir Campoo', 'No se subio el campo');
		return ($id > 0);
	}
	
	/*
	 * Adiciona una categoria al contacto especififado por $id_contacto.
	 *
     * @param  int  $id_contacto idenficador del contacto.
     * @param  int  $id_categoria identificador de la categoria que se quiere adicionar al contacto.
	 *
	 * @return bool true si se adicion la categoria, false en caso contrario.
	 */
	function adicionar_categoria_contacto($id_contacto, $id_categoria) {
		// Chequeamos que el $id_contacto e $id_categoria no sean vacio
		if ($id_contacto == "") {
			$_SESSION['cnt_mensaje'] .= "\\nNo estableci el identificador del contacto";
			return false;
		} elseif ($id_categoria == "") {
			$_SESSION['cnt_mensaje'] .= "\\nNo estableci el identificador de la categoria";
			return false;
		}
		// chequeamos que ese contacto no tenga y esa categoria
		$cnt_cat = new Cnt_contactos_x_categorias;
		$cnt_cat->whereAdd('id_contacto='.$id_contacto);
		$cnt_cat->whereAdd('id_categoria='.$id_categoria);
		if ($cnt_cat->find()) {
			$_SESSION['cnt_mensaje'] .= "\\nEste contacto y tiene esta categoria";
			return false;
		}
		// ahora si, ingresamos la categoria del contacto
		$cnt_cat = new Cnt_contactos_x_categorias;
		$cnt_cat->id_contacto = $id_contacto;
		$cnt_cat->id_categoria = $id_categoria;
		$id = $cnt_cat->insert();
		return ($id > 0);
	}
	
	/*
	 * Elimina un conjunto de categorias de un contacto determinado
	 *
	 * @param array $arr_id_categorias  arreglo de identificadores de formularios
     * @param  int  $id_contacto idenficador del contacto.
	 *
	 * @return bool true si se eliminaron las categorias del contacto, false en caso contrario.
	 */
	function eliminar_categorias_contacto($arr_id_categorias, $id_contacto) {
		// Chequeamos que el $id_contacto no sea vacio
		if ($id_contacto == "") {
			$_SESSION['cnt_mensaje'] .= "\\nNo estableci el identificador del contacto";
			return false;
		}
		// Borramos cada uno de los id_categorias que vienen en el arreglo recibido
		$cnt_cat = new Cnt_contactos_x_categorias;
		$tam_arra = sizeof($arr_id_categorias);
		if (!$tam_arra) {
			$_SESSION['cnt_mensaje'] = "\\nDebe seleccionar al menos una categoria para eliminar";
			return false;
		}
		// Agregamos el id_contacto al query de eliminacion de las mismas
		$str_query = "Delete from Cnt_contactos_x_categorias Where id_contacto=".$id_contacto." AND (";
		// Agregamos cada id_categoria al query de eliminacion de las mismas
		for ($i=0; $i < $tam_arra; $i++) {
			if ($i) $str_query .= " OR ";
			$str_query .= "id_categoria = ".$arr_id_categorias[$i];
		}
		$str_query .= ")";
		// Ejecutamos la eliminacin
		$cnt_cat->query($str_query);
		
		Util::log('Contactos', 'Eliminar Categorias Contacto', 'Se eliminaron las categorias del contacto');
		return true;
	}
	
    /**
	 * Generado.
     * Envia un mail masivo a los integrantes de una categoria.
     *
     * @param   string $from           email del contacto
     * @param   string $asunto         asunto del mensaje a enviar
     * @param   string $mensaje        Texto del mensaje
     * @param   string $id_categoria   identificador de la categoria
	 *
     * @access  public
	 * @author  Junior Tello
     * @return  boolean dice si el usuario a ingresar es vlido.
     */
	function enviar_mail_masivo($from, $asunto, $mensaje, $id_categoria) {
		// Chequeamos que el id_categoria exista
		$categorias = new Cnt_categorias_contactos;
		if ($id_categoria == "" or !$categorias->get($id_categoria)) {
			$_SESSION['cnt_mensaje'] .= "\\nError: No se encontr la categoria";
			return false;
		}
		// Ahora capturamos los emails de los integrantes de la categoria
		$contxcat = new Cnt_contactos_x_categorias;
		$contactos = new Sis_contactos;
		$contxcat->whereAdd('id_categoria='.$id_categoria);
		$contxcat->joinAdd($contactos);
		$contxcat->selectAs();
		$contxcat->selectAs(array('email'), 'con_%s','Sis_contactos');
		$contxcat->find();
		$i = 0;
		while($contxcat->fetch()) {
			$arr_mails[$i] = $contxcat->con_email; //print_r($contxcat);
			$i++;
		} // print_r($arr_mails);exit;
		// Ahora enviamos los emails del arreglo de emails
		$tam_arra = sizeof($arr_mails);
		for ($i=0; $i < $tam_arra; $i++) {
			if ($arr_mails[$i] != "" && substr_count($arr_mails[$i],'@')) {
				$headers = "";
				if ($from != "") $headers .= "From: ". $from ."\r\n";
				mail($arr_mails[$i], $asunto, $mensaje, $headers);
			}
		}
		return true;
	}
}
?>