<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */
 /**
 * Gnenerador de las categorias y pginas de contendio
 *
 * @package Contenido
 * @version 1.1
 * @author John Alexander Vargas <johnvargas@telesat.com.co> 
 * @since   PHP 4.1.2
 */
 class Generar_contenido 
{

	/**
 	 * Genera los archivos planos de HTML para el articulo solicitado
	 *
     * @param  int $id_sitio sitio que contiene al articulo a generar
	 *         string $path_sitio nombre del directorio donde esta el sitio
	 *         objeto $idioma Objeto idioma en el cual se generar el articulo
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */   
	function generar_articulos($id_articulo)
	{
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
	
		$articulo = new Art_articulos;
		$articulo_version = new Art_articulos_versiones;
		$template_articulo = PATH_CONTENIDO . "vistas/templates/tpl_articulo.html";
		$articulo->get($id_articulo);
		$articulo_version->setid_idioma($id_idioma);
		$articulo_version->setid_objeto($id_articulo);
		if (!$articulo_version->find(true))
			Fachada_Sistema::crear_version(&$articulo_version, $id_idioma);
	
		$archivo_articulo = $path_sitio . "/pagina_" . $articulo->id_objeto . '.php'; 
		//echo $archivo_articulo;
		$articulo_version->id_objeto = $id_articulo;
		$articulo_version->id_idioma = $id_idioma;
				
		// Se escribe la cabecera del portal
		$vista = "vistas/" . $_SESSION['sis_idioma']['enctype'];
		
		// Cuando se vaya a ver el articulo verificar permisos para verlo
		$include_head = "";
		$art_obj = new Art_articulos;
		$art_obj->get($id_articulo);
		if ($art_obj->publico == 0) {
			$template_privado = PATH_CONTENIDO . "vistas/templates/tpl_privado.html";
			$include_head .= implode("\n",file($template_privado));
		}
		$categoria_padre = new Art_categorias_articulos;
		$categoria_padre->get($art_obj->id_contenedor);
		
		$include_head .= '<?
			$id_menu = "";
		  include("'.$vista.'/head_public.php") ?>';
		
		File::writeLine($archivo_articulo, $include_head, FILE_MODE_WRITE);
				
			// Se escribe el contenido del articulo
		$contenido_articulo = addslashes(implode("\n",file($template_articulo))); 
			
		eval("\$contenido_HTML = \"$contenido_articulo\"; ");
		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));
		// Traer los bloques del articulo
		$bloques_array = array();
		$bloques = new Art_bloques;
		$articulo->id_objeto = $id_articulo;
		$bloques->joinAdd($articulo);
		$bloques->selectAs();
		$bloques->find(); 
			
		while ($bloques->fetch()) 
			$bloques_array[$bloques->posicion] = array('id_bloque' => $bloques->id_objeto, 'tipo' => $bloques->tipo);	
		// se ordenan los bloques por posicion
		ksort($bloques_array); 
		reset($bloques_array);
		
		// Se escriben el contenido de los bloques
		foreach ($bloques_array as $k => $v) { 
			$metodo = "generar_bloque_" . $v['tipo']; 
			Generar_contenido::$metodo($v['id_bloque'], $path_sitio, $archivo_articulo, $id_idioma);		
		}
		// Se escribe el pie del portal
		File::writeLine($archivo_articulo, '<?  include("vistas/foot_public.php") ?>');
	}
	
	/**
 	 * Genera los archivos planos de HTML para la categoria solicitada
	 *
     * @param  int $id_sitio sitio que contiene al articulo a generar
	 * @param  string $path_sitio nombre del directorio donde esta el sitio
	 * @param  objeto $idioma Objeto idioma en el cual se generar el articulo
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */   
	function generar_categoria($id_categoria)
	{			
		// Ruta e idioma de generacin
		$path_imagenes = '<?= PATH_IMAGES ?>/articulos/';
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		
		// Instanciar objetos necesarios para la generacin
		$categoria = new Art_categorias_articulos;
		$categoria_version = new Art_categorias_articulos_versiones;
		$plantilla = new Art_plantillas_categorias;
		
		$categoria->id_objeto = $id_categoria;
		$categoria_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$categoria->joinAdd($categoria_version); // Join con la version
		$categoria->selectAs($categoria_version, 'ver_%s');
		$categoria->joinAdd($plantilla); // Join con la plantilla
		$categoria->selectAs($plantilla, 'plt_%s');
		$categoria->find(true);
		
		// Archivo con la plantilla y destino de la generacin
		$template_categoria = PATH_CONTENIDO . "vistas/templates/tpl_categoria_".$categoria->plt_tipo.".html";
		$archivo_categoria = $path_sitio . "/pagina_" . $id_categoria . '.php'; 

		// Se escribe la cabecera del portal
		$vista = "vistas/" . $_SESSION['sis_idioma']['enctype'];

		
		File::writeLine($archivo_categoria, '<?
		  $id_menu = ' . $categoria->id_menu . ';	
		  include("'.$vista.'/head_public.php") ?>', FILE_MODE_WRITE);
				
		// Se obtiene un listado de las subcategorias de la categoria
		$subcategoria = new Art_categorias_articulos;
		$subcategoria->id_contenedor = $id_categoria;
		$subcategoria->find();
		$lista_subcategorias = array();
		while ($subcategoria->fetch()) {
			$subcategoria_version = new Art_categorias_articulos_versiones;
			$subcategoria_version->id_idioma = $id_idioma;
			$subcategoria_version->id_objeto = $subcategoria->id_objeto;
			if (!$subcategoria_version->find(true))
				Fachada_Sistema::crear_version(&$subcategoria_version, $id_idioma);
			array_push($lista_subcategorias, $subcategoria_version);
		}	
		
		// Se obtiene un listado de los articulos de la categoria
		$articulo = new Art_articulos;
		$articulo->id_contenedor = $id_categoria;
		$articulo->find();
		$lista_articulos = array();
		while ($articulo->fetch()) {
			$articulo_version = new Art_articulos_versiones;
			$articulo_version->id_idioma = $id_idioma;
			$articulo_version->id_objeto = $articulo->id_objeto;
			if (!$articulo_version->find(true))
				Fachada_Sistema::crear_version(&$articulo_version, $id_idioma);
			array_push($lista_articulos, $articulo_version);
		}	

		include($template_categoria); 
		File::writeLine($archivo_categoria, stripslashes($contenido_HTML));
		
		// Se escribe el pie del portal
		File::writeLine($archivo_categoria, '<?  include("vistas/foot_public.php") ?>');
	}
	
	/**
 	 * Genera los archivos planos de HTML para el bloque tipo FOTO_TEXTO
	 *
     * @param   int $id_bloque Identificador del bloque a generar
	 * @param   string $path_sitio nombre del directorio donde esta el sitio
	 * @param   string $archivo_articulo nombre del archivo del articulo
	 * @author  John Vargas
     * @access  public
     */   
	function generar_bloque_foto_texto($id_bloque, $path_sitio, $archivo_articulo, $id_idioma)
	{ 
		$template_bloque = PATH_CONTENIDO . "vistas/templates/" . "tpl_bloque_foto_texto.html";		
		$bloque = new Art_bloques_foto_textos;
		$bloque->id_objeto = $id_bloque;
		$bloque->id_idioma = $id_idioma;
		
		$url_sitio = $_SESSION['sitio']['url'];
		$path_imagenes = "<?= PATH_IMAGES ?>articulos/";
		
		if (!$bloque->find(true))
			Fachada_Sistema::crear_version(&$bloque, $id_idioma);

		// Se escribe el contenido del bloque
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		eval("\$contenido_HTML = \"$contenido_bloque\"; ");

		// Contenido a buscar y reemplazar
		$search = array ("lib/spaw/empty.html#",  			// Los href de los cuadros de dialogo
						"empty.html",
						"imagenes_cont");                    // Los empty.html que hayan quedado por ahi
		$replace = array ("#",
						 "",
						 "". PATH_CMS ."/imagenes_cont");
		$contenido_HTML = str_replace ($search, $replace, $contenido_HTML); 

		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));
	}
	
	/**
 	 * Genera los archivos planos de HTML para el bloque IMAGENES
	 *
     * @param   int $id_bloque Identificador del bloque a generar
	 *          string $path_sitio nombre del directorio donde esta el sitio
	 *          string $archivo_articulo nombre del archivo del articulo
	 *          int $id_idioma Identifdicador del idioma de la versin
	 * @author  John A. Vargas
     * @access  public
     */   
	function generar_bloque_imagenes($id_bloque, $path_sitio, $archivo_articulo, $id_idioma)
	{ 
		$template_bloque = PATH_CONTENIDO . "vistas/templates/" . "tpl_bloque_imagenes.html";		
		$bloque = new Art_bloques_imagenes;
		$bloque->setid_objeto($id_bloque);
		$bloque->setid_idioma($id_idioma);
		$url_sitio = $_SESSION['sitio']['url'];
		$path_imagenes = "<?= PATH_IMAGES ?>articulos/";
		 if (!$bloque->find(true))
		 	Fachada_Sistema::crear_version(&$bloque, $id_idioma);
			
		// Se escribe el contenido del bloque
		$contenido_bloque = '';
		include($template_bloque); 
		$contenido_bloque = addslashes($contenido_bloque);
		eval("\$contenido_HTML = \"$contenido_bloque\"; ");
		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));	
	}
	
	/**
 	 * Genera los archivos planos de HTML para el bloque tipo TEXTO_FOTO
	 *
     * @param   int $id_bloque Identificador del bloque a generar
	 * @param   string $path_sitio nombre del directorio donde esta el sitio
	 * @param   string $archivo_articulo nombre del archivo del articulo
	 * @author  John Vargas
     * @access  public
     */   
	function generar_bloque_texto_foto($id_bloque, $path_sitio, $archivo_articulo, $id_idioma)
	{ 
		$template_bloque = PATH_CONTENIDO . "vistas/templates/" . "tpl_bloque_texto_foto.html";		
		$bloque = new Art_bloques_texto_fotos;
		$bloque->id_objeto = $id_bloque;
		$bloque->id_idioma = $id_idioma;
		$url_sitio = $_SESSION['sitio']['url'];
		$path_imagenes = "<?= PATH_IMAGES ?>articulos/";
		 if (!$bloque->find(true))
		 	Fachada_Sistema::crear_version(&$bloque, $id_idioma);
			
		// Se escribe el contenido del bloque
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		eval("\$contenido_HTML = \"$contenido_bloque\"; ");

		// Contenido a buscar y reemplazar
		$search = array ("lib/spaw/empty.html#",  			// Los href de los cuadros de dialogo
						"empty.html",
						"imagenes_cont");                    // Los empty.html que hayan quedado por ahi
		$replace = array ("#",
						 "",
						 "". PATH_CMS ."/imagenes_cont");
		$contenido_HTML = str_replace ($search, $replace, $contenido_HTML); 

		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));
		
	}
	/**
 	 * Genera los archivos planos de HTML para el bloque tipo TEXTO
	 *
     * @param   int $id_bloque Identificador del bloque a generar
	 * @param   string $path_sitio nombre del directorio donde esta el sitio
	 * @param   string $archivo_articulo nombre del archivo del articulo
	 * @author  John Vargas
     * @access  public
     */   
	function generar_bloque_texto($id_bloque, $path_sitio, $archivo_articulo, $id_idioma)
	{  
		$template_bloque = PATH_CONTENIDO . "vistas/templates/" . "tpl_bloque_texto.html";		
		$bloque = new Art_bloques_textos;
		$bloque->id_objeto = $id_bloque;
		$bloque->id_idioma = $id_idioma;
		
		if (!$bloque->find(true))
			Fachada_Sistema::crear_version(&$bloque, $id_idioma);
	
		// Se escribe el contenido del bloque
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		eval("\$contenido_HTML = \"$contenido_bloque\"; ");
		
		// Contenido a buscar y reemplazar
		$search = array ("lib/spaw/empty.html#",  			// Los href de los cuadros de dialogo
						"empty.html",
						"imagenes_cont");                    // Los empty.html que hayan quedado por ahi
		$replace = array ("#",
						 "",
						 "". PATH_CMS ."/imagenes_cont");
		$contenido_HTML = str_replace ($search, $replace, $contenido_HTML); 

		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));
	}
	/**
 	 * Genera los archivos planos de HTML para el bloque tipo FLASH
	 *
     * @param   int $id_bloque Identificador del bloque a generar
	 * @param   string $path_sitio nombre del directorio donde esta el sitio
	 * @param   string $archivo_articulo nombre del archivo del articulo
	 * @author  John Vargas
     * @access  public
     */   
	function generar_bloque_flash($id_bloque, $path_sitio, $archivo_articulo, $id_idioma)
	{  
		$template_bloque = PATH_CONTENIDO . "vistas/templates/" . "tpl_bloque_flash.html";		
		$bloque = new Art_bloques_flash;
		$bloque->id_objeto = $id_bloque; 
		$bloque->id_idioma = $id_idioma;
		$url_sitio = $_SESSION['sitio']['url'];
		$path_imagenes = "<?= PATH_IMAGES ?>articulos/";
		
		if (!$bloque->find(true))
			Fachada_Sistema::crear_version(&$bloque, $id_idioma);
			
		// Se escribe el contenido del bloque
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		eval("\$contenido_HTML = \"$contenido_bloque\"; ");
		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));
	}
	/**
 	 * Genera los archivos planos de HTML para el bloque tipo ARCHIVO
	 *
     * @param   int $id_bloque Identificador del bloque a generar
	 * @param   string $path_sitio nombre del directorio donde esta el sitio
	 * @param   string $archivo_articulo nombre del archivo del articulo
	 * @author  John Vargas
     * @access  public
     */   
	function generar_bloque_archivo($id_bloque, $path_sitio, $archivo_articulo, $id_idioma)
	{  
		$template_bloque = PATH_CONTENIDO . "vistas/templates/" . "tpl_bloque_archivo.html";		
		$bloque = new Art_bloques_archivos;
		$bloque->id_objeto = $id_bloque;
		$bloque->id_idioma = $id_idioma;
		$url_sitio = $_SESSION['sitio']['url'];
		$path_imagenes = "<?= PATH_IMAGES ?>articulos/";
		
		if (!$bloque->find(true))
			Fachada_Sistema::crear_version(&$bloque, $id_idioma);
		
		// Se escribe el contenido del bloque
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		eval("\$contenido_HTML = \"$contenido_bloque\"; ");
		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));	
	}
	
	/*
	 * Genera todo el modulo de contenido
	 *
	 * @static
	 */
	function generar_contenido()
	{
		$modulo = new Art_datos_modulos_articulos;
		$modulo->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
			
		// Generacin de categorias.
		$categoria = new Art_categorias_articulos;
		$categoria->id_modulo = $modulo->id_objeto;
		$categoria->find();
		while ($categoria->fetch())
			Generar_contenido::generar_categoria($categoria->id_objeto);
		
		// Generacin de articulos.
		$articulo = new Art_articulos;
		$articulo->id_modulo = $modulo->id_objeto;
		$articulo->find();
		while ($articulo->fetch())
			Generar_contenido::generar_articulos($articulo->id_objeto);
	}
}
?>