<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.1.2                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2004 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
 * |		  Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John A. Vargas <jhonvargas@telesat.com.co>                  |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */
//
// Especificacin de articulos
//
 /**
 *  La clase fachada contenido administra las clases para el modulo de contenido
 *
 * @package Contenido
 * @version 1.1
 * @author  Maria Luisa Manyoma <mlmanyoma@telesat.com.co> 
 * @modificado Sonia Marcela Benavides <smbenavides@telesat.com.co> 
 * @since   PHP 4.1.2
 */
// Clases necesarias
require_once(PATH_CONTENIDO . 'modelo/Art_articulos.php');
require_once(PATH_CONTENIDO . 'modelo/Art_articulos_versiones.php');
require_once(PATH_CONTENIDO . 'modelo/Art_bloques.php');
require_once(PATH_CONTENIDO . 'modelo/Art_bloques_archivos.php');
require_once(PATH_CONTENIDO . 'modelo/Art_bloques_flash.php');
require_once(PATH_CONTENIDO . 'modelo/Art_bloques_foto_textos.php');
require_once(PATH_CONTENIDO . 'modelo/Art_bloques_texto_fotos.php');
require_once(PATH_CONTENIDO . 'modelo/Art_bloques_textos.php');
require_once(PATH_CONTENIDO . 'modelo/Art_categorias_articulos.php');
require_once(PATH_CONTENIDO . 'modelo/Art_categorias_articulos_versiones.php');
require_once(PATH_CONTENIDO . 'modelo/Art_datos_modulos_articulos.php');
require_once(PATH_CONTENIDO . 'modelo/Art_plantillas_categorias.php');
require_once(PATH_CONTENIDO . 'modelo/Art_bloques_imagenes.php');
//require_once(PATH_CONTENIDO . 'modelo/Art_bloques_tablas.php');

// Mapeamiento
include(PATH_CONTENIDO . 'controlador/mappings.php');

// Genenerador
include(PATH_CONTENIDO . 'modelo/Generar_contenido.php');

//CONTROLADOR
require_once PATH_CONTENIDO . 'controlador/forms/listar_articulosForm.php';
require_once PATH_CONTENIDO . 'controlador/actions/listar_articulosAction.php'; 
require_once PATH_CONTENIDO . 'controlador/forms/insertar_bloqueForm.php';
require_once PATH_CONTENIDO . 'controlador/actions/insertar_bloqueAction.php'; 
require_once PATH_CONTENIDO . 'controlador/actions/ver_articuloAction.php'; 
require_once PATH_CONTENIDO . 'controlador/actions/subir_bloqueAction.php'; 
require_once PATH_CONTENIDO . 'controlador/actions/bajar_bloqueAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/eliminar_bloqueAction.php'; 
require_once PATH_CONTENIDO . 'controlador/forms/modificar_articuloForm.php';
require_once PATH_CONTENIDO . 'controlador/actions/modificar_articuloAction.php'; 
require_once PATH_CONTENIDO . 'controlador/actions/previsualizarAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/listar_categoriasAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/art_crear_categoriaAction.php';
require_once PATH_CONTENIDO . 'controlador/forms/art_crear_categoriaForm.php';
require_once PATH_CONTENIDO . 'controlador/actions/ver_categoriaAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/mostrar_detalle_categoriaAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/modificar_categoria_contenidoAction.php';
require_once PATH_CONTENIDO . 'controlador/forms/modificar_categoria_contenidoForm.php';
require_once PATH_CONTENIDO . 'controlador/actions/subir_articuloAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/bajar_articuloAction.php';
require_once PATH_CONTENIDO . 'controlador/forms/buscar_articulosForm.php';
require_once PATH_CONTENIDO . 'controlador/actions/buscar_articulosAction.php';
require_once PATH_CONTENIDO . 'controlador/forms/borrar_articulosForm.php';
require_once PATH_CONTENIDO . 'controlador/actions/borrar_articulosAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/crear_articuloAction.php'; 
//require_once PATH_CONTENIDO . 'controlador/actions/listar_resumenAction.php'; 
//require_once PATH_CONTENIDO . 'controlador/actions/previsualizar_articuloAction.php'; 
require_once PATH_CONTENIDO . 'controlador/actions/guardar_rolAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/ver_usuarioAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/mostrar_arbol_articulosAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/eliminar_categoria_contenidoAction.php';
require_once PATH_CONTENIDO . 'controlador/actions/previsualizar_articuloAction.php';

class Fachada_contenido
{
	// Esta variable es necesaria para la optimizacion del wisywyg.
	var $num_bloques_wisywyg;
	var $estilos_wysiwyg;
	
    /**
 	 * Construye una cadena para el arbol javascript de categorias y productos
     *
     * @param   int $id_objeto Identificador de la categoria a listar
	 * @param   string $cadena cadena con las categorias y articulos a listar
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function construir_arbol($id_objeto, $cadena = '', $id_usuario)
	{
	
			echo "ID: $id_objeto, CADENA: $cadena<br />";
        $categoria = new Art_categorias_articulos;
		$categoria->get($id_objeto);
		$categoria_versiones = new  Art_categorias_articulos_versiones;
		$categoria_versiones->id_objeto = $id_objeto;
		$categoria_versiones->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		if (!$categoria_versiones->find(true))
			Fachada_Sistema::crear_version(&$categoria_versiones, $_SESSION['sis_idioma']['id_idioma']);
	
		// Verificar permiso de acceso
		$usa = Fachada_Sistema::traer_permiso($id_usuario, $id_objeto) & ALIMENTAR;
		$permiso = Fachada_Sistema::chequear_permiso($id_usuario, $id_objeto, ALIMENTAR); 
		$perfiles = new ArrayList();
		$perfiles->add('es_alimentador=' . Fachada_Sistema::chequear_permiso($id_usuario, $id_objeto, ALIMENTAR));
		$perfiles->add('es_editor=' . Fachada_Sistema::chequear_permiso($id_usuario, $id_objeto, EDITAR));
		$perfiles->add('es_admin=' . Fachada_Sistema::chequear_permiso($id_usuario, $id_objeto, ADMINISTRAR));
		$perfil = implode('&', $perfiles->toArray());
		$nombre_categoria = addslashes($categoria_versiones->getnombre());
		if ($permiso || $usa) {
			$cadena .= "['<b>$nombre_categoria</b>', 'index.php?view=src/contenido/vistas/opciones_categoria.php&id_categoria_contenido=$id_objeto&nombre=$nombre_categoria&$perfil', 'contenido_mod'";
			$categoria = new Art_categorias_articulos;
			$categoria->whereAdd("id_contenedor='$id_objeto'");
			$categoria->orderBy("id_objeto");
			$categoria->find(); 
			while($categoria->fetch()){
				$child_id=$categoria->id_objeto;
					$cadena .= ", ";
				Fachada_contenido::construir_arbol($child_id, &$cadena, $id_usuario);
			}
 		}
		
        $articulo = new Art_articulos;
		$articulo->id_contenedor = $id_objeto;
        $articulo->find();
       while($articulo->fetch()){ 
	   		// Obtener la version del articulo en el idioma de sesion
      	  	$articulo_versiones = new Art_articulos_versiones;
			$articulo_versiones->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			$articulo_versiones->id_objeto = $articulo->id_objeto;
			if (!$articulo_versiones->find(true))
				Fachada_Sistema::crear_version(&$articulo_versiones, $_SESSION['sis_idioma']['id_idioma']);
				
			// Obtener el permiso necesario para alimentar el articulo	
			$permiso_art = Fachada_Sistema::chequear_permiso($id_usuario, $articulo_versiones->id_objeto, ALIMENTAR); 
			$nombre_articulo = addslashes($articulo_versiones->getnombre());
			if ($permiso_art)
	   			$cadena .= ",['$nombre_articulo', 'index.php?view=src/contenido/vistas/opciones_articulo.php&id_articulo=$articulo_versiones->id_objeto&nombre_articulo=$nombre_articulo', 'contenido_mod']";
        }
		if ($permiso || $usa)
	        $cadena .= "]";
			
			echo "ID: $id_objeto, CADENA: $cadena<br />";
        return;
    }

    /**
 	 * Copia un archivo de tipo .gif, .jpg, .swf, .doc, .xls, .pps a un path dado
     *
     * @param   string $archivo archivo a copiar
	 * @param   string $nombre nombre del archivo a copiar
	 * @param   string $size tamanno del archivo a copiar
	 * @param   string $path ruta de la imagen
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  1 si se pudo copiar el archivo
     */  
	function copiar_archivo($tipo, $nombre, $size, $archivo, $path){
		switch ($tipo){
			case 'archivo':
				$formatos_permitidos = array(".pdf", ".doc", ".xls", ".pps");
				$peso = 1000000;
			break;
			case 'flash':
				$formatos_permitidos = array(".swf");
				$peso = 100000;
			break;
			case 'imagen':
				$formatos_permitidos = array(".gif", ".jpg");
				$peso = 100000;
			break;
		}
		$path = $path.time(); 
			//verifica el tamao del archivo
			if ($size > $peso){
				$mensaje = "El tama&ntilde;o del archivo excede el valor permitido";
				$_SESSION['mensaje'] = $mensaje;
				$copiado = 0;
				return;
			}
			//verifica el formato del archivo
			if  (($nombre != "") and  (in_array(substr($nombre, -4), $formatos_permitidos))){
				if (is_uploaded_file($archivo)){
			        copy($archivo, $path."_".$nombre);
					$copiado = 1;
		        } else {
					$mensaje = "Error al copiar el archivo";
					$_SESSION['mensaje'] = $mensaje;
					$copiado = 0;
					return;
				}   
			}    	
			else{
				$mensaje = "El tipo de archivo no es valido";
				$_SESSION['mensaje'] = $mensaje;
				$copiado = 0;
				return;
			}
		
		return $copiado;
	
	}

    /**
 	 * ajusta el tamao de una imagen a un ancho dado
     * @param   file $imagen imagen a cambiar
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  array con el nuevo ancho y alto de la imagen
     */  
	function ajustar_imagen($imagen, $path)
	{
		$imagen = new Imagen($imagen, $path);
		$imagen->rezise(113, 114);
		return array("width" =>  $imagen->width, "height" => $imagen->height);
	}

    /**
 	 * Muestra un articulo del portal
     *
     * @param   int $id_sitio identificador del sito
	 * @param   int $id_objeto identificador del articulo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function previsualizar_articulo($id_sitio, $id_objeto){	
		$sitio = new Mst_minisitios;
		$sitio->get($id_sitio);
			
		$articulo = new Art_articulos;
		$articulo->whereAdd("id_contenedor = '$id_sitio'");
		$articulo->whereAdd("id_objeto = '$id_objeto'");
		$articulo->find();
		$articulo->fetch();
		$template_cabeza_articulo = PATH_CONTENIDO . "vistas/templates/tpl_bloque_encabezado_portal.html";
		$contenido_cabeza_articulo = addslashes(implode("\n",file($template_cabeza_articulo))); 
	
		eval("\$contenido_HTML = \"$contenido_cabeza_articulo\"; ");
		// Traer los bloques del articulo
		$bloques_array = array();
		$bloques = new Art_bloques;
		$bloques->whereAdd("id_articulo = '{$articulo->id_objeto}'");
		$bloques->orderBy('posicion ASC');
		$bloques->find(); 
		$i = 0;
		while ($bloques->fetch()){ 
			$bloques_array[$i] = array('id_articulo' => $bloques->id_articulo, 'id_bloque' => $bloques->id_bloque, 'tipo' => $bloques->tipo, 'posicion' => $bloques->posicion);	
			$i++;
        }
		// Se escriben los bloques
		for ($i = 0; $i < sizeof($bloques_array); $i++) { 
			$tamanno = sizeof($bloques_array);
			switch ($bloques_array[$i]['tipo']) {
				case "foto_texto": 
				Fachada_contenido::previsualizar_bloque_ft($bloques_array[$i]['id_articulo'], $bloques_array[$i]['id_bloque'], &$contenido_HTML);
				break;
				case "texto_foto": 
					Fachada_contenido::previsualizar_bloque_tf($bloques_array[$i]['id_articulo'], $bloques_array[$i]['id_bloque'], &$contenido_HTML);
				break;
				case "texto": 
					Fachada_contenido::previsualizar_bloque_t($bloques_array[$i]['id_articulo'], $bloques_array[$i]['id_bloque'], &$contenido_HTML);
				break;
				case "flash": 
					Fachada_contenido::previsualizar_bloque_flash($bloques_array[$i]['id_articulo'], $bloques_array[$i]['id_bloque'], &$contenido_HTML);
				break;
				case "archivo": 
					Fachada_contenido::previsualizar_bloque_archivo($bloques_array[$i]['id_articulo'], $bloques_array[$i]['id_bloque'], &$contenido_HTML);
				break;
			}
		}
 		$_SESSION['contenido_HTML'] = $contenido_HTML;
		return ;
	}
	/**
 	 * Muestra un bloque de tipo flash de un articulo para modificarlo
	 *
     * @param   int $tamanno numero de bloques del articulo
     * @param   int $id_articulo codigo del articulo
     * @param   int $id_bloque codigo del bloque
     * @param   int $i posicion del bloque
     * @param   string $contenido_HTML  HTML de los bloques anteriores 
	 * @author  Maria Luisa Manyoma
     * @access  public
     */   
	function previsualizar_bloque_flash($id_articulo, $id_bloque, $contenido_HTML){
		$bloque = new Art_bloques_flash;
		$bloque ->whereAdd("id_bloque = '$id_bloque'");
		$bloque ->find(); 
		$bloque ->fetch();
		$posicion = $bloque->posicion;
		$template_flash = PATH_CONTENIDO . "vistas/templates/tpl_bloque_flash_portal.html";
		$contenido_flash = addslashes(implode("\n",file($template_flash))); 
		eval("\$contenido_HTML .= \"$contenido_flash\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}
	
	/**
 	 * Muestra un bloque de tipo archivo de un articulo para modificarlo
	 *
     * @param   int $tamanno numero de bloques del articulo
     * @param   int $id_articulo codigo del articulo
     * @param   int $id_bloque codigo del bloque
     * @param   int $i posicion del bloque
     * @param   string $contenido_HTML  HTML de los bloques anteriores 
	 * @author  Maria Luisa Manyoma
     * @access  public
     */   
	function previsualizar_bloque_archivo($id_articulo, $id_bloque, $contenido_HTML){
		$bloque = new Art_bloques_archivos;
		$bloque->whereAdd("id_bloque = '$id_bloque'");
		$bloque->find(); 
		$bloque ->fetch();
		$posicion = $bloque->posicion;
		$template_archivo = PATH_CONTENIDO . "vistas/templates/tpl_bloque_archivo_portal.html";
		$contenido_archivo = addslashes(implode("\n",file($template_archivo))); 
		eval("\$contenido_HTML .= \"$contenido_archivo\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}
	
	/**
 	 * Muestra un bloque de tipo foto_texto de un articulo para modificarlo
	 *
     * @param   int $tamanno numero de bloques del articulo
     * @param   int $id_articulo codigo del articulo
     * @param   int $id_bloque codigo del bloque
     * @param   int $i posicion del bloque
     * @param   string $contenido_HTML  HTML de los bloques anteriores 
	 * @author  Maria Luisa Manyoma
     * @access  public
     */   
	function previsualizar_bloque_ft($id_articulo, $id_bloque, $contenido_HTML){
		$bloque = new Art_bloques_foto_textos;
		$bloque->whereAdd("id_bloque = '$id_bloque'");
		$bloque->find(); 
		$bloque->fetch();
		$posicion = $bloque->posicion;
		$template_foto_texto = PATH_CONTENIDO . "vistas/templates/tpl_bloque_foto_texto_portal.html";
		$contenido_foto_texto = addslashes(implode("\n",file($template_foto_texto))); 
	
		eval("\$contenido_HTML .= \"$contenido_foto_texto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}

	/**
 	 * Muestra un bloque de tipo texto_foto de un articulo para modificarlo
	 *
     * @param   int $tamanno numero de bloques del articulo
     * @param   int $id_articulo codigo del articulo
     * @param   int $id_bloque codigo del bloque
     * @param   int $i posicion del bloque
     * @param   string $contenido_HTML  HTML de los bloques anteriores 
	 * @author  Maria Luisa Manyoma
     * @access  public
     */   
	function previsualizar_bloque_tf($id_articulo, $id_bloque, $contenido_HTML){
		$bloque = new Art_bloques_texto_fotos;
		$bloque->whereAdd("id_bloque = '$id_bloque'");
		$bloque->find(); 
		$bloque->fetch();
		$posicion = $bloque->posicion;
		$template_texto_foto = PATH_CONTENIDO . "vistas/templates/tpl_bloque_texto_foto_portal.html";
		$contenido_texto_foto = addslashes(implode("\n",file($template_texto_foto))); 
		
		eval("\$contenido_HTML .= \"$contenido_texto_foto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}

	/**
 	 * Muestra un bloque de tipo texto de un articulo para modificarlo
	 *
     * @param   int $tamanno numero de bloques del articulo
     * @param   int $id_articulo codigo del articulo
     * @param   int $id_bloque codigo del bloque
     * @param   int $i posicion del bloque
     * @param   string $contenido_HTML  HTML de los bloques anteriores 
	 * @author  Maria Luisa Manyoma
     * @access  public
     */   
	function previsualizar_bloque_t($id_articulo, $id_bloque, $contenido_HTML){
		$bloque = new Art_bloques_textos;
		$bloque->whereAdd("id_bloque = '$id_bloque'");
		$bloque->find(); 
		$bloque->fetch();
		$posicion = $bloque->posicion;
		$template_texto = PATH_CONTENIDO . "vistas/templates/tpl_bloque_texto_portal.html";
		$contenido_texto = addslashes(implode("\n",file($template_texto))); 

		eval("\$contenido_HTML .= \"$contenido_texto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}


    /**
 	 * Actualiza nombre, descripcin y estado de un articulo
     *
	 * @param   int $id_objeto identificador del articulo
	 * @param   string $nombre_menu nombre del articulo en el menu
	 * @param   string $nombre nombre del articulo
	 * @param   string $descripcin descripcion de articulo
	 * @param   Bool $estado publicado / no publicado
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int Identificador del articulo
	 * @static
     */  
	function modificar_articulo($id_idioma, $id_objeto, $nombre, $descripcion, $estado, $imagen_articulo, $publico){
		$dir = "";
		$articulo = new Art_articulos_versiones;
    	// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		$path_sitio =  $dir . str_replace(" ", "_", array_pop(explode('/',$_SESSION['sitio']['url'])));
	
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido)){
			System::mkdir($dir_contenido);
			System::mkdir($dir_contenido."/articulos");
		}
		if (!file_exists($dir_contenido."/articulos")){
			System::mkdir($dir_contenido."/articulos");
		}
		$path = $dir_contenido."/articulos/";
		$articulo->id_idioma = $id_idioma;
		$articulo->id_objeto = $id_objeto;
		$articulo->find(true);
		if($_FILES['imagen_articulo']['name']){
			if(Fachada_contenido::copiar_archivo('imagen', $_FILES['imagen_articulo']['name'], $_FILES['imagen_articulo']['size'], $_FILES['imagen_articulo']['tmp_name'], $path) == 1){
				$foto = time()."_".$_FILES['imagen_articulo']['name']; 
				$articulo->imagen = $foto;
			}
		}
		$articulo->nombre = strip_tags($nombre);
		$articulo->descripcion = ereg_replace("\r\n","<br>",strip_tags($descripcion));
		
		$bandera = $articulo->update();
		
		// Asignarle visibilidad al articulo
		$art_obj = new Art_articulos;
		$art_obj->get($id_objeto);
		$art_obj->publico = $publico;
		$art_obj->update();
		

		//Escribe en el log
		if($bandera > 0)
			Util::log('Contenido', 'Modificar Articulo', 'Se Modifico el articulo con exito');
		else
			Util::log('Contenido', 'Modificar Articulo', 'No se modifico el articulo');


		Generar_contenido::generar_articulos($id_objeto);
		
		$articulo = new Art_articulos;
		$articulo->get($id_objeto);
		Generar_contenido::generar_categoria($articulo->id_contenedor);
        return $id_objeto; 
	}

    /**
 	 * Modifica cada uno de los bloques de un articulo
     *
	 * @param   int $id_objeto identificador del articulo
	 * @param   int $tamanno cantidad de bloques
	 * @param   array $arreglo_texto arreglo con el texto de los bloques tipo texto del articulo
	 * @param   array $foto_texto arreglo con el texto de los bloques tipo foto_texto del articulo
	 * @param   array $texto_foto arreglo con el texto de los bloques tipo texto_foto del articulo
	 * @param   array $foto_texto_imagen arreglo con la imagen de los bloques tipo foto_texto del articulo
	 * @param   array $texto_foto_imagen arreglo con la imagen de los bloques tipo texto_foto del articulo
	 * @param   array $flash arreglo con el texto de los bloques tipo flash del articulo
	 * @param   array $flash_archivo arreglo con el archivo de los bloques tipo flash del articulo
	 * @param   array $archivo arreglo con el texto de los bloques tipo archivo del articulo
	 * @param   array $archivo_archivo arreglo con la imagen de los bloques tipo archivo del articulo
	 * @author  Maria Luisa Manyoma
 	 * @modify  Sonia Marcela Benavides <smbenavides@telesat.com.co>
     * @access  public
     */  
	function modificar_bloque($id_idioma, $tamanno, $id_objeto, $arreglo_texto, 
	                          $foto_texto, $texto_foto, $foto_texto_imagen, 
							  $texto_foto_imagen, $flash, $flash_archivo, 
							  $archivo, $archivo_archivo, $imagenes)
	{
		$dir = "";
    	// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		$path_sitio =  $dir . str_replace(" ", "_", array_pop(explode('/',$_SESSION['sitio']['url'])));
	
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido)){
			mkdir($dir_contenido, 0755);
			mkdir($dir_contenido."/articulos", 0755);
		}
		if (!file_exists($dir_contenido."/articulos")){
			mkdir($dir_contenido."/articulos", 0755);
		}
	
		$path = $dir_contenido."/articulos/";
		for($j=0; $j<$tamanno; $j++) 
		{
			if($flash[$j]['id_bloque'] != ""){
				$id_bloque = $flash[$j]['id_bloque'];
				$bloque_flash = new Art_bloques_flash;
				$bloque_flash->whereAdd("id_idioma = '$id_idioma'");
				$bloque_flash->whereAdd("id_objeto = '$id_bloque'");
				if($_FILES['flash_archivo']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('flash',$_FILES['flash_archivo']['name'][$j], $_FILES['flash_archivo']['size'][$j], $_FILES['flash_archivo']['tmp_name'][$j], $path) == 1){
						$flash_nombre = time()."_".$_FILES['flash_archivo']['name'][$j]; 
						$bloque_flash->flash = $flash_nombre;
					}
				}
				$bloque_flash->ancho = $flash[$j]['ancho'];
				$bloque_flash->alto = $flash[$j]['alto'];
				$bloque_flash->alineacion = $flash[$j]['alineacion'];
				$bandera_flash = $bloque_flash->update();

				//Escribe en el log
				if($bandera_flash > 0)
					Util::log('Contenido', 'Modificar Bloque Flash', 'Se Modifico el bloque Flash con exito');
				else
					Util::log('Contenido', 'Modificar Bloque Flash', 'No se modifico el bloque Flash');

			}
			if($archivo[$j]['id_bloque'] != ""){ 
				$id_bloque = $archivo[$j]['id_bloque'];
				$bloque_archivo = new Art_bloques_archivos;
				$bloque_archivo->get('id_idioma' , $id_idioma);
				$bloque_archivo->get('id_objeto' , $id_bloque);
				$nombre = $archivo[$j]['nombre'];
				if($_FILES['archivo_archivo']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('archivo', $_FILES['archivo_archivo']['name'][$j], $_FILES['archivo_archivo']['size'][$j], $_FILES['archivo_archivo']['tmp_name'][$j], $path) == 1){
						$archivo = time()."_".$_FILES['archivo_archivo']['name'][$j]; 
						$bloque_archivo->archivo = $archivo;
						$bloque_archivo->nombre = $nombre;
					}
				}
				
				$bandera_archivo = $bloque_archivo->update(); 
				//Escribe en el log
				if($bandera_archivo > 0)
					Util::log('Contenido', 'Modificar Bloque Archivo', 'Se Modifico el bloque Archivo con exito');
				else
					Util::log('Contenido', 'Modificar Bloque Archivo', 'No se modifico el bloque Archivo');
			}
		    if($arreglo_texto[$j]['id_bloque'] != ""){ 
				$bloque_t = new Art_bloques_textos;
				$id_bloque = stripslashes( $arreglo_texto[$j]['id_bloque'] );
			
				$bloque_t->whereAdd("id_idioma = '$id_idioma'");
				$bloque_t->whereAdd("id_objeto = '$id_bloque'");
				$contenido = stripslashes( $arreglo_texto[$j]['texto'] );
				//$contenido = str_replace('"',"'",$contenido);
				$car_aux = "\r\n";
				$contenido = ereg_replace($car_aux,' ',$contenido);
				// Contenido a buscar y reemplazar
				$search = array ("lib/spaw/empty.html#",  			// Los href de los cuadros de dialogo
								"empty.html",
								"lib/spaw/",
								"img_popup.php");                    // Los empty.html que hayan quedado por ahi
				$replace = array ("#",
								 "",
								 "",
								 "lib/spaw/img_popup.php");
				$contenido = str_replace ($search, $replace, $contenido);

				$bloque_t->texto1 = $contenido;
				$bandera_texto = $bloque_t->update();  
				//Escribe en el log
				if($bandera_texto > 0)
					Util::log('Contenido', 'Modificar Bloque texto', 'Se Modifico el bloque Texto con exito');
				else
   					Util::log('Contenido', 'Modificar Bloque texto', 'No se modifico el bloque Texto');
			}
			if($foto_texto[$j]['id_bloque'] != ""){
				//print_r($foto_texto);
				$bloque_ft = new Art_bloques_foto_textos;
				$id_bloque = $foto_texto[$j]['id_bloque'];
				if($_FILES['foto_texto_imagen']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('imagen', $_FILES['foto_texto_imagen']['name'][$j], $_FILES['foto_texto_imagen']['size'][$j], $_FILES['foto_texto_imagen']['tmp_name'][$j], $path) == 1){
						$foto = time()."_".$_FILES['foto_texto_imagen']['name'][$j]; 
						$bloque_ft->foto = $foto;
					}
				}
				$contenido = stripslashes( $foto_texto[$j]['texto'] );
//				$contenido = str_replace('"',"'",$contenido);
				$car_aux = "\r\n";
				$contenido = ereg_replace($car_aux,' ',$contenido);
				// Contenido a buscar y reemplazar
				$search = array ("lib/spaw/empty.html#",  			// Los href de los cuadros de dialogo
								"empty.html",
								"lib/spaw/",
								"img_popup.php");                    // Los empty.html que hayan quedado por ahi
				$replace = array ("#",
								 "",
								 "",
								 "lib/spaw/img_popup.php");
				$contenido = str_replace ($search, $replace, $contenido);

				$bloque_ft->whereAdd("id_idioma = '$id_idioma'");
				$bloque_ft->whereAdd("id_objeto = '$id_bloque'");
				$bloque_ft->texto = $contenido;
				$bloque_ft->pie_foto = $foto_texto[$j]['pie_foto'];			
				$bloque_ft->alt = $foto_texto[$j]['alt'];
				$bandera_ft = $bloque_ft->update();  
				//Escribe en el log
				if($bandera_ft > 0 )
					Util::log('Contenido', 'Modificar bloque Foto Texto', 'Se Modifico el bloque Foto Texto con exito');
				else
					Util::log('Contenido', 'Modificar bloque Foto Texto', 'No se modifico el bloque Foto Texto');
			}
			if($texto_foto[$j]['id_bloque'] != ""){
				$bloque_tf = new Art_bloques_texto_fotos;
				$id_bloque = $texto_foto[$j]['id_bloque'];
				if($_FILES['texto_foto_imagen']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('imagen', $_FILES['texto_foto_imagen']['name'][$j], $_FILES['texto_foto_imagen']['size'][$j], $_FILES[texto_foto_imagen]['tmp_name'][$j], $path) == 1){
						$foto = time()."_".$_FILES['texto_foto_imagen']['name'][$j]; 
						$bloque_tf->foto = $foto;
					}
				}
				$contenido = stripslashes( $texto_foto[$j]['texto'] );
//				$contenido = str_replace('"',"'",$contenido);
				$car_aux = "\r\n";
				$contenido = ereg_replace($car_aux,' ',$contenido);
				// Contenido a buscar y reemplazar
				$search = array ("lib/spaw/empty.html#",  			// Los href de los cuadros de dialogo
								"empty.html",
								"lib/spaw/",
								"img_popup.php");                    // Los empty.html que hayan quedado por ahi
				$replace = array ("#",
								 "",
								 "",
								 "lib/spaw/img_popup.php");
				$contenido = str_replace ($search, $replace, $contenido);

				$bloque_tf->whereAdd("id_idioma = '$id_idioma'");
				$bloque_tf->whereAdd("id_objeto = '$id_bloque'");
				$bloque_tf->texto = $contenido;
				$bloque_tf->pie_foto = $foto_texto[$j]['pie_foto'];			
				$bloque_tf->alt = $foto_texto[$j]['alt'];
				$bandera_tf = $bloque_tf->update(); 
				//Escribe en el log
				if($bandera_tf > 0)
					Util::log('Contenido', 'Modificar bloque Texto Foto', 'Se Modifico el bloque Texto Foto con exito');
				else
					Util::log('Contenido', 'Modificar bloque Texto Foto', 'No se Modifico el bloque Texto Foto');
			}
			if($imagenes[$j]['id_bloque'] != ""){
				$bloque_img = new Art_bloques_imagenes;
				$bloque_img->setid_idioma($id_idioma);
				$bloque_img->setid_objeto($imagenes[$j]['id_bloque']);
				$bloque_img->find(true);
				
				if($_FILES['imagenes_file1']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('imagen', $_FILES['imagenes_file1']['name'][$j], $_FILES['imagenes_file1']['size'][$j], $_FILES[imagenes_file1]['tmp_name'][$j], $path) == 1){
						$foto = time()."_".$_FILES['imagenes_file1']['name'][$j]; 
						$bloque_img->foto1 = $foto;
					}
				}
				if($_FILES['imagenes_file2']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('imagen', $_FILES['imagenes_file2']['name'][$j], $_FILES['imagenes_file2']['size'][$j], $_FILES[imagenes_file2]['tmp_name'][$j], $path) == 1){
						$foto = time()."_".$_FILES['imagenes_file2']['name'][$j]; 
						$bloque_img->foto2 = $foto;
					}
				}
				
				if($_FILES['imagenes_file3']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('imagen', $_FILES['imagenes_file3']['name'][$j], $_FILES['imagenes_file3']['size'][$j], $_FILES[imagenes_file3]['tmp_name'][$j], $path) == 1){
						$foto = time()."_".$_FILES['imagenes_file3']['name'][$j]; 
						$bloque_img->foto3 = $foto;
					}
				}
				$bloque_img->pie_foto1 = $imagenes[$j]['pie_foto1'];
				$bloque_img->pie_foto2 = $imagenes[$j]['pie_foto2'];
				$bloque_img->pie_foto3 = $imagenes[$j]['pie_foto3'];
				$bandera_img = $bloque_img->update();
				//Escribe en el log
				if($bandera_img > 0)
					Util::log('Contenido', 'Modificar bloque Imagen', 'Se Modifico el bloque Imagen con exito');
				else
					Util::log('Contenido', 'Modificar bloque Imagen', 'No se odifico el bloque Imagen');
    
			}
		}
	}

    /**
 	 * Muestra un articulo para modificacin
     *
	 * @param   int $id_sitio identificador del sitio
	 * @param   int $id_objeto identificador del articulo
	 * @author  Maria Luisa Manyoma
 	 * @modify Sonia Marcela Benavides <smbenavides@telesat.com.co>
     * @access  public
     */  
	function ver_articulo($id_sitio, $id_objeto, $id_idioma)
	{
		$path_imagenes = "imagenes_cont/".$_SESSION['sitio']['url']."/articulos/";
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/pagina_" . $id_objeto . '.php'; 
		$articulo = new Art_articulos_versiones;
		$articulo->id_idioma = $id_idioma;
		$articulo->id_objeto = $id_objeto;
		if (!$articulo->find(true))
			Fachada_Sistema::crear_version(&$articulo, $id_idioma);
		
		if (!file_exists("imagenes_cont/".$_SESSION['sitio']['url']."/documentos")
			 && !is_dir("imagenes_cont/".$_SESSION['sitio']['url']."/documentos"))
			 mkdir("imagenes_cont/".$_SESSION['sitio']['url']."/documentos");
		
		$imagen = (!$articulo->imagen) ? "foto1.gif" : $articulo->imagen;
		$size = Fachada_contenido::ajustar_imagen($imagen, $path_imagenes);
        $ancho = $size['width'];
        $alto = $size['height'];

		// Traer los bloques del articulo
		$bloques_array = array();
		$bloques = new Art_bloques;
		$bloques->whereAdd("id_contenedor = '{$articulo->id_objeto}'");
		$bloques->orderBy('posicion ASC');
		$bloques->find(); 
		
		$this->num_bloques_wisywyg = 0;
		$this->estilos_wysiwyg = "";
		$instancia_clase_wisywyg = "";
		$bloques_array = new ArrayList();
		while ($bloques->fetch()) {
			$bloques_array->add($bloques->toArray());
			if (ereg("texto",$bloques->tipo)) $this->num_bloques_wisywyg++;
			}

		// Si hay mas de 1 bloque con wisywyg, se instancia la clase q se usa en los templates
		if ( $this->num_bloques_wisywyg > 0 ) {
			$instancia_clase_wisywyg = "";
			$estilos_wysiwyg = $_SESSION['fckeditor_comboBoxStyles'];
		    $estilo_tmp = split(';', $estilos_wysiwyg);
			foreach ($estilo_tmp as $estilo_u){
		          $this->estilos_wysiwyg .= '$demo_array["style"]["'.$estilo_u.'"] = "'.$estilo_u.'";';
		    }
		    //echo $this->estilos_wysiwyg . " - dsfsd";
		}// num_bloques_wisywyg

		// Asignar visiblidad al articulo
		$art_obj = new Art_articulos;
		$art_obj->get($id_objeto);
		$publico = ($art_obj->publico) ? "checked" : "";
		$privado = ($art_obj->publico) ? "" : "checked"; 

		//Obtenemos la categoria a la cual pertenece el articulo para la mostrar la cabecera
		$categoria = new Art_categorias_articulos;
		$categoria->get('id_objeto',$art_obj->id_contenedor);
		
		$articulo->descripcion = ereg_replace("<br>","\r\n",$articulo->descripcion);
		$include_wysiwyg = '<? include (PATH_CMS."lib/spaw/spaw_control.class.php"); ?> ';
		
		//print_r($categoria); exit();
		if($categoria->id_plantilla == 2)
			$template_cabeza_articulo = PATH_CONTENIDO . "vistas/templates/tpl_cabeza_articulo.html";
		else
			$template_cabeza_articulo = PATH_CONTENIDO . "vistas/templates/tpl_cabeza_articulo2.html";

		$contenido_cabeza_articulo = addslashes(implode("\n",file($template_cabeza_articulo))); 
		eval("\$contenido_HTML = \"$contenido_cabeza_articulo\"; ");
		// Se escriben los bloques
		$this->tamanno_bloques_wisywyg = 0;		// Cuenta la cantidad de editores desplegados
		$tamanno = $bloques_array->size();
		$lista = $bloques_array->toArray();
		foreach ($lista as $i => $bloque) { 
			$metodo = "mostrar_bloque_" . $bloque['tipo'];
			Fachada_contenido::$metodo($bloque['posicion'], $id_idioma, $tamanno, $id_objeto, $bloque['id_objeto'], $i, &$contenido_HTML);
		}
 		if($tamanno == 0){
			/* Es necesario poner este path para el botn de vista previa cuando no ningn bloque */
			$path_sitio_ = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
			$archivo_articulo = $path_sitio_ . "/pagina_" . $id_objeto . '.php'; 
			
			$template_opciones = PATH_CONTENIDO . "vistas/templates/tpl_opciones_bloques4.html";
			$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
			eval("\$contenido_HTML .= \"$contenido_flash\"; ");
			eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
		}
		$template_pie_articulo = PATH_CONTENIDO . "vistas/templates/tpl_pie_articulo.html";
		$contenido_pie_articulo = addslashes(implode("\n",file($template_pie_articulo))); 
		
		eval("\$contenido_HTML .= \"$contenido_pie_articulo\"; ");
		$_SESSION['contenido_HTML'] = $contenido_HTML;
		

       // Arbol de enlaces de la ventana hiperlynk
        $ventana_enlaces_internos = "";
        Fachada_Menus::cargar_enlaces_internos_wysiwyg(&$ventana_enlaces_internos, $_SESSION['sitio']['id_objeto'],'');
		$_SESSION['enlaces_internos'] = stripslashes($ventana_enlaces_internos);
		
		return ;
	}// ver_articulo

    /**
 	 * Muestra un bloque tipo flash para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $i posicion del bloque
	 * @param   string $contenido_HTML HTML del bloque
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function mostrar_bloque_flash($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML){
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/pagina_" . $id_articulo . '.php'; 
		$path_imagenes = "imagenes_cont/".array_pop(explode('/',$_SESSION['sitio']['url']))."/articulos/";
		$bloque_flash = new Art_bloques_flash;
		$bloque_flash->id_objeto = $id_bloque;
		$bloque_flash->id_idioma = $id_idioma;
		if (!$bloque_flash->find(true))
			Fachada_Sistema::crear_version(&$bloque_flash, $id_idioma);
			
		//variables necesarias para el funcionamiento del editor wysiwyg
		$nom_editor = "tbCE$i";
		$doc_complet = $nom_editor.'_doc_complet';
		$tipo_bloque = "flash[$i][texto]";
		$tbCE_timerID = "tbCE$i_timerID"; 
		$ObjTableInfo = "ObjTableInfo$i";
		// Se incluye la variable del editor wysiwyg version 2.0
		$contador_editor = $i+1;
		$template_flash = PATH_CONTENIDO . "vistas/templates/tpl_flash.html";
		$contenido_flash = addslashes(implode("\n",file($template_flash))); 

        $template_opciones = fachada_contenido::opciones_articulo($tamanno,$i);
		$contenido_opciones = addslashes(implode("\n",file($template_opciones)));

		eval("\$contenido_HTML .= \"$contenido_flash\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}

    /**
	 * Muestra un bloque tipo imagenes para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 *          int $id_articulo identificador del articulo
	 *          int $id_bloque identificador del bloque
	 *          int $i posicion del bloque
	 *          string $contenido_HTML HTML del bloque
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */  
	function mostrar_bloque_imagenes($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML)
	{
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/pagina_" . $id_articulo . '.php'; 
		$path_imagenes = "imagenes_cont/".$_SESSION['sitio']['url']."/articulos/";
		$bloque_imagenes = new Art_bloques_imagenes;
		$bloque_imagenes->id_objeto = $id_bloque;
		$bloque_imagenes->id_idioma = $id_idioma;
		if (!$bloque_imagenes->find(true))
			Fachada_Sistema::crear_version(&$bloque_imagenes, $id_idioma);
			
		//variables necesarias para el funcionamiento del editor wysiwyg
		$nom_editor = "tbCE$i";
		$doc_complet = $nom_editor.'_doc_complet';
		$tipo_bloque = "archivo[$i][texto]";
		$tbCE_timerID = "tbCE$i_timerID"; 
		$ObjTableInfo = "ObjTableInfo$i";
	
		// Se incluye la variable del editor wysiwyg version 2.0
		$contador_editor = $i+1;
		$size = Fachada_contenido::ajustar_imagen($bloque_imagenes->foto1, $path_imagenes);
        $ancho1 = $size['width'];
        $alto1 = $size['height'];
		
		$size = Fachada_contenido::ajustar_imagen($bloque_imagenes->foto2, $path_imagenes);
        $ancho2 = $size['width'];
        $alto2 = $size['height'];
		
		$size = Fachada_contenido::ajustar_imagen($bloque_imagenes->foto3, $path_imagenes);
        $ancho3 = $size['width'];
        $alto3 = $size['height'];
				
		$template_archivo = PATH_CONTENIDO . "vistas/templates/tpl_imagenes.html";
		$contenido_archivo = addslashes(implode("\n",file($template_archivo))); 
		
        $template_opciones = fachada_contenido::opciones_articulo($tamanno,$i);
		$contenido_opciones = addslashes(implode("\n",file($template_opciones)));

		eval("\$contenido_HTML .= \"$contenido_archivo\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}

    /**
 	 * Muestra un bloque tipo archivo para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $i posicion del bloque
	 * @param   string $contenido_HTML HTML del bloque
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function mostrar_bloque_archivo($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML){
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/pagina_" . $id_articulo . '.php'; 
		$path_imagenes = "imagenes_cont/".$_SESSION['sitio']['url']."/articulos/";
		$bloque_archivo = new Art_bloques_archivos;
		$bloque_archivo->id_objeto = $id_bloque;
		$bloque_archivo->id_idioma = $id_idioma;
		if (!$bloque_archivo->find(true))
			Fachada_Sistema::crear_version(&$bloque_archivo, $id_idioma);
			
		//variables necesarias para el funcionamiento del editor wysiwyg
		$nom_editor = "tbCE$i";
		$doc_complet = $nom_editor.'_doc_complet';
		$tipo_bloque = "archivo[$i][texto]";
		$tbCE_timerID = "tbCE$i_timerID"; 
		$ObjTableInfo = "ObjTableInfo$i";
		// Se incluye la variable del editor wysiwyg version 2.0
		$contador_editor = $i+1;
		
		if($bloque_archivo->archivo)
			$rotulo = "Archivo Actual:";
				
		$template_archivo = PATH_CONTENIDO . "vistas/templates/tpl_archivo.html";
		$contenido_archivo = addslashes(implode("\n",file($template_archivo))); 

        $template_opciones = fachada_contenido::opciones_articulo($tamanno,$i);
		$contenido_opciones = addslashes(implode("\n",file($template_opciones)));

		eval("\$contenido_HTML .= \"$contenido_archivo\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}

    /**
 	 * Muestra un bloque tipo foto_texto para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $i posicion del bloque
	 * @param   string $contenido_HTML HTML del bloque
	 * @author  Maria Luisa Manyoma
 	 * @modify  Sonia Marcela Benavides <smbenavides@telesat.com.co>
	 * @access  public
   	 */  
	function mostrar_bloque_foto_texto($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML){
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/pagina_" . $id_articulo . '.php'; 
		$bloque_ft = new Art_bloques_foto_textos;
		$bloque_ft->id_objeto = $id_bloque;
		$bloque_ft->id_idioma = $id_idioma;
		if (!$bloque_ft->find(true))
			Fachada_Sistema::crear_version(&$bloque_ft, $id_idioma);
			
		//variables necesarias para el funcionamiento del editor wysiwyg
		$contenido = "";
		if($bloque_ft->texto){
			$contenido = $bloque_ft->texto;
//			$contenido = str_replace("'",'"', $contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,' ',$contenido);
			$contenido = str_replace('"','COMILLAS2CMS',$contenido);
		}

		$tipo_bloque = "foto_texto[$i][texto]";
		// Wysiwyg

		$path_imagenes = "imagenes_cont/".$_SESSION['sitio']['url']."/articulos/";
		$size = Fachada_contenido::ajustar_imagen($bloque_ft->foto, $path_imagenes);
        $ancho = $size['width'];
        $alto = $size['height'];

		// -----   Prueba del spaw editor
		//								SPAW_Wysiwyg(name, value, language, toolbar mode, theme, width, height);
		$array_estilos = '<? $demo_array = $spaw_dropdown_data;
		// unset current styles
		unset($demo_array["style"]);
		// set new styles
		'.$this->estilos_wysiwyg .'?>';	

		$instancia_wysiwyg = '<? $sw = new SPAW_Wysiwyg("'. $tipo_bloque .'" ,"'. addslashes($contenido) .'", "es", "sidetable", "default", "350px", "270px", "'. NOMBRE_HOST.CSS_SITEFILE . '", $demo_array);';
		$mostrar_wysiwyg = '$sw->show(); ?>';
		// ----- Fin prueba spaw editor
		
		$template_foto_texto = PATH_CONTENIDO . "vistas/templates/tpl_foto_texto.html";
		$contenido_foto_texto = addslashes(implode("\n",file($template_foto_texto))); 

        $template_opciones = fachada_contenido::opciones_articulo($tamanno,$i);
		$contenido_opciones = addslashes(implode("\n",file($template_opciones)));

		eval("\$contenido_HTML .= \"$contenido_foto_texto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");

	}// mostrar_bloque_foto_texto

    /**
 	 * Muestra un bloque tipo texto_foto para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $i posicion del bloque
	 * @param   string $contenido_HTML HTML del bloque
	 * @author  Maria Luisa Manyoma
 	 * @modify  Sonia Marcela Benavides <smbenavides@telesat.com.co>
     * @access  public
     */  
	function mostrar_bloque_texto_foto($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML){
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/pagina_" . $id_articulo . '.php'; 
		$bloque_tf = new Art_bloques_texto_fotos;
		$bloque_tf->id_objeto = $id_bloque;
		$bloque_tf->id_idioma = $id_idioma;
		if (!$bloque_tf->find(true))
			Fachada_Sistema::crear_version(&$bloque_tf, $id_idioma);
			
		//variables necesarias para el editor wysiwyg
		if($bloque_tf->texto){
			$contenido = $bloque_tf->texto;
//			$contenido = str_replace("'",'"', $contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,' ',$contenido);
			$contenido = str_replace('"','COMILLAS2CMS',$contenido);
		}
		$tipo_bloque = "texto_foto[$i][texto]";
		// Wysiwyg - lo usan los templates
			
		$path_imagenes = "imagenes_cont/".array_pop(explode('/',$_SESSION['sitio']['url']))."/articulos/";
		$size = Fachada_contenido::ajustar_imagen($bloque_tf->foto, $path_imagenes);
        $ancho = $size['width'];
        $alto = $size['height'];
		
		// -----   Prueba del spaw editor
		//								SPAW_Wysiwyg(name, value, language, toolbar mode, theme, width, height);
		$array_estilos = '<? 
		$demo_array = $spaw_dropdown_data;
		// unset current styles
		unset($demo_array["style"]);
		// set new styles
		'.$this->estilos_wysiwyg .'?>';		
		$instancia_wysiwyg = '<? $sw = new SPAW_Wysiwyg("'. $tipo_bloque .'" ,"'. $contenido .'", "es", "sidetable", "default", "350px", "270px", "'. NOMBRE_HOST.CSS_SITEFILE . '", $demo_array);';
		$mostrar_wysiwyg = '$sw->show(); ?>';
		// ----- Fin prueba spaw editor

		//include('src/contenido/vistas/templates/tpl_texto_foto.html');
		$template_texto_foto = PATH_CONTENIDO . "vistas/templates/tpl_texto_foto.html";
		$contenido_texto_foto = addslashes(implode("\n",file($template_texto_foto))); 

        $template_opciones = fachada_contenido::opciones_articulo($tamanno,$i);
		$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
		
		eval("\$contenido_HTML .= \"$contenido_texto_foto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}

    /**
 	 * Muestra un bloque tipo texto para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $i posicion del bloque
	 * @param   string $contenido_HTML HTML del bloque
	 * @author  Maria Luisa Manyoma
 	 * @modify  Sonia Marcela Benavides <smbenavides@telesat.com.co>
     * @access  public
     */  
	function mostrar_bloque_texto($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML){
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/pagina_" . $id_articulo . '.php'; 
		$bloque_t = new Art_bloques_textos;
		$bloque_t->id_objeto = $id_bloque;
		$bloque_t->id_idioma = $id_idioma;
		if (!$bloque_t->find(true))
			Fachada_Sistema::crear_version(&$bloque_t, $id_idioma);
		
		//variables necesarias para el editor wysiwyg

		if($bloque_t->texto1){
			$contenido = $bloque_t->texto1;
//			$contenido = str_replace("'",'"', $contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,' ',$contenido);
			$contenido = str_replace('"','COMILLAS2CMS',$contenido);
		}
		$tipo_bloque = "texto[$i][texto]";

		// -----   Prueba del spaw editor
		//								SPAW_Wysiwyg(name, value, language, toolbar mode, theme, width, height, stylesheet);
		$array_estilos = '<? 
		$demo_array = $spaw_dropdown_data;
		// unset current styles
		unset($demo_array["style"]);
		// set new styles
		'.$this->estilos_wysiwyg .'?>';		

		$instancia_wysiwyg = '<? $sw = new SPAW_Wysiwyg("'. $tipo_bloque .'" ,"'. addslashes( $contenido ) .'", "es", "sidetable", "default", "700px", "270px", "'. NOMBRE_HOST.CSS_SITEFILE . '", $demo_array);';
		$mostrar_wysiwyg = '$sw->show(); ?>';
		// ----- Fin prueba spaw editor

		$template_texto = PATH_CONTENIDO . "vistas/templates/tpl_texto.html";
		$contenido_texto = addslashes(implode("\n",file($template_texto))); 
		
        $template_opciones = fachada_contenido::opciones_articulo($tamanno,$i);
		$contenido_opciones = addslashes(implode("\n",file($template_opciones)));

		eval("\$contenido_HTML .= \"$contenido_texto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}

    /**
 	 * Muestra un bloque tipo tabla para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $i posicion del bloque
	 * @param   string $contenido_HTML HTML del bloque
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function mostrar_bloque_tabla($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML){
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/pagina_" . $id_articulo . '.php'; 
		$bloque_tabla = new Art_bloques_tablas;
		$bloque_tabla->id_objeto = $id_bloque;
		$bloque_tabla->id_idioma = $id_idioma;
		if (!$bloque_tabla->find(true))
			Fachada_Sistema::crear_version(&$bloque_tabla, $id_idioma);
		
		$nom_editor = "tbCE$i";
		$doc_complet = $nom_editor.'_doc_complet';
		$tipo_bloque = "tabla[$i][texto]";
		$ObjTableInfo = "ObjTableInfo$i";
		// Se incluye la variable del editor wysiwyg version 2.0
		$contador_editor = $i+1;
		//se incluye el editor wysiwyg
		$template_wysiwyg = PATH_CONTENIDO . "vistas/bloque_wysiwyg.html";
		$wysiwyg = addslashes(implode("\n",file($template_wysiwyg))); 
		eval("\$editor = \"$wysiwyg\"; ");
		//echo $editor;
		$template_texto = PATH_CONTENIDO . "vistas/templates/tpl_tabla.html";
		$contenido_texto = addslashes(implode("\n",file($template_texto))); 

        $template_opciones = fachada_contenido::opciones_articulo($tamanno,$i);
		$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
		
		eval("\$contenido_HTML .= \"$contenido_texto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}

    /**
 	 * Agrega un bloque de cualquier tipo a un articulo
     *
	 * @param   int $id_idioma identificador del idioma del articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $posicion posicion en la que se adicionara el bloque
	 * @param   string $tipo_bloque tipo del bloque a adicionar
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function insertar_bloque($id_idioma, $id_articulo, $posicion, $tipo_bloque){
		$bloques = new Art_bloques;
		$bloques->whereAdd("posicion > '$posicion'");
		$bloques->whereAdd("id_contenedor = '$id_articulo'");
		$bloques->orderBy('posicion ASC');
		$bloques->find();
		$i=0;
		
		// Guarda en un arreglo los bloques que estan en posicin superior al que se va a insertar
		while ($bloques->fetch()) {
        	 $bloques_array[$i] = array('id_bloque' => $bloques->id_objeto, 'tipo' => $bloques->tipo, 'posicion' => $bloques->posicion);	
			 $i++;
		}
		// si el bloque se inserta al final se suma uno a la ltima posicion
		if($bloques_array[0]['posicion'] == "")
			$bloques_array[0]['posicion'] = $posicion+1;
		// Insertar EL OBJETO bloque
		$bloques = new Art_bloques;
		$bloques->id_contenedor = $id_articulo;
		$bloques->posicion = $bloques_array[0]['posicion'];
		$bloques->tipo = $tipo_bloque;
		$id = $bloques->insert();
		
		$clase_bloque = 'Art_bloques_' . $tipo_bloque;
		if (!in_array($tipo_bloque, array('flash', 'imagenes')))
			$clase_bloque .= 's';
			
		$bloques_version = new $clase_bloque;
		$bloques_version->id_objeto = $id;
		$bloques_version->id_idioma = $id_idioma;
		// Inserta LA VERSION DEL OBJETO bloque dependiendo del tipo	
		switch ($tipo_bloque) {
			case "foto_texto": 
				$bloques_version->foto = 'foto1.gif';
			break;
			case "texto_foto": 
				$bloques_version->foto = 'foto1.gif';
			break;
			case "flash": 
				$bloques_version->flash = 'a_tip.swf';
				$bloques_version->ancho = '230';
				$bloques_version->alto = '50';
			break;
			case "imagenes": 
				$bloques_version->setfoto1('foto1.gif');
				$bloques_version->setfoto2('foto1.gif');
				$bloques_version->setfoto3('foto1.gif');
			break;
		}
		$bloques_version->insert();
		//actualizo de posicin los bloques
		for ($i = 0; $i < sizeof($bloques_array); $i++) { 
			if($i == sizeof($bloques_array)-1)
			   $nueva_posicion = $bloques_array[$i]['posicion']+1;
			else 
			   $nueva_posicion = $bloques_array[$i+1]['posicion'];
		   $id_objeto = $bloques_array[$i]['id_bloque'];
		   $bloques = new Art_bloques;
		   $bloques->get($id_objeto);
		   $bloques->posicion = $nueva_posicion;
		   $bloques->update();
		}
	}

    /**
 	 * Busca la ltima posicin de un articulo dentro de una categoria
     *
	 * @param   int $id_categoria identificador de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int posicion para el articuo dentro de la categoria
     */  
	function buscar_posicion($id_categoria){
		$articulo = new Art_Articulos;
		$sql = "SELECT posicion 
				FROM $articulo->__table 
				WHERE id_contenedor = $id_categoria ORDER BY posicion DESC";
		$articulo->query($sql);
		$articulo->fetch();
		return $articulo->posicion;
	}

    /**
 	 * Crea un articulo nuevo en el sitio
     *
	 * @param   int $id_categoria identificador de la categoria
	 * @param   string $nombre tipo del bloque a adicionar
	 * @param   string $descripcion tipo del bloque a adicionar
	 * @param   int $id_estilo posicion en la que se adicionara el bloque
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int identificador del articulo
     */  
	function crear_articulo($id_idioma, $autor, $id_categoria, $nombre, $descripcion, $id_estilo){
		// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		if ($nombre == '') $nombre = 'Nuevo Articulo';
		$path_sitio =  $_SESSION['sitio']['url'];
		$modulo = new Art_datos_modulos_articulos;
		$modulo->get("id_contenedor", $_SESSION['sitio']['id_objeto']);
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido))
			mkdir($dir_contenido, 0755);
		if (!file_exists($dir_contenido."/articulos")){
			mkdir($dir_contenido."/articulos", 0755);
		}
		// copiamos las imagenes por defecto en el directorio del sitio
		copy ("imagenes_cont/default/foto1.gif", $dir_contenido . "/articulos/foto1.gif");
		copy ("imagenes_cont/default/foto2.gif", $dir_contenido . "/articulos/foto2.gif");
		copy ("imagenes_cont/default/a_tip.swf", $dir_contenido . "/articulos/a_tip.swf");

		$posicion = fachada_contenido::buscar_posicion($id_categoria) + 1;
		
		$articulo = new Art_Articulos;
		$articulo->autor = $_SESSION['usuario']['nombre'];
		$articulo->id_contenedor = $id_categoria;
		$articulo->setid_modulo($modulo->getid_objeto());
		$articulo->id_estilo = $id_estilo;
		$articulo->posicion = $posicion;
		$articulo->fecha_publicacion = date("Y-m-d");
		$id_articulo = $articulo->insert();  
		
		$articulo_versiones = new Art_Articulos_versiones;
		$articulo_versiones->id_objeto = $id_articulo;
		$articulo_versiones->id_idioma = $id_idioma;
		$articulo_versiones->nombre = addslashes(strip_tags($nombre));
		$articulo_versiones->descripcion = addslashes( ereg_replace("\r\n","<br>",strip_tags($descripcion)) );
		$id_articulo_versiones = $articulo_versiones->insert();  
				
		Generar_contenido::generar_articulos($id_articulo);
		Generar_contenido::generar_categoria($id_categoria);

		//Escribe en el log
		if($id_articulo_versiones > 0)
			Util::log('Contenido', 'Crear Articulo', 'Se creo el articulo con exito');
		else 
			Util::log('Contenido', 'Crear Articulo', 'No se creo el articulo');

		
		return $id_articulo;
	}

    /**
 	 * Crear los bloque de contenido
     *
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $posicion posicion del bloque en el articulo
	 * @param   string $tipo tipo de blque
	 * @param   string $pie_foto texto pie de la foto 
	 * @param   string $alt alt de la imagen
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int identificador del bloque
     */  
	function crear_bloque($id_articulo, $posicion, $tipo){
		$bloque = new Art_bloques;
		$bloque->id_contenedor=$id_articulo;
		$bloque->posicion=$posicion;
		$bloque->tipo=$tipo;
		$id_bloque = $bloque->insert();
		
		return $id_bloque;
	}

    /**
 	 * Agrega un bloque de tipo foto_texto
     *
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $posicion identificador del articulo
	 * @param   int $idioma identificador del idioma
	 * @param   file $foto imagen del bloque
	 * @param   string $texto texto del articulo
	 * @param   string $pie_foto texto pie de la foto 
	 * @param   string $alt alt de la imagen
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function agregar_bloque_foto_texto($id_articulo, $posicion, $idioma, $foto, $texto, $pie_foto, $alt){
		$id_objeto = Fachada_contenido::crear_bloque($id_articulo, $posicion, 'foto_texto');
		$bloque = new Art_bloques_foto_textos;
		$bloque->id_objeto = $id_objeto;
		$bloque->id_idioma = $idioma;
		$bloque->foto = $foto;
		$bloque->texto = $texto;
		$bloque->pie_foto = $pie_foto;
		$bloque->alt = $alt;
		$id_bloque = $bloque->insert();
		return;
	}

    /**
 	 * Agrega un bloque de tipo texto_foto
     *
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $posicion identificador del articulo
	 * @param   int $idioma identificador del idioma
	 * @param   file $foto imagen del bloque
	 * @param   string $texto texto del articulo
	 * @param   string $pie_foto texto pie de la foto 
	 * @param   string $alt alt de la imagen
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function agregar_bloque_texto_foto($id_articulo, $posicion, $idioma, $foto, $texto, $pie_foto, $alt){
		$id_objeto = Fachada_contenido::crear_bloque($id_articulo, $posicion, 'texto_foto');
		$bloque = new Art_bloques_texto_fotos;
		$bloque->id_objeto = $id_objeto;
		$bloque->id_idioma = $idioma;
		$bloque->foto = $foto;
		$bloque->texto = $texto;
		$bloque->pie_foto = $pie_foto;
		$bloque->alt = $alt;
		$id_bloque = $bloque->insert();
		return;
	}

    /**
 	 * Agrega un bloque de tipo texto
     *
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $posicion identificador del articulo
	 * @param   int $idioma identificador del idioma
	 * @param   string $texto1 texto del articulo
	 * @param   string $texto2 texto del articulo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function agregar_bloque_texto($id_articulo, $posicion, $idioma, $texto1, $texto2){
		$id_objeto = Fachada_contenido::crear_bloque($id_articulo, $posicion, 'texto');
		$bloque = new Art_bloques_textos;
		$bloque->id_objeto = $id_objeto;
		$bloque->id_idioma = $idioma;
		$bloque->tipo = "texto";
		$bloque->texto1 = $texto1;
		$bloque->texto2 = $texto2;
		$id_bloque = $bloque->insert();
		return;
	}

    /**
 	 * Agrega un bloque de tipo archivo
     *
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $posicion identificador del articulo
	 * @param   int $idioma identificador del idioma
	 * @param   string $nombre nombre del enlace del archivo
	 * @param   file $archivo archivo a subir
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int identificador del bloque
     */  
	function agregar_bloque_archivo($id_articulo, $posicion, $idioma, $nombre, $archivo){
		$id_objeto = Fachada_contenido::crear_bloque($id_articulo, $posicion, 'archivo');
		$bloque = new Art_bloques_archivos;
		$bloque->id_objeto = $id_objeto;
		$bloque->id_idioma = $idioma;
		$bloque->archivo = $archivo;
		$id_bloque = $bloque->insert();
        return $id_bloque;
	}

    /**
 	 * Baja un bloque de cualquier tipo
     *
	 * @param   int $id_contenedor identificador del articulo
	 * @param   int $id_objeto identificador del bloque
	 * @param   int $idioma identificador del idioma
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function bajar_bloque($id_objeto, $id_contenedor){
		$bloque = new Art_bloques;
		
		$bloque->get($id_objeto);
        $posicion_actual = $bloque->posicion;
		$id_objeto = $bloque->id_objeto;
		
		$sql = "SELECT id_objeto, posicion 
						FROM $bloque->__table 
						WHERE posicion > $bloque->posicion AND id_contenedor = $id_contenedor ORDER BY posicion ASC";
		$bloque->query($sql);
		$bloque->fetch();
        $posicion_nueva = $bloque->posicion;
		$id_otro_bloque= $bloque->id_objeto;
		$bloque->get($id_objeto);		
		$bloque->posicion = $posicion_nueva;
		$bloque->update();    
		$bloque = new Art_bloques;
		$bloque->get($id_otro_bloque);
		$bloque->posicion = $posicion_actual;
		$bloque->update();    
		return;
	}

    /**
 	 * Sube bloque de cualquier tipo
     *
	 * @param   int $id_contenedor identificador del articulo
	 * @param   int $id_objeto identificador del bloque
	 * @param   int $idioma identificador del idioma
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function subir_bloque($id_objeto, $id_contenedor){
		$bloque = new Art_bloques;
		
		$bloque->get($id_objeto);
        $posicion_actual = $bloque->posicion;
		$id_objeto= $bloque->id_objeto;
		
		$sql = "SELECT id_objeto, posicion 
				FROM $bloque->__table 
				WHERE posicion < $bloque->posicion AND id_contenedor = $id_contenedor ORDER BY posicion DESC";
		$bloque->query($sql);
 
		$bloque->fetch();
        $posicion_nueva = $bloque->posicion;
		$id_otro_bloque= $bloque->id_objeto;
		$bloque->get($id_objeto);		
		$bloque->posicion = $posicion_nueva;
		$bloque->update();    
		$bloque = new Art_bloques;
		$bloque->get($id_otro_bloque);
		$bloque->posicion = $posicion_actual;
		$bloque->update();    
		return;
	}

    /**
 	 * Quita bloque de cualquier tipo
     *
	 * @param   int $id_bloque identificador del bloque
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function quitar_bloque($id_bloque){
		$bloque = new Art_bloques;
		$bloque->get("id_objeto", $id_bloque);
		$clase_bloque = 'Art_bloques_' . $bloque->tipo;
		if (!in_array($bloque->tipo, array('flash', 'imagenes')))
			$clase_bloque .= 's';
		$bloques_version = new $clase_bloque;
		$bloques_version->get("id_objeto", $id_bloque);
		$bloques_version->delete();
		$bloque->delete();

		//Escribe en el log
		Util::log('Contenido', 'Eliminar bloque', 'Se elimino el bloque con exito');
 

		return;
	}

    /**
 	 * Cambia el articulo de estado a publicado
     *
	 * @param   int $id_articulo identificador del articulo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function activar_articulo($id_articulo){
		$articulo = new Art_Articulos;
		$articulo->query("UPDATE  art_articulos 
						  SET publicado=TRUE 
						  WHERE id_objeto=$id_articulo");
		return;
	}

    /**
 	 * Cambia el articulo de estado a no publicado
     *
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $idioma identificador del idioma
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function desactivar_articulo($id_articulo){
		$articulo = new Art_Articulos;
		$articulo->query("UPDATE  art_articulos 
						  SET publicado=FALSE 
						  WHERE id_objeto=$id_articulo");
		return;
	}

    /**
 	 * Lista los articulos de una categoria
     *
	 * @param   int $id_contenedor identificador de la categoria
	 * @param   int $id_idioma identificador del idioma
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function listar_articulos($id_idioma, $id_contenedor){
		$categoria = new Art_categorias_articulos_versiones;
		$categoria->whereAdd("id_objeto = '$id_contenedor'");
		$categoria->whereAdd("id_idioma = '$id_idioma'");
		$categoria->find(true);
		$arreglo = array();
		$articulo = new Art_articulos;
		$articulo->whereAdd("id_contenedor = '$id_contenedor'"); 
		$articulo->orderBy("posicion ASC");
		$articulo->find();
		while ($articulo->fetch()) {
			$articulo_versiones = new Art_articulos_versiones;
			$articulo_versiones->id_idioma = $id_idioma;
			$articulo_versiones->joinAdd($articulo); 
			if (!$articulo_versiones->find(true))
				Fachada_Sistema::crear_version(&$articulo_versiones, $_SESSION['sis_idioma']['id_idioma']);
			if($articulo_versiones->nombre == "")
                 $nombre_articulo = $articulo_versiones->nombre_menu;
			else
				 $nombre_articulo = $articulo_versiones->nombre;
	    	/* almacenamos en el arreglo slo los campos que necesitamos */
			if(sizeof($arreglo) == 0)
				$arreglo = Array(Array("id_objeto" =>  $articulo->id_objeto, 
									   "nombre" => $nombre_articulo, 
									   "nombre_categoria" => $categoria->nombre, 
									   "fecha_publicacion" => $articulo->fecha_publicacion,
									   "id_contenedor" => $articulo->id_contenedor));
			else
				array_push($arreglo, Array("id_objeto" =>  $articulo->id_objeto, 
										   "nombre" => $nombre_articulo, 
										   "nombre_categoria" => $categoria->nombre, 
										   "fecha_publicacion" => $articulo->fecha_publicacion,
									   	   "id_contenedor" => $articulo->id_contenedor));
		}
		$_SESSION['arreglo_articulos'] = $arreglo;
		return; 
	}

    /**
 	 * Lista las categorias del sitio
     *
	 * @param   int $id_contenedor identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function listar_categorias($id_sitio){
		$categoria = new Art_categorias_articulos;
		$categoria_versiones = new Art_categorias_articulos_versiones;
		$query = "SELECT cat.id_objeto , ver.nombre
				  FROM {$categoria->__table} cat, art_datos_modulos_articulos dat, {$categoria_versiones->__table} ver
				  WHERE cat.id_contenedor = dat.id_objeto AND cat.id_objeto=ver.id_objeto
				  AND dat.id_contenedor = '$id_sitio' "; 
		$categoria->query($query);
		$arreglo = array();
		while ($categoria->fetch()) {
	    	/* almacenamos en el arreglo slo los campos que necesitamos */
			if(sizeof($arreglo) == 0)
				$arreglo = Array(Array("id_objeto" =>  $categoria->id_objeto, 
									   "nombre" => $categoria->nombre));
			else
				array_push($arreglo, Array("id_objeto" =>  $categoria->id_objeto, 
										   "nombre" => $categoria->nombre));
		}		
		$_SESSION['arreglo_categorias']=$arreglo;
		return; 
	}

    /**
 	 * Crea una nueva categoria de contenido
     *
	 * @param   int $id_idioma identificador del idioma
	 * @param   string $nombre nombre de la categoria
	 * @param   string $descripcion descripcion de la categoria
	 * @param   int $id_contenedor identificador del datos modulo articulo
	 * @param   int $id_estilo identificador del estilo de la categoria
	 * @param   int $padre identificador de la categoria padre
	 * @param   int $id_plantilla_resumen identificador de la plantilla resumen de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int identificador de la categoria
     */  
	function crear_categoria($id_idioma, $nombre, $descripcion, $id_modulo, $id_estilo, $padre, $id_plantilla_resumen){
		$categoria = new Art_categorias_articulos;
		$categoria->id_contenedor = $padre;
		$categoria->id_estilo = $id_estilo;
		$categoria->id_categoria_padre = $padre;
		$categoria->id_plantilla = $id_plantilla_resumen;
		$categoria->id_modulo = $id_modulo;
		$id = $categoria->insert();
		$categoria_version = new Art_categorias_articulos_versiones;
		$categoria_version->id_objeto = $id;
		$categoria_version->id_idioma = $id_idioma;
		$categoria_version->nombre = $nombre;
		$categoria_version->descripcion = $descripcion;
		$id_categoria_version = $categoria_version->insert();

		//Escribe en el log
		if($id > 0 and $id_categoria_version > 0)
			Util::log('Contenido', 'Crear Categoria', 'Se creo la categoria con exito');
		else
			Util::log('Contenido', 'Crear Categoria', 'No se creo la categoria');

		
		Generar_contenido::generar_categoria($id);
		Generar_contenido::generar_categoria($padre);
		
		return $id; 
	}

    /**
 	 * Verifica los limites de una categoria 
     *
	 * @param   int $id_sitio identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int $indicador 1 si no ha llegado al limite 0 en caso contrario
     */  
	function verificar_limite_categorias($id_sitio){
		$categorias = new Art_categorias_articulos;
		$total_categorias = $categorias->count();
		//print_r($total); exit();
		$datos = new Art_datos_modulos_articulos;
		$datos->get("id_contenedor", $id_sitio);
		if($total_categorias < ($datos->limite_categorias + 1))
			return 1;
		else
			return 0;
	}

    /**
 	 * Verifica los limites de un articulo
     *
	 * @param   int $id_sitio identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int $indicador 1 si no ha llegado al limite 0 en caso contrario
     */  
	function verificar_limite_articulos($id_sitio){
		$articulos = new Art_articulos;
		$total_articulos = $articulos->count();
		$datos = new Art_datos_modulos_articulos;
		$datos->get("id_contenedor", $id_sitio);
		if($total_articulos < $datos->limite_articulos)
			return 1;
		else
			return 0;
	}


    /**
 	 * Modifica una  categoria de contenido
     *
	 * @param   int $id_idioma identificador del idioma
	 * @param   string $nombre nombre de la categoria
	 * @param   string $descripcion descripcion de la categoria
	 * @param   int $id_categoria identificador de la categoria
	 * @param   int $id_contenedor identificador del datos modulo articulo
	 * @param   int $id_estilo identificador del estilo de la categoria
	 * @param   int $padre identificador de la categoria padre
	 * @param   int $id_plantilla_resumen identificador de la plantilla resumen de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function modificar_categoria($id_idioma, $id_categoria_contenido, $nombre, $descripcion, $id_contenedor, $id_estilo, $padre, $id_plantilla_resumen, $publico, $id_menu){
		$categoria_versiones = new Art_categorias_articulos_versiones;
		$categoria_versiones->whereAdd("id_objeto = '$id_categoria_contenido'");
		$categoria_versiones->whereAdd("id_idioma = '$id_idioma'");
		$categoria_versiones->nombre = $nombre;
		$categoria_versiones->descripcion = $descripcion;
		$categoria_versiones->update();
		$categoria = new Art_categorias_articulos;
		$categoria->get($id_categoria_contenido);
		$categoria->id_plantilla = $id_plantilla_resumen;
		$categoria->publico = $publico;
		$categoria->id_menu = $id_menu;
		$bandera = $categoria->update(); 

		//Escribe en el log
		if($bandera > 0)
			Util::log('Contenido', 'Modificar Categoria', 'Se modifico la categoria con exito');
		else
			Util::log('Contenido', 'Modificar Categoria', 'No se modifico la categoria');
		
		Generar_contenido::generar_categoria($id_categoria_contenido);
		Generar_contenido::generar_categoria($categoria->id_contenedor);
		return; 
	}


    /**
 	 * muestra una categoria de contenido para modificacin
	 * @param   int $id_idioma identificador del idioma actual del sitio
	 * @param   int $id_contenedor identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function ver_categoria($id_idioma, $id_categoria){
		$categoria_versiones = new Art_categorias_articulos_versiones;
		$categoria = new Art_categorias_articulos;
		$categoria_versiones->id_objeto = $id_categoria; 
		$categoria_versiones->id_idioma = $id_idioma;
		$categoria->joinAdd($categoria_versiones); 
		$categoria->find();
		$categoria->fetch();
   		$detalle_categoria = Array("id_objeto" =>  $categoria->id_objeto, 
							       "nombre" => $categoria->nombre,
							       "publico" => $categoria->publico,
							       "descripcion" => $categoria->descripcion,
							   	   "id_categoria_padre" => $categoria->id_categoria_padre,
			    				   "id_plantilla_resumen" => $categoria->id_plantilla);
		$_SESSION['detalle_categoria'] = $detalle_categoria;
		return; 
	}

    /**
 	 * Lista las plantillas para las categorias
     *
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function listar_plantillas(){
		$plantillas = new Art_plantillas_categorias;
		$arreglo = array();
		$query = "SELECT * 
				  FROM art_plantillas_categorias";
		$plantillas->query($query);
		while ($plantillas->fetch()) {
	    	/* almacenamos en el arreglo slo los campos que necesitamos */
			if(sizeof($arreglo) == 0)
				$arreglo = Array(Array("id_plantilla" =>  $plantillas->id_plantilla, 
									   "tipo" => $plantillas->tipo,
									   "imagen" => $plantillas->imagen));
			else
				array_push($arreglo, Array("id_plantilla" =>  $plantillas->id_plantilla, 
									       "tipo" => $plantillas->tipo,
									       "imagen" => $plantillas->imagen));
		}		
		$_SESSION['arreglo_plantillas']=$arreglo;
		return; 
	}
	
	/**
 	 * Obtiene el contendor de una categoria
	 *
     * @param   int $id_sitio Identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int identificador del datos modulos del sitio
     */  
	function traer_contenedor($id_sitio)
	{
		$datos_modulo = new Art_datos_modulos_articulos;
		$query = "SELECT id_objeto 
				  FROM {$datos_modulo->__table} 
				  WHERE id_contenedor = '$id_sitio' "; 
		$datos_modulo->query($query);
		$datos_modulo->fetch();
		
		return $datos_modulo->id_objeto;
	}
	/**
 	 * Obtiene la categoria contenido del sitio
	 *
     * @param   int $id_sitio Identificador del sitio
	 * @author  John Vargas
     * @access  public
	 * @return  int identificador de la categoria
     */  
	function traer_categoria_articulo($id_sitio)
	{
		$categoria = new Art_categorias_articulos;
		$query = "SELECT cat.* 
				  FROM {$categoria->__table} cat, art_datos_modulos_articulos dat
				  WHERE cat.id_contenedor = dat.id_objeto
				  AND dat.id_contenedor = '$id_sitio' AND cat.id_categoria_padre != '1'"; 
		//echo $query;
		$categoria->query($query);
		$categoria->fetch();
		
		return $categoria->id_objeto;
	}
	/**
 	 * Devuelve el nombre de un articulo
	 *
     * @param   int $id_articulo Identificador del articulo
	 * @author  John Vargas
     * @access  public
	 * @return  string nombre del articulo
     */   
	function traer_nombre_articulo($id_articulo)
	{
		$articulo = new Art_articulos;
		$articulo->get($id_articulo);
		return $articulo->nombre;
	}
	/**
 	 * Lista los articulos de una categoria
	 *
     * @param   int $id_categoria Identificador de la categoria del articulo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */   
	function listar_resumen_articulo($id_categoria){
		$articulo = new Art_articulos;
		$sql = "SELECT *
				FROM $articulo->__table 
				WHERE id_contenedor='$id_categoria' and publicado='TRUE' order by id_objeto DESC";
		$articulo->query($sql);
		while ($articulo->fetch()) {
	    	/* almacenamos en el arreglo slo los campos que necesitamos */
			if(sizeof($arreglo) == 0)
				$arreglo = Array(Array("id_objeto" =>  $articulo->id_objeto, 
									   "nombre" => $articulo->nombre_menu, 
									   "descripcion" => $articulo->descripcion,
									   "id_categoria" => $id_categoria));
			else
				array_push($arreglo, Array("id_objeto" =>  $articulo->id_objeto, 
										   "nombre" => $articulo->nombre_menu, 
										   "descripcion" => $articulo->descripcion,
										   "id_categoria" => $id_categoria));
		}
		$_SESSION['arreglo_articulos']=$arreglo;
	}

    /**
 	 * Baja un articulo de posicin de cualquier tipo
     *
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_categoria identificador del contenedor
	 * @author  Maria Luisa Manyoma
     * @access  public
    */  
	function bajar_articulo($id_articulo, $id_categoria){
		$articulo = new Art_articulos;
		
		$articulo->get($id_articulo);
        $posicion_actual = $articulo->posicion;
		$id_articulo = $articulo->id_objeto;
		
		$sql = "SELECT id_objeto, posicion 
				FROM $articulo->__table 
				WHERE posicion > $articulo->posicion AND id_contenedor = $id_categoria ORDER BY posicion ASC";
		$articulo->query($sql);
		$articulo->fetch();
        $posicion_nueva = $articulo->posicion;
		$id_otro_articulo = $articulo->id_objeto;
		$articulo->get($id_articulo);		
		$articulo->posicion = $posicion_nueva;
		$articulo->update();    
		$articulo = new Art_articulos;
		$articulo->get($id_otro_articulo);
		$articulo->posicion = $posicion_actual;
		$articulo->update();    
		return;
	}

    /**
 	 * Sube un articulo de posicion
     *
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_categoria identificador del contenor 
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function subir_articulo($id_articulo, $id_categoria){
		$articulo = new Art_articulos;
		
		$articulo->get($id_articulo);
        $posicion_actual = $articulo->posicion;
		$id_articulo = $articulo->id_objeto;
		
		$sql = "SELECT id_objeto, posicion 
				FROM $articulo->__table 
				WHERE posicion < $articulo->posicion AND id_contenedor = $id_categoria ORDER BY posicion DESC";
		$articulo->query($sql);
		$articulo->fetch();
        $posicion_nueva = $articulo->posicion;
		$id_otro_articulo = $articulo->id_objeto;
		$articulo->get($id_articulo);		
		$articulo->posicion = $posicion_nueva;
		$articulo->update();    
		$articulo = new Art_articulos;
		$articulo->get($id_otro_articulo);
		$articulo->posicion = $posicion_actual;
		$articulo->update();    
		return;
	}

    /**
 	 * Busca un articulo dado unos criterios de busqueda
     *
	 * @param   int $id_categoria identificador del contenedor del articulo
	 * @param   int $titulo titulo del articulo
	 * @param   int $resumen resumen del articulo
	 * @param   int $mes mes de creacin del articulo
	 * @param   int $anno ao de creacin del articulo
	 * @param   int $id_idioma Idioma en que se esta administrando
	 * @param   int $id_usuario Usuario que esta logeado en el sistema
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function buscar_articulos($titulo, $autor, $mes, $anno, $id_idioma, $id_usuario){
		$articulo = new Art_articulos;
		$articulo_versiones = new Art_articulos_versiones;
		$articulo_versiones->setid_idioma($id_idioma);
		$articulo->joinAdd($articulo_versiones); 
		if ($titulo){
			$titulo = "'%".$titulo."%'";
			$articulo->whereAdd("LOWER(nombre) LIKE LOWER($titulo)");
			$articulo->whereAdd("LOWER(nombre) LIKE LOWER($titulo)", "OR");
		}
		if ($autor){
			$autor = "'%".$autor."%'";
			$articulo->whereAdd("LOWER(autor) LIKE LOWER($autor)");
		}
		if ($mes)
			$articulo->whereAdd("Date_Part('Month', fecha_publicacion) = '$mes'");
		if ($anno)	
			$articulo->whereAdd("Date_Part('Year', fecha_publicacion) = '$anno'");
		$articulo->find();
		//print_r($articulo);
		$arreglo = array();
		while ($articulo->fetch()) {
			if($articulo->nombre == "")
                 $nombre_articulo = $articulo->nombre_menu;
			else
				 $nombre_articulo = $articulo->nombre;
	    	/* almacenamos en el arreglo slo los campos que necesitamos */
			if (Fachada_Sistema::chequear_permiso($id_usuario, $articulo->id_objeto, ALIMENTAR))
				array_push($arreglo, array("id_objeto" =>  $articulo->id_objeto, 
										   "nombre" => $nombre_articulo, 
										   "autor" => $articulo->autor, 
										   "fecha_publicacion" => $articulo->fecha_publicacion,
									   	   "id_contenedor" => $articulo->id_contenedor));
		}
		if(sizeof($arreglo) == 0)
			$_SESSION['mensaje'] = "Ninguna pgina concuerda con los criterios de bsqueda indicados ";
		else
			$_SESSION['arreglo_articulos'] = $arreglo;
		return; 
	}

    /**
 	 * Borra un articulo dado el identificador
     *
	 * @param   int $id_articulo identificador del articulo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function borrar_articulos($id_articulo){
        $bloques = new Art_bloques;
		$bloques->whereAdd("id_contenedor = '$id_articulo'");
		$bloques->find();
		while ($bloques->fetch()) {
			Fachada_contenido::quitar_bloque($bloques->id_objeto);
		}
		$articulo_versiones = new Art_articulos_versiones;
		$articulo_versiones->get('id_objeto', $id_articulo);
		$articulo_versiones->delete();
		$articulo = new Art_articulos;
		$articulo->get($id_articulo);
		$articulo->delete();
		
		Generar_contenido::generar_categoria($articulo->id_contenedor);
	}
	/**
     * Crea un nuevo usuario de contenido (Editor / Alimentador)
     *
     * @param string $nombre
     * @param string $apellido1
     * @param string $apellido2
     * @param string $email
     * @param int $telefono1
     * @param int $telefono2
     * @param int $celular
     * @param string $id_ciudad
     * @param string $id_pais
     * @param string $login
     * @param string $contrasena
     * @param string $pregunta
     * @param string $respuesta
	 * @author  Maria Luisa Manyoma
     * @access  public
     */
    function crear_usuario ($nombre, $apellido1, $apellido2, $email, $telefono1, $telefono2, $celular, 
							$login, $password, $pregunta, $respuesta, $id_sitio, $tipo){
			
        // Creacin del usuario 
        $usuario = new Sis_usuarios;
		$usuario->nombre = $login;
		$usuario->password = md5($password);
		$usuario->pregunta = $pregunta;
		$usuario->respuesta = $respuesta;
        
        $contacto = new Sis_contactos;
        
        $contacto->nombre = $nombre;
        $contacto->apellido1 = $apellido1;
        $contacto->apellido2 = $apellido2;
        $contacto->email = $email;
        $contacto->telefono1 = $telefono1;
        $contacto->telefono2 = $telefono2;
        $contacto->celular = $celular;
		$datos_contactos = new Cnt_datos_modulos_contactos;
		$datos_contactos->get("id_contenedor",$id_sitio);
		
        $contacto->id_datos_modulos = $datos_contactos->id_objeto;       
        $id_contacto = $contacto->insert();
        	
        $usuario->id_contacto = $id_contacto;
        $usuario->id_contenedor = $id_sitio;
        $id_usuario = $usuario->insert();
        $rol = new Sis_roles;
		$rol->tipo = $tipo;
		$rol->escribir = "TRUE";
		if($tipo == Editor)
	        $rol->publicar = "TRUE";
		else 
			$rol->publicar = "FALSE";
        $rol->id_usuario = $id_usuario;
        $id_rol = $rol->insert();
        if ($id > 0) $_SESSION['usuario'] = $usuario->toArray();
        return ($id > 0);
    }
    

    /**
 	 * Busca un usario dado unos criterios de busqueda
     *
	 * @param   string $nombre nombre del usuario
	 * @param   string $apellido apellido del usuario
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function buscar_usuarios($nombre, $apellido){
		$contacto = new Sis_contactos;
		$cadena = "";
		$inicio='1';
		if ($nombre != ""){
			if ($inicio == '1'){
    			 $cadena=$cadena." LOWER(nombre) LIKE LOWER("."'%".$nombre."%')" ;
   			 	 $inicio='0';
            }
   			else{
    			 $cadena=$cadena." AND LOWER(nombre) LIKE LOWER("."'%".$nombre."%')" ;
   			}
        }
   		if ($apellido != "")
		{
		    if ($inicio == '1'){
				$cadena.=" LOWER(apellido1) LIKE LOWER("."'%".$apellido."%')" ;
				$inicio='0';
            } 
			else{
    			 $cadena.=" AND LOWER(apellido1) LIKE LOWER("."'%".$apellido."%')" ;
			}	
   		}
		if($cadena != ""){
			$query = "SELECT id_contacto, nombre, apellido1 
					  FROM sis_contactos  
				  	  WHERE $cadena "; 
		}
		else {
			$query = "SELECT id_contacto, nombre, apellido1 
					  FROM sis_contactos ";
		}
		//print_r($query);
	
		$contacto->query($query);
		while ($contacto->fetch()) {
	    	/* almacenamos en el arreglo slo los campos que necesitamos */
			if(sizeof($arreglo_usuarios) == 0)
				$arreglo_usuarios = Array(Array("id_objeto" =>  $contacto->id_contacto, 
									   "nombre" => $contacto->nombre, 
									   "apellido" => $contacto->apellido1));
			else
				array_push($arreglo_usuarios, Array("id_objeto" =>  $contacto->id_contacto, 
										   "nombre" => $contacto->nombre, 
										   "apellido" => $contacto->apellido1));
		}
		$_SESSION['arreglo_usuarios']=$arreglo_usuarios;
		return; 
	}
	/**
     * Lista todos los usuarios dependiendo del tipo
     *
     * @param string $tipo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */
    function listar_usuarios (){
		$usuarios = new Sis_usuarios;
		$roles = new Sis_roles;
		$query = "SELECT DISTINCT {$usuarios->__table}.id_objeto, {$usuarios->__table}.nombre
				  FROM {$usuarios->__table} , {$roles->__table}
				  WHERE {$usuarios->__table}.id_objeto = {$roles->__table}.id_usuario AND ({$roles->__table}.tipo = 'Alimentador' or {$roles->__table}.tipo = 'Editor')"; 
		$usuarios->query($query);
		while ($usuarios->fetch()) {
			if(sizeof($arreglo_usuarios) == 0)
				$arreglo_usuarios = Array(Array("id_objeto" =>  $usuarios->id_objeto, 
									   "nombre" => $usuarios->nombre));
			else
				array_push($arreglo_usuarios, Array("id_objeto" =>  $usuarios->id_objeto,
										   "nombre" => $usuarios->nombre));
		}
		$_SESSION['arreglo_usuarios']=$arreglo_usuarios;
		//print_r($_SESSION['arreglo_usuarios']);
		return; 
	}
	/**
     * Guarda el rol de usuarios de contenido
     *
     * @param string $id_categoria_contenido identificador de la categoria a la cual se le asigna el permiso
     * @param array $arreglo_alimentador arreglo con los alimentadores que tienen permiso sobre la categoria
     * @param array $arreglo_editor arreglo con los editores que tienen permiso sobre la categoria
     * @param int cantidad cantidad tamao del arreglo alimentador y editor
	 * @author  Maria Luisa Manyoma
     * @access  public
     */
    function guardar_rol($id_categoria_contenido, $arreglo_alimentador, $arreglo_editor, $cantidad){
		$roles = new Sis_roles;
		for($j = 0; $j < $cantidad; $j++){
	
		   if($arreglo_alimentador[$j]['id_usuario'] != ''){
			$roles->tipo = 'Alimentador';
			$roles->id_usuario = $arreglo_alimentador[$j]['id_usuario'];
			$roles->id_objeto = $id_categoria_contenido;
			$id = $roles->insert();
		   }
		   if($arreglo_editor[$j]['id_usuario'] != ''){
			$roles->tipo = 'Editor';
			$roles->id_usuario = $arreglo_editor[$j]['id_usuario'];
			$roles->id_objeto = $id_categoria_contenido;
			$id = $roles->insert();
		   }
		}
		return;
	}
	/**
     * Muestra un usuario dado el identificador del usuario
     *
     * @param int id_usuario identificador del usuario
	 * @author  Maria Luisa Manyoma
     * @access  public
     */
    function ver_usuario($id_usuario){
		$usuario = new Sis_usuarios;
		$contacto = new Sis_contactos;
		$query = "SELECT * 
				  FROM sis_usuarios usu, sis_contactos con 
				  WHERE con.id_contacto = usu.id_contacto and usu.id_contacto = '$id_usuario' "; 
		$usuario->query($query);
		$usuario->fetch();
	  
	  	/* almacenamos en el arreglo slo los campos que necesitamos */
		$datos_usuario = Array("id_objeto" =>  $usuario->id_objeto, 
							   "id_contacto" =>  $usuario->id_contacto, 
							   "login" => $usuario->nombre, 
							   "password" => $usuario->password, 
							   "pregunta" => $usuario->pregunta, 
							   "respuesta" => $usuario->respuesta, 
							   "nombre" => $usuario->nombre, 
							   "apellido1" => $usuario->apellido1, 
							   "apellido2" => $usuario->apellido2, 
							   "email" => $usuario->email, 
							   "tel_residencia" => $usuario->telefono1, 
							   "tel_contacto" => $usuario->telefono2, 
							   "celular" => $usuario->celular); 
		$_SESSION['datos_usuario']=$datos_usuario;
	    return; 
	}
	/**
     * Modifica un usuario de contenido
     *
     * @param string $nombre
     * @param string $apellido1
     * @param string $apellido2
     * @param string $email
     * @param int $telefono1
     * @param int $telefono2
     * @param int $celular
     * @param string $contrasena
     * @param string $pregunta
     * @param string $respuesta
	 * @author  Maria Luisa Manyoma
     * @access  public
     */
    function modificar_usuario ($id_usuario, $id_contacto, $nombre, $apellido1, $apellido2, $email, $tel_residencia, $tel_contacto, $celular, 
							    $login, $password, $pregunta, $respuesta, $id_sitio){
        // Creacin del usuario 
        $usuario = new Sis_usuarios;
		$usuario->get($id_usuario);
		//$usuario->nombre = $login;
		$usuario->password = md5($password);
		$usuario->pregunta = $pregunta;
		$usuario->respuesta = $respuesta;
		$usuario->update();     
     
        $contacto = new Sis_contactos;  
		$contacto->get($id_contacto);
        $contacto->nombre = $nombre;
        $contacto->apellido1 = $apellido1;
        $contacto->apellido2 = $apellido2;
        $contacto->email = $email;
        $contacto->telefono1 = $tel_residencia;
        $contacto->telefono2 = $tel_contacto;
        $contacto->celular = $celular;
        $contacto->update();
		
        return ;
    }

    /**
 	 * Obtiene la categoria raiz de un sitio
     *
     * @param   int $id_sitio Identificador del sitio al cual se le obtendra la categoria
	 * @author  John Vargas
     * @access  public
     * @return  int identificador de la categoria raiz
     */   		
	function obtener_categoria_raiz($id_sitio)
	{
		$categoria = new Art_categorias_articulos;
		$datos = new Art_datos_modulos_articulos;
		$datos->get("id_contenedor", $id_sitio); print_r($datos);
		$categoria->whereAdd("id_modulo = '{$datos->id_objeto}'");
		$categoria->whereAdd("id_contenedor = id_modulo");
		$categoria->find(true);
		print_r($categoria);
		
		return ($categoria->N) ? $categoria->id_objeto : 0;
	}

    /**
 	 * verifica si existen articulos en una categoria
     *
     * @param   int $id_categoria Identificador de la categoria a eliminar
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int numero de articulos en la categoria
     */   		
	function verificar_articulos($id_categoria)
	{
		$articulos = new Art_articulos;
		$articulos->whereAdd("id_contenedor = '$id_categoria'");
		$total_articulos = $articulos->count();
		return $total_articulos;
	}

    /**
 	 * verifica si una categoria tiene subcategorias
     *
     * @param   int $id_categoria Identificador de la categoria a eliminar
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int numero de subcategorias en la categoria
     */   		
	function verificar_categorias($id_categoria)
	{
		$categorias = new Art_categorias_articulos;
		$categorias->whereAdd("id_contenedor = '$id_categoria'");
		$total_categorias = $categorias->count();
		return $total_categorias;
	}

    /**
 	 * Elimina una categoria de contenido
     *
     * @param   int $id_categoria Identificador de la categoria a eliminar
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  1 si se pudo eliminar 0 en caso contrario
     */   		
	function eliminar_categoria($id_categoria)
	{
        if(Fachada_contenido::verificar_articulos($id_categoria) == 0 AND Fachada_contenido::verificar_categorias($id_categoria) == 0){
			$categoria_versiones = new Art_categorias_articulos_versiones;
			$categoria_versiones->get('id_objeto', $id_categoria);
			$bandera1 = $categoria_versiones->delete();
	
			$categoria = new Art_categorias_articulos;
			$categoria->get($id_categoria);
			$bandera2 = $categoria->delete();
			Generar_contenido::generar_categoria($categoria->id_contenedor);
        }
		else 
			return 0;

		//Escribe en el log
		if($bandera1 > 0 and $bandera2 > 0)
			Util::log('Contenido', 'Eliminar Categoria', 'Se elimino la categoria con exito');
		else
			Util::log('Contenido', 'Eliminar Categoria', 'No se elimino la categoria');

		return 1;
	}

    /**
 	 * Da el url de un articulo dado el id del articulo
     *
     * @param   int $id_articulo Identificador del articulo
	 *          int $id_idioma  Identificador del idioma
	 * @return string Url del articulo
	 * @author  John A. Vargas
     * @access  public
     * @return  string url del articulo
	 * @static
     */   
	function url_articulo($id_articulo, $id_idioma)
	{
		$articulo = new Art_articulos_versiones;
		$articulo->setid_objeto($id_articulo);
		$articulo->setid_idioma($id_idioma);
		
		$articulo->find(true);
		
		$url = 'index.php?view=src/contenido/vistas/opciones_articulo.php&id_articulo=';
		$url .= $articulo->getid_objeto();
		$url .= '&nombre_articulo=' . $articulo->getnombre();
		
		return $url;
	}

    /**
 	 * Define que template de opciones poner debajo de un bloque
     *
     * @param   int $tamanno Cantidad de bloques
	 * @param   int $i  Identificador del nmero de bloque
	 * @return  string template de las opciones
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */   
	function opciones_articulo($tamanno,$i) {

		if($i == 0){
			$template_opciones = PATH_CONTENIDO . "vistas/templates/tpl_opciones_bloques1.html";
		}	  
		if($i == ($tamanno-1)){
			$template_opciones = PATH_CONTENIDO . "vistas/templates/tpl_opciones_bloques3.html";
		}
		if($i != 0  and $i != ($tamanno-1)){
			$template_opciones = PATH_CONTENIDO . "vistas/templates/tpl_opciones_bloques.html";
		}
		if( $tamanno == 1 && $i == 0){
			$template_opciones = PATH_CONTENIDO . "vistas/templates/tpl_opciones_bloques5.html";
		}	  

	    return $template_opciones;
	}

}
?>