----------------------------------------------------------------
-- Archivo de creacin de tablas para el paquete Articulos    --
-- Fecha: Diciembre 15 de 2003                                --
----------------------------------------------------------------

-- Posterior a create_sistema.sql

CREATE TABLE art_datos_modulos_articulos (
    limite_categorias smallint,
    limite_articulos smallint,
    PRIMARY KEY (id_objeto)
)
INHERITS (sis_datos_modulos);

CREATE TABLE art_categorias_articulos (
    PRIMARY KEY (id_objeto)
)
INHERITS (sis_categorias);

CREATE TABLE art_articulos (
    publicado boolean DEFAULT true,
    autor character varying(255),
    fecha_publicacion date,
    nombre_menu character varying(25),
    PRIMARY KEY (id_objeto)
)
INHERITS (sis_paginas);

CREATE TABLE art_bloques (
    id_bloque serial NOT NULL,
    id_articulo integer,
    posicion integer,
    id_idioma integer,
    tipo character varying(50),
    PRIMARY KEY (id_bloque),
    FOREIGN KEY (id_idioma) REFERENCES sis_idiomas(id_idioma)
);

CREATE TABLE art_bloques_flash (
    flash character varying(255),
    PRIMARY KEY (id_bloque)
)
INHERITS (art_bloques);

CREATE TABLE art_bloques_archivos (
    archivo character varying(255),
    nombre character varying(255),
    PRIMARY KEY (id_bloque)
)
INHERITS (art_bloques);

CREATE TABLE art_bloques_textos (
    texto1 text,
    texto2 text,
    PRIMARY KEY (id_bloque)
)
INHERITS (art_bloques);

CREATE TABLE art_bloques_texto_fotos (
    texto text,
    foto character varying(255),
    pie_foto character varying(255),
    alt character varying(255),
    PRIMARY KEY (id_bloque)
)
INHERITS (art_bloques);

CREATE TABLE art_bloques_foto_textos (
    foto character varying(255),
    texto text,
    pie_foto character varying(255),
    alt character varying(255),
    PRIMARY KEY (id_bloque)
)
INHERITS (art_bloques);

CREATE TABLE art_bloques_imagenes
(
  foto1 varchar(255),
  foto2 varchar(255),
  foto3 varchar(255),
  pie_foto1 varchar(255),
  pie_foto2 varchar(255),
  pie_foto3 varchar(255),
  alt1 varchar(255),
  alt2 varchar(255),
  alt3 varchar(255),
  PRIMARY KEY (id_versiones),
  FOREIGN KEY (id_objeto) REFERENCES art_bloques (id_objeto) ON DELETE CASCADE,
  FOREIGN KEY (id_idioma) REFERENCES sis_idiomas (id_idioma) ON DELETE CASCADE
) INHERITS (public.sis_versiones);