<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |   	      Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// |          Fernando Rengifo <frengifo@telesat.com.co>                  |
// +----------------------------------------------------------------------+
//

/**
 * Generador de Contratacin en lnea
 * Esta clase genera los archivos de la parte pblica de contratacin en lnea
 *
 * @package  Contratos
 * @version  1.0
 * @author   Fernando Rengifo <frengifo@telesat.com.co>
 * @since    PHP 4.1.2
 */
class Generador_Contratos
{ 
    /**
 	 * Genera contratos
     *
     * @param int $id_sitio Identificador del sitio
	 *        string $path_sitio ruta donde se generan los archivos
	 *        object $idioma Idioma en el que se genera el listado de contratos 
	 *
	 * @return array Arreglo asociativo con los datos de los contratos
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */
	 function generar_contratos()
	 {
	 	$datos = new Gel_datos_modulos_contratos;
		$datos->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
	 	$pagina = new Gel_contratos_pagina;
		$pagina->get('id_contenedor', $datos->id_objeto);

	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'] . "/"; 
		$template_contratacion = PATH_CONTRATOS . "vistas/templates/tpl_contratos_contratacion.php";
		$archivo_contratacion = $path_sitio . "pagina_{$pagina->id_objeto}.php";

		@unlink($archivo_contratacion);
		copy ($template_contratacion, $archivo_contratacion);

		$template_contratos = PATH_CONTRATOS . "vistas/templates/tpl_contratos_listadocontratos.php";
		$archivo_contratos = $path_sitio . "contratos.php";

		@unlink($archivo_contratos);
		copy ($template_contratos, $archivo_contratos);
		
		$template_contratos = PATH_CONTRATOS . "vistas/templates/tpl_contratos_detallecontrato.php";
		$archivo_contratos = $path_sitio . "detallar_contrato.php";
		
		@unlink($archivo_contratos);
		copy ($template_contratos, $archivo_contratos);		

		$template_menus_contratos = PATH_CONTRATOS . "vistas/templates/tpl_contratos_menuinterno.php";
		$archivo_menu_contratos = $path_sitio . "menuinterno.php";
		
		@unlink($archivo_menu_contratos);
		copy ($template_menus_contratos, $archivo_menu_contratos);		

		$template_proponentes = PATH_CONTRATOS . "vistas/templates/tpl_contratos_registroproponente.php";
		$archivo_proponentes = $path_sitio . "adicionar_proponente.php";
		
		@unlink($archivo_proponentes);
		copy ($template_proponentes, $archivo_proponentes);		

		$template_validaproponentes = PATH_CONTRATOS . "vistas/templates/tpl_contratos_validacionproponente.php";
		$archivo_validaproponentes = $path_sitio . "valida_proponente.php";
		
		@unlink($archivo_validaproponentes);
		copy ($template_validaproponentes, $archivo_validaproponentes);		

		$template_enviarcomentario = PATH_CONTRATOS . "vistas/templates/tpl_contratos_enviarcomentario.php";
		$archivo_enviarcomentario = $path_sitio . "enviar_comentario.php";
		
		@unlink($archivo_enviarcomentario);
		copy ($template_enviarcomentario, $archivo_enviarcomentario);		

		$template_buscarcontratos = PATH_CONTRATOS . "vistas/templates/tpl_contratos_busqueda.php";
		$archivo_buscarcontratos = $path_sitio . "buscar_contratos.php";
		
		@unlink($archivo_buscarcontratos);
		copy ($template_buscarcontratos, $archivo_buscarcontratos);		

		
		$idioma = '<?= $_SESSION[\'lang\']?>';
	 }
	 
    /**
 	 * Genera detalle contrato
     *
     * @param int $id_sitio Identificador del sitio
	 *        string $path_sitio ruta donde se generan los archivos
	 *        object $idioma Idioma en el que se genera el listado de contratos 
	 *
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */
	 function generar_detalle_contrato($id_contrato) {

		$contratos = new Gel_contratos;
		$contratos->get($id_contrato);

		$template_contrato = PATH_CONTRATOS . "vistas/templates/tpl_contratos_detallecontrato_publico.php";
		$pagina = "pagina_" . $contratos->id_objeto .".php";
		$path_vistas = "vistas/". $_SESSION['sis_idioma']['enctype'];
		$archivo_contrato =  "html/" . $_SESSION['sitio']['url']. "/$path_vistas/$pagina";
		@unlink($archivo_contrato);		
		
	 	$versiones      = new gel_contratos_versiones;
		$archivos       = new gel_archivos;
		$estados        = new gel_estados;		
		$dependencias   = new gel_dependencias;
		$tipos_archivos = new gel_tipos_archivos;
		
		$contratos->joinAdd($dependencias);
		$contratos->joinAdd($estados);
		$contratos->selectAs();
		$contratos->selectAs($dependencias, 'dep_%s');
		$contratos->selectAs($estados, 'est_%s');
		$contratos->find(true);
		
		//$contratos->print_query();
		$versiones->id_objeto = $contratos->id_objeto;
		$versiones->id_idioma = $_SESSION["sis_idioma"]["id_idioma"]; 	
		$versiones->find(true);
		
		//print_r($versiones);
		
		$archivos->joinAdd($versiones);
		$archivos->joinAdd($tipos_archivos);
		$archivos->selectAs();
		$archivos->selectAs($tipos_archivos, 'tarch_%s');
		$archivos->orderBy('id_tipo_archivo');
		$archivos->find();
	
		$lista_archivos = array();
		while ($archivos->fetch()) {
  			 array_push($lista_archivos, $archivos);
		}	
		
		$listado = Fachada_contratos::listado_proponentes($contratos->id_objeto);
	    $listado_proponentes = $listado['lista'];
		$cuantos             = $listado['cuantos'];
	
		// Se escribe la cabecera del portal
		$includes = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_contrato, $includes, FILE_MODE_WRITE); 
		
		// Se escribe el contenido del contrato
		include($template_contrato);

		File::writeLine($archivo_contrato, $contenido_HTML);
		
		// Se escribe el pie del portal
		File::writeLine($archivo_contrato, '<? include("vistas/foot_public.php") ?>'); 
		
	 }
	 
}

?>
