<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Fernando Rengifo <frengifo@telesat.com.co>                    |
 * +----------------------------------------------------------------------+
 * 
 */
//
// Especificacin del mdulo de Gobierno en Lnea (Contratacin Pblica)
//
 /**
 *  La clase Fachada_Contratos administra las clases para el modulo de contratacin
 *
 * @package  Contratos
 * @version  0.9
 * @author   Fernando Rengifo <frengifo@telesat.com.co> 
 * @since    PHP 4.3.3
 */

// Clases necesarias

require_once(PATH_CONTRATOS . 'modelo/Gel_archivos.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_contratos.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_contratos_versiones.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_datos_modulos_contratos.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_dependencias.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_estados.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_proponentes.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_comentarios.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_tipos_contratos.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_unidades_ejecutoras.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_categorias_contratos.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_historial_contratos.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_tipos_archivos.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_contratos_pagina.php');
require_once(PATH_CONTRATOS . 'modelo/Gel_contratos_pagina_versiones.php');
require_once(PATH_CONTRATOS . 'modelo/Generador_contratos.php');

//CONTROLADOR
// Mapping
include(PATH_CONTRATOS . 'controlador/mappings.php');

// Solo se requieren los formularios que neecesitan validacin
require_once PATH_CONTRATOS . 'controlador/actions/listar_categorias_contratosAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/buscarAction.php'; 
require_once PATH_CONTRATOS . 'controlador/actions/listar_tipos_contratosAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/borrar_tipo_contratoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/cambiar_tipo_contratoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/adicionar_tipo_contratoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/listar_unidades_ejecutorasAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/borrar_unidad_ejecutoraAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/cambiar_unidad_ejecutoraAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/adicionar_unidad_ejecutoraAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/listar_cat_contratosAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/borrar_cat_contratosAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/cambiar_cat_contratosAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/adicionar_cat_contratosAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/listar_comentariosAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/listar_dependenciasAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/borrar_dependenciasAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/cambiar_dependenciasAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/adicionar_dependenciasAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/listar_contratosAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/listar_contratos_enprocesoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/adicionar_contratoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/mostrar_contratoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/modificar_contratoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/eliminar_contratoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/descargar_archivoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/borrar_archivoAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/insertar_proponenteAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/validar_proponenteAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/insertar_comentarioAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/mostrar_comentarioAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/listar_historialAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/listar_proponentesAction.php';
require_once PATH_CONTRATOS . 'controlador/actions/mostrar_proponenteAction.php';
require_once(PATH_CONTRATOS . 'modelo/Generador_contratos.php');

class Fachada_Contratos
{

     /**
 	 * Verifica si existe una unidad ejecutora, tipo o categora de contratos con el mismo nombre
     *
	 * @param   string $nombre nombre de la categoria a buscar
	 * @return  $int Cantidad de registros encontrados
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function existe_item($nombre,$nombre_clase) {
		$item = new $nombre_clase;
		
		$item->nombre = $nombre;
		$item->whereAdd("nombre like '$nombre'");
		$total = $item->count();
		return $total;
	}

     /**
 	 * Inserta si no existe una categora de contratos con nombre deseado
     *
	 * @param   string $nombre nombre de la categoria a ingresar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function crear_categoria($nombre) {
        $mensaje = '';
		
		$categoria = new Gel_categorias_contratos;  
        $categoria->nombre = $nombre;

		$categoria->cuantos = Fachada_Contratos::existe_item($nombre,"Gel_categorias_contratos");

		if( $categoria->cuantos == 0 ) {
			$id = $categoria->insert();
			
			$mensaje = '* La categora ' . $categoria->getnombre() . ', ha sido ingresada\\n';		
	
			$depmensaje = ($id) ? 'Se insert la categora '.$categoria->nombre : 'Error al insertar la categora '.$categoria->nombre;
			Util::log('Contratos', 'crear_categoria', $depmensaje);		
		} else {
			$mensaje = "La categora ya existe en la base de datos";
		}	
		
		return $mensaje;
	}

     /**
 	 * Inserta si no existe un tipo de contrato con el nombre deseado
     *
	 * @param   string $nombre nombre del tipo de contrato a ingresar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function crear_tipo_contrato($nombre) {
	    $mensaje = '';
	 
		$tipo_contrato = new Gel_tipos_contratos;  
        $tipo_contrato->nombre = $nombre;

		$tipo_contrato->cuantos = Fachada_Contratos::existe_item($nombre,"Gel_tipos_contratos");

		if( $tipo_contrato->cuantos == 0 ) {
			$id = $tipo_contrato->insert();
			
			$mensaje = '* El tipo de contrato ' . $tipo_contrato->getnombre() . ', ha sido ingresado\\n';		
	
			$depmensaje = ($id) ? 'Se insert el tipo de categora '.$tipo_contrato->getnombre() : 'Error al insertar el tipo de categora '.$tipo_contrato->getnombre();
			Util::log('Contratos', 'crear_tipo_contrato', $depmensaje);		
		} else {
			$mensaje = "El tipo de contrato a insertar ya existe en la base de datos";
		}	
		
		return $mensaje;
	}
	
     /**
 	 * Inserta si no existe una unidad ejecutora con el nombre deseado
     *
	 * @param   string $nombre nombre de la unidad ejecutora a ingresar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function crear_unidad_ejecutora($nombre) {
	    $mensaje = '';
		
		$unidad_ejecutora = new Gel_unidades_ejecutoras;  
		$unidad_ejecutora->nombre = $nombre;
	
		$unidad_ejecutora->cuantos = Fachada_Contratos::existe_item($nombre,"Gel_unidades_ejecutoras");
	
		if( $unidad_ejecutora->cuantos == 0 ) {
			$id = $unidad_ejecutora->insert();
	
			$mensaje = '* La unidad ejecutora ' . $unidad_ejecutora->getnombre() . ', ha sido ingresada\\n';		
	
			$depmensaje = ($id) ? 'Se insert la unidad ejecutora '.$unidad_ejecutora->nombre : 'Error al insertar la unidad ejecutora '.$unidad_ejecutora->nombre;
			Util::log('Contratos', 'crear_unidad_ejecutora', $depmensaje);		
		} else {
			$mensaje = "La unidad ejecutora a insertar ya existe en la base de datos";
		}	

		return $mensaje;
	}
	
    /**
 	 * Lista las estados, unidades ejecutoras, tipos y categorias de contratos para usar en desplegables
	 * @param   string $nombre_clase nombre de la clase a instanciar
     * @return  array Arreglo de datos solicitados
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function listar($nombre_clase) {
		$lista = new $nombre_clase;

	 	$lista->find();
		$lista_datos = array();
		while ($lista->fetch()) 
			array_push($lista_datos, $lista->toArray());
		
		if( sizeof($lista_datos) == 0 ) {
			$mensaje = "No existen datos para listar";
			$_SESSION['mensaje'] = $mensaje;
		}

		return $lista_datos;
    }	

    /**
 	 * Lista las comentarios, estados, unidades ejecutoras, tipos y categorias de contratos
	 * @param   string $nombre_clase nombre de la clase a instanciar
     * @return  array Arreglo de datos solicitados
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function listar_datos($nombre_clase,$from) {
		$lista = new $nombre_clase;

		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0;
		$data = DB_Pager::getData($from, NUM_REGISTROS, $lista->count(), MAXPAGES);

		$lista->limit($from, NUM_REGISTROS);
	 	$lista->find();

		$lista_datos = array();
		while ($lista->fetch()) 
			array_push($lista_datos, $lista->toArray());
		
		if( sizeof($lista_datos) == 0 ) {
			$mensaje = "No existen datos para listar";
			$_SESSION['mensaje'] = $mensaje;
		}

		return array("lista" => $lista_datos, "data" => $data);
    }	
	
    /**
 	 * Obtiene el estado de un determinado contrato
     *
	 * @param   int $id_contrato Identificador del contrato a obtener su estado
	 * @return  int Identificador del estado 
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function obtener_estado($id_contrato) {
	   $contrato = new Gel_contratos;
	   $estado   = new Gel_estados;
	   
	   $contrato->id_objeto = $id_contrato;
	   
	   $estado->joinAdd($contrato);
	   $estado->find(true);
	   $id_estado = $estado->id_estado;
	   
       return $id_estado;
    }	
	
     /**
 	 * Inserta si no existe una unidad ejecutora con el nombre deseado
     *
	 * @param   string $nombre nombre de la unidad ejecutora a ingresar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function crear_comentario($id_contrato,$nombre,$ciudad,$telefono,$email,$new_comentario,$numero) {
	    $mensaje = '';
		$comentario = new Gel_comentarios;  
		
        $comentario->id_contrato = $id_contrato;
		$comentario->numero      = $numero; 
		$comentario->nombre      = $nombre;
		$comentario->ciudad      = $ciudad;
		$comentario->telefono    = $telefono;
		$comentario->email       = $email;
		$comentario->comentario  = $new_comentario;
		$comentario->ip          = $_SERVER['REMOTE_ADDR'];
		$comentario->fecha       = date("Y-m-d");
		
		$id_estado = Fachada_Contratos::obtener_estado($comentario->id_contrato);

		if( $id_estado == 1 )
			if( $id = $comentario->insert() ) {
				$depmensaje = ($id) ? 'Se ingresa el comentario de '.$comentario->nombre.' al contrato '.$id_contrato.' el '.$comentario->fecha : 'Error al insertar el comentario de '.$comentario->nombre.' al contrato '.$id_contrato.' el '.$comentario->fecha;
				Util::log('Contratos', 'insertar_historial_estado', $depmensaje);		
				
				$mensaje = "El comentario ha sido agregado satisfactoriamente";				
			}
			else
				$mensaje = "El comentario NO ha sido agregado satisfactoriamente";							    
		else {
			$mensaje = "El contrato se encuentra en un estado que no permite comentarios";
			$id = 0;
		}	
		
		$_SESSION['mensaje_comentario'] = $mensaje;
		return $mensaje;
	}
	
     /**
 	 * Muestra los detalles de un comentario
	 * @param   int $id_comentario Indice del comentario a detallar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function ver_comentario($id_comentario) {
		$comentario = new Gel_comentarios;  
		
		$comentario->get($id_comentario);
        $detalle_comentario = $comentario->toArray();
		return $detalle_comentario;
	}
	
     /**
 	 * Modifica unidades ejecutoras y categoras de contratos
	 * @param   int $id_item Indice del registro a modificar
	 * @param   string $nombre Dato a modificar
	 * @param   string $nombre_clase nombre de la clase a instanciar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function modificar_item($nombre,$id_item,$nombre_clase) {
		$item = new $nombre_clase;
		
		$mensaje = '';
		
		if( $nombre != "" ) {
			$item->get($id_item);
			$item->nombre = $nombre;
			
			if ( !$id = $item->update() ) {
				$mensaje .= '* El campo NO puedo ser actualizado\\n';				
			 			
				$mensaje .= '* El registro ' . $item->getnombre() . ', no pudo ser modificado\\n';
			}
			else {
				$mensaje .= '* El campo ' . $item->getnombre() . ' fue actualizado\\n';
				
				$depmensaje = ($id) ? 'Se modific en '.$nombre_clase.' el item '.$item->getnombre() : 'Error al modificar en '.$nombre_clase.' el item '.$item->getnombre();
				Util::log('Contratos', 'modificar_item', $depmensaje);		
			}
		}
        else 
			 $mensaje = '* El campo NO puede ser actualizado por un valor vacio\\n';				
		
		return $mensaje;
	}
	
     /**
 	 * Eliminar unidades ejecutoras, comentarios y categoras de contratos
	 * @param   array $lista_item arreglo de registros a eliminar
	 * @param   string $nombre_clase nombre de la clase a instanciar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function eliminar_item($lista_items,$nombre_clase) {
	 	$mensaje = '';
	 
	 	foreach ($lista_items as $id_item => $v) {
			$item = new $nombre_clase;
			$item->get($id_item);

			if ( !$item->delete() ) {
				$mensaje .= '* El registro ' . $item->getnombre() . ', no puede ser eliminado\\n';
			}
		}

		return $mensaje;
	}

    /**
 	 * Obtiene los datos de un contrato
     *
     * @param int $id_contratoo Identificador del contrato a obtener
	 * @return array Los datos del contrato obtenido
     */ 
	 function mostrar_contrato($id_contrato)
	 {
	 	$contrato       = new gel_contratos;
	 	$versiones      = new gel_contratos_versiones;
		$archivos       = new gel_archivos;
		$tipos_archivos = new gel_tipos_archivos;
		
		$contrato->get($id_contrato);
		
		$contrato->id_objeto = $id_contrato;
		
		$versiones->joinAdd($contrato);
		$versiones->selectAs();
		$versiones->selectAs($contrato,'con_%s');
		
		if( !isset($_SESSION["sis_idioma"]["id_idioma"]) ) {
            $idioma = new Sis_idiomas;
			$idioma->get('enctype',$_SESSION['lang']);
			
			$versiones->id_idioma = $idioma->id_idioma;		
		} else {
			$versiones->id_idioma = $_SESSION["sis_idioma"]["id_idioma"];

 		}
		    	
		$versiones->find(true);

        /* Se sacan el listado de archivos */
        $versiones_ = new Gel_contratos_versiones;
		$archivos->id_versiones = $versiones->id_versiones;
		
		$archivos->joinAdd($versiones_);
		$archivos->joinAdd($tipos_archivos);
		$archivos->selectAs();
		$archivos->selectAs($tipos_archivos, 'tarch_%s');
		$archivos->orderBy('id_tipo_archivo');
		$archivos->find();
		
		$lista_archivos = array();
		while ($archivos->fetch()) {
  			 array_push($lista_archivos, $archivos->toArray());
		}
		

		return array("contrato" => $versiones->toArray(), "archivos" => $lista_archivos);
	 }  
	
     /**
 	 * Insertar datos del contrato
	 * @param string $numero Nmero del contrato
	 * @param int $estado Indice del estado actual del contrato
	 * @param string $nombre Nombre del contrato
	 * @param int $tipo_contrato Indice del tipo de contrato
	 * @param string $objeto Objeto o descripcin del contrato
	 * @param $dependencia Dependencia que ordena el contrato
	 * @param int $categoria_contrato Indice de la categora del contrato
	 * @param timestamp $fecha_adjudicacion Fecha en que se adjudica o adjudicar el contrato
	 * @param string $ordenador_gasto Nombre de la persona o la dependencia que ordena el gasto
	 * @param string $direccion_cp Direccin donde se compran los pliegos
	 * @param string $horario_atencion Horario en que venden los pliegos
     * @param timestamp $fecha_hora_apertura_cp Fecha y hora de la apertura de la licitacin 
     * @param timestamp $fecha_hora_cierre_cp Fecha y hora de cierre de la licitacin 
	 
	 /* Faltan comentarios
	 * @param int $tipo_contrato Indice del tipo de contrato
	 * @param string $objeto Objeto o descripcin del contrato
	 * @param $dependencia Dependencia que ordena el contrato
	 * @param int $categoria_contrato Indice de la categora del contrato
	 * @param timestamp $fecha_adjudicacion Fecha en que se adjudica o adjudicar el contrato
	 * @param string $ordenador_gasto Nombre de la persona o la dependencia que ordena el gasto

	 * @return int $id_contrato Indice generado para el contrato insertado
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function insertar_contrato($numero,$id_estado_contrato,$nombre,$id_tipo_contrato,$objeto,$contratista,$presupuesto,$id_dependencia,$unidad_ejecutora,$id_categoria_contrato,$fecha_adjudicacion,$ordenador_gasto,$activo,$direccion_cp,$horario_atencion,$precio,$fecha_hora_apertura_cp,$fecha_hora_cierre_cp,$departamento,$ciudad,$direccion_pr,$fecha_hora_apertura_pr,$fecha_hora_cierre_pr,$direccion_web_pr,$email_pi,$direccion_web_pi,$doc) {
		$mensaje = '';
		$contrato = new Gel_contratos;  
	    $datos_modulos = new Gel_datos_modulos_contratos;
		
		$datos_modulos->get('id_contenedor', $_SESSION["sitio"]["id_objeto"]);
		
		$contrato->id_contenedor            = $datos_modulos->id_objeto;
		$contrato->id_dependencia           = $id_dependencia;
		$contrato->id_modulo                = $datos_modulos->id_objeto;
		$contrato->id_estado                = $id_estado_contrato;
		$contrato->id_tipo_contrato         = $id_tipo_contrato;
		$contrato->id_categoria_contrato    = $id_categoria_contrato;
		$contrato->nombre                   = $nombre;
		$contrato->objeto                   = $objeto;
		$contrato->contratista              = $contratista;
		$contrato->fecha_adjudicacion       = ($fecha_adjudicacion != '') ? $fecha_adjudicacion : 'NULL';
		$contrato->ordenador_gasto          = $ordenador_gasto;
		$contrato->activo                   = 1;
		$contrato->direccion_compra_pliegos = $direccion_cp;
		$contrato->horario_atencion         = $horario_atencion;
		$contrato->fecha_hora_apertura_cp   = $fecha_hora_apertura_cp;
		$contrato->fecha_hora_cierre_cp     = $fecha_hora_cierre_cp;
		$contrato->departamento             = $departamento;
		$contrato->ciudad                   = $ciudad;
		$contrato->direccion_propuestas     = $direccion_pr;
		$contrato->fecha_hora_apertura_pr   = $fecha_hora_apertura_pr;
		$contrato->fecha_hora_cierre_pr     = $fecha_hora_cierre_pr;
		$contrato->direccion_web_pr         = $direccion_web_pr;
		$contrato->email_pi                 = $email_pi;
		$contrato->direccion_web_pi         = $direccion_web_pi;
        $contrato->numero                   = $numero;
		$contrato->precio                   = $precio;
		$contrato->unidad_ejecutora         = $unidad_ejecutora;
		$contrato->presupuesto              = $presupuesto;				

		if( $id_contrato = $contrato->insert() ) {

            $mensaje = 'Se insert el contrato ' . $contrato->nombre;
			$depmensaje = ($id_contrato) ? 'Se insert el contrato' : 'Error al insertar el contrato';
			Util::log('Contratos', 'insertar_contrato', $depmensaje);		
		}	
		
        $versiones  = new gel_contratos_versiones;
		
		$versiones->id_objeto    = $id_contrato;
		$versiones->id_idioma    = $_SESSION["sis_idioma"]["id_idioma"];
		$versiones->nombre       = $nombre;
		$versiones->descripcion  = $objeto;
		
		$id_version = $versiones->insert();

		$depmensaje = ($id_version) ? 'Se insert la versin del contrato' : 'Error al insertar la versin del contrato';
		Util::log('Contratos', 'insertar_contrato', $depmensaje);		
		
		for( $i= 1; $i <= sizeof($doc['name']); $i++ ) {
			if ($doc['name'][$i] != "") {
			   $mensaje .= Fachada_Contratos::ingresar_archivo($doc,$id_version,$i,"",$id_contrato);
			}
		}
		
		Generador_contratos::generar_detalle_contrato($id_contrato);
		Generador_contratos::generar_contratos();
		
		return $mensaje;
	}

     /**
 	 * Modificar datos del contrato
	 * @param string $numero Nmero del contrato
	 * @param int $estado Indice del estado actual del contrato
	 * @param string $nombre Nombre del contrato
	 * @param int $tipo_contrato Indice del tipo de contrato
	 * @param string $objeto Objeto o descripcin del contrato
	 * @param $dependencia Dependencia que ordena el contrato
	 * @param int $categoria_contrato Indice de la categora del contrato
	 * @param timestamp $fecha_adjudicacion Fecha en que se adjudica o adjudicar el contrato
	 * @param string $ordenador_gasto Nombre de la persona o la dependencia que ordena el gasto
	 * @param string $direccion_cp Direccin donde se compran los pliegos
	 * @param string $horario_atencion Horario en que venden los pliegos
     * @param timestamp $fecha_hora_apertura_cp Fecha y hora de la apertura de la licitacin 
     * @param timestamp $fecha_hora_cierre_cp Fecha y hora de cierre de la licitacin 
	 
	 /* Faltan comentarios
	 * @param int $tipo_contrato Indice del tipo de contrato
	 * @param string $objeto Objeto o descripcin del contrato
	 * @param $dependencia Dependencia que ordena el contrato
	 * @param int $categoria_contrato Indice de la categora del contrato
	 * @param timestamp $fecha_adjudicacion Fecha en que se adjudica o adjudicar el contrato
	 * @param string $ordenador_gasto Nombre de la persona o la dependencia que ordena el gasto

	 * @return int $id_contrato Indice generado para el contrato insertado
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function modificar_contrato($id_contrato,$numero,$id_estado_contrato,$nombre,$id_tipo_contrato,$objeto,$contratista,$presupuesto,$id_dependencia,$unidad_ejecutora,$id_categoria_contrato,$fecha_adjudicacion,$ordenador_gasto,$activo,$direccion_cp,$horario_atencion,$precio,$fecha_hora_apertura_cp,$fecha_hora_cierre_cp,$departamento,$ciudad,$direccion_pr,$fecha_hora_apertura_pr,$fecha_hora_cierre_pr,$direccion_web_pr,$email_pi,$direccion_web_pi,$doc,$id_archivos) {
		$mensaje = '';
		
		$contrato = new Gel_contratos; 
		
		$contrato->get($id_contrato);
		
		$contrato->id_dependencia           = $id_dependencia;
		$contrato->id_estado                = $id_estado_contrato;
		$contrato->id_tipo_contrato         = $id_tipo_contrato;
		$contrato->id_categoria_contrato    = $id_categoria_contrato;
		$contrato->nombre                   = $nombre;
		$contrato->objeto                   = $objeto;
		$contrato->contratista              = $contratista;
		$contrato->fecha_adjudicacion       = ($fecha_adjudicacion != '') ? $fecha_adjudicacion : 'NULL';
		$contrato->ordenador_gasto          = $ordenador_gasto;
		$contrato->activo                   = $activo;
		$contrato->direccion_compra_pliegos = $direccion_cp;
		$contrato->horario_atencion         = $horario_atencion;
		$contrato->fecha_hora_apertura_cp   = $fecha_hora_apertura_cp;
		$contrato->fecha_hora_cierre_cp     = $fecha_hora_cierre_cp;
		$contrato->departamento             = $departamento;
		$contrato->ciudad                   = $ciudad;
		$contrato->direccion_propuestas     = $direccion_pr;
		$contrato->fecha_hora_apertura_pr   = $fecha_hora_apertura_pr;
		$contrato->fecha_hora_cierre_pr     = $fecha_hora_cierre_pr;
		$contrato->direccion_web_pr         = $direccion_web_pr;
		$contrato->email_pi                 = $email_pi;
		$contrato->direccion_web_pi         = $direccion_web_pi;
        $contrato->numero                   = $numero;
		$contrato->precio                   = $precio;
		$contrato->unidad_ejecutora         = $unidad_ejecutora;
		$contrato->presupuesto              = $presupuesto;		

        /* Retorna el estado actual del contrato */ 
		$id_estado = Fachada_Contratos::obtener_estado($id_contrato);
		
		/* Se verifica que no actualize a un estado inferior */
		if( $id_estado_contrato < $id_estado ) {
		     $mensaje = "No se puede actualizar el estado de un contrato a un estado inferior que el actual";
        } 
		/* Si es correcta la actualizacin de estado */
		else { 
			if( $id_objeto = $contrato->update() ) {
				Fachada_contratos::insertar_historial_estado($id_contrato,$id_estado_contrato,$id_estado);

				$mensaje = "El contrato ".$numero." fue modificado ";
				
				$depmensaje = ($id_objeto) ? 'Se actualiz el contrato' : 'Error al actualizar el contrato';
				Util::log('Contratos', 'modificar_contrato', $depmensaje);		
			}
			
			$versiones  = new gel_contratos_versiones;
			
			$versiones->id_idioma    = $_SESSION["sis_idioma"]["id_idioma"];
			$contrato->joinAdd($versiones);
			$contrato->find(true);
			
			for( $i= 1; $i <= 8; $i++ ) {
				if ($doc['name'][$i] != "") { 
				   $mensaje .= Fachada_Contratos::ingresar_archivo($doc,$contrato->id_versiones,$i,$id_archivos[$i],$id_contrato);
				}
			}	
			
			Generador_contratos::generar_detalle_contrato($id_contrato);
			Generador_contratos::generar_contratos();
		}	
		
		return $mensaje;
	}
	
   /**
 	 * Descargar archivo
	 * @return  int $id_archivo Indice del archivo a descargar
	 * @author  Fernando Rengifo
     * @access  public
     */  	 
	
	function descargar_archivo($id_archivo)
	{
		$mensaje = '';

	    $archivos = new gel_archivos;

        $archivos->get($id_archivo);
		$archivos->descargas++;
		$archivos->update(); 
		
        /* archivo*/
	    if( !isset($_SESSION["sis_idioma"]["id_idioma"]) ) {
			$path_url = PATH_IMAGES;		
			$filename = $path_url . "/contratos/".$archivos->nombre;			
		} else {
			$path_url = $_SESSION["sitio"]["url"];		
			$filename = "imagenes_cont/" . $path_url . "/contratos/".$archivos->nombre;			
		}
		
		$file_extension = substr( $filename,-3 );
		
		/* Si el archivo est vacio o no existe */
		if( $filename == "" ) {
			$mensaje = "El archivo a descargar est vacio";
			$_SESSION['mensaje_descarga'] = $mensaje;
			exit();
		} else if ( ! file_exists( $filename ) ) {
			$mensaje = "El archivo a descargar NO existe";
			$_SESSION['mensaje_descarga'] = $mensaje;
		    exit();
		};

		header("Pragma: public");
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
		header("Content-Type: application/force-download");
		header( "Content-Disposition: attachment; filename=".basename($filename));
		header( "Content-Description: File Transfer");
		@readfile($filename);
		
		Generador_contratos::generar_detalle_contrato($id_contrato);
	}	

     /**
 	 * Ingresar archivo
	 * @param  string $archivo 
	 * @param  int $id_version 
	 * @param  int $tipo_archivo
	 * @author  Fernando Rengifo
     * @access  public
     */ 
    function ingresar_archivo($file,$id_version,$tipo_archivo,$id_archivo,$id_objeto) {
        $mensaje = '';
		$accion = "insert";
		$path_url = $_SESSION["sitio"]["url"];
		list($n,$ext) = split("[.]",$file['name'][$tipo_archivo]);

        /* Se reciben solo archivos de extensin .pdf */
		//print_r($file['type'][$tipo_archivo]);
        if( $file['type'][$tipo_archivo] == "application/pdf" ) {
			$archivos = new gel_archivos;
			
			if( $id_archivo != "" ) {
			  $archivos->id_archivo = $id_archivo;
			  $archivos->find(true);
	
				/* Aqu se verifica si el archivo que llega es nuevo y se inserta o se actualiza */
				if( $file['name'][$tipo_archivo] == $archivos->nombre  ) {
					 $accion = "update";
					 $depmes = "actualiz";
				}	 
				else {
					 $accion = "insert";
					 $archivos = new gel_archivos;
					 $depmes = "insert";				 
				}	 
			}
			
			$archivos->id_versiones        = $id_version;
			$archivos->id_tipo_archivo     = $tipo_archivo;
			$archivos->fecha_actualizacion = date("Y-m-d H:i:s");
			$archivos->extension           = $ext;
	
			if( !is_dir("imagenes_cont/" . $path_url )) 
			   mkdir("imagenes_cont/" . $path_url );
			
			if( !is_dir("imagenes_cont/" . $path_url . "/contratos/")) 
			   mkdir("imagenes_cont/" . $path_url . "/contratos");
			
			// Copiar el archivo
			$path_images = "imagenes_cont/" . $path_url . "/contratos/";
			if ($file['name'][$tipo_archivo] != "") {
				$name_file = $file['name'][$tipo_archivo];
				if (copy($file['tmp_name'][$tipo_archivo], $path_images . $name_file)) {
					$archivos->nombre = $name_file; 
					
					/* Se ingresa una lnea al historial del archivo */
					Fachada_Contratos::insertar_historial_archivo($id_objeto,$tipo_archivo);
				}
			}
	
			$id_arch = $archivos->$accion();
			$archmensaje = ($id_arch) ? 'Se '.$archivos->nombre.' el archivo' : 'Error al '.$archivos->nombre.' el archivo';
			Util::log('Contratos', 'ingresar_archivo', $archmensaje);		
		} else {
		    $mensaje .= "\\nPero ". $file['type'][$tipo_archivo]." NO es un tipo permitido de archivo,\\nNO puede ser adicionado al contrato. \\nSOLO se pueden adicionar archivo PDF ";
		}

		return $mensaje;
	}
	
   /**
 	 * Descargar archivo
	 * @return  int $id_archivo Indice del archivo a descargar
	 * @author  Fernando Rengifo
     * @access  public
     */  	 
	
	function borrar_archivo($id_archivo) {
	
		$path_url = $_SESSION["sitio"]["url"];
		$mensaje = '';

	    $archivos = new gel_archivos;

        $archivos->get($id_archivo);

        /* archivo */
		$filename = "imagenes_cont/" . $path_url . "/contratos/".$archivos->nombre;

        if ( file_exists($filename) ) {
            unlink($filename);
			
			$archivos->delete();
			
			$mensaje = "El archivo ha sido borrado";
			$_SESSION['mensaje_borrado'] = $mensaje;
		}
		
		return $mensaje;
	}

	
     /**
 	 * Listar todos los contratos o los contratos en proceso
	 * @param  int $enproceso Si es 1 lista los que esten en proceso de lo contrario los lista todos
	 * @return array $lista_contratos Listado total de contratos o listado de contratos no adjudicados
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function listar_contratos($enproceso,$id_tipo_contrato,$id_estado_contrato,$from) {
		$contratos = new Gel_contratos;
        $dependencias = new Gel_dependencias;
		$categoria_contrato = new Gel_categorias_contratos;
		
		/* Para la lista de contratos en proceso mira que no est adjudicado */
		if ( $enproceso == 1 ){
			$contratos->whereAdd("gel_contratos.id_estado < 3");
		}
		if ($id_tipo_contrato != ""){
			$contratos->whereAdd("gel_contratos.id_tipo_contrato = '$id_tipo_contrato'");
		}
		if ($id_estado_contrato != ""){
			$contratos->whereAdd("gel_contratos.id_estado = '$id_estado_contrato'");
		}

        /* Verifico solo que liste los contratos activos */
		$contratos->whereAdd("gel_contratos.activo = '1'");

		$contratos->joinAdd($dependencias);
		$contratos->joinAdd($categoria_contrato);
		$contratos->selectAs();
		$contratos->selectAs($dependencias, 'dep_%s');
		$contratos->selectAs($categoria_contrato, 'cat_%s');

		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0;
		$data = DB_Pager::getData($from, NUM_REGISTROS, $contratos->count(), MAXPAGES);

		$contratos->limit($from, NUM_REGISTROS);
		$contratos->orderBy("id_objeto desc");
		$contratos->find();		
		
		$lista_contratos = array();
		while ($contratos->fetch()) {
  			 array_push($lista_contratos, $contratos->toArray());
		}
		
		if( sizeof($lista_contratos) == 0 ) {
			$mensaje = "No existen contratos en proceso";
			$_SESSION['mensaje'] = $mensaje;
		}
		else
		    $_SESSION['mensaje'] = "";
			
		return array("lista" => $lista_contratos, "data" => $data);
	}

    /**
 	 * Buscar contratos
	 * @param string $numero Nmero del contrato
	 * @param int $categoria_contrato Indice de la categora del contrato
	 * @param string $objeto Objeto o descripcin del contrato	 
     * @param timestamp $fecha_hora_apertura_pr Fecha y hora de la apertura de la licitacin 
     * @param timestamp $fecha_hora_cierre_pr Fecha y hora de cierre de la licitacin 
	 * @param int $id_tipo_contrato Indice del tipo de contrato	 
	 * @param int $estado Indice del estado actual del contrato
	 * @param string $presupuesto Rangos de presupuestos de contratos
	 * @return array $lista_resultados Arreglo con los resultados de la bsqueda de contratos
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function buscar_contratos($numero,$id_categoria_contrato,$objeto,$fecha_hora_apertura_pr,$fecha_hora_cierre_pr,$id_tipo_contrato,$id_estado_contrato,$presupuesto,$from) {
		$contrato = new Gel_contratos;
        $dependencias = new Gel_dependencias;
		$categoria_contrato = new Gel_categorias_contratos;
		
		switch($presupuesto){
            case 1:
			        $valor_presupuesto_down = 0; 
					$valor_presupuesto_up   = 50000000; 
			break;
            case 2:
			        $valor_presupuesto_down = 50000000; 
					$valor_presupuesto_up   = 100000000; 
			break;
            case 3:
			        $valor_presupuesto_down = 100000000; 
					$valor_presupuesto_up   = 150000000; 
			break;
            case 4:
			        $valor_presupuesto_down = 150000000; 
					$valor_presupuesto_up   = 5000000000000000000;
			break;
            default:
			        $valor_presupuesto_down = 0; 
					$valor_presupuesto_up   = 5000000000000000000; 
			break;
		}
		
		if ($numero != ""){
			$contrato->whereAdd("LOWER(gel_contratos.numero) LIKE LOWER('%".$numero."%')");
		}
		if ($id_categoria_contrato != ""){
			$contrato->whereAdd("gel_contratos.id_categoria_contrato = '$id_categoria_contrato'");
		}
		if ($objeto != ""){
			$contrato->whereAdd("LOWER(gel_contratos.objeto) LIKE LOWER('%".$objeto."%')");
		}
		if ($fecha_hora_apertura_pr != ""){
			$contrato->whereAdd("gel_contratos.fecha_hora_apertura_pr >= '".$fecha_hora_apertura_pr." 00:00:00'");
		}
		if ($fecha_hora_cierre_pr != ""){
			$contrato->whereAdd("gel_contratos.fecha_hora_cierre_pr <= '".$fecha_hora_cierre_pr." 23:59:59'");
		}
		if ($id_tipo_contrato != ""){
			$contrato->whereAdd("gel_contratos.id_tipo_contrato = '$id_tipo_contrato'");
		}
		if ($id_estado_contrato != ""){
			$contrato->whereAdd("gel_contratos.id_estado = '$id_estado_contrato'");
		}
		if ($presupuesto != ""){
			$contrato->whereAdd("gel_contratos.presupuesto > ".$valor_presupuesto_down." AND gel_contratos.presupuesto <= ".$valor_presupuesto_up." ");
		}
		
		$contrato->whereAdd("gel_contratos.activo = '1'");		
		
		$contrato->joinAdd($dependencias);
		$contrato->joinAdd($categoria_contrato);
		$contrato->selectAs();
		$contrato->selectAs($dependencias, 'dep_%s');
		$contrato->selectAs($categoria_contrato, 'cat_%s');

		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0;
		$data = DB_Pager::getData($from, NUM_REGISTROS, $contrato->count(), MAXPAGES);

		$contrato->limit($from, NUM_REGISTROS);
		$contrato->find();

		$lista_contratos = array();
		while ($contrato->fetch()) {
			array_push($lista_contratos, $contrato->toArray());
		}

		if( sizeof($lista_contratos) == 0 ) {
			$mensaje = "No existen contratos a listar";
			$_SESSION['mensaje'] = $mensaje;
		}
		else
		    $_SESSION['mensaje'] = "";
		
		return array("lista" => $lista_contratos, "data" => $data);
	}
	
     /**
 	 * Eliminar un contrato
	 * @param   int $id_contrato Indice del contrato a eliminar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function eliminar_contratos($id_contrato) {
		$contrato = new Gel_contratos;
		
		$contrato->get($id_contrato);
		$contrato->activo = 0;
		if( $id_ = $contrato->update() ) {
			Generador_contratos::generar_contratos();
	
			$depmensaje = ($id_) ? 'Se elimin el contrato ' . $id_contrato : 'Error al eliminar el contrato '. $di_contrato;
			Util::log('Contratos', 'eliminar_contratos', $depmensaje);		
		}
	}	
	
    /**
 	 * Listado de proponentes
	 * @param   int $id_contrato Indice del contrato a eliminar
	 * @return  array $lista_proponentes listado de proponentes
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function listado_proponentes($id_contrato) {
		$proponentes        = new Gel_proponentes;
		$contrato_versiones = new Gel_contratos_versiones;
		
		$contrato_versiones->id_objeto = $id_contrato;
		
		if( !isset($_SESSION["sis_idioma"]["id_idioma"]) ) {
            $idioma = new Sis_idiomas;
			$idioma->get('enctype',$_SESSION['lang']);
			
			$contrato_versiones->id_idioma = $idioma->id_idioma;
		} else {
			$contrato_versiones->id_idioma = $_SESSION["sis_idioma"]["id_idioma"];
 		}

		$proponentes->joinAdd($contrato_versiones);
		$proponentes->selectAs();
		$proponentes->selectAs($contrato_versiones,'conv_%s');		
	 	$proponentes->find();
		$lista_proponentes = array();
		while ($proponentes->fetch()) {
			array_push($lista_proponentes, $proponentes->toArray());
		}	
		
		$cuantos = sizeof($lista_proponentes);
		
		if( $cuantos == 0 ) {
			$mensaje = "No existen proponentes para ste contrato";
			$_SESSION['mensaje_proponentes'] = $mensaje;
		}

        return array("lista" => $lista_proponentes, "cuantos" => $cuantos); 
	}		
	
    /**
 	 * verificar proponentes
	 * @param   string $documento Documento de identidad del proponente
	 * @param   string $password Palabra clave del proponente
	 * @return  int $registrado 1 si esta registrado 0 si no
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function verificar_proponentes($documento,$password,$id_version,$registrado) {
		$proponentes = new Gel_proponentes;
		
		$proponentes->whereAdd("documento = '".$documento."'");
		//$proponentes->whereAdd("password = PASSWORD('".$password."') ");
		
		/* Si se est validando se le pide el password */
		if( $registrado == 1 )		
			$proponentes->whereAdd("password = '".$password."' ");

		$proponentes->whereAdd("id_versiones = '".$id_version."' ");			
			
		$cuantos = $proponentes->count();
		
		return $cuantos;
	}
	
    /**
 	 * Ingresar proponentes
	 * @param   string $numero_documento Nmero del documento de identidad del proponente
	 * @param   string $password Palabra clave del proponente
	 * @return  int $registrado 1 si esta registrado 0 si no
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function ingresar_proponentes($id_contrato,$documento,$nombre,$representante_legal,$direccion,$telefono,$email,$password,$password2,$registrado) {
        $mensaje = '';

		$proponentes        = new Gel_proponentes;
		$contrato_versiones = new Gel_contratos_versiones;
		
		$contrato_versiones->id_objeto = $id_contrato;
		
		if( !isset($_SESSION["sis_idioma"]["id_idioma"]) ) {
            $idioma = new Sis_idiomas;
			$idioma->get('enctype',$_SESSION['lang']);
			
			$contrato_versiones->id_idioma = $idioma->id_idioma;		
		} else {
			$contrato_versiones->id_idioma = $_SESSION["sis_idioma"]["id_idioma"];
 		}
		
		$contrato_versiones->find(true);
		$id_version = $contrato_versiones->id_versiones;

		/* Valida que la contrasea sea al menos de 6 caracteres */
		if (strlen($password) < 6) {
			$mensaje = "El password debe ser por lo menos de 6 caracteres";
			$_SESSION['mensaje'] = $mensaje;

			return $mensaje;
		}
		/* Valida que coincidan las contraseas */
		else if ( $registrado == 0 && ( $password != $password2 ) ) {
			$mensaje = "Las contraseas ingresadas no coinciden\n"; 
			$insertar_proponente = 0;					
			
			return $mensaje;
		}		

        /* Se verifica el proponente */ 
		$cuantos = Fachada_contratos::verificar_proponentes($documento,$password,$contrato_versiones->id_versiones,$registrado);

		/* Si no se ha registrado como proponente de un mismo contrato */
	    /* y lleg por el formulario de registro de proponentes        */
		if( $cuantos == 0 && $registrado == 0 ) {
				$proponentes->id_versiones         = $id_version;
				$proponentes->documento            = $documento;
				$proponentes->nombre               = $nombre;
				$proponentes->representante_legal  = $representante_legal;
				$proponentes->direccion            = $direccion;
				$proponentes->telefono             = $telefono;
				$proponentes->password             = $password;
				$proponentes->email                = $email; 
				
				$insertar_proponente = 1;
        }
		/* Si no se ha registrado como proponente de un mismo contrato */
	    /* y lleg por el formulario de validacin de proponentes      */
		else if ( $cuantos == 0 && $registrado == 1 ) {

			$oldproponente      = new Gel_proponentes;
		
		     $oldproponente->documento = $documento;
		     $oldproponente->password  = $password;			 

			if( $oldproponente->find(true) ) { 
				$proponentes->id_versiones         = $id_version;
				$proponentes->documento            = $documento;
				$proponentes->password             = $password;
				$proponentes->nombre               = $oldproponente->nombre;
				$proponentes->representante_legal  = $oldproponente->representante_legal;
				$proponentes->direccion            = $oldproponente->direccion;
				$proponentes->telefono             = $oldproponente->telefono;
				$proponentes->email                = $oldproponente->email; 
				
				$insertar_proponente = 1;
			}
			else {				
				$mensaje = "No est registrado como proponente de ningn contrato";
				$_SESSION['mensaje'] = $mensaje;
				
				return $mensaje;
			}
		}
		else {
			$mensaje = "Ya estaba registrado como proponente de ste contrato";
			$_SESSION['mensaje'] = $mensaje;
			
			return $mensaje;
		}

        if(	$insertar_proponente == 1 ) {

			 if( $id_proponente = $proponentes->insert() ) {
						
				$depmensaje = ($id_proponente) ? 'Se ingres un proponente' : 'Error al ingresar un proponente';
				Util::log('Contratos', 'ingresar_proponente', $depmensaje);		

				Generador_contratos::generar_detalle_contrato($id_contrato);			
					
				/* Se envia e-mail al proponente */
				$recipients = $proponentes->email;
				
				$headers['From']    = 'info@cms.telesat.com.co';
				$headers['To']      = $proponentes->email;
				$headers['Subject'] = '[CONTRATOS] Nuevo registro de proponente';
				
				$body  = "El registro del proponente ".$proponentes->nombre." ha sido exitoso!\n\n";
				$body .= "Estas son sus credenciales de acceso, por favor consrvelas para poder ingresar a nuestro sistema:\n\n";
				$body .= "Direccin: ".$proponentes->direccion."\n";
				$body .= "Su e-mail : ".$proponentes->email."\n";
				$body .= "Su clave: ".$proponentes->password."\n\n";
				$body .= "Si tiene inconvenientes, responda a este correo adjuntando el mensaje de error que\n";
				$body .= "recibe.\n\n\nCordialmente,\n\n\n Administrador\n ".NOMBRE_HOST;
	
				$mail_object =& Mail::factory('mail');
				$mail_object->send($recipients, $headers, $body);
				
				$mensaje = "Su registro ha sido satisfactorio.";
			 }
			 else {
				$mensaje = "Su registro no ha sido satisfactorio.";
		     }	

 		  $_SESSION['mensaje'] = $mensaje;
  		  return $mensaje;
        }

	}
	
    /**
 	 * Detallar proponente
	 * @param   string $id_proponente id del proponente
	 * @return  array $detalle_proponente Detalles del proponente
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function detallar_proponentes($id_proponente) {
		$proponentes = new Gel_proponentes;
		
		$proponentes->get($id_proponente);
        $detalle_proponente = $proponentes->toArray();
		return $detalle_proponente;
	}
	
    /**
 	 * Ingresar dependencias
	 * @param   string $nombre nombre de la dependencia
	 * @return  int $id_dependencia Id de la dependencia
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function ingresar_dependencias($nombre) {
	    $mensaje = '';
		
	    $datos_modulos = new Gel_datos_modulos_contratos;
    	$dependencias  = new Gel_dependencias;
		
		$datos_modulos->get('id_contenedor', $_SESSION["sitio"]["id_objeto"]);
		
		$dependencias->id_contenedor   = $datos_modulos->id_objeto;
		$dependencias->id_modulo       = $datos_modulos->id_objeto;
		$dependencias->nombre          = $nombre;
		
		if( $id = $dependencias->insert() ) {
			$mensaje .= '* La dependencia ' . $dependencias->getnombre() . ', ha sido ingresada\\n';		

			$depmensaje = ($id) ? 'Se insert la dependencia '.$dependencias->nombre : 'Error al insertar la dependencia '.$dependencias->nombre;
			Util::log('Contratos', 'ingresar_dependencias', $depmensaje);		
        }
		else 
			$mensaje .= '* La dependencia ' . $dependencias->getnombre() . ', NO ha sido ingresada\\n';		      

		return $mensaje;
	}	
	
    /**
 	 * modificar dependencias
	 * @param   string $nombre nombre de la dependencia a modificar
	 * @param   int $id_dependencia Id de la dependencia a modificar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function modificar_dependencias($nombre,$id_objeto) {
	 	$mensaje = '';
		
		if( $nombre != "" ) {	
			$dependencias  = new Gel_dependencias;
			
			$dependencias->id_objeto       = $id_objeto;
			$dependencias->nombre          = $nombre;
			
			$dependencias->get($id_objeto);
			if( !$id = $dependencias->update() ) {
				$mensaje .= '* La dependencia ' . $dependencias->getnombre() . ', no pudo ser actualizada\\n';
			}
			else {
				$mensaje .= '* La dependencia ' . $dependencias->getnombre() . ', ha sido actualizada\\n';
				
				$depmensaje = ($id) ? 'Se modific la dependencia '.$dependencias->id_objeto.' a '.$dependencias->getnombre() : 'Error al modificar la dependencia '.$dependencias->id_objeto.' a '.$dependencias->getnombre();
				Util::log('Contratos', 'modificar_dependencias', $depmensaje);		
			}
	    }
		else
				$mensaje .= '* La dependencia no puede ser actualizada por un valor vacio\\n';		   		
		
		return $mensaje;
	}		
	
     /**
 	 * Eliminar dependencias
	 * @param   array $lista_dependencias arreglo de dependencias a eliminar
     * @return  string $mensaje 
 	 * @author  Fernando Rengifo
     * @access  public
     */  
	 function borrar_dependencias($lista_dependencias)
	 {
	 	$mensaje = '';
	 
	 	foreach ($lista_dependencias as $id_dependencia => $v) {
			$dependencia = new Gel_dependencias;
			$dependencia->get($id_dependencia);
		
			$contratos = new Gel_contratos;
			$contratos->id_contenedor = $id_dependencia;

			if ($contratos->count() == 0) {
				$id = $dependencia->delete(); 
				$mensaje .= '* La dependencia ' . $dependencia->getnombre() . ' fue eliminada con xito.\\n';
				
				$depmensaje = ($id) ? 'Se elimin la dependencia '.$dependencia->nombre : 'Error al eliminar la dependencia '.$dependencia->nombre;
				Util::log('Contratos', 'borrar_dependencias', $depmensaje);		
			} else {
				$mensaje .= '* La dependencia ' . $dependencia->getnombre() . ' tiene contratos, no puede ser eliminada\\n';
			}
		}

		return $mensaje;
	 }  
	 
   /**
 	 * Listado de dependencias
	 * @return  array $lista_dependencia listado de dependencias
	 * @author  Fernando Rengifo
     * @access  public
     */  	 
	 
	function listado_dependencias($from) {
    	$dependencias  = new Gel_dependencias;

		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0;
		$data = DB_Pager::getData($from, NUM_REGISTROS, $dependencias->count(), MAXPAGES);

		$dependencias->limit($from, NUM_REGISTROS);

	 	$dependencias->find();
		$lista_dependencias = array();
		while ($dependencias->fetch()) 
			array_push($lista_dependencias, $dependencias->toArray());
		
		if( sizeof($lista_dependencias) == 0 ) {
			$mensaje = "No existen datos para listar";
			$_SESSION['mensaje'] = $mensaje;
		}

		return array("lista" => $lista_dependencias, "data" => $data);
	}			

     /**
 	 * Inserta la adicin de un archivo en el historial del contrato
     *
	 * @param   string $nombre nombre de la unidad ejecutora a ingresar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function insertar_historial_archivo($id_objeto,$id_tipo_archivo) {
		$historial    = new Gel_historial_contratos;
		$tipo_archivo = new Gel_tipos_archivos;
		
		$tipo_archivo->get($id_tipo_archivo);
        $historial->id_contrato   = $id_objeto;
		$historial->descripcion   = "Se adiciona ".$tipo_archivo->nombre;
		$historial->fecha         = date("Y-m-d H:i:s");
		
		$id = $historial->insert();
		
		$depmensaje = ($id) ? 'Se ingres un nuevo archivo al historial' : 'Error al ingresar un nuevo archivo al historial';
		Util::log('Contratos', 'insertar_historial_archivo', $depmensaje);		
		
	}

     /**
 	 * Inserta el cambio de estado de un contrato en el historial del contrato
     *
	 * @param   string $nombre nombre de la unidad ejecutora a ingresar
	 * @author  Fernando Rengifo
     * @access  public
     */  

	function insertar_historial_estado($id_objeto,$id_estado_entrante,$id_estado_actual) {
		$estado       = new Gel_estados;
		
		if( $id_estado_entrante > $id_estado_actual ) {
			$historial    = new Gel_historial_contratos;

			$estado->get($id_estado_entrante);
			
	        $historial->id_contrato   = $id_objeto;
			$historial->descripcion   = "Se cambia a ".$estado->nombre;
			$historial->fecha         = date("Y-m-d H:i:s");
			
			$id = $historial->insert();

			$depmensaje = ($id) ? 'Se cambia a '.$estado->nombre.' al historial del contrato '.$id_objeto.' el '.$historial->fecha : 'Error al cambiar a '.$estado->nombre.' al historial del contrato '.$id_objeto.' el '.$historial->fecha;
			Util::log('Contratos', 'insertar_historial_estado', $depmensaje);		
		}  
	}
	
	function listado_historial_contrato($id_contrato) {
		$historial        = new Gel_historial_contratos;
		
		$historial->id_contrato = $id_contrato;
		
	 	$historial->find();
		$lista_historial = array();
		while ($historial->fetch()) 
			array_push($lista_historial, $historial->toArray());
		
		$cuantos = sizeof($lista_historial);
		
		if( $cuantos == 0 ) {
			$mensaje = "No existe historial para ste contrato";
			$_SESSION['mensaje_historial'] = $mensaje;
		}

        return array("lista" => $lista_historial, "cuantos" => $cuantos); 
	}		
	
}

?>