<?php
/*
 * Accin para adicionar un contacto con cuestionario en el sitio
 *
 * @package  Cuestionarios
 * @version  1
 * @author JUNIOR TELLO <rtello@telesat.com.co> 
 * @since    PHP 4.1.2
 */

class cue_cnt_ingresar_respuestasAction extends Action
{
	/**
	 * Perform business logic to say "Hello" to a person.
	 *
	 * @access	public
	 * @param	ActionMapping	$actionMapping
	 * @param	ActionForm		$actionForm
	 * @return	ActionForward
	 */
	
	function perform($actionMapping, $actionForm) {
		
		$_SESSION['cue_mensaje'] = "";
		
		$id_contacto = Fachada_Contactos::adicionar_contacto(
			$actionForm->get('nombres'),
			$actionForm->get('apellido1'),
			$actionForm->get('apellido2'),
			$actionForm->get('tipo_id'),
			$actionForm->get('id'),
			$actionForm->get('email'),
			$actionForm->get('sexo'),
			$actionForm->get('empresa'),
			$actionForm->get('cargo'),
			$actionForm->get('tel_1'),
			$actionForm->get('tel_2'),
			$actionForm->get('celular'),
			$actionForm->get('fax'),
			$actionForm->get('dir_1'),
			$actionForm->get('dir_2'),
			$actionForm->get('cod_postal'),
			$actionForm->get('id_pais'),
			$actionForm->get('region'),
			$actionForm->get('ciudad'),
			$actionForm->get('id_formulario'));
		if ( $id_contacto == "" || $id_contacto == false ) {
			
			$_SESSION['cue_mensaje'] .= "\\nError: NO se pudo ingresar el contacto al sistema";
			$actionForward = $actionMapping->get('fracaso');
			$path  = $actionForward->getPath();
			$path .= $actionForm->get('page_name');
			$actionForward->setPath($path);
			return $actionForward;
			
		} elseif ( !Fachada_Contactos::enviar_mail_creacion_contacto(
			$actionForm->get('email'),
			$actionForm->get('asunto'),
			$actionForm->get('observaciones'),
			$actionForm->get('id_formulario')) ) {
			
			$_SESSION['cue_mensaje'] .= "\\nError: NO se pudo enviar el email";
			$actionForward = $actionMapping->get('fracaso');
			$path  = $actionForward->getPath();
			$path .= $actionForm->get('page_name');
			$actionForward->setPath($path);
			return $actionForward;
		} elseif (!Fachada_Cuestionarios::ingresar_respuestas($actionForm->get('id_cuestionario'),
			$actionForm->get('id_respuesta'),$actionForm->get('texto_respuesta'),$actionForm->get('numero_ip'),
			$actionForm->get('id_usuario'), $id_contacto)) {
			
			$_SESSION['cue_mensaje'] .= "\\nError: NO se pudo ingresar la informacin del cuestionario a la base de datos";
			$actionForward = $actionMapping->get('fracaso');
			$path  = $actionForward->getPath();
			$path .= $actionForm->get('page_name');
			$actionForward->setPath($path);
			return $actionForward;
		} else { // Todo sali bien
			$_SESSION['cms_mensaje'] = "Gracias por participar";
			$actionForward = $actionMapping->get('exito');
			return $actionForward;
		}
		
		$actionForward = $actionMapping->get('fracaso');
		$path  = $actionForward->getPath();
		$path .= $actionForm->get('page_name');
		$actionForward->setPath($path);
		return $actionForward;
	}
}
?>