<?php
/*
 * Accin para crear un cuestionario en el sitio
 *
 * @package  Cuestionarios
 * @version  1
 * @author JUNIOR TELLO <rtello@telesat.com.co> 
 * @since    PHP 4.1.2
 */

class cue_crear_cuestionarioAction extends Action
{
	/**
	 * Perform business logic to say "Hello" to a person.
	 *
	 * @access	public
	 * @param	ActionMapping	$actionMapping
	 * @param	ActionForm		$actionForm
	 * @return	ActionForward
	 */
	
	function perform($actionMapping, $actionForm) {
		$_SESSION['cue_mensaje'] = "";
		// Si se crea el cuestionario de nuevos contactos desde el modulo de cuestionarios
		// lo redireccionamos a la pagina de creacin de cuestionario y formulario
		if ( $actionForm->get('tipo') == 3 && $actionForm->get('id_formulario') == "" ) {
			$actionForward = $actionMapping->get('exito');
			$path  = 'index.php?view=src/cuestionarios/vistas/crear_cuestionario_contactos.php';
			$path .= '&nombre_cuestionario='.$actionForm->get('nombre_cuestionario');
			$actionForward->setPath($path);
			return $actionForward;
		}
		// Si se crea el cuestionario desde la modificacion del formulario de contactos
		// o desde el modulo de cuestionarios siempre que no sea tipo 3 (Nuevos Contactos)
		$id_cuestionario = Fachada_Cuestionarios::crear_cuestionario($actionForm->get('nombre_cuestionario'),
							$actionForm->get('tipo'),$actionForm->get('id_formulario'));
		
		if ( $id_cuestionario == false ) {
//echo "RETORNO FALSE";exit();
			$_SESSION['cue_mensaje'] .= "\\nError: NO se pudo crear el cuestionario";
			$actionForward = $actionMapping->get('fracaso');
			return $actionForward;
		}
		// Si es una encuesta redireccionamos a la pagina de creacin de pregunta de seleccion multiple del cuestionario
		if ( $actionForm->get('tipo') == 4 ) {
			$_SESSION['cue_mensaje'] = "\\nLa encuesta ha sido creada";
			$actionForward = $actionMapping->get('exito');
			$path  = 'phrame.php?action=cue_cargar_encuesta';
			$path .= '&nombre_cuestionario='.$actionForm->get('nombre_cuestionario');
			$path .= '&id_cuestionario='.$id_cuestionario;
			$actionForward->setPath($path);
			return $actionForward;
		}
		
		// Si sigue es porque el cuestionario YA ha sido creado
		$_SESSION['cue_mensaje'] = "\\nEl cuestionario ha sido creado";
		$_SESSION['cue_preguntas'] = Fachada_Cuestionarios::cargar_editar_cuestionario($id_cuestionario);
//print_r($_SESSION['cue_preguntas']);exit();
		$actionForward = $actionMapping->get('exito');
		
		return $actionForward;
	}
}
?>