<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */
 /**
 * Generador de los cuestionarios
 *
 * @package Cuestionarios
 * @version 1.1
 * @author Junior Tello <rtello@telesat.com.co> 
 * @since   PHP 4.1.2
 */
 class Generar_cuestionarios
{
	/*
	 * Genera los archivos html que contienen los cuestionarios
	 *
	 * @param  int    $id_cuestionario  identificador del cuestionario
	 *
	 * @return void no devuelve nada.
	 */
	function generar_cuestionarios($id_cuestionario = 0)
	{ // print_r($_SESSION['sitio']);exit;
	
		/**** Generar todo el mdulo cuestionarios *****/
		if (!$id_cuestionario) {
			$modulo = new cue_datos_modulos_cuestionarios;
			$modulo->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
				
			// Generacin de categorias.
			$cuestionarios = new Cue_cuestionarios;
			$cuestionarios->id_contenedor = $modulo->id_objeto;
			$cuestionarios->find();
			while ($cuestionarios->fetch())
				Generar_cuestionarios::generar_cuestionarios($cuestionarios->id_objeto);
				
			return;
		}
		/******************/
	
		$path_idioma = "html/" . $_SESSION['sitio']['url']."/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$idioma = new Sis_idiomas;
		$idioma->get($_SESSION['sis_idioma']['id_idioma']);
		
		// Buscamos los cuestionarios del sitio (id_sitio)
		$dm_cuestionarios = new Cue_datos_modulos_cuestionarios;
		$dm_cuestionarios->get('id_contenedor',$_SESSION['sitio']['id_objeto']);
		$cuestionario = new Cue_cuestionarios;
		$cuestionario->id_objeto = $id_cuestionario;
		$cuestionario->id_contenedor = $dm_cuestionarios->id_objeto;
		
		// Si no encuentra el cuestionario devuelve falso
		if (!$cuestionario->find(true)) {
			$_SESSION['cue_mensaje'] = "\\nNo se encontr el cuestionario en la base de datos";
			return false;
		}
		
		$archivo = "pagina_" . $cuestionario->id_objeto . ".php";
		if ($cuestionario->tipo == 4) $archivo = "encuesta.php";
//echo "JUAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA".$idioma->enctype;print_r($idioma);exit();
		$archivo_formulario = $path_idioma . "/" . $archivo; //echo "AF: ".$archivo_formulario;
		$contenido_articulo = '';
		// cargamos las preguntas del cuestionario
		$preguntas = Fachada_Cuestionarios::cargar_cuestionario_pre($cuestionario->id_objeto);
		$opciones = Fachada_Cuestionarios::cargar_cuestionario_pre_opc($cuestionario->id_objeto);
		
		$template_catalogo = "src/cuestionarios/vistas/tpl_cuestionarios.php";
		if ($cuestionario->tipo == 4) $template_catalogo = "src/cuestionarios/vistas/tpl_encuestas.php";
		include($template_catalogo);
		
		// Se escribe la cabecera del portal
		$data = explode("/",$path_idioma);
		array_shift($data);
		array_shift($data);
		$vistas = implode("/",$data);
		
		// Copiamos el contenido del cuestionario
		File::writeLine($archivo_formulario, stripslashes($contenido_articulo), FILE_MODE_WRITE);
		File::close ($archivo_formulario, FILE_MODE_WRITE);
		
		return true;
	}	
}
?>