<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.3.3                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |		  John Vargas <jhonvargas@telesat.com.co>                     |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
// $Id: fachada_cuestionarios.php,v 1.9 2004/06/28 22:21:37 rtello Exp $
//
// Clase Fachada que maneja el paquete cuestionarios
//

// Clases necesarias
// MODELO

require_once PATH_CUESTIONARIOS . 'modelo/Cue_cuestionarios.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_cuestionarios_versiones.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_datos_modulos_cuestionarios.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_posibles_respuestas.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_posibles_respuestas_versiones.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_preguntas.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_preguntas_versiones.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_respuestas_cuestionarios.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_rc_anonimos.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_rc_contactos_nuevos.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_rc_registrados.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_respuestas_preguntas.php';
require_once PATH_CUESTIONARIOS . 'modelo/Cue_tipos_preguntas.php';
// CONTROLADOR
// Mapping 
include(PATH_CUESTIONARIOS . 'controlador/mappings.php');
// Genenerador
include(PATH_CUESTIONARIOS . 'modelo/Generar_cuestionarios.php');
// clases necesarias
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_crear_cuestionarioAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_crear_cuestionario_contactosAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_buscar_cuestionariosAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_eliminar_cuestionariosAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_cargar_editar_cuestionarioAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_editar_cuestionarioAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_subir_preguntaAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_borrar_preguntasAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_crear_preguntaAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_cargar_crear_preguntaAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_cargar_editar_preguntaAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_editar_preguntaAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_ingresar_respuestasAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_cnt_ingresar_respuestasAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_cargar_estadisticasAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_buscar_usr_respuestaAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_respuestas_individualesAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_cargar_resp_texto_individualesAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_cargar_encuestaAction.php');
include(PATH_CUESTIONARIOS . 'controlador/actions/cue_crear_excel_encuestaAction.php');
/**
 * Esta clase tiene los mtodos para la creacin, interaccin y administracin de los cuestionarios
 * y formularios de contactos del sitio.
 * Tipos de usuarios de los cuestionarios:
 * 1. Annimos
 * 2. Registrados
 * 3. Nuevos Contctos
 *
 * @package  Cuestionarios
 * @version  1
 * @author   JUNIOR TELLO <rtello@telesat.com.co>
 * @since    PHP 4.3.3
 */

class Fachada_Cuestionarios {
	/*
	 * Administracin.
	 * Crea la fila que identifica a los cuestionarios del sitio en la tabla
	 * datos modulos cuestionarios
	 *
	 * @return bool true si la configuaracin del formulario fu exitosa, false en caso contrario.
	 */
	function configurar_cuestionarios() {
		// NO se ha logueado en el sitio
		if ( $_SESSION['sitio']['id_objeto'] == "" ) {
			return false;
		}
		// creamos la fila en la tabla cnt_datos_modulos_cuestionarios
		$dm_cue = new Cue_datos_modulos_cuestionarios;
		$dm_cue->id_contenedor = $_SESSION['sitio']['id_objeto'];
		$dm_cue->nombre = "Cuestionario";
		$dm_cue->id_tipo = 2; // 3 es el tipo de datos modulo que identifica a un cuestionario
		$id = $dm_cue->insert();
		
		return ($id > 0);
	}
	
	/*
	 * Crea un cuestionario en el sistema.
	 *
	 * @param string  $nombre  nombre del cuestionario
	 * @param int     $tipo    tipo del cuestionario segn usuarios (annimos, usuarios del sistema, contactos)
	 *
	 * @return object objeto cuestionarios con los datos del mismo si su creacin fu exitosa,
	 *                false en caso contrario.
	 */
	function crear_cuestionario($nombre,$tipo,$id_formulario) {
		// Si el nombre es vaco
		if ( $nombre == "" ) {
			$_SESSION['cue_mensaje'] = "\\nDebe escribir un nombre para el cuestionario";
			return false;
		}
		
		if ($tipo == "") $tipo = 1;
		// creamos la fila en la tabla cue_datos_modulos_cuestionarios
		$dm_cue = new Cue_datos_modulos_cuestionarios;
		$dm_cue->id_contenedor = $_SESSION['sitio']['id_objeto'];
		if ($dm_cue->find(true)) {
			// Buscamos el total de cuestionarios que ha creado el usuario
			$cue = new Cue_cuestionarios;
			$cue->id_contenedor = $dm_cue->id_objeto;
			$num_cues = $cue->find();  //print_r($dm_cue);exit;
			// Chequeamos que no se pase del lmite de cuestionarios
			if ($num_cues >= $dm_cue->num_cues) {
				$_SESSION['cue_mensaje'] = "\\nYa ha alcanzado el nmero mximo de cuestionarios que puede crear";
				return false;
			}
			// creamos la fila en la tabla cue_cuestionarios
			$cue = new Cue_cuestionarios;
			$cue->id_contenedor = $dm_cue->id_objeto;
			$cue->tipo = $tipo;
			$id1 = $cue->insert();
			// creamos la fila en la tabla cue_cuestionarios_versiones
			$cue_v = new Cue_cuestionarios_versiones;
			$cue_v->id_objeto = $cue->id_objeto;
			$cue_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			$cue_v->nombre = $nombre;
			$id2 = $cue_v->insert();
			
			// enlazamos el cuestionario con el formulario de contactos si el tipo=3 y generamos el 
			if ($tipo == 3 && $id_formulario != "") {
				$formulario = new Cnt_formularios;
				$formulario->get($id_formulario);
				$formulario->id_cuestionario = $cue->id_objeto;
				$formulario->update();
				// Generamos el formulario de contactos porque ahora esta enlazado a un cuestionario
				// entonces cambia el action del form...
				Generar_contactos::generar_contactos($id_formulario);
			}
			
			// Si es una encuesta entonces le creamos una pregunta por default, que es la nica que tendr
			if ($tipo == 4) {
				$pregunta = new Cue_preguntas;
				$pregunta_v = new Cue_preguntas_versiones;
				$posresp = new Cue_posibles_respuestas;
				$posresp_v = new Cue_posibles_respuestas_versiones;
				// ingresamos la pregunta
				$pregunta->id_cuestionario = $cue->id_objeto;
				$pregunta->tipo = 1;
				$pregunta->numero_preg = 1;
				$pregunta->requerida = "t";
				$pregunta->insert();
				// la version de la pregunta
				$pregunta_v->id_objeto = $pregunta->id_pregunta;
				$pregunta_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
				$pregunta_v->descripcion = "Escriba aqui el contenido de la pregunta";
				$pregunta_v->insert();
				// ingresamos la primera opcion y su version
				$posresp->id_pregunta = $pregunta->id_pregunta;
				$posresp->tipo = 1;
				$posresp->numero = 1;
				$posresp->insert();
				$posresp_v->id_objeto = $posresp->id_respuesta;
				$posresp_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
				$posresp_v->nombre = "Escriba aqui la opcion 1";
				$posresp_v->insert();
				// ingresamos la segunda opcion y su version
				$posresp = new Cue_posibles_respuestas;
				$posresp_v = new Cue_posibles_respuestas_versiones;
				$posresp->id_pregunta = $pregunta->id_pregunta;
				$posresp->tipo = 1;
				$posresp->numero = 2;
				$posresp->insert();
				$posresp_v->id_objeto = $posresp->id_respuesta;
				$posresp_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
				$posresp_v->nombre = "Escriba aqui la opcion 2";
				$posresp_v->insert();
			}
//print_r($cue_v);exit();
		} else {
			$_SESSION['cue_mensaje'] = "\\nNo existe el identificador de cuestionarios del sitio";
			return false;
		}
		// Generamos el archivo html del cuestionario
		Generar_cuestionarios::generar_cuestionarios($cue->id_objeto);
		
		// Devuelve el identificador del nuevo cuestionario (si lo cre).
		if ($id1 > 0 && $id2 > 0) {
			Util::log('Cuestionarios', 'Crear Cuestionario', 'Se creo el cuestionario');
			return $cue->id_objeto;
		} else {
			Util::log('Cuestionarios', 'Crear Cuestionario', 'No se creo el cuestionario');
		}
		
		return false;
	}
	
	/*
	 * Bsqueda de cuestionarios
	 *
	 * @param int    $from                el limite inicial de la bsqueda
     * @param string $mes_creacion        mes en que se cre el cuestionario
	 * @param string $anno_creacion       ao en que se cre el cuestionario
     * @param string $nombre_cuestionario nombre del cuestionario
     * @param int    $tipo                tipo del cuestionario
     * @param string $id_sitio            identificador del sitio en la base de datos
     *
	 * @author Junior Tello <rtello@telesat.com.co>
	 * @return array Arreglo asociativo con la lista de cuestionarios
	 */
	function buscar_cuestionarios($from, $mes_creacion, $anno_creacion, $nombre_cuestionario, $tipo, $id_sitio) {
		$cue = new Cue_cuestionarios;
		$cue_v = new Cue_cuestionarios_versiones;
		$dm_cue = new Cue_datos_modulos_cuestionarios;
		
		// Capturamos el identificador de los cuestionarios del sitio
		$dm_cue->id_contenedor = $id_sitio;
		$dm_cue->find(true); // Ya tenemos el $dm_cue->id_objeto
		
		// Buscamos el id_objeto de datos modulos cuestionarios
		$dm_cues2 = new Cue_datos_modulos_cuestionarios;
		$dm_cues2->get('id_contenedor',$_SESSION['sitio']['id_objeto']);
		
		// creacion de versiones de cuestionarios
		$cue2 = new Cue_cuestionarios;
		$cue2->id_contenedor = $dm_cues2->id_objeto;
		$cue2->find();
		while ($cue2->fetch()) { // print_r($cue2);exit();
			$cue_v2 = new Cue_cuestionarios_versiones;
			$cue_v2->id_objeto = $cue2->id_objeto;
			$cue_v2->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			if (!$cue_v2->find(true))
				Fachada_Sistema::crear_version(&$cue_v2, $_SESSION['sis_idioma']['id_idioma']);
		}
		
		// Datos del cuestionario
		if ($mes_creacion != '')
			$cue->whereAdd('fecha_creacion LIKE (\'%-'.$mes_creacion.'-%\')');
		
		if ($anno_creacion != '')
			$cue->whereAdd('fecha_creacion LIKE (\'%'.$anno_creacion.'-%\')');
		
		if ($tipo != '')
			$cue->whereAdd('tipo = '.$tipo);
		
		// Hacemos el join entre cuestionarios y cuestionarios_versiones
		$cue_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$cue->joinAdd($cue_v); // Se une cuestionario_versiones a cuestionario
		$cue->selectAs();
		$cue->selectAs($cue_v, 'cue_v_%s');
		
		if ($nombre_cuestionario != '')
			$cue->whereAdd("LOWER(nombre) LIKE LOWER('%$nombre_cuestionario%')");
		
		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0; 
		$data = DB_Pager::getData($from, NUM_REGISTROS, $cue->count(), MAXPAGES);
		
		$cue->limit($from, NUM_REGISTROS);
		$cue->orderBy('fecha_creacion');
		$cue->orderBy('nombre');
		$cue->find();  //echo "QUE PIERNOTAS";print_r($cue);exit();
		
		$lista_cuestionarios = array();
		while ($cue->fetch()) 
			array_push($lista_cuestionarios, get_object_vars ($cue));
		
		return array('lista' => $lista_cuestionarios, 'data' => $data);
	}
	
	/*
	 * Carga los cuestionarios de tipo contactos
	 *
	 * @return array arreglo de objetos cuestionario con los datos de los mismos
	 */
	function cargar_cuestionarios_contactos() {
		// Hacemos el join entre las dos tablas de cuestionarios
		$cuestionario = new Cue_cuestionarios;
		$cuestionario_v = new Cue_cuestionarios_versiones;
		
		$cuestionario->tipo = 3; // el tipo de cuestionario es de contactos
		$cuestionario->joinAdd($cuestionario_v);
		$cuestionario->selectAs();
		$cuestionario->selectAs($cuestionario_v, 'cuestionario_v_%s');
		$cuestionario->orderBy('cuestionario_v_nombre');
		$cuestionario->find();
		while ($cuestionario->fetch()) //print_r($cuestionario);exit();
			$cue_arr[] = $cuestionario;
		
		return $cue_arr;
	}
	
	/*
	 * Busca los usuarios que han respondido el cuestionario
	 *
	 * @param int    $from             el limite inicial de la bsqueda
     * @param int    $id_cuestionario  identificador del cuestionario
     * @param string $param_usuario    identificador del usuario que cambia segn el tipo de cuestionario
	 *
	 * @return array arreglo de objetos cuestionario con los datos de los mismos, false si hay algn error.
	 */
	function buscar_usr_respuesta($from,$id_cuestionario,$param_usuario) {
		$cuestionario = new Cue_cuestionarios;
		$resp_cue = new Cue_respuestas_cuestionarios;
		
		// Chequeamos que el cuestionario exista y su tipo
		if (!$cuestionario->get($id_cuestionario)) return false;
		
		// dependiendo del tipo del cuestionario el valor de la primera columna cambia
		if ($cuestionario->tipo == 1 || $cuestionario->tipo == 4) { // Usuarios anonimos
			$resp_cue = new Cue_rc_anonimos;
			if ($param_usuario != '')
				$resp_cue->whereAdd("ip LIKE '%$param_usuario%'");
		// Si el cuestionario es tipo usuarios el parametro es un login (campo nombre)
		} elseif ($cuestionario->tipo == 2) { // Usuarios registrados (id_usuario)
			$resp_cue = new Cue_rc_registrados;
			$usuario = new Sis_usuarios;
			if ($param_usuario != '')
				$resp_cue->whereAdd("LOWER(nombre) LIKE LOWER('%$param_usuario%')");
			// Hacemos el join con la tabla de usuarios
			$resp_cue->joinAdd($usuario);
			$resp_cue->selectAs();
			$resp_cue->selectAs($usuario, 'usuario_%s');
		} elseif ($cuestionario->tipo == 3) { // Usuarios nuevos contctos (id_contacto)
			$resp_cue = new Cue_rc_contactos_nuevos;
			$contactos = new Cnt_contactos_externos;
			if ($param_usuario != '')
				$resp_cue->whereAdd("LOWER(email) LIKE LOWER('%$param_usuario%')");
			// Hacemos el join con la tabla de contactos externos
			$resp_cue->joinAdd($contactos);
			$resp_cue->selectAs();
			$resp_cue->selectAs($contactos, 'contactos_%s');
		}
		$resp_cue->whereAdd('id_cuestionario='.$id_cuestionario);
		
		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0; 
		$data = DB_Pager::getData($from, NUM_REGISTROS, $resp_cue->count(), MAXPAGES);
		
		$resp_cue->limit($from, NUM_REGISTROS);
		$resp_cue->orderBy('fecha');
//		$resp_cue->orderBy('nombre');
		$resp_cue->find();  //echo "QUE PIERNOTAS";print_r($cue);exit();
		$lista_usr_resp = array();
		while ($resp_cue->fetch()) //print_r($resp_cue);exit();
			array_push($lista_usr_resp, get_object_vars ($resp_cue));
//print_r($lista_usr_resp);exit();
		
		return array('lista' => $lista_usr_resp, 'data' => $data, 'tipo' => $cuestionario->tipo);
	}
	
	/*
	 * Elimina la relacin entre el cuestionario que se v a eliminar y el formulario
	 * que est vinculado a ste
	 *
	 * @param  int  $id_cuestionario  identificador del cuestionario
	 *
	 * @return bool true si neutraliza el campo cuestionario del formulario
	 */
	function neutralizar_cuestionario_en_formulario($id_cuestionario) {
		// si hay un formulario con cuestionario ponemos su id_cuestionario en NULL y generamos la pagina
		$formul = new Cnt_formularios;
		$formul->id_cuestionario = $id_cuestionario;
		if ($formul->find()) {
			while ($formul->fetch()) {
				$formul2 = new Cnt_formularios;
				$formul2->get($formul->id_objeto);
				$formul2->id_cuestionario = 'NULL';
				$formul2->update();
				// volvemos a generar la pgina del formulario (porque ya no tiene la pgina del cuestionario)
				Fachada_Contactos::generar_contactos($formul->id_objeto);
			}
		}
		
		return true;
	}
	
	/*
	 * Elimina uno o varios cuestionarios de la base de datos
	 *
	 * @param  array $arr_id_cuestionarios arreglo de identificadores de los cuestionarios a eliminar
	 *
	 * @return bool  true si se eliminaron los cuestionarios false en caso contrario.
	 */
	function eliminar_cuestionarios($arr_id_cuestionarios) {
		// Borramos cada uno de los id_contactos que vienen en el arreglo recibido
		$cue = new Cue_cuestionarios;
		$tam_arra = sizeof($arr_id_cuestionarios);
		$path = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'] . "/";
		
		if (!$tam_arra) {
			$_SESSION['cue_mensaje'] = "\\nDebe seleccionar al menos un diccionario para eliminar";
			return false;
		} elseif ($tam_arra == 1) {
			$cue2 = new Cue_cuestionarios;
			$cue2->get($arr_id_cuestionarios[0]);
			$cue->whereAdd('id_objeto ='.$arr_id_cuestionarios[0]);
			// si hay un formulario con cuestionario ponemos su id_cuestionario en NULL y generamos la pagina del formulario
			if (in_array("Contactos", $_SESSION['modulos']) && $cue2->tipo == 3) {
				Fachada_Cuestionarios::neutralizar_cuestionario_en_formulario($arr_id_cuestionarios[0]);
			}
			// borramos la pgina del cuestionario
			unlink($path."pagina_".$arr_id_cuestionarios[0].".php");
			// lo borramos del men (conexion entre id_objeto de menu y el id_pagina del cuestionario)
			$men_ei = new Men_enlaces_internos;
			$men_ei->id_pagina = $arr_id_cuestionarios[0];
			if ($men_ei->find(true)) // si est en el men
				Fachada_Menus::eliminar_item($men_ei->id_objeto); // se borra del men
		} else // es ms de un cuestionario
			for ($i=0; $i < $tam_arra; $i++) {
				$cue2 = new Cue_cuestionarios;
				$cue2->get($arr_id_cuestionarios[$i]);
				$cue->whereAdd('id_objeto ='.$arr_id_cuestionarios[$i], 'OR');
				// si hay un formulario con cuestionario ponemos su id_cuestionario en NULL y generamos la pagina del formulario
				if (in_array("Contactos", $_SESSION['modulos']) && $cue2->tipo == 3) {
					Fachada_Cuestionarios::neutralizar_cuestionario_en_formulario($arr_id_cuestionarios[$i]);
				}
				// borramos la pgina del cuestionario
				unlink($path."pagina_".$arr_id_cuestionarios[$i].".php");
				// lo borramos del men (conexion entre id_objeto de menu y el id_pagina del cuestionario)
				$men_ei = new Men_enlaces_internos;
				$men_ei->id_pagina = $arr_id_cuestionarios[$i];
				if ($men_ei->find(true)) // si est en el men
					Fachada_Menus::eliminar_item($men_ei->id_objeto); // se borra del men
			}
		
		$id1 = $cue->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		
		if ($id1 > 0) Util::log('Cuestionarios', 'Eliminar Cuestionarios', 'Se elimino el(los) cuestionario(s)');
		else Util::log('Cuestionarios', 'Eliminar Cuestionarios', 'No se elimino el(los) cuestionario(s)');
		
		return ($id1 > 0);
	}
	
	/*
	 * Carga los datos del cuestionario a editar
	 *
	 * @param  int  $id_cuestionario identificador del cuestionario
	 *
	 * @return array arreglo de objetos con las preguntas del cuestionario y los datos del mismo, false en caso contrario.
	 */
	function cargar_editar_cuestionario($id_cuestionario) {
		$cue = new Cue_cuestionarios;
		$cue_v = new Cue_cuestionarios_versiones;
		$preguntas = new Cue_preguntas;
		$preguntas_v = new Cue_preguntas_versiones;
		$tipos_p = new Cue_tipos_preguntas;
		
		// capturamos la informacin del cuestionario
		if (!$cue->get($id_cuestionario)) {
			$_SESSION['cue_mensaje'] .= "\\nEl cuestionario no se encontr en la base de datos";
			return false;
		}
		// Buscamos el id_objeto de datos modulos cuestionarios
		$dm_cues2 = new Cue_datos_modulos_cuestionarios;
		$dm_cues2->get('id_contenedor',$_SESSION['sitio']['id_objeto']);
		
		// creacion de versiones de cuestionarios
		$cue2 = new Cue_cuestionarios;
		$cue2->id_contenedor = $dm_cues2->id_objeto;
		$cue2->find();
		while ($cue2->fetch()) { // print_r($cue2);exit();
			$cue_v2 = new Cue_cuestionarios_versiones;
			$cue_v2->id_objeto = $cue2->id_objeto;
			$cue_v2->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			if (!$cue_v2->find(true))
				Fachada_Sistema::crear_version(&$cue_v2, $_SESSION['sis_idioma']['id_idioma']);
		}
		
		// capturamos la version para este idioma
		$cue_v->id_objeto = $id_cuestionario;
		$cue_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		if (!$cue_v->find(true)) {
			$_SESSION['cue_mensaje'] .= "\\nHay un error en las versiones del cuestionario";
			return false;
		}
		// almacenamos los datos del cuestionario en la sesion
		$cuestionario->id_objeto = $cue->id_objeto;
		$cuestionario->tipo = $cue->tipo;
		$cuestionario->fecha_creacion = $cue->fecha_creacion;
		$cuestionario->nombre = $cue_v->nombre;
		$cuestionario->id_formulario = "";
		// Tratamos de encontrar el formulario al que est linkeado este cuestionario (si existe)
		if ($cue->tipo == 3) {
			$formulario = new Cnt_formularios;
			$formulario->id_cuestionario = $id_cuestionario;
			if ($formulario->find(true))
				$cuestionario->id_formulario = $formulario->id_objeto;
		}
		
		// creacion de versiones de preguntas
		$preg2 = new Cue_preguntas;
		$preg2->id_cuestionario = $cue->id_objeto;
		$preg2->find();
		while ($preg2->fetch()) { // print_r($preg2);exit();
			$preg_v2 = new Cue_preguntas_versiones;
			$preg_v2->id_objeto = $preg2->id_pregunta;
			$preg_v2->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			if (!$preg_v2->find(true))
				Fachada_Sistema::crear_version(&$preg_v2, $_SESSION['sis_idioma']['id_idioma']);
		}
		// ahora capturamos las preguntas del cuestionario
		$preguntas->id_cuestionario = $id_cuestionario;
		$preguntas_v = new Cue_preguntas_versiones;
		$preguntas_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$preguntas->joinAdd($preguntas_v); // Se une preguntas_versiones a preguntas
		$preguntas->orderBy('numero_preg');
		$preguntas->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
 		$tipos_p->id_idioma = 1;//$_SESSION['sis_idioma']['id_idioma'];
		$preguntas->joinAdd($tipos_p);
		$preguntas->selectAs();
		$preguntas->selectAs($preguntas_v, 'preguntas_v_%s');
		$preguntas->selectAs($tipos_p, 'tipreg_%s');
		$preguntas->find();//print_r($preguntas);
		
		$questions = array();
		while ($preguntas->fetch()) {
			$questions[] = $preguntas;
		}
		$questions['cuestionario'] = $cuestionario;
//echo "AAAAAAA";print_r($questions);exit();
		return $questions;
	}
	
	/*
	 * Cambia el nombre de un cuestionario
	 *
	 * @param  int     $id_cuestionario identificador del cuestionario
	 * @param  string  $nombre          nuevo nombre del cuestionario
	 *
	 * @return bool  true si se edit el cuestionario false en caso contrario.
	 */
	function editar_cuestionario($id_cuestionario,$nombre) {
		
		$cue = new Cue_cuestionarios;
		$cue_v = new Cue_cuestionarios_versiones;
		
		$cue_v->nombre = $nombre;
		$cue_v->whereAdd('id_objeto='.$id_cuestionario);
		$cue_v->whereAdd('id_idioma='.$_SESSION['sis_idioma']['id_idioma']);
		$id = $cue_v->update();
		
		Generar_cuestionarios::generar_cuestionarios($id_cuestionario);
		if ($id > 0) Util::log('Cuestionarios', 'Editar Cuestionarios', 'Se edito el cuestionario');
		else Util::log('Cuestionarios', 'Editar Cuestionarios', 'No se edito el cuestionario');
		return ($id > 0);
	}
	
	/*
	 * Sube un lugar la pregunta al desplegar la lista de preguntas
	 *
	 * @param  string  $pregunta_subir  identificador de la pregunata a subir
	 * @param  string  $pregunta_bajar  identificador de la pregunata a bajar
	 * @param  int     $id_cuestionario identificador del cuestionario
	 *
	 * @return bool  true si se subi la pregunta y false en caso contrario.
	 */
	function subir_pregunta($pregunta_subir, $pregunta_bajar, $id_cuestionario) {
		
		$pregunta1 = new Cue_preguntas;
		$pregunta2 = new Cue_preguntas;
		
		// Hacemos el cambio en el orden de pregunta entre las dos filas
		$pregunta1->get($pregunta_subir);
		$pregunta2->get($pregunta_bajar);
		$numero_preg_one = $pregunta1->numero_preg; 
		$pregunta1->numero_preg = $pregunta2->numero_preg;
		$id1 = $pregunta1->update();
		
		$pregunta2->numero_preg = $numero_preg_one;
		$id2 = $pregunta2->update();
		
		Generar_cuestionarios::generar_cuestionarios($id_cuestionario);
		return ($id1 > 0 && $id2 > 0);
	}
	
	/*
	 * Elimina una pregunta de un cuestionario dado
	 *
	 * @param  array  $arr_preguntas   arreglo de identificadores de pregunatas
	 * @param  int    $id_cuestionario identificador del cuestionario
	 *
	 * @return bool  true si se elimin la pregunta y false en caso contrario.
	 */
	function eliminar_preguntas($arr_preguntas, $id_cuestionario) {
		
		$preguntas = new Cue_preguntas;
		$preguntas_v = new Cue_preguntas_versiones;
		$posresp = new Cue_posibles_respuestas;
		$posresp_v = new Cue_posibles_respuestas_versiones;
		
//print_r($arr_preguntas);exit();
		// Hacemos el cambio en el orden de pregunta entre las dos filas
		for ($i=0; $i < sizeof($arr_preguntas); $i++) {
			$preguntas_v->whereAdd('id_objeto='.$arr_preguntas[$i], 'OR');
			$preguntas->whereAdd('id_pregunta='.$arr_preguntas[$i], 'OR');
			$posresp->whereAdd('id_pregunta='.$arr_preguntas[$i], 'OR');
			$posresp_v->whereAdd('id_objeto='.$arr_preguntas[$i], 'OR');
		}
		$id1 = $preguntas_v->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		$id2 = $preguntas->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		$posresp->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		$posresp_v->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		
		Generar_cuestionarios::generar_cuestionarios($id_cuestionario);
		if ($id1 > 0 && $id2 > 0) Util::log('Cuestionarios', 'Eliminar Preguntas', 'Se eliminaron las preguntas');
		else Util::log('Cuestionarios', 'Eliminar Preguntas', 'No se eliminaron las preguntas');
		return ($id1 > 0 && $id2 > 0);
	}
	
	/*
	 * Crea una pregunta con sus posibles respuestas en un cuestionario dado
	 *
	 * @param  string $nombre_pregunta  nombre de la pregunta
	 * @param  string $texto_pregunta   texto de la pregunta
	 * @param  string $texto_post       texto que va despues del texto de la pregunta
	 * @param  int    $columnas         nmero de columnas de la pregunta si es un textarea
	 * @param  int    $filas            nmero de filas de la pregunta si es un textarea
	 * @param  bool   $requerida        nos dice si la pregunta es de respuesta obligatoria o no
	 * @param  array  $opcion           arreglo de opciones a escoger de la pregunta
	 * @param  string $pregunta_abierta pregunta abierta
	 * @param  int    $id_cuestionario  identificador del cuestionario
	 * @param  int    $tipo_pregunta    tipo de pregunta
	 *
	 * @return bool  true si se elimin la pregunta y false en caso contrario.
	 */
	function crear_pregunta($nombre_pregunta, $texto_pregunta, $texto_post, $columnas, $filas, $requerida,
			$opcion, $pregunta_abierta, $id_cuestionario, $tipo_pregunta) {
//echo "idioma: ".$_SESSION['sis_idioma']['id_idioma'];exit();
		$_SESSION['cue_mensaje'] = "";
		$preguntas = new Cue_preguntas;
		$preguntas_v = new Cue_preguntas_versiones;
		
		// Sacamos el numero de preguntas para este cuestionario
		$preguntas->id_cuestionario = $id_cuestionario;
		$total_preguntas_cue = $preguntas->find();
		//Chequeamos que no se pase del limite de preguntas para el cuestionario
		$dm_cue = new Cue_datos_modulos_cuestionarios;
		$cue = new Cue_cuestionarios;
		$cue->get($id_cuestionario);
		$dm_cue->get($cue->id_contenedor);
		if ($total_preguntas_cue >= $dm_cue->num_pregs) {
			$_SESSION['cue_mensaje'] = "Ya ha alcanzado el nmero de mximo de preguntas por cuestionario";
			return false;
		}
		
		// Buscamos el mximo en el orden de las preguntas del cuestionario
		$preguntas = new Cue_preguntas;
		$preguntas->selectAdd();
		$preguntas->selectAdd("MAX(numero_preg) as orden_preg ");
		$preguntas->id_cuestionario = $id_cuestionario;
		if ($preguntas->find(true))
			$orden_preg = ++$preguntas->orden_preg;
		else 
			$orden_preg = 1;
		
		// Llenamos la tabla preguntas
		$preguntas = new Cue_preguntas;
		$preguntas->id_cuestionario = $id_cuestionario;
		$preguntas->tipo = $tipo_pregunta;
		$preguntas->numero_preg = $orden_preg;
		if ($columnas != '') $preguntas->columnas = $columnas;
		if ($filas != '') $preguntas->filas = $filas;
		if ($requerida == 't') $preguntas->requerida = $requerida;
		$id1 = $preguntas->insert();//print_r($preguntas);
		// Llenamos la tabla preguntas_versiones
		$preguntas_v->id_objeto = $preguntas->id_pregunta;
		$preguntas_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$preguntas_v->nombre = $nombre_pregunta;
		$preguntas_v->descripcion = $texto_pregunta;
		$preguntas_v->texto_post = $texto_post;
		$id2 = $preguntas_v->insert();//print_r($preguntas_v);exit();
		
		$posresp = new Cue_posibles_respuestas;
		$posresp_v = new Cue_posibles_respuestas_versiones;
		
		$orden_resp = 1;
		// Ingresamos el contenido del arreglo opcion
		for ($i=0; $i < sizeof($opcion); $i++) {
			$posresp = new Cue_posibles_respuestas;
			$posresp_v = new Cue_posibles_respuestas_versiones;
			// Llenamos la tabla posibles_respuestas
			$posresp->id_pregunta = $preguntas->id_pregunta;
			$posresp->tipo = 1; // $preguntas->tipo; 1 porque estas siempre son de seleccin asi vengan de una pregunta combinada
			$posresp->numero = $orden_resp;
			$posresp->insert();
			// Llenamos la tabla posibles_respuestas_versiones
			$posresp_v->id_objeto = $posresp->id_respuesta;
			$posresp_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			$posresp_v->nombre = $opcion[$i];
			$posresp_v->insert();
			$orden_resp++;
		}
		
		// Ingresamos la pregunta abierta
		if ($pregunta_abierta != "") {
			$posresp = new Cue_posibles_respuestas;
			$posresp_v = new Cue_posibles_respuestas_versiones;
			// Llenamos la tabla posibles_respuestas
			$posresp->id_pregunta = $preguntas->id_pregunta;
			$posresp->tipo = 4; // pregunta combinada
			$posresp->numero = $orden_resp;
			$posresp->insert();
			// Llenamos la tabla posibles_respuestas_versiones
			$posresp_v->id_objeto = $posresp->id_respuesta;
			$posresp_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			$posresp_v->nombre = $pregunta_abierta;
			$posresp_v->insert();
		}
		
		Generar_cuestionarios::generar_cuestionarios($id_cuestionario);
		if ($id1 > 0 && $id2 > 0) Util::log('Cuestionarios', 'Crear Pregunta', 'Se creo la pregunta');
		else Util::log('Cuestionarios', 'Crear Pregunta', 'No se creo la pregunta');
		return ($id1 > 0 && $id2 > 0);
	}
	
	/*
	 * Carga el wysiwyg para la creacin de una pregunta
	 *
	 * @return bool siempre true.
	 */
	function cargar_crear_pregunta() {
		
		// Se incluye el editor wysiwyg version 2.0
		$estilos_wysiwyg = $_SESSION['fckeditor_comboBoxStyles'];
		$_SESSION['contenido_HTML'] = null;
		for($i = 0; $i < 2; $i++) {
			$contenido = "";
			
			$contenido = str_replace('"',"'",$contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,'',$contenido);

			$_SESSION['contenido_HTML'][$i] = $contenido_HTML;
		}

		return true;
	}
		
	/*
	 * Edita una pregunta con sus posibles respuestas en un cuestionario dado
	 *
	 * @param  int    $id_pregunta identificador de la pregunta
	 *
	 * @return array  arreglo con los datos de la pregunta a editar.
	 */
	function cargar_editar_pregunta($id_pregunta) {
		$cue = new Cue_cuestionarios;
		$preguntas = new Cue_preguntas;
		$preguntas_v = new Cue_preguntas_versiones;
		$preguntas->get($id_pregunta);
		// cargamos los datos de la pregunta
		$preguntas_v->id_objeto = $id_pregunta;
		$preguntas_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$preguntas_v->find(true);
		// cargamos los datos del cuestionario al que pertenece la pregunta
		$cue->get($preguntas->id_cuestionario);
		$pregunta['preguntas'] = $preguntas;
		$pregunta['preguntas_v'] = $preguntas_v;
		
		// creacion de versiones de preguntas
		$preg2 = new Cue_preguntas;
		$preg2->id_cuestionario = $cue->id_objeto;
		$preg2->find();
		while ($preg2->fetch()) { // print_r($preg2);exit();
			$preg_v2 = new Cue_preguntas_versiones;
			$preg_v2->id_objeto = $preg2->id_pregunta;
			$preg_v2->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			if (!$preg_v2->find(true))
				Fachada_Sistema::crear_version(&$preg_v2, $_SESSION['sis_idioma']['id_idioma']);
		}
		
		$posresp = new Cue_posibles_respuestas;
		$posresp_v = new Cue_posibles_respuestas_versiones;
		$posresp->id_pregunta = $id_pregunta;
		$posresp_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$posresp->joinAdd($posresp_v);
		$posresp->selectAs();
		$posresp->selectAs($posresp_v, 'posresp_v_%s');
		$posresp->orderBy('numero');
		$posresp->find();
//print_r($posresp);exit();
		while ($posresp->fetch())
			$pregunta['posresp'][] = $posresp; //print_r($posresp);
//print_r($pregunta);exit();
		// Se incluye el editor wysiwyg version 2.0
		$_SESSION['contenido_HTML'] = null;
		for($i = 0; $i < 2; $i++) {
			$contenido = ($i) ? $preguntas_v->texto_post : $preguntas_v->descripcion;
			
/*			$contenido = str_replace('"',"'",$contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,'',$contenido);*/

			$_SESSION['contenido_HTML'][$i] = $contenido;
		}

		return $pregunta;
	}
	
	/*
	 * Edita una pregunta con sus posibles respuestas en un cuestionario dado
	 *
	 * @param  string $nombre_pregunta  nombre de la pregunta
	 * @param  string $texto_pregunta   texto de la pregunta
	 * @param  string $texto_post       texto que va despues del texto de la pregunta
	 * @param  int    $columnas         nmero de columnas de la pregunta si es un textarea
	 * @param  int    $filas            nmero de filas de la pregunta si es un textarea
	 * @param  bool   $requerida        nos dice si la pregunta es de respuesta obligatoria o no
	 * @param  array  $opcion           arreglo de opciones a escoger de la pregunta
	 * @param  string $pregunta_abierta pregunta abierta
	 * @param  int    $id_cuestionario  identificador del cuestionario
	 * @param  int    $tipo_pregunta    tipo de pregunta
	 * @param  int    $id_pregunta      identificador de la pregunta
	 * @param  array  $id_opcion        arreglo de identificadores de opciones de la pregunta
	 *
	 * @return bool  true si se edit la pregunta y false en caso contrario.
	 */
	function editar_pregunta($nombre_pregunta, $texto_pregunta, $texto_post, $columnas, $filas, $requerida,
			$opcion, $pregunta_abierta, $id_cuestionario, $tipo_pregunta, $id_pregunta, $id_opcion) {
		
		// Llenamos la tabla preguntas
		$preguntas = new Cue_preguntas;
		$preguntas->get($id_pregunta);
		$preguntas->id_cuestionario = $id_cuestionario;
		$preguntas->tipo = $tipo_pregunta;
		if ($columnas != '') $preguntas->columnas = $columnas;
		if ($filas != '') $preguntas->filas = $filas;
		if ($requerida == 't') $preguntas->requerida = $requerida;
		$id1 = $preguntas->update();
		// Llenamos la tabla preguntas_versiones
		$preguntas_v = new Cue_preguntas_versiones;
		$preguntas_v->id_objeto = $preguntas->id_pregunta;
		$preguntas_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$preguntas_v->find(true);
		$preguntas_v->nombre = $nombre_pregunta;
		$preguntas_v->descripcion = $texto_pregunta;
		$preguntas_v->texto_post = $texto_post;
		$id2 = $preguntas_v->update();
//print_r($opcion);exit();		
		if (sizeof($opcion)) {
			// Ahora las posibles respuestas pueden ser actualizadas o adicionadas segn el caso
			// pero se me ha ocurrido una ideota, el plan es: borramos lo que ya est e ingresamos los nuevos datos...
			$posresp = new Cue_posibles_respuestas;
			$posresp_v = new Cue_posibles_respuestas_versiones;
			// Con el manejo de versiones al borrar las opciones de una version se borran las de las otras versiones, 
			// por lo tanto, vamos a guardar en un arreglo lo que hay en las otras versiones y despues lo volvemos a meter...
			$posresp2 = new Cue_posibles_respuestas;
			$posresp_v2 = new Cue_posibles_respuestas_versiones;
			$posresp2->id_pregunta = $id_pregunta;
			$posresp_v2->joinAdd($posresp2);
			$posresp_v2->selectAs();
			$posresp_v2->selectAs($posresp2, 'posresp2_%s');
			$posresp_v2->orderBy('numero');
			$posresp_v2->find();
			while ($posresp_v2->fetch()) {
				$array_op_v[] = $posresp_v2->toArray(); // $array_op_v[] tiene las versiones de las opciones de la pregunta
			}  //print_r($array_op_v);exit();
			
			// Ahora si, borramos las opciones viejas
			$posresp->whereAdd('id_pregunta='.$id_pregunta);
			$posresp->delete(DB_DATAOBJECT_WHEREADD_ONLY);
			
			// Ingresamos el contenido del arreglo opcion
			$orden_resp = 1;
			for ($i=0; $i < sizeof($opcion); $i++) {
				$posresp = new Cue_posibles_respuestas;
				$posresp_v = new Cue_posibles_respuestas_versiones;
				// Creamos la posible respuesta sea una de las borradas o una nueva
				// Llenamos la tabla posibles_respuestas
				$posresp->id_pregunta = $preguntas->id_pregunta;
				$posresp->tipo = 1; // $preguntas->tipo; 1 porque estas siempre son de seleccin asi vengan de una pregunta combinada
				$posresp->numero = $orden_resp;
				$posresp->insert();
				// Llenamos la tabla posibles_respuestas_versiones
				$posresp_v->id_objeto = $posresp->id_respuesta;
				$posresp_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
				$posresp_v->nombre = $opcion[$i];
				$posresp_v->insert();
				$orden_resp++;
			} // Fin de for ingreso de arreglo opcion
//exit();	
			// Ingresamos la pregunta abierta
			if ($pregunta_abierta != "") {
				$posresp = new Cue_posibles_respuestas;
				$posresp_v = new Cue_posibles_respuestas_versiones;
				// Creamos la posible respuesta sea una de las borradas o una nueva
				// Llenamos la tabla posibles_respuestas
				$posresp->id_pregunta = $preguntas->id_pregunta;
				$posresp->tipo = 4; // $preguntas->tipo; 1 porque estas siempre son de seleccin asi vengan de una pregunta combinada
				$posresp->numero = $orden_resp;
				$posresp->insert();
				// Llenamos la tabla posibles_respuestas_versiones
				$posresp_v->id_objeto = $posresp->id_respuesta;
				$posresp_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
				$posresp_v->nombre = $pregunta_abierta;
				$posresp_v->insert();
			} // Fin de if pregunta abierta
			
			// Ahora ingresamos en los otros idiomas las versiones de posibles respuestas segn el nmero de opciones que tiene la 
			// pregunta en el idioma actual, es decir, si hay menos opciones, las otras se pierden en los otros idiomas, si hay mas
			// opciones, se agrega una copia de la opcion en el idioma actual para que en todas las preguntas siempre haya el mismo
			// nmero de opciones.
			$lang_types = new Sitio_idioma;
			$lang_types->find();
			while ($lang_types->fetch()) { // recorremos los idiomas del sitio
				if ($lang_types->id_idioma != $_SESSION['sis_idioma']['id_idioma']) { // no entrar en el idioma actual
					$posresp2 = new Cue_posibles_respuestas;
					$posresp2->id_pregunta = $id_pregunta;
					$posresp2->find();
					$i = 1;
					while ($posresp2->fetch()) {
						$posresp_v2 = new Cue_posibles_respuestas_versiones;
						$posresp_v2->id_idioma = $lang_types->id_idioma;
						$posresp_v2->id_objeto = $posresp2->id_respuesta;
						// ingresamos el campo nombre segun el idioma, si es tipo 1 y hacemos el insert() 
						for ($k=0; $k < sizeof($array_op_v); $k++) {
							if ($array_op_v[$k]['id_idioma'] == $lang_types->id_idioma && $array_op_v[$k]['posresp2_numero'] == $i) {
								if ($array_op_v[$k]['posresp2_tipo'] == 1 || 
									($array_op_v[$k]['posresp2_tipo'] == 4  && $posresp2->tipo == 4)) { // si es tipo 1 o 4
									$posresp_v2->nombre = $array_op_v[$k]['nombre'];
									$posresp_v2->insert();
									break; // break porque solo hay un nombre por idioma
								}
							}
						}
						$i++;
					} // fin del while $posresp2->fetch()
				} // fin if $lang_types->id_idioma
			} // fin while $lang_types->fetch
			
			// Ahora creamos versiones para que las opciones que no existen queden con las del idioma en que han sido creadas
			// creacion de versiones de posibles respuestas
			$posresp2 = new Cue_posibles_respuestas;
			$preguntas2 = new Cue_preguntas;
			$preguntas2->id_cuestionario = $id_cuestionario;
			$posresp2->joinAdd($preguntas2);
			$posresp2->orderBy('numero');
			$posresp2->selectAs();
			$posresp2->selectAs($preguntas2, 'preguntas2_%s');
			$posresp2->find(); // seleccionamos las preguntas de este cuestionario
			while ($posresp2->fetch()) { // print_r($preg2);exit();
				$lang_types = new Sitio_idioma;
				$lang_types->find();
				while ($lang_types->fetch()) { // recorremos los idiomas del sitio
					$posresp_v2 = new Cue_posibles_respuestas_versiones;
					$posresp_v2->id_objeto = $posresp2->id_respuesta;
					$posresp_v2->id_idioma = $lang_types->id_idioma;
					if (!$posresp_v2->find(true))
						Fachada_Sistema::crear_version(&$posresp_v2, $lang_types->id_idioma);
				}
			}
		} // Fin de if sizeof opcion
		
		Generar_cuestionarios::generar_cuestionarios($id_cuestionario);
		if ($id1 > 0 && $id2 > 0) Util::log('Cuestionarios', 'Editar Pregunta', 'Se edito la pregunta');
		else Util::log('Cuestionarios', 'Editar Pregunta', 'No se edito la pregunta');
		return ($id1 > 0 && $id2 > 0);
	}
	
	/*
	 * Carga las preguntas del cuestionario
	 *
	 * @param  int  $id_cuestionario  identificador del cuestionario
	 *
	 * @return array con las preguntas del cuestionario.
	 */
	function cargar_cuestionario_pre($id_cuestionario) {
		$cue = new Cue_cuestionarios;
		$cue_v = new Cue_cuestionarios_versiones;
		$preguntas = new Cue_preguntas;
		$preguntas_v = new Cue_preguntas_versiones;
		$tipos_p = new Cue_tipos_preguntas;
		
		// Si estamos en el generado no existe $_SESSION['sis_idioma']['id_idioma']
		if (!isset($_SESSION['sis_idioma']['id_idioma']) or $_SESSION['sis_idioma']['id_idioma'] == "" or isset($_SESSION['lang'])) {
			$idioma = new Sis_idiomas;
			$idioma->get('enctype', $_SESSION['lang']);
			$_SESSION['sis_idioma'] = $idioma->toArray();
//print_r($_SESSION['sis_idioma']);exit;
		}//print_r($_SESSION['sis_idioma']); print_r($_SESSION['lang']);exit;
		
		// capturamos la informacin del cuestionario
		if (!$cue->get($id_cuestionario)) {
			$_SESSION['cue_mensaje'] = "El cuestionario no se encontr en la base de datos";
			return false;
		}
		$cue_v->id_objeto = $id_cuestionario;
		$cue_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		if (!$cue_v->find(true)) {
			$_SESSION['cue_mensaje'] = "La version del cuestionario no se encontr en la base de datos";
			return false;
		}
		// almacenamos los datos del cuestionario en la sesion
		$cuestionario->id_objeto = $cue->id_objeto;
		$cuestionario->tipo = $cue->tipo;
		$cuestionario->fecha_creacion = $cue->fecha_creacion;
		$cuestionario->nombre = $cue_v->nombre;
		
		// ahora capturamos las respuestas del cuestionario
		$preguntas->id_cuestionario = $id_cuestionario;
 		$preguntas_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$preguntas->joinAdd($preguntas_v); // Se une preguntas_versiones a preguntas
		$preguntas->orderBy('numero_preg');
		$preguntas->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
 		$tipos_p->id_idioma = 1;//$_SESSION['sis_idioma']['id_idioma'];
		$preguntas->joinAdd($tipos_p);
		$preguntas->selectAs();
		$preguntas->selectAs($preguntas_v, 'preguntas_v_%s');
		$preguntas->selectAs($tipos_p, 'tipreg_%s');
		$preguntas->find(); //print_r($preguntas);
		
		$questions = array();
		while ($preguntas->fetch()) {
			$questions[] = $preguntas;
		}
		$questions['cuestionario'] = $cuestionario;
//echo "AAAAAAA";print_r($questions);exit();
		return $questions;
		
	}
	
	/*
	 * Carga las preguntas (y sus opciones) del cuestionario 
	 *
	 * @param  int  $id_cuestionario  identificador del cuestionario
	 *
	 * @return array con las preguntas del cuestionario y sus opciones.
	 */
	function cargar_cuestionario_pre_opc($id_cuestionario) {
		$cue = new Cue_cuestionarios;
		$cue_v = new Cue_cuestionarios_versiones;
		$preguntas = new Cue_preguntas;
		$preguntas_v = new Cue_preguntas_versiones;
		$tipos_p = new Cue_tipos_preguntas;
		
		// Si estamos en el generado no existe $_SESSION['sis_idioma']['id_idioma']
		if (!isset($_SESSION['sis_idioma']['id_idioma']) or $_SESSION['sis_idioma']['id_idioma'] == "") {
			$idioma = new Sis_idiomas;
			$idioma->get('enctype', $_SESSION['lang']);
			$_SESSION['sis_idioma'] = $idioma->toArray();
//print_r($_SESSION['sis_idioma']);exit;
		}
		
		// capturamos la informacin del cuestionario
		if (!$cue->get($id_cuestionario)) {
			$_SESSION['cue_mensaje'] = "El cuestionario no se encontr en la base de datos";
			return false;
		}
		$cue_v->id_objeto = $id_cuestionario;
		$cue_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		if (!$cue_v->find(true)) {
			$_SESSION['cue_mensaje'] = "La version del cuestionario no se encontr en la base de datos";
			return false;
		}
		// almacenamos los datos del cuestionario en la sesion
		$cuestionario->id_objeto = $cue->id_objeto;
		$cuestionario->tipo = $cue->tipo;
		$cuestionario->fecha_creacion = $cue->fecha_creacion;
		$cuestionario->nombre = $cue_v->nombre;
		
		// creacion de versiones de posibles respuestas
		$posresp2 = new Cue_posibles_respuestas;
		$preguntas2 = new Cue_preguntas;
		$preguntas2->id_cuestionario = $id_cuestionario;
		$posresp2->joinAdd($preguntas2);
		$posresp2->orderBy('numero');
		$posresp2->selectAs();
		$posresp2->selectAs($preguntas2, 'preguntas2_%s');
		$posresp2->find(); // seleccionamos las preguntas de este cuestionario
		while ($posresp2->fetch()) { // print_r($preg2);exit();
			$posresp_v2 = new Cue_posibles_respuestas_versiones;
			$posresp_v2->id_objeto = $posresp2->id_respuesta;
			$posresp_v2->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			if (!$posresp_v2->find(true))
				Fachada_Sistema::crear_version(&$posresp_v2, $_SESSION['sis_idioma']['id_idioma']);
		}
		
		// ahora capturamos las respuestas del cuestionario
		$posresp = new Cue_posibles_respuestas;
		$preguntas->id_cuestionario = $id_cuestionario;
		$posresp->joinAdd($preguntas);
		$posresp->orderBy('numero');
		$posresp_v = new Cue_posibles_respuestas_versiones;
		$posresp_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$posresp->joinAdd($posresp_v);
		$posresp->selectAs();
		$posresp->selectAs($preguntas, 'preguntas_%s');
		$posresp->selectAs($posresp_v, 'posresp_v_%s');
		$posresp->find(); //print_r($preguntas);
		
		$questions = array();
		while ($posresp->fetch()) {
			$questions[] = $posresp;
		}
		$questions['cuestionario'] = $cuestionario;
//echo "AAAAAAA";print_r($questions);exit();
		return $questions;
	}
	
	/*
	 * Devuelve un arreglo con el conteo estadstico de las respuestas
	 *
	 * @param  int  $id_cuestionario  identificador del cuestionario
	 *
	 * @return array con estadisticas de las respuestas del cuestionario.
	 */
	function cargar_cuestionario_resp($id_cuestionario) {
		// contamos las respuestas de las opciones
		$res_preg = new Cue_respuestas_preguntas;
		$query = "SELECT z.id_respuesta, count(z.id_resp_preg) as num FROM 
				(SELECT * FROM cue_respuestas_preguntas as x
				JOIN cue_respuestas_cuestionarios as y 
				ON x.id_resp_cues=y.id_resp_cue and y.id_cuestionario=".$id_cuestionario.") as z
				GROUP BY z.id_respuesta
				HAVING NOT(z.id_respuesta IS NULL)";
		$res_preg->query($query);
		$i = 0;
		while ($res_preg->fetch()) {
			$res_preg_opciones[$i]->tipo_resp = "opciones";
			$res_preg_opciones[$i]->id_respuesta = $res_preg->id_respuesta;
			$res_preg_opciones[$i]->num = $res_preg->num;
			$i++;
		}
		
		// contamos las respuestas tipo si
		$res_preg = new Cue_respuestas_preguntas;
		$query = "SELECT z.id_pregunta, count(z.id_pregunta) as num FROM 
				(SELECT * FROM cue_respuestas_preguntas as x
				JOIN cue_respuestas_cuestionarios as y 
				ON x.id_resp_cues=y.id_resp_cue and y.id_cuestionario=".$id_cuestionario." and x.texto_resp='si') as z
				GROUP BY z.id_pregunta";
		$res_preg->query($query);
		$i = 0;
		while ($res_preg->fetch()) {
			$res_preg_si[$i]->tipo_resp = "si";
			$res_preg_si[$i]->id_pregunta = $res_preg->id_pregunta;
			$res_preg_si[$i]->num = $res_preg->num;
			$i++;
		}
		
		// contamos las respuestas tipo no
		$res_preg = new Cue_respuestas_preguntas;
		$query = "SELECT z.id_pregunta, count(z.id_pregunta) as num FROM 
				(SELECT * FROM cue_respuestas_preguntas as x
				JOIN cue_respuestas_cuestionarios as y 
				ON x.id_resp_cues=y.id_resp_cue and y.id_cuestionario=".$id_cuestionario." and x.texto_resp='no') as z
				GROUP BY z.id_pregunta";
		$res_preg->query($query);
		$i = 0;
		while ($res_preg->fetch()) {
			$res_preg_no[$i]->tipo_resp = "no";
			$res_preg_no[$i]->id_pregunta = $res_preg->id_pregunta;
			$res_preg_no[$i]->num = $res_preg->num;
			$i++;
		}
		
		// Calculamos el total de respuestas al cuestionario
		$res_cues = new Cue_respuestas_cuestionarios;
		$res_cues->whereAdd('id_cuestionario ='.$id_cuestionario);
		$total = $res_cues->count();
		$res_total[0]->tipo_resp = "total";
		$res_total[0]->total = $total;
		
		// Devuelve el arreglo de las respuestas
		return array_merge($res_preg_opciones,$res_preg_si,$res_preg_no,$res_total);
	}
	
	/*
	 * Carga las respuestas al cuestionario de un usuario dado
	 *
	 * @param  int  $id_resp_cues  identificador de usuario que ha respondido el cuestionario
	 *
	 * @return array con las respuestas del cuestionario hechas por un usuario.
	 */
	function cargar_respuestas_individuales($id_resp_cues) {
		$resp_preg = new Cue_respuestas_preguntas;
		$resp_preg->whereAdd('id_resp_cues='.$id_resp_cues);
		$resp_preg->orderBy('id_pregunta');
		$resp_preg->find();
		$arr_resp_ind = array();
		while ($resp_preg->fetch()) 
			$arr_resp_ind[] = $resp_preg;
//print_r($arr_resp_ind);exit();
		return $arr_resp_ind;
	}
	
	/*
	 * Ingresa las respuestas del usuario desde la pgina del formulario
	 *
	 * @param  int    $id_cuestionario identificador del cuestionario
	 * @param  int    $id_respuesta    identificador de la respuesta
	 * @param  string $texto_respuesta texto de la respuesta
	 * @param  int    $numero_ip       numero ip del computador desde donde el usuario llen el cuestionario
	 * @param  int    $id_usuario      identificador del usuario del sistema
	 * @param  int    $id_contacto     identificador del contacto en la base de datos
	 *
	 * @return bool true si la respuesta se ingres correctamente false en caso contrario.
	 */
	function ingresar_respuestas($id_cuestionario,$id_respuesta,$texto_respuesta,$numero_ip,$id_usuario,$id_contacto) {
//return false;
		// Primero vemos si el cuestionario existe
		$cuestionario = new Cue_cuestionarios;
		if (!$cuestionario->get($id_cuestionario)) {
			$_SESSION['cue_mensaje'] .= "\\nEl cuestionario no exite en la base de datos";
			Util::log('Cuestionarios', 'Ingresar Respuestas', 'No se ingreso la respuesta');
			return false;
		}
		
		// Al ingresar una respuesta, el cuestionario ya no se puede editar
		if ($cuestionario->respuestas == 'f') {
			$cuestionario->respuestas = 't';
			$cuestionario->update();
		}
		
		// Vemos que segn el tipo de cuestionario el usuario no repita
		if ($cuestionario->tipo == 1 || $cuestionario->tipo == 4) { // ip o encuesta
			// Buscamos si el nmero ip ya est en la base de datos para ese cuestionario
			$rc = new Cue_rc_anonimos;
			$rc->id_cuestionario = $id_cuestionario;
			$rc->ip = $numero_ip;
			$rc->selectAdd();
			$rc->selectAdd('MAX(fecha)');
			$rc->find(true);//print_r($rc);exit;//echo $rc->max;exit;
			if ($rc->find(true)) {
				$min_dif = 4; // minutos de diferencia o intervalo de tiempo antes de ingresar nueva respuesta
				if (Fachada_Cuestionarios::bloquear_ingreso_cue_anonimo($rc->max, $min_dif)) {
					$_SESSION['cue_mensaje'] .= "\\nUsted ya contest este cuestionario";
					Util::log('Cuestionarios', 'Ingresar Respuestas', 'No se ingreso la respuesta');
					return false;
				}
			}
			// ingresamos los datos del usuario en la tabla rc correspondiente (anonimos, contactos nuevos, registrados)
			$rc = new Cue_rc_anonimos;
			$rc->id_cuestionario = $id_cuestionario;
			$rc->ip = $numero_ip;
			$id = $rc->insert();
			if (!($id > 0)) { // NO se ingres la respuesta al sistema
				$_SESSION['cue_mensaje'] .= "\\nNO se pudo ingresar la respuesta";
				Util::log('Cuestionarios', 'Ingresar Respuestas', 'No se ingreso la respuesta');
				return false;
			}
		} elseif ($cuestionario->tipo == 2) { // id_usuario
			// si el id_usuario es vacio devolvemos un error
			if ($id_usuario == '') {
				$_SESSION['cue_mensaje'] .= "\\nEl id_usuario no puede ser vaco";
				Util::log('Cuestionarios', 'Ingresar Respuestas', 'No se ingreso la respuesta');
				return false;
			}
			// Buscamos si el id_usuario ya est en la base de datos para ese cuestionario
			$rc = new Cue_rc_registrados;
			$rc->id_cuestionario = $id_cuestionario;
			$rc->id_usuario = $id_usuario;
			if ($rc->find()) {
				$_SESSION['cue_mensaje'] .= "\\nUsted ya contest este cuestionario";
				Util::log('Cuestionarios', 'Ingresar Respuestas', 'No se ingreso la respuesta');
				return false;
			}
			// ingresamos los datos del usuario en la tabla rc correspondiente (anonimos, contactos nuevos, registrados)
			$rc = new Cue_rc_registrados;
			$rc->id_cuestionario = $id_cuestionario;
			$rc->id_usuario = $id_usuario;
			$id = $rc->insert();
			if (!($id > 0)) { // NO se ingres la respuesta al sistema
				$_SESSION['cue_mensaje'] .= "\\nNO se pudo ingresar la respuesta";
				Util::log('Cuestionarios', 'Ingresar Respuestas', 'No se ingreso la respuesta');
				return false;
			}
		} elseif ($cuestionario->tipo == 3) { // id_contacto
			// si el id_contacto es vacio devolvemos un error
			if ($id_contacto == '') {
				$_SESSION['cue_mensaje'] .= "\\nEl id_contacto no puede ser vaco";
				Util::log('Cuestionarios', 'Ingresar Respuestas', 'No se ingreso la respuesta');
				return false;
			}
			// NO es necesario revisar si el id_contacto ya est en la base de datos porque el contacto (y su email)
			// puede estar repetido en la tabla de contactos externos incluso en el mismo formulario.
			// Ingresamos los datos del contacto en la tabla rc correspondiente (anonimos, contactos nuevos, registrados)
			$rc = new Cue_rc_contactos_nuevos;
			$rc->id_cuestionario = $id_cuestionario;
			$rc->id_contacto = $id_contacto;
			$id = $rc->insert();
			if (!($id > 0)) { // NO se ingres la respuesta al sistema
				$_SESSION['cue_mensaje'] .= "\\nNO se pudo ingresar la respuesta";
				Util::log('Cuestionarios', 'Ingresar Respuestas', 'No se ingreso la respuesta');
				return false;
			}
		}
		
		// ingresamos los datos de las opciones en la tabla respuestas_preguntas
		foreach ($id_respuesta as $key => $value) {
			$respreg = new Cue_respuestas_preguntas;
			$respreg->id_resp_cues = $rc->id_resp_cue; // segun la tabla respuestas cuestionarios respectiva
			$respreg->id_respuesta = $value;
			$respreg->id_pregunta = $key;
			// buscamos en texto_respuesta si tiene un valor para esta pregunta
			if (isset($texto_respuesta[$key])) {
				$respreg->texto_resp = $texto_respuesta[$key];
				unset($texto_respuesta[$key]);
			}
			$respreg->insert();
		}
		// ingresamos los datos de slo texto en la tabla respuestas_preguntas
		foreach ($texto_respuesta as $key => $value) {
			$respreg = new Cue_respuestas_preguntas;
			$respreg->id_resp_cues = $rc->id_resp_cue; // segun la tabla respuestas cuestionarios respectiva
			$respreg->id_pregunta = $key;
			$respreg->texto_resp = $value;
			$respreg->insert();
		}
		
		Util::log('Cuestionarios', 'Ingresar Respuestas', 'Se ingreso la respuesta');
		return true;
	}
	
	/*
	 * Carga las respuestas tipo texto de cada usuario que respondi el cuestionario
	 *
	 * @param  int    $id_pregunta      identificador de la pregunta
	 * @param  int    $id_cuestionario  identificador del cuestionario
	 *
	 * @return array arreglo con las respuestas tipo texto de los usuarios que contestaron el cuestionario.
	 */
	function cargar_resp_texto_individuales($id_pregunta, $id_cuestionario) {
		$respreg = new Cue_respuestas_preguntas;
		$cuestionario = new Cue_cuestionarios;
		
		if (!$cuestionario->get($id_cuestionario)) {
			$_SESSION['cue_mensaje'] = "\\nNo se encontr el cuestionario en la base de datos";
			return false;
		}
		// Escogemos la tabla de respuestas de cuestionarios segun el tipo del mismo para
		// capturar el usuario segn el caso.
		if ($cuestionario->tipo == 1) {
			$respcue = new Cue_rc_anonimos;
			$respcue->id_cuestionario = $id_cuestionario;
		} elseif ($cuestionario->tipo == 2) {
			$respcue = new Cue_rc_registrados;
			$respcue->id_cuestionario = $id_cuestionario;
			$usuario = new Sis_usuarios;
			// Hacemos el join con la tabla de usuarios
			$respcue->joinAdd($usuario);
			$respcue->selectAs();
			$respcue->selectAs($usuario, 'usuario_%s');    //print_r($resp_cue);exit();
		} elseif ($cuestionario->tipo == 3) { // No ha sido implementado an
			$respcue = new Cue_rc_contactos_nuevos;
			$respcue->id_cuestionario = $id_cuestionario;
			$contacto = new Cnt_contactos_externos;
			// Hacemos el join con la tabla de usuarios
			$respcue->joinAdd($contacto);
			$respcue->selectAs();
			$respcue->selectAs($contacto, 'contacto_%s');    //print_r($resp_cue);exit();
		}
		
		$resp_texto = array();
		$respreg->id_pregunta = $id_pregunta;
		$respreg->joinAdd($respcue);
		$respreg->orderBy('respcue_fecha');
		//$respreg->selectAs();
		$respreg->selectAs($respcue, 'respcue_%s');
		$respreg->find();//print_r($respreg);exit();
		
		while ($respreg->fetch()) //print_r($respreg);exit();
			$resp_texto[] = $respreg;
		$resp_texto[] = $cuestionario->tipo;
//print_r($resp_texto);exit();
		return $resp_texto;
	}
	
	/*
	 * Bloquea el ingreso de una respuesta en un cuestionario annimo segn un intervalo de tiempo
	 *
	 * @param  int    $id_cuestionario  identificador del cuestionario
	 *
	 * @return void no devuelve nada.
	 */
	function bloquear_ingreso_cue_anonimo($fecha_db, $min_dif) {
		$fecha_db = substr($fecha_db, 0, 19);
//echo $fecha_db."<br>\n".$min_dif."\n";//exit;
		$hoy = getdate(); // le ponemos el cero a la izquierda a los valores de tamao 1 en la fecha
		if (strlen($hoy['mon']) == 1) $hoy['mon'] = '0'.$hoy['mon'];
		if (strlen($hoy['mday']) == 1) $hoy['mday'] = '0'.$hoy['mday'];
		if (strlen($hoy['hours']) == 1) $hoy['hours'] = '0'.$hoy['hours'];
		if (strlen($hoy['minutes']) == 1) $hoy['minutes'] = '0'.$hoy['minutes'];
		if (strlen($hoy['seconds']) == 1) $hoy['seconds'] = '0'.$hoy['seconds'];
		$fecha2  = $hoy['year'].'-'.$hoy['mon'].'-'.$hoy['mday'].' ';
		$fecha2 .= $hoy['hours'].':'.$hoy['minutes'].':'.$hoy['seconds'];
//echo $fecha2."\n";//exit;
		$min_db = substr($fecha_db, 14, 2); // minutos de la db
		$min2   = substr($fecha2  , 14, 2); // minutos de fecha2
		$hour_db = substr($fecha_db, 11, 2); // horas de la db
		$hour2   = substr($fecha2  , 11, 2); // horas de fecha2
//echo "mindb: ".$min_db."\nmin2: ".$min2."\nhour_db: ".$hour_db."\nhour2: ".$hour2."\n";exit;
		// Si tienen la misma fecha
		if (substr($fecha_db, 0, 10) == substr($fecha2, 0, 10)) {
			// Si tienen la misma hora:
			if ($hour_db == $hour2) {
				// chequeamos que la diferencia en minutos no sea mayor que $min_dif+1
				if ($min2-$min_db < $min_dif+1)
					return true;
			}
			// Si en la segunda fecha la hora es igual a la de la db + 1
			elseif ($hour2 == $hour_db+1) {
				if (($min2+60)-$min_db < $min_dif+1)
					return true;
			}
		}
		
		return false;
	}
	
	/*
	 * Devuelve el id_pregunta de un cuestionario cuestionario tipo 4 (encuesta)
	 *
	 * @param  int    $id_cuestionario  identificador del cuestionario
	 *
	 * @return int    el $id_pregunta, o false en caso contrario.
	 */
	function get_id_pregunta_encuesta($id_cuestionario) {
		$cue = new Cue_cuestionarios;
		// Buscamos el cuestionario
		if (!$cue->get($id_cuestionario)) {
			return false;
		}
		$pregunta = new Cue_preguntas;
		$pregunta->id_cuestionario = $id_cuestionario;
		if ($pregunta->find(true)) { // Buscamos la pregunta
			return $pregunta->id_pregunta;
		}
		
		return false;
	}
	
	/*
	 * Devuelve las respuestas de todos los usuarios que han respondido el cuestionario
	 *
     * @param int    $id_cuestionario  identificador del cuestionario
	 *
	 * @return array arreglo de objetos cuestionario con los datos de los mismos, false si hay algn error.
	 */
	function crear_excel_encuesta($id_cuestionario) {
		$cuestionario = new Cue_cuestionarios;
		$resp_cue = new Cue_respuestas_cuestionarios;
		
		// Chequeamos que el cuestionario exista y su tipo
		if (!$cuestionario->get($id_cuestionario)) return false;
		
		// dependiendo del tipo del cuestionario el valor de la primera columna cambia
		if ($cuestionario->tipo == 4) { // Usuarios anonimos
			$resp_cue = new Cue_rc_anonimos;
		// Si el cuestionario es tipo usuarios el parametro es un login (campo nombre)
		} else {
			$_SESSION['cue_mensaje'] = "\\nEl cuestionario debe ser una encuesta";
			return false;
		}
		
		$resp_cue->whereAdd('id_cuestionario='.$id_cuestionario);
		
		// Paginar los resultados de bsqueda
		$resp_cue->orderBy('fecha');
		
		$resp_preg = new Cue_respuestas_preguntas;
		$resp_cue->joinAdd($resp_preg);
		$resp_cue->selectAs();
		$resp_cue->selectAs($resp_preg, 'resp_preg_%s');
		$resp_cue->find();  //echo "QUE PIERNOTAS";print_r($cue);exit();
		
		while ($resp_cue->fetch()) 
			$respuestas_cue[] = $resp_cue->toArray(); //print_r($respuestas_cue);exit();
		
		// ingresamos el contenido de las opciones de one...
		for ($i=0; $i < sizeof($respuestas_cue); $i++) {
			$respuestas_cue[$i]['respuesta'] = "";
			$respuestas_cue[$i]['fecha'] = substr($respuestas_cue[$i]['fecha'], 0, 19);
			if ($respuestas_cue[$i]['resp_preg_id_respuesta'] != "") {
				$pos_res_v = new Cue_posibles_respuestas_versiones;
				$pos_res_v->id_objeto = $respuestas_cue[$i]['resp_preg_id_respuesta'];
				$pos_res_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
				if ($pos_res_v->find(true))
					$respuestas_cue[$i]['respuesta'] = $pos_res_v->nombre;
			}
		}
		$cuestionario = $cuestionario->toArray(); // convertimos la info del cuestionario a arreglo
//echo "asdfawfeasfs\n";print_r($respuestas_cue);exit();
		
		return array('lista' => $respuestas_cue, 'cuestionario' => $cuestionario);
	}
}