<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |   	      Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//

/**
 * Generador de Directorio
 * Esta clase genera los archivos de la parte pblica del 
 * directorio de empleados
 *
 * @package  Directorio
 * @version  1.0
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
class Generador_Directorio
{ 
    /**
 	 * Construye el rbol de organigrama
     *
     * @param string $cadena Cadena donde queda el rbol
	 *        int $id_contacto Identificador del contacto padre del subarbol
	 *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */ 
	 function construir_arbol($cadena, $id_contacto)
	 {
	 	$contacto = new Dir_contactos;
	 	$contacto->get($id_contacto);
				
		$cadena .= "['{$contacto->nombres} {$contacto->apellido1}', 'phrame.php?action=dir_mostrar_contacto&id_contacto=$id_contacto&go=mostrar_contacto', 'contenido_mod'";
		
		$contacto = new Dir_contactos;
		$contacto->id_contacto_padre = $id_contacto;
		$contacto->find();
		while ($contacto->fetch()){
			$cadena .= ',';
			Generador_Directorio::construir_arbol(&$cadena, $contacto->id_contacto);
		}
		
        $cadena .= "]";
	 }
	 
    /**
 	 * Genera el directorio
     *
     * @param int $id_sitio Identificador del sitio
	 *        string $path_sitio ruta donde se generan los archivos
	 *        object $idioma Idioma en el que se genera el directorio
	 *
	 * @return array Arreglo asociativo con los datos del contacto
	 * @author  John A. Vargas
     * @access public
	 * @static
     */
	 function generar_directorio()
	 {
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'] . "/"; 
		$template_directorio = PATH_DIRECTORIO . "vistas/templates/tpl_directorio.php";

	 	$pagina_directorio = new Dir_directorio;
		$modulo = new Dir_datos_modulos_directorio;

		$modulo->id_contenedor = $id_sitio;
		$pagina_directorio->joinAdd($modulo);
		$pagina_directorio->selectAs();
		$pagina_directorio->find(true);

	 	$pagina = 'pagina_' . $pagina_directorio->id_objeto . '.php';
		$archivo_directorio = $path_sitio . "/$pagina";

		// Se escribe la cabecera del portal
		$include = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_directorio, $include, FILE_MODE_WRITE);

		// Copiar los archivos para frame del directorio
		copy(PATH_DIRECTORIO . 'vistas/templates/tpl_directorio_frame.php',
			 $path_sitio . '/directorio_frame.php');
			 
		copy(PATH_DIRECTORIO . 'vistas/templates/tpl_arbol_frame.php',
			 $path_sitio . '/arbol_frame.php');
			
		copy(PATH_DIRECTORIO . 'vistas/templates/tpl_arbol_izq.php',
			 $path_sitio . '/arbol_izq.php');
			 
		copy(PATH_DIRECTORIO . 'vistas/templates/tpl_arbol_der.php',
			 $path_sitio . '/arbol_der.php');
			 
		copy(PATH_DIRECTORIO . 'vistas/templates/tpl_arbol_arriba.php',
			 $path_sitio . '/arbol_arriba.php');
			 
		copy(PATH_DIRECTORIO . 'vistas/templates/tpl_arbol_abajo.php',
			 $path_sitio . '/arbol_abajo.php');

		$idioma = '<?= $_SESSION[\'lang\']?>';

		// Leemos el codigo del template
		$contenido_directorio = addslashes(implode("\n",file($template_directorio)));
		$contenido_directorio = str_replace ("?"," #?# ",$contenido_directorio);

		// Evaluo el codigo PHP que hay en el template
		eval("\$contenido_HTML = \"$contenido_directorio\"; ");
		$contenido_HTML = str_replace (" #?# ", "?", $contenido_HTML);
		// Se escribe en el archivo
		File::writeLine($archivo_directorio, stripslashes($contenido_HTML));

		// Se escribe el pie del portal
		File::writeLine($archivo_directorio, '<? include("vistas/foot_public.php") ?>');

		// Generar el archivo con el arbol de cronograma
		Generador_Directorio::generar_arbol($path_sitio);
		// Generar el archivo con el formulario de busqueda
		Generador_Directorio::generar_busqueda($path_sitio);
	 }
	 
    /**
 	 * Genera el archivo con el arbol para el directorio
     *
     * @param int $id_sitio Identificador del sitio
	 *        string $path_sitio ruta donde se generan los archivos
	 *        object $idioma Idioma en el que se genera el directorio
	 *
	 * @author John A. Vargas
     * @access public
	 * @static
     */ 
	 function generar_arbol($path_sitio)
	 {
		$template_arbol = PATH_DIRECTORIO . "vistas/templates/tpl_arbol.php";
		$archivo_arbol = $path_sitio . "/arbol_directorio.php";
		
		$contacto = new Dir_contactos;
		$contacto_hijo = new Dir_contactos;
		$contacto->id_contacto_padre = 'NULL';
		$subquery = "SELECT cnt.* 
		             FROM " . $contacto->tableName() . " AS cnt
				     WHERE cnt.id_contacto_padre = " . $contacto->tableName() . ".id_contacto";
		$contacto->whereAdd(" EXISTS ($subquery)");
		$contacto->find(true);
		
		// Generar archivos del arbol
		$cadena = '';
		Generador_Directorio::construir_arbol(&$cadena, $contacto->id_contacto);
		
		// Leemos el codigo del template		
		$contenido_arbol = addslashes(implode("\n", file($template_arbol)));
		
		// Evaluo el codigo PHP que hay en el template 
		$contenido_arbol = str_replace ("?"," #?# ",$contenido_arbol);
		eval("\$contenido_HTML = \"$contenido_arbol\"; ");
		$contenido_HTML = str_replace (" #?# ", "?", $contenido_HTML);
		
		// Se escribe en el archivo
		File::writeLine($archivo_arbol, stripslashes($contenido_HTML), FILE_MODE_WRITE);		
	 }
	 
    /**
 	 * Genera el archivo con el formulario de bsqueda
     *
     * @param int $id_sitio Identificador del sitio
	 *        string $path_sitio ruta donde se generan los archivos
	 *        object $idioma Idioma en el que se genera el directorio
	 *
	 * @author John A. Vargas
     * @access public
	 * @static
     */ 	 
	 function generar_busqueda($path_sitio)
	 {
		$template_buscar = PATH_DIRECTORIO . "vistas/templates/tpl_buscar.php";
		$archivo_buscar = $path_sitio . "/buscar_directorio.php";
		$template_contacto = PATH_DIRECTORIO . "vistas/templates/tpl_contacto.php";
		$archivo_contacto = $path_sitio . "/mostrar_contacto.php";
		
		copy ($template_buscar, $archivo_buscar);
		copy ($template_contacto, $archivo_contacto);
	}
}

?>
