<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |   	      Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//

/**
 *  Esta clase representa un componente tipo Flash
 * 
 * @package  Diseno
 * @version  1.0
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
class Flash
{
    /**
 	 * Muestra un componente tipo flash
     *
	 * @author  John A. Vargas <jhonvargas@telesat.com.co>
     * @access  public
	 * @static
     */  
	function mostrar_dis_flash($id_componente, $contenido_HTML, $i)
	{
		$path_imagenes = 'imagenes_cont/' . $_SESSION['sitio']['url'] . '/diseno/';
		$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		
		$componente = new Dis_flash_versiones;
		$componente->id_objeto = $id_componente;
		$componente->id_idioma = $id_idioma;
		
		if (!$componente->find(true))
			Fachada_Sistema::crear_version(&$componente, $id_idioma);
		
		// Se incluye la variable del editor wysiwyg version 2.0
		$template_flash = PATH_DISENO . "vistas/templates/tpl_flash.html";
		$contenido_flash = addslashes(implode("\n",file($template_flash))); 
		
		eval("\$contenido_HTML .= \"$contenido_flash\"; ");
	}
	
    /**
 	 * Guarda los cambios del Flash
     *
	 * @param array $datos_flash Datos del componente Flash a guardar
	 * @author  John A. Vargas <jhonvargas@telesat.com.co>
     * @access  public
	 * @static
     */ 
	function guardar($datos_flash)
	{
		$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
	
		foreach ($datos_flash as $datos) {
			$componente = new Dis_flash_versiones;
			$componente->id_objeto = $datos['id_componente'];
			$componente->id_idioma = $id_idioma;
			$componente->find(true);
		   
			$componente->ancho = $datos['ancho'];
			$componente->alto = $datos['alto'];
			
			// Copiar archivo
			$nombre_archivo = time() . $datos['archivo']['name'];
			$path_diseno = 'imagenes_cont/' . $_SESSION['sitio']['url'] . '/diseno';
			if (!is_dir($path_diseno)) mkdir($path_diseno);
	
			$path_archivo = $path_diseno . '/' . $nombre_archivo;
			if (is_uploaded_file($datos['archivo']['tmp_name'])) {
				move_uploaded_file($datos['archivo']['tmp_name'], $path_archivo);;
				
				$componente->archivo = $nombre_archivo;
				$componente->update();
			}
		}		
	}

    /**
 	 * Generar el componente Flash
     *
	 * @param int $id_componente Identificador del componente
	 * @param string $archivo Nombre del archivo donde se genera
	 * @author  John A. Vargas <jhonvargas@telesat.com.co>
     * @access  public
	 * @static
     */  
	 function generar($id_componente, $archivo)
	 {
	 	$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
	 	$path_imagenes = '<?= PATH_IMAGES ?>diseno/';
		$template = PATH_DISENO . "vistas/templates/" . "tpl_cmp_flash.html";
		
		$componente = new Dis_flash_versiones;
		$componente->id_objeto = $id_componente;
		$componente->id_idioma = $id_idioma;
		
		if (!$componente->find(true))
			Fachada_Sistema::crear_version(&$componente, $id_idioma);
			
		// Se escribe el contenido del bloque
		$contenido = addslashes(implode("\n",file($template)));
		eval("\$contenido_HTML = \"$contenido\"; ");
		File::writeLine($archivo, stripslashes($contenido_HTML));
	}
}
?>