<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |   	      Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//

/**
 * Esta clase representa un componente tipo Html
 * 
 * @package  Diseno
 * @version  1.0
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
class Html
{
	var $tamanno_bloques_wisywyg;
	
	/**
	 * Metodo conrtuctor
	 */
	function Html()
	{
		$this->tamanno_bloques_wisywyg = 0;
	}
	
    /**
 	 * Muestra un componente tipo html para modificacin
     *
	 * @author  John A. Vargas <jhonvargas@telesat.com.co>
     * @access  public
	 * @static
     */  
	function mostrar_dis_html($id_componente, $contenido_HTML, $i)
	{
		$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$componente = new Dis_html_versiones;
		$componente->id_objeto = $id_componente;
		$componente->id_idioma = $id_idioma;
		if (!$componente->find(true))
			Fachada_Sistema::crear_version(&$componente, $id_idioma);
		
		//variables necesarias para el editor wysiwyg
		if($componente->texto_html){
			$contenido = $componente->texto_html;
			$contenido = str_replace('"',"'",$contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,'',$contenido);
		} else $contenido = '';
		
		$nombre_wysiwyg = "texto_html_$i";
		$this->tamanno_bloques_wisywyg++;
		
		// Se incluye el editor wysiwyg version 2.0
		$contador_editor = $i+1;
		$editor = '$editor'.$i.' = new wysiwygPro();';
		$set_name = '$editor'.$i.'->set_name';
		$set_contenido = '$editor'.$i.'->set_code';
		$set_botones =  '$editor'.$i.'->removebuttons';
		$set_imagenes = '$editor'.$i.'->set_img_dir("CMS_images");';
		$set_documentos = '$editor'.$i.'->set_doc_dir("CMS_images");';
		$set_guidelines = '$editor'.$i.'->guidelines_visible(true);';
		$set_links = '$editor'.$i.'->set_links';
		$print_editor = '$editor'.$i.'->print_editor';

       // Arbol de enlaces de la ventana hiperlynk
        $ventana_enlaces_internos = "";
        Fachada_Menus::cargar_enlaces_internos_wysiwyg(&$ventana_enlaces_internos, $_SESSION['sitio']['id_objeto'],'');
        $ventana_enlaces_internos = str_replace("comillasCMS","\\\"",$ventana_enlaces_internos);
        $set_links_internos = '$editor'.$i.'->set_hyperlink("'.$ventana_enlaces_internos.'");';

        $print_editor = '$editor'.$i.'->print_editor';

		// Si hay mas de una instancia de wysiwyg se optmimiza su funcionamiento 
		if ( $this->tamanno_bloques_wisywyg > 1 )
			$set_subsequent = '$editor'.$i.'->subsequent(true);';
		else
			$set_subsequent = "";

		$template_texto = PATH_DISENO . "vistas/templates/tpl_html.html";
		$contenido_texto = addslashes(implode("\n",file($template_texto))); 
		
		eval("\$contenido_HTML .= \"$contenido_texto\"; ");
	}
	
    /**
 	 * Guarda los cambios del HTML
     *
	 * @param array $datos_flash Datos del componente Flash a guardar
	 * @author  John A. Vargas <jhonvargas@telesat.com.co>
     * @access  public
	 * @static
     */ 
	function guardar($datos_html)
	{
		$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
	
		foreach ($datos_html as $datos) {
			$componente = new Dis_html_versiones;
			$componente->id_objeto = $datos['id_componente'];
			$componente->id_idioma = $id_idioma;
			$componente->find(true);
				
			$componente->texto_html = $datos['texto'];
			$componente->update();
		}		
	}

    /**
 	 * Generar el componente Html
     *
	 * @param int $id_componente Identificador del componente
	 * @param string $archivo Nombre del archivo donde se genera
	 * @author  John A. Vargas <jhonvargas@telesat.com.co>
     * @access  public
	 * @static
     */  
	 function generar($id_componente, $archivo)
	 {
	 	$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		
		$componente = new Dis_html_versiones;
		$componente->id_objeto = $id_componente;
		$componente->id_idioma = $id_idioma;
		
		if (!$componente->find(true))
			Fachada_Sistema::crear_version(&$componente, $id_idioma);
			
		// Se escribe el contenido del bloque
		File::writeLine($archivo, $componente->texto_html);
	}
}
?>