<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |   	      Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//

		/**** MODELO ****/
// Lgica del negocio
require_once PATH_DISENO . 'modelo/Estilos.php';
require_once PATH_DISENO . 'modelo/Plantillas.php';		
		
// Capa de abstraccin de datos (DataObjects)		
require_once PATH_DISENO . 'modelo/Dis_datos_modulo_diseo.php';
require_once PATH_DISENO . 'modelo/Dis_componentes.php';
require_once PATH_DISENO . 'modelo/Dis_paneles.php';
require_once PATH_DISENO . 'modelo/Dis_contenido.php';
require_once PATH_DISENO . 'modelo/Dis_paneles_frame.php';
require_once PATH_DISENO . 'modelo/Dis_paneles_tabla.php';
require_once PATH_DISENO . 'modelo/Dis_plantillas.php';
require_once PATH_DISENO . 'modelo/Dis_menu.php';
require_once PATH_DISENO . 'modelo/Dis_menu_imagen.php';
require_once PATH_DISENO . 'modelo/Dis_menu_flash.php';
require_once PATH_DISENO . 'modelo/Dis_menu_html.php';
require_once PATH_DISENO . 'modelo/Dis_flash.php';
require_once PATH_DISENO . 'modelo/Dis_imagen.php';
require_once PATH_DISENO . 'modelo/Dis_html.php';
require_once PATH_DISENO . 'modelo/Dis_flash_versiones.php';
require_once PATH_DISENO . 'modelo/Dis_imagen_versiones.php';
require_once PATH_DISENO . 'modelo/Dis_html_versiones.php';

		/**** CONTROLADOR ****/
// Mapeamiento
include(PATH_DISENO . 'controlador/mappings.php');

// Formas
//require_once PATH_DIRECTORIO . 'controlador/forms/validar_relacionForm.php';

// Acciones
require_once PATH_DISENO . 'controlador/actions/listar_hojas_estilosAction.php';
require_once PATH_DISENO . 'controlador/actions/listar_plantillasAction.php';
require_once PATH_DISENO . 'controlador/actions/mostrar_estiloAction.php';
require_once PATH_DISENO . 'controlador/actions/modificar_estiloAction.php';
require_once PATH_DISENO . 'controlador/actions/asignar_hojaAction.php';
require_once PATH_DISENO . 'controlador/actions/mostrar_componentesAction.php';
require_once PATH_DISENO . 'controlador/actions/llenar_plantillaAction.php';
require_once PATH_DISENO . 'controlador/actions/ver_vista_previa_plantillaAction.php';
require_once PATH_DISENO . 'controlador/actions/generar_plantillaAction.php';
require_once PATH_DISENO . 'controlador/actions/crear_estiloAction.php';

/**
 * Esta clase despacha los mensajes de la accin a ejecutar por
 * medio del controlador, es quien interactua con todas las clases
 * lgicas (Modelo) del paquete Diseno
 *
 * @package  Diseno
 * @version  1.0
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
class Fachada_Diseo
{ 
	/* Despacha el mensaje de listar Hojas  de estilos */
	function listar_hojas_estilos($id_sitio)
	{
		return Estilos::listar_hojas_estilos($id_sitio);
	}

	/* Despacha el mensaje de listar estilos de una hoja */
	function listar_estilos($id_hoja_estilos)
	{	
		$_SESSION['contenido_CSS'] = Estilos::ver_estilo($id_hoja_estilos);
		return Estilos::listar_estilos($id_hoja_estilos);
	}

	/* Despacha el mensaje de modificar los estilos de una hoja */	
	function modificar_estilos($id_hoja_estilo, $nombre_hoja_estilo, $id_estilo,
							   $fuente, $color_fondo, $tamagno,	$color_fuente, $borde, $nombre_estilo)
	{
		return Estilos::modificar_estilos($id_hoja_estilo, $nombre_hoja_estilo, $id_estilo,
							   $fuente, $color_fondo, $tamagno,	$color_fuente, $borde, $nombre_estilo);
	}
	
	/* Despacha el mensaje de listar Hojas  de estilos */
	function listar_plantillas($id_sitio)
	{
		return PLantillas::listar_plantillas($id_sitio);
	}
	
	/* Despacha el mensaje de asignar una hoja de estilos */
    function asignar_hoja_estilo($id_plantilla, $id_hoja_estilo)
	{
		return Plantillas::asignar_hoja_estilo($id_plantilla, $id_hoja_estilo);
	}
	
	/* Despacha el mensaje de asignar una hoja de estilos */
    function mostrar_componentes($id_plantilla)
	{
		$plantilla = new Plantillas();
		return $plantilla->mostrar_componentes($id_plantilla);
	}
	
	/* Llena los componentes de una plantilla */
	function llenar_plantilla($id_plantilla, $componentes)
	{ 
		return Plantillas::llenar_plantilla($id_plantilla, $componentes);
	}
	
	/* Generar una plantilla */
    function generar($id_plantilla, $temp)
	{
		return Plantillas::generar($id_plantilla, $temp);
	}
	
	/* Crea una nueva hoja de estilos */
	function crear_hoja_estilos($nombre, $id_estilo_base)
	{ 
		return Estilos::crear_hoja_estilo($nombre, $id_estilo_base);
	}
}
?>