<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */
 /**
 * Parte traducible de los tipos de lugar en cada idioma disponible para el sitio 
 *
 * @package Eventos
 * @version  1
 * @author GeneratorCMS - Emedia 
 * @since    PHP 4.1.2
 */

class Generador_Eventos
{

	/*
	 * Obtiene los parametros para llamar la generacion de paginas del modulo
     *
	 * @author  Camilo Torres
     * @access  public
	*/

    function generar_local ()
    { 
        $idioma = new Sis_idiomas;
        $idioma->get("id_idioma", $_SESSION['sis_idioma']['id_idioma']);
        $path = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
        Generador_Eventos::generar_eventos ($_SESSION['sitio']['id_objeto'], $path, $idioma);
    }

	/*
	 * Genera los archivos HTML para los eventos del sitio
     *
     * @param   int $id_sitio Identificador del sitio al cual se genera los eventos
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param   string $idioma Idioma en el que se va a generar el sitio.
	 * @author  Camilo Torres
	 * @return string nombre de la pagina generada
     * @access  public
	*/
	function generar_eventos ($id_sitio = 0, $path_sitio = 0, $idioma = 0)
	{ 
		if (!$id_sitio) {
			$id_sitio = $_SESSION['sitio']['id_objeto'];
			$idioma = new Sis_idiomas;
			$idioma->get('enctype' , $_SESSION['sis_idioma']['enctype']);
			$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/';
		}
		
		// obtengo el url del sitio
		$url = explode("/",$path_sitio);
	    $contenedor = new Eve_datos_modulos_eventos;
        $contenedor->get("id_contenedor", ID_SITIO);
		$categoria = new Eve_categorias;

		$raiz = Fachada_Eventos::obtener_categoria_raiz($contenedor->id_objeto);
        $pagina = "pagina_". $raiz . ".php";

		// incluyo el template
		$archivo_eventos = $path_sitio . "/" . $pagina;
		$template_eventos = PATH_EVENTOS . "vistas/tpl_eventos_ppal.php";

        $forward = '$go_map->_addForward';
        $form = '$go_map->_addForm';
        $mapping= '$go_map->_addMapping';
		$session = '$_SESSION["go_map"] = $go_map;';


		// Se escribe el contenido del eventos
		$contenido = addslashes(implode("\n", file($template_eventos)));
		$contenido= str_replace ("?"," #?# ",$contenido);

		eval("\$contenido_HTML = \"$contenido\"; ");
		$contenido_HTML = str_replace (" #?# ", "?", $contenido_HTML);
		File::writeLine($archivo_eventos, stripslashes($contenido_HTML), FILE_MODE_WRITE);

		return $pagina;
    }

/****************************************************************************************/
/*                                Aqui van las funciones que ejecuta el navegante                                              */
/****************************************************************************************/


	/*
	 * Genera los archivos HTML para los resultados de la busqueda de un usuario
     *
	 * @param   string $enc_idioma carpeta en la que se va a generar la pagina.
	 *
	 * @author  Camilo Torres
     * @access  public
	*/
	function generar_resultado_busqueda ($enc_idioma) {
		$template_lista = PATH_EVENTOS . "vistas/tpl_lista_evento_usuario.php";
//		@unlink("vistas/$enc_idioma/listar_evento_usuario.php");
		File::writeLine("vistas/$enc_idioma/listar_evento_usuario.php", '<? include("vistas/'.$enc_idioma.'/head_public.php") ?>', FILE_MODE_WRITE);
		File::writeLine("vistas/$enc_idioma/listar_evento_usuario.php", '<? include(PATH_EVENTOS."vistas/'.$enc_idioma.'.php") ?>');
		File::writeLine("vistas/$enc_idioma/listar_evento_usuario.php", "<? include('$template_lista') ?>");
		File::writeLine("vistas/$enc_idioma/listar_evento_usuario.php", '<? include("vistas/foot_public.php") ?>');
	}
	
	/*
	 * Genera los archivos HTML para ver los datos de el lugar
     *
	 * @param   string $enc_idioma carpeta en la que se va a generar la pagina.
	 *
	 * @author  Camilo Torres
     * @access  public
	*/
    function generar_lugar ($enc_idioma) {
		$template_lista = PATH_EVENTOS . "vistas/tpl_lugar.php";
		@unlink("vistas/$enc_idioma/ver_lugar.php");
		File::writeLine("vistas/$enc_idioma/ver_lugar.php", '<? include(PATH_EVENTOS."vistas/'.$enc_idioma.'.php") ?>', FILE_MODE_WRITE);
		File::writeLine("vistas/$enc_idioma/ver_lugar.php", "<? include('$template_lista') ?>");
	}

	/*
	 * Genera los archivos HTML para ver informacion detallada de un evento
     *
	 * @param   string $enc_idioma carpeta en la que se va a generar la pagina.
	 *
	 * @author  Camilo Torres
     * @access  p?????r???A?G?????G?G?Gublic
	*/
	function generar_resultado_ver_mas ($enc_idioma) {
		$template_lista = PATH_EVENTOS . "vistas/tpl_ver_mas.php";
		@unlink("vistas/$enc_idioma/ver_mas.php");
		File::writeLine("vistas/$enc_idioma/ver_mas.php", '<? include("vistas/'.$enc_idioma.'/head_public.php") ?>', FILE_MODE_WRITE);
		File::writeLine("vistas/$enc_idioma/ver_mas.php", '<? include(PATH_EVENTOS."vistas/'.$enc_idioma.'.php") ?>');
		File::writeLine("vistas/$enc_idioma/ver_mas.php", "<? include('$template_lista') ?>");
		File::writeLine("vistas/$enc_idioma/ver_mas.php", '<? include("vistas/foot_public.php") ?>');
	}


}

?>