<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */
//
// Especificacin de articulos
//
 /**
 *  La clase fachada contenido administra las clases para el modulo de contenido
 *
 * @package  Foro
 * @version  1
 * @author Maria Luisa Manyoma <mlmanyoma@telesat.com.co> 
 * @since    PHP 4.3.3
 */


// Clases necesarias

require_once(PATH_FORO . 'modelo/For_categorias.php');
require_once(PATH_FORO . 'modelo/For_categorias_versiones.php');
require_once(PATH_FORO . 'modelo/For_datos_modulos_foro.php');
require_once(PATH_FORO . 'modelo/For_mensajes.php');
require_once(PATH_FORO . 'modelo/For_mensajes_versiones.php');


// Mapeamiento
include(PATH_FORO . 'controlador/mappings.php');


//CONTROLADOR
require_once PATH_FORO . 'controlador/forms/for_crear_categoriaForm.php';
require_once PATH_FORO . 'controlador/actions/for_crear_categoriaAction.php'; 
//require_once PATH_FORO . 'controlador/forms/for_modificar_categoriaForm.php';
//require_once PATH_FORO . 'controlador/actions/for_modificar_categoriaAction.php'; 
require_once PATH_FORO . 'controlador/actions/for_listar_categoriasAction.php'; 
require_once PATH_FORO . 'controlador/actions/for_listar_mensajesAction.php'; 
require_once PATH_FORO . 'controlador/actions/for_crear_mensajeAction.php'; 
require_once PATH_FORO . 'controlador/actions/for_ver_mensajeAction.php'; 
require_once PATH_FORO . 'controlador/actions/for_enviar_emailAction.php'; 
require_once PATH_FORO . 'controlador/actions/for_mostrar_opcionesAction.php'; 
require_once PATH_FORO . 'controlador/actions/for_eliminar_categoriaAction.php'; 
require_once PATH_FORO . 'controlador/actions/for_buscar_mensajesAction.php'; 

class Fachada_foro
{


	 /**
 	 * Crea una categoria de foro nueva
     *
	 * @param   int $id_categoria identificador de la categoria
	 * @param   int $id_categoria_padre identificador del padre de la categoria
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @param   string $nombre nombre  de la categoria
	 * @param   string $descripcion descripcion de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function crear_categoria($id_contenedor, $id_categoria_padre, $id_idioma, $nombre, $descripcion){
		$categoria = new For_categorias;
		$categoria->id_contenedor = $id_contenedor;
		$categoria->id_categoria_padre = $id_categoria_padre;
		$id = $categoria->insert();

		$categoria_version = new For_categorias_versiones;
		$categoria_version->id_objeto = $id;
		$categoria_version->id_idioma = $id_idioma;
		$categoria_version->nombre = $nombre;
		$categoria_version->descripcion = $descripcion;
		$id_categoria_version = $categoria_version->insert();

		return $id; 
	}


	 /**
 	 * Crea una categoria de foro nueva
     *
	 * @param   int $id_contenedo identificador del contenedor de la categoria
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function listar_categorias($id_contenedor, $id_idioma){
		$categorias = new For_categorias;
		$categorias_versiones = new For_categorias_versiones;
		$categorias->id_contenedor = $id_contenedor;
        $categorias_versiones->id_idioma = $id_idioma;
		$categorias->joinAdd($categorias_versiones);
		$categorias->find();
		$arreglo_categorias = array();
		while ($categorias->fetch()) {
			array_push($arreglo_categorias, Array("id_objeto" =>  $categorias->id_objeto, 
									              "nombre" => $categorias->nombre, 
									              "descripcion" => $categorias->descripcion));
		}
		return $arreglo_categorias;
	}


	 /**
 	 * Muestra una categoria de foro
     *
	 * @param   int $id_categoria identificador de la categoria
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function ver_categoria($id_categoria_foro, $id_idioma){
		$categoria_versiones = new For_categorias_versiones;
		$categoria_versiones->whereAdd("id_objeto = '$id_categoria_foro'");
		$categoria_versiones->whereAdd("id_idioma = '$id_idioma'");
		$categoria_versiones->find(true);
        $array_categoria = array();
		$array_categoria = Array(Array("id_objeto" =>  $categoria_versiones->id_objeto, 
							   		   "nombre" => $categoria_versiones->nombre, 
							   		   "descripcion" => $categoria_versiones->descripcion));
		return $array_categoria;
	}


	/**
 	 * Obtiene el contendor de una categoria
	 *
     * @param   int $id_sitio Identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function traer_contenedor($id_sitio)
	{
		$datos_modulo = new For_datos_modulos_foro;
		$query = "SELECT id_objeto 
				  FROM {$datos_modulo->__table} 
				  WHERE id_contenedor = '$id_sitio' "; 

		$datos_modulo->query($query);
		$datos_modulo->fetch();
		return $datos_modulo->id_objeto;
	}

	 /**
 	 * Modifica una categoria de foro 
     *
	 * @param   int $id_categoria_foro identificador de la categoria
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @param   string $nombre nombre modificado de la categoria
	 * @param   string $descripcion descripcion modificada de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function modificar_categoria($id_categoria_foro, $id_idioma, $nombre, $descripcion){
		$categoria_version = new For_categorias_versiones;
		$categoria_version->whereAdd("id_objeto = '$id_categoria_foro'");
		$categoria_version->whereAdd("id_idioma = '$id_idioma'");
		$categoria_version->nombre = $nombre;
		$categoria_version->descripcion = $descripcion;
		$categoria_version->update();

		return; 
	}

	 /**
 	 * Crea un mensaje nuevo 
     *
	 * @param   int $id_padre identificador de la categoria
	 * @param   int $id_categoria_foro identificador del padre de la categoria
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @param   string $autor nombre  de la categoria
	 * @param   string $email nombre  de la categoria

	 * @param   string $titulo nombre  de la categoria
	 * @param   string $asunto descripcion de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function crear_mensaje($id_idioma, $id_categoria_foro, $id_padre, $autor, $email, $titulo, $texto_mensaje){
		$mensaje = new For_mensajes;
		$mensaje->id_contenedor = $id_categoria_foro;
		$mensaje->id_padre = $id_padre;
        $mensaje->autor = $autor;
		$mensaje->email = $email;
		$mensaje->fecha_publicacion = date("Y-m-d");
		$id = $mensaje->insert(); 

		$mensaje_version = new For_mensajes_versiones;
		$mensaje_version->id_objeto = $id; 
		$mensaje_version->id_idioma = $id_idioma;
		$mensaje_version->nombre = $titulo;
		$mensaje_version->descripcion = $texto_mensaje;
		$id_version = $mensaje_version->insert();

        return $id;
	}

	 /**
 	 * Listar mensajes 
     *
	 * @param   int $id_categoria identificador de la categoria a listar
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function listar_mensajes($id_idioma, $id_categoria){
		$mensajes = new For_mensajes;
		$mensajes_versiones = new For_mensajes_versiones;
		$mensajes->id_contenedor = $id_categoria; 
		$mensajes->joinAdd($mensajes_versiones); 
		$mensajes->find();
        $arreglo_mensajes = array();
		while ($mensajes->fetch()) {
			array_push($arreglo_mensajes, Array("id_objeto" =>  $mensajes->id_objeto, 
									            "titulo" => $mensajes->nombre, 
									            "autor" => $mensajes->autor,
									            "fecha" => $mensajes->fecha_publicacion,
												"id_categoria_foro" => $id_categoria));
		}

		return $arreglo_mensajes;
	}

	 /**
 	 * muestra un mensaje
     *
	 * @param   int $id_mensaje identificador del mensaje
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function ver_mensaje($id_idioma, $id_mensaje){
		$mensajes = new For_mensajes;
		$mensajes_versiones = new For_mensajes_versiones;
		$mensajes_versiones->id_objeto = $id_mensaje; 
		$mensajes_versiones->id_idioma = $id_idioma; 
		$mensajes->joinAdd($mensajes_versiones); 
		$mensajes->find(true);
		$id_padre = $mensajes->id_objeto;
        $mensaje = array();
		$mensaje = Array(Array("id_objeto" =>  $mensajes->id_objeto, 
							   "id_contenedor" => $mensajes->id_contenedor, 
							   "email" => $mensajes->email, 
							   "autor" => $mensajes->autor,
						       "email" => $mensajes->email,
							   "fecha" => $mensajes->fecha_publicacion,
							   "titulo" => $mensajes->nombre,
							   "mensaje" => $mensajes->descripcion));
		return $mensaje;

    }


	 /**
 	 * muestra las respuestas a un mensaje
     *
	 * @param   int $id_padre identificador del mensaje padre
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function ver_respuestas($id_idioma, $id_padre){

		$mensajes = new For_mensajes;
		$mensajes_versiones = new For_mensajes_versiones;
		$mensajes->id_padre = $id_padre; 
		$mensajes_versiones->id_idioma = $id_idioma; 
		$mensajes->joinAdd($mensajes_versiones); 
		$mensajes->find();
        $respuestas = array();
		while ($mensajes->fetch()) {
			array_push($respuestas, Array("id_objeto" =>  $mensajes->id_objeto, 
										  "id_contenedor" => $mensajes->id_contenedor, 
									      "titulo" => $mensajes->nombre, 
									      "autor" => $mensajes->autor,
									      "email" => $mensajes->email,
									      "fecha" => $mensajes->fecha_publicacion,
										  "titulo" => $mensajes->nombre,
										  "mensaje" => $mensajes->descripcion));
		}
		return $respuestas;
    }


	 /**
 	 * envia un email a un autor de un mensaje
     *
	 * @param   int $id_padre identificador del mensaje padre
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function enviar_email($email_destino, $email_fuente, $nombre, $asunto, $referencia, $contenido){

			$recipients = $email_destino;

			$headers['From']    = $email_fuente;
			$headers['To']      = $email_destino;
			$headers['Subject'] = $asunto;
			
			$body = "Referencia: ";
			$body .= $referencia;
			$body .= "\n";
			$body .= "Nombre: ";
			$body .= $nombre;
			$body .= "\n";
			$body .= "Contenido: ";
			$body .= $contenido;
	
			//$params['sendmail_path'] = '/usr/lib/sendmail';
			
			// Create the mail object using the Mail::factory method
			$mail_object =& Mail::factory('sendmail');
			$mail_object->send($recipients, $headers, $body);
			
			return;





	}

	 /**
 	 * Elimina una categoria de foro con todo su contenido
     *
	 * @param   int $id_categoria_foro identificador de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function eliminar_categoria($id_categoria_foro, $id_idioma){

		$categoria_version = new For_categorias_versiones;
		$categoria_version->id_objeto = $id_categoria_foro;
		$categoria_version->id_idioma = $id_idioma;
		$categoria_version->delete();

		$categoria = new For_categorias;
		$categoria->get($id_categoria_foro);
		$categoria->delete();


		return; 
	}
    /**
 	 * Busca un mensajes dado unos criterios
     *
	 * @param   int $id_categoria_foro identificador del contenedor del mensaje
	 * @param   int $titulo titulo del articulo
	 * @param   int $resumen resumen del articulo
	 * @param   int $mes mes de creacin del articulo
	 * @param   int $anno ao de creacin del articulo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function buscar_mensajes($id_idioma, $id_categoria_foro, $titulo, $contenido, $mes, $anno){
		$mensajes = new For_mensajes;
		$mensajes_versiones = new For_mensajes_versiones;
		$mensajes->id_contenedor = $id_categoria;
		$mensajes_versiones->id_idioma = $id_idioma;
		$mensajes->joinAdd($mensajes_versiones); 

		if ($titulo){
			$titulo = "'%".$titulo."%'";
			$mensajes->whereAdd("LOWER(nombre) LIKE LOWER($titulo)");
		}
		if ($resumen){
			$resumen = "'%".$resumen."%'";
			$mensajes->whereAdd("LOWER(descripcion) LIKE LOWER($contenido)");
		}
		if ($mes)
			$mensajes->whereAdd("MONTH(fecha_publicacion) = '$mes'");
		if ($anno)	
			$mensajes->whereAdd("YEAR(fecha_publicacion) = '$anno'");

		$mensajes->find();
		$arreglo = array();
		while ($mensajes->fetch()) {

	    	/* almacenamos en el arreglo slo los campos que necesitamos */
			if(sizeof($arreglo) == 0)
				$arreglo = Array(Array("id_objeto" =>  $mensajes->id_objeto, 
									   "titulo" => $mensajes->nombre, 
									   "autor" => $mensajes->autor, 
									   "fecha" => $mensajes>fecha_publicacion,
									   "id_contenedor" => $mensajes->id_contenedor));
			else
				array_push($arreglo, Array("id_objeto" =>  $mensajes->id_objeto, 
									       "titulo" => $mensajes->nombre, 
									       "autor" => $mensajes->autor, 
										   "fecha" => $mensajes->fecha_publicacion,
									   	   "id_contenedor" => $mensajes->id_contenedor));
		}

		return $arreglo; 

	}

	 /**
 	 * Modifica un mensaje
     *
	 * @param   int $id_idioma identificador del idioma del sitio
	 * @param   string $autor nombre  de la categoria
	 * @param   string $email nombre  de la categoria
	 * @param   string $titulo nombre  de la categoria
	 * @param   string $contenido descripcion de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function modificar_mensaje($id_idioma, $id_mensaje, $autor, $email, $titulo, $contenido){
		$mensaje = new For_mensajes;
		$mensaje->get($id_mensaje);
        $mensaje->autor = $autor;
		$mensaje->email = $email;
	    $mensaje->update(); 

		$mensaje_version = new For_mensajes_versiones;
		$mensaje_version->whereAdd("id_objeto = '$id_mensaje'"); 
		$mensaje_version->whereAdd("id_idioma = '$id_idioma'"); 
		$mensaje_version->nombre = $titulo;
		$mensaje_version->descripcion = $contenido;
		$mensaje_version->update();

        return;
	}


}
?>