-- Archivo de creacin de tablas para el paquete Foro
-- Fecha: Septiembre 13 2004
-- Autor Maria Luisa Manyoma

CREATE TABLE for_datos_modulos_foro
(
  PRIMARY KEY (id_objeto),
  FOREIGN KEY (id_tipo) REFERENCES sis_tipo_modulo (id_tipo)
) INHERITS (sis_datos_modulos);
COMMENT ON TABLE for_datos_modulos_foro IS 'Datos generales del modulo de foro.';

CREATE TABLE for_categorias
(
  PRIMARY KEY (id_objeto)
) INHERITS (sis_categorias);
COMMENT ON TABLE for_categorias IS 'Datos cada categoria de foro.';

CREATE TABLE for_categorias_versiones
(
  PRIMARY KEY (id_versiones),
  FOREIGN KEY (id_objeto) REFERENCES for_categorias (id_objeto),
  FOREIGN KEY (id_idioma) REFERENCES sis_idiomas (id_idioma)
) INHERITS (sis_paginas_versiones);

CREATE TABLE for_censura
(
  PRIMARY KEY (id_objeto)
) INHERITS (sis_objetos_protegidos);

CREATE TABLE for_censura_versiones
(
  PRIMARY KEY (id_versiones),
  FOREIGN KEY (id_objeto) REFERENCES for_censura (id_objeto),
  FOREIGN KEY (id_idioma) REFERENCES sis_idiomas (id_idioma)
) INHERITS (sis_versiones) WITH OIDS;

CREATE TABLE for_directorio
(
  PRIMARY KEY (id_objeto),
  FOREIGN KEY (id_contenedor) REFERENCES for_datos_modulos_foro (id_objeto)
) INHERITS (sis_paginas);

CREATE TABLE for_directorio_versiones
(
  PRIMARY KEY (id_versiones),
  FOREIGN KEY (id_objeto) REFERENCES for_directorio (id_objeto),
  FOREIGN KEY (id_idioma) REFERENCES sis_idiomas (id_idioma)
) INHERITS (sis_paginas_versiones) WITH OIDS;

CREATE TABLE for_mensajes
(
  id_padre int4 DEFAULT 0,
  publicado bool,
  autor varchar(255),
  fecha_publicacion date,
  email varchar(255),
  PRIMARY KEY (id_objeto)
) INHERITS (public.sis_paginas) WITH OIDS;

CREATE TABLE public.for_mensajes_versiones
(
  PRIMARY KEY (id_versiones),
  FOREIGN KEY (id_objeto) REFERENCES for_mensajes (id_objeto),
  FOREIGN KEY (id_idioma) REFERENCES sis_idiomas (id_idioma)
) INHERITS (sis_versiones) WITH OIDS;