<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.3.3                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// |									  |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |		  John Vargas <jhonvargas@telesat.com.co>                 |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
//
/*
 * Clase que contiene las funciones de generacion del modulo de  Foto Album
 *
 * @package Foto_Album
 * @version  1
 * @author   Camilo Torres C.
 * @since    PHP 4.1.2
 */
 
class Generador_Foto_Album
{

    /* 
  	 * Obtiene los datos necesarios para generar las paginas del foto album, y llama la creacion
     *
	 * @author  Camilo Torres
     * @access  public
	*/
    function generar_local ()
    { 
        $idioma = new Sis_idiomas;
        $idioma->get("id_idioma", $_SESSION['sis_idioma']['id_idioma']);
        $path = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
        Generador_Foto_Album::generar_foto_album ($_SESSION['sitio']['id_objeto'], $path, $idioma);
    }
    
	
    
    /* 
	 * Genera los archivos HTML para el foto album del sitio
     *
     * @param   int $id_sitio Identificador del sitio al cual se le genera el foto album
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param   string $idioma Idioma del sitio
	 * @author  Camilo Torres
     * @access  public
	*/
	function generar_foto_album ($id_sitio = 0, $path_sitio = 0, $idioma = 0)
	{ 
		if (!$id_sitio) {
			$id_sitio = $_SESSION['sitio']['id_objeto'];
			$idioma = new Sis_idiomas;
			$idioma->get('enctype' , $_SESSION['sis_idioma']['enctype']);
			$path_sitio = 'html/' . $_SESSION['sitio']['url'] . '/vistas/' . $_SESSION['sis_idioma']['enctype'] . '/';
		}
	
		$url = explode("/",$path_sitio);
        $url = $url[1];
		$contenedor = new Fot_datos_modulos_foto_album;
	 	$categoria = new Fot_categorias;
		$contenedor->get("id_contenedor",$id_sitio);
		$categoria->id_contenedor = $contenedor->id_objeto;
		$resultados = $categoria->find();
		$lista_categorias = array();
		// Nombre de la pagina generada
		$pagina = "pagina_" . $contenedor->id_objeto . ".php";
		// Si hay datos 
		if ($resultados) {
			while ($categoria->fetch()){
				$categoria_version = new Fot_categorias_versiones;
				$categoria_version->id_idioma = $idioma->id_idioma;
				$categoria_version->id_objeto = $categoria->id_objeto;
				$esta_version = $categoria_version->find(true);
				// Este if va por los diferentes idiomas del sitio
				if ($esta_version) {
					$categoria_versiones[$categoria->id_objeto] = $categoria_version->toArray();
				} else {
					$categoria_version->id_idioma = null;
					$categoria_version->find(true);
					$categoria_versiones[$categoria->id_objeto] = $categoria_version->toArray();
				}
				array_push($lista_categorias, $categoria);		
				// Generar por cada categoria el archivo que muestra sus colecciones
				Generador_Foto_Album::generar_categoria($categoria->id_objeto, $path_sitio, $archivo_foto_album, $idioma);
			}

			$archivo_foto_album = $path_sitio . "/" . $pagina;
			$template_foto_album = PATH_FOTO_ALBUM . "vistas/tpl_foto_album.php";
				
			// Se escribe la cabecera del portal
			File::writeLine($archivo_foto_album, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>', FILE_MODE_WRITE);
			File::writeLine($archivo_foto_album, '<? include( PATH_FOTO_ALBUM . "vistas/' .$idioma->enctype . '.php") ?>');
				
			// Se escribe la cabecera del minisitio
/*			File::writeLine($archivo_foto_album, '<? include("ms_cabecera.php") ?>');*/
		
			// Se escribe el contenido del foto_album
			include($template_foto_album); 
			File::writeLine($archivo_foto_album, $contenido_HTML);
		
			// Se escribe el pie del portal
			File::writeLine($archivo_foto_album, '<? include("vistas/foot_public.php") ?>');

			return $pagina;
		} else {
			$archivo_foto_album = $path_sitio . "/" . $archivo_foto_album;
			// Se escribe la cabecera del portal
			File::writeLine($archivo_foto_album, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>', FILE_MODE_WRITE);
			File::writeLine($archivo_foto_album, '<? include( PATH_FOTO_ALBUM . "vistas/' .$idioma->enctype . '.php") ?>');

			File::writeLine($archivo_foto_album, "<?= NO_DATOS ?> ");
			File::writeLine($archivo_foto_album, "<a href='javascript:history.back()'><?= VOLVER ?></a>");
			
			// Se escribe el pie del portal
			File::writeLine($archivo_foto_album, '<? include("vistas/foot_public.php") ?>');
			return $pagina;
		}
	}


    /* 
	 * Genera los archivos HTML para las categorias del foto album del sitio
     *
     * @param   int $id_categoria id_objeto de la categoria que voy a generar
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param   string $archivo_foto_album archivo inicial del foto album
	 * @param   string $idioma Idioma del sitio
	 * @author  Camilo Torres
     * @access  public
	*/
	function generar_categoria ($id_categoria, $path_sitio, $archivo_foto_album, $idioma)
	{
		$url = explode("/",$path_sitio)	;
        $url = $url[1];
		// Nombre del archivo a generar
		$archivo_categoria = "pagina_" . $id_categoria . ".php";
		$coleccion = new Fot_colecciones;
		$coleccion->id_contenedor = $id_categoria;
		$coleccion->orderBy('posicion');
		$resultados = $coleccion->find();
		$lista_colecciones = array();
		
		$categoria_version = new Fot_categorias_versiones;
		$categoria_version->id_objeto = $id_categoria;
		$categoria_version->id_idioma = $idioma->id_idioma;
		$categoria_version->find(true);
		// Verifico si la categoria tiene coleccionas
		if ($resultados){
			while ($coleccion->fetch()){
                $coleccion_version = new Fot_colecciones_versiones;
                $coleccion_version->joinAdd($coleccion);
                $coleccion_version->selectAs();
                $coleccion_version->selectAs($coleccion, 'col_%s');
                $coleccion_version->id_idioma = $idioma->id_idioma;
                $coleccion_version->find(true);
                array_push($lista_colecciones, get_object_vars($coleccion_version));
				
				Generador_Foto_Album::generar_coleccion($coleccion->id_objeto, $path_sitio, $archivo_categoria, $idioma);
			}
			$archivo_categoria = $path_sitio . "/" . $archivo_categoria;
			$template_categoria = PATH_FOTO_ALBUM . "vistas/tpl_categoria.php";

			// Se escribe la cabecera del portal
			File::writeLine($archivo_categoria, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>', FILE_MODE_WRITE);
			File::writeLine($archivo_categoria, '<? include( PATH_FOTO_ALBUM . "vistas/' .$idioma->enctype . '.php") ?>');
				
			// Se escribe la cabecera del minisitio
			/*File::writeLine($archivo_categoria, '<? include("ms_cabecera.php") ?>');*/
		
			// Se escribe el contenido de la categoria
			include($template_categoria);
			File::writeLine($archivo_categoria, $contenido_HTML);
		
			// Se escribe el pie del portal
			File::writeLine($archivo_categoria, '<?  include("vistas/foot_public.php")  ?>');

			return 1;
		} else {
			$archivo_categoria = $path_sitio . "/" . $archivo_categoria;
			// Se escribe la cabecera del portal
			File::writeLine($archivo_categoria, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>', FILE_MODE_WRITE);
			File::writeLine($archivo_categoria, '<? include( PATH_FOTO_ALBUM . "vistas/' .$idioma->enctype . '.php") ?>');

			File::writeLine($archivo_categoria, "<?= NO_DATOS ?> ");
			File::writeLine($archivo_categoria, "<a href='javascript:history.back()'><?= VOLVER ?></a>");
			
			// Se escribe el pie del portal
			File::writeLine($archivo_categoria, '<? include("vistas/foot_public.php") ?>');
			return 0;
		}
	}
	
    /* 
	 * Genera los archivos HTML para las colecciones del foto album del sitio
     *
     * @param   int $id_coleccion id_objeto de la coleccion que voy a generar
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param   string $archivo_categoria archivo de la categoria a la que pertenece la coleccion
	 * @param   string $idioma Idioma del sitio
	 * @author  Camilo Torres
     * @access  public
	*/
	function generar_coleccion ($id_coleccion, $path_sitio, $archivo_categoria, $idioma)
	{
		$url = explode("/",$path_sitio)	; 
        $url = $url[1];
		// Nombre del archivo a generar
		$archivo_coleccion = "pagina_" . $id_coleccion . ".php";
		$imagen = new Fot_imagenes;
		$imagen->id_contenedor = $id_coleccion;
        $imagen->orderBy('posicion');
		$resultados = $imagen->find();
		$lista_imagenes = array();
		// Verifico si la coleccion tiene imagenes
		if ($resultados){
			while ($imagen->fetch()){                
                $imagen_version = new Fot_imagenes_versiones;
                $imagen_version->joinAdd($imagen);
                $imagen_version->selectAs();
                $imagen_version->selectAs($imagen, 'arc_%s');
                $imagen_version->id_idioma = $idioma->id_idioma;
                $imagen_version->find(true);
                array_push($lista_imagenes, get_object_vars($imagen_version));
				Generador_Foto_Album::generar_imagen($imagen->id_objeto, $path_sitio, $archivo_coleccion, $idioma, $resultados);
			}

        $coleccion = new Fot_colecciones;
        $coleccion->get("id_objeto", $id_coleccion);
        $coleccion_version = new Fot_colecciones_versiones;
        $coleccion_version->joinAdd($coleccion);
        $coleccion_version->id_idioma = $_SESSION[sis_idioma][id_idioma];
        $coleccion_version->find(true);
        
		// Busco los atributos de la coleccion para visualizarlos
        $atributos_cat = Fachada_Foto_Album::buscar_atributos($coleccion->id_contenedor, $_SESSION['sis_idioma']['id_idioma']);
        foreach ($atributos_cat AS $atributo) {
            $atributo_valor = new Fot_atributos_valores;
            $atributo_valor->id_contenedor = $atributo['id_objeto'];
            $atributo_valor->id_coleccion = $coleccion_version->id_versiones;
            $atributo_valor->find(true);
            $coleccion_atributos[$atributo['id_objeto']] = $atributo_valor->toArray();
        }
            			
            $archivo_coleccion = $path_sitio . "/" . $archivo_coleccion;
			$template_coleccion = PATH_FOTO_ALBUM . "vistas/tpl_coleccion.php";
			// Se escribe la cabecera del portal
			File::writeLine($archivo_coleccion, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>', FILE_MODE_WRITE);
			File::writeLine($archivo_coleccion, '<? include(PATH_FOTO_ALBUM . "vistas/'.$idioma->enctype.'.php") ?>');
				
			// Se escribe la cabecera del minisitio
			/*File::writeLine($archivo_coleccion, '<? include("ms_cabecera.php") ?>'); */
		
			// Se escribe el contenido de la coleccion
			include($template_coleccion);
			File::writeLine($archivo_coleccion, $contenido_HTML);
		
			// Se escribe el pie del portal
			File::writeLine($archivo_coleccion, '<? include("vistas/foot_public.php") ?>');

			return 1;
		} else {
			$archivo_coleccion = $path_sitio . "/" . $archivo_coleccion;
			// Se escribe la cabecera del portal
			File::writeLine($archivo_coleccion, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>', FILE_MODE_WRITE);
			File::writeLine($archivo_coleccion, '<? include(PATH_FOTO_ALBUM . "vistas/'.$idioma->enctype.'.php") ?>');

			File::writeLine($archivo_coleccion, "<?= NO_DATOS ?> ");
			File::writeLine($archivo_coleccion, "<a href='javascript:history.back()'><?= VOLVER ?></a>");
			
			// Se escribe el pie del portal
			File::writeLine($archivo_coleccion, '<? include("vistas/foot_public.php") ?>');
			return 0;
		}
	}
	
    /* 
	 * Genera los archivos HTML para las imagenes del foto album del sitio
     *
     * @param   int $id_imagen id_objeto de la imagen que voy a generar
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param   string $archivo_coleccion archivo de la coleccion a la que pertenece la imagen
	 * @param   string $idioma Idioma del sitio
	 * @param   int $resultados Cantidad de imagenes que voy a generar
	 * @author  Camilo Torres
     * @access  public
	*/
	function generar_imagen ($id_imagen, $path_sitio, $archivo_coleccion, $idioma, $resultados)
	{ 
		$url = explode("/",$path_sitio)	;
        $url = $url[1];
		// Nombre de la pagina que voy a generar
		$archivo_imagen = "pagina_" . $id_imagen . ".php";
		$archivo = new Fot_imagenes;
		$archivo->get("id_objeto", $id_imagen);
		$template_imagen = PATH_FOTO_ALBUM . "vistas/tpl_imagen.php";
		$archivo_imagen = $path_sitio . "/" . $archivo_imagen;
		
		$imagen_version = new Fot_imagenes_versiones;
		$imagen_version->id_objeto = $id_imagen;
		$imagen_version->id_idioma = $idioma->id_idioma;
		$imagen_version->find(true);

		// Se escribe la cabecera del portal
		/*File::writeLine($archivo_imagen, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>');*/
				
		// Se escribe la cabecera del minisitio
		/*File::writeLine($archivo_imagen, '<? include("ms_cabecera.php") ?>');*/

		// Se escribe el contenido de la imagen

		// Verifico si la imagen tiene una imagen predecesora y sucesora
        if ($archivo->posicion != 1) {
            $anterior = new Fot_imagenes;
            $anterior->id_contenedor = $archivo->id_contenedor;
            $anterior->posicion = $archivo->posicion - 1;
            $anterior->find(true);
            $cadena_anterior = "pagina_" . $anterior->id_objeto . ".php";
        }
        if ($archivo->posicion < $resultados) {
            $siguiente = new Fot_imagenes;
            $siguiente->id_contenedor = $archivo->id_contenedor;
            $siguiente->posicion = $archivo->posicion + 1;
            $siguiente->find(true);
            $cadena_siguiente = "pagina_" . $siguiente->id_objeto . ".php";
        }

        	
		include($template_imagen); 
	
/*		File::writeLine($archivo_imagen, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>', FILE_MODE_WRITE);		*/
		File::writeLine($archivo_imagen, '<? include(PATH_FOTO_ALBUM . "vistas/'.$idioma->enctype.'.php") ?>', FILE_MODE_WRITE);
		File::writeLine($archivo_imagen, $contenido_HTML);
		
		// Se escribe el pie del portal
		/*File::writeLine($archivo_imagen, '<? include("vistas/foot_public.php") ?>');*/

	}


}
?>
