<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.3.3                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// |                                                                         |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John Vargas <jhonvargas@telesat.com.co>                     |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
//
//
// Especificaci?n de los minisitios
//
// Clases necesarias
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_datos_modulos_hojas_de_vida.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_area_estudio.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_nivel_educacion.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_profesiones.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_informacion_personal.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_informacion_personal_versiones.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_estudios_realizados.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_estudios_realizados_versiones.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_idiomas.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_expectativas.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_expectativas_versiones.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_experiencia_laboral.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_experiencia_laboral_versiones.php');
require_once(PATH_HOJAS_DE_VIDA . 'modelo/Hdv_moneda.php');
// Mapping
include (PATH_HOJAS_DE_VIDA . 'controlador/mappings.php');
//CONTROLADOR
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_iniciar_hojaAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_iniciar_hojaForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_crear_hojaAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_crear_hojaForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_mostrar_hojaAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_mostrar_hojaForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_modificar_hojaAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_modificar_hojaForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_mostrar_estudiosAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_mostrar_estudiosForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_modificar_estudioAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_modificar_estudioForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_mostrar_laboralAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_mostrar_laboralForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_modificar_laboralAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_modificar_laboralForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_publicadoAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_publicadoForm.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/actions/hdv_publicarAction.php');
require_once(PATH_HOJAS_DE_VIDA . 'controlador/forms/hdv_publicarForm.php');

/**
 * La clase Fachada_Hojas_De_Vida contiene los mtodos para el manejo del
 * mdulo de Hojas de vida del sistema CMS
 *	Creacion y modificacion de los datos personales
 *	Creacion y modificacion de los estudios
 *	Creacion y modificacion de las expectativas laborales
 *	Creacion y modificacion de las referencias laborales
 *
 *
 * @package  Hojas_De_Vida
 * @version  1
 * @author   Camilo Torres <ccordoba@telesat.com.co>
 * @since    PHP 4.3.3
 */

class Fachada_Hojas_De_Vida
{

    /**
 	 * Busca las profesiones para visualizar en un combo
     *
     *
	 * @author  Camilo Torres C.
	 * @return array Arreglo asociativo con las profesiones
     * @access public
	 * @static
     */
  function listar_profesiones()
  {
    $profesion = new Sis_profesiones;
    $profesion->whereAdd('id_idioma = ' . $_SESSION['sis_idioma']['id_idioma']);
    $profesion->orderBy("nombre");
    $profesion->find();
    $arreglo_profesiones = array();
    while ($profesion->fetch()){
        array_push($arreglo_profesiones, $profesion);
    }
    return $arreglo_profesiones;
  }
  

    /**
 	 * Busca las actividades economicas para visualizar en un combo
     *
     *
	 * @author  Camilo Torres C.
	 * @return array Arreglo asociativo con las actividades economicas
     * @access public
	 * @static
     */
  function listar_actividades_economicas()
  {
    $actividad = new Sis_actividades_economicas;
    $actividad->whereAdd('id_idioma = ' . $_SESSION['sis_idioma']['id_idioma']);
    $actividad->orderBy("nombre");
    $actividad->find();
    $arreglo_actividades = array();
    while ($actividad->fetch()){
        array_push($arreglo_actividades, $actividad);
    }
    return $arreglo_actividades;
  }

    /**
 	 * Busca los idiomas para visualizar en un combo
     *
     *
	 * @author  Camilo Torres C.
	 * @return array Arreglo asociativo con los idiomas
     * @access public
	 * @static
     */
  function listar_idiomas()
  {
    $idioma = new Sis_idiomas;
    $idioma->orderBy("nombre");
    $idioma->find();
    $arreglo_idiomas = array();
    while ($idioma->fetch())
    {
        array_push($arreglo_idiomas, $idioma);}
    return $arreglo_idiomas;
  }
  
    /**
 	 * Busca los niveles de educacion para visualizar en un combo
     *
     *
	 * @author  Camilo Torres C.
	 * @return array Arreglo asociativo con los niveles de educacion
     * @access public
	 * @static
     */
  function listar_nivel_educacion()
  {
    $nivel_educacion = new Hdv_nivel_educacion;
	$nivel_educacion->whereAdd("id_idioma = ". $_SESSION['sis_idioma']['id_idioma']);
    $nivel_educacion->orderBy("nombre");
    $nivel_educacion->find();
    $arreglo_nivel_educacion = array();
    while ($nivel_educacion->fetch()){
        array_push($arreglo_nivel_educacion, $nivel_educacion);
    }
    return $arreglo_nivel_educacion;
  }
  

    /**
 	 * Busca las areas de estudio para visualizar en un combo
     *
     *
	 * @author  Camilo Torres C.
	 * @return array Arreglo asociativo con las areas de estudio
     * @access public
	 * @static
     */
  function listar_areas_estudio()
  {
    $area_estudio = new Hdv_area_estudio;
	$area_estudio->whereAdd("id_idioma = ". $_SESSION['sis_idioma']['id_idioma']);
    $area_estudio->orderBy("nombre");
    $area_estudio->find();
    $arreglo_area_estudio = array();
    while ($area_estudio->fetch()){
        array_push($arreglo_area_estudio, $area_estudio);
    }
    return $arreglo_area_estudio;
  }
  

    /**
 	 * Busca los tipos de moneda para visualizar en un combo
     *
     *
	 * @author  Camilo Torres C.
	 * @return array Arreglo asociativo con los tipos de moneda
     * @access public
	 * @static
     */
  function listar_monedas()
  {
    $moneda = new Hdv_moneda;
	$moneda->whereAdd("id_idioma = ". $_SESSION['sis_idioma']['id_idioma']);
    $moneda->orderBy("nombre");
    $moneda->find();
    $arreglo_moneda= array();
    while ($moneda->fetch()){
        array_push($arreglo_moneda, $moneda);
    }
    return $arreglo_moneda;
  }

    /**
 	 * Busca los datos que van a ser desplegados en combos en los datos personales de la hoja de vida,
     * verifica que haya un contacto previamente para generarle la hoja de vida
     *
	 * @author  Camilo Torres C.
	 * @return int 1 si hay un contacto, 0 en caso contrario
     * @access public
	 * @static
     */
  function iniciar_hoja()
  {
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);    
    $hoja_vida = new Hdv_informacion_personal;
    $existe = $hoja_vida->get("id_contenedor", $contenedor->id_objeto);
	// Verifico que no hayan datos previamente
    if ($existe){
        $_SESSION['mensaje'] = "La hoja de vida ya fu creada, ahora debe modificarla.";
        return 0;
    }
	// Traigo los datos de los combos
    $_SESSION['lista_paises'] = Fachada_Sistema::listar_paises($_SESSION['sis_idioma']['id_idioma']);
    $_SESSION['lista_profesiones'] = Fachada_Hojas_De_Vida::listar_profesiones();
    $_SESSION['lista_idiomas'] = Fachada_Hojas_De_Vida::listar_idiomas();
    
	// Verifico que exista un contacto
    $contacto = new Sis_contactos;
    $hay = $contacto->get("id_contacto", $_SESSION['usuario']['id_contacto']);
    if ($hay)
        $_SESSION['datos_contacto'] = $contacto;
    return $hay;
  }
  
    /**
 	 * Toma los datos personales del usuario y los almacena en la base de datos
     * 
     * @param string $nombre_completo Nombre de la persona
     * @param string $apellido_materno Apellido materno de la persona
     * @param string $apellido_paterno Apellido paterno de la persona
     * @param string $tipo_identificacion tipo de identificacion
     * @param string $identificacion Numero de identificacion
     * @param string $genero Genero
     * @param string $profesion Profesion
     * @param string $objetivo_profesional Objetivo profesional de la persona
     * @param string $areas_conocimiento Areas de conocimiento de la persona
     * @param string $imagen Nombre del archivo de la imagen para la hoja de vida
     * @param string $fecha_nacimiento Fecha de nacimiento de la persona
     * @param string $pais_origen Pais de nacimiento
     * @param string $nacionalidad Nacionalidad
     * @param string $direccion Direccion de residencia
     * @param string $barrio Barrio de residencia
     * @param string $ciudad Ciudad de residencia
     * @param string $departamento Departamento de residencia
     * @param string $pais Pais de residencia
     * @param string $codigo_postal Codigo postal
     * @param string $telefono_hogar Numero telefonico de la residencia
     * @param string $telefono_trabajo Numero telefonico del trabajo
     * @param string $telefono_movil Numero telefonico movil
     * @param string $email direccion de correo electronico
     * @param string $reubicarse_trabajo Si desea reubicarse de trabajo
     * @param string $reubicarse_pais Si es factible una reubicacion de pais
     * @param string $pais_visa1 Pais a donde tiene visa
     * @param string $pais_visa2 Pais a donde tiene visa
     * @param string $pais_visa3 Pais a donde tiene visa
     * @param string $anos_experiencia Aos de experiencia
     * @param string $archivo Nombre del archivo que desea adjuntar a su hoja de vida
     * @param array $idiomas Idiomas que domina y el nivel
     *
	 * @author  Camilo Torres C.
	 * @return int id_objeto de la hoja de vida si fue insertada, 0 en caso contrario
     * @access public
	 * @static
     */
  function crear_hoja($nombre_completo, $apellido_materno, $apellido_paterno, $tipo_identificacion,
                        $identificacion, $genero, $profesion, $objetivo_profesional, $areas_conocimiento,
                        $imagen, $fecha_nacimiento, $pais_origen, $nacionalidad, $direccion, $barrio,
                        $ciudad, $departamento, $pais, $codigo_postal, $telefono_hogar, $telefono_trabajo,
                        $telefono_movil, $email, $reubicarse_trabajo, $reubicarse_pais, $pais_visa1,
                        $pais_visa2,$pais_visa3, $anos_experiencia, $archivo, $idiomas)
  {
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);
    $id_contenedor = $contenedor->id_objeto;
    $path_sitio =  $_SESSION['sitio']['url'];
    $path_sitio = Util::fuera($path_sitio);
    $dir_contenido = "imagenes_cont/".$path_sitio;
    if (!file_exists($dir_contenido))
        mkdir($dir_contenido, 0755);
    if (!file_exists($dir_contenido."/hojas_de_vida"))
        mkdir($dir_contenido."/hojas_de_vida", 0755);
    
    
    $hoja_vida = new Hdv_informacion_personal;
    $hoja_vida->id_contenedor = $id_contenedor;
    $hoja_vida->nombre_completo = $nombre_completo;
    $hoja_vida->apellido_paterno = $apellido_paterno;
    $hoja_vida->apellido_materno = $apellido_materno;
    $hoja_vida->tipo_identificacion = $tipo_identificacion;
    $hoja_vida->identificacion = $identificacion;
    $hoja_vida->genero = $genero;
    if ($imagen['name'] != ""){
        $name_file = "Foto_hv" . substr($imagen['name'], -4);
        if (Imagen::copiar_imagen($imagen, $dir_contenido."/hojas_de_vida/".$name_file) == 1) {
            $hoja_vida->foto = $name_file;
        }
    }
    $hoja_vida->fecha_nacimiento = $fecha_nacimiento;
    $hoja_vida->direccion = $direccion; 
    $hoja_vida->codigo_postal = $codigo_postal; 
    $hoja_vida->telefono_hogar = $telefono_hogar; 
    $hoja_vida->telefono_trabajo = $telefono_trabajo; 
    $hoja_vida->telefono_movil = $telefono_movil; 
    $hoja_vida->email = $email; 
    $hoja_vida->reubicarse_trabajo = $reubicarse_trabajo; 
    $hoja_vida->reubicarse_pais = $reubicarse_pais; 
    $hoja_vida->anos_experiencia = $anos_experiencia;
    if ($archivo['name'] != ""){
        $name_file = "HojaDeVida" . substr($archivo['name'], -4);
        if (Util::copiar_archivo($archivo, $dir_contenido."/hojas_de_vida/".$name_file) == 1) {
            $hoja_vida->archivo = $name_file;
        }
    }
    $hoja_vida->publicado = 0;
    $insertar = $hoja_vida->insert();
	if ($insertar){
	    $hoja_vida_versiones = new Hdv_informacion_personal_versiones;
	   	$hoja_vida_versiones->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$hoja_vida_versiones->id_objeto = $insertar;
	   	$hoja_vida_versiones->nombre = $nombre_completo;
	   	$hoja_vida_versiones->profesion = $profesion;
	    $hoja_vida_versiones->objetivo_profesional = $objetivo_profesional;
	    $hoja_vida_versiones->areas_conocimiento = $areas_conocimiento;
	    $hoja_vida_versiones->pais_origen = $pais_origen;
	    $hoja_vida_versiones->nacionalidad = $nacionalidad; 
	    $hoja_vida_versiones->barrio = $barrio; 
	    $hoja_vida_versiones->ciudad = $ciudad; 
	    $hoja_vida_versiones->departamento = $departamento; 
	    $hoja_vida_versiones->pais = $pais; 
	    $hoja_vida_versiones->pais_visa1 = $pais_visa1; 
	    $hoja_vida_versiones->pais_visa2 = $pais_visa2; 
	    $hoja_vida_versiones->pais_visa3 = $pais_visa3; 
		$hoja_vida_versiones->insert();
		Util::log('Hojas de Vida', 'Datos personales', 'Se insertaron los datos personales');
	} else {
		Util::log('Hojas de Vida', 'Datos personales', 'Error al tratar de insertar los datos personales');
	}
    foreach($idiomas as $idioma){
        $item = new Hdv_idiomas;
        $datos = explode("|", $idioma);
        $item->id_contenedor = $id_contenedor;
        $item->idioma = $datos[0];
        $item->nivel = $datos[1];
        $item->insert();
    }
    $estudios = new Hdv_estudios_realizados;
    $estudios->id_contenedor = $id_contenedor;
    $estudios->insert();
    $experiencia = new Hdv_experiencia_laboral;
    $experiencia->id_contenedor = $id_contenedor;
    $experiencia->insert();
    $expectativas = new Hdv_expectativas;
    $expectativas->id_contenedor = $id_contenedor;
    $expectativas->insert();
    $_SESSION['mensaje'] = ($insertar)? "La informacin personal ha sido insertada." : "Ocurrio un error al insertar los datos.";    
    return $insertar;
  }
  

    /**
 	 * Busca la informacion referente a los datos personales de la hoja de vida,
     * 
     *
	 * @author  Camilo Torres C.
	 * @return int 1 si hay un contacto, 0 en caso contrario
     * @access public
	 * @static
     */
  function buscar_hoja()
  {
  	// Obtengo la informacion de los combos
    $_SESSION['lista_paises'] = Fachada_Sistema::listar_paises($_SESSION['sis_idioma']['id_idioma']);
    $_SESSION['lista_profesiones'] = Fachada_Hojas_De_Vida::listar_profesiones();
    $_SESSION['lista_idiomas'] = Fachada_Hojas_De_Vida::listar_idiomas();
  
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);    
    $hoja_vida = new Hdv_informacion_personal;
	// Obtengo el id_objeto de la hoja de vida
    $existe = $hoja_vida->get("id_contenedor", $contenedor->id_objeto);
    if ($existe){
        $_SESSION['datos_hv'] = $hoja_vida;
		$hoja_vida_versiones = new Hdv_informacion_personal_versiones;
		$hoja_vida_versiones->ib_objeto = $hoja_vida->id_objeto;
		$hoja_vida_versiones->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$hdv_version = $hoja_vida_versiones->find(true);
		if (hdv_version){
	        $_SESSION['datos_hv_version'] = $hoja_vida_versiones;
		}
		// Obtengo los idiomas que domina y el nivel
        $idioma = new Hdv_idiomas;
        $idioma->id_contenedor = $contenedor->id_objeto;
        $idioma->find();
        while ($idioma->fetch()){
            $dato['idioma'] = $idioma->idioma;
            $dato['nivel'] = $idioma->nivel;
            $idiomas[] = $dato;
        }        
        $_SESSION['datos_idiomas'] = $idiomas;
    } else {
        $_SESSION['mensaje'] = "Primero debe crear la hoja de vida.";
    }
    return $existe;
  }
  
    /**
 	 * Modifica los datos personales del usuario
     * 
     * @param string $nombre_completo Nombre de la persona
     * @param string $apellido_materno Apellido materno de la persona
     * @param string $apellido_paterno Apellido paterno de la persona
     * @param string $tipo_identificacion tipo de identificacion
     * @param string $identificacion Numero de identificacion
     * @param string $genero Genero
     * @param string $profesion Profesion
     * @param string $objetivo_profesional Objetivo profesional de la persona
     * @param string $areas_conocimiento Areas de conocimiento de la persona
     * @param string $imagen Nombre del archivo de la imagen para la hoja de vida
     * @param string $fecha_nacimiento Fecha de nacimiento de la persona
     * @param string $pais_origen Pais de nacimiento
     * @param string $nacionalidad Nacionalidad
     * @param string $direccion Direccion de residencia
     * @param string $barrio Barrio de residencia
     * @param string $ciudad Ciudad de residencia
     * @param string $departamento Departamento de residencia
     * @param string $pais Pais de residencia
     * @param string $codigo_postal Codigo postal
     * @param string $telefono_hogar Numero telefonico de la residencia
     * @param string $telefono_trabajo Numero telefonico del trabajo
     * @param string $telefono_movil Numero telefonico movil
     * @param string $email direccion de correo electronico
     * @param string $reubicarse_trabajo Si desea reubicarse de trabajo
     * @param string $reubicarse_pais Si es factible una reubicacion de pais
     * @param string $pais_visa1 Pais a donde tiene visa
     * @param string $pais_visa2 Pais a donde tiene visa
     * @param string $pais_visa3 Pais a donde tiene visa
     * @param string $anos_experiencia Aos de experiencia
     * @param string $archivo Nombre del archivo que desea adjuntar a su hoja de vida
     * @param array $idiomas Idiomas que domina y el nivel
     *
	 * @author  Camilo Torres C.
	 * @return int id_objeto de la hoja de vida si fue insertada, 0 en caso contrario
     * @access public
	 * @static
     */
  function modificar_hoja($nombre_completo, $apellido_materno, $apellido_paterno, $tipo_identificacion,
                        $identificacion, $genero, $profesion, $objetivo_profesional, $areas_conocimiento,
                        $imagen, $fecha_nacimiento, $pais_origen, $nacionalidad, $direccion, $barrio,
                        $ciudad, $departamento, $pais, $codigo_postal, $telefono_hogar, $telefono_trabajo,
                        $telefono_movil, $email, $reubicarse_trabajo, $reubicarse_pais, $pais_visa1,
                        $pais_visa2,$pais_visa3, $anos_experiencia, $archivo, $idiomas)
  {
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);    
    $hoja_vida = new Hdv_informacion_personal;
	// Obtengo el id_objeto de la hoja de vida
    $hoja_vida->get("id_contenedor", $contenedor->id_objeto);
    
    $path_sitio =  $_SESSION['sitio']['url'];
    $path_sitio = Util::fuera($path_sitio);
    $dir_contenido = "imagenes_cont/".$path_sitio;
    $hoja_vida->nombre_completo = $nombre_completo;
    $hoja_vida->apellido_paterno = $apellido_paterno;
    $hoja_vida->apellido_materno = $apellido_materno;
    $hoja_vida->tipo_identificacion = $tipo_identificacion;
    $hoja_vida->identificacion = $identificacion;
    $hoja_vida->genero = $genero;
    if ($imagen['name'] != ""){
        $name_file = "Foto_hv" . substr($imagen['name'], -4);
        if (Imagen::copiar_imagen($imagen, $dir_contenido."/hojas_de_vida/".$name_file) == 1) {
            $hoja_vida->foto = $name_file;
        }
    }
    $hoja_vida->fecha_nacimiento = $fecha_nacimiento;
    $hoja_vida->direccion = $direccion; 
    $hoja_vida->codigo_postal = $codigo_postal; 
    $hoja_vida->telefono_hogar = $telefono_hogar; 
    $hoja_vida->telefono_trabajo = $telefono_trabajo; 
    $hoja_vida->telefono_movil = $telefono_movil; 
    $hoja_vida->email = $email; 
    $hoja_vida->reubicarse_trabajo = $reubicarse_trabajo; 
    $hoja_vida->reubicarse_pais = $reubicarse_pais; 
    $hoja_vida->anos_experiencia = $anos_experiencia;
    if ($archivo['name'] != ""){
        $name_file = "HojaDeVida" . substr($archivo['name'], -4);
        if (Util::copiar_archivo($archivo, $dir_contenido."/hojas_de_vida/".$name_file) == 1) {
            $hoja_vida->archivo = $name_file;
        }
    }
/**/
	$hoja_vida_version = new Hdv_informacion_personal_versiones;
	$hoja_vida_version->id_objeto = $hoja_vida->id_objeto;
	$hoja_vida_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
	$esta_version = $hoja_vida_version->find(true);
    $hoja_vida_version->profesion = $profesion;
    $hoja_vida_version->objetivo_profesional = $objetivo_profesional;
    $hoja_vida_version->areas_conocimiento = $areas_conocimiento;
    $hoja_vida_version->pais_origen = $pais_origen;
    $hoja_vida_version->nacionalidad = $nacionalidad; 
    $hoja_vida_version->barrio = $barrio; 
    $hoja_vida_version->ciudad = $ciudad; 
    $hoja_vida_version->departamento = $departamento; 
    $hoja_vida_version->pais = $pais; 
    $hoja_vida_version->pais_visa1 = $pais_visa1; 
    $hoja_vida_version->pais_visa2 = $pais_visa2; 
    $hoja_vida_version->pais_visa3 = $pais_visa3; 
	$actualiza_version = ($esta_version)? $hoja_vida_version->update() : $hoja_vida_version->insert() ;
/**/
	// Actualizo los idiomas que domina
    $idioma = new Hdv_idiomas;
    $idioma->id_contenedor = $contenedor->id_objeto;
    $idioma->find();
    while ($idioma->fetch()){
        $idioma->delete();
    }        
    foreach($idiomas as $idioma){
        $item = new Hdv_idiomas;
        $datos = explode("|", $idioma);
        $item->id_contenedor = $contenedor->id_objeto;
        $item->idioma = $datos[0];
        $item->nivel = $datos[1];
        $item->insert();
    }
    $modificar = $hoja_vida->update();
	
	if (modificar) {
		Util::log('Hojas de Vida', 'Modificar Datos personales', 'Se modificaron los datos personales');
	} else {
		Util::log('Hojas de Vida', 'Modificar Datos personales', 'Error al tratar de modificar los datos personales');
	}
	
    $_SESSION['mensaje'] = ($modificar)? "La informacin personal ha sido modificada." : "Ocurrio un error al modificar los datos.";    
    return $modificar;
    
  }
  
    /**
 	 * Busca la informacion referente a los estudios realizados,
     * Obtiene la informacion a mostrar en los combos
     *
	 * @author  Camilo Torres C.
	 * @return int 1 si hay estudios, 0 en caso contrario
     * @access public
	 * @static
     */
  function buscar_estudios()
  {
  	// Obtengo la informacion a mostrar en los combos
    $_SESSION['lista_paises'] = Fachada_Sistema::listar_paises($_SESSION['sis_idioma']['id_idioma']);
    $_SESSION['lista_nivel_educacion'] = Fachada_Hojas_De_Vida::listar_nivel_educacion();
    $_SESSION['lista_areas_estudio'] = Fachada_Hojas_De_Vida::listar_areas_estudio();
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);    
	// Busco los estudios realizados
    $estudio = new Hdv_estudios_realizados;
    $estudio->id_contenedor = $contenedor->id_objeto;
    $existe = $estudio->find(); 
    $arreglo_estudio = array();
	$_SESSION['est_ver'] = array();
    if ($existe){
        while ($estudio->fetch()){
            array_push($arreglo_estudio, $estudio);
			$estudio_version = new Hdv_estudios_realizados_versiones;
			$estudio_version->id_objeto = $estudio->id_objeto;
			$estudio_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			$esta_version = $estudio_version->find(true);
			if ($esta_version){
				$_SESSION['est_ver'][$estudio->id_objeto] = $estudio_version;
			}
        }
        $_SESSION['lista_estudio'] = $arreglo_estudio;
    } else {
        $_SESSION['mensaje'] = "Primero debe crear la hoja de vida.";
    }
    return $existe;
  }
  
    /**
 	 * Modifica la informacion referente a los estudios realizados,
     *
     * @param array $codigo id_objeto del estudio a modificar
     * @param array $nivel Nivel del estudio
     * @param array $nombre Nombre del curso o estudio
     * @param array $area Area de estudio
     * @param array $institucion Institucion donde se realizo el estudio
     * @param array $anos Aos cursados
     * @param array $ultimo Ultimo ao cursado
     * @param array $no_terminado Si el estudio fue finalizado o esta en curso
     * @param array $pais Pais donde se realizo el estudio
     * @param array $ciudad Ciudad donde se realizo el estudio
     * @param int $otra Si va a adicionar otro estudio
     *
	 * @author  Camilo Torres C.
	 * @return int 1 si los estudios fueron modificados exitosamente, 0 en caso contrario
     * @access public
	 * @static
     */
  function modificar_estudio($codigo, $nivel, $nombre, $area, $institucion, $anos, $ultimo, $no_terminado,
                            $pais, $ciudad, $otra)
  {
		// Modifico los estudios
      for ($i = 0; $i < sizeof($codigo); $i++){
        $estudio = new Hdv_estudios_realizados;
        $estudio->get("id_objeto", $codigo[$i]); 
        $estudio->anos_cursados = $anos[$i];
        $estudio->ultimo_ano_cursado = $ultimo[$i];
        $estudio->no_terminado = ($no_terminado[$i])? "Si" : "No";
		$estudio_version = new Hdv_estudios_realizados_versiones;
        $estudio_version->id_objeto = $codigo[$i];
		$estudio_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$esta_version = $estudio_version->find(true);
        $estudio_version->nombre = $nombre[$i];
		
        $estudio_version->nivel_educacion = $nivel[$i];
        $estudio_version->area_estudio = $area[$i];
        $estudio_version->institucion = $institucion[$i];
        $estudio_version->ciudad = $ciudad[$i];
        $estudio_version->pais = $pais[$i];
		$modificado_version = ($esta_version)? $estudio_version->update() : $estudio_version->insert();
        $exito = $estudio->update(); 
		if ($exito) {
			Util::log('Hojas de Vida', 'Estudios realizados', 'Se modifico el estudio '.$nombre[$i]);
		} else {
			Util::log('Hojas de Vida', 'Estudios realizados', 'Error al tratar de modificar el estudio '.$nombre[$i]);
		}
    }
	// Adicion de otro estudio
    if ($otra){
        $contenedor = new Hdv_datos_modulos_hojas_de_vida;
        $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);
        $id_contenedor = $contenedor->id_objeto;
        $estudio = new Hdv_estudios_realizados;
        $estudio->id_contenedor = $id_contenedor;
        $estudio->insert();
    }
    return $exito;
  }
  
    /**
 	 * Busca la informacion referente a la experiencia laboral
     * Obtiene la informacion a mostrar en los combos
     *
	 * @author  Camilo Torres C.
	 * @return int 1 si hay experiencias laborales, 0 en caso contrario
     * @access public
	 * @static
     */
  function buscar_laboral()
  {
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);    
	// Obtengo las expectativas laborales
    $expectativa = new Hdv_expectativas;
    $expectativa->get("id_contenedor", $contenedor->id_objeto);
    $experiencia = new Hdv_experiencia_laboral;
    $experiencia->id_contenedor = $contenedor->id_objeto;
	// Busco si hay experiencia laborales
    $existe = $experiencia->find();
    $arreglo_experiencia = array();
	$_SESSION['lista_experiencia_version'] = array();
    if ($existe) {
		// Busco la informacion de cada experiencia laboral
        while ($experiencia->fetch()){
            array_push($arreglo_experiencia, $experiencia);
			$experiencia_version = new Hdv_experiencia_laboral_versiones;
			$experiencia_version->id_objeto = $experiencia->id_objeto;
			$experiencia_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			$experiencia_version->find(true) ;
			$_SESSION['lista_experiencia_version'][$experiencia->id_objeto] = $experiencia_version;
        }
	    $expectativa_version = new Hdv_expectativas_versiones;
	    $expectativa_version->id_objeto = $expectativa->id_objeto;
		$expectativa_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$expectativa_version->find(true);
		// Obtengo la informacion a visualizar en los combos
        $_SESSION['lista_experiencia'] = $arreglo_experiencia;
        $_SESSION['expectativas'] = $expectativa;
        $_SESSION['expectativas_version'] = $expectativa_version;
        $_SESSION['lista_areas_estudio'] = Fachada_Hojas_De_Vida::listar_areas_estudio();
        $_SESSION['lista_monedas'] = Fachada_Hojas_De_Vida::listar_monedas();
        $_SESSION['lista_actividades'] = Fachada_Hojas_De_Vida::listar_actividades_economicas();
    } else {
        $_SESSION['mensaje'] = "Primero debe crear la hoja de vida.";
    }
    return $existe;
  }
  
    /**
 	 * Modifica la informacion referente a la experiencia laboral
     * 
     * @param string $area_interes1 Areas de interes
     * @param string $area_interes2 Areas de interes
     * @param string $area_interes3 Areas de interes
     * @param string $tipo_cargo Tipo de cargo que espera desempear
     * @param string $informacion_adicional Informacion adicional
     * @param string $monto Salario esperado
     * @param string $moneda tipo de moneda esperado
     * @param string $periodo_pago Expectativa de periodo de pago
     * @param string $forma_pago Forma de pago esperada
     * @param array $codigo id_objeto de la experiencia laboral a modificar
     * @param array $empresa Empresa donde laboro
     * @param array $actividad_economica Actividad economica de la empresa
     * @param array $fecha_ingreso Fecha de ingreso a la empresa
     * @param array $fecha_salida Fecha de salida de la empresa
     * @param array $exp_tipo_cargo Tipo de cargo desempeado
     * @param array $exp_cargo Cargo desempeado
     * @param array $exp_funcion Funciones desempeadas
     * @param int $otra Si desea adicionar otra experiencia laboral
     *
	 * @author  Camilo Torres C.
	 * @return int 1 si las experiencias laborales fueron modificadas exitosamente, 0 en caso contrario
     * @access public
	 * @static
     */
  function modificar_laboral($area_interes1, $area_interes2, $area_interes3, $tipo_cargo, 
                              $informacion_adicional, $monto, $moneda, $periodo_pago, $forma_pago,
                            $codigo, $empresa, $actividad_economica, $fecha_ingreso, $fecha_salida,
                            $exp_tipo_cargo, $exp_cargo, $exp_funcion, $otra)
  {
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);    
    $expectativas = new Hdv_expectativas;
	// Obtengo las expectativas laborales
    $expectativas->get("id_contenedor", $contenedor->id_objeto);
    $expectativas->tipo_cargo = $tipo_cargo;
    $expectativas->monto = $monto;
    $expectativas->moneda = $moneda;
    $expectativas->periodo_pago = $periodo_pago;
    $expectativas->forma_pago = $forma_pago;
	$expectativas_version = new Hdv_expectativas_versiones;
	$expectativas_version->id_objeto = $expectativas->id_objeto;
	$expectativas_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
	$esta_expect_ver = $expectativas_version->find(true);
    $expectativas_version->area_interes1 = $area_interes1;
    $expectativas_version->area_interes2 = $area_interes2;
    $expectativas_version->area_interes3 = $area_interes3;
    $expectativas_version->informacion_adicional = $informacion_adicional;
	$modificado_expect_version = ($esta_expect_ver)? $expectativas_version->update() : $expectativas_version->insert() ;
	
    $expectativas->update();
		// Modifico las experiencias laborales
      for ($i = 0; $i < sizeof($codigo); $i++){
        $experiencia = new Hdv_experiencia_laboral;
        $experiencia->get("id_objeto", $codigo[$i]);
        $experiencia->ingreso = $fecha_ingreso[$i];
        $experiencia->salida = $fecha_salida[$i];
        $experiencia->ejecutivo = $exp_tipo_cargo[$i];
		$experiencia_version = new Hdv_experiencia_laboral_versiones;
		$experiencia_version->id_objeto = $codigo[$i];
		$experiencia_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$esta_esper_ver = $experiencia_version->find(true);
        $experiencia_version->empresa = $empresa[$i];
        $experiencia_version->actividad = $actividad_economica[$i];
        $experiencia_version->cargo = $exp_cargo[$i];
        $experiencia_version->funcion = $exp_funcion[$i];
		$modificado_exper_ver = ($esta_esper_ver)? $experiencia_version->update() : $experiencia_version->insert();
        $actualiza = $experiencia->update();
		if ($actualiza) {
			Util::log('Hojas de Vida', 'Experiencia laboral', 'Se modifico la experiencia laboral');
		} else {
			Util::log('Hojas de Vida', 'Experiencia laboral', 'Error al tratar de modificar la experiancia laboral');
		}
    }    
	// Aado otra experiencia laboral
    if ($otra){
        $contenedor = new Hdv_datos_modulos_hojas_de_vida;
        $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);
        $id_contenedor = $contenedor->id_objeto;
        $experiencia = new Hdv_experiencia_laboral;
        $experiencia->id_contenedor = $id_contenedor;
        $experiencia->insert();
    }
    return $actualiza;
  }
  
    /**
 	 * Verifica si la hoja de vida esta publicada o no.
     * 
     *
	 * @author  Camilo Torres C.
	 * @return int 1 si la hoja de vida esta publicada, 0 en caso contrario
     * @access public
	 * @static
     */
  function esta_publicado()
  {
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor",$_SESSION['sitio']['id_objeto']);    
    $hoja_vida = new Hdv_informacion_personal;
    $existe = $hoja_vida->get("id_contenedor", $contenedor->id_objeto);
    if ($existe){
        $_SESSION['publicado'] = $hoja_vida;
    } else {
        $_SESSION['mensaje'] = "Primero debe crear la hoja de vida.";
    }
    return $existe;
  }

    /**
 	 * Publica o despublica la hoja de vida dependiendo del contenido de $valor
     * 
     *
	 * @author  Camilo Torres C.
	 * @return int 1 si la hoja de vida se actualizo, 0 en caso contrario
     * @access public
	 * @static
     */
  function publicar($valor)
  {
    $contenedor = new Hdv_datos_modulos_hojas_de_vida;
    $contenedor->get("id_contenedor", ID_SITIO);    
    $hoja_vida = new Hdv_informacion_personal;
    $hoja_vida->get("id_contenedor", $contenedor->id_objeto);
    $hoja_vida->publicado = $valor;
    $existe = $hoja_vida->update();
	Fachada_Hojas_De_Vida::generar_local();
    return $existe;
  }

	/*
	 * Obtiene los parametros para llamar la generacion de paginas del modulo
     *
	 * @author  Camilo Torres
     * @access  public
	*/
    function generar_local ()
    { 
        $idioma = new Sis_idiomas;
        $idioma->get("id_idioma", $_SESSION['sis_idioma']['id_idioma']);
        $path = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
        Fachada_Hojas_De_Vida::generar_hojas_de_vida (ID_SITIO, $path, $idioma);
    }


	/*
	 * Genera los archivos HTML para la hoja de vida
     *
     * @param   int $id_sitio Identificador del sitio al cual se genera los eventos
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param   string $idioma Idioma en el que se va a generar el sitio.
	 * @author  Camilo Torres
	 * @return string nombre de la pagina generada
     * @access  public
	*/
  function generar_hojas_de_vida($id_sitio, $path_sitio, $idioma)
  {
	// Obtengo el path del sitio
	$url = explode("/",$path_sitio)	;
	$idioma_solicitado = $idioma;
	
	// Obtengo la informacion de los combos
	$lista_paises = Fachada_Sistema::listar_paises($idioma_solicitado->id_idioma);
	$lista_profesiones = Fachada_Hojas_De_Vida::listar_profesiones();
	$lista_idiomas = Fachada_Hojas_De_Vida::listar_idiomas();
	$lista_nivel_educacion = Fachada_Hojas_De_Vida::listar_nivel_educacion();
	$lista_areas_estudio = Fachada_Hojas_De_Vida::listar_areas_estudio();
	$lista_monedas = Fachada_Hojas_De_Vida::listar_monedas();
	$lista_actividades = Fachada_Hojas_De_Vida::listar_actividades_economicas();
	
//	include_once (PATH_HOJAS_DE_VIDA ."vistas/" .$idioma->enctype . ".php");
	
	$contenedor = new Hdv_datos_modulos_hojas_de_vida;
	$contenedor->get("id_contenedor",$id_sitio);
	$hoja_vida = new Hdv_informacion_personal;
	$hoja_vida->id_contenedor = $contenedor->id_objeto;
	$hoja_vida->find(true);
	$hoja_vida_version = new Hdv_informacion_personal_versiones;
	$hoja_vida_version->id_contenedor = $hoja_vida->id_objeto;
	$hoja_vida_version->id_idioma = $idioma->id_idioma;
	$hoja_vida_version->find(true);
	$pagina = "pagina_{$hoja_vida->id_objeto}.php";
//	$hoja_vida->get("id_contenedor", $contenedor->id_objeto);
//
		$archivo_hojas_de_vida = $path_sitio . "/" . $pagina;
		$template_hojas_de_vida = PATH_HOJAS_DE_VIDA . "vistas/tpl_hojas_de_vida.php";
		$template_estudios_realizados = PATH_HOJAS_DE_VIDA . "vistas/tpl_estudios_realizados.php";
		$template_experiencia_laboral = PATH_HOJAS_DE_VIDA . "vistas/tpl_experiencia_laboral.php";
		
		// Se escribe la cabecera del portal
		File::writeLine($archivo_hojas_de_vida, '<? include("vistas/'.$idioma->enctype.'/head_public.php") ?>');
		File::writeLine($archivo_hojas_de_vida, '<? include( PATH_HOJAS_DE_VIDA . "vistas/' .$idioma->enctype . '.php") ?>');
//
	if ($hoja_vida->publicado){
		/* Incluye la informacion personal */
		$idioma = new Hdv_idiomas;
		$idioma->id_contenedor = $contenedor->id_objeto;
		$idioma->find();
		while ($idioma->fetch()){
			$dato['idioma'] = $idioma->idioma;
			$dato['nivel'] = $idioma->nivel;
			$idiomas[] = $dato;
		}		
		include($template_hojas_de_vida); 
		File::writeLine($archivo_hojas_de_vida, $contenido_HTML);
		/* Fin Informacion personal */
		/* Incluye los estudios realizados */
		$estudio = new Hdv_estudios_realizados;
		$estudio->id_contenedor = $contenedor->id_objeto;
		$estudio->id_idioma = $idioma_solicitado->id_idioma;
		$estudio->find(); 
		while ($estudio->fetch()){
			$lista_estudios[] = $estudio;
			$estudio_version = new Hdv_estudios_realizados_versiones;
			$estudio_version->id_objeto = $estudio->id_objeto;
			$estudio_version->id_idioma = $idioma_solicitado->id_idioma;
			$esta_version = $estudio_version->find(true);
			if ($esta_version){
				$estudios_version[$estudio->id_objeto] = $estudio_version;
			}
		}
		include($template_estudios_realizados); 
		File::writeLine($archivo_hojas_de_vida, $contenido_HTML);
		/* Fin estudios realizados */
		
		/* Incluye experiencia laboral */
		$expectativa = new Hdv_expectativas;
		$expectativa->id_idioma = $idioma_solicitado->id_idioma;
		$expectativa->id_contenedor = $contenedor->id_objeto;
		$expectativa->find(true);
	    $expectativa_version = new Hdv_expectativas_versiones;
	    $expectativa_version->id_objeto = $expectativa->id_objeto;
		$expectativa_version->id_idioma = $idioma_solicitado->id_idioma;
		$expectativa_version->find(true);
		$experiencia = new Hdv_experiencia_laboral;
		$experiencia->id_contenedor = $contenedor->id_objeto;
		$experiencia->id_idioma = $idioma_solicitado->id_idioma;
		$experiencia->find();
		while ($experiencia->fetch()){
			$lista_experiencia[] = $experiencia;
			$experiencia_version = new Hdv_experiencia_laboral_versiones;
			$experiencia_version->id_objeto = $experiencia->id_objeto;
			$experiencia_version->id_idioma = $idioma_solicitado->id_idioma;
			$experiencia_version->find(true) ;
			$experiencias_version[$experiencia->id_objeto] = $experiencia_version;
		}
		include($template_experiencia_laboral); 
		File::writeLine($archivo_hojas_de_vida, $contenido_HTML);
		/* Fin experiencia laboral */
	} else {
		File::writeLine($archivo_hojas_de_vida, 'No hay datos disponibles.');
	}
		// Se escribe el pie del portal
		File::writeLine($archivo_hojas_de_vida, '<? include("vistas/foot_public.php") ?>');
	return $pagina;
  }
} 
