<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.3.3                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |		  John Vargas <jhonvargas@telesat.com.co>                     |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
// $Id: fachada_instalador.php,v 1.9 2004/06/28 23:27:41 rtello Exp $
//
// Clase Fachada que maneja el instalador
//

// Mapping 
include(PATH_INSTALADOR . 'controlador/mappings.php');

// clases necesarias
include(PATH_INSTALADOR . 'controlador/forms/ins_probar_conexionForm.php');
include(PATH_INSTALADOR . 'controlador/actions/ins_probar_conexionAction.php');
include(PATH_INSTALADOR . 'controlador/actions/ins_crear_tablasAction.php');


/**
 * La clase Fachada_Instalador provee los metodos para instalar AzucarCMS
 *
 * @package  Instalador
 * @version  1
 * @author   Camilo Torres <ccordoba@telesat.com.co>
 * @since    PHP 4.3.3
 */
class Fachada_Instalador
{

    /**
	 * Prueba la conexion con la Base de Datos
	 *
	 * @param    string $dsn cadena de conexion para la base de datos
	 *
	 * @author  Camilo Torres C.
	 * @return  int Id de conexion
     * @access public
	 * @static
	 */
    function probar_conexion ($dsn) {

        $conn =& DB::connect($dsn);
        return $conn;

    }

    /**
	 * Corre los scripts de creacion de la Base de Datos
	 *
	 * @param    string $dsn cadena de conexion para la base de datos
	 *
	 * @author  Camilo Torres C.
	 * @return  int Id de conexion
     * @access public
	 * @static
	 */
    function crear_tablas ($dsn, $usuario_apache) {

        $directorios_problema = array();

        if (get_current_user() != $usuario_apache) {
               
        if (fileperms('config') != '16895') {
            array_push($directorios_problema, 'config');
        }
            
        $directorio = opendir('src');
        while (($file = readdir($directorio)) !== false) {
            if ($file != "." && $file != ".." && $file != "instalador") {
                $usuario = posix_getpwuid(fileowner('src/'.$file.'/modelo'));
                if ($usuario["name"] != $usuario_apache){
                    if (fileperms('src/'.$file.'/modelo') != '16895') {
                        array_push($directorios_problema, $file);
                    } else {
                        $subdir = opendir('src/'.$file.'/modelo');
                        $bandera = 0;
                        while (($subfile = readdir($subdir)) !== false) {
                            if ($subfile != "." && $subfile != "..") {
                                if (fileperms('src/'.$file.'/modelo/'.$subfile) != '33222'){
                                    $bandera = 1;
                                }
                            }
                        }
                        if ($bandera){
                            array_push($directorios_problema, $file);
                        }
                        closedir($subdir);
                    }
                }
            }
        }
        closedir($directorio);
        
        }

        if (sizeof($directorios_problema) > 0){
            return array('error' => 'errorC', 'cadena' => $directorios_problema);
        }

        $archivo_tablas = 'createAll.sql';
        $archivo_datos = 'dataAll.sql';
        if (file_exists($archivo_tablas) && file_exists($archivo_datos)){
            $valores  = "host=".$dsn["hostspec"]." port=5432 dbname=".$dsn["database"]." user=".$dsn["username"]." password=".$dsn["password"];
            $conexion = pg_connect($valores);

            $apuntador_tablas = fopen($archivo_tablas, "r");
            $datos = fread($apuntador_tablas, filesize($archivo_tablas));
            fclose($apuntador_tablas);
            $crear_tablas = pg_exec($datos);

            $apuntador_datos = fopen($archivo_datos, "r");
            $datos = fread($apuntador_datos, filesize($archivo_datos));
            fclose($apuntador_datos);
            $crear_datos = pg_exec($datos);
            
            $config = Fachada_Instalador::crear_config();
            
            if ($config) {
                return 'funciona';
            } else {
                return array('error' => 'errorB', 'cadena' => '');
            }
            
        } else {
            return array('error' => 'errorA', 'cadena' => '');
        }
    }
    
    function crear_config () {
        $archivo   = "configDB.php";
        $apuntador = fopen($archivo, "w");
        if ($apuntador) {
            $cadena = "<?";
            $cadena .= " \$options = array (";
            $cadena .= "'database' => 'pgsql://".$_SESSION["dsn"]["username"].":".$_SESSION["dsn"]["password"]."@".$_SESSION["dsn"]["hostspec"]."/".$_SESSION["dsn"]["database"]."',";
            $cadena .= "'schema_location'  => PATH_CMS . 'config',";
            $cadena .= "'class_location'   => PATH_CMS . 'config',";
            $cadena .= "'require_prefix'   => '',";
            $cadena .= "'class_prefix'     => ''";
            $cadena .= "); ?>";
            $contenido = fwrite($apuntador, $cadena);
            fclose($apuntador);
            return true;
        } else {
            return false;
        }
    }
    
    function obtener_usuario_apache (){

        ob_start();

        phpinfo(INFO_MODULES);   
  
        $string = ob_get_contents();
        ob_end_clean();   
  
        $pieces = explode("<h2", $string);
  
        $settings = array();
  
        foreach($pieces as $val)
        {
            preg_match("/<a name=\"module_([^<>]*)\">/", $val, $sub_key);
      
            preg_match_all("/<tr[^>]*>
                                           <td[^>]*>(.*)<\/td>
                                           <td[^>]*>(.*)<\/td>/Ux", $val, $sub);
            preg_match_all("/<tr[^>]*>
                                           <td[^>]*>(.*)<\/td>
                                           <td[^>]*>(.*)<\/td>
                                           <td[^>]*>(.*)<\/td>/Ux", $val, $sub_ext);
                              
           foreach($sub[0] as $key => $val)
           {
                $settings[$sub_key[1]][strip_tags($sub[1][$key])] = array(strip_tags($sub[2][$key]));
            }
      
           foreach($sub_ext[0] as $key => $val)
            {
               $settings[$sub_key[1]][strip_tags($sub_ext[1][$key])] = array(strip_tags($sub_ext[2][$key]), strip_tags($sub_ext[3][$key]));
           }               
              
        }
 
        $usuario = explode("(",$settings['apache']['User/Group '][0]);
        
        return $usuario[0];

    }
}

?>