<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.3.3                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// |   																	  |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |		  John Vargas <jhonvargas@telesat.com.co>                     |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
// $Id: fachada_menus.php,v 1.14 2004/06/28 22:18:47 rtello Exp $
//
// Especificacin de los menues
//
	
/**
 * Esta clase tiene los mtodos para la creacin e interaccin y administracin del men del sitio.
 *
 * @package  Men
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
class Generador_Menu
{
	/*
	 * Genera los items de primer nivel en el pie de pgina
	 *
	 * @author John A. Vargas
	 * @access static
	 */
	function generar_pie_pagina()
	{
		// La ruta en la que se genera el pie de pgina y el nombre del archivo
		$path_sitio = "html/" . $_SESSION['sitio']['url']."/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_pie = $path_sitio . "/foot_public.php";
		$idioma = new Sis_idiomas;
		$idioma->get($_SESSION['sis_idioma']['id_idioma']);
		
		// Templates para los enlaces
		$template_interno = PATH_MENUS . 'vistas/templates/tpl_enlace_interno.html';
		$template_externo = PATH_MENUS . 'vistas/templates/tpl_enlace_externo.html';
		
		// Obtener el datos mdulos de Men
		$datos = new Men_datos_modulos_menus;
		$datos->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		
		// Obtenemos el men de ese mdulo
		$menu = new Men_menus;
		$menu->get('id_contenedor', $datos->id_objeto);
		
		// Generar los enlaces de primer nivel
		$contenido_HTML = '';
		$links = array();
		$enlace = new Men_enlaces;
		$enlace->id_contenedor = $menu->id_objeto;
		$enlace->orderBy('id_objeto ASC');
		$enlace->find(); 
		while ($enlace->fetch()) {
			$version = new Men_items_versiones;
			$version->id_objeto = $enlace->id_objeto;
			$version->id_idioma = $idioma->id_idioma;
			$version->find(true);
			$enlace_esp = $enlace->get_hijo();
			
			if (get_class($enlace_esp) == 'men_enlaces_internos')
				$contenido_enlace = addslashes(implode('\n', file($template_interno)));
			else
				$contenido_enlace = addslashes(implode('\n', file($template_externo)));
				
			eval("\$contenido_HTML = \"$contenido_enlace\"; ");
			array_push($links, stripslashes($contenido_HTML));
		}

		// Escribimos lo generado en el archivo de pie de pgina
		File::writeLine($archivo_pie, implode('&nbsp;|&nbsp;', $links), FILE_MODE_WRITE);
	}
	
	/*
	 * Genera un archivo XML con el men
	 *
	 * @author John A. Vargas
	 * @access static
	 */	
	 function generar_XML()
	 {
	 	require_once "lib/XML/Tree.php";
		
		$path_sitio = "html/" . $_SESSION['sitio']['url']."/vistas/" . $_SESSION['sis_idioma']['enctype'];
		
		$modulo = new Men_datos_modulos_menus;
		$modulo->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		
		$objMenu = new Men_menus;
		$objMenu->id_contenedor = $modulo->id_objeto; 
		$objMenu->find();
		$es_primero = true;
		
		while ($objMenu->fetch()) {
			if (!$es_primero)
				$archivo_xml = "$path_sitio/datosMenu_".$objMenu->id_objeto.".xml";
			else {
				$archivo_xml = "$path_sitio/datosMenu.xml";
				$es_primero = false;
			}
			$tree  = new XML_Tree;
			
			$xmlMenu =& $tree->addRoot("menu");
			
			$objItemMenu = new Men_items;
			$objItemMenu->id_contenedor = $objMenu->id_objeto;
			$objItemMenu->orderBy('id_objeto');				
			$objItemMenu->find();
			
			while ($objItemMenu->fetch()) 
				Generador_Menu::contruir_arbol($objItemMenu->get_hijo(), &$xmlMenu);
			
			File::write($archivo_xml, '<?xml version="1.0" encoding="iso-8859-1"?>', FILE_MODE_WRITE);
			File::write($archivo_xml, $tree->get());
			File::close($archivo_xml, FILE_MODE_WRITE);		
		}
	 }
	
	/*
	 * Construir recursivamente el rbol XML a partir del de contenimiento.
	 * @param Sis_objeto_protegido $objItem Nodo del rbol de contenimiento.
	 * @param Nodo_Tree            $xmlItem Nodo del rbol XML.
	 *
	 * @author John A. Vargas
	 * @access public
	 * @static
	 */	
	 function contruir_arbol($objItem, $xmlItem) 
	 {
	 	// Se obtiene el tipo de item (Enlace externo, interno o submenu)
		$tipo_menu = get_class($objItem);
		
		// Se obtiene la versin del men.
		$item_version = new Men_items_versiones;
		$item_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_version->id_objeto = $objItem->id_objeto;
		if (!$item_version->find(true))
			Fachada_Sistema::crear_version($item_version, $_SESSION['sis_idioma']['id_idioma']);

		switch ($tipo_menu) {
			case 'men_enlaces_externos':
				$itemMenu  =& $xmlItem->addChild("itemMenu", "", array('tipo' => 'externo'));
				$nombre = $itemMenu->addChild("nombre", $item_version->nombre);
				$url = $itemMenu->addChild("url", $objItem->url);
				return;
			case 'men_enlaces_internos':
				$itemMenu  =& $xmlItem->addChild("itemMenu", "", array('tipo' => 'interno'));
				$nombre = $itemMenu->addChild("nombre", $item_version->nombre);
				$url = $itemMenu->addChild("url", "index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'] . "/pagina_{$objItem->id_pagina}.php");
				return; 
			case 'men_menus':
				// Se adiciona el subnodo al nodo XML.
				$itemMenu  =& $xmlItem->addChild("itemMenu", "", array('tipo' => 'menu'));
				$itemnombreMenu  =& $itemMenu->addChild("nombre", $item_version->nombre);
				$itemsubMenu  =& $itemMenu->addChild("menu");
						
				$objItemMenu = new Men_items;
				$objItemMenu->id_contenedor = $objItem->id_objeto;
				$objItemMenu->orderBy('id_objeto');				
				$objItemMenu->find();
				
				// Llamado recursivo para la generacin de items del subnodo.
				while ($objItemMenu->fetch()) 
					Generador_Menu::contruir_arbol($objItemMenu->get_hijo(), &$itemsubMenu);
					
				return; 
		} // Fin switch
	 } 
}
?>