<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.3.3                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 El grupo Emedia - Telesat                         |
// +----------------------------------------------------------------------+
// |   																	  |
// +----------------------------------------------------------------------+
// | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |		  John Vargas <jhonvargas@telesat.com.co>                     |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
// $Id: fachada_menus.php,v 1.14 2004/06/28 22:18:47 rtello Exp $
//
// Especificación de los menues
//

// Clases necesarias
require_once('src/menu/modelo/Men_datos_modulos_menus.php');
require_once('src/menu/modelo/Men_items.php');
require_once('src/menu/modelo/Men_items_versiones.php');
require_once('src/menu/modelo/Men_menus.php');
require_once('src/menu/modelo/Men_enlaces.php');
require_once('src/menu/modelo/Men_enlaces_externos.php');
require_once('src/menu/modelo/Men_enlaces_internos.php');

//CONTROLADOR modificar_tipo_menu
// Mapping 
include('src/menu/' . 'controlador/mappings.php');
// Genenerador
include('src/menu/' . 'modelo/Generar_menus.php');
include('src/menu/' . 'modelo/Generador_menu.php');

// clases necesarias
require_once 'src/menu/' . 'controlador/forms/crear_menuForm.php';
require_once 'src/menu/' . 'controlador/actions/crear_menuAction.php';
require_once 'src/menu/' . 'controlador/forms/men_mostrar_arbolForm.php';
require_once 'src/menu/' . 'controlador/actions/men_mostrar_arbolAction.php';
require_once 'src/menu/' . 'controlador/forms/men_crear_enlace_externoForm.php';
require_once 'src/menu/' . 'controlador/actions/men_crear_enlace_externoAction.php';
require_once 'src/menu/' . 'controlador/forms/men_crear_enlace_internoForm.php';
require_once 'src/menu/' . 'controlador/actions/men_crear_enlace_internoAction.php';
require_once 'src/menu/' . 'controlador/actions/men_crear_submenuAction.php';
require_once 'src/menu/' . 'controlador/forms/men_modificar_item_externoForm.php';
require_once 'src/menu/' . 'controlador/actions/men_modificar_item_externoAction.php';
require_once 'src/menu/' . 'controlador/forms/men_modificar_item_internoForm.php';
require_once 'src/menu/' . 'controlador/actions/men_modificar_item_internoAction.php';
require_once 'src/menu/' . 'controlador/actions/men_modificar_submenuAction.php';
require_once 'src/menu/' . 'controlador/actions/men_eliminar_itemAction.php';
require_once 'src/menu/' . 'controlador/actions/men_cargar_enlaces_internosAction.php';
require_once 'src/menu/' . 'controlador/forms/men_modificar_tipo_menuForm.php';
require_once 'src/menu/' . 'controlador/actions/men_modificar_tipo_menuAction.php';
require_once 'src/menu/' . 'controlador/actions/men_eliminar_imagenAction.php';
require_once 'src/menu/' . 'controlador/actions/men_chequear_primero_ultimoAction.php';
require_once 'src/menu/' . 'controlador/actions/men_subir_bajar_itemAction.php';
require_once 'src/menu/' . 'controlador/actions/men_hacer_home_pageAction.php';
require_once 'src/menu/' . 'controlador/actions/eliminar_menuAction.php';

/**
 * Esta clase tiene los métodos para la creación e interacción y administración del menú del sitio.
 *
 * @package  Menú
 * @version  $Id: fachada_menus.php,v 1.14 2004/06/28 22:18:47 rtello Exp $
 * @author   Junior Tello <rtello@telesat.com.co>
 * @since    PHP 4.1.2
 */ 
class Fachada_Menus
{
	/*
	 * Crea en la base de datos el identificador del menu.
	 *
	 * @param string $nombre_menu Nombre del nuevo menú.
	 * @return bool  True si todo sale bien, False en caso contrario
	 */
	function crear_menu($nombre_menu) {
		if ( $_SESSION['sitio']['id_objeto'] == "" || !isset($_SESSION['sitio']['id_objeto']) ) {
			return false;
		}
		
		// Ingresamos datos en la tabla datos modulos menus
		$dat_mod_menu = new Men_datos_modulos_menus;
		$dat_mod_menu->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		
		// Ingresamos datos en la tabla menus
		$menu = new Men_menus;
		$menu->id_contenedor = $dat_mod_menu->id_objeto;
		$menu->id_modulo = $dat_mod_menu->id_objeto;
		$id2 = $menu->insert();
		
		// Ingresamos el rotulo del menu principal en el idioma actual
		$item_v = new Men_items_versiones;
		$item_v->id_objeto = $menu->id_objeto;
		$item_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_v->nombre = $nombre_menu;
		$id3 = $item_v->insert();
		
		$_SESSION['menu'] = $menu;
		
		return ($id2 > 0 && $id3 > 0) ? $id2 : false;
	}
	
	/*
	 * Carga la fila de la tabla menu que identifica al menu del portal en la sesion
	 *
	 * @return bool  true si todo sale bien false en caso contrario
	 */
	function cargar_menu($id_menu = '')
	{
		$menu = new Men_menus;
		
		if ($id_menu == '') {
			$dat_mod_menu = new Men_datos_modulos_menus;
			$dat_mod_menu->get('id_contenedor',$_SESSION['sitio']['id_objeto']);
			
			$menu->get('id_contenedor',$dat_mod_menu->id_objeto);
		} else
			$menu->get($id_menu);
		
		$_SESSION['menu'] = $menu;
		
		return true;
	}
	
	/*
	 * Construye el arbol en javascript para la administración del menu.
	 *
	 * @param int     $id_objeto  el campo id_objeto raíz del menú
	 * @param string  $cadena     la cadena que se va formando recursivamente
	 *
	 * @return string la cadena que contiene el árbol en código javascript.
	 */
	function construir_arbol($id_objeto, $cadena = '') {
	
        $item = new Men_items;
		$item->get($id_objeto);
        $enl_ext = new Men_enlaces_externos;
		$id = $enl_ext->get($id_objeto);
        $enl_int = new Men_enlaces_internos;
		$enl_int->get($id_objeto);
		$menu = new Men_menus;
		if ($menu->get($id_objeto)) { $submenu = 1;}
		else { $submenu = 0;}
		
		$item_version = new Men_items_versiones;
		$item_version->id_objeto = $id_objeto;
		$item_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		if (!$item_version->find(true))
			Fachada_Sistema::crear_version(&$item_version, $_SESSION['sis_idioma']['id_idioma']);
		
		$nombre_web = urlencode($item_version->nombre);
		
		if ( $submenu ) { $relleno1="<b>"; $relleno2="</b>"; }
		if ( $id ) { $relleno1="<font color=gray>"; $relleno2="</font>"; }
		if ( $enl_int->id_objeto == $_SESSION['menu']->id_index ) { $relleno1="<font color=red>"; $relleno2="</font>"; }
		if ( $enl_ext->id_objeto == $_SESSION['menu']->id_index ) { $relleno1="<font color=red>"; $relleno2="</font>"; }
		
		$cadena .= "['".$relleno1."$item_version->nombre".$relleno2."', 'phrame.php?action=men_chequear_primero_ultimo&".
					"rotulo=$nombre_web&url=$enl_ext->url&id_objeto=$item->id_objeto&".
					"id_padre=$item->id_contenedor&id_pagina=$enl_int->id_pagina".
					"&submenu=$submenu"."', 'mainFrame'";

		$item = new Men_items;
		$item->whereAdd("id_contenedor='$id_objeto'");
		$item->orderBy("id_objeto");
		$item->find();

        while( $item->fetch() ) {
            $child_id=$item->id_objeto;
    	        $cadena .= ", ";
            Fachada_Menus::construir_arbol($child_id, &$cadena);
        }
        $cadena .= "]";
//print_r($cadena);
		
        return $cadena;
    }
	
	/*
	 * Determina si un id_objeto del arreglo de items tiene hijos
	 *
	 * @param int     $id_objeto  el campo id_objeto que identifica al ítem del menú
	 * @param int     $tam_arr    tamaño del arreglo de ítems del menú
	 *
	 * @return bool true si sí tiene hijos y false si no los tiene.
	 */
	function tiene_hijos( $id_objeto, $tam_arr ) {
		// Determinamos que items tienen hijos
		for ( $i=0; $i < $tam_arr; $i++ ) {
			if ( $_SESSION['menu_items']['id_padre'][$i] == $id_objeto) {
				$key = array_search($id_objeto, $_SESSION['menu_items']['id_objeto']);
				$_SESSION['menu_items']['hijos'][$key] = 1;
				//echo $_SESSION['menu_items']['id_padre'][$i]." ".$_SESSION['menu_items']['hijos'][$key]." ".$i." ".$id_objeto."<br>\n";
				break;
			}
		}
		return true;
	}
	
	/*
	 * Carga en $_SESSION['menu_items'] un arreglo con los items que conforman el 
	 * menu el cual sale de la base de datos
	 *
	 * @param int     $id_objeto  el campo id_objeto que identifica al ítem raíz del menú
	 * @param int     $id_idioma  identificador del idioma
	 *
	 * @return bool true si se cargó el arrglo.
	 */
	function cargar_arreglo_items( $id_objeto, $id_idioma ) {
		$_SESSION['menu_items'] = null;
		
        $item_menu = new Men_items;
		
		$item_menu->id_modulo = $id_objeto;
		$item_menu->orderBy("id_objeto");
		$item_menu->find();
		
        while ($item_menu->fetch()) {
			$enl_ext = new Men_enlaces_externos;
			$enl_int = new Men_enlaces_internos;
			$menu = new Men_menus;
			$item_menu_version = new Men_items_versiones;
			$item_menu_version->id_idioma = $id_idioma;
			$item_menu_version->id_objeto = $item_menu->id_objeto;
			
			if (!$item_menu_version->find(true))
				Fachada_Sistema::crear_version(&$item_menu_version, $_SESSION['sis_idioma']['id_idioma']);
			
			$menu_items['id_objeto'][] = $item_menu->id_objeto;
			$menu_items['nombre'][] = $item_menu_version->nombre;
			$menu_items['id_padre'][] = $item_menu->id_contenedor;
			$menu_items['hijos'][] = 0;
			// Capturamos el url
			if ( $enl_ext->get($item_menu->id_objeto) ) {
				$menu_items['url'][] = $enl_ext->url;
			} else {
				$menu_items['url'][] = "";
			}
			// Capturamos el id_pagina
			if ( $enl_int->get($item_menu->id_objeto) ) {
				$menu_items['id_pagina'][] = $enl_int->id_pagina;
			} else {
				$menu_items['id_pagina'][] = "";
			}
			// Chequeamos si el item es un submenu o un enlace
			if ( $menu->get($item_menu->id_objeto) ) {
				$menu_items['link'][] = 0; // NO es enlace
			} else {
				$menu_items['link'][] = 1; // SI es enlace
			}
		} // Fin del while
		
		$_SESSION['menu_items'] = $menu_items;
		$tam_arr = sizeof($menu_items['id_objeto']);
		for ( $i=0; $i < $tam_arr; $i++ ) {
			Fachada_Menus::tiene_hijos( $menu_items['id_objeto'][$i], $tam_arr );
		}
		
//print_r($_SESSION['menu_items']);exit();
        return true;
    }
	
	
	/*
	 * Escribe los submenues en el código javascript
	 *
	 * @param int     $id_objeto      el campo id_objeto que identifica al ítem raíz del menú
	 * @param int     $j              identifica submenues en el javascript
	 * @param int     $submenu_index  indice del submenú
	 * @param string  $dir_idioma     cadena con el nombre del directorio según el idioma
	 *
	 * @return void   no devuelve nada.
	 */
	function escribir_menu_js($id_objeto, $j, $submenu_index, $dir_idioma) {
		$tam_arr = sizeof($_SESSION['menu_items']['id_objeto']);
		// Imprimimos los hijos
		$submenu_index .= "_".$j;
		Fachada_Menus::profundidad_submenus($submenu_index);
		$contenido = "";
		if ($submenu_index != "_0") {
			$submenu_index = str_replace("_0_", "", $submenu_index);
			$contenido .= "m1mn".$submenu_index."=new Array\n(\n";
			$flag_second = false; // flag para determinar si va o no una coma
			for ( $i=0; $i < $tam_arr; $i++ ) {
					if ( $_SESSION['menu_items']['id_padre'][$i] == $id_objeto ) {
						if ( $flag_second ) {
							$contenido .= ",";
						}
						if ( $_SESSION['menu_items']['id_pagina'][$i] != "" && isset($_SESSION['menu_items']['id_pagina'][$i]) ) {
							$final_url = "index.php?view=vistas/$dir_idioma/pagina_".$_SESSION['menu_items']['id_pagina'][$i].".php";
						} elseif ( $_SESSION['menu_items']['url'][$i] != "" && isset($_SESSION['menu_items']['url'][$i]) ) {
							$final_url = $_SESSION['menu_items']['url'][$i];
						} else {
							$final_url = "";
						}
						$contenido .= "\"".$_SESSION['menu_items']['nombre'][$i]."\"" .",".
						"\"".$final_url."\"".",".
						$_SESSION['menu_items']['hijos'][$i] ."\n";
						$flag_second = true;
					}
			}
			$contenido .= ")\n";
			fwrite($_SESSION['menu']->submjs, $contenido);
		}
		
		// Imprimimos los hijos de los hijos (si existen)
		for ( $i=0,$j=0,$k=0; $i < $tam_arr; $i++ ) {
		
			if ( $_SESSION['menu_items']['id_padre'][$i] == $id_objeto ) {
				$j++; // recursion adentro
				if ( $_SESSION['menu_items']['hijos'][$i] ) {
					$k++; // recursion afuera
					if ( $_SESSION['menu_items']['id_padre'][$i] == $_SESSION['menu']->id_objeto ) {
						Fachada_Menus::escribir_menu_js( $_SESSION['menu_items']['id_objeto'][$i], $k, $submenu_index, $dir_idioma );
					} else {
						Fachada_Menus::escribir_menu_js( $_SESSION['menu_items']['id_objeto'][$i], $j, $submenu_index, $dir_idioma );
					}
				}
			}
		}
	}
	
	/*
	 * Chequea si el menú prinicipal tiene imagenes o no
	 *
	 * @return bool true si sí tiene imagenes, false en caso contrario.
	 */
	function tiene_imagenes() {
		$item_menu = new Men_items;
		$query = "
			SELECT count(*) as total FROM (
			SELECT id_objeto FROM men_items WHERE id_contenedor=".$_SESSION['menu']->id_objeto.") AS X
			JOIN men_items_versiones 
			ON X.id_objeto=men_items_versiones.id_objeto AND 
			men_items_versiones.imagen_up != 'NULL' AND men_items_versiones.imagen_up != ''";
		$item_menu->query($query);
		$item_menu->fetch();
		//print_r($item_menu);exit();
		
		return ($item_menu->total > 0);
	}
	
	/*
	 * Escribe javascript:void(0); si el url está vacio
	 *
	 * @param string   $url        dirección url
	 * @param int     $id_pagina  identificador de la página
	 * @param int     $id_idioma  identificador del idioma
	 *
	 * @return string cadena con el url formateado o 'javascript:void(0);' según el caso.
	 */
	function write_url($url,$id_pagina, $id_idioma) {
		$idioma = new Sis_idiomas;
		$idioma->get($id_idioma);
	
		if ($url != "") {
			return $url;
		} elseif ($id_pagina != "") {
			return "index.php?view=vistas/{$idioma->enctype}/pagina_".$id_pagina.".php";
		}
		return "javascript:void(0);";
	}
	
	/*
	 * Devuelve el nombre de la imagen para un item apuntado por el parametro
	 * $id_objeto, $mouse nos dice si la imagen es de tipo onMouseOut u onMouseOver
	 * Precondicion: cargar_imagenes() debe haber ya cargado los datos de las imagenes 
	 * de los items de menu hijos del item raiz (primer nivel).
	 * $mouse debe tener el valor imagen_over o imagen_up.
	 *
	 * @param int     $id_objeto  identificador del ìtem del menú
	 * @param string  $mouse      nos dice si la imagen es de tipo onMouseOut u onMouseOver
	 *
	 * @return string cadena con el nombre de la imagen con el path o 'lib/empty.gif' según el caso.
	 */
	function get_image_name($id_objeto,$mouse) {
		$path_sitio =  $_SESSION['sitio']['url'];
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "../../imagenes_cont/".$path_sitio."/menu/";
		$tam_arr = sizeof($_SESSION['imagenes_menu']['id_objeto']);
		// Recorremos el arreglo para ver si se encuentra el id_objeto
		for ($i=0; $i < $tam_arr; $i++) {
			if ( ($_SESSION['imagenes_menu']['id_objeto'][$i] == $id_objeto && 
				  $_SESSION['imagenes_menu'][$mouse][$i] != "") ) {
				return $dir_contenido.$_SESSION['imagenes_menu'][$mouse][$i];
			}
		}
		return "lib/empty.gif";
	}
	
	/*
	 * Escribe el menu principal que se ve en la página como una tabla HTML
	 * Precondicion: Ya se creo el arreglo de items de menu $_SESSION['menu_items']
	 * con la funcion cargar_arreglo_items($id_objeto).
	 *
	 * @param int     $id_objeto  el campo id_objeto que identifica al ítem raíz del menú
	 * @param int     $id_idioma  identificador del idioma
	 *
	 * @return bool true si sí se escribió el menú principal, false en caso contrario.
	 */
	function escribir_mainMenu($id_objeto, $id_idioma) {
		// Chequeamos si el menu prinicipal tiene imagenes o no
		$IMA = Fachada_menus::tiene_imagenes(); // $IMA Nos dice si el menú tiene imagenes o no.
		if ($IMA) { // Para poder llamar a get_image_name()
			Fachada_menus::cargar_imagenes($id_idioma);
		}
		$tam_arr = sizeof($_SESSION['menu_items']['id_objeto']);
		//"<script language=\"JavaScript\" src=\"sitemap_scr.js.php\">\n<//script>\n".<- la palabra script no tiene 2 // sino 1
		
		include 'src/menu/vistas/escribir_mainMenu.php';//exit();
//echo "AAA".$contenido;exit();
		
		if (fwrite($_SESSION['menu']->mainmjs, $contenido)) {
			return true;
		} else {
			return false;
		}
	}
    
    /**
     * Almacena los enlaces internos del portal que serÃ¡n desplegados
     * en la pagina que muestra los enlaces internos.  El parÃ¡metro id_objeto
     * serÃ¡ el id_padre del enlace interno a crear.     
     *
     * @param string $cadena  Cadena donce queda la informaciÃ³n del Ã¡rbol
     *        int $id_objeto  Identificador del objeto a adicionar en el Ã¡rbol
     *        int $id_item    Identificador del Item en el menÃº al cual va enlazado
     *
	 * @return void no devuelve nada en el return pero si devuelve la cadena con los
	 *              enlaces internos en $cadena que se supone está en la sesion.
     * @author  John A. Vargas
	 *          Junior Tello
     * @access public
     * @static
     */  
    function cargar_enlaces_internos($cadena, $id_objeto, $id_item) {    
        $objeto = new Sis_objetos_protegidos;
        $objeto->get($id_objeto);
        
        // Adicionar la cadena de enlace        
        if ($cadena != '')    $cadena .= ', ';
        
        // En esta variable pasamos el parametro del id_padre del enlace interno a crear.
        $_SESSION['id_objeto_tmp'] = $id_item;
        
        // Averiguar si el objeto es o no un modulo
        $nombre_clase = get_class($objeto->get_hijo());
        $clase_version = ($nombre_clase == 'sis_portales') ? 'sis_portal_versiones' : 'sis_paginas_versiones';
        if (ereg("datos_modulos", $nombre_clase)) {
            $obj = new $nombre_clase;
            $obj->get($objeto->id_objeto);
            $nombre_objeto = addslashes($obj->nombre); 
            $cadena .= "['<b>$nombre_objeto</b>','javascript:void(0)','_parent'";
        } else {
            $version = new $clase_version;
            $version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
            $version->id_objeto = $objeto->id_objeto;
            $version->find(true);
            $nombre_objeto = addslashes($version->nombre);
            
            if ($nombre_clase == "sis_portales")
                $cadena .= "['<b>$nombre_objeto</b>','javascript:void(0)','_parent'";
            else {
				$id_objeto2 = $id_objeto;
				// cambiamos el id_objeto de 
				if ($nombre_clase == 'cue_cuestionarios') {
					$formul = new Cnt_formularios;
					$formul->id_cuestionario = $id_objeto;
					if ($formul->find(true))
						$id_objeto2 = $formul->id_objeto;
				}
				$cadena .= "['$nombre_objeto','index.php?view=src/menu/vistas/crear_enlace_interno2.php&id_padre=". 
				$id_item."&id_pagina=$id_objeto2&rotulo=".urlencode($version->nombre)."','_parent'";
			}
        }            
                    
        // Buscar los objeto contenidos
        $clase = ($nombre_clase == "sis_portales") ? 'sis_datos_modulos' : 'sis_paginas';
        $obj_hijos = new $clase;
        $obj_hijos->id_contenedor = $id_objeto;
        $obj_hijos->find(); 
        while ($obj_hijos->fetch()) { 
            // No puedo imprimir usuarios como contenido
			$class_name = get_class($obj_hijos->get_hijo());
			$escribir = 1;
			// Si el cuestionario es tipo 4 (encuesta) no lo metemos en el arbol
			if ($class_name == "cue_cuestionarios") {
				$cue = new Cue_cuestionarios;
				$cue->get($obj_hijos->id_objeto);
				if ($cue->tipo == 4) $escribir = 0;
			}
			if ($class_name != "sis_usuarios" && $class_name != "men_datos_modulos_menus" && $escribir) 
                Fachada_Menus::cargar_enlaces_internos(&$cadena, $obj_hijos->id_objeto, $id_item);
        }
        
        $cadena .= "]";
        return;
     }
	 
	
    /**
     * Almacena los enlaces internos del portal que serán desplegados
     * dentro del editor wysiwyg que muestra los enlaces internos.  El parámetro id_objeto
     * será el id_padre del enlace interno a crear.     
     *
     * @param string $cadena Cadena donce queda la información del árbol
     *        int $id_objeto Identificador del objeto a adicionar en el árbol
     *        int $id_item Identificador del Item en el menú al cual va enlazado
     *
     * @author  John A. Vargas 
	 *          Junior Tello
     *          Sonia Marcela Benavides
     * @access public
     * @static
     */    
    function cargar_enlaces_internos_wysiwyg($cadena, $id_objeto, $id_item) {    
         $objeto = new Sis_objetos_protegidos;
        $objeto->get($id_objeto);
        
        // Adicionar la cadena de enlace        
        if ($cadena != '')    $cadena .= ', ';
        
        // En esta variable pasamos el parametro del id_padre del enlace interno a crear.
        $_SESSION['id_objeto_tmp'] = $id_item;
        
        // Averiguar si el objeto es o no un modulo
        $nombre_clase = get_class($objeto->get_hijo());
        $clase_version = ($nombre_clase == 'sis_portales') ? 'sis_portal_versiones' : 'sis_paginas_versiones';
        $idioma_actual_enlaces = $_SESSION['sis_idioma']['enctype'];
        if (ereg("datos_modulos", $nombre_clase)) {
            $obj = new $nombre_clase;
            $obj->get($objeto->id_objeto);
            $nombre_objeto = addslashes($obj->nombre); 
            $cadena .= "['<b>$nombre_objeto</b>','javascript:void(0)','contenido_mod'";
        } else {
            $version = new $clase_version;
            $version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
            $version->id_objeto = $objeto->id_objeto;
            $version->find(true);
            $nombre_objeto = addslashes($version->nombre);

            if ($nombre_clase == "sis_portales")
                $cadena .= "['<b>$nombre_objeto</b>','javascript:void(0)','contenido_mod'";
            else {
				$id_objeto2 = $id_objeto;
				// cambiamos el id_objeto de 
				if ($nombre_clase == 'cue_cuestionarios') {
					$formul = new Cnt_formularios;
					$formul->id_cuestionario = $id_objeto;
					if ($formul->find(true))
						$id_objeto2 = $formul->id_objeto;
				}
                $cadena .= "['$nombre_objeto','blank.php?view=vistas/$idioma_actual_enlaces/pagina_$id_objeto2.php&nombre=$nombre_objeto','contenido_mod'";
			}
        }            
        
        // Buscar los objeto contenidos
        $clase = ($nombre_clase == "sis_portales") ? 'sis_datos_modulos' : 'sis_paginas';
        $obj_hijos = new $clase;
        $obj_hijos->id_contenedor = $id_objeto;
        $obj_hijos->find(); 
        while ($obj_hijos->fetch()) { 
            // No puedo imprimir usuarios como contenido
			$class_name = get_class($obj_hijos->get_hijo());
			$escribir = 1;
			// Si el cuestionario es tipo 4 (encuesta) no lo metemos en el arbol
			if ($class_name == "cue_cuestionarios") {
				$cue = new Cue_cuestionarios;
				$cue->get($obj_hijos->id_objeto);
				if ($cue->tipo == 4) $escribir = 0;
			}
            if ($class_name != "sis_usuarios" && $class_name != "men_datos_modulos_menus" && $escribir) 
                Fachada_Menus::cargar_enlaces_internos_wysiwyg(&$cadena, $obj_hijos->id_objeto, $id_item);
        }
        
        $cadena .= "]";
        return;
     }// cargar_enlaces_internos_wysiwyg
	
	
	/*
	 * $tipo_imagen tiene uno de los valores "primaria" ó "alterna".
	 *
	 * @param array   $imagen       arreglo con los datos de la imagen
	 * @param string  $tipo_imagen  cadena con el tipo de la imagen
	 *
	 * @return int 1 si es true 0 sí es false.
	 */
	function ingresar_imagen($imagen, $tipo_imagen) {
//print_r($imagen);echo $imagen['name']."***".$imagen['type'];exit();
		if (!isset($imagen) || $imagen == "") {
			return 0;
		}
		// Si el usuario ingresó la imagen, la copiamos en el filesystem
		$path_sitio =  $_SESSION['sitio']['url'];

		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		if (!file_exists($dir_contenido))
			System::mkdir($dir_contenido);
		$dir_contenido .= "/menu/";
		if (!file_exists($dir_contenido))
			System::mkdir($dir_contenido);
		
		$path = $dir_contenido;
		$_SESSION['men_mensaje'] = "";
		
//echo "<br><br><br>\n\n\n\n";print_r($_FILES);echo $imagen['name'];exit();
        if (isset($imagen['name']) && $imagen['name'] != "") {
			$formatos_permitidos = array(".jpg",".jpe",".jpeg",".gif",".png"); 
            if ($imagen['size'] > 200000){ // el archivo debe ser < 200 KB.
				$_SESSION['men_mensaje'] .= '\\nEl tama&ntilde;o de la imagen '.$tipo_imagen.' excede el valor permitido.';
				return 0;
            } 
            
            if  ( ($imagen['name'] != "") and  (in_array(substr($imagen['name'], -4), $formatos_permitidos)) ) { 
                if (is_uploaded_file($imagen['tmp_name'])) {
                    if (!copy($imagen['tmp_name'], $path.$imagen['name'] )) {
						$_SESSION['men_mensaje'] .= '\\nLa imagen '.$tipo_imagen.' no se pudo copiar.';
						return 0;
					} 
				}
                else {
					$_SESSION['men_mensaje'] .= '\\nLa imagen '.$tipo_imagen.' no se cargo.';
                    return 0;
				}
            } 
            else {
				$_SESSION['men_mensaje'] .= '\\nNo se envio la imagen '.$tipo_imagen.' o no era tipo jpg,gif o png.';
                return 0;
			}
		} // Fin del chequeo de la imagen cargada
		return 1;
	}

    /**
     * Crea un enlace interno en el menú
     *
	 * @param int     $id_padre         identificador del item padre del nuevo enlace interno
     * @param int     $nombre           nombre del nuevo enlace
     * @param int     $id_pagina        identificador de pagina
     * @param string  $imagen           arreglo con los datos de la imagen primaria
     * @param int     $imagen_alterna   arreglo con los datos de la imagen alterna
	 *
	 * @return bool true si se creó el enlace interno o false en caso contrario.
    */
    function crear_enlace_interno ($id_padre, $nombre, $id_pagina, $imagen, $imagen_alterna)
	{
		$dat_mod_menu = new Men_datos_modulos_menus;
		$dat_mod_menu->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		
		// La ingresamos en la tala items_menus
		$int_link = new Men_enlaces_internos;
		$int_link->id_contenedor = $id_padre;
		$int_link->id_modulo = $dat_mod_menu->id_objeto;
		$int_link->id_pagina = $id_pagina;
        $id1 = $int_link->insert();
		
		// Ahora ingresamos los datos a la tabla items_versiones
		$item_v = new Men_items_versiones;
		$item_v->id_objeto = $int_link->id_objeto;
		$item_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_v->nombre = $nombre;
		// Ingresamos los datos de la imagen
		if (isset($imagen) && $imagen['name'] != "" && Fachada_Menus::ingresar_imagen($imagen, "primaria"))
			$item_v->imagen_up = $imagen['name'];
		if (isset($imagen_alterna) && $imagen_alterna['name'] != "" && Fachada_Menus::ingresar_imagen($imagen_alterna, "alterna"))
			$item_v->imagen_over = $imagen_alterna['name'];
		$id2 = $item_v->insert();
		
		// generamos el menu
		Generar_Menus::generar_menus($this->gen_dir, $_SESSION['sis_idioma']);
		
		if ($id1 > 0 && $id2 > 0) Util::log('Menus', 'Crear Enlace Interno', 'Se creo el enlace interno');
		else Util::log('Menus', 'Crear Enlace Interno', 'No se creo el enlace interno');
		return ($id1 > 0 && $id2 > 0);
    }

	/**
     * Crea un enlace externo en el menú
     *
	 * @param int     $id_padre         identificador del item padre del nuevo enlace externo
     * @param int     $nombre           nombre del nuevo enlace
     * @param string  $url              cadena con el url del enlace externo
     * @param string  $imagen           arreglo con los datos de la imagen primaria
     * @param int     $imagen_alterna   arreglo con los datos de la imagen alterna
	 *
	 * @return bool true si se creó el enlace externo o false en caso contrario.
    */
	function crear_enlace_externo ($id_padre, $nombre, $url, $imagen, $imagen_alterna)
	{
		$dat_mod_menu = new Men_datos_modulos_menus;
		$dat_mod_menu->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		
		// La ingresamos en la tala items_menus
        $ext_lnk = new Men_enlaces_externos;
        $ext_lnk->id_contenedor = $id_padre;  
		$ext_lnk->id_modulo = $dat_mod_menu->id_objeto;
        $ext_lnk->url = $url;
        $id1 = $ext_lnk->insert();
		
		// Ahora ingresamos los datos a la tabla items_versiones
		$item_v = new Men_items_versiones;
		$item_v->id_objeto = $ext_lnk->id_objeto;
		$item_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_v->nombre = $nombre;
		// Ingresamos los datos de la imagen
		if (isset($imagen) && $imagen['name'] != "" && Fachada_Menus::ingresar_imagen($imagen, "primaria"))
			$item_v->imagen_up = $imagen['name'];
		if (isset($imagen_alterna) && $imagen_alterna['name'] != "" && Fachada_Menus::ingresar_imagen($imagen_alterna, "alterna"))
			$item_v->imagen_over = $imagen_alterna['name'];
		
		$id2 = $item_v->insert();
		
		// generamos el menu
		Generar_Menus::generar_menus($this->gen_dir, $_SESSION['sis_idioma']);
		
		if ($id1 > 0 && $id2 > 0) Util::log('Menus', 'Crear Enlace Externo', 'Se creo el enlace externo');
		else Util::log('Menus', 'Crear Enlace Externo', 'No se creo el enlace externo');
		return ($id1 > 0 && $id2 > 0);
    }

	/**
     * Crea un submenú en el menú
     *
	 * @param int     $id_padre         identificador del item padre del nuevo submenú
     * @param int     $nombre           nombre del nuevo enlace
     * @param string  $imagen           arreglo con los datos de la imagen primaria
     * @param int     $imagen_alterna   arreglo con los datos de la imagen alterna
	 *
	 * @return bool true si se creó el submenú o false en caso contrario.
    */
	function crear_submenu ($id_padre, $nombre, $imagen, $imagen_alterna)
	{
		$dat_mod_menu = new Men_datos_modulos_menus;
		$dat_mod_menu->get('id_contenedor', $_SESSION['sitio']['id_objeto']);
		
		// La ingresamos en la tala men _menus
        $menu = new Men_menus;
        $menu->id_contenedor = $id_padre;  
		$menu->id_modulo = $dat_mod_menu->id_objeto;
        $id1 = $menu->insert();
		
		// Ahora ingresamos los datos a la tabla items_versiones
		$item_v = new Men_items_versiones;
		$item_v->id_objeto = $menu->id_objeto;
		$item_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_v->nombre = $nombre;
		// Ingresamos los datos de la imagen
		if (isset($imagen) && $imagen['name'] != "" && Fachada_Menus::ingresar_imagen($imagen, "primaria"))
			$item_v->imagen_up = $imagen['name'];
		if (isset($imagen_alterna) && $imagen_alterna['name'] != "" && Fachada_Menus::ingresar_imagen($imagen_alterna, "alterna"))
			$item_v->imagen_over = $imagen_alterna['name'];
		
		$id2 = $item_v->insert();
		
		// generamos el menu
		Generar_Menus::generar_menus($this->gen_dir, $_SESSION['sis_idioma']);
		
		if ($id1 > 0 && $id2 > 0) Util::log('Menus', 'Crear Submenu', 'Se creo el submenu');
		else Util::log('Menus', 'Crear Submenu', 'No se creo el submenu');
		return ($id1 > 0 && $id2 > 0);
    }

    /**
     * Modifica el enlace externo
	 *
	 * @param int     $id_padre         identificador del item padre del enlace externo
     * @param int     $nombre           nombre del nuevo enlace
     * @param string  $url              cadena con el url del enlace externo
     * @param string  $imagen           arreglo con los datos de la imagen primaria
     * @param int     $imagen_alterna   arreglo con los datos de la imagen alterna
	 *
	 * @return bool true si se modificó el enlace externo o false en caso contrario.
	*/
    function modificar_item_externo ($id_objeto, $nombre, $url, $imagen, $imagen_alterna) {
	
		$ext_lnk = new Men_enlaces_externos;
		$ext_lnk->get($id_objeto);
		$ext_lnk->url = $url;
		$id1 = $ext_lnk->update();

		$item_v = new Men_items_versiones;
		$item_v->id_objeto = $id_objeto;
		$item_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_v->find(true);
		$item_v->nombre = $nombre;
		// Ingresamos los datos de la imagen
		if (isset($imagen) && $imagen['name'] != "" && Fachada_Menus::ingresar_imagen($imagen, "primaria"))
			$item_v->imagen_up = $imagen['name'];
		if (isset($imagen_alterna) && $imagen_alterna['name'] != "" && Fachada_Menus::ingresar_imagen($imagen_alterna, "alterna"))
			$item_v->imagen_over = $imagen_alterna['name'];
		
        $id2 = $item_v->update();
		
		// generamos el menu
		Generar_Menus::generar_menus($this->gen_dir, $_SESSION['sis_idioma']);
		
		if ($id1 > 0 && $id2 > 0) Util::log('Menus', 'Modificar Item Externo', 'Se modifico el item externo');
		else Util::log('Menus', 'Modificar Item Externo', 'No se modifico el item externo');
		return ($id1 > 0 && $id2 > 0);
    }
	
    /**
     * Modifica un enlace interno
	 *
	 * @param int     $id_padre         identificador del item padre del enlace interno
     * @param int     $nombre           nombre del nuevo enlace
     * @param string  $imagen           arreglo con los datos de la imagen primaria
     * @param int     $imagen_alterna   arreglo con los datos de la imagen alterna
	 *
	 * @return bool true si se modificó el enlace interno o false en caso contrario.
	*/
    function modificar_item_interno ($id_objeto, $nombre, $imagen, $imagen_alterna) {

		$item_v = new Men_items_versiones;
		$item_v->id_objeto = $id_objeto;
		$item_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_v->find(true);
		$item_v->nombre = $nombre;
		// Ingresamos los datos de la imagen
		if (isset($imagen) && $imagen['name'] != "" && Fachada_Menus::ingresar_imagen($imagen, "primaria"))
			$item_v->imagen_up = $imagen['name'];
		if (isset($imagen_alterna) && $imagen_alterna['name'] != "" && Fachada_Menus::ingresar_imagen($imagen_alterna, "alterna"))
			$item_v->imagen_over = $imagen_alterna['name'];
		
        $id = $item_v->update();
		
		// generamos el menu
		Generar_Menus::generar_menus($this->gen_dir, $_SESSION['sis_idioma']);
		
		if ($id > 0) Util::log('Menus', 'Modificar Item Interno', 'Se modifico el item interno');
		else Util::log('Menus', 'Modificar Item Interno', 'No se modifico el item interno');
		return ($id > 0);
    }

    /**
     * Modifica un submenú
	 *
	 * @param int     $id_objeto        identificador del item del submenú
     * @param int     $nombre           nombre del nuevo enlace
     * @param string  $imagen           arreglo con los datos de la imagen primaria
     * @param int     $imagen_alterna   arreglo con los datos de la imagen alterna
	 *
	 * @return bool true si se modificó el submenú o false en caso contrario.
	*/
    function modificar_submenu ($id_objeto, $nombre, $imagen, $imagen_alterna) {
	
		$item_v = new Men_items_versiones;
		$item_v->id_objeto = $id_objeto;
		$item_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_v->find(true);
		$item_v->nombre = $nombre;
		// Ingresamos los datos de la imagen
		if (isset($imagen) && $imagen['name'] != "" && Fachada_Menus::ingresar_imagen($imagen, "primaria"))
			$item_v->imagen_up = $imagen['name'];
		if (isset($imagen_alterna) && $imagen_alterna['name'] != "" && Fachada_Menus::ingresar_imagen($imagen_alterna, "alterna"))
			$item_v->imagen_over = $imagen_alterna['name'];
		
        $id = $item_v->update();
		
		// generamos el menu
		Generar_Menus::generar_menus($this->gen_dir, $_SESSION['sis_idioma']);
		
		if ($id > 0) Util::log('Menus', 'Modificar Submenu', 'Se modifico el submenu');
		else Util::log('Menus', 'Modificar Submenu', 'No se modifico el submenu');
		return ($id > 0);
    }

    /**
     * Elimina los hijos de un item del menú
     *
     * @param int $id_objeto  identificador del item del menú
	 *
	 * @return void no devuelve nada.
    */
    function eliminar_hijos_item ($id_objeto)
    {
		$tam_arr = sizeof($_SESSION['menu_items']['id_objeto']);
		
		// Creamos el camino recursivo de abajo hacia arriba
		for ( $i=0,$j=0; $i < $tam_arr; $i++ ) {
			if ( $_SESSION['menu_items']['id_padre'][$i] == $id_objeto ) {
				if ( $_SESSION['menu_items']['hijos'][$i] ) {
					Fachada_Menus::eliminar_hijos_item( $_SESSION['menu_items']['id_objeto'][$i] );
				}
			}
		}
		// Eliminamos los hijos
		for ( $i=0; $i < $tam_arr; $i++ ) {
			if ( $_SESSION['menu_items']['id_padre'][$i] == $id_objeto ) {
				$item_menu = new Men_items;
				$query = "DELETE FROM Men_items WHERE id_objeto=".$_SESSION['menu_items']['id_objeto'][$i];
				$item_menu->query($query);
				$item_menu_v = new Men_items_versiones;
				$query = "DELETE FROM Men_items_versiones WHERE id_objeto=".$_SESSION['menu_items']['id_objeto'][$i].
						 " AND id_idioma=".$_SESSION['sis_idioma']['id_idioma'];
				$item_menu_v->query($query);
			}
		}
    }
	
	/*
	 * Llama a eliminar hijos item para eliminar los hijos de este item
	 * por ultimo se elimina el item apuntado por $id_objeto
	 *
	 * @param int $id_objeto  identificador del item del menú
	 *
	 * @return bool true si se elimina el ítem y sus hijos o false en caso contrario.
	 */
	function eliminar_item($id_objeto) {
		// Se eliminan los hijos del item
		Fachada_Menus::eliminar_hijos_item($id_objeto);
		
		// Se elimina el item apuntado por $id_objeto
		$item_menu = new Men_items;
		$item_menu->get($id_objeto);
		$id1 = $item_menu->delete();
		
		$item_menu_v = new Men_items_versiones;
		$query = "DELETE FROM Men_items_versiones WHERE id_objeto=".$id_objeto.
				 " AND id_idioma=".$_SESSION['sis_idioma']['id_idioma'];
		$id2 = $item_menu_v->query($query);
		
		// generamos el menu
		Generar_Menus::generar_menus();
		
		if ($id1 > 0 && $id2 > 0) Util::log('Menus', 'Eliminar Item', 'Se elimino el item');
		else Util::log('Menus', 'Eliminar Item', 'No se elimino el item');
		return ($id1 > 0 && $id2 > 0);
	}
	
	/*
	 * Almacena la profundidad de los submenus
	 *
	 * @param int $submenu_index  indice del submenú
	 *
	 * @return bool true si se establece la profundidad del submenú.
	 */
	function profundidad_submenus($submenu_index) {
		if (!isset($_SESSION['menu']->profundidad_submenus)) {
			$_SESSION['menu']->profundidad_submenus = 0;
		}
		$profundidad = substr_count ( $submenu_index, "_");
		if ($_SESSION['menu']->profundidad_submenus < $profundidad) {
			$_SESSION['menu']->profundidad_submenus = $profundidad;
		}
		return true;
	}
	
	/*
	 * Imprime en el archivo de javascript el codigo que determina la profundidad de los submenus
	 *
	 * @return bool true si se imprime el código de la profundidad del submenú.
	 */
	function imprimir_profundidad_submenu() {
		$css = new Sis_hojas_estilos;
		$css->get($_SESSION['sitio']['id_hoja_estilo']);
		$css_menu = new Sis_estilos_textos;
		$css_menu->get($css->menu);
		$css_menu_over = new Sis_estilos_textos;
		$css_menu_over->get($css->menu_over);
//echo "hola";print_r($css_menu);print_r($css_menu_over);exit();
		
		$contenido = "\n";
		for ( $i=0; $i <= ($_SESSION['menu']->profundidad_submenus + 1); $i++ ) {
			$contenido .= "m1.lev$i=new Array(\"12px\",false,false,\"".$css_menu->color_fuente."\",".
			"\"".$css_menu->color_fondo."\",\"".$css_menu_over->color_fuente.
			"\",\"".$css_menu->fuente."\",\"".$css_menu_over->color_fondo."\")\n";
		}
		fwrite($_SESSION['menu']->submjs, $contenido);
		return true;
	}
	
	/*
	 * Imprime la cabecera del archivo de submenus
	 *
	 * @return bool true si se imprime la cabecera del archivo de submenues.
	 */
	function imprimir_cabecera_archivo_submenus() {
		$rm = "0";
		$menuHorizontal = "false";
		if ( $_SESSION['menu']->tipo != 'v' ) {
			$rm = "-1";
			$menuHorizontal = "true";
		}
		
		include "src/menu/vistas/imprimir_cabecera_archivo_submenus.php";
		
		if (fwrite($_SESSION['menu']->submjs, $contenido)) {
			return true;
		} else {
			return false;
		}
	}
	
	/*
	 * Imprime el pie del archivo de submenus
	 *
	 * @return bool true si se imprime el pie del archivo de submenues.
	 */
	function imprimir_pie_archivo_submenus() {
	
		include "src/menu/vistas/imprimir_pie_archivo_submenus.php";
		
		if (fwrite($_SESSION['menu']->submjs, $contenido)) {
			return true;
		} else {
			return false;
		}
	}
	
	/*
	 * Modifica el tipo del menu entre horizontal y vertical
	 *
     * @param int $id_objeto  identificador del item raíz del menú
     * @param int $tipo_menu  tipo de menú (vertical u horizontal)
	 *
	 * @return bool true si se modifica el tipo de menú, false en caso contrario.
	 */
	function modificar_tipo_menu($id_objeto,$tipo_menu) {
		$menu = new Men_menus;
		$menu->get($id_objeto);
		$menu->tipo = $tipo_menu;
		$id = $menu->update();
		return ($id > 0);
	}
	
	/*
	 * Carga la tabla de imagenes del menu, para su despliegue en la administración 
	 * del menu en la pagina modificar enlace y en la generacion del menu.
	 *
	 * @return bool true si se cargaron las imagenes.
	 */
	function cargar_imagenes($id_idioma = '') {
		$items = new Men_items;
		$items_v = new Men_items_versiones;
		
		$_SESSION['imagenes_menu'] = null;
		$_SESSION['imagenes_menu']['id_objeto'] = null;
		$_SESSION['imagenes_menu']['imagen_over'] = null;
		$_SESSION['imagenes_menu']['imagen_up'] = null;
		
		$items->whereAdd('id_contenedor = '.$_SESSION['menu']->id_objeto);
		// Hacemos el join entre items e items_versiones
		$items_v->id_idioma = $id_idioma;
		$items->joinAdd($items_v); // Se une items_versiones a items
		$items->selectAs();
		$items->selectAs($items_v, 'items_v_%s');
		//$items->whereAdd('id_objeto = '.$_SESSION['menu']->id_objeto);
		
		$items->find();
		
		while ($items->fetch()) {
			$_SESSION['imagenes_menu']['id_objeto'][] = $items->id_objeto;
			$_SESSION['imagenes_menu']['nombre'][] = $items->items_v_nombre;
			$_SESSION['imagenes_menu']['imagen_over'][] = $items->items_v_imagen_over;
			$_SESSION['imagenes_menu']['imagen_up'][] = $items->items_v_imagen_up;
			$_SESSION['imagenes_menu']['id_idioma'][] = $items->items_v_id_idioma;
		}
//print_r($_SESSION['imagenes_menu']);exit();
		return true;
	}
	
	/*
	 * Borra la imagen del filesystem y de la base de datos
	 *
     * @param int $id_objeto  identificador del item del menú
     * @param int $mouse      cadena con el tipo de imagen
	 *
	 * @return bool true si se eliminó la imagen.
	 */
	function eliminar_imagen($id_objeto,$mouse) {
		$path_sitio =  $_SESSION['sitio']['url'];
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio."/menu/";
		
		// Borramos el archivo del filesystem
		@unlink($dir_contenido.$men_ima->nombre);
		
		// Borramos el nombre del archivo de la base de datos
		$item_menu_v = new Men_items_versiones;
		$item_menu_v->id_objeto = $id_objeto;
		$item_menu_v->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$item_menu_v->find(true);
		$item_menu_v->$mouse = 'NULL';
        $id = $item_menu_v->update();
		//echo $men_ima->nombre;print_r($men_ima);exit();
		
		if ($id > 0) Util::log('Menus', 'Eliminar Imagen', 'Se elimino la imagen');
		else Util::log('Menus', 'Eliminar Imagen', 'No se elimino la imagen');
		return ($id > 0);
	}
	
	/*
	 * Nos dice si el item apuntado por id_objeto es el primero o el último
	 * en un submenu.
	 *
     * @param int $id_objeto  identificador del item del menú
     * @param int $id_padre   identificador del item padre de $id_objeto
	 *
	 * @return bool true por default.
	 */
	function chequear_primero_ultimo($id_objeto,$id_padre) {
		$_SESSION['item_primero'] = false;
		$_SESSION['item_ultimo'] = false;
		$item_menu = new Men_items;
//$query = "SELECT id_objeto FROM men_items WHERE id_padre=$id_padre order by id_objeto";
		// Capturamos los hijos de este item
		$item_menu->id_contenedor = $id_padre;
		$item_menu->orderBy("id_objeto");
		$item_menu->find();
		while($item_menu->fetch()) {
			$hijos_item['id_objeto'][] = $item_menu->id_objeto;
		}
		
		// Chequear si es el primero
		if ($hijos_item['id_objeto'][0] == $id_objeto) {
			$_SESSION['item_primero'] = true;//echo "\nes primero\n";
		}
		// Chequear si es el último
		$tam_arr = sizeof($hijos_item['id_objeto']);
		if ($hijos_item['id_objeto'][$tam_arr-1] == $id_objeto) {
			$_SESSION['item_ultimo'] = true;//echo "\nes ultimo\n";
		}
//echo "<br>\n".$_SESSION['menu']['item_primero']." seg ".$_SESSION['menu']['item_ultimo'];exit();
		return true;
	}
	
	/*
	 * Sube o baja un item en el menu.
	 * Si $subir_bajar es true sube, si es false baja.
	 *
     * @param int  $id_padre     identificador del item padre de $id_objeto
     * @param int  $id_objeto    identificador del item del menú
     * @param bool $subir_bajar  nos indica si subimos o bajamos el item en el menú
	 *
	 * @return void no devuelve nada.
	 */
	function subir_bajar_item($id_padre,$id_objeto,$subir_bajar) {
		// Cargamos los hijos de $id_padre en un arreglo
		$item_menu = new Men_items;
		
		$query ="SELECT x.* FROM 
				(SELECT w.* FROM 
				(SELECT z.*,ei.id_pagina as id_pagina FROM 
				(SELECT i.id_objeto,i.id_modulo,ee.url as url,i.id_contenedor as id_contenedor FROM (
				SELECT * FROM men_items WHERE id_contenedor=".$id_padre.") as i LEFT JOIN men_enlaces_externos as ee ON 
				i.id_objeto=ee.id_objeto) AS z LEFT JOIN men_enlaces_internos as ei ON
				z.id_objeto=ei.id_objeto) AS w LEFT JOIN men_menus as m ON w.id_objeto=m.id_objeto) AS x 
				order by x.id_objeto";
/*		$query = "SELECT x.*,y.nombre as rotulo,y.imagen_over as imagen_over,y.imagen_up as imagen_up FROM 
				(SELECT id_objeto,id_modulo,url,id_pagina FROM men_items WHERE 
				id_contenedor=".$id_padre." ) AS x 
				JOIN men_items_versiones AS y 
				ON x.id_objeto=y.id_objeto AND y.id_idioma=".$_SESSION['sis_idioma']['id_idioma']." order by x.id_objeto";*/
		$item_menu->query($query);
		
		/* [[item1, [v1, v2,..., vn]], ... ,[itemM, [v1, v2, ..., vN]]] */
		while($item_menu->fetch()) {
			$versiones = new Men_items_versiones;
			$versiones->id_objeto = $item_menu->id_objeto;
			$versiones->find(); 
			$lista_versiones = array();
			while($versiones->fetch()) array_push($lista_versiones, $versiones->toArray());
			$hijos_item[] = array('item' => get_object_vars($item_menu), 'versiones' => $lista_versiones);
		
		} //echo "ya";print_r($hijos_item);exit();
		$tam_arr = sizeof($hijos_item);
		// Buscamos la posicion $id_objeto (el item a subir)
		for ($i=0; $i < $tam_arr; $i++) {
			if ($hijos_item[$i]['item']['id_objeto'] == $id_objeto) {
				break;
			}
		}
		// Determinamos si subimos o bajamos segun la variable $subir_bajar
		if ($subir_bajar) {
			$j = $i - 1; // avanzamos una posicion (hacia arriba)
		} else {
			$j = $i + 1; // retrocedemos una posicion (hacia abajo)
		}
//echo $id_objeto."jaja".$id_padre."jejeje";print_r($hijos_item);echo "i $i, j $j, sb $subir_bajar";exit();
//print_r($hijos_item);echo "<br>\n";
//echo "id_obj_J:".$hijos_item['id_objeto'][$j]." url_J:".$hijos_item['url'][$j]." id_pag_J:".$hijos_item['id_pagina'][$j]."<br>\n";
//echo "id_obj_I:".$hijos_item['id_objeto'][$i]." url_I:".$hijos_item['url'][$i]." id_pag_I:".$hijos_item['id_pagina'][$i];return true;
		
		// Borramos los dos items
		$item_menu = new Men_items;
		$item_menu->get($hijos_item[$j]['item']['id_objeto']);
		$item_menu->delete();
		$item_menu_v = new Men_items_versiones;
		$item_menu_v->whereAdd('id_objeto ='.$hijos_item[$j]['item']['id_objeto']);
		//$item_menu_v->whereAdd('id_idioma ='.$_SESSION['sis_idioma']['id_idioma']);
		$item_menu_v->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		$item_menu = new Men_items;
		$item_menu->get($hijos_item[$i]['item']['id_objeto']);
		$item_menu->delete();
		$item_menu_v = new Men_items_versiones;
		$item_menu_v->whereAdd('id_objeto ='.$hijos_item[$i]['item']['id_objeto']);
		//$item_menu_v->whereAdd('id_idioma ='.$_SESSION['sis_idioma']['id_idioma']);
		$item_menu_v->delete(DB_DATAOBJECT_WHEREADD_ONLY);
		
		// Hacemos el itercambio de i con j
		if ($hijos_item[$i]['item']['url'] != '') { // se trata de un enlace externo
			$enl_ext = new Men_enlaces_externos;
			$enl_ext->id_modulo = $hijos_item[$i]['item']['id_modulo'];
			$enl_ext->id_contenedor = $id_padre;
			$enl_ext->url = $hijos_item[$i]['item']['url'];
			$enl_ext->id_objeto = $hijos_item[$j]['item']['id_objeto'];
			$enl_ext->insert();
		} elseif ($hijos_item[$i]['item']['id_pagina'] != '') { // se trata de un enlace interno
			$enl_int = new Men_enlaces_internos;
			$enl_int->id_modulo = $hijos_item[$i]['item']['id_modulo'];
			$enl_int->id_contenedor = $id_padre;
			$enl_int->id_pagina = $hijos_item[$i]['item']['id_pagina'];
			$enl_int->id_objeto = $hijos_item[$j]['item']['id_objeto'];
			$enl_int->insert(); 
		} else { // se trata de un submenú
			$menu = new Men_menus;
			$menu->id_modulo = $hijos_item[$i]['item']['id_modulo'];
			$menu->id_contenedor = $id_padre;
			$menu->id_objeto = $hijos_item[$j]['item']['id_objeto'];
			$menu->insert();
		}
		foreach ($hijos_item[$i]['versiones'] as $version) {
			$item_menu_v = new Men_items_versiones;
			$item_menu_v->nombre = $version['nombre'];
			$item_menu_v->imagen_up = $version['imagen_up'];
			$item_menu_v->imagen_over = $version['imagen_over'];
			$item_menu_v->id_objeto = $hijos_item[$j]['item']['id_objeto'];
			$item_menu_v->id_idioma = $version['id_idioma'];
			$item_menu_v->insert();
		}
//return true;
/*		
		$query = "UPDATE men_items SET id_contenedor=".$hijos_item['id_contenedor'][$i].", url='".$hijos_item['url'][$i].
				"', id_pagina=".$hijos_item['id_pagina'][$i]." WHERE id_objeto=".$hijos_item['id_objeto'][$j];//echo "jejeje".$query;exit();
		$item_menu->query($query);//echo $query;
		$query = "UPDATE men_items_versiones SET nombre='".$hijos_item['rotulo'][$i].
				"', imagen_up='".$hijos_item['imagen_up'][$i]."', imagen_over='".$hijos_item['imagen_over'][$i].
				 "' WHERE id_objeto=".$hijos_item['id_objeto'][$j]." AND id_idioma=".$_SESSION['sis_idioma']['id_idioma'];
		$item_menu_v->query($query);//echo $query;exit();
*/		
		// Hacemos el itercambio de j con i
		if ($hijos_item[$j]['item']['url'] != '') { // se trata de un enlace externo
			$enl_ext = new Men_enlaces_externos;
			$enl_ext->id_modulo = $hijos_item[$j]['item']['id_modulo'];
			$enl_ext->id_contenedor = $id_padre;
			$enl_ext->url = $hijos_item[$j]['item']['url'];
			$enl_ext->id_objeto = $hijos_item[$i]['item']['id_objeto'];
			$enl_ext->insert();
		} elseif ($hijos_item[$j]['item']['id_pagina'] != '') { // se trata de un enlace interno
			$enl_int = new Men_enlaces_internos;
			$enl_int->id_modulo = $hijos_item[$j]['item']['id_modulo'];
			$enl_int->id_contenedor = $id_padre;
			$enl_int->id_pagina = $hijos_item[$j]['item']['id_pagina'];
			$enl_int->id_objeto = $hijos_item[$i]['item']['id_objeto'];
			$enl_int->insert();
		} else { // se trata de un submenú
			$menu = new Men_menus;
			$menu->id_modulo = $hijos_item[$j]['item']['id_modulo'];
			$menu->id_contenedor = $id_padre;
			$menu->id_objeto = $hijos_item[$i]['item']['id_objeto'];
			$menu->insert();
		}
		
		foreach ($hijos_item[$j]['versiones'] as $version) {
			$item_menu_v = new Men_items_versiones;
			$item_menu_v->nombre = $version['nombre'];
			$item_menu_v->imagen_up = $version['imagen_up'];
			$item_menu_v->imagen_over = $version['imagen_over'];
			$item_menu_v->id_objeto = $hijos_item[$i]['item']['id_objeto'];
			$item_menu_v->id_idioma = $version['id_idioma'];
			$item_menu_v->insert(); 
		}
		
/*		
		$query = "UPDATE men_items SET id_contenedor=".$hijos_item['id_contenedor'][$j].", url='".$hijos_item['url'][$j].
				"', id_pagina=".$hijos_item['id_pagina'][$j]." WHERE id_objeto=".$hijos_item['id_objeto'][$i];
		$item_menu->query($query);
		$query = "UPDATE men_items_versiones SET nombre='".$hijos_item['rotulo'][$j].
				"', imagen_up='".$hijos_item['imagen_up'][$j]."', imagen_over='".$hijos_item['imagen_over'][$j].
				 "' WHERE id_objeto=".$hijos_item['id_objeto'][$i]." AND id_idioma=".$_SESSION['sis_idioma']['id_idioma'];
		$item_menu_v->query($query);
*/		
		// Ahora necesitamos cambiar el id_padre (id_contenedor) de los hijos de cada uno de ellos (i y j).
		// Empezamos por almacenar los hijos del item i:
		$item_i = new Men_items;
//		$query = "SELECT id_objeto FROM men_items WHERE id_padre=".$hijos_item['id_objeto'][$i]." order by id_objeto";
		$item_i->whereAdd('id_contenedor ='.$hijos_item[$i]['item']['id_objeto']);
		$item_i->orderBy("id_objeto");
		$item_i->find();
//		$item_i->query($query);
		while($item_i->fetch()) {
			$hijos_i['id_objeto'][] = $item_i->id_objeto;
		}
		
		// Ahora seguimos almacenando los hijos del item j
		$item_j = new Men_items;
//		$query = "SELECT id_objeto FROM men_items WHERE id_padre=".$hijos_item['id_objeto'][$j]." order by id_objeto";
		$item_j->whereAdd('id_contenedor ='.$hijos_item[$j]['item']['id_objeto']);
		$item_j->orderBy("id_objeto");
		$item_j->find();
//		$item_j->query($query);
		while($item_j->fetch()) {
			$hijos_j['id_objeto'][] = $item_j->id_objeto;
		}
		
		$tam_arr = sizeof($hijos_i['id_objeto']);
		for ($k=0; $k < $tam_arr; $k++) {
			$item_i = new Men_items;
			$item_i->id_contenedor = $hijos_item[$j]['item']['id_objeto'];
			$item_i->whereAdd('id_objeto ='.$hijos_i['id_objeto'][$k]);
			$item_i->update();
/*			$query = "UPDATE men_items SET id_padre=".$hijos_item['id_objeto'][$j].
					 "WHERE id_objeto=".$hijos_i['id_objeto'][$k];
			$item_i->query($query);*/
		}
		$tam_arr = sizeof($hijos_j['id_objeto']);
		for ($k=0; $k < $tam_arr; $k++) {
			$item_j = new Men_items;
			$item_j->id_contenedor = $hijos_item[$i]['item']['id_objeto'];
			$item_j->whereAdd('id_objeto ='.$hijos_j['id_objeto'][$k]);
			$item_j->update();
/*			$query = "UPDATE men_items SET id_padre=".$hijos_item['id_objeto'][$i].
					 "WHERE id_objeto=".$hijos_j['id_objeto'][$k];
			$item_j->query($query);*/
		}
		
		// generamos el menu
		Generar_Menus::generar_menus();
		
		return $hijos_item[$j]['item']['id_objeto'];
	}
	
	
	/*
	 * Establece un enlace interno o externo como home page.
	 *
     * @param int  $id_objeto  identificador del item que será home page
     * @param int  $rotulo     rotulo del item
     * @param bool $url        url del item (si es enlace externo)
     * @param bool $id_pagina  id_pagina del item (si es enlace interno)
	 *
	 * @return bool true si se el item queda como home page y false en caso contrario.
	 */
	function hacer_home_page($id_objeto) {
		// Cargamos los hijos de $id_padre en un arreglo
//print_r($_SESSION['menu']);exit;
		$menu = new Men_menus;
		$ei = new Men_enlaces_internos;
		$ee = new Men_enlaces_externos;
		
		// Asignamos el home page al menú
		$menu->get($_SESSION['menu']->id_objeto);
		$menu->id_index = $id_objeto;
		$ei->id_objeto = $id_objeto;
		$ee->id_objeto = $id_objeto;
		
		if ($ei->find(true)) {
			$menu->tipo_index = 'i';//echo "ei\n";
		} elseif ($ee->find(true)) {
			$menu->tipo_index = 'e';//echo "ee\n";
		}
		
		$id = $menu->update(); //echo "<br>\nid: ".$id;print_r($_SESSION['menu']);print_r($menu); exit;
		if ($id > 0 || $id != false) {
			$_SESSION['menu']->id_index = $id_objeto;
			$_SESSION['menu']->tipo_index = $menu->tipo_index;
			// Cambiar el index fisicamente en el archivo:
			if ($menu->tipo_index == 'i')
				$urlilla = "vistas/" . $_SESSION['sis_idioma']['enctype'] . "/pagina_" . $ei->id_pagina .".php";
			else
				$urlilla = $ee->url;
			// Generamos el index
			Fachada_Menus::generar_index($urlilla, $menu->tipo_index);
		}
//print_r($menu);exit;
		if ($id > 0) Util::log('Menus', 'Hacer Home Page', 'Se establecio el home page');
		else Util::log('Menus', 'Hacer Home Page', 'No se establecio el home page');
		return ($id > 0);
	}
	
	function generar_index($urlilla, $tipo_enlace) {
		$path_archivo = "html/" . $_SESSION['sitio']['url']."/index.php";
		if ($tipo_enlace == 'e') {
			$contenido = '<?php
			header("Location: '. $urlilla .'");
			exit();
			?>';
		} else {
			$contenido = '<?php
			include(\'config.inc.php\');
			session_start();
			
			$_SESSION[\'sitio\'][\'id_objeto\'] = ID_SITIO;
			/***** IDIOMAS *****/
			if (!isset($_SESSION[\'lang\'])) $_SESSION[\'lang\'] = \'es_ES\';
			/******************/
			
			// Modificación para que trabaje con vistas en HTML
			$vista = (isset($_GET[_VIEW])) ? $_GET[_VIEW] : PATH_PROYECTO . \'';
			$contenido .= $urlilla;
			$contenido .= '\';
			include($vista);
			?>';
		}
		
		File::writeLine($path_archivo, stripslashes($contenido), FILE_MODE_WRITE);
		
		return true;
	}
	
	/*
	 * Valida que no exista un menú con el nombre $nombre.
	 *
     * @param string $nombre_menu Nombre del menú que será validado
	 * @return bool true si se no existe un menú con ese nombre, false en caso contrario.
	 */
	 function validar_nombre_menu($nombre_menu)
	 {
	 	$menu = new Men_menus;
		$menu_version = new Men_items_versiones;
		
		if ($menu_version->get('nombre', $nombre_menu))
			return ($menu->get($menu_version->id_objeto) == 0);
		else
			return true;
	 }
	
	/*
	 * Carga la lista de menus.
	 *
	 * @return array Lista de menus del sitio.
	 */
	 function cargar_lista_menus()
	 {
	 	$menu = new Men_items;
		$menu_version = new Men_items_versiones;
		
		$menu_version->joinAdd($menu);
		$menu_version->whereAdd("men_items.id_contenedor = men_items.id_modulo");
		$menu_version->find();
		
		$lista = new ArrayList;
		while ($menu_version->fetch())
			$lista->add($menu_version->toArray());
		
		return $lista->toArray();
	 }
	 
	 /*
	  * Eliminar un nodo raíz Menú.
	  *
	  * @param int $id_menu Identificador del menú.
	  * @return boolean True si la eliminación fue exitosa, falso en caso contrario.
	  */
	  function eliminar_menu($id_menu)
	  {
		$menuDefecto = new Men_items;
		$menuDefecto->orderBy('id_objeto');
		$menuDefecto->find(true);
				
		if ($menuDefecto->id_objeto != $id_menu ) {
			// Eliminar las versiones.
			$menu_version = new Men_items_versiones;
			$menu_version->whereAdd("id_objeto = '$id_menu'");
			$numBorrados = $menu_version->delete(DB_DATAOBJECT_WHEREADD_ONLY);
			
			// Eliminar los items y sus versiones.
			$item = new Men_items;
			$item->whereAdd("id_contenedor = '$id_menu'");
			$item->find();
			
			// Eliminar recursivamente los items hijos.
			while ($item->fetch()) 
				Fachada_Menus::eliminar_menu($item->id_objeto);
			
			$item = new Men_items;
			$item->get($id_menu); 
			return ($item->delete() > 0);
		}
		
		return false;
	}
}
?>