---------------------------------------------------------------------
-- Autor: JUNIOR TELLO, juniorts7@yahoo.com, rtello@telesat.com.co --
-- Archivo de creacin de tablas para el paquete menu              --
-- Fecha: 14 de Abril de 2004                                      --
---------------------------------------------------------------------

CREATE TABLE men_items
(
  CONSTRAINT men_items_pkey PRIMARY KEY (id_objeto)
) INHERITS (sis_objetos_protegidos);

CREATE TABLE men_items_versiones
(
  imagen_over VARCHAR,
  imagen_up VARCHAR,
  PRIMARY KEY (id_objeto, id_idioma),
  FOREIGN KEY (id_idioma) REFERENCES sis_idiomas (id_idioma) ON DELETE CASCADE
) INHERITS (sis_versiones);

CREATE TABLE men_datos_modulos_menus
(
  nombre VARCHAR(50),
  descripcion VARCHAR(255),
  id_tipo INTEGER,
  PRIMARY KEY (id_objeto),
  FOREIGN KEY (id_tipo) REFERENCES sis_tipo_modulo (id_tipo)
) INHERITS (sis_datos_modulos);

CREATE TABLE men_menus
(
  id_index int4,
  tipo_index CHAR(1) DEFAULT 'i',
  tipo CHAR(1) DEFAULT 'v',
  CONSTRAINT men_menus_pkey PRIMARY KEY (id_objeto)
) INHERITS (men_items);

CREATE TABLE men_enlaces
(
  CONSTRAINT men_enlaces_pkey PRIMARY KEY (id_objeto)
) INHERITS (men_items) ;

CREATE TABLE men_enlaces_externos
(
  url VARCHAR,
  PRIMARY KEY (id_objeto)
) INHERITS (men_enlaces) ;

CREATE TABLE men_enlaces_internos
(
  id_pagina INTEGER,
  PRIMARY KEY (id_objeto)
) INHERITS (men_enlaces) ;


------------------------------------------------------------------
-----------------------  TRIGGERS  -------------------------------
------------------------------------------------------------------


CREATE OR REPLACE FUNCTION men_items_versiones__men_items()
  RETURNS trigger AS
'
     DECLARE 
	     fila men_items%ROWTYPE;
     BEGIN
	     SELECT * INTO fila 
	     FROM men_items 
	     WHERE id_objeto = NEW.id_objeto;
	
	     IF fila.id_objeto ISNULL THEN
	     RAISE EXCEPTION \'Error CMSII: de integridad referencial de men_items_versiones en men_items\';
	     END IF;
		
	     RETURN NEW;
     END;
 '
  LANGUAGE 'plpgsql' VOLATILE;
CREATE TRIGGER men_items_versiones__men_items
BEFORE INSERT OR UPDATE ON men_items_versiones
FOR EACH ROW 
EXECUTE PROCEDURE 
men_items_versiones__men_items('men_items_versiones', 'id_objeto', 'men_items', 'id_objeto');

------------------------------------------------------------------

--  THE END  --