<?php
/*
 * Accin para crear un nuevo newsletter
 *
 * @package  Newsletter
 * @version  1
 * @author Fernando Eduardo Rengifo <frengifo@telesat.com.co> 
 * @since    PHP 4.1.2
 */

class crear_envioAction extends Action
{
	/**
	 *
	 * @access	public
	 * @param	ActionMapping	$actionMapping
	 * @param	ActionForm		$actionForm
	 * @return	ActionForward
	 */

	function perform($actionMapping, $actionForm) {
	
	    /* Se crea la categora del news si no existe */
	    //$id_categoria_contenido = Fachada_newsletter::crear_categoria_news();

		$num_bloques_max = Fachada_newsletter::verificar_limite_bloques($actionForm->get('id_news'));

		/* Se crea si o si el newsletter */  
		$id_articulo = Fachada_newsletter::crear_envio($_SESSION['sis_idioma']['id_idioma'], 
														 $_SESSION['usuario'],
														 $actionForm->get('id_news'), 
														 "Nuevo envo",
														 $actionForm->get('descripcion'), 
														 $actionForm->get('id_estilo'));
			
		/* Se crean los bloques de acuerdo al nmero mximo de bloques permitidos 
		   Por defecto se coloca 1 bloque texto al final y el resto bloques texto-foto y foto-texto intercalados
		*/												 
		for( $i = 0; $i < $num_bloques_max['num_bloques']; $i++) {
			 if( $i < $num_bloques_max['num_bloques'] - 1 ) {
				$metodo = ($i % 2) ? 'agregar_bloque_foto_texto' : 'agregar_bloque_texto_foto';			 
	
				Fachada_contenido::$metodo($id_articulo,
										   $i, //posicion	
										   $_SESSION['sis_idioma']['id_idioma'], // idioma
										   'foto1.gif', //foto
										   '', //texto
										   '', // pie_foto
										   ''  //alt
										   );
			 } else {
				Fachada_contenido::agregar_bloque_texto($id_articulo, 
														($num_bloques_max['num_bloques'] - 1), //posicion
														$_SESSION['sis_idioma']['id_idioma'],// idioma
														'', //texto1
														''  //texto2
														);
			 }
		 
		}														 
	
		/* Se extrae el listado de estados para el desplegable de estados */
		$_SESSION['lista_estados'] = Fachada_newsletter::listar("ns_estados");
		/* Se extrae el listado de categorias de contactos para el desplegable de listas */		
		$_SESSION['cnt_lista_categorias'] = Fachada_Contactos::cargar_categorias_contactos();
		
		/* Mtodo que permite imprimir el formulario para llenar datos del newsletter */										 
		Fachada_newsletter::ver_newsletter($id_articulo,
										   $_SESSION['sis_idioma']['id_idioma']);
										   
		$_SESSION['id_articulo'] = $id_articulo;
		$_SESSION['id_categoria_contenido'] = $id_categoria_contenido;
		$actionForward = $actionMapping->get('exito');
		
		return $actionForward;
	}	
}
?>