<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Fernando Rengifo <frengifo@telesat.com.co>                    |
 * +----------------------------------------------------------------------+
 * 
 */
//
// Especificacin del mdulo de Newsletter (Envo de boletines por correo a grupos de usuarios)
//
 /**
 *  La clase Fachada_Newsletter administra las clases para el modulo de Newsletter
 *
 * @package  Newsletter
 * @version  0.1
 * @author   Fernando Rengifo <frengifo@telesat.com.co> 
 * @since    PHP 4.3.3
 */

// Clases necesarias
require_once(PATH_NEWSLETTER . 'modelo/Ns_datos_modulos_newsletter.php');
require_once(PATH_NEWSLETTER . 'modelo/Ns_enlaces.php');
require_once(PATH_NEWSLETTER . 'modelo/Ns_enlaces_contacto.php');
require_once(PATH_NEWSLETTER . 'modelo/Ns_envios.php');
require_once(PATH_NEWSLETTER . 'modelo/Ns_estadisticas.php');
require_once(PATH_NEWSLETTER . 'modelo/Ns_estados.php');
require_once(PATH_NEWSLETTER . 'modelo/Ns_newsletter.php');
require_once(PATH_NEWSLETTER . 'modelo/Ns_bloques.php');
require_once(PATH_NEWSLETTER . 'modelo/Ns_categorias_contacto.php');
require_once(PATH_NEWSLETTER . 'modelo/generador_newsletter.php');

//CONTROLADOR
// Mapping
include(PATH_NEWSLETTER . 'controlador/mappings.php');

// Solo se requieren los formularios que neecesitan validacin
require_once PATH_NEWSLETTER . 'controlador/actions/crear_envioAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/adicionar_newsletterAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/listar_newslettersAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/modificar_envioAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/ver_envioAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/listar_enviosAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/bajar_bloquensAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/subir_bloquensAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/insertar_bloquensAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/eliminar_bloquensAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/redirigir_paginaAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/establecer_envioAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/enviar_correoAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/desuscribir_usuarioAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/eliminar_envioAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/ver_estadisticasAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/listarEnlacescontactosAction.php';
require_once PATH_NEWSLETTER . 'controlador/actions/confirmarRegistroAction.php';

class Fachada_Newsletter
{
	// Esta variable es necesaria para la optimizacion del wisywyg.
	var $num_bloques_wisywyg;
	var $estilos_wysiwyg;

    /**
 	 * Ingresar newsletter
	 * @param   string $nombre nombre del newsletter
	 * @param   string $descripcion descripcin del newsletter	 
	 * @return  int $id_envio Id del newsletter
	 * @author  Fernando Rengifo
     * @access  public
     */  
	function ingresar_newsletter($nombre,$descripcion) {
	    $mensaje = '';
		
	    $datos_modulos = new Ns_datos_modulos_newsletter;
    	$newsletter  = new Ns_newsletter;
		
		$datos_modulos->get('id_contenedor', $_SESSION["sitio"]["id_objeto"]);
		
		$newsletter->id_contenedor   = $datos_modulos->id_objeto;
		$newsletter->id_modulo       = $datos_modulos->id_objeto;
		$newsletter->nombre          = $nombre;
		$newsletter->descripcion     = $descripcion;		
		
		//$newsletter->print_query();
		
		if( $id = $newsletter->insert() ) {

			/* Se crean los directorios necesarios para la plantillas de cada newsletter */
			$dir_templates = PATH_NEWSLETTER . "vistas/templates/" .$newsletter->id_objeto;
			$dir_headfoot = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype']. "/" .$newsletter->id_objeto;
						
			if( !is_dir($dir_templates) ) {
			   mkdir($dir_templates);
			}

			if( !is_dir($dir_headfoot) ) {
			   mkdir($dir_headfoot);
			}
		
			$mensaje .= '* El Newsletter ' . $newsletter->getnombre() . ', ha sido ingresado\\n';		

			$depmensaje = ($id) ? 'Se insert el newsletter '.$newsletter->nombre : 'Error al insertar el newsletter '.$newsletter->nombre;
			Util::log('Newsletter', 'ingresar_newsletter', $depmensaje);		
        }
		else 
			$mensaje .= '* El newsletter ' . $newsletter->getnombre() . ', NO ha sido ingresado\\n';		      

		return $mensaje;
	}	

    /**
 	 * Lista las estados en desplegables
	 * @param   string $nombre_clase nombre de la clase a instanciar
     * @return  array Arreglo de datos solicitados
	 * @author  Fernando Rengifo
     * @access  public
     */  
	function listar($nombre_clase) {
		$lista = new $nombre_clase;

	 	$lista->find();
		$lista_datos = array();
		while ($lista->fetch()) 
			array_push($lista_datos, $lista->toArray());
		
		return $lista_datos;
    }
	
    /**
 	 * Verifica el lmite de bloques de un newsletter
	 * @author  Fernando Eduardo Rengifo
     * @access  public
	 * @return  int $indicador 1 si no ha llegado al limite 0 en caso contrario
     */  
	function verificar_limite_bloques($id_articulo){
		$bloques = new Art_bloques;
		$bloques->whereAdd("id_contenedor = '" .$id_articulo. "' ");
		$total_bloques = $bloques->count();
		
		$datos = new ns_datos_modulos_newsletter;
		$datos->get("id_contenedor", $_SESSION['sitio']['id_objeto']);
  
		if($total_bloques < $datos->num_bloques)
		    $bloquesadd = 1;
		else
			$bloquesadd = 0;
			
		return array("num_bloques" => $datos->num_bloques, "bloquesadd" => $bloquesadd);	
	}
	
   /**
 	 * Verifica la existencia de una categora 
	 * @author  Fernando Eduardo Rengifo
     * @access  public
	 * @return  int $indicador 1 si existe, 0 en caso contrario
     */  
	function existe_categoria($nombre){
		$categoria = new Art_categorias_articulos_versiones;
		$categoria->whereAdd("nombre = '$nombre'");
        $num_cat = $categoria->find(true);
		
		if( $num_cat > 0 )
			return $categoria->id_objeto;
		else
		    return 0;	
	}
	
   /**
 	 * Crea la categora newsletter 
	 * @author  Fernando Eduardo Rengifo
     * @access  public
	 * @return  int $indicador 1 si existe, 0 en caso contrario
     */  
	function crear_categoria_news() {
		
		$cat_main = Fachada_contenido::obtener_categoria_raiz($_SESSION['sitio']['id_objeto']);
		
		$id_categoria_news = fachada_newsletter::existe_categoria('Newsletter');
		
		if( $id_categoria_news == 0 ) {
			if(Fachada_contenido::verificar_limite_categorias($_SESSION['sitio']['id_objeto']) == 1) {
				$id_modulo = Fachada_contenido::traer_contenedor($_SESSION['sitio']['id_objeto']);
				$id_categoria_news = Fachada_contenido::crear_categoria($_SESSION['sis_idioma']['id_idioma'],
																			 'Newsletter',
																			 'Categora para manejo de Newsletter',
																			 $id_modulo,
																			 "",	
																			 $cat_main,	
																			 1,
																			 1);
			} else 
				$_SESSION['mensaje'] = "No puede crear categorias, ya llego a su limite. ";            
		} 
		
		return $id_categoria_news;
		
	}
	
    /**
 	 * Muestra un newsletter para modificacin
     *
	 * @param   int $id_sitio identificador del sitio
	 * @param   int $id_objeto identificador del articulo
	 * @author  Maria Luisa Manyoma
 	 * @modify Sonia Marcela Benavides <smbenavides@telesat.com.co>
     * @access  public
     */  
	function ver_newsletter($id_objeto, $id_idioma)
	{	
		$path_imagenes = "imagenes_cont/".$_SESSION['sitio']['url']."/articulos/";
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/news_" . $id_objeto . '.php'; 
		$articulo = new Art_articulos_versiones;
		$articulo->id_idioma = $id_idioma;
		$articulo->id_objeto = $id_objeto;
		if (!$articulo->find(true))
			Fachada_Sistema::crear_version(&$articulo, $id_idioma);
		
		$imagen = (!$articulo->imagen) ? "foto1.gif" : $articulo->imagen;
		
		$size = Fachada_contenido::ajustar_imagen($imagen, $path_imagenes);
        $ancho = $size['width'];
        $alto = $size['height'];

		// Traer los bloques del articulo
		$bloques_array = array();
		$bloques = new Art_bloques;
		$bloques->whereAdd("id_contenedor = '{$articulo->id_objeto}'");
		$bloques->orderBy('posicion ASC');
		$bloques->find(); 
		
		// Traer los datos del news
		$ns_envio = new Ns_envios;
		$estados  = new Ns_estados;
		
		$ns_envio->whereAdd("id_objeto = '$id_objeto'");
		
		$ns_envio->joinAdd($estados);
		$ns_envio->selectAs();
		$ns_envio->selectAs($estados, 'est_%s');
		$ns_envio->find(true); 

		$_SESSION["ns_envio"] = $ns_envio->toArray();

		$cat_contactos = new Ns_categorias_contacto;
		
		$cat_contactos->whereAdd("id_envio = ".$_SESSION["ns_envio"]["id_contenedor"]." ");
		$cat_contactos->find(); 

		$this->num_bloques_wisywyg = 0;
		$this->estilos_wysiwyg = "";
		$instancia_clase_wisywyg = "";
	
		$bloques_array = new ArrayList();
		while ($bloques->fetch()) {
			$bloques_array->add($bloques->toArray());
			if (ereg("texto",$bloques->tipo)) $this->num_bloques_wisywyg++;
			}
		
		// Si hay mas de 1 bloque con wisywyg, se instancia la clase q se usa en los templates
		if ( $this->num_bloques_wisywyg > 0 ) {
			$instancia_clase_wisywyg = "";
			$estilos_wysiwyg = $_SESSION['fckeditor_comboBoxStyles'];
		    $estilo_tmp = split(';', $estilos_wysiwyg);
			foreach ($estilo_tmp as $estilo_u){
		          $this->estilos_wysiwyg .= '$demo_array["style"]["'.$estilo_u.'"] = "'.$estilo_u.'";';
		    }
		    //echo $this->estilos_wysiwyg . " - dsfsd";
		}// num_bloques_wisywyg

		// Asignar visiblidad al articulo
		$art_obj = new Art_articulos;
		$art_obj->get($id_objeto);
		$publico = ($art_obj->publico) ? "checked" : "";
		$privado = ($art_obj->publico) ? "" : "checked"; 

		//Obtenemos la categoria a la cual pertenece el articulo para la mostrar la cabecera
		//$categoria = new Art_categorias_articulos;
		//$categoria->get('id_objeto',$art_obj->id_contenedor);

		// Se escriben los bloques
		$this->tamanno_bloques_wisywyg = 0;		// Cuenta la cantidad de editores desplegados
		$tamanno = $bloques_array->size();
		$lista = $bloques_array->toArray();
		
		foreach ($lista as $i => $bloque) { 
			if( $bloque['tipo'] == "texto" ) {
				Fachada_newsletter::mostrar_bloque_ns_texto($bloque['posicion'], $id_idioma, $tamanno, $id_objeto, $bloque['id_objeto'], $i, &$contenido_HTML);			
			} else if( $bloque['tipo'] == "texto_foto" || $bloque['tipo'] == "foto_texto" ) {
				Fachada_newsletter::mostrar_bloque_ns($bloque['posicion'], $id_idioma, $tamanno, $id_objeto, $bloque['id_objeto'], $i, &$contenido_HTML, $bloque['tipo']);
	        } 		
		}
 		if($tamanno == 0){
			$template_opciones = PATH_CONTENIDO . "vistas/templates/tpl_opciones_bloques4.html";
			$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
			eval("\$contenido_HTML .= \"$contenido_flash\"; ");
			eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
		}
		$template_pie_articulo = PATH_NEWSLETTER . "vistas/templates/tpl_pie_envio.html";
		$contenido_pie_articulo = addslashes(implode("\n",file($template_pie_articulo))); 
		
		eval("\$contenido_HTML .= \"$contenido_pie_articulo\"; ");
		$_SESSION['contenido_HTML'] = $contenido_HTML;
		

       // Arbol de enlaces de la ventana hiperlynk
        $ventana_enlaces_internos = "";
        Fachada_Menus::cargar_enlaces_internos_wysiwyg(&$ventana_enlaces_internos, $_SESSION['sitio']['id_objeto'],'');
		$_SESSION['enlaces_internos'] = stripslashes($ventana_enlaces_internos);
		
		return ;
	}		
		
    /**
 	 * Muestra un bloque tipo texto_foto para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $i posicion del bloque
	 * @param   string $contenido_HTML HTML del bloque
	 * @author  Maria Luisa Manyoma
 	 * @modify  Sonia Marcela Benavides <smbenavides@telesat.com.co>
     * @access  public
     */  
	function mostrar_bloque_ns($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML, $template){
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/news_" . $id_articulo . '.php'; 
		
		$metodo_bloque = "Art_bloques_".$template."s";
		
		$bloque = new $metodo_bloque;
		$bloque->id_objeto = $id_bloque;
		$bloque->id_idioma = $id_idioma;
		if (!$bloque->find(true))
			Fachada_Sistema::crear_version(&$bloque, $id_idioma);
			
		//variables necesarias para el editor wysiwyg
		if($bloque->texto){
			$contenido = $bloque->texto;
			$contenido = str_replace("'",'"', $contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,' ',$contenido);
			//$contenido = '"'.$contenido.'"';
		}
		$tipo_bloque = $template."[$i][texto]";
		// Wysiwyg
		$estilos_wysiwyg = $_SESSION['fckeditor_comboBoxStyles'];
			
		$ns_bloques = new Ns_bloques;
		$ns_bloques->id_objeto = $id_bloque;
		$ns_bloques->id_idioma = $id_idioma;
		$ns_bloques->find(true);
				$array_estilos = '<? 
		$demo_array = $spaw_dropdown_data;
		// unset current styles
		unset($demo_array["style"]);
		// set new styles
		'.$this->estilos_wysiwyg .'?>';		

		$instancia_wysiwyg = '<? $sw = new SPAW_Wysiwyg("'. $tipo_bloque .'" ,"'. addslashes( $contenido ) .'", "es", "sidetable", "default", "350px", "270px", "'. NOMBRE_HOST.CSS_SITEFILE . '", $demo_array);';
		$mostrar_wysiwyg = '$sw->show(); ?>';
		
		$path_imagenes = "imagenes_cont/".array_pop(explode('/',$_SESSION['sitio']['url']))."/articulos/";
		$size = Fachada_contenido::ajustar_imagen($bloque->foto, $path_imagenes);
        $ancho = $size['width'];
        $alto = $size['height'];

		$template_texto_foto = PATH_NEWSLETTER . "vistas/templates/tpl_ns_".$template.".php";

		$contenido_texto_foto = addslashes(implode("\n",file($template_texto_foto))); 
		if($i == 0){
			$template_opciones = PATH_NEWSLETTER . "vistas/templates/tpl_opciones_bloques1.html";
			$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
		}	  
		if($i == ($tamanno-1)){
			$template_opciones = PATH_NEWSLETTER . "vistas/templates/tpl_opciones_bloques3.html";
			$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
		}
		if($i != 0  and $i != ($tamanno-1)){
			$template_opciones = PATH_NEWSLETTER . "vistas/templates/tpl_opciones_bloques.html";
			$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
		}
		
		eval("\$contenido_HTML .= \"$contenido_texto_foto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
	}
		
    /**
 	 * Muestra un bloque tipo texto para modificacin
     *
	 * @param   int $tamanno numero de bloques en el articulo
	 * @param   int $id_articulo identificador del articulo
	 * @param   int $id_bloque identificador del bloque
	 * @param   int $i posicion del bloque
	 * @param   string $contenido_HTML HTML del bloque
	 * @author  Maria Luisa Manyoma
 	 * @modify  Sonia Marcela Benavides <smbenavides@telesat.com.co>
     * @access  public
     */  
	function mostrar_bloque_ns_texto($posicion, $id_idioma, $tamanno, $id_articulo, $id_bloque, $i, $contenido_HTML){
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/index.php?view=vistas/" . $_SESSION['sis_idioma']['enctype'];
		$archivo_articulo = $path_sitio . "/news_" . $id_articulo . '.php'; 
		$bloque_t = new Art_bloques_textos;
		$bloque_t->id_objeto = $id_bloque;
		$bloque_t->id_idioma = $id_idioma;
		if (!$bloque_t->find(true))
			Fachada_Sistema::crear_version(&$bloque_t, $id_idioma);
		
		//variables necesarias para el editor wysiwyg
		$estilos_wysiwyg = $_SESSION['fckeditor_comboBoxStyles'];

		if($bloque_t->texto1){
			$contenido = $bloque_t->texto1;
			$contenido = str_replace("'",'"', $contenido);
			$car_aux = "\r\n";
			$contenido = ereg_replace($car_aux,' ',$contenido);
			//$contenido = str_replace('"','COMILLAS2CMS',$contenido);
		}
		$tipo_bloque = "texto[$i][texto]";
		// -----   Prueba del spaw editor
		//								SPAW_Wysiwyg(name, value, language, toolbar mode, theme, width, height, stylesheet);
		$array_estilos = '<? 
		$demo_array = $spaw_dropdown_data;
		// unset current styles
		unset($demo_array["style"]);
		// set new styles
		'.$this->estilos_wysiwyg .'?>';		

		$instancia_wysiwyg = '<? $sw = new SPAW_Wysiwyg("'. $tipo_bloque .'" ,"'. addslashes( $contenido ) .'", "es", "sidetable", "default", "700px", "270px", "'. NOMBRE_HOST.CSS_SITEFILE . '", $demo_array);';
		$mostrar_wysiwyg = '$sw->show(); ?>';
		// ----- Fin prueba spaw editor
		$ns_bloques_t = new Ns_bloques;
		$ns_bloques_t->id_objeto = $id_bloque;
		$ns_bloques_t->id_idioma = $id_idioma;
		$ns_bloques_t->find(true);
		
		$template_texto = PATH_NEWSLETTER . "vistas/templates/tpl_ns_texto.php";
		$contenido_texto = addslashes(implode("\n",file($template_texto))); 

		if($i == 0){
			$template_opciones = PATH_NEWSLETTER . "vistas/templates/tpl_opciones_bloques1.html";
			$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
		}	  
		if($i == ($tamanno-1)){
			$template_opciones = PATH_NEWSLETTER . "vistas/templates/tpl_opciones_bloques3.html";
			$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
		}
		if($i != 0  and $i != ($tamanno-1)){
			$template_opciones = PATH_NEWSLETTER . "vistas/templates/tpl_opciones_bloques.html";
			$contenido_opciones = addslashes(implode("\n",file($template_opciones)));
		}
		eval("\$contenido_HTML .= \"$contenido_texto\"; ");
		eval("\$contenido_HTML .= \"$contenido_opciones\"; ");
		
	}

    /**
 	 * Modifica cada uno de los bloques de un articulo
     *
	 * @param   int $id_objeto identificador del articulo
	 * @param   int $tamanno cantidad de bloques
	 * @param   array $arreglo_texto arreglo con el texto de los bloques tipo texto del articulo
	 * @param   array $foto_texto arreglo con el texto de los bloques tipo foto_texto del articulo
	 * @param   array $texto_foto arreglo con el texto de los bloques tipo texto_foto del articulo
	 * @param   array $foto_texto_imagen arreglo con la imagen de los bloques tipo foto_texto del articulo
	 * @param   array $texto_foto_imagen arreglo con la imagen de los bloques tipo texto_foto del articulo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function ns_modificar_bloque($id_idioma, $tamanno, $id_objeto, $arreglo_texto, 
	                          $foto_texto, $texto_foto, $foto_texto_imagen, 
							  $texto_foto_imagen)
	{
		$dir = "";
    	// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		$path_sitio =  $dir . str_replace(" ", "_", array_pop(explode('/',$_SESSION['sitio']['url'])));
	
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido)){
			mkdir($dir_contenido, 0755);
			mkdir($dir_contenido."/articulos", 0755);
		}
		if (!file_exists($dir_contenido."/articulos")){
			mkdir($dir_contenido."/articulos", 0755);
		}
	
		$path = $dir_contenido."/articulos/";
		
		for($j=0; $j<$tamanno; $j++) 
		{
		    if($arreglo_texto[$j]['id_bloque'] != ""){ 
				$bloque_t = new Art_bloques_textos;
				$id_bloque = $arreglo_texto[$j]['id_bloque'];
				$titulo    = $arreglo_texto[$j]['titulo'];
				$categoria = $arreglo_texto[$j]['categoria'];
				$enlace_bl = $arreglo_texto[$j]['enlace'];								
			
				$bloque_t->whereAdd("id_idioma = '$id_idioma'");
				$bloque_t->whereAdd("id_objeto = '$id_bloque'");
				$contenido = $arreglo_texto[$j]['texto'];
				$contenido = str_replace('"',"'",$contenido);
				$car_aux = "\r\n";
				$contenido = ereg_replace($car_aux,'',$contenido);
				
				/* Se obtienen los enlaces puestos en un contenido */
				$linkscontenido = Fachada_newsletter::parselinks($contenido);
				array_push($linkscontenido,$enlace_bl);
				
				/* Se obtienen el contenido con los enlaces reemplazados */				
				$contenido = Fachada_newsletter::reemplazarEnlaces($contenido,$linkscontenido,$id_objeto,$titulo);
				
				$bloque_t->texto1 = $contenido;
				$bandera_texto = $bloque_t->update();  
				
				/* Aqui se ingresan los valores adicionales del bloque texto */
			    fachada_newsletter::adicionarNsbloque($id_bloque,$id_idioma,$titulo,$categoria,$enlace_bl);
							
				//Escribe en el log
				if($bandera_texto > 0)
					Util::log('Contenido', 'Modificar Bloque texto', 'Se Modifico el bloque Texto con exito');
				else
   					Util::log('Contenido', 'Modificar Bloque texto', 'No se modifico el bloque Texto');
			}
			if($foto_texto[$j]['id_bloque'] != ""){
				//print_r($foto_texto);
				$bloque_ft = new Art_bloques_foto_textos;
				$id_bloque = $foto_texto[$j]['id_bloque'];
				$titulo    = $foto_texto[$j]['titulo'];
				$categoria = $foto_texto[$j]['categoria'];
				$enlace_bl = $foto_texto[$j]['enlace'];								
				
				if($_FILES['foto_texto_imagen']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('imagen', $_FILES['foto_texto_imagen']['name'][$j], $_FILES['foto_texto_imagen']['size'][$j], $_FILES['foto_texto_imagen']['tmp_name'][$j], $path) == 1){
						$foto = time()."_".$_FILES['foto_texto_imagen']['name'][$j]; 
						$bloque_ft->foto = $foto;
					}
				}
				$contenido = $foto_texto[$j]['texto'];
				$contenido = str_replace('"',"'",$contenido);
				$car_aux = "\r\n";
				$contenido = ereg_replace($car_aux,'',$contenido);

				/* Se obtienen los enlaces puestos en un contenido */
				$linkscontenido = Fachada_newsletter::parselinks($contenido);
				array_push($linkscontenido,$enlace_bl);
				
				/* Se obtienen el contenido con los enlaces reemplazados */				
				$contenido = Fachada_newsletter::reemplazarEnlaces($contenido,$linkscontenido,$id_objeto,$titulo);

				$bloque_ft->whereAdd("id_idioma = '$id_idioma'");
				$bloque_ft->whereAdd("id_objeto = '$id_bloque'");
				$bloque_ft->texto = $contenido;
				$bloque_ft->pie_foto = $foto_texto[$j]['pie_foto'];			
				$bloque_ft->alt = $foto_texto[$j]['alt'];
				$bandera_ft = $bloque_ft->update();  
				
				/* Aqui se ingresan los valores adicionales del bloque foto texto */
			    fachada_newsletter::adicionarNsbloque($id_bloque,$id_idioma,$titulo,$categoria,$enlace_bl);
								
				//Escribe en el log
				if($bandera_ft > 0 )
					Util::log('Contenido', 'Modificar bloque Foto Texto', 'Se Modifico el bloque Foto Texto con exito');
				else
					Util::log('Contenido', 'Modificar bloque Foto Texto', 'No se modifico el bloque Foto Texto');
			}
			if($texto_foto[$j]['id_bloque'] != ""){
				$bloque_tf = new Art_bloques_texto_fotos;
				$id_bloque = $texto_foto[$j]['id_bloque'];
				$titulo    = $texto_foto[$j]['titulo'];
				$categoria = $texto_foto[$j]['categoria'];
				$enlace_bl = $texto_foto[$j]['enlace'];								

				if($_FILES['texto_foto_imagen']['name'][$j] != ''){
					if(Fachada_contenido::copiar_archivo('imagen', $_FILES['texto_foto_imagen']['name'][$j], $_FILES['texto_foto_imagen']['size'][$j], $_FILES[texto_foto_imagen]['tmp_name'][$j], $path) == 1){
						$foto = time()."_".$_FILES['texto_foto_imagen']['name'][$j]; 
						$bloque_tf->foto = $foto;
					}
				}
				$contenido = $texto_foto[$j]['texto'];
				$contenido = str_replace('"',"'",$contenido);
				$car_aux = "\r\n";
				$contenido = ereg_replace($car_aux,'',$contenido);

				/* Se obtienen los enlaces puestos en un contenido */
				$linkscontenido = Fachada_newsletter::parselinks($contenido);
				array_push($linkscontenido,$enlace_bl);
				
				/* Se obtienen el contenido con los enlaces reemplazados */				
				$contenido = Fachada_newsletter::reemplazarEnlaces($contenido,$linkscontenido,$id_objeto,$titulo);
			
				$bloque_tf->whereAdd("id_idioma = '$id_idioma'");
				$bloque_tf->whereAdd("id_objeto = '$id_bloque'");
				$bloque_tf->texto = $contenido;
				$bloque_tf->pie_foto = $foto_texto[$j]['pie_foto'];			
				$bloque_tf->alt = $foto_texto[$j]['alt'];
				$bandera_tf = $bloque_tf->update(); 

				/* Aqui se ingresan los valores adicionales del bloque foto texto */
			    fachada_newsletter::adicionarNsbloque($id_bloque,$id_idioma,$titulo,$categoria,$enlace_bl);

				//Escribe en el log
				if($bandera_tf > 0)
					Util::log('Contenido', 'Modificar bloque Texto Foto', 'Se Modifico el bloque Texto Foto con exito');
				else
					Util::log('Contenido', 'Modificar bloque Texto Foto', 'No se Modifico el bloque Texto Foto');
			}
		}
	}

    /**
 	 * Crea un articulo nuevo en el sitio
     *
	 * @param   int $id_categoria identificador de la categoria
	 * @param   string $nombre tipo del bloque a adicionar
	 * @param   string $descripcion tipo del bloque a adicionar
	 * @param   int $id_estilo posicion en la que se adicionara el bloque
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int identificador del articulo
     */  
	function crear_envio($id_idioma, $autor, $id_categoria, $nombre, $descripcion, $id_estilo){
	    global $dir_temp_cms;
	
		// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		if ($nombre == '') $nombre = 'Nuevo envo';
		$path_sitio =  $_SESSION['sitio']['url'];
		$modulo = new ns_datos_modulos_newsletter;
		$modulo->get("id_contenedor", $_SESSION['sitio']['id_objeto']);
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido))
			mkdir($dir_contenido, 0755);
		if (!file_exists($dir_contenido."/articulos")){
			mkdir($dir_contenido."/articulos", 0755);
		}
		
		
		// copiamos las imagenes por defecto en el directorio del sitio
		copy ("imagenes_cont/default/foto1.gif", $dir_contenido . "/articulos/foto1.gif");
		copy ("imagenes_cont/default/foto2.gif", $dir_contenido . "/articulos/foto2.gif");
		copy ("imagenes_cont/default/a_tip.swf", $dir_contenido . "/articulos/a_tip.swf");

		$posicion = fachada_contenido::buscar_posicion($id_categoria) + 1;
		
		$articulo = new ns_envios;
		$articulo->autor = $_SESSION['usuario']['nombre'];
		$articulo->id_contenedor = $id_categoria;
		$articulo->setid_modulo($modulo->getid_objeto());
		$articulo->id_estilo = $id_estilo;
		$articulo->posicion = $posicion;
		$articulo->fecha_creacion = date("Y-m-d");
		$articulo->descripcion = $nombre;
		$articulo->id_estado = 2; // Por defecto se crea inactivo
		$id_articulo = $articulo->insert();  

		$dir_estadisticas = $_SERVER['DOCUMENT_ROOT']."/".$dir_temp_cms."tmp/newsstats/".$id_articulo;
		
		if ( !is_dir($dir_estadisticas) ){
			mkdir($dir_estadisticas, 0755);
			
			$database = $dir_estadisticas."/logdb.dta";
			$archivo = fopen($database,"a+");
			fclose($archivo);
		}

		$articulo_versiones = new Art_Articulos_versiones;
		$articulo_versiones->id_objeto = $id_categoria;
		$articulo_versiones->id_idioma = $id_idioma;
		$articulo_versiones->nombre = addslashes($nombre);
		$articulo_versiones->descripcion = addslashes($descripcion);
		$id_articulo_versiones = $articulo_versiones->insert();  
				

		//Escribe en el log
		if($id_articulo_versiones > 0)
			Util::log('Contenido', 'Crear envio', 'Se creo el envio con exito');
		else 
			Util::log('Contenido', 'Crear envio', 'No se creo el envio');

		
		return $id_articulo;
	}
	
    /**
 	 * Actualiza nombre, descripcin y estado de un articulo
     *
	 * @param   int $id_objeto identificador del articulo
	 * @param   string $nombre_menu nombre del articulo en el menu
	 * @param   string $nombre nombre del articulo
	 * @param   string $descripcin descripcion de articulo
	 * @param   Bool $estado publicado / no publicado
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int Identificador del articulo
	 * @static
     */  
	function modificar_envio($id_idioma, $id_objeto, $asunto, $descripcion, $estado, $fecha_envio, $categorias, $fecha_boletin, $nro_boletin, $id_news, $publico){
		$dir = "";
		$articulo = new Art_articulos_versiones;
    	// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		$path_sitio =  $dir . str_replace(" ", "_", array_pop(explode('/',$_SESSION['sitio']['url'])));
	
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido)){
			System::mkdir($dir_contenido);
			System::mkdir($dir_contenido."/articulos");
		}
		if (!file_exists($dir_contenido."/articulos")){
			System::mkdir($dir_contenido."/articulos");
		}
		$path = $dir_contenido."/articulos/";
		$articulo->id_idioma = $id_idioma;
		$articulo->id_objeto = $id_objeto;
		$articulo->find(true);
		$articulo->nombre = $nombre;
		$articulo->descripcion = $descripcion;
		
		$bandera = $articulo->update();
		
		//Guardar valores del envio
		$envio = new Ns_envios;
		$envio->get($id_objeto);
		$envio->asunto = $asunto;
		$envio->fecha_envio = $fecha_envio;
		$envio->fecha_creacion = date("Y-m-d");
		$envio->fecha_boletin = $fecha_boletin;		
		$envio->nro_boletin = $nro_boletin;		
		$envio->descripcion = $descripcion;
		$envio->id_estado = $estado;		
		$envio->update();
		
		//Se guardan y eliminan las listas asignadas para envio
		fachada_newsletter::actualizarCategorias($categorias,$id_objeto);
		
		// Asignarle visibilidad al articulo
		$art_obj = new Art_articulos;
		$art_obj->get($id_objeto);
		$art_obj->publico = $publico;
		$art_obj->update();

		//Escribe en el log
		if($bandera > 0)
			Util::log('Newsletter', 'Modificar Newsletter', 'Se Modifico el newsletter con xito');
		else
			Util::log('Newsletter', 'Modificar Newsletter', 'No se modifico el newsletter');

		Generador_newsletter::generar_newsletter($id_objeto,$id_news);
		
        return $id_objeto; 
	}
	
    /**
 	 * Elimina un envio
	 * @param   int $id_envio Identificador del envio
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function eliminar_envio($id_envio) {

 	    global $dir_temp_cms;
	   
	 	$mensaje = '';
		
		$dir_estadisticas = $_SERVER['DOCUMENT_ROOT']."/".$dir_temp_cms."tmp/newsstats/".$id_envio;
		
		$deldir = fachada_newsletter::deldir($dir_estadisticas);  
		
		if( $deldir == true || $deldir == 5) {
		   if( $deldir == true )
			   $mensaje .= 'Directorio de estadsticas Borrado\\n';
		   else if( $deldir == 5 )	   
			   $mensaje .= 'Directorio de estadsticas No existe, pero los datos sern borrados\\n';						   

		   $exito = 1;													   			
		}   
		else
		   $mensaje .= 'Directorio de estadsticas No fue borrado \\n';   

        /* Si el directorio fue borrado xitosamente o no existia el directorio */ 		
        if( $exito == 1 ) {
     
			/* Se borran primero los registro en la tabla Ns_categorias_contacto */
			$ns_cat_contacto = new Ns_categorias_contacto;
			$ns_cat_contacto->id_objeto = $id_envio;
			$ns_cat_contacto->delete();
	
			/* Se borran luego los registros en la tabla Ns_enlaces */
			$ns_enlaces = new Ns_enlaces;
			$ns_enlaces->id_envio = $id_envio;
			$ns_enlaces->delete();
	
			/* Se borran luego los registros en la tabla Ns_estadisticas */
			$ns_estadisticas = new Ns_estadisticas;
			$ns_estadisticas->id_envio = $id_envio;
			$ns_estadisticas->delete();
		
			$item = new Ns_envios;
			$item->get($id_envio);
	
			if ( !$item->delete() ) {
				$mensaje .= '* Se elimin el envi ' . $item->getnombre().'\\n';
				
				//Escribe en el log
				Util::log('Newsletter', 'eliminar_envio', 'Se elimino el envio con exito');
			}	 
		
		} else {
			$mensaje .= '* el envi ' . $item->getnombre() . ', no puede ser eliminado\\n';		
		}

		return $mensaje;
	}	
	

    /**
 	 * Actualiza nombre, descripcin y estado de un articulo
     *
	 * @param   int $categorias Categorias seleccionadas por el usuario
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
    function actualizarCategorias($categorias,$id_envio) {
	
		$lista_categorias = fachada_newsletter::listarCategoriasSeleccionadas($id_envio);	
	
	    $nombre_clase = "Ns_categorias_contacto";

		/* 
		  Se halla la diferencia entre las categorias que ya estan insertadas y las seleccionadas 
		  Para insertarlas.
		*/
		$diferencia   = array_diff ($categorias, $lista_categorias);
		
		// Se halla la interseccin entre las categorias que ya estan insertadas y las seleccionadas 
		$interseccion = array_intersect ($categorias, $lista_categorias);
		$catborrar    = array_diff ($lista_categorias, $interseccion);

	 	foreach ($diferencia as $id_categoria => $v) {
			$item = new $nombre_clase;

            $item->id_categoria = $v;
			$item->id_objeto    = $id_envio;
		
		    $id = $item->insert();
			$insertmensaje = ($id) ? 'Se insert la categora con id ' . $v . ' del envio ' . $id_envio : 'No pudo insertarse la categora con id '. $v .' del envio ' .$id_envio;				
		}

	 	foreach ($catborrar as $id_catborrar => $value) {
			$item = new $nombre_clase;

            $item->id_categoria = $value;
			$item->id_objeto    = $id_envio;
			
		    $id = $item->delete();
			$delmensaje = ($id) ? 'Se elimino la categora con id ' . $value . ' del envio ' . $id_envio : 'No pudo eliminarse la categora con id ' . $value . ' del envio ' .$id_envio;				
		}

	    Util::log('Newsletter', 'actualizarCategorias', $insertmensaje);	
	    Util::log('Newsletter', 'actualizarCategorias', $delmensaje);
	}

     /**
 	 * Listar datos como envios de newsletter
	 * @return array $lista_envios Listado total de envios de un newsletter
	 * @author  Fernando Rengifo
     * @access  public
     */  
	function listar_datos($nombre_clase,$id_envio,$criterio,$sentido,$from) {
		$lista = new $nombre_clase;

		if ( $id_envio != "" ){
			$envios->whereAdd($nombre_clase.".id_contenedor = " . $id_envio);
		}

		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0;
		$data = DB_Pager::getData($from, NUM_REGISTROS, $lista->count(), MAXPAGES);

		$lista->limit($from, NUM_REGISTROS);
		if( $criterio != "" ) {
		  $lista->orderBy($criterio." ".$sentido);
		}
	 	$lista->find();

		$lista_datos = array();
		while ($lista->fetch()) 
			array_push($lista_datos, $lista->toArray());
		
		if( sizeof($lista_datos) == 0 ) {
			$mensaje = "No existen datos para listar";
			$_SESSION['mensaje'] = $mensaje;
		}

		return array("lista" => $lista_datos, "data" => $data);
    }	 

     /**
 	 * Listar los envios de un newsletter
	 * @return array $lista_envios Listado total de envios de un newsletter
	 * @author  Fernando Rengifo
     * @access  public
     */  
	function listar_envios($id_envio,$criterio,$sentido,$from) {
		$envios = new Ns_envios;
        $estados = new Ns_estados;

		if ( $id_envio != "" ){
			$envios->whereAdd("Ns_envios.id_contenedor = " . $id_envio);
		}

		$envios->joinAdd($estados);
		$envios->selectAs();
		$envios->selectAs($estados, 'est_%s');

		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0;
		$data = DB_Pager::getData($from, NUM_REGISTROS, $envios->count(), MAXPAGES);

		$envios->limit($from, NUM_REGISTROS);
		if( $criterio != "" ) {
		  $envios->orderBy($criterio." ".$sentido);
		}
	 	$envios->find();
		
		$lista_envios = array();
		while ($envios->fetch()) 
			array_push($lista_envios, $envios->toArray());
		
		if( sizeof($lista_envios) == 0 ) {
			$mensaje = "No existen envos para listar";
			$_SESSION['mensaje'] = $mensaje;
		}

		return array("lista" => $lista_envios, "data" => $data);
    }
	
    /**
 	 * Lista las categorias seleccionadas para un envio
     *
	 * @param   int $id_envio Identificador del envio
	 * @return Array Retorna un arreglo con las categorias seleccionadas
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
    function listarCategoriasSeleccionadas($id_envio) {
		$listas_envio = new Ns_categorias_contacto;
		$listas_envio->whereAdd("Ns_categorias_contacto.id_objeto='".$id_envio."' ");
		$listas_envio->find();

		$lista_categorias = array();
		$i = 0;
		while ($listas_envio->fetch()) {
  			 $lista_categorias[$i++] = $listas_envio->id_categoria;
		}

		return $lista_categorias;
	}
	
    /**
 	 * Carga las listas de los usuarios a los que se les va a enviar un newsletter
     *
	 * @param  Int $id_envio Identificador del envio
	 * @return Array $links Retorna un arreglo con los contactos para envio del envio.
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function cargarListas($id_envio) {
	
	    $id_categorias = fachada_newsletter::listarCategoriasSeleccionadas($id_envio);


		$contactos = new Sis_contactos;
		$cat_x_contactos = new cnt_contactos_x_categorias;
		
		foreach( $id_categorias as $cat ) {
		    $cat_x_contactos->whereAdd('id_categoria = '.$cat['id_categoria'].' ', 'or');
		}
		$cat_x_contactos->joinAdd($contactos);
		$cat_x_contactos->selectAs();
		$cat_x_contactos->selectAs(array('email','nombres','apellido1'), 'cnt_%s', 'sis_contactos');		
		$cat_x_contactos->find();
		
		$lista_contactos = array();
		while($cat_x_contactos->fetch()) {
		     array_push($lista_contactos,$cat_x_contactos->toArray());
		}

		return $lista_contactos;
	}
	
    /**
 	 * Cambia los enlaces ingresados en los Wysiwyg
     *
	 * @param   String $string Identificador del envio
	 * @return Array $links Retorna un arreglo con los enlaces a modificar
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function parselinks($string)
	{
	 $allhere="";
	 $links=array();
	 $i=0;
	
	   $pat='href=\"([a-zA-Z0-9.:/?=+-_%&#]+)\"';
	   $pat2="href='([a-zA-Z0-9.:/?=+-_%&#]+)'";
	   $pat3='href=([a-zA-Z0-9.:/?=+-_%&#]+)>';
	   $chunk=split('<',$string);
	   
	   foreach($chunk as $key => $value)
	   {
	      $found=eregi($pat,stripslashes($value),$link);
	      if($found)
		  {
		     $links[$i]=$link[1];
		     $i++;
	      } 
	      $found=eregi($pat2,stripslashes($value),$link);
	      if($found)
		  {
	         $links[$i]=$link[1];
	         $i++;
	      }
	      $found=eregi($pat3,stripslashes($value),$link);
	      if($found)
		  {
	         $links[$i]=$link[1];
	         $i++;
	      }
	   }
	   
	   return $links;
	}

    /**
 	 * Agrega un enlace de un articulo	
     *
	 * @param  String $string Identificador del enlace
	 * @return int $links Retorna un arreglo con los enlaces a modificar
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function enlaceAdd($id_envio,$enlace,$titulo)
	{
		$enlaces = new ns_enlaces;
		
        $enlaces->id_envio = $id_envio;
		$enlaces->enlace   = $enlace;
		
		$num_rows = $enlaces->find(true); 		

		$enlaces->titulo   = $titulo;
		
		if( $num_rows == 0 && $enlace != "" ) {
			$id = $enlaces->insert();
			
			$insertmensaje = ($id) ? 'Se insert el enlace con id ' . $id . ' del envio ' . $id_envio : 'No pudo insertarse el enlace con id '. $id .' del envio ' .$id_envio;				
			Util::log('Newsletter', 'enlaceAdd', $insertmensaje);
			
		} else
		   $id = 0;

		return $id;
	}	

    /**
 	 * Reemplaza enlaces de los bloques 
     *
	 * @param  String $contenido Contenido
	 * @param  Array  $linkscontenido Enlaces puestos en el contenido	 
	 * @return String $contenido Retorna el contenido modificado
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function reemplazarEnlaces($contenido,$linkscontenido,$id_envio,$titulo) {
		$path_enlace = NOMBRE_HOST . "html/sitio/";
		
		/* Cadena para poder detectar que es un enlace ya cambiado, se tuvo que hacer asi porque
		   el Wysiwyg cambiaba el ampersan
		*/
		$pagina_inter      = $path_enlace."phrame.php?action=redirigir_pagina";		
		
		/* Pagina intermedia */
		$pagina_intermedia      = $path_enlace."phrame.php?action=redirigir_pagina&go=publico&id_contacto=IDUSER&id_enlace=";		

		for($i=0; $i <sizeof($linkscontenido); $i++) {
			$encontrado = substr($linkscontenido[$i] , 0, strlen($pagina_inter));
			$linkscontenido[$i] = str_replace("$amp;","&",$linkscontenido[$i]);
			$encontrado = str_replace("$amp;","&",$encontrado);
			
			if( $encontrado != $pagina_inter ) {

			  $id_enlace = fachada_newsletter::enlaceAdd($id_envio,$linkscontenido[$i],$titulo);	
			  
			  if( $id_enlace > 0 )
				  $contenido = str_replace($linkscontenido[$i],$pagina_intermedia.$id_enlace,$contenido);  
			}  
		}
		
		return $contenido;
	}

    /**
 	 * Inserta o actualiza en Ns_bloques
     *
	 * @param  Int $id_bloque id del bloque
	 * @param  Int $id_idioma id del idioma
	 * @param  String $titulo Titulo del bloque	 
	 * @param  String $categoria Categoria del bloque	 	 
	 * @param  Array  $linkscontenido Enlaces puestos en el contenido	 
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
    function adicionarNsbloque($id_bloque,$id_idioma,$titulo,$categoria,$enlace) {
		$ns_bloque = new Ns_bloques;

		$ns_bloque->id_idioma = $id_idioma;
		$ns_bloque->id_objeto = $id_bloque;
		
		$metodo = ($ns_bloque->find(true)) ? 'update' : 'insert'; 

		$ns_bloque->categoria = $categoria;
		$ns_bloque->titulo    = $titulo;
		$ns_bloque->enlace    = $enlace;				
		
		// Se crea el registro en la base de datos
		$mensaje = ($ns_bloque->$metodo()) ? 'Se creo el bloque' : 'Error al crear el bloque';
	}
	
    /**
 	 * Quita bloque de cualquier tipo
     *
	 * @param   int $id_bloque identificador del bloque
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function quitar_nsbloque($id_bloque){
		$bloque = new ns_bloques;
		$bloque->get("id_objeto", $id_bloque);
		$bloque->delete();

		//Escribe en el log
		Util::log('Newsletter', 'Eliminar Ns bloque', 'Se elimino el Ns bloque con exito');

		return;
	}
	
    /**
 	 * Extrae un enlace de un articulo y adems hace el conteo del click y el contacto que hizo el click para las estadisticas
     *
	 * @param  String $string Identificador del enlace
	 * @param  String $string Identificador del contacto	 
	 * @return int retorna el enlace solicitado
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function extraerEnlace($id_enlace,$id_contacto)
	{
		$enlaces = new ns_enlaces;
		
        $enlaces->id_enlace = $id_enlace;
		$num_rows = $enlaces->find(true); 		

		$enlaces->clicks   += 1;
		
		if( $id_enlace != "" ) {
			$id = $enlaces->update();
			
			$updatemensaje = ($id) ? 'Se insert un click al enlace con id ' . $id_enlace  : 'No pudo actualizar el click al enlace con id '. $id;				
			Util::log('Newsletter', 'extraerEnlace', $updatetmensaje);
		} 
		
		$enlace_contacto = new ns_enlaces_contacto;
		$enlace_contacto->id_enlace = $id_enlace;
		$enlace_contacto->id_contacto = $id_contacto;
		

		if( $id_contacto != "" ) {
			$id = $enlace_contacto->insert();

			$insertmensaje = ($id) ? 'Se insert enlace contacto ' : 'No pudo insertar el enlace contacto';				
			Util::log('Newsletter', 'extraerEnlace', $inserttmensaje);
		} 

		return $enlaces->enlace;
	}

    /**
 	 * Agrega los mensajes a la tabla que gestiona los correos
     *
	 * @param  String $string Identificador del enlace
	 * @return int retorna el enlace solicitado
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
    function adicionarMensajes($id_envio) {
	
	    global $db_options;
		global $mail_options;
		global $mail_from;
		global $mail_from_name; 
		global $dir_temp_cms;

		$ns_envios = new Ns_envios;
		$ns_envios->id_objeto = $id_envio;
		$ns_envios->find(true);
		
		$ns_newsletter = new Ns_newsletter;
		$ns_newsletter->id_objeto = $ns_envios->id_contenedor;
		$ns_newsletter->find(true);

		/* we use the db_options and mail_options here */
		$mail_queue =& new Mail_Queue($db_options, $mail_options);
		
		$path_news = NOMBRE_HOST . "html/sitio/";

        /* Version texto del email */		
		$text  = 'Si no puede observar el newsletter por favor copie o de clien a la siguiente direccin: ';
		$text .= $path_news . 'vistas/es_ES/news_'.$ns_envios->id_objeto.'.php';

		$file  = $_SERVER['DOCUMENT_ROOT']."/".$dir_temp_cms.'html/sitio/vistas/es_ES/news_'.$ns_envios->id_objeto.'.php';
		
		/* Version Html del email */
		$fp_ = fopen ($file,"r");
		if (!$fp_) {
				echo "<p>No se pudo leer el archivo.\n";
				exit();
		} else {
			$contenido = fread($fp_, filesize($file));
		}	
		fclose($fp_);
		
		//$html = $contenido;
		
		$crlf = "\n";
		
        /* Para adicionar un email a la cola */
		$from             = $mail_from;
		$from_name        = $mail_from_name;
		
		if( $from_name == '' )
		     $from_params = '<'.$from.'>';
	    else 	
		     $from_params = '"'.$from_name.'" <'.$from.'>';
		

		/* Put message to queue */
		$id_user = 1;
		$sec_to_send = 0;
		$delete_after_send=true;
		
		$lista_ = fachada_newsletter::cargarListas($id_envio);
		
        $cadena_a_reemplazar = "haga click aqu&iacute;";
		   
		foreach( $lista_  as $k => $emails ) {
			$id_user = $emails['id_contacto'];
			$to      = $emails['cnt_email'];

			$mime = new Mail_mime($crlf);
			
            $parametros      = "&id_usuario=".base64_encode($emails['id_contacto'])."&id_lista=".base64_encode($emails['id_categoria'])."&lista=".base64_encode($ns_newsletter->nombre)."&go=publico";
	        $url_desuscribir = NOMBRE_HOST ."/html/sitio/phrame.php?action=desuscribir_usuario".$parametros;
	        $cadena_a_poner  = 'haga click <a href="'.$url_desuscribir.'" class="desuscribir">aqu&iacute;</a>';		

            $html_ = str_replace($cadena_a_reemplazar,$cadena_a_poner,$contenido);
			$html  = str_replace("IDUSER",$emails['id_contacto'],$html_);
			
			$recipient        = $emails['cnt_email'];
			$recipient_name   = $emails['cnt_nombres'].' '.$emails['cnt_apellido1'];
			
			if( $recipient_name == '' )
			  $recipient_params = '<'.$recipient.'>';
			else  
			  $recipient_params = '"'.$recipient_name.'" <'.$recipient.'>';
			
			$hdrs = array( 'From'    => $from_params,
						   'To'      => $recipient_params,
						   'Subject' => $ns_envios->asunto  );

			$mime->setTXTBody($text);
			$mime->setHTMLBody($html);
			//$mime->addAttachment($file, 'text/plain');
			
			$body = $mime->get();
			$hdrs = $mime->headers($hdrs);		

			$mail_queue->put( $from, $recipient, $hdrs, $body, $sec_to_send, $delete_after_send, $id_user );
		}

		return $lista_;
	}

    /**
 	 * Crea un proceso at en la maquina para enviar el email a determinada hora
     *
	 * @param  int $id_envio Identificador del envio
	 * @param  int $id_news Identificador del news	 
	 * @return String retorna un mensaje
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function crearProcesoat($id_envio,$id_news) {
	
        /* Saco la fecha de envio */
		$ns_envios = new Ns_envios;
		$ns_envios->id_objeto = $id_envio;
		$ns_envios->find(true);

		$ns_envios->id_estado   = 3;
		
		$id = $ns_envios->update();
		
		$fecha_envio_real    = date("Y-m-d H:i:s", time() + 90 );
		$fecha_envio_entrada = $ns_envios->fecha_envio;
		
		list($fecha, $hora)                = split("[ ]", $fecha_envio_entrada);
		list($ano_, $mes_, $dia_)          = split("[-]",$fecha);
		list($hora_, $minutos_, $segundos) = split("[:]",$hora);

		$fecha_real    = mktime ( date("H"), date("i"), date("s"), date("m"), date("d"), date("Y"));
		$fecha_entrada = mktime ( $hora_, $minutos_, $segundos, $mes_, $dia_, $ano_);
		
		if( $fecha_entrada < $fecha_real ) {
		   $fecha_envio = $fecha_envio_real;

		   list($fecha, $hora)                = split("[ ]", $fecha_envio_real);
		   list($ano_, $mes_, $dia_)          = split("[-]",$fecha);
		   list($hora_, $minutos_, $segundos) = split("[:]",$hora);
		   
		} else {
		   $fecha_envio = $fecha_envio_entrada;
		}   		
		
	    /* Hora de envio para el comando at */
		$hora_at = $hora_.":".$minutos_." ".$mes_.$dia_.$ano_;

		/* Establesco el nombre del archivo que se corre para enviar los correos */
		$pagina_envio =  NOMBRE_HOST . "html/sitio/vistas/send_messages.php?id_envio=".$id_envio;

        /* Llama al Script que crear el proces at para correr la pgina que envia los emails.*/
		$comando = "/usr/bin/sudo /root/admin/Hosting/admin/correr_at_hosting  " . urlencode($pagina_envio). " " .$hora_at. " 2>&1 ";
		
		/* Se corre el comando */
		exec ($comando, $salida, $error);
	
		$retorno = (!$error) ? 'Se program el envo para la fecha ' . $fecha_envio  : 'No pudo programar el envio para  '. $fecha_envio . ' Salida ' .join("\n", $salida).' '.$error;				
		Util::log('Newsletter', 'crearProcesoat', $retorno);		
		
		$_SESSION['mensaje_envio'] = $retorno;
	}

    /**
 	 * Envia los mensajes que se han encolado en la tabla ns_mail_queue
     *
	 * @param  int $id_envio Identificador del envio
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function sendMessages($id_envio) {
	
	    global $db_options;
		global $mail_options;
		
		$lista__ = fachada_newsletter::adicionarMensajes($id_envio);
		
		sleep(1);
		
		/* Cuantos emails pueden ser enviados cada vez que el script es llamado */
		$max_amount_mails = count($lista__);
		
		/* Se usa el db_options and mail_options para configurar otra vez  */
		$mail_queue =& new Mail_Queue($db_options, $mail_options);
		
		/* Enviando los mensajes */
		$retry = 2;
		
		$mail_queue->setBufferSize(50);
		
		$correos_enviados= 0;
		
		while ( $mail = $mail_queue->get() ) {

			$result = $mail_queue->sendMail($mail);
			
				if (!PEAR::isError($result)) {
					$mail_queue->deleteMail($mail->getId());
				}
				
				$correos_enviados++;
				// Tiempo de espera de envio entre emails 
				sleep(3);
		}

		/* Actualizo el nmero de correos enviados */
		$ns_envios = new Ns_envios;
		$ns_envios->id_objeto = $id_envio;
		$ns_envios->find(true);
		
		$ns_envios->num_envios += $correos_enviados;
		$ns_envios->id_estado   = 4;
		
		$id = $ns_envios->update();
	}
	
    /**
 	 * Detecta el sistema operativo, usado para las estadsticas del newsletter
	 * @param  int $var Sistema operativo
	 * @param  int $var2 Sistema operativo desconocido
	 * @return String $temp 
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function os_detection($var,$var2){
	
		if (preg_match("/windows nt 5.1/i",$var)) $temp = 'Windows XP';
		elseif (preg_match("/windows xp/i",$var)) $temp = 'Windows XP';
		elseif (preg_match("/linux/i",$var)) $temp = 'Linux';
		elseif (preg_match("/macintosh/i",$var)) $temp = 'Macintosh';
		elseif (preg_match("/win 9x 4.90/i",$var)) $temp = 'Windows Me';
		elseif (preg_match("/windows me/i",$var)) $temp = 'Windows Me';
		elseif (preg_match("/windows nt 5.0/i",$var)) $temp = 'Windows 2000';
		elseif (preg_match("/windows 2000/i",$var)) $temp = 'Windows 2000';
		elseif (preg_match("/windows nt 3.1/i",$var)) $temp = 'Windows 3.1';
		elseif (preg_match("/windows nt 3.5.0/i",$var)) $temp = 'Windows NT 3.5';
		elseif (preg_match("/windows nt 3.5.1/i",$var)) $temp = 'Windows NT 3.5.1';
		elseif (preg_match("/windows nt 4.0/i",$var)) $temp = 'Windows NT 4.0';
		elseif (preg_match("/windows 98/i",$var)) $temp = 'Windows 98';
		elseif (preg_match("/windows 95/i",$var)) $temp = 'Windows 95';
		elseif (preg_match("/sunos/i",$var)) $temp = 'SunOS';
		else $temp = $var2;
	
		return $temp;
	}
	
    /**
 	 * Detecta la version de navegador, usado para las estadsticas del newsletter
	 * @param  int $var Navegador
	 * @param  int $var2 Navegador desconocido
	 * @return String $temp 
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function browser_detection($var,$var2) {
		if (preg_match("/Opera/i",$var)) $temp = 'Opera';
		elseif (preg_match("/MSIE 6/i",$var)) $temp = 'Internet Explorer 6';
		elseif (preg_match("/MSIE 5.5/i",$var)) $temp = 'Internet Explorer 5.5';
		elseif (preg_match("/MSIE 5.0/i",$var)) $temp = 'Internet Explorer 5';
		elseif (preg_match("/MSIE 4/i",$var)) $temp = 'Internet Explorer 4';
		elseif (preg_match("/Netscape\/7.0/i",$var)) $temp = 'Netscape 7';
		elseif (preg_match("/Mozilla\/5.0/i",$var)) $temp = 'Netscape 6';
		elseif (preg_match("/Mozilla\/4.7/i",$var)) $temp = 'Netscape 4.7';
		elseif (preg_match("/Mozilla\/4.6/i",$var)) $temp = 'Netscape 4.6';
		elseif (preg_match("/Mozilla\/4.5/i",$var)) $temp = 'Netscape 4.5';
		elseif (preg_match("/rv:1.4/i",$var)) $temp = 'Mozilla 1.4';
		elseif (preg_match("/rv:1.5a/i",$var)) $temp = 'Mozilla 1.5a';
		elseif (preg_match("/rv:1.5/i",$var)) $temp = 'Mozilla 1.5';
		elseif (preg_match("/Galeon/i",$var)) $temp = 'Galeon';
		elseif (preg_match("/Konqueror/i",$var)) $temp = 'Konqueror';
		else $temp = $var2;
	
		return $temp;
	}
	
    /**
 	 * Muestra una tabla con determinadas estadsticas 
	 * @param  string $stadistik_name nombre de la estadistica
	 * @param  string $stadistik_db datos de la estadistica	 
	 * @param  string $order ordenamiento de la estadistica	 
	 * @param  int $width_key ancho de la tabla de la estadistica	 
	 * @param  int $count_elements cantidad de elementos 
	 * @param  int $var2 Navegador desconocido
	 * @return String $contenido_HTML retorna el html de la tabla de estadisticas 
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	 function statistik_display ( $statistik_name , $statistik_db , $order , $width_key , $count_elements ) {
	    /* Ordenamiento */
		if ( $order == "ksort" )
		 ksort ( $statistik_db );
	
		if ( $order == "krsort" )
		 krsort ( $statistik_db );
	
		if ( $order == "arsort" )
		 arsort ( $statistik_db );
	
		if ( $order == "asort" )
		 asort ( $statistik_db );
	
		if ( $order == "rsort" )
		 rsort ( $statistik_db );

		/* Template de la tabla de estadsticas */
		$template_tabla_estadistica = PATH_NEWSLETTER . "vistas/templates/tpl_tabla_estadisticas.php";	
		
		$contenido_HTML = "";
		include($template_tabla_estadistica);
		
		return $contenido_HTML;
	 }
		
    /**
 	 * Muestra una pgina con las estadsticas de un envo
	 * @param  int $id_envio Identificador del envio
	 * @return String $table contenido_HTML retorna el html de la tabla de estadisticas 
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
     function ver_estadisticas($id_envio){
	    global $country_array;
		global $dir_temp_cms;

		// Variables usadas para las estadsticas 
		$database_files = array();

		$hour 			 = array ();
		$day 			 = array ();
		$weekday 		 = array ();
		$month 			 = array ();
		$year 			 = array ();

		$hostname_kurz   = array ();

		$browser 		 = array();
		$browser_long 	 = array();

		$os 			 = array();
		$os_long 		 = array();

		$siteorder 		 = array();
		$siteorder_array = array();
		
		$last_time 		 = array ();
		$last_hostname   = array ();
		$last_browser    = array ();
		$last_site       = array ();
		$last_counter    = 0;

		$referer 		 = array();

		$site 			 = array();

		$domain 		 = array();

		$first_visitor_counter = 0;

		$daysago 		 = array ();
		$referer_daysago = array ();

		$allarray 		 = array ();
		$ip_allarray 	 = array ();

		$sort_hlp_db     = array ();

		$search_words    = array ();

		$search_engines  = array ();

		$temp = 0;
	 
        /* Se lee el archivo de configuracin para las estadsticas */
		$archivoConfigE = $_SERVER['DOCUMENT_ROOT']."/".$dir_temp_cms."config/newsstat.cfg";
	 
		 $datei = fopen( $archivoConfigE , "r" );
		
		  while ( !FEOF($datei) ) {
			   $data_array_stat = fgetcsv ( $datei , 4096 , "=" );
		
			   if ( ( isset ( $data_array_stat[0] ) ) && ( !empty ( $data_array_stat[0] ) ) )
				$$data_array_stat[0] = $data_array_stat [1];
		  }
			 
		fclose($datei);
		unset($datei);	 

		$directory = $_SERVER['DOCUMENT_ROOT']."/".$dir_temp_cms."tmp/newsstats/".$id_envio."/logdb.dta";
         /* Se abre el archivo con las estadisticas */  
	     $datei = fopen( $directory , "r" );

		  while ( !feof($datei) && sizeof(file($directory)) )
		   {
			 $data_array_database = fgetcsv ( $datei , filesize($directory) , "*" );
          
	            /* Se ponen los hits en un arreglo */
				$last_time[$last_counter] = $data_array_database[0];
				$last_hostname[$last_counter] = $data_array_database[2];
				$last_browser[$last_counter] = $data_array_database[3];
				$last_site[$last_counter] = $data_array_database[4];
				//$id_envio[$last_counter] = $data_array_database[5];				
				//$id_contacto[$last_counter] = $data_array_database[6];
					
				$last_counter++;
			 
	         /* Obtiene el primer visitante */
			 if ( $first_visitor_counter == 0 )
				  {
					$first_visitor=$data_array_database[0];
					$first_visitor_counter=1;
				  }
	
			 /* Pone los dias en un arreglo */
				$wochentage = array (
					  "Monday"=>$weekday1,
					  "Tuesday"=>$weekday2,
					  "Wednesday"=>$weekday3,
					  "Thursday"=>$weekday4,
					  "Friday"=>$weekday5,
					  "Saturday"=>$weekday6,
					  "Sunday"=>$weekday7
				 );
	
			   $wochentag = date ( "l" , $data_array_database[0] );
	
			   if ( array_key_exists ( $wochentag , $wochentage ) )
						 $wochentag = $wochentage [ $wochentag ];
	
			   $domain_temp = explode ( "." , $data_array_database[2] );
	
			   $hostname_temp = $domain_temp;
	
			   $domain_temp = strtolower ( $domain_temp [ count( $domain_temp )-1 ] );
	
			   if ( array_key_exists ( $domain_temp, $country_array ) )
				{
				 $domain_temp  = $country_array [ $domain_temp ];
				 $hostname_temp = strtolower ( $hostname_temp [ count( $hostname_temp )-2 ].".".$hostname_temp [ count( $hostname_temp )-1] );
				}
			   else
				{
				 $domain_temp = $unknown;
				 $hostname_temp = $unknown;
				}
	
				$os_temp = fachada_newsletter::os_detection ( $data_array_database[3] , $unknown );
	
				$browser_temp = fachada_newsletter::browser_detection ( $data_array_database[3] , $unknown );
	
			  if ( ( array_key_exists ( date( "dHmY" , $data_array_database[0] ) , $allarray ) ) && ( array_key_exists ( $data_array_database[1] , $ip_allarray ) ) )
			   $temp = 0;
			  else
			   {
	
				if  ( array_key_exists ( date( $date_format , $data_array_database[0] ) , $daysago ) )
				  {
	
				   if ( $data_array_database[0] > ( date ( "U" , mktime ( 0,0,0, date ( "m" ) -1 , date ( "d" ) , date ( "Y" ) ) ) ) )
					{
					  $daysago [ date( $date_format , $data_array_database[0] ) ] = $daysago [ date( $date_format , $data_array_database[0] ) ] + 1;
	
					   if ( !empty ( $data_array_database [ 5 ] ) && ( substr ( $data_array_database [ 5 ], 0 , strlen ( $exceptiondomain ) ) != $exceptiondomain ) )
						{
	
						 if ( strlen ( $data_array_database [ 5 ] ) > 90 )
						  $referer_temp = substr ( $data_array_database [ 5 ] , 0 , 90 );
						 else
						  $referer_temp = $data_array_database [ 5 ];
	
						  if ( array_key_exists ( $referer_temp, $referer_daysago ) )
						   $referer_daysago [ $referer_temp ] = $referer_daysago [ $referer_temp ] + 1;
						}
					}
	
				  }
				else
				  {
					if ( $data_array_database[0] > ( date ( "U" , mktime ( 0,0,0, date ( "m" ) -1 , date ( "d" ) , date ( "Y" ) ) ) ) )
					 {
	
					  $daysago [ date( $date_format , $data_array_database[0] ) ] = 1;
	
						 if ( !empty ( $data_array_database [ 5 ] ) && ( substr ( $data_array_database [ 5 ], 0 , strlen ( $exceptiondomain ) ) != $exceptiondomain ) )
						 {
	
						  if ( strlen ( $data_array_database [ 5 ] ) > 90 )
							$referer_temp = substr ( $data_array_database [ 5 ] , 0 , 90 );
						   else
							$referer_temp = $data_array_database [ 5 ];
	
						  $referer_daysago [ $referer_temp ] = 1;
						 }
					 }
				  }
	
				 if  ( array_key_exists ( date( "H." , $data_array_database[0] ) , $hour ) )
				  $hour [ date( "H." , $data_array_database[0] ) ] = $hour [ date( "H." , $data_array_database[0] ) ] + 1;
				 else
				  $hour [ date( "H." , $data_array_database[0] ) ] = 1;
	
	
				 if  ( array_key_exists ( date( "m/Y" , $data_array_database[0] ) , $month ) )
				  $month [ date( "m/Y" , $data_array_database[0] ) ] = $month [ date( "m/Y" , $data_array_database[0] ) ] + 1;
				 else
				  $month [ date( "m/Y" , $data_array_database[0] ) ] = 1;
	
	
				 if  ( array_key_exists ( date( "Y" , $data_array_database[0] ) , $year ) )
				  $year [ date( "Y" , $data_array_database[0] ) ] = $year [ date( "Y" , $data_array_database[0] ) ] + 1;
				 else
				  $year [ date( "Y" , $data_array_database[0] ) ] = 1;
	
	
				 if  ( array_key_exists ( $wochentag , $weekday ) )
				  $weekday [ $wochentag ] = $weekday [ $wochentag ] + 1;
				 else
				  $weekday [ $wochentag ] = 1;
	
				 if ( array_key_exists ( $browser_temp , $browser ) )
				  $browser [ $browser_temp ] = $browser [ $browser_temp ] + 1;
				 else
				  $browser [ $browser_temp ] = 1;
	
				 if ( array_key_exists ( $os_temp , $os ) )
				  $os [ $os_temp ] = $os [ $os_temp ] + 1;
				 else
				  $os [ $os_temp ] = 1;
	
				 if ( array_key_exists ( $domain_temp , $domain ) )
				  $domain [ $domain_temp ] = $domain [ $domain_temp ] + 1;
				 else
				  $domain [ $domain_temp ] = 1;
	
				 if  ( array_key_exists ( date( "d." , $data_array_database[0] ) , $day ) )
				  $day [ date( "d." , $data_array_database[0] ) ] = $day [ date( "d." , $data_array_database[0] ) ] + 1;
				 else
				  $day [ date( "d." , $data_array_database[0] ) ] = 1;
	
				 if ( array_key_exists ( $hostname_temp , $hostname_kurz ) )
				  $hostname_kurz [ $hostname_temp ] = $hostname_kurz [ $hostname_temp ] + 1;
				 else
				  $hostname_kurz [ $hostname_temp ] = 1;
	
				 if ( array_key_exists ( $data_array_database [ 1 ] , $siteorder ) )
				  {
					if ( substr ( strrchr ( $siteorder [ $data_array_database [ 1 ] ] , "+" ) , 1 ) == $data_array_database [ 4 ] )
					 { }
					else
					 $siteorder [ $data_array_database [ 1 ] ] = $siteorder [ $data_array_database [ 1 ] ]."+".$data_array_database [ 4 ];
				  }
				 else
				  {
				   $siteorder [ $data_array_database [ 1 ] ] = $data_array_database [ 4 ];
				  }
	
				$ip_allarray [ $data_array_database[1] ] = 1;
				$temper = date( "dHmY" , $data_array_database[0] );
				$allarray [ $temper ] = 1;
	
			   }
	
	           /* Pone los sitios en un arreglo */
				  $site_temp = $data_array_database [ 4 ];
	
				  if ( array_key_exists ( $site_temp, $site ) )
				   $site [ $site_temp ] = $site [ $site_temp ] + 1;
				  else
				   $site [ $site_temp ] = 1;
	
	
	           /* Pone los referers en un arreglo */
		  if ( !empty ( $data_array_database [ 5 ] ) && ( substr ( $data_array_database [ 5 ], 0 , strlen ( $exceptiondomain ) ) != $exceptiondomain ) )
				{
				  $referer_temp = $data_array_database [ 5 ];
	
					parse_str ( str_replace ( "?","&","___url_http_referer=".$referer_temp ) , $vars );
	
					$searchengine = "";
	
					$altterms = "";
	
					if ( !array_key_exists ( "q" , $vars) )
					 $vars [ "q" ] = "";
					if ( !array_key_exists ( "p" , $vars) )
					 $vars [ "p" ] = "";
					if ( !array_key_exists ( "query" , $vars) )
					 $vars [ "query" ] = "";
					if ( !array_key_exists ( "search" , $vars) )
					 $vars [ "search" ] = "";
					if ( !array_key_exists ( "Keywords" , $vars) )
					 $vars [ "Keywords" ] = "";
					if ( !array_key_exists ( "ask" , $vars) )
					 $vars [ "ask" ] = "";
					if ( !array_key_exists ( "qkw" , $vars) )
					 $vars [ "qkw" ] = "";
					if ( !array_key_exists ( "searchfor" , $vars) )
					 $vars [ "searchfor" ] = "";
					if ( !array_key_exists ( "terms" , $vars) )
					 $vars [ "terms" ] = "";
	
					if ( preg_match ("/http.+google\..+\/.+/",$vars["___url_http_referer"] ) )
					 { $searchengine = "Google"; $terms = $vars [ "q" ]; }
	
					if ( preg_match ("/http.+altavista\..+\/.+/",$vars["___url_http_referer"] ) )
					 { $searchengine = "Altavista"; $terms = $vars["q"]; }
	
					if ( preg_match ("/http.+wisenut\..+\/.+/",$vars["___url_http_referer"] ) )
					 { $searchengine = "WiseNet"; $terms = $vars["q"];   }
	
					if ( preg_match ("/http.+alltheweb\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "AllTheWeb"; $terms = $vars["q"]; }
	
					if ( preg_match ("/http.+\.yahoo\..+\/.+/",$vars["___url_http_referer"] ) )
					 { $searchengine = "Yahoo"; $terms = $vars["p"]; }
	
					if ( preg_match ("/http.+\.aol\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "AOL"; $terms = $vars["query"]; }
	
					if ( preg_match ("/http.+netscape\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "Netscape"; $terms = $vars["query"]; }
	
					if ( preg_match ("/http.+\.lycos\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "Lycos"; $terms = $vars["query"]; }
	
					if ( preg_match ("/http.+\.teoma\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "Teoma"; $terms = $vars["query"]; }
	
					if ( preg_match ("/http.+\.dmoz\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "dmoz"; $terms = $vars["search"]; }
	
					if ( preg_match ("/http.+\.overture\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "Overture"; $terms = $vars["Keywords"]; }
	
					if ( preg_match ("/http.+\.ask\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "AskJeeves"; $terms = $vars["ask"]; }
	
					if ( preg_match ("/http.+\.about\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "About"; $terms = $vars["terms"]; }
	
					if ( preg_match ("/http.+\.looksmart\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "LookSmart"; $terms = $vars["key"]; }
	
					if ( preg_match ("/http.+\.excite\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "Excite"; $terms = $vars["qkw"]; }
	
					if ( preg_match ("/http.+\.iwon\.com.+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "IWon"; $terms = $vars["searchfor"]; }
	
					if ( preg_match ("/http.+\.webcrawler\.com.+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "WebCrawler"; $terms = $vars["qkw"]; }
	
					if ( preg_match("/http.+\.msn\..+\/.+/",$vars["___url_http_referer"]) )
					 { $searchengine = "MSN"; $terms = $vars["q"]; $altterms = $vars["origq"]; }
	
					if ( $searchengine )
					 {
					   $message = $searchengine;
					   $termarray=preg_split("/ /",$terms);
	
					   $search_words_temp = "[";
	
					   while ( list ( $key , $value ) = each ( $termarray ) )
					   {
						 $message.= " [".$value."]";
						 $search_words_temp.= $value." ";
					   }
	
						if( $altterms )
						 {
						   $termarray = preg_split("/ /",$altterms );
	
						   while ( list  ($key , $value) = each ( $termarray ) )
							{
							  $message.= " [".$value."]";
							  $search_words_temp.= $value." ";
							}
	
						 }
	
					  $search_words_temp.= "]";
	
					}
				   else
					{
	
					 $message = $data_array_database [ 5 ];
	
					   if ( ( strpos ( $message , "216.239.37.104" ) > -1 ) ||
						  ( strpos ( $message , "216.239.39.104" ) > -1 ) )
						   $message = "google translator";
	
					   if ( strpos ( $message , "topsitelists.com" ) > -1 )
						$message = "topsitelists.com";
	
					   if ( strlen ( $message ) > 90 )
						$message = substr ( $message , 0 , 90 );
	
					}
	
				 if ( ( !empty ( $searchengine ) ) && ( $searchengine != "" ) )
				  {
					if ( array_key_exists ( $searchengine , $search_engines ) )
					 $search_engines [ $searchengine ] = $search_engines [ $searchengine ] + 1;
					else
					 $search_engines [ $searchengine ] = 1;
	
					if ( array_key_exists ( $search_words_temp , $search_words ) )
					 $search_words [ $search_words_temp ] = $search_words [ $search_words_temp ] + 1;
					else
					 $search_words [ $search_words_temp ] = 1;
	
				  }
	
				  if ( array_key_exists ( $message , $referer ) )
				   $referer [ $message ] = $referer [ $message ] + 1;
				  else
				   $referer [ $message ] = 1;
	
			  }
		   }
	
		fclose ( $datei );
		
		/* Ordena los das de la semana */
		if ( !array_key_exists ( $weekday1 , $weekday ) )
		  $weekday [ $weekday1 ] = 0;
		 if ( !array_key_exists ( $weekday2 , $weekday ) )
		  $weekday [ $weekday2 ] = 0;
		 if ( !array_key_exists ( $weekday3 , $weekday ) )
		  $weekday [ $weekday3 ] = 0;
		 if ( !array_key_exists ( $weekday4 , $weekday ) )
		  $weekday [ $weekday4 ] = 0;
		 if ( !array_key_exists ( $weekday5 , $weekday ) )
		  $weekday [ $weekday5 ] = 0;
		 if ( !array_key_exists ( $weekday6 , $weekday ) )
		  $weekday [ $weekday6 ] = 0;
		 if ( !array_key_exists ( $weekday7 , $weekday ) )
		  $weekday [ $weekday7 ] = 0;
		
		 $sort_hlp_db = array ( $weekday1 => $weekday [ $weekday1 ],
								$weekday2 => $weekday [ $weekday2 ],
								$weekday3 => $weekday [ $weekday3 ],
								$weekday4 => $weekday [ $weekday4 ],
								$weekday5 => $weekday [ $weekday5 ],
								$weekday6 => $weekday [ $weekday6 ],
								$weekday7 => $weekday [ $weekday7 ]
							   );
	
		    $weekday = $sort_hlp_db;
	
			foreach ( $siteorder as $var1 ) {
			   if ( array_key_exists ( $var1 , $siteorder_array ) )
				$siteorder_array [ $var1 ] = $siteorder_array [ $var1 ] + 1;
			   else
				$siteorder_array [ $var1 ] = 1;
			}
			 
			$i = ( count ( $last_time ) -1 ) - $lasthits;
			/* Saco el browser y el navegador para la tabla ltimos hits */
			for ( $i ; $i < ( count ( $last_time ) -1 ) ; $i++ ) {
			   if ( !empty ( $last_browser[$i] ) ) {
				  $_SESSION['os_temp'][$i]      = fachada_newsletter::os_detection($last_browser[$i],$unknown);
			
				  $_SESSION['browser_temp'][$i] = fachada_newsletter::browser_detection($last_browser[$i],$unknown);
				}
			} 
			 
			/* Se extraen las estadsticas de la cantidad de correos enviados */           
            $envios = new Ns_envios;
			$envios->id_objeto = $id_envio;
			$envios->find(true);
			
			$envios->toArray();
			
			$num_envios = $envios->num_envios;
			
			/* Template de los ultimos hits */
			$template_lasthits = PATH_NEWSLETTER . "vistas/templates/tpl_tabla_estad_lasthits.php";	
			
			include($template_lasthits);
			
			$table = $contenido_HTML;

			/* Se extraen las estadsticas de los enlaces */           
            $estad_enlaces = new Ns_enlaces;
			$estad_enlaces->id_envio = $id_envio;

			$estad_enlaces->find();
			$result_enlaces = array();
			while ($estad_enlaces->fetch()) 
				array_push($result_enlaces, $estad_enlaces->toArray());
				
			/* Template de los clicks */
			$template_clicks = PATH_NEWSLETTER . "vistas/templates/tpl_tabla_estad_clicks.php";	
			
			include($template_clicks);
			
			$table .= $contenido_HTML;

            /* Se sacan las tablas de las estadisticas */  
			 for ( $i = 1 ; $i <= 16 ; $i++ ) {
			
				 $temp_stat  = "stat".$i;
				 $temp_name  = "namestat".$i;
				 $temp_sort  = "sort".$i;
				 $temp_count = "countstat".$i;
			
				if ( $$temp_stat == "country" )          $table .= fachada_newsletter::statistik_display ( $$temp_name , $domain , $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "provider" )         $table .= fachada_newsletter::statistik_display ( $$temp_name , $hostname_kurz , $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "sites" )            $table .= fachada_newsletter::statistik_display ( $$temp_name , $site , $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "browser" )          $table .= fachada_newsletter::statistik_display ( $$temp_name , $browser , $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "os" )               $table .= fachada_newsletter::statistik_display ( $$temp_name , $os , $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "referer" )          $table .= fachada_newsletter::statistik_display ( $$temp_name , $referer , $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "month" )            $table .= fachada_newsletter::statistik_display ( $$temp_name , $month ,  $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "day" )              $table .= fachada_newsletter::statistik_display ( $$temp_name , $day ,  $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "hour" )             $table .= fachada_newsletter::statistik_display ( $$temp_name , $hour , $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "weekday" )          $table .= fachada_newsletter::statistik_display ( $$temp_name , $weekday , $$temp_sort , 710 , $$temp_count );
				/* if ( $$temp_stat == "order" )            $table .= fachada_newsletter::statistik_display ( $$temp_name , $siteorder_array , $$temp_sort , 710 , $$temp_count ); */
				if ( $$temp_stat == "year" )             $table .= fachada_newsletter::statistik_display ( $$temp_name , $year ,  $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "lastdays" )         $table .= fachada_newsletter::statistik_display ( $$temp_name , $daysago ,  $$temp_sort , 710 , $$temp_count );
				if ( $$temp_stat == "referer_lastdays" ) $table .= fachada_newsletter::statistik_display ( $$temp_name , $referer_daysago ,  $$temp_sort , 710 , $$temp_count );
				/* if ( $$temp_stat == "searchwords" )      $table .= fachada_newsletter::statistik_display ( $$temp_name , $search_words ,  $$temp_sort , 710 , $$temp_count);
				if ( $$temp_stat == "searchengines" )    $table .= fachada_newsletter::statistik_display ( $$temp_name , $search_engines ,  $$temp_sort , 710 , $$temp_count); */
			  }	 
			  
			  return $_SESSION['tabla'] = $table;
	 }
	
    /**
 	 * Carga el listado de clicks por Contacto de un determinado envo
     *
	 * @param  Int $id_envio Identificador del envio
	 * @return Array $links Retorna un arreglo con los contactos para envio del envio.
	 * @author  Fernando Rengifo
     * @access  public
	 * @static
     */  
	function listaEnlacescontactos($id_envio,$from) {
	
		$contactos       = new Sis_contactos;
		$enlace_contacto = new ns_enlaces_contacto;
		$enlaces         = new ns_enlaces; 
		
		$enlace_contacto->whereAdd("ns_enlaces.id_envio = '". $id_envio . "'");
		$enlace_contacto->joinAdd($contactos);
		$enlace_contacto->joinAdd($enlaces);		
		$enlace_contacto->selectAs();
		$enlace_contacto->selectAs(array('email','nombres','apellido1'), 'cnt_%s', 'sis_contactos');
		$enlace_contacto->selectAs(array('enlace'), 'enl_%s', 'ns_enlaces');
		$enlace_contacto->selectAdd("count(ns_enlaces_contacto.id_enlace) as cuantos");		
		$enlace_contacto->keys('id_contacto');
		$enlace_contacto->groupBy('ns_enlaces_contacto.id_enlace,ns_enlaces_contacto.id_contacto,sis_contactos.email,sis_contactos.nombres  , sis_contactos.apellido1 , ns_enlaces.enlace');
		
		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0;
		$data = DB_Pager::getData($from, NUM_REGISTROS, $enlace_contacto->count(), MAXPAGES);

		$enlace_contacto->limit($from, NUM_REGISTROS);

	    $enlace_contacto->orderBy('nombres, apellido1 ASC');
		$enlace_contacto->find();
		
		$lista_enlacescontactos = array();
		while($enlace_contacto->fetch()) {
		     array_push($lista_enlacescontactos,$enlace_contacto->toArray());
		}

		return array('contacto'=>$lista_enlacescontactos,'data'=>$data);
	}
	
	/*
	 * Pedir confirmacin.
	 *
	 * @param int $id_contacto Identificador del contacto al que se le envia el mail.
	 * @return int Identificador de contacto del usuario
	 */
	function pedirConfirmacion($id_contacto, $id_categoria)
	{ 
			global $mail_from;
	
			$contacto = new Sis_contactos;
			$contacto->get($id_contacto);
	   
			$url_confirmacion = NOMBRE_HOST . 'html/sitio/phrame.php?action=confirmar_registro&contacto=' . md5($id_contacto)."&idc=".$id_categoria;
			$template_confirmacion = PATH_NEWSLETTER . 'vistas/templates/tpl_email_confirmacion.php';
			$contenido = addslashes(implode("\n", file($template_confirmacion)));
			eval("\$texto = \"$contenido\"; ");
			$text = stripslashes($texto);
	  
			$headers['From']    = $mail_from;
			$headers['Subject'] = 'Confirmacion de registro de Distrimas.com';
			$headers['To'] = $contacto->email;
			
			// Create the mail object using the Mail::factory method
			$mail_object =& Mail::factory('mail', $params);
	 
			$mail_object->send($contacto->email, $headers, $text);
	}	
	
	/*
	 * Verificar registro
	 * 
	 * @param string $id_contacto Identificador del contacto que confirma.
	 * @static
	 */
	 function verificarConfirmacion($id_contacto)
	 {
			$contacto = new Sis_contactos;
	        $contacto->whereAdd("MD5(id_contacto) = '$id_contacto'");
            $contacto->find(true);
			
			$id_contacto = $contacto->id_contacto;			
			
			return $id_contacto;
	 }	
	 
	/*
	 * Borrar recursivamente un directorio de estadsticas cuando se borra un envo
	 * 
	 * @param string $dir Ruta del directorio a borrar 
	 * @static
	 */
	function deldir($dir)
	{
	  if (is_dir($dir)) {
		  $handle = @opendir($dir);
		  while (false!==($FolderOrFile = @readdir($handle)))
		  {
			 if($FolderOrFile != "." && $FolderOrFile != "..") 
			 {  
			   if(is_dir("$dir/$FolderOrFile")) { 
				 fachada_newsletter::deldir("$dir/$FolderOrFile"); 
			   }  // recursivo
			   else {
				 unlink("$dir/$FolderOrFile"); 
			   }
			 }  
		  }
		  @closedir($handle);
		  
		  /* Borra el directorio */
		  if( @rmdir($dir)) { 
			$success = true; 
		  } else {
			$success = false;
		  }
		  
		  return $success;  
	  } else { // Si el directorio no existe
	      $nodir = 5; 
		  
	      return $nodir;
	  }	  
	}	 
}

?>