<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |   	      Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//

/**
 * Generador de Newsletter
 * Esta clase genera los archivos para el envio de un boletn por correo
 *
 * @package  Newsletter
 * @version  1.0
 * @author   Fernando Rengifo<frengifo@telesat.com.co>
 * @since    PHP 4.1.2
 */
class Generador_Newsletter
{ 
	/**
 	 * Genera los archivos planos de HTML para el newsletter solicitado
	 *
     * @param  int $id_sitio sitio que contiene al articulo a generar
	 *         string $path_sitio nombre del directorio donde esta el sitio
	 *         objeto $idioma Objeto idioma en el cual se generar el articulo
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */   
	function generar_newsletter($id_articulo,$id_news)
	{
		$path_sitio = "html/" . $_SESSION['sitio']['url'] . "/vistas/" . $_SESSION['sis_idioma']['enctype'];
		$path_estilos = "html/" . $_SESSION['sitio']['url'] . "/";		
		$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		
		$path_news = NOMBRE_HOST . "html/" . $_SESSION['sitio']['url'] . "/images/";
		$path_stat = NOMBRE_HOST . "html/sitio/vistas/pixel.php?ie=".$id_articulo."&iu=IDUSER";
	
		$articulo = new Art_articulos;
		$articulo_version = new Art_articulos_versiones;
		
		$template_cabezote = PATH_NEWSLETTER . "vistas/templates/". $id_news ."/tpl_cabezote_newsletter.html";
		$template_pie      = PATH_NEWSLETTER . "vistas/templates/". $id_news ."/tpl_pie_newsletter.html";
		
		$articulo->get($id_articulo);
		$articulo_version->setid_idioma($id_idioma);
		$articulo_version->setid_objeto($id_articulo);
		if (!$articulo_version->find(true))
			Fachada_Sistema::crear_version(&$articulo_version, $id_idioma);
	
		$archivo_articulo = $path_sitio . "/news_" . $articulo->id_objeto . '.php'; 
		//echo $archivo_articulo;
		$articulo_version->id_objeto = $id_articulo;
		$articulo_version->id_idioma = $id_idioma;
				
		// Se escribe la cabecera del portal
		$vista = "vistas/" . $_SESSION['sis_idioma']['enctype'];
		
		// Cuando se vaya a ver el articulo verificar permisos para verlo
		$include_head = "";
		$art_obj = new Art_articulos;
		$art_obj->get($id_articulo);
		
		$ns_envios = new Ns_envios;
		$ns_envios->id_objeto = $id_articulo;
		$ns_envios->find(true);
		
		list($ano,$mes,$dia) = split("[-]",$ns_envios->fecha_boletin);  
		setlocale (LC_TIME, 'es_ES');
		$mes_fecha_boletin =  strftime('%B', mktime(0,0,0,$mes,$dia,$ano));
		$dia_fecha_boletin =  (int) strftime('%d', mktime(0,0,0,$mes,$dia,$ano));
		$ano_fecha_boletin =  strftime('%Y', mktime(0,0,0,$mes,$dia,$ano));

		$include_head = $path_sitio.'/'. $id_news .'/head_public_news.php';
		
		include($include_head); 
		File::writeLine($archivo_articulo, $contenido_HTML, FILE_MODE_WRITE);
				
			// Se escribe el contenido del articulo
		$contenido_articulo = addslashes(implode("\n",file($template_cabezote))); 
			
		eval("\$contenido_HTML = \"$contenido_articulo\"; ");
		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));
		// Traer los bloques del articulo
		$bloques_array = array();
		$bloques = new Art_bloques;
		$articulo->id_objeto = $id_articulo;
		$bloques->joinAdd($articulo);
		$bloques->selectAs();
		$bloques->find(); 
			
		while ($bloques->fetch()) 
			$bloques_array[$bloques->posicion] = array('id_bloque' => $bloques->id_objeto, 'tipo' => $bloques->tipo);	
		// se ordenan los bloques por posicion
		ksort($bloques_array); 
		reset($bloques_array);
		
		// Se escriben el contenido de los bloques
		foreach ($bloques_array as $k => $v) { 
			Generador_newsletter::generar_bloque_news($v['tipo'],$v['id_bloque'], $path_sitio, $archivo_articulo, $id_idioma, $id_articulo, $id_news);		
		}
		
		$contenido_articulo = addslashes(implode("\n",file($template_pie))); 
		
		eval("\$contenido_HTML = \"$contenido_articulo\"; ");
		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));
		
		// Se escribe el pie del portal
		$include_foot = $path_sitio.'/'. $id_news .'/foot_public_news.php';
		$contenido_foot = implode("\n",file($include_foot));
		File::writeLine($archivo_articulo, $contenido_foot);
		File::close($archivo_articulo,FILE_MODE_WRITE);
	}
	
	/**
 	 * Genera los archivos planos de HTML para el bloque tipo TEXTO_FOTO
	 *
     * @param   int $id_bloque Identificador del bloque a generar
	 * @param   string $path_sitio nombre del directorio donde esta el sitio
	 * @param   string $archivo_articulo nombre del archivo del articulo
	 * @author  John Vargas
     * @access  public
     */   
	function generar_bloque_news($tipo_bloque, $id_bloque, $path_sitio, $archivo_articulo, $id_idioma, $id_envio, $id_news)
	{ 
   		$path_news = NOMBRE_HOST . "html/" . $_SESSION['sitio']['url'] . "/images/";
		$path_imagenes = NOMBRE_HOST."imagenes_cont/sitio/articulos/"; 
		
		$template_bloque = PATH_NEWSLETTER . "vistas/templates/". $id_news . "/tpl_categoria_".$tipo_bloque."_newsletter.html";		
		
	    $C_bloque = "Art_bloques_".$tipo_bloque."s";
		
		$ns_bloque = new Ns_bloques;
		$ns_bloque->id_objeto = $id_bloque;
		$ns_bloque->id_idioma = $id_idioma;
		$ns_bloque->find(true);

		$ns_enlaces = new Ns_enlaces;
		$ns_enlaces->id_envio  = $id_envio;
		$ns_enlaces->enlace    = $ns_bloque->enlace;
		$ns_enlaces->find(true);
		
		$path_enlace = NOMBRE_HOST . "html/sitio/";		
		$pagina_intermedia      = $path_enlace."phrame.php?action=redirigir_pagina&go=publico&id_contacto=IDUSER&id_enlace=";
		
		if( $ns_enlaces->id_enlace != "" ) {
			 $enlace_image_inicio = "<a href='".$pagina_intermedia.$ns_enlaces->id_enlace."'>";	
			 $enlace_image_fin = "</a>";		
		}
		
		$bloque = new $C_bloque;
		$bloque->id_objeto = $id_bloque;
		$bloque->id_idioma = $id_idioma;
		$url_sitio = $_SESSION['sitio']['url'];
		/*$path_imagenes = "<?= PATH_IMAGES ?>articulos/"; */
		 if (!$bloque->find(true))
		 	Fachada_Sistema::crear_version(&$bloque, $id_idioma);
			
		// Se escribe el contenido del bloque
		$contenido_bloque = addslashes(implode("\n",file($template_bloque)));
		eval("\$contenido_HTML = \"$contenido_bloque\"; ");
		/*$contenido_HTML = str_replace("imagenes_cont", "<?= NOMBRE_HOST?>/imagenes_cont", $contenido_HTML);*/

		// Contenido a buscar y reemplazar
		/*
		$search = array ("lib/spaw/empty.html#",  			// Los href de los cuadros de dialogo
						"empty.html");                    // Los empty.html que hayan quedado por ahi
		$replace = array ("#",
						 "");
		$contenido_HTML = str_replace ($search, $replace, $contenido_HTML); 
        */
		File::writeLine($archivo_articulo, stripslashes($contenido_HTML));
	}
	

}

?>
