----------------------------------------------------------------------
-- Archivo de creacin de tablas para el paquete Newsletter         --
-- Fecha: Diciembre 16 de 2004                                      --
-- Fernando Rengifo                                                 --
----------------------------------------------------------------------

CREATE TABLE ns_datos_modulos_newsletter
(
  PRIMARY KEY (id_objeto),
  numero_envios INTEGER,          -- Lmite de envios
  num_bloques   INTEGER           -- Lmite de nmero de bloques  
) INHERITS (sis_datos_modulos);

CREATE TABLE ns_estados
(
  id_estado SERIAL PRIMARY KEY,
  nombre VARCHAR(255)
);

ALTER TABLE Cnt_categorias_contactos ADD id_envio INT;

CREATE TABLE ns_bloques
(
  id_objeto SERIAL PRIMARY KEY,
  id_idioma INT,
  categoria varchar(255),
  titulo varchar(255),
  enlace varchar(255),
  FOREIGN KEY (id_objeto) REFERENCES Art_bloques (id_objeto)
);

CREATE TABLE ns_newsletter
(
  nombre VARCHAR(255),
  descripcion text,
  FOREIGN KEY (id_contenedor) REFERENCES ns_datos_modulos_newsletter (id_objeto),
  FOREIGN KEY (id_modulo) REFERENCES ns_datos_modulos_newsletter (id_objeto),
  PRIMARY KEY (id_objeto)
) INHERITS (sis_objetos_protegidos);

CREATE TABLE ns_envios
(
  num_envios INT,
  fecha_envio timestamp,
  fecha_creacion timestamp,
  asunto varchar(255),
  id_estado INT,
  fecha_boletin date,
  nro_boletin varchar(255),
  descripcion varchar(255),
  FOREIGN KEY (id_estado) REFERENCES ns_estados (id_estado),
  FOREIGN KEY (id_contenedor) REFERENCES ns_newsletter (id_objeto),
  PRIMARY KEY (id_objeto)
) INHERITS (Art_articulos);

CREATE TABLE ns_categorias_contacto
(
  id_objeto INT,
  id_categoria INT,
  FOREIGN KEY (id_objeto) REFERENCES ns_envios (id_objeto),
  FOREIGN KEY (id_categoria) REFERENCES Cnt_categorias_contactos (id_categoria)  
);



CREATE TABLE ns_enlaces
(
  id_enlace SERIAL PRIMARY KEY,
  enlace VARCHAR(255),
  titulo VARCHAR(255),
  clicks VARCHAR(255),  
  id_envio INT,
  FOREIGN KEY (id_envio) REFERENCES ns_envios (id_objeto)
);

CREATE TABLE ns_enlaces_contacto
(
  id_enlace INT,
  id_contacto INT,
  FOREIGN KEY (id_enlace) REFERENCES ns_enlaces (id_enlace),
);

CREATE TABLE ns_estadisticas
(
  id_estadisticas SERIAL PRIMARY KEY,
  num_clics INT,
  num_vistas INT,
  id_envio INT,
  FOREIGN KEY (id_envio) REFERENCES ns_envios (id_objeto)
);

CREATE TABLE ns_mail_queue (
  create_time timestamp,
  time_to_send timestamp,
  sent_time timestamp default NULL,
  id_user INT8 NOT NULL default '0',
  ip varchar(20) NOT NULL default 'desconocido',
  sender varchar(50) NOT NULL default '',
  recipient varchar(50) NOT NULL default '',
  headers text NOT NULL,
  body text NOT NULL,
  try_sent INT2 NOT NULL default '0',
  delete_after_send INT2 NOT NULL default '1',
  id SERIAL PRIMARY KEY
);