<?php
/*
 * Accion para crear categorias de productos
 *
 * @package  Catalogo
 * @version  1
 * @author Maria Luisa Manyoma <mlmanyoma@telesat.com.co> 
 * @since    PHP 4.1.2
 */

class crear_categoriaAction extends Action
{
	/**
	 *
	 * @access	public
	 * @param	ActionMapping	$actionMapping
	 * @param	ActionForm		$actionForm
	 * @return	ActionForward
	 */

	function perform($actionMapping, $actionForm) {
		if(Fachada_Productos::verificar_limite_categorias($_SESSION['sitio']['id_objeto']) == 1){
			$id_cat = Fachada_Productos::crear_categoria($actionForm->get('id_categoria_padre'),
											   $actionForm->get('nombre'),
											   $actionForm->get('descripcion'),
											   $actionForm->get('imagen'),
											   $_SESSION['sis_idioma']['id_idioma']);
		} else 
			$_SESSION['mensaje'] = "No puede crear categorias, ya llego a su limite.";			

		$actionForward = $actionMapping->get('exito');
		
		// Adicionar valores al path del forward
		$path = $actionForward->getPath() . '&tipo=categoria&id_objeto=' . $id_cat;
		$actionForward->setPath($path);
		return $actionForward;
	}
}
?>