<?php
/*
 * Accin para crear productos a una categoria
 *
 * @package  Catalogo
 * @version  1
 * @author Maria Luisa Manyoma <mlmanyoma@telesat.com.co> 
 * @since    PHP 4.1.2
 */

class crear_productoAction extends Action
{
	/**
	 *
	 * @access	public
	 * @param	ActionMapping	$actionMapping
	 * @param	ActionForm		$actionForm
	 * @return	ActionForward
	 */

	function perform($actionMapping, $actionForm) {
		if(Fachada_Productos::verificar_limite_productos($_SESSION['sitio']['id_objeto']) == 1){
			$result = Fachada_Productos::crear_producto($actionForm->get('producto_nombre'),
											  $actionForm->get('producto_descripcion'),
											  $actionForm->get('producto_precio'),
											  $actionForm->get('id_contenedor'),
											  $actionForm->get('imagen'),
											  $actionForm->get('destacado'),
											  $_SESSION['sis_idioma']['id_idioma']);
	
			// Asignar los valores de atributos al producto
			Fachada_Productos::asginar_valores_atributos($result->id_versiones, // Id de la versin del producto
														 $actionForm->get('id_atributo'), // Id's de atributos
														 $actionForm->get('valor_atributo') // Valores
														 );
			Generar_productos::generar_producto($result);
											 
		} else 
			$_SESSION['mensaje'] = "No puede crear productos, ya llego a su limite.";			


		$actionForward = $actionMapping->get('exito');
		
		// Adicionar valores al path del forward
		$path = $actionForward->getPath() . '&tipo=producto&id_objeto=' . $result->id_objeto;
		$actionForward->setPath($path);
	
		return $actionForward;
	}
}
?>