<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */
 /**
 * Gnenerador de las categorias y pginas de contendio
 *
 * @package Productos
 * @version 1.1
 * @author John Alexander Vargas <johnvargas@telesat.com.co> 
 * @since   PHP 4.1.2
 */
 class Generar_productos 
{
    /**
 	 * Genera los archivos planos de HTML para el catalogo del sitio
     *
     * @param   int $id_sitio Identificador del sitio al cual se le genera el catalogo
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param   int $id_idioma Identificador del idioma en el que se genera.
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */   
	function generar_productos()
	{	
		$path_images_cat = 'imagenes_cont/' . $_SESSION['sitio']['url']  . '/categorias/';
		$path_images_prd = 'imagenes_cont/' . $_SESSION['sitio']['url']  . '/productos/';
		
 		// Se obtiene las categoria raiz del sitio
		$categoria_raiz = new Prd_categorias_productos_versiones;
		$categoria = new Prd_categorias_productos;
		$datos = new Prd_datos_modulos_productos;
		$datos->id_contenedor = $_SESSION['sitio']['id_objeto'];
		$categoria->whereAdd("Prd_categorias_productos.id_contenedor = Prd_categorias_productos.id_modulo");
		$categoria->joinAdd($datos);
		$categoria_raiz->joinAdd($categoria);

		$categoria_raiz->selectAs();
		$categoria_raiz->find(true); 
	
		// Se obtiene las categorias del sitio
		$categoria_version = new Prd_categorias_productos_versiones;
		$categoria = new Prd_categorias_productos;
		$categoria->id_contenedor = $categoria_raiz->id_objeto;
		$categoria_version->joinAdd($categoria);
		$categoria_version->selectAs();
		$categoria_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$categoria_version->find();
		
		$lista_categorias = array();
		while ($categoria_version->fetch()) 
			array_push($lista_categorias, $categoria_version);
		
		$productos = new Prd_productos;
		$productos_version = new Prd_productos_versiones;
		$productos->id_contenedor = $categoria_raiz->id_objeto;
		$productos_version->joinAdd($productos);
		$productos_version->selectAs();
		$productos_version->id_idioma =  $_SESSION['sis_idioma']['id_idioma'];
		$productos_version->find();
		
		$lista_productos = array();
		while ($productos_version->fetch()) 
			array_push($lista_productos, $productos_version);
				
		$pagina = "pagina_$categoria_raiz->id_objeto.php";
		$path_vistas = "vistas/" . $_SESSION['sis_idioma']['enctype'] . '/';
		$template_catalogo = PATH_PRODUCTOS . "vistas/".$_SESSION['sis_idioma']['enctype'] ."/tpl_catalogo.php";
		$archivo_catalogo = "html/" . $_SESSION['sitio']['url']. "/$path_vistas$pagina"; 
		
		// Se escribe la cabecera del portal
		$includes = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'] .'/head_public.php"); ?>';
		File::writeLine($archivo_catalogo, $includes, FILE_MODE_WRITE); 
						
		// Se escribe el contenido del catalogo
		include($template_catalogo);
		File::writeLine($archivo_catalogo, $contenido_HTML);
		
		// Se escribe el pie del portal
		File::writeLine($archivo_catalogo, '<?  include("vistas/foot_public.php") ?>');
		
		return ;
	}
		
    /**
 	 * Genera los archivos planos de HTML para ela categoria de productos
     *
     * @param   int $id_categoria Identificador de la categoria a listar
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param   string $archivo_catalogo Archivo donde se guarda la fuente del catalogo
	 * @param   int $id_idioma Identificador del idioma en el que se genera.
	 * @author  John Vargas
     * @access  public
	 * @static
     */   
	function generar_categoria($categoria)
	{		
		$path_images_cat = 'imagenes_cont/' . $_SESSION['sitio']['url']  . '/categorias/';
		$path_images_prd = 'imagenes_cont/' . $_SESSION['sitio']['url']  . '/productos/';
		$pagina = "pagina_" . $categoria->id_objeto . ".php";
		$path_vistas = "vistas/" . $_SESSION['sis_idioma']['enctype'] . '/';
		$cadena_ruta = "";
		
		$cat_obj = new Prd_categorias_productos;
		$cat_obj->get($categoria->id_objeto);
		$ruta = array();
		Fachada_Productos::crear_ruta($cat_obj->id_contenedor, &$ruta); 
		$ruta = array_reverse($ruta);
		
		foreach ($ruta as $v)
			$cadena_ruta .= '<a href="'.$v['link'].'">'.$v['nombre'].'</a> ';
		
		$subcategoria = new Prd_categorias_productos;
		$subcategoria_version = new Prd_categorias_productos_versiones;
		$subcategoria->id_contenedor = $categoria->id_objeto;
		$subcategoria_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$subcategoria_version->joinAdd($subcategoria);
		$subcategoria_version->selectAs();
		$subcategoria_version->orderBy("nombre");
		$subcategoria_version->find(); 
		$lista_categorias = array();
		while ($subcategoria_version->fetch()) {
			array_push($lista_categorias, $subcategoria_version);	
		}
	

        // Se obtiene el producto destacado para mostrarlo en tpl_categoria
        $destacado = new Prd_productos;
        $destacado->destacado = 1;
		$destacado_version = new Prd_productos_versiones;
        $destacado_version->joinAdd($destacado);
        $destacado_version->find(true);
 

		$productos = new Prd_productos;
		$productos_version = new Prd_productos_versiones;
		$productos->id_contenedor = $categoria->id_objeto;
		$productos_version->joinAdd($productos);
		$productos_version->selectAs();
		$productos_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];;
		$productos_version->orderBy("nombre");
		$productos_version->find(); 
		$lista_productos = array();
		while ($productos_version->fetch()) 
			array_push($lista_productos, $productos_version);
		
		$archivo_categoria =  "html/" . $_SESSION['sitio']['url']. "/$path_vistas/$pagina"; 
		
		$template_categoria = PATH_PRODUCTOS . "vistas/".$_SESSION['sis_idioma']['enctype']."/tpl_categoria.php";
				
		// Se escribe la cabecera del portal
		$includes = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_categoria, $includes, FILE_MODE_WRITE);

		include($template_categoria);
		// Se escribe en el archivo
		File::writeLine($archivo_categoria, stripslashes($contenido_HTML));		
					
		// Se escribe el pie del portal
		File::writeLine($archivo_categoria, '<? include("vistas/foot_public.php") ?>');
		
		return;
	}
			
    /**
 	 * Genera los archivos planos de HTML para ela categoria de productos
     *
     * @param   objeto $producto Producto a generar
	 * @param   string $path_sitio Ruta del sitio a generar
	 * @param 	string $archivo_catalogo Archivo donde se guarda la fuente del catalogo
	 * @param 	string $archivo_categoria Archivo donde se guarda la fuente del categoria
	 * @param   objeto $idioma Idioma en el que se genera.
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */  
	function generar_producto ($producto)
	{
		$path_images_prd = 'imagenes_cont/' . $_SESSION['sitio']['url']  . '/productos/';
		$template_producto = PATH_PRODUCTOS . "vistas/".$_SESSION['sis_idioma']['enctype']."/tpl_producto.php";
		$pagina = "pagina_" . $producto->id_objeto .".php";
		$path_vistas = "vistas/". $_SESSION['sis_idioma']['enctype'];
		$archivo_producto =  "html/" . $_SESSION['sitio']['url']. "/$path_vistas/$pagina";
		$cadena_ruta = "";
		
		$prod_obj = new Prd_productos;
		$prod_obj->get($producto->id_objeto);
		
		$ruta = array();
		Fachada_Productos::crear_ruta($prod_obj->id_contenedor, &$ruta);
		$ruta = array_reverse($ruta);
		foreach ($ruta as $v)
			$cadena_ruta .= '<a href="'.$v['link'].'">'.$v['nombre'].'</a> /';
			
		$precio = ($prod_obj->precio) ? '$' . number_format ($prod_obj->precio) : '';
		$descripcion = nl2br ($producto->descripcion);
	
		$lista_atributos = Fachada_Productos::listar_atributos($_SESSION['sis_idioma']['id_idioma'], '', $producto->id_objeto);

		$path_imagen = ""; 
		if (file_exists($path_images_prd . $producto->imagen) && $producto->imagen != '') {
			$imagen = new Imagen($producto->imagen, $path_images_prd); 
			$imagen->rezise(500, 500);
			$path_imagen = '<img src="<?=PATH_IMAGES?>productos/'.$producto->imagen.'" border="0" width="'.$imagen->width.'" height="'.$imagen->height.'">';
		} 

		// Se escribe la cabecera del portal
		$includes = '<? include("vistas/'.$_SESSION['sis_idioma']['enctype'].'/head_public.php"); ?>';
		File::writeLine($archivo_producto, $includes, FILE_MODE_WRITE); 
				
		// Leemos el codigo del template		
		$contenido_producto = addslashes(implode("\n",file($template_producto)));

		// Evaluo el codigo PHP que hay en el template
		include(PATH_PRODUCTOS . "vistas/".$_SESSION['sis_idioma']['enctype']."/tpl_atributos.php");
		
		eval("\$contenido_HTML = \"$contenido_producto\"; ");

		// Se escribe en el archivo
		File::writeLine($archivo_producto, stripslashes($contenido_HTML));
		
		// Se escribe el pie del portal
		File::writeLine($archivo_producto, '<? include("vistas/foot_public.php") ?>'); 
	}


}
?>