<?
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */
//
// Especificacin del catalogo de productos
//
 /**
 *  La clase fachada contenido administra las clases para el modulo de productos
 *
 * @package  Productos
 * @version  1.2
 * @author Maria Luisa Manyoma <mlmanyoma@telesat.com.co> 
 * @since    PHP 4.3.3
 */

// Clases necesarias

require_once(PATH_PRODUCTOS . 'modelo/Prd_datos_modulos_productos.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_categorias_productos.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_categorias_productos_versiones.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_productos.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_productos_versiones.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_atributos.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_atributos_versiones.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_atributos_valores.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_atributos_opciones.php');
require_once(PATH_PRODUCTOS . 'modelo/Prd_atributos_opciones_versiones.php');

// Generador
include(PATH_PRODUCTOS . 'modelo/Generar_productos.php');


//CONTROLADOR
// Mapping
include(PATH_PRODUCTOS . 'controlador/mappings.php');

require_once PATH_PRODUCTOS . 'controlador/forms/crear_categoriaForm.php';
require_once PATH_PRODUCTOS . 'controlador/actions/crear_categoriaAction.php'; 
require_once PATH_PRODUCTOS . 'controlador/actions/mostrar_arbolAction.php';
require_once PATH_PRODUCTOS . 'controlador/forms/mostrar_categoriaForm.php';
require_once PATH_PRODUCTOS . 'controlador/actions/mostrar_categoriaAction.php';
require_once PATH_PRODUCTOS . 'controlador/forms/modificar_categoriaForm.php';
require_once PATH_PRODUCTOS . 'controlador/actions/modificar_categoriaAction.php';
require_once PATH_PRODUCTOS . 'controlador/forms/eliminar_categoriaForm.php';
require_once PATH_PRODUCTOS . 'controlador/actions/eliminar_categoriaAction.php';
require_once PATH_PRODUCTOS . 'controlador/forms/crear_productoForm.php';
require_once PATH_PRODUCTOS . 'controlador/actions/crear_productoAction.php';
require_once PATH_PRODUCTOS . 'controlador/forms/modificar_productoForm.php';
require_once PATH_PRODUCTOS . 'controlador/actions/modificar_productoAction.php';
require_once PATH_PRODUCTOS . 'controlador/forms/mostrar_productoForm.php';
require_once PATH_PRODUCTOS . 'controlador/actions/mostrar_productoAction.php';
require_once PATH_PRODUCTOS . 'controlador/forms/eliminar_productoForm.php';
require_once PATH_PRODUCTOS . 'controlador/actions/eliminar_productoAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/crear_atributoAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/listar_atributosAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/listar_atributos_modAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/modificar_atributoAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/eliminar_atributoAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/quitar_imagenAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/listar_productosAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/bajar_productoAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/subir_productoAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/prd_listar_categoriasAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/prd_buscar_productosAction.php';
require_once PATH_PRODUCTOS . 'controlador/actions/prd_borrar_listaAction.php';




class Fachada_Productos 
{

   /** 
     * Copia un archivo de tipo .jpg , .gif a un path especifico
     * @param   file $imagen archivo con la imagen a copiar 
     * @param   string $path ruta de la imagen 
     * @author  Maria Luisa Manyoma 
     * @access  public 
     * @return  int 1 si se copia la imagen, string mensaje de fallo en caso contrario
	 * @static
     */   
    function copiar_imagen($imagen, $path){ 
        $formatos_permitidos = array(".gif", ".jpg"); 
        $path = $path.time()."_". $imagen['name'];  
			// verifica el tamao de la imagen
            if ($imagen['size'] > 30000){
				$_SESSION['mensaje'] = "El tama&ntilde;o del archivo excede el valor permitido.";
                return $_SESSION['mensaje']; 
            } 
			// verifica si el formato es permitido
            if  (($imagen['name'] != "") and  (in_array(substr($imagen['name'], -4), $formatos_permitidos))){ 
                if (is_uploaded_file($imagen['tmp_name'])) 
                    copy($imagen['tmp_name'], $path); 
                else{ 
					$_SESSION['mensaje'] = "Error al copiar el archivo";
					return $_SESSION['mensaje']; 
				}
            }         
            else {
				$_SESSION['mensaje'] = "El tipo de archivo no es valido";
				return $_SESSION['mensaje']; 
			}
        return 1; 
     
    } 

    /**
 	 * Construye una cadena de categorias y productos
     *
     * @param   int $id_objeto Identificador de la categoria a listar
	 *          int $id_idioma Identificador del idioma en session
	 * @param   string $cadena cadena con las categorias y productos a listar
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  string cadena con las categorias y productos del arbol
	 * @static
     */  
	function construir_arbol($id_objeto, $cadena = '', $id_idioma)
	 { 
		//print_r($id_objeto); exit();
        $categoria = new Prd_categorias_productos;
		$categoria->get($id_objeto);

        $categoria_version = new Prd_categorias_productos_versiones;
		$categoria_version->id_objeto = $id_objeto;
		$categoria_version->id_idioma = $id_idioma;
		$categoria_version->find(true);
		if (!$categoria_version->find(true))
				Fachada_Sistema::crear_version(&$categoria_version, $id_idioma);
	
/*		if($categoria_version->nombre == "Catalogo")
	       $cadena .= "['<b>$categoria_version->nombre</b>', 'index.php?view=src/productos/vistas/crear_categoria.htm&id_categoria=$id_objeto', 'mainFrame'";
		else
*/
 		   $cadena .= "['<b>$categoria_version->nombre</b>', 'index.php?view=src/productos/vistas/opciones_categoria.php&id_categoria=$id_objeto&nombre=$categoria_version->nombre', 'contenido_mod'";
	
        $categoria = new Prd_categorias_productos;
		$categoria->id_contenedor = $id_objeto;
		$categoria->find();

        while($categoria->fetch()){
            $child_id = $categoria->id_objeto;
    	    $cadena .= ", ";
            Fachada_Productos::construir_arbol($child_id, &$cadena, $id_idioma);
        }

        $producto = new Prd_productos;
		$producto->id_contenedor = $id_objeto;
		$producto->find();
		
        while($producto->fetch()){
            $child_id = $producto->id_objeto;
			$producto_version = new Prd_productos_versiones;
			$producto_version->id_idioma = $id_idioma;
			$producto_version->id_objeto = $child_id;
			if (!$producto_version->find(true))
				Fachada_Sistema::crear_version(&$producto_version, $id_idioma);
	        $cadena .= ",['$producto_version->nombre', 'index.php?view=src/productos/vistas/opciones_producto.php&id_objeto=$child_id&nombre=$producto_version->nombre', 'contenido_mod']";
        }

        $cadena .= "]";
//		print_r($cadena);
        return;
    }


    /**
 	 * Verifica si existe una categoria con el mismo nombre en el catalogo
     *
	 * @param   string $nombre nombre de la categoria a buscar
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int numero de categorias existentes
	 * @static
     */  

	function existe_categoria($nombre){
		$categoria = new Prd_categorias_productos;
		$categoria->query("SELECT * FROM {$categoria->__table} WHERE nombre = '$nombre'");
		$total = $categoria->count();
		return $total;
	}

    /**
 	 * Verifica los limites de una categoria 
     *
	 * @param   int $id_sitio identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int $indicador 1 si no ha llegado al limite 0 en caso contrario
     */  
	function verificar_limite_categorias($id_sitio){
		$categorias = new Prd_categorias_productos;
		$total_categorias = $categorias->count();
		//print_r($total); exit();
		$datos = new Prd_datos_modulos_productos;
		$datos->get("id_contenedor", $id_sitio);
		if($total_categorias < ($datos->limite_categorias + 1))
			return 1;
		else
			return 0;
	}

    /**
 	 * Verifica los limites de un producto
     *
	 * @param   int $id_sitio identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  int $indicador 1 si no ha llegado al limite 0 en caso contrario
     */  
	function verificar_limite_productos($id_sitio){
		$productos = new Prd_productos;
		$total_productos = $productos->count();
		$datos = new Prd_datos_modulos_productos;
		$datos->get("id_contenedor", $id_sitio);
		if($total_productos < $datos->limite_productos)
			return 1;
		else
			return 0;
	}


    /**
 	 * Crea una nueva categoria en el catalogo
     *
	 * @param   int $id_categoria padre identificador de la categoria padre
	 * @param   string $nombre nombre de la categoria a crear
	 * @param   string $descripcion descripcion de la categoria a crear
	 * @param   string $imagen imagen de la categoria a crear
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int identificador de la categoria
	 * @static
     */  
	function crear_categoria($id_contenedor, $nombre, $descripcion, $imagen, $id_idioma) 
	{
		// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		$path_sitio =  $_SESSION['sitio']['url'];
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		if (!file_exists($dir_contenido."/categorias")){
			System::mkdir($dir_contenido."/categorias");
		}

		//obtiene el identificador del datos modulo
		$datos_modulos = new Prd_datos_modulos_productos;
		$datos_modulos->get('id_contenedor',$_SESSION['sitio']['id_objeto']);

		$name_imagen = time() . '_' . $imagen['name'];
		$path_image = $dir_contenido."/categorias/";
		
		$categoria = new Prd_categorias_productos;  
		$categoria_version = new Prd_categorias_productos_versiones;
		if($imagen[type] != ""){  
			if(Fachada_productos::copiar_imagen($imagen, $path_image) == 1)
				$categoria_version->imagen = $name_imagen;     
		}
		$categoria_version->nombre = $nombre;                          
		$categoria_version->descripcion = $descripcion;                
		$categoria->id_contenedor = $datos_modulos->id_objeto;          
		$categoria->id_estilo = '';                     
		$categoria->id_contenedor = $id_contenedor;
		$categoria->id_modulo  = $datos_modulos->id_objeto;
		//inserta la nueva categoria
		$id = $categoria->insert(); 
		$categoria_version->id_objeto = $id;
		//inserta la version de la categoria
		$categoria_version->id_idioma = $id_idioma;
		$bandera = $categoria_version->insert(); 
		
		// Generamos el archivo que enlaza esta categoria
		if ($categoria->id_contenedor == $categoria->id_modulo) 
			Generar_productos::generar_productos();
		else {
			$padre = new Prd_categorias_productos_versiones;
			$padre->id_objeto = $categoria->id_contenedor;
			$padre->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			Generar_productos::generar_categoria($padre);
		}
		
		// Generamos la categoria
		Generar_productos::generar_categoria($categoria_version);

		//Escribe en el log
		if($bandera > 0)
			Util::log('Productos', 'Creacin de Categoria', 'Se creo la categoria con exito');
		else
			Util::log('Productos', 'Creacin de Categoria', 'No se creo la categoria');


		return $id;
	}       

    /**
 	 * Crea un nuevo producto en el catalogo
     *
	 * @param   int $id_contenedor identificador de la categoria
	 * @param   int $producto precio precio del producto a crear 
	 * @param   string $producto_nombre nombre del producto a crear
	 * @param   string $producto_descripcion descripcion del producto a crear
	 * @param   string $imagen imagen del producto a crear
	 * @param   int $destacado 1 si es producto destacado 0 en caso contrario
	 * @param   int $id_idioma identificador del idioma
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  arreglo con identificador del producto, identificador de la version
	 * @static
     */  

	function crear_producto($producto_nombre, $producto_descripcion, $producto_precio, $id_contenedor, $imagen, $destacado, $id_idioma) 
	{
		// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		$path_sitio =  $_SESSION['sitio']['url'];
	
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido."/productos")){
			mkdir($dir_contenido."/productos", 0755);
		}

		$name_image = time() . '_' . $imagen['name'];
		$path_image = $dir_contenido."/productos/" ;
		
		$producto = new Prd_productos;  
		$producto_version = new Prd_productos_versiones;
	    $producto_version->nombre = $producto_nombre;                          
        $producto_version->descripcion = $producto_descripcion;                
        $producto->id_contenedor = $id_contenedor;          
        $producto->id_estilo = '';                    
        $producto->precio = $producto_precio;     
		$producto->posicion = Fachada_Productos::buscar_posicion($id_contenedor) + 1;

        // Si el producto es destacado, eclipsa a los dems 
        // en su misma categora y destaca el actual
        if ($destacado == 1) {
            Fachada_Productos::eclipsar_productos($id_contenedor);
            $producto->destacado = 1;
        }
       
		if($imagen['name'] && Fachada_productos::copiar_imagen($imagen, $path_image) == 1)
			$producto_version->imagen = $name_image;   

		//inserta el producto  
		$id_prd = $producto->insert(); 
		//inserta la version del producto
		$producto_version->id_objeto = $id_prd;
		$producto_version->id_idioma = $id_idioma;
		$id = $producto_version->insert();

		//Escribe en el log
		if($id > 0)
			Util::log('Productos', 'Creacin de Producto', 'Se creo el producto con exito');
		else
			Util::log('Productos', 'Creacin de Producto', 'No se creo el producto');

		// Generar la pgina que enlaza a este producto
		$padre = new Prd_categorias_productos_versiones;
		$padre->id_objeto = $producto->id_contenedor;
		$padre->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$padre->find(true);
		Generar_productos::generar_categoria($padre);

		return $producto_version;
	}       

	/**

 	 * Convierte en cero toda la columna DESTACADO para la categora dada
	 *
     * @param   int $id_contenedor Identificador de la categora
	 * @author  Mauricio Cuenca
     * @access  public
     * @return  int identificador del producto
	 * @static
     */  

	function eclipsar_productos($id_contenedor)
	{
        $eclipsados = new Prd_productos;
        $eclipsados->whereAdd("id_contenedor = '$id_contenedor'");
        $eclipsados->destacado = 0;
        $eclipsados->update();
		return;
	}



	/**

 	 * Obtiene el contendor de una categoria
	 *
     * @param   int $id_sitio Identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int identificador del datos modulos
	 * @static
     */  

	function traer_contenedor($id_sitio)
	{
		$datos_modulo = new Prd_datos_modulos_productos;
		$datos_modulo->get('id_contenedor', $id_sitio);
		$datos_modulo->fetch(true);
		return $datos_modulo->id_objeto;
	}



    /**
 	 * Lista las categorias del catalogo
     *
	 * @param   int $id_objeto identificador del sitio
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  array $lista_categorias lista con las categorias del catalogo
	 * @static
     */  

	function listar_categorias($id_objeto, $id_idioma)
    {
		$categoria = new Prd_categorias_productos;
		$categoria_versiones = new Prd_categorias_productos_versiones;
		$categoria_versiones->whereAdd("id_idioma = '$id_idioma'");
		$categoria->whereAdd("id_modulo = '$id_objeto'");
		$categoria_versiones->joinAdd($categoria);
	 	$categoria_versiones->find();
		$lista_categorias = array();
		while ($categoria_versiones->fetch()) 
			array_push($lista_categorias, $categoria_versiones->toArray());
		
		return $lista_categorias;
    }


    /**
 	 * Busca un producto dado el nombre del producto, el identeficador de la categoria
     *
	 * @param   int $id_categoria identificador del contenedor del producto
	 * @param   int $producto nombre del producto
	 *          int $id_idioma Idioma en que se esta administrando
	 *
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  array $lista_productos lista con los productos del catalogo
	 * @static
     */  

	function buscar_productos($nombre_producto, $id_categoria, $id_idioma){
		$producto_versiones = new Prd_productos_versiones;
		$producto = new Prd_productos;
		$producto_versiones->whereAdd("id_idioma = '$id_idioma'");
		// si existe nombre de producto busca por este
		if ($nombre_producto){
			$nombre_producto = "'%".$nombre_producto."%'";
			$producto->whereAdd("LOWER(nombre) LIKE LOWER($nombre_producto)");
		}
		// si existe identificador de la categoria busca por esta
		if ($id_categoria){
			$producto->whereAdd("id_contenedor = '$id_categoria'");
		}

		$producto_versiones->joinAdd($producto);
		$producto_versiones->find();
		$lista_productos = array();
		while ($producto_versiones->fetch()) {
			array_push($lista_productos, $producto_versiones->toArray());
		}

		return $lista_productos; 
	}

    /**
 	 * Lista los productos del catalogo dado la categoria
     *
	 * @param   string $nombre nombre del producto
	 * @param   string $descripcion descripcin del producto
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  array $lista_productos lista con los productos del catalogo
	 * @static
     */  
	function listar_productos($id_contenedor, $id_idioma)
    {
		$categoria = new Prd_categorias_productos_versiones;
		$categoria->whereAdd("id_objeto = '$id_contenedor'");
		$categoria->whereAdd("id_idioma = '$id_idioma'");
		$categoria->find(true);
		$nombre_contenedor = $categoria->nombre;

		$lista_productos = array();
		$producto = new Prd_productos;
		$producto->whereAdd("id_contenedor = '$id_contenedor'"); 
		$producto->orderBy("posicion ASC");
		$producto->find();

		while ($producto->fetch()) {
			$producto_versiones = new Prd_productos_versiones;
			$producto_versiones->id_idioma = $id_idioma;
			$producto_versiones->joinAdd($producto); 
			if (!$producto_versiones->find(true))
				Fachada_Sistema::crear_version(&$producto_versiones, $_SESSION['sis_idioma']['id_idioma']);


	    	/* almacenamos en el arreglo slo los campos que necesitamos */
			if(sizeof($lista_productos) == 0)
				$lista_productos = Array(Array("id_objeto" =>  $producto->id_objeto, 
											   "nombre" => $producto_versiones->nombre, 
											   "nombre_categoria" => $nombre_contenedor, 
											   "id_contenedor" => $producto->id_contenedor));
			else
				array_push($lista_productos, Array("id_objeto" =>  $producto->id_objeto, 
												   "nombre" => $producto_versiones->nombre, 
												   "nombre_categoria" => $nombre_contenedor, 
												   "id_contenedor" => $producto->id_contenedor));
		}

		return $lista_productos; 
    }

    /**
 	 * Muestra un producto especifico
     *
	 * @param   int $id_objeto identificador del producto
	 * @param   int $id_idioma identificador del idioma
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  array datos del producto
	 * @static
     */  
	function ver_producto($id_objeto, $id_idioma)
    {
		$producto_versiones = new Prd_productos_versiones;
		$producto = new Prd_productos;
		$producto->id_objeto = $id_objeto;
		$producto->id_idioma = $id_idioma;
		$producto->joinAdd($producto_versiones); 
		
        // $producto->print_query();
        // print_r($producto);

		if (!$producto->find(true)) 
			Fachada_Sistema::crear_version(&$producto, $id_idioma);
		
		$_SESSION['producto'] = $producto;
		return; 

	}

    /**
 	 * Muestra una categoria
     *
	 * @param   int $id_objeto identificador de la categoria
	 * @param   int $id_idioma Identificador del idioma
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function ver_categoria($id_objeto, $id_idioma)
    {
		$categoria = new Prd_categorias_productos_versiones;
		$categoria->id_objeto = $id_objeto;
		$categoria->id_idioma = $id_idioma;
		
		if (!$categoria->find(true))
			Fachada_Sistema::crear_version(&$categoria, $id_idioma);
		
		$_SESSION['categoria'] = $categoria;
		return ;
	}
	
    /**
 	 * Modifica nombre, descripcin e imagen de una categoria existente
     *
	 * @param   int $id_categoria identificador del producto
	 * @param   int $id_idioma Identificador del idioma
	 * @param   string $nombre identificador del producto
	 * @param   string $descripcion identificador del producto
	 * @param   string $imagen identificador del producto
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
    function modificar_categoria($id_categoria, $nombre, $descripcion, $imagen, $id_idioma)
    {
		// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		$path_sitio =  $_SESSION['sitio']['url'];
	
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido)){
			mkdir($dir_contenido, 0755);
			mkdir($dir_contenido."/categorias", 0755);
		}

		if (!file_exists($dir_contenido."/categorias")){
			mkdir($dir_contenido."/categorias", 0755);
		}
		
		$name_image = time() . '_' . $imagen['name'];
		$path_image = $dir_contenido."/categorias/";

 		$categoria = new Prd_categorias_productos_versiones;  
		$categoria->id_objeto = $id_categoria;
		$categoria->id_idioma = $id_idioma;
		$categoria->find(true);
		
		$categoria2 = new Prd_categorias_productos_versiones;
		$categoria2->id_objeto = $id_categoria;
		$categoria2->find(); $encontro = false;
		while ($categoria2->fetch() && !$encontro) 
			$encontro = ($categoria2->imagen == $categoria->imagen);
		
		$old_image = $dir_contenido."/categorias/" . $categoria->imagen;
		

        if($imagen['name'] && Fachada_productos::copiar_imagen($imagen, $path_image) == 1) {
			if (file_exists($old_image) && !$encontro) unlink($old_image);
			$categoria->imagen = $name_image;     
		}
		$categoria->nombre = $nombre;
		$categoria->descripcion = $descripcion;
		$bandera = $categoria->update();  

		//Escribe en el log
		if($bandera > 0)
			Util::log('Productos', 'Modificar Categoria', 'Se modifico la categoria con exito');
		else
			Util::log('Productos', 'Modificar Categoria', 'No se modifico la categoria con exito');
		  
		// Generamos el archivo que enlaza esta categoria
		$cat_obj = new Prd_categorias_productos;
		$cat_obj->get($categoria->id_objeto);
		$padre = new Prd_categorias_productos_versiones;
		$padre->id_objeto = $cat_obj->id_contenedor;
		$padre->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$padre->find(true);
		
		$padre_obj = new Prd_categorias_productos;
		$padre_obj->get($padre->id_objeto);
		if ($padre_obj->id_contenedor == $padre_obj->id_modulo) 
			Generar_productos::generar_productos();
		else {
			Generar_productos::generar_categoria($padre);
		}
		
		// Generamos la categoria
		Generar_productos::generar_categoria($categoria);
		
		return ; 
    }     

    /**
	 * Modifica nombre, descripcin, precio e imagen de un producto existente
     *
	 * @param   int $id_categoria identificador del producto
	 * @param   precio $precio precio del producto
	 * @param   string $nombre identificador del producto
	 * @param   string $descripcion identificador del producto
	 * @param   string $imagen identificador del producto
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int identificador de la version del producto
	 * @static
     */  
    function modificar_producto($id_objeto, $id_categoria, $nombre, $descripcion, $imagen, $precio, $id_idioma)
    {
		// Crear del directorio del sitio dentro de la carpeta imagenes_cont/
		$path_sitio =  $_SESSION['sitio']['url'];
	
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		if (!file_exists($dir_contenido)){
			mkdir($dir_contenido, 0755);
			mkdir($dir_contenido."/productos", 0755);
		}

		if (!file_exists($dir_contenido."/productos")){
			mkdir($dir_contenido."/productos", 0755);
		}

		$name_image = time() . '_' . $imagen['name'];
		$path_image = $dir_contenido."/productos/";

		$producto = new Prd_productos;
		$producto_version = new Prd_productos_versiones;
		$producto->get($id_objeto);
		$producto_version->id_objeto = $id_objeto;
		$producto_version->id_idioma = $id_idioma;
		$producto_version->find(true);
		
		$producto_version->nombre = $nombre;
		$producto_version->descripcion = $descripcion;
		$producto->precio = $precio;
		$producto->id_contenedor = $id_categoria;
		
		$producto2 = new Prd_productos_versiones;
		$producto2->id_objeto = $id_objeto;
		$producto2->find(); $encontro = false;
		while ($producto2->fetch() && !$encontro) 
			$encontro = ($producto2->imagen == $producto->imagen);
		
		$old_image = $dir_contenido."/productos/" . $producto_version->imagen;
		
        if($imagen['name'] && Fachada_Productos::copiar_imagen($imagen, $path_image) == 1) {
			if (file_exists($old_image) && !$encontro) unlink($old_image);
			$producto_version->imagen = $name_image;     
		}
		$bandera1 = $producto->update(); 
		$bandera2 = $producto_version->update(); 

		//Escribe en el log
		if($bandera1 > 0 and $bandera2 > 0)
			Util::log('Productos', 'Modificar Producto', 'Se modifico el producto con exito');
		else
			Util::log('Productos', 'Modificar Producto', 'No se modifico el producto con exito');
		
		// Generar la pgina que enlaza a este producto
		$padre = new Prd_categorias_productos_versiones;
		$padre->id_objeto = $producto->id_contenedor;
		$padre->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$padre->find(true);
		Generar_productos::generar_categoria($padre);

		return $producto_version;
    }     

    /**
	 * Elimina una categoria existente
     *
	 * @param   int $id_categoria identificador de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int identificador de la categoria 0 en caso de no eliminacion
	 * @static
     */  
    function eliminar_categoria($id_categoria)
    {
		//Buscamos el directorio de imagenes del sitio para eliminar la imagen de la categoria
		$path_sitio =  $_SESSION['sitio']['url'];
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;

		//Borramos la categoria y la version pero  verificamos si no tiene productos ni subcategorias
        if(Fachada_productos::verificar_productos($id_categoria) == 0 AND Fachada_productos::verificar_categorias($id_categoria) == 0){
			$categoria_version = new Prd_categorias_productos_versiones;
			$categoria_version->whereAdd("id_objeto = '$id_categoria'");
	
			//si existe imagen la elimina
			while ($categoria_version->fetch()) {
				$image = $dir_contenido . '/productos/' . $categoria_version->imagen;
				if (file_exists($image))  unlink($image);
			}

			//elimina la version de la categoria
			$categoria_version = new Prd_categorias_productos_versiones;
			$categoria_version->get('id_objeto', $id_categoria);
			$categoria_version->delete();

			//elimina la categoria
			$categoria = new Prd_categorias_productos;
			$categoria->get($id_categoria);
			$bandera = $categoria->delete(); 

			//Escribe en el log
			if($bandera > 0)
				Util::log('Productos', 'Eliminar Categoria', 'Se elimino la categoria con exito');
			else
				Util::log('Productos', 'Eliminar Categoria', 'No se elimino la categoria');

			// Generamos el archivo que enlaza esta categoria
			$padre = new Prd_categorias_productos_versiones;
			$padre->id_objeto = $categoria->id_contenedor;
			$padre->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
			Generar_productos::generar_categoria($padre); 
			
			//  Eliminar el archivo de la categoria
			@unlink("html/vistas/".$_SESSION['sis_idioma']['id_idioma']."/pagina_" . $categoria->id_objeto . ".php");
			
	
			return $categoria->id_contenedor;
		}
		else 
			return 0;
    }     

    /**
	 * Elimina un producto existente
     *
	 * @param   int $id_objeto identificador del producto
	 * @author  Maria Luisa Manyoma
     * @access  public
     * @return  int identificador de la categoria a la que pertenece el producto
	 * @static
     */  
	function borrar_producto($id_objeto)
    {
		$producto = new Prd_productos;
		$producto->get($id_objeto);
		
		$path_sitio =  $_SESSION['sitio']['url'];
	
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		
		$producto_version = new Prd_productos_versiones;
		$producto_version->id_objeto = $id_objeto;

		while ($producto_version->fetch()) {
			$image = $dir_contenido . '/productos/' . $producto_version->imagen;
		    if (file_exists($image))  unlink($image);
		}
		$producto_version->delete();
		$bandera = $producto->delete();
		
		// Generar la pgina que enlaza a este producto
		$padre = new Prd_categorias_productos_versiones;
		$padre->id_objeto = $producto->id_contenedor;
		$padre->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$padre->find(true);
		Generar_productos::generar_categoria($padre);
		@unlink("html/vistas/".$_SESSION['sis_idioma']['id_idioma']."/pagina_" . $id_objeto . ".php");

		//Guarda en el log
		if($bandera > 0 )
			Util::log('Productos', 'Eliminar Producto', "Se borro el producto con exito");
		else
			Util::log('Productos', 'Eliminar Producto', "No se borro el producto");

		return $producto->id_contenedor;
    }     
		
    /**
 	 * Obtiene la categoria raiz de un sitio
     *
     * @param   int $id_sitio Identificador del sitio al cual se le obtendra la categoria
	 * @author  John A. Vargas
     * @access  public
     * @return  int identificador de la categoria
	 * @static
     */   		
	function obtener_categoria_raiz($id_sitio)
	{
		$categoria = new Prd_categorias_productos;
		$datos = new Prd_datos_modulos_productos;
		$datos->get("id_contenedor", $id_sitio);
		$categoria->setid_modulo($datos->getid_objeto());
		$categoria->whereAdd("id_contenedor = id_modulo");
		
		return ($categoria->find(true)) ? $categoria->id_objeto : 0;
	}
		

    /**
 	 * Realia la configuracion minimia del modulo de productos para un sitio
     *
     * @param   int $id_sitio Identificador de la categoria a listar
     * @param   int $id_modulo Identificador de la categoria a listar
	 * @author  John Vargas
     * @access  public
	 * @static
     */  
	 function configurar_productos($id_sitio)
	 {
	 	$sitio = new Sis_sitios;
		$sitio->get($id_sitio);
	
		$idioma = new Sis_idiomas;
		$idioma->get('nombre',IDIOMA_DEFECTO);

	 	Fachada_Productos::crear_categoria('NULL','CATALOGO',
				   		   				   'catalogo de sitio ' . $sitio->nombre, '',
										   $idioma->id_idioma);	
	 }

    /**
	 * Inserta un atributo a una categoria o a un producto existente
     *
	 * @param   int $id_idioma identificador del idioma del atributo
	 * @param   int $tipo tipo de objeto al que se le adiciona el atributo
	 * @param   string $nombre_atributo nombre del atributo
	 * @param   int $id_contenedor identificador del objeto al que se le aplica el atributo
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @static
     */  
	function adicionar_atributo($id_idioma, $tipo, $nombre_atributo, $id_contenedor, $caracteristica, $opcion)
    {
		$atributo = new Prd_atributos;
		$atributo->tipo = $tipo;
		$atributo->id_contenedor = $id_contenedor;
		$atributo->caracteristica = $caracteristica;
		$id_atributo = $atributo->insert();

		$atributo_versiones = new Prd_atributos_versiones;
		$atributo_versiones->id_objeto = $id_atributo;
		$atributo_versiones->id_idioma = $id_idioma;
		$atributo_versiones->nombre = $nombre_atributo;
		$id_atributo_versiones = $atributo_versiones->insert();

		if($caracteristica == 'lista'){
			for($i=0; $i < sizeof($opcion); $i++){
				$atributo_opciones = new Prd_atributos_opciones;
				$atributo_opciones->id_contenedor = $id_atributo;
				$id_atributo_opciones = $atributo_opciones->insert();
	
				$atributo_opciones_versiones = new Prd_atributos_opciones_versiones;
				$atributo_opciones_versiones->id_objeto = $id_atributo_opciones;
				$atributo_opciones_versiones->id_idioma = $id_idioma;
				$atributo_opciones_versiones->nombre = $opcion[$i];
				$atributo_opciones_versiones->insert();
			}
        }

		//Guarda en el log
		if($bandera > 0 )
			Util::log('Productos', 'Crear Atributo', "Se creo el atributo con exito");
		else
			Util::log('Productos', 'Crear Atributo', "No se creo el atributo");


		return;
    }   

    /**
	 * muestra todos los atributo de un porducto
     *
	 * @param   int $id_idioma identificador del idioma del atributo
	 * @param   int $tipo tipo de objeto al que se le adiciona el atributo
	 * @param   int $id_contenedor identificador del objeto al que se le aplica el atributo
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  array arreglo con la lista de atributos del producto
     */  
	function mostrar_atributos($id_idioma, $tipo, $id_contenedor)
    {

		if($tipo == 'categoria')
			$contenedor = new Prd_categorias_productos_versiones;
		else
		    $contenedor = new Prd_productos_versiones;      
		$contenedor->id_objeto = $id_contenedor;
		$contenedor->id_idioma = $id_idioma;
		$contenedor->find(true);
		$nombre_contenedor = $contenedor->nombre;

		$atributo = new Prd_atributos;
		$atributo_versiones = new Prd_atributos_versiones;
		$atributo_versiones->id_idioma = $id_idioma;
		$atributo->joinAdd($atributo_versiones); 
		
		/** WHERE para sacar los atributos */
		$where_list = new ArrayList();
		$where_list->add("id_contenedor = '$id_contenedor'");
		$contenedor = new Sis_objetos_protegidos;
		$contenedor->get($id_contenedor);
		$id_contenedor = $contenedor->id_contenedor;
		
		/** Tambien debe tener los atributos de las categorias ancestras **/
		$obj = new Sis_objetos_protegidos;
		$obj->get($contenedor->id_contenedor);
		while (get_class($obj->get_hijo()) == "prd_categorias_productos") {
			$where_list->add("id_contenedor = '$id_contenedor'");
			$id_contenedor = $obj->id_contenedor;
			
			$obj = new Sis_objetos_protegidos;
			$obj->get($id_contenedor);
		}

		/** Asignamos el where */
		$atributo->whereAdd("(" . implode (" OR " , $where_list->toArray()) . ")");

		$atributo->find(); 
		$arreglo_atributos = new ArrayList();
		while ($atributo->fetch()) {
			$lista_opciones = new ArrayList();
			if($atributo->caracteristica == "lista")
				$lista_opciones = Fachada_Productos::traer_lista_atributos($id_idioma, $atributo->id_objeto);

			$arreglo_atributos->add(Array("id_objeto" =>  $atributo->id_objeto,
									   	  "nombre" => $atributo->nombre,
										  "id_contenedor" => $atributo->id_contenedor,
										  "nombre_contenedor" => $nombre_contenedor,
										  "tipo" => $tipo,
										  "caracteristica" => $atributo->caracteristica,
										  "opciones" => $lista_opciones));
		}
		return $arreglo_atributos->toArray();
    }     
  

    /**
	 * muestra los atributos propios de un producto o una categoria
     *
	 * @param   int $id_idioma identificador del idioma del atributo
	 * @param   int $tipo tipo de objeto al que se le adiciona el atributo
	 * @param   int $id_contenedor identificador del objeto al que se le aplica el atributo
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  array arreglo con la lista de atributos del producto
     */  
	function mostrar_atributos_mod($id_idioma, $tipo, $id_contenedor)
    {

		if($tipo == 'categoria')
			$contenedor = new Prd_categorias_productos_versiones;
		else
		    $contenedor = new Prd_productos_versiones;      
		$contenedor->id_objeto = $id_contenedor;
		$contenedor->id_idioma = $id_idioma;
		$contenedor->find(true);
		$nombre_contenedor = $contenedor->nombre;

		$atributo = new Prd_atributos;
		$atributo_versiones = new Prd_atributos_versiones;
		$atributo_versiones->id_idioma = $id_idioma;
		$atributo->id_contenedor = $id_contenedor;
		$atributo->joinAdd($atributo_versiones); 
		

		$atributo->find(); 
		$arreglo_atributos = new ArrayList();
		while ($atributo->fetch()) {
			$lista_opciones = new ArrayList();
			if($atributo->caracteristica == "lista")
				$lista_opciones = Fachada_Productos::traer_lista_atributos($id_idioma, $atributo->id_objeto);

			$arreglo_atributos->add(Array("id_objeto" =>  $atributo->id_objeto,
									   	  "nombre" => $atributo->nombre,
										  "id_contenedor" => $atributo->id_contenedor,
										  "nombre_contenedor" => $nombre_contenedor,
										  "tipo" => $tipo,
										  "caracteristica" => $atributo->caracteristica,
										  "opciones" => $lista_opciones));
		}
		return $arreglo_atributos->toArray();
    }     





    /**
	 * lista todos los atributo de un porducto
     *
	 * @param   int $id_idioma identificador del idioma del atributo
	 * @param   int $tipo tipo de objeto al que se le adiciona el atributo
	 * @param   int $id_contenedor identificador del objeto al que se le aplica el atributo
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  array arreglo con la lista de atributos del producto
     */  
	function listar_atributos($id_idioma, $tipo, $id_contenedor)
    {
		$atributo = new Prd_atributos;
		$atributo_version = new Prd_atributos_versiones;
		$producto_version = new Prd_productos_versiones;
		$producto_version->id_idioma = $id_idioma;
		$producto_version->id_objeto = $id_contenedor;
		$producto_version->find(true);

		//$atributo->id_contenedor = $id_contenedor;		
		$atributo_version->id_idioma = $id_idioma;
		$atributo->joinAdd($atributo_version);
		
		$atributo->selectAs();
		$atributo->selectAs($atributo_version, "ver_%s");

		/** WHERE para sacar los atributos */
		$where_list = new ArrayList();
		$where_list->add("id_contenedor = '$id_contenedor'");
		$contenedor = new Sis_objetos_protegidos;
		$contenedor->get($id_contenedor);
		$id_contenedor = $contenedor->id_contenedor;
		
		/** Tambien debe tener los atributos de las categorias ancestras **/
		$obj = new Sis_objetos_protegidos;
		$obj->get($contenedor->id_contenedor);
		while (get_class($obj->get_hijo()) == "prd_categorias_productos") {
			$where_list->add("id_contenedor = '$id_contenedor'");
			$id_contenedor = $obj->id_contenedor;
			
			$obj = new Sis_objetos_protegidos;
			$obj->get($id_contenedor);
		}

		/** Asignamos el where */
		$atributo->whereAdd("(" . implode (" OR " , $where_list->toArray()) . ")");

		$atributo->find();
		$lista_atributos = new ArrayList();
		while ($atributo->fetch()) {
			//echo "Id atributo: "; print_r($atributo->id_objeto); echo "<br>";

			$atributo_valores = new Prd_atributos_valores;
			$atributo_valores->id_producto = $producto_version->id_versiones;
			$atributo_valores->id_contenedor = $atributo->id_objeto;
			$atributo_valores->find(true);
			//print_r($atributo_valores); exit();
			$lista_opciones = array();
			if($atributo->caracteristica == "lista")
				$lista_opciones = Fachada_Productos::traer_lista_atributos($id_idioma, $atributo->id_objeto);

			//echo "Lista Opciones: "; print_r($lista_opciones); echo "<br>";
			$lista_atributos->add(array("id_objeto" =>  $atributo->id_objeto,
									 	"nombre" => $atributo->ver_nombre,
										"valor" => $atributo_valores->valor,
										"id_contenedor" => $atributo->id_contenedor,
										"caracteristica" => $atributo->caracteristica,
										"opciones" => $lista_opciones));
			
		}
			//print_r($lista_atributos);exit();
		return $lista_atributos->toArray();
    }   

    /**
	 * Trae la lista de los atributos tipo lista
     *
	 * @param   int $id_contenedor identificador del atributo
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return  array arreglo con las opciones de la lista
     */  

	function traer_lista_atributos($id_idioma, $id_contenedor)
    {
		$atributo_opciones = new Prd_atributos_opciones;
		$atributo_opciones->whereAdd("id_contenedor = '$id_contenedor'");

		$atributo_opciones_versiones = new Prd_atributos_opciones_versiones;
		$atributo_opciones_versiones->id_idioma = $id_idioma; 

		$atributo_opciones->joinAdd($atributo_opciones_versiones);
		$atributo_opciones->find();	
		$lista_opciones = new ArrayList();
		while ($atributo_opciones->fetch()) {
			$lista_opciones->add(array("id_objeto" =>  $atributo_opciones->id_objeto,
									   "id_contenedor" =>  $atributo_opciones->id_contenedor,
									   "nombre" => $atributo_opciones->nombre));
		}
		return $lista_opciones->toArray();
	}
				
  

    /**
	 * lista todos los atributo de una categoria o un porducto
     *
	 * @param   int $id_idioma identificador del idioma del atributo
	 * @param   int $tipo tipo de objeto al que se le adiciona el atributo
	 * @param   int $id_contenedor identificador del objeto al que se le aplica el atributo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function modificar_atributo($id_idioma, $id_atributo, $nombre_atributo, $posicion)
    {
		for($j = 0; $j < $posicion; $j++){
			$atributo_versiones = new Prd_atributos_versiones;
			$atributo_versiones->whereAdd("id_idioma = '$id_idioma'");
			$atributo_versiones->whereAdd("id_objeto = '$id_atributo[$j]'");
			$atributo_versiones->nombre = $nombre_atributo[$j];
			$atributo_versiones->update();  
		}
		return;   

		//Escribe en el log
		Util::log('Productos', 'Modificar Atributo', 'Se modifico el atributo con exito');


	}

    /**
	 * Elimina un atributo
     *
	 * @param   int $id_atributo identificador del atributo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function eliminar_atributo($id_atributo)
    {
		$atributo_versiones = new Prd_atributos_versiones;
		$atributo_versiones->get('id_objeto', $id_atributo);
		$atributo_versiones->delete();     

		$atributo = new Prd_atributos;
		$atributo->get($id_atributo);
		$bandera = $atributo->delete();   

		//Escribe en el log
		if($bandera > 0) 
			Util::log('Productos', 'Eliminar atributo', 'Se elimino el atributo con exito');
		else
			Util::log('Productos', 'Eliminar atributo', 'No se elimino el atributo');
	
	}

    /**
	 * verifica si existen valores de atributos en una categoria 
     *
	 * @param   int $id_atributo identificador del atributo
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function exite_valor($id_categoria) {
        $valor = new Prd_atributos_valores;
		$valor->get('id_contenedor', $id_categoria);
		$bandera = $valor->find(true);
        return $bandera;
	}

    /**
	 * Asigna los valores de atributos para los productos nuevos
     *
	 * @param   int $id_version Identificador de la version del producto
	 *          array $atributos_ids Lista de identificadores de atributos
	 *          array $valores_atributor Lista de valores de los atributos
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */   
	function modificar_lista_atributos($id_version, $atributos_ids, $valores_atributos) 
	{
		foreach ($atributos_ids as $k => $id_atributo) {
			$valor_atributo = new Prd_atributos_valores;
			$valor_atributo->whereAdd("id_producto = '$id_version'");
			$valor_atributo->whereAdd("id_contenedor = '$id_atributo'");
			if (!$valor_atributo->find(true)){
				$valor_atributo->id_producto = $id_version;
				$valor_atributo->id_contenedor = $id_atributo;
				$valor_atributo->insert();
			}
			$valor_atributo->valor = $valores_atributos[$k];
			$valor_atributo->update();
		}

		return;
	}

    /**
	 * Asigna los valores de atributos para los productos nuevos
     *
	 * @param   int $id_version Identificador de la version del producto
	 *          array $atributos_ids Lista de identificadores de atributos
	 *          array $valores_atributor Lista de valores de los atributos
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */  
	function asginar_valores_atributos($id_version, $atributos_ids, $valores_atributos)
	{
		foreach ($atributos_ids as $k => $id_atributo) {
			if($valores_atributos[$k] != ""){ 
				//echo $k."<br>";
				$valor_atributo = new Prd_atributos_valores;
				
				$valor_atributo->id_producto = $id_version;
				$valor_atributo->id_contenedor = $id_atributo;
				$valor_atributo->valor = $valores_atributos[$k];
				
				$valor_atributo->insert();
			}     
		}

		return;
	}

    /**
	 * Quita una imagen de un producto o una categoria 
     *
	 * @param   int $id_objeto identificador del producto/categoria
	 * @param   string $foto imagen a quitar
	 * @param   string $tipo categoria/producto
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  

	function quitar_imagen($id_objeto, $foto, $tipo) {
		if($tipo == 'categoria')
           $entidad = new Prd_categorias_productos_versiones;
		else
		   $entidad = new Prd_productos_versiones;

		$elemento = $entidad;
		$elemento->get('id_objeto', $id_objeto);
		$elemento->imagen = "";
		$elemento->update(); 

		$path_sitio =  $_SESSION['sitio']['url'];
		$path_sitio = Util::fuera($path_sitio);
		$dir_contenido = "imagenes_cont/".$path_sitio;
		unlink($dir_contenido . $foto); 
	}

    /**
	 * Trae el url del objeto en el arbol
     *
	 * @param int $id_objeto identificador del producto/categoria
	 *        string $tipo Tipo de objeto
	 *
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return url del objeto en el arbol	
     */  
	function url_objeto($id_objeto, $tipo, $id_idioma)
	{
		// Obtenemos el objeto
		$nombre_clase = ($tipo == 'producto') ? "Prd_productos" : "Prd_categorias_productos";
		$nombre_clase .= '_versiones';
		$obj = new $nombre_clase;
		$obj->setid_objeto($id_objeto);
		$obj->setid_idioma($id_idioma);
		$obj->find(true);
		
		// Construimos el url del objeto
		$url = 'index.php?view=src/productos/vistas/';
		$url .= ($tipo == 'producto') ? 'opciones_producto.php' : 'opciones_categoria.php';
		$url .= ($tipo == 'producto') ? '&id_objeto=' : '&id_categoria=';
		$url .= $id_objeto;
		$url .= '&nombre=' . $obj->nombre;
		
		return $url;
	}

    /**
 	 * Baja un producto de posicin
     *
	 * @param   int $id_producto identificador del producto
	 * @param   int $id_categoria identificador del contenedor
	 * @author  Maria Luisa Manyoma
     * @access  public
    */  
	function bajar_producto($id_producto, $id_categoria){
		$producto = new Prd_productos;
		
		$producto->get($id_producto);
        $posicion_actual = $producto->posicion;
		$id_producto = $producto->id_objeto;
		
		$sql = "SELECT id_objeto, posicion 
				FROM $producto->__table 
				WHERE posicion > $producto->posicion  AND id_contenedor = $id_categoria ORDER BY posicion ASC";

		$producto->query($sql);
		$producto->fetch();
        $posicion_nueva = $producto->posicion;
		$id_otro_producto = $producto->id_objeto;

		$producto->get($id_producto);		
		$producto->posicion = $posicion_nueva;
		$producto->update();    

		$producto = new Prd_productos;
		$producto->get($id_otro_producto);
		$producto->posicion = $posicion_actual;
		$producto->update();    

		return;
	}

    /**
 	 * Sube un producto de posicion
     *
	 * @param   int $id_producto identificador del articulo
	 * @param   int $id_categoria identificador del contenor 
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function subir_producto($id_producto, $id_categoria){
		$producto = new Prd_productos;
		
		$producto->get($id_producto);
        $posicion_actual = $producto->posicion;
		$id_producto = $producto->id_objeto;
		
		$sql = "SELECT id_objeto, posicion 
				FROM $producto->__table 
				WHERE posicion < $producto->posicion AND id_contenedor = $id_categoria ORDER BY posicion DESC";


		$producto->query($sql);
		$producto->fetch();

        $posicion_nueva = $producto->posicion;
		$id_otro_producto = $producto->id_objeto;

		$producto->get($id_producto);		
		$producto->posicion = $posicion_nueva;
		$producto->update();    

		$producto = new Prd_productos;
		$producto->get($id_otro_producto);
		$producto->posicion = $posicion_actual;
		$producto->update();    
		return;
	}

    /**
 	 * Busca la ltima posicin de un producto dentro de una categoria
     *
	 * @param   int $id_categoria identificador de la categoria
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function buscar_posicion($id_categoria){
		$producto = new Prd_productos;
		$sql = "SELECT posicion 
				FROM $producto->__table 
				WHERE id_contenedor = $id_categoria ORDER BY posicion DESC";

		$producto->query($sql);
		$producto->fetch();

		return $producto->posicion;
	}

    /**
 	 * Eliminar lista de productos
     *
	 * @param   array arreglo con los producto a eliminar
	 * @author  Maria Luisa Manyoma
     * @access  public
     */  
	function borrar_lista_productos($lista_productos){

        foreach ($lista_productos as $k => $id_producto){
			$producto_versiones = new Prd_productos_versiones;
			$producto = new Prd_productos;
			$producto_versiones->get('id_objeto', $id_producto);
			$producto_versiones->delete();
			$producto->get($id_producto);
			$producto->delete();
		}
		//Escribe en el log
		Util::log('Productos', 'Eliminar lista de atributos', 'Se elimino la lista de productos con exito');


	}

    /**
 	 * Genera la ruta para los archivos generados del catalogo
     *
	 * @param   int $id_objeto Identificador del objeto al cual se le crea la ruta
	 *          array $ruta La direccin del arreglo de rutas
	 * @author  John A. Vargas
     * @access  public
     */  
	function crear_ruta($id_objeto, $ruta)
	{		
		// Se obtiene las categorias del sitio
		$categoria_version = new Prd_categorias_productos_versiones;
		$categoria = new Prd_categorias_productos;
		$categoria->get($id_objeto);
		$categoria_version->id_objeto = $id_objeto;
		$categoria_version->id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$categoria_version->find(true);

		array_push($ruta, array('link' => "index.php?view=vistas/".$_SESSION['sis_idioma']['enctype']."/pagina_$id_objeto.php",
			                    'nombre' => $categoria_version->nombre)); 
							
		if ($categoria->id_contenedor == $categoria->id_modulo)
			return;
		else
			Fachada_Productos::crear_ruta($categoria->id_contenedor, &$ruta);
	}
    /**
 	 * verifica si existen productos en una categoria
     *
     * @param   int $id_categoria Identificador de la categoria a eliminar
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return int total de productos	
     */   		
	function verificar_productos($id_categoria)
	{
		$productos = new Prd_productos;
		$productos->whereAdd("id_contenedor = '$id_categoria'");
		$total_productos = $productos->count();
		return $total_productos;
	}
    /**
 	 * verifica si una categoria tiene subcategorias
     *
     * @param   int $id_categoria Identificador de la categoria a eliminar
	 * @author  Maria Luisa Manyoma
     * @access  public
	 * @return int total de categorias
     */   		
	function verificar_categorias($id_categoria)
	{
		$categorias = new Prd_categorias_productos;
		$categorias->whereAdd("id_contenedor = '$id_categoria'");
		$total_categorias = $categorias->count();
		return $total_categorias;
	}

}

?>