<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/* +----------------------------------------------------------------------+
 * | PHP version 4.3.3                                                    |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003 El grupo Emedia - Telesat                         |
 * +----------------------------------------------------------------------+
 * | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
 * |		  Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
 * |          John Vargas <jhonvargas@telesat.com.co>                     |
 * |          Camilo Torres <ccordoba@telesat.com.co>                     |
 * |          Junior Tello <rtello@telesat.com.co>                        |
 * +----------------------------------------------------------------------+
 * 
 */

/*
 * Es la accion de ingresar al sistema y cargar el menu apropiado
 *
 * @package  Sistema
 * @version  $$
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */
class ingresar_sistemaAction extends Action
{
	/**
	 * Ejecuta el ingreso al sistema
	 *
	 * @access	public
	 * @param	ActionMapping	$actionMapping
	 * @param	ActionForm		$actionForm
	 * @return	ActionForward
	 */
	function perform($actionMapping, $actionForm) { 

		if(Fachada_Sistema::ingresar_sistema($actionForm->get('us_log'), 
										  $actionForm->get('us_pass'))) {
			
			/** Idioma por defecto **/
			$idioma = new Sis_idiomas;
			$idioma->get("nombre", IDIOMA_DEFECTO);
			$_SESSION['sis_idioma'] = $idioma->toArray();
										
			/** Cargar el sitio a administrar por el usuario **/							
			$_SESSION['sitio'] = Fachada_Sistema::cargar_sitio($_SESSION['usuario']['id_contenedor'], $actionForm->get('id_sitio'));

			/** Cargar los modulos seleccionados para el sitio, en los cuales el usuario tiene permisos **/
			if ($actionForm->get('tipo') != 'Usuario')
				$_SESSION['permisos_menu'] = Fachada_Sistema::permisos_menu($_SESSION['sitio']['id_objeto'], $_SESSION['usuario']['id_objeto']);

			/** Idiomas seleccionados para el sitio **/
			$_SESSION['idiomas_sitio'] = Fachada_Sistema::lista_idiomas($_SESSION['sitio']['id_objeto']);
			
			/** Cargar los estilos del archivo .CSS **/
			$_SESSION['fckeditor_comboBoxStyles'] = Fachada_Sistema::extraer_clases_CSS( CSS_SITEFILE );
//define('CSS_FONTSTYLES', Fachada_Sistema::extraer_clases_CSS( CSS_SITEFILE ) );
/*
print_r( $_SESSION['fckeditor_comboBoxStyles'] );
exit();
*/
			$actionForward = $actionMapping->get($actionForm->get('tipo'));		    
		} else {
			$actionForward = $actionMapping->get('login_' . $actionForm->get('tipo'));	
		}
			
		return $actionForward;
	}
}
?>