<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.1.2                                                    |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Equipo de desarrollo Emedia - Telesat             |
// +----------------------------------------------------------------------+
// | Authors: Enrique Eder <ejeder@telesat.com.co>                        |
// |          Maria Luisa Manyoma <mlmanyoma@telesat.com.co>              |
// |          John A. Vargas <jhonvargas@telesat.com.co>                  |
// |          Camilo Torres <ccordoba@telesat.com.co>                     |
// |          Junior Tello <rtello@telesat.com.co>                        |
// +----------------------------------------------------------------------+
//
//
// Clase Fachada que maneja el paquete sistema
//

		/**** MODELO (Conjunto de clases DataObject) ****/
require_once PATH_SISTEMA . 'modelo/Sis_objetos_protegidos.php';
require_once PATH_SISTEMA . 'modelo/Sis_idiomas.php';
require_once PATH_SISTEMA . 'modelo/Sis_versiones.php';
require_once PATH_SISTEMA . 'modelo/Sis_contactos.php';
require_once PATH_SISTEMA . 'modelo/Sis_datos_modulos.php';
require_once PATH_SISTEMA . 'modelo/Sis_estilos_textos.php';
require_once PATH_SISTEMA . 'modelo/Sis_estilos_bodys.php';
require_once PATH_SISTEMA . 'modelo/Sis_hojas_estilos.php';
require_once PATH_SISTEMA . 'modelo/Sis_paginas.php';
require_once PATH_SISTEMA . 'modelo/Sis_paginas_versiones.php';
require_once PATH_SISTEMA . 'modelo/Sis_categorias.php';
require_once PATH_SISTEMA . 'modelo/Sis_sitios.php';
require_once PATH_SISTEMA . 'modelo/Sis_portales.php';
require_once PATH_SISTEMA . 'modelo/Sis_portal_versiones.php';
require_once PATH_SISTEMA . 'modelo/Sis_roles.php';
require_once PATH_SISTEMA . 'modelo/Sis_usuarios.php';
require_once PATH_SISTEMA . 'modelo/Sitio_idioma.php';
require_once PATH_SISTEMA . 'modelo/Sis_paises.php';
require_once PATH_SISTEMA . 'modelo/Sis_profesiones.php';
require_once PATH_SISTEMA . 'modelo/Sis_actividades_economicas.php';
require_once PATH_SISTEMA . 'modelo/Sis_tipo_identificacion.php';
require_once PATH_SISTEMA . 'modelo/Sis_tipo_modulo.php';
require_once PATH_SISTEMA . 'modelo/Sis_grupos.php';
require_once PATH_SISTEMA . 'modelo/Sis_grupos_usuarios.php';
require_once PATH_SISTEMA . 'modelo/Generador_sistema.php';

		/**** CONTROLADOR (Phrame: acciones, formas y mapping) ****/
// Mapeamiento
include(PATH_SISTEMA . 'controlador/mappings.php');

// Formularios
require_once PATH_SISTEMA . 'controlador/forms/ingresar_sistemaForm.php';
require_once PATH_SISTEMA . 'controlador/forms/cambiar_passwordForm.php';
require_once PATH_SISTEMA . 'controlador/forms/validar_loginForm.php';
require_once(PATH_SISTEMA . 'controlador/forms/crear_portalForm.php');
require_once(PATH_SISTEMA . 'controlador/forms/modificar_cabeceraForm.php');
require_once PATH_SISTEMA . 'controlador/forms/crear_usuarioForm.php';
require_once PATH_SISTEMA . 'controlador/forms/mostrar_arbolForm.php';
require_once PATH_SISTEMA . 'controlador/forms/crear_grupoForm.php';

// Acciones
require_once PATH_SISTEMA . 'controlador/actions/ingresar_sistemaAction.php';
require_once PATH_SISTEMA . 'controlador/actions/salir_sistemaAction.php';
require_once PATH_SISTEMA . 'controlador/actions/cambiar_passwordAction.php';
require_once PATH_SISTEMA . 'controlador/actions/hacer_preguntaAction.php';
require_once PATH_SISTEMA . 'controlador/actions/recordar_claveAction.php';
require_once(PATH_SISTEMA . 'controlador/actions/crear_portalAction.php');
require_once(PATH_SISTEMA . 'controlador/actions/escoger_modulosAction.php');
require_once(PATH_SISTEMA . 'controlador/actions/cambiar_idiomaAction.php');
require_once(PATH_SISTEMA . 'controlador/actions/mostrar_sitioAction.php');
require_once(PATH_SISTEMA . 'controlador/actions/buscar_usuariosAction.php');
require_once PATH_SISTEMA . 'controlador/actions/crear_usuarioAction.php';
require_once PATH_SISTEMA . 'controlador/actions/mostrar_arbol_permisosAction.php';
require_once PATH_SISTEMA . 'controlador/actions/asignar_permisosAction.php';
require_once PATH_SISTEMA . 'controlador/actions/mostrar_usuarioAction.php';
require_once PATH_SISTEMA . 'controlador/actions/modificar_usuarioAction.php';
require_once PATH_SISTEMA . 'controlador/actions/eliminar_usuarioAction.php';
require_once PATH_SISTEMA . 'controlador/actions/manejar_cuentaAction.php';
require_once PATH_SISTEMA . 'controlador/actions/verificar_permisoAction.php';
require_once PATH_SISTEMA . 'controlador/actions/modificar_datos_sitioAction.php';
require_once PATH_SISTEMA . 'controlador/actions/ver_datos_sitioAction.php';
require_once PATH_SISTEMA . 'controlador/actions/buscar_gruposAction.php';
require_once PATH_SISTEMA . 'controlador/actions/crear_grupoAction.php';
require_once PATH_SISTEMA . 'controlador/actions/modificar_grupoAction.php';
require_once PATH_SISTEMA . 'controlador/actions/eliminar_grupoAction.php';
require_once PATH_SISTEMA . 'controlador/actions/adicionar_usuarioAction.php';
require_once PATH_SISTEMA . 'controlador/actions/sacar_usuarioAction.php';
require_once PATH_SISTEMA . 'controlador/actions/generar_todoAction.php';

/**
 * Esta clase resive los mensajes de la accin a ejecutar por
 * medio del controlador, es quien interactua con todas las clases
 * entidades (Modelo) del paquete sistema.
 * 
 * Se encarga bsicamente de administrar:
 * --> Mdulos del sistema
 * --> Idiomas
 * --> Apariencia (Estilos de los sitios)
 * --> Usuarios y sus permisos
 *
 * Sus mtodos correspondes con cada una de las acciones a ejecutar
 * desde la interfaz de usuario.
 *
 * @package  Sistema
 * @version  $Id: fachada_sistema.php,v 1.18 2004/07/10 15:28:10 jhonvargas Exp $
 * @author   John A. Vargas <jhonvargas@telesat.com.co>
 * @since    PHP 4.1.2
 */

class Fachada_Sistema
{                      
    /**
      * Crea un nuevo usuario para el sistema
     *
     * @param   string $login Login del usuario
     *          string $password Contrasea del usuario
     * @param   string $pregunta Pregunta para cuando se olvida la contrasea
     * @param   string $respuesta Respuesta para que el sistema le recuerde al 
     *                            usuario cual es su contrasea de acceso.
     * @param   string $nombre Nombre del usuario
     * @param   string $apellido1 Primer apellido del usuario
     * @param   string $apellido2 Segundo apellido del usuario
     * @param   string $tipo_identificacion Tipo de identificacion 
     * @param   int $identificacion Identificacion
     * @param   string $email Correo electrnico del usuario
     * @param   string $cargo Cargo desempeado 
     * @param   int $telefono1 Telfono
     * @param   int $telefono2 Telfono alterno
     * @param   string $empresa Nombre de la empresa
     * @param   int $celular Telfono mvil
     * @param   string $sexo Sexo: M, F
	 *
     * @access  public
     * @return  int Identificador del nuevo usuario
	 * @static
     */               
    function crear_usuario( $login, $password, $pregunta, $respuesta, 
                            $nombre, $apellido, $tipo_identificacion,
                            $identificacion, $email, $id_contenedor = '0', $id_contacto = 0)
    {	
        // Creacin del usuario (Informacin General)
        $usuario = new Sis_usuarios;
        $usuario->setnombre($login);
        $usuario->setpassword(md5($password));
        $usuario->setpregunta($pregunta);
        $usuario->setrespuesta($respuesta);
        
        // Informacin detallada del usuario
        $info_usuario = new Sis_contactos;
		if ($id_contacto) $info_usuario->get($id_contacto);
		
		$info_usuario->nombres = $nombre;
		$info_usuario->apellido1 = $apellido;
		$info_usuario->tipo_identificacion = $tipo_identificacion;
		$info_usuario->identificacion = $identificacion;
		$info_usuario->email = $email;
                            
        // Asignar la informacin detallada al usuario  
		if ($id_contacto)                  
			$info_usuario->update();
		else
			$id_contacto = $info_usuario->insert();
		
        $usuario->id_contacto = $id_contacto;
    
        $usuario->id_contenedor = $id_contenedor;
                
        // Se crea el registro del usuario
        $id = $usuario->insert();
		 
		$mensaje = ($id) ? 'El usuario se cre con xito' : 'Error al crear el usuario';
        Util::log('Sistema', 'Crear Usuario', $mensaje);
		
        return $id;
    }
    
    /**
      * Crea un nuevo usuario para el sistema
     *
     * @param string $rol Papel que juega el usuario, por defecto no tiene un rol
     *               asignado, los tipos de roles son:
     *               adminSistema -> Administrador del sistema
     *               adminPortal -> Administrador de Portal
     *               adminSitio -> Administrador de Sitio
     * @param   int $id_obj Identificacion del usuario
     * @param   int $id_objeto Objeto incial al que el usuario va a tener permiso
     * @access  public
	 * @static
     */       
    function asignar_role($role, $id_usuario, $id_objeto)
    {
        // Se intancia el permiso del role
        $rol = new Sis_roles;
  	    $rol->id_usuario = $id_usuario;          
        $rol->id_objeto = $id_objeto;    
		
		$metodo = ($rol->find(true)) ? 'update' : 'insert';      
		$rol->tipo = $role;  

        // Se crea el registro en la base de datos
        $mensaje = ($rol->$metodo()) ? 'Se creo exitosamente' : 'Error al crear el rol';
		Util::log('Sistema', 'Asignar permisos', $mensaje);
    }
    
    /**
     * Consultar si un usuario tiene determinado permiso sobre un objeto
	 * la consulta se hace de forma recursiva sobre la jerarquia de contenimiento
     *
     * @param   int $id_usuario Usuario que actua sobre el objeto.
     * @param   int $id_objeto Objeto a modificar.
     * @param   string $permiso Permiso a consultar.
	 *
	 * @return  boolean Verdadero si tiene permiso falso en caso contrario
	 * @author John Vargas
     * @access  public
	 * @static
     */       
    function chequear_permiso($id_usuario, $id_objeto, $permiso) 
    {
		$rol = new Sis_roles;
				
		$rol->id_usuario = $id_usuario;
		$rol->id_objeto = $id_objeto;
		
		if (isset($_SESSION['usuario']['admin'])) return true;

        // Caso trivial
		if ($rol->find(true)) { 
			return ($rol->tipo & $permiso);
		} else {
			$obj = new Sis_objetos_protegidos;
			$obj->get($id_objeto);
			if ($obj->id_contenedor == '')
				return false;

			// Llamado a la funcion recursiva sobre la jerarquia de contenimiento		
			$result = Fachada_Sistema::chequear_permiso ($id_usuario, $obj->id_contenedor, $permiso);
			
			// Hacer la bsqueda para los grupos a los que pertenece el usuario en caso de no haber permiso
			if (!$result) {
				$grupo_usuario = new Sis_grupos_usuarios;
				$grupo_usuario->id_usuario = $id_usuario;
				$grupo_usuario->find();
				while ($grupo_usuario->fetch() && !$result)
					$result  = Fachada_Sistema::chequear_permiso ($grupo_usuario->id_grupo, 
																  $obj->id_contenedor, 
																  $permiso);
			}
			
			return $result;
		}
    }
    
    /**
      * Permitir el cambio de password de un usuario que esta logueado
     *
     * @param   string $login login del Usuario.
     * @param   string $nuevo_password Nuevo password del usuario.
     * @access  public
	 * @static
     */       
    function cambiar_password($nuevo_password) 
    {
        $usuario_cambiar = new Sis_usuarios;
        $id_user = $_SESSION['usuario']['id_objeto'];
		$usuario_cambiar->get($id_user);
		$usuario_cambiar->password = md5($nuevo_password);
		$mensaje = ($usuario_cambiar->update()) ? " Se cambi con xito " : "Problemas de DB al cambiar";
		
		$_SESSION['usuario'] = $usuario_cambiar->toArray();
		Util::log('Sistema', 'Cambiar clave', $mensaje);
	   return 1;
    }
    
    /**
      * Valida el ingreso de un usuario al sistema de adminstracin
     *
     * @param   string $login Apodo  alias del usuario en el sistema.
     * @param   string $password Contrasea de ingreso.
     * @access  public
     * @return boolean dice si el usuario a ingresar es vlido.
	 * @static
     */       
	function ingresar_sistema($login, $password)
    {
        $valido = false;
        $usuario = new Sis_usuarios;

		$valido = $usuario->get("nombre",$login) ? ($usuario->password == $password) : Util::cms_usuarios($login, $password);
    	
        switch ($valido) {
			case 1:
			    $_SESSION['usuario'] = $usuario->toArray();
				if(!$_SESSION['usuario']['id_contenedor'])
					 $_SESSION['usuario']['id_contenedor'] = $_SESSION['usuario']['admin'] = 1;
			    Util::log('Sistema','Ingresar_sistema','Password satisfactorio');
			break;
           	case 0:
			    $_SESSION['mensaje_ingreso'] = "Password invalido";
	    	    Util::log('Sistema','Ingresar_sistema','Password  incorrecto');
			break;
			case 2:
				$_SESSION['mensaje_ingreso'] = "EL login $login no existe en el sistema";
				 Util::log('Sistema','Ingresar_sistema','El Login no existe');
			break;
	    }

        return ($valido == 1);
    }
    
    /**
     * Consulta el perfil del usuario para saber que men cargar
     * en el administrador
     *
     * @param   int $id_usuario Identificador del usuario
     * @access  public
     * @return string Perfil  role del usuario
	 * @static
     */       
    function obtener_role($id_usuario)
    {
        $role = new Sis_roles;
        $role->id_usuario = $id_usuario;
		$role->orderBy('tipo DESC');
		
		return ($role->find(true)) ? $role->tipo : 0;
    }
    
    /**
 	 * Busca el Portal del usuario y lo carga en session
     *
     * @param   int $id_sitio Identificador del sitio
     *
	 * @author  John Vargas
     * @access  public
	 * @static
     */    	
	function cargar_sitio($id_sitio, $id_sitio2 = '') 
	{
		$sitio = new Sis_portales;
		$sitio_version = new sis_portal_versiones;
		if ($id_sitio2 != '') $id_sitio = $id_sitio2; 
		
		$sitio->get($id_sitio);  
		$sitio_version->setid_idioma($_SESSION['sis_idioma']['id_idioma']);
		$sitio->joinAdd($sitio_version);
		$sitio->selectAs();
		$sitio->selectAs($sitio_version, 'ver_%s');
		
		$sitio->find(true);
		
		return get_object_vars($sitio);
	}
    
    /**
 	 * Valida que no exista un usuario con el mismo login
     *
     * @param   string $login Login del nuevo usuario
     *
	 * @return bool False en caso de que exista un usuario con el mismo login
	 * @author  John Vargas
     * @access  public
	 * @static
     */    
	 function validar_datos_usuario($login)
	 {
	 	$usuario = new Sis_usuarios;

		return $usuario->get("nombre",$login);
	 }
	 
    
    /**
 	 * Obtiene una lista de paises para los formularios
     *
     * @param   int $id_idioma Identficador del idioma del sitios
     *
	 * @return array Listado de los paises en el idioma de session
	 * @author  John A. Vargas
     * @access  public
	 * @static
     */   
	 function listar_paises($id_idioma)
	 {
	 	$paises = new sis_paises;
		$paises->id_idioma = $id_idioma;
		$paises->orderBy('nombre');
		$paises->find();
		$paises_array = array();
		while ($paises->fetch()) 
			array_push($paises_array, $paises);
		
		return $paises_array;
	 }
	 
    
    /**
 	 * Obtiene la pregunta de un usuario.
     *
     * @param   string $login Login del usuario
     *
	 * @return  string  La pregunta del usuario para una nueva contrasea.
	 * @author  John Vargas
     * @access  public
	 * @static
     */   
	 function obtener_pregunta($login)
	 {
	 	$usuario = new Sis_usuarios; 
		$usuario->get("nombre", $login); 
		
		return $usuario->pregunta;
	 }
	 
    
    /**
 	 * Asigna una nueva clave al usuario si la respuesta es correcta
     *
     * @param   string $login Login del usuario
     * @param   string $respuesta Respuesta del usuario
     *
	 * @return  bool Verdadero si la respuesta es correcta, falso en caso contrario
	 * @author  John Vargas
     * @access  public
	 * @static
     */   
	 function recordar_clave($login, $respuesta)
	 {
	 	$usuario = new Sis_usuarios; 
		$usuario->get("nombre", $login); 
		
		if ($respuesta == $usuario->respuesta) {
			$contacto = new Sis_contactos;
			$contacto->get($usuario->id_contacto);
			
			$recipients = $contacto->email;

			$headers['From']    = 'info@cms.telesat.com.co';
			$headers['To']      = $contacto->email;
			$headers['Subject'] = 'Recordar contrasea';
			
			$nuevo_password = substr(md5(time()), 0, 8);
			$usuario->password = md5($nuevo_password);
			$usuario->update();
			$body = "El sistema de " . NOMBRE_PORTAL . " le acaba de asignar la siguiente contrasea: ";
			$body .= $nuevo_password . ", por favor intente ingresar y cambie la contrasea por una que usted fcilmente pueda recordar. ";
			
			$mail_object =& Mail::factory('mail');
			
			$mail_object->send($recipients, $headers, $body);
		
			return true;
		}else
			return false;
		
	 }
	
	/**
	 * Crea un registro de portal en la base de datos
	 *
	 * @param    string $nombre Nombre del portal
	 * @param    string $descripcion Descripcion del portal
	 * @param    string $url Direccin para internet del portal desde el nombre del host
	 * @param    int $id_usuario Identificador del usuario propietar
	 *
	 * @return array Hash con los datos del sitio creado
	 * @author John A. Vargas
	 * @static
	 */
	function crear_portal($nombre, $descripcion, $url)
	{
        $sis_portal = new Sis_portal_versiones;
        $sis_portal->get('nombre',NOMBRE_PORTAL);
		
		// Datos basicos del portal
		$portal = new Sis_portales;
		$portal->id_contenedor = $sis_portal->id_objeto;
		$portal->url = util::fuera($url);
		
		$portal_v = new Sis_portal_versiones;
		$portal_v->nombre = $nombre;
		$portal_v->descripcion = $descripcion;
		$portal_v->logotipo = "mod_log.gif";
		
		// Hoja de estilo por defecto del sitio
		$hoja_estilo = new Sis_hojas_estilos;
		$hoja_estilo->get("nombre","clasico");
		$portal->id_hoja_estilo = $hoja_estilo->id_objeto;
		$portal->insert();
		
		// Idioma por defecto del sistema
		$idioma_defecto = new Sis_idiomas;
		$idioma_defecto->get("nombre", IDIOMA_DEFECTO);
			
		$portal_v->id_idioma = $idioma_defecto->id_idioma;
		$portal_v->id_objeto = $portal->id_objeto;
		$portal_v->insert();

		// Imagen logo por defecto
		if ($url != ""){
			System::mkdir ("imagenes_cont/$url");
			copy(PATH_SISTEMA . "vistas/imagen/mod_log.gif","imagenes_cont/$url/mod_log.gif");
		}
		
		// Asignar el idioma por defecto para el sitio
		$version = new Sitio_idioma;
		$version->id_idioma = $idioma_defecto->id_idioma;
		$version->id_sitio = $portal->id_objeto;
		$version->insert();
		
		// Se crea el modulo de articulos del sitio
		$datos_modulo_articulo = new Art_datos_modulos_articulos;
		$datos_modulo_articulo->id_contenedor = $portal->id_objeto;
		$id_datos_modulo = $datos_modulo_articulo->insert();	
				
		// Categoria raiz del sitio
		
		$id_categoria = Fachada_Contenido::insertar_categoria($idioma_defecto->id_idioma,
											  "Contenido", //$nombre,
											  "Categoria Raiz de {$portal_v->nombre}",//$descripcion,
											  $id_datos_modulo, //$id_contenedor,
											  $portal->id_hoja_estilo, //$id_estilo,
											  1, // Padre
											  4 // Plantilla resumen
											 );
		$categoria_raiz = new Art_categorias_articulos;
		$categoria_raiz->get($id_categoria);
		$categoria_raiz->id_idioma = $idioma_defecto->id_idioma;
		$categoria_raiz->update();
				
		return $portal->toArray();		
	}
    
   /**
     * Adiciona idiomas al sitio
     *
     * @param int $id_sitio Identificador del portal
	 * @param array $modulos Listado de modulos a adicionar
     *
     * @author  John Vargas
     * @access  public
	 * @static
     */            
    function adicionar_idiomas ($id_sitio, $idiomas)
	{
		foreach ($idiomas as $id_idioma) {
			$version = new Sitio_idioma;
			$version->id_sitio = $id_sitio;
			$version->id_idioma = $id_idioma;
			$version->insert(); 
		}
	}
    
   /**
     * Adiciona modulos al portal 
     *
     * @param int $id_portal Identificador del portal
	 * @param array $modulos Listado de modulos a adicionar
     *
     * @author  John Vargas
     * @access  public
	 * @static
     */            
    function adicionar_modulos ($id_portal, $modulos)
	{
		$portal = new Sis_portales;
		$portal->get($id_portal);
		
		$clases = get_declared_classes();
		if (!isset($modulos)) $modulos = array();
		
		foreach ($modulos as $mod) {
			// Buscamos la clase correspondiente al modulo
			$encontro = false; $i = 0;
			while (!$encontro && $i < sizeof ($clases))
				if (ereg('datos_modulos_'.$mod.'$', $clases[$i++]))
					$encontro = true;
				
			// Se instancia el modulo correspondiente
			$dato_modulo = new $clases[$i-1];
			$dato_modulo->id_contenedor = $portal->id_objeto;
			$dato_modulo->insert(); 
			
			// configurar cada modulo
			$clase = "Fachada_" . ucwords($mod);
			$configurar = "configurar_" . $mod;
			
			$fch_modulo = new $clase; 
			if (method_exists ( $fch_modulo, $configurar))
				$fch_modulo->$configurar($id_portal);
		}
	}
		
    /**
 	 * Cambia el estilo del portal
     *
     * @param   int $id_objeto Identificador del portal
     * @param   int $id_estilo Identificador de la hoja de estilo nueva
	 * @author  John A. Vargas
     * @access public
	 * @static
	 */
	function modificar_estilo($id_objeto, $id_estilo) 
	{
		$sitio = new sis_portales;  
		$sitio->get($id_objeto);
		$sitio->id_hoja_estilo = $id_estilo;
		$sitio->update();
		
		$_SESSION['sitio'] = $sitio->toArray();
		
		return;
	}
	
	/*
	 * Hace la generacion de el portal
	 * @param int $id_sitio Identificador del sitio a generar
	 * @param string $dir Directorio donde el sitio ser generado
	 *
	 * @author John A. Vargas
	 * @access public
	 * @static
	 */
	function generar_sitio($id_sitio, $dir = "html/")
	{
		$generador = new Generador($id_sitio, $dir); 
		$generador->generar_portal();
		
		return $generador->path_sitio;	
	}
	
	/*
	 * Genera el menu con los items de los modulos del sitio (Portal)
	 * @param int $id_sitio Identificador del sitio
	 * @param int $id_usuario Identificador del usuario logeado
	 *
	 * @author John A. Vargas
	 * @return array Listado de los modulos del sitio
	 * @access public
	 * @static
	 */	 
	 function permisos_menu($id_sitio, $id_usuario)
	 {
		global $modulos_default;
	 
		$modulo = new Sis_datos_modulos;
	
		// Se obtienen los modulos del sitio
		$modulo->id_contenedor = $id_sitio; 
		$modulo->find();
	
		// Modulos adicionados al sitio
		$lista_modulos = new ArrayList(); 
		while ($modulo->fetch()) {
			$tipo = new Sis_tipo_modulo;
			$tipo->get($modulo->id_tipo);
	
			if (!in_array($tipo->carpeta, $modulos_default)) {
				// Averiguar si el usuario accede al modulo
				$permiso_obj = Fachada_Sistema::traer_permiso($id_usuario, $modulo->id_objeto) & ALIMENTAR; 
				$permiso_mdl = Fachada_Sistema::chequear_permiso($id_usuario, $modulo->id_objeto, ALIMENTAR); 
		
				if ($permiso_obj || $permiso_mdl) {
					$mdl = new HashMap;
					$mdl->put('nombre', $tipo->nombre);
					$mdl->put('descripcion', $tipo->descripcion);
					$mdl->put('carpeta', $tipo->carpeta); 
		
					$lista_modulos->add($mdl->values());
				}
			}
		}	
	
		// Modulos por defecto del sitio
		$lista_defecto = new ArrayList();
		
		// Usuarios
		if (Fachada_Sistema::obtener_role($id_usuario) & ADMINISTRAR) 
			$lista_defecto->add('usuarios'); 
			
		// Contenido	
		$modulo = new Art_datos_modulos_articulos;
		$modulo->get('id_contenedor', $id_sitio);
		if (Fachada_Sistema::traer_permiso($id_usuario, $modulo->id_objeto) & ALIMENTAR ||
		    Fachada_Sistema::chequear_permiso($id_usuario, $modulo->id_objeto, ADMINISTRAR))
			$lista_defecto->add('contenido');
			
		// Menu
		$modulo = new Men_datos_modulos_menus;
		$modulo->get('id_contenedor', $id_sitio);
		if (Fachada_Sistema::traer_permiso($id_usuario, $modulo->id_objeto) & ALIMENTAR ||
		    Fachada_Sistema::chequear_permiso($id_usuario, $modulo->id_objeto, ADMINISTRAR))
			$lista_defecto->add('menu');

		$permisos = new HashMap;
		$permisos->put('modulos', $lista_modulos->toArray());
		$permisos->put('defecto', $lista_defecto->toArray());

		return $permisos->values();
	 }
	
	/*
	 * Obtiene la lista de idiomas para un sitio
	 * @param int $id_sitio Identificador del sitio
	 *
	 * @author John A. Vargas
	 * @return array Listado de idomas del sitio
	 * @access public
	 * @static
	 */	 
	 function lista_idiomas($id_sitio = 0)
	 {
	 	$idioma = new Sis_idiomas;

		// Buscar los idiomas que hayan sido seleccionados para el sitio
		if ($id_sitio) {
			$sitio_idioma = new Sitio_idioma;
			$sitio_idioma->id_sitio = $id_sitio;
			$sitio_idioma->find();
			
			while ($sitio_idioma->fetch())
				$idioma->whereAdd(" id_idioma = '{$sitio_idioma->id_idioma}'","OR");
		}
		
		$idioma->find();
		
		$lista_idiomas = array();
		while ($idioma->fetch()) 
			array_push($lista_idiomas, $idioma->toArray());
			
		return $lista_idiomas;
	 }
	
	/*
	 * Crea una versin del objeto en otro idioma
	 * @param referencia $objeto Referencia del objeto en otra versin.
	 * @param int $id_idioma Identificador del idioma de la nueva versin.
	 *
	 * @author John A. Vargas
	 * @access public
	 * @static
	 */	 
	 function crear_version($objeto, $id_idioma)
	 {			
		unset($objeto->id_idioma);
		$objeto->orderBy("id_idioma");
		$objeto->find(true);
		$objeto->id_idioma = $id_idioma;
		
		unset($objeto->id_versiones);
		$objeto->insert(); 
	 }
	
	/*
	 * Verificar si un login de usuario no esta repetido en el sistema
	 * @param string $login Login a verficar.
	 *
	 * @author John A. Vargas
	 * @access public
	 * @static
	 */	 
	 function validar_login($login)
	 {			
	 	$usuario = new Sis_usuarios;
		$usuario->nombre = $login;
		
		return (!$usuario->find(true));
	 }
	
	/*
	 * Verificar si un sitio ya tiene el url
	 * @param string $url Url a verificar 
	 *
	 * @author John A. Vargas
	 * @access public
	 * @static
	 */	 
	 function validar_url($url)
	 {			
	 	$sitio = new Sis_sitios;
		$sitio->url = Util::Fuera($url);
		
		return (!$sitio->find(true));
	 }
    
    /**
 	 * Cambia los datos de una cabecera
     *
     * @param   int $id_sitio identificador del sitio al que pertenece la cabecera
     * @param   int $archivo_logo Archivo con el logo de la cabecera
     * @param   int $archivo_slogan Archivo con el background del slogan
     * @param   int $texto_slogan Texto que va en el slogan de la cabecera
     *
	 * @author  John A. Vargas
     * @access  public
     */    	
    function modificar_cabecera ($id_sitio, $archivo_logo, $archivo_slogan, $texto_slogan, $idioma)
    {
		$sitio = new Sis_sitios;
		$sitio->get($id_sitio);

        $path_images = "imagenes_cont/" . $sitio->url . "/";
        $cabecera = new sis_portal_versiones;
        $cabecera->id_objeto = $id_sitio;
		$cabecera->id_idioma = $idioma;
		$cabecera->find(true); 
		
		// Copiar imagen Logo
		if ($archivo_logo['name'] != "") {
			$name_file = time() . $archivo_logo['name'];
	        if (Imagen::copiar_imagen($archivo_logo, $path_images . $name_file) == 1){ 
				if(preg_match("/^\d+/",$cabecera->logotipo))
					unlink($path_images . $cabecera->logotipo); 
	            $cabecera->logotipo = $name_file;
			}
		}
		
		// Copiar imagen de background
		if ($archivo_slogan['name'] != "") {
			$name_file = time() . $archivo_slogan['name'];
	        if (Imagen::copiar_imagen($archivo_slogan, $path_images . $name_file) == 1) {
				if(preg_match("/^\d+/",$cabecera->background))
					unlink($path_images . $cabecera->background);
	            $cabecera->background = $name_file; 
	        }
		}
		
		// Texto del slogan
        if ($texto_slogan != '') 
       		$cabecera->slogan = $texto_slogan;
        
        $cabecera->update(); 
		
		/*
		if ($sitio->publicado == "t")
			Fachada_Minisitios::generar_minisitio($id_sitio,"");*/
        
        return 1;
    }
    
    /**
 	 * Carga los datos de la cabecera en una sesion para ser desplegados
     *
     * @param int $id_sitio identificador del sitio al que pertenece la cabecera
     * @param int $id_idioma Identificador del idioma en que se esta administrando
     *
	 * @author  John A. Vargas
	 * @return array Arreglo asociativo de la cabecera
     * @access public
     */    		
	function cargar_cabecera($id_sitio, $id_idioma)
	{
		$cabecera = new sis_portal_versiones;
		$cabecera->id_objeto = $id_sitio;
		$cabecera->id_idioma = $id_idioma; 
		if(!$cabecera->find(true))
			Fachada_sistema::crear_version(&$cabecera, $id_idioma);
				
		return $cabecera->toArray();
	}
    
    /**
 	 * Busca usuarios en el sistema
     *
     * @param string $nombre Nombre de los usuarios 
     * @param string $login Login del usuario
     * @param string $email Direccin electrnica del usuario
     * @param string $identificacion Identificacin del usuario
     *
	 * @author  John A. Vargas
	 * @return array Arreglo asociativo con la lista de usuarios y los datos de paginacion
     * @access public
	 * @static
     */    
	 function buscar_usuarios($from, $nombre, $login, $email, $identificacion, 
	 						  $tipo_doc, $id_sitio, $id_grupo)
	 {
	 	$usuario = new Sis_usuarios;
		$contacto = new Sis_contactos;

		// Datos de contacto
		if ($nombre != '') { 
			$usuario->whereAdd("( LOWER(sis_contactos.nombres) LIKE LOWER('%$nombre%')");	
			$usuario->whereAdd("LOWER(sis_contactos.apellido1) LIKE LOWER('%$nombre%') )",'OR');
		}

		if ($email != '')
			$usuario->whereAdd("LOWER(sis_contactos.email) LIKE LOWER('%$email%')");	

		if ($identificacion != '')
			$usuario->whereAdd("LOWER(sis_contactos.identificacion) LIKE LOWER('%$identificacion%')");
			
		if ($tipo_doc != '')
			$usuario->whereAdd("sis_contactos.tipo_identificacion = '$tipo_doc'"); 	
					
		if ($id_grupo != '') {
			$grupo_usuario = new Sis_grupos_usuarios;
			$grupo_usuario->id_grupo = $id_grupo;
			$usuario->joinAdd($grupo_usuario);
		}			
					
		$usuario->joinAdd($contacto); // Se une usuario a contacto
		$usuario->selectAs();
		$usuario->selectAs($contacto, 'cnt_%s');	
			
		// Datos del usuario	
		if ($login != '')
			$usuario->whereAdd("LOWER(sis_usuarios.nombre) LIKE LOWER('%$login%')");
			
		$usuario->whereAdd("sis_usuarios.id_contenedor = '$id_sitio'");
		
		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0; 
		$data = DB_Pager::getData($from, NUM_REGISTROS, $usuario->count(), MAXPAGES);

		$usuario->limit($from, NUM_REGISTROS);
		$usuario->orderBy('sis_usuarios.nombre'); 
		$usuario->find(); //$usuario->print_query();
	
		$lista_usuarios = array();
		while ($usuario->fetch()) 
			array_push($lista_usuarios, get_object_vars ($usuario));

		return array('lista' => $lista_usuarios, 'data' => $data);
	 }
    
    /**
 	 * Construye al arbol de jerarquia de contenimiento para asignar permisos
     *
     * @param string $cadena Cadena donce queda la informacin del rbol
     * @param int $id_contenedor Identificador del contenedor en la jerarquia
	 * @param int $id_obj Identificador del grupo o usuario a mostrar los permisos
	 * @param string $clase Indica si es un grupo o un usuario
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */    
	 function construir_arbol($cadena, $id_objeto, $id_obj, $clase_obj)
	 {	
	 	$objeto = new Sis_objetos_protegidos;
		$objeto->get($id_objeto);
		
		$usuario = new $clase_obj;
		$usuario->get($id_obj);
		
		// Averiguar si el objeto es o no un modulo
	    $nombre_clase = get_class($objeto->get_hijo());
		$clase_version = ($nombre_clase == 'sis_portales') ? 'sis_portal_versiones' : 'sis_paginas_versiones';
		
		// Si es mdulo entonces traemos el nombre
		if (ereg("datos_modulos", $nombre_clase)) {
			$obj = new $nombre_clase;
			$obj->get($objeto->id_objeto);
			$nombre_objeto = $obj->nombre; 
			$nombre_objeto = "<b>$nombre_objeto</b>";
		} else {
			// Si no es mdulo traemos el nombre de una version existente
			$version = new $clase_version;
			$version->id_objeto = $objeto->id_objeto;
			$version->orderBy('id_idioma');
			$version->find(true); 
			$nombre_objeto = $version->nombre;
			if ($nombre_clase == "sis_portales")
				$nombre_objeto = "<b>$nombre_objeto</b>";
		}	
		
		// Mostrar el permiso del usuario
		$tipo = Fachada_Sistema::traer_permiso($id_obj, $id_objeto);
		
		// Adicionar la cadena de enlace		
		if ($cadena != '')	$cadena .= ', ';

		$cadena .= "['$nombre_objeto', 'index.php?view=src/sistema/vistas/asignar_permisos.php&id_objeto=$id_objeto&nombre=$nombre_objeto&id_obj=$id_obj&publico={$objeto->publico}&tipo=$tipo&nombre_obj={$usuario->nombre}&clase=$clase_obj', 'contenido_mod'";
					
		// Buscar los objeto contenidos
		$clase = ($nombre_clase == "sis_portales") ? 'sis_datos_modulos' : 'sis_paginas';
		$obj_hijos = new $clase;
		$obj_hijos->id_contenedor = $id_objeto;
		$obj_hijos->find(); 
		while ($obj_hijos->fetch()) { 
			// Se tiene permidos sobre el mdulo de usuarios si es administrador del sistema
			// por lo tanto no tiene sentido poner usuarios en el rbol
			if (get_class($obj_hijos->get_hijo()) != "sis_usuarios") 
				Fachada_Sistema::construir_arbol(&$cadena, $obj_hijos->id_objeto, $id_obj, $clase_obj);
		}
		
        $cadena .= "]";
        return;
	 }
    
    /**
 	 * Muestra los datos del usuario a modificar
     *
     * @param int $id_usuario Identificador del usuario
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */    
	 function mostrar_usuario($id_usuario)
	 {
	 	$usuario = new Sis_usuarios;
		$contacto = new Sis_contactos;
		
		$usuario->get($id_usuario);
		$contacto->get($usuario->getid_contacto());
		
		return array_merge($usuario->toArray(), $contacto->toArray());
	 }           
    
    /**
 	 * Modifica el usuario con los datos suministrados
     *
     * @param int $id_usuario Identificador del usuario a modificar
     *        string $nombre Nombre del usuario
     *        string $apellido Apellido del usuario
     *        string $identificacion Identificacion del usuario
     *        string $email Email del usuario
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */    
    function modificar_usuario($id_usuario, $nombre, $apellido, $tipo_id, $identificacion, $email, $pregunta, $respuesta)
    {
        // Creacin del usuario (Informacin General)
        $usuario = new Sis_usuarios;
		$usuario->get($id_usuario);
		
		if ($pregunta != '' && $respuesta != '') {
			$usuario->pregunta = $pregunta;
			$usuario->respuesta = $respuesta;
			$usuario->update();
			$_SESSION['usuario'] = $usuario->toArray();
		}

        // Informacin detallada del usuario
        $info_usuario = new Sis_contactos;
		$info_usuario->get($usuario->id_contacto);
		$original = $info_usuario;
		$info_usuario->nombres = $nombre;
		$info_usuario->tipo_identificacion = $tipo_id;
		$info_usuario->apellido1 = $apellido;
		if ($info_usuario->identificacion !== $identificacion) {
			$info_usuario->identificacion = $identificacion;
		}
		$info_usuario->email = $email;

		if ($info_usuario !== $original)
			$mess = ($info_usuario->update($original)) ? 'Se actualiz con xito' : 'Problemas al actualizar en DB'; 
        Util::log('Sistema', 'Modificar Usuario', $mess);
		
		$_SESSION['user'] = $info_usuario->toArray();
        return;
    }
    
    /**
 	 * Obtiene el maximo permiso de un usuario sobre el el objeto de un modulo
     *
     * @param int $id_usuario Identificador del usuario
     *        int $id_objeto Identificador del objeto.
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */    
	function traer_permiso($id_usuario, $id_objeto) 
    {
		$rol = new Sis_roles;
				
		$rol->id_usuario = $id_usuario;
		$rol->id_objeto = $id_objeto;
		
		if (isset($_SESSION['usuario']['admin'])) return 15;
		
        // Caso trivial
		if ($rol->find(true))
			return $rol->tipo;
		else {
			$obj = new Sis_objetos_protegidos;
			$obj->id_contenedor = $id_objeto;
			$obj->find();
			$max_perm = 0;
			while ($obj->fetch()) {
				$perm = Fachada_Sistema::traer_permiso ($id_usuario, $obj->id_objeto);
				if ($max_perm < $perm)
					$max_perm = $perm;	
			}
			
			$result = $max_perm;
			
			// Hacer la bsqueda para los grupos a los que pertenece el usuario en caso de no haber permiso
			if (!$result) {
				$grupo_usuario = new Sis_grupos_usuarios;
				$grupo_usuario->id_usuario = $id_usuario;
				$grupo_usuario->find();
				while ($grupo_usuario->fetch() && !$result)
					$result  = Fachada_Sistema::traer_permiso ($grupo_usuario->id_grupo, 
																$id_objeto);
			}
			
			return $result;
		}
    }
    
    /**
 	 * Eliminar un usuario 
     *
     * @param int $id_usuario Identificador del usuario
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
	 */
	 function eliminar_usuario($id_usuario)
	 {
	 	$usuario = new Sis_usuarios;
		$usuario->get($id_usuario);
		$mess = ($usuario->delete()) ? 'Se elimin con xito' : 'Problemas al eliminar';
		Util::log('Sistema','Eliminar Usuario',$mess);
	 }
    
    /**
 	 * Obtiene la informacin de contacto del usuario
     *
     * @param int $id_usuario Identificador del usuario
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
	 */
	 function informacion_contacto($id_contacto)
	 {
	 	$contacto = new Sis_contactos;
		$contacto->get($id_contacto);
		
		return $contacto->toArray();
	 }
    
    /**
 	 * Verifica sis se tiene permiso para ingresar un nuevo objeto de la clase dada
     *
     * @param string $clase Nombre de la clase a la que se verificar el limite
     * @return boolean Verdadero si puede ingresar un nuevo objeto, false en caso contrario
	 * @author  John A. Vargas
     * @access public
	 * @static
	 */
	 function verificar_limite($clase)
	 {
		$obj = new $clase;
		$cantidad = $obj->count();
		
		return ($_SESSION['sitio']['num_usuarios'] > $cantidad);
	 }

    /**
 	 * Cambia los datos bsicos de un sitio
     *
     * @param   int $id_sitio identificador del sitio
     * @param   int $id_idioma
     *
	 * @author  Maria Luisa Manyoma
     * @access  public
     */    	
    function ver_datos_sitio ($id_sitio, $id_idioma)
    {
		$sitio = new Sis_portal_versiones;
		$sitio->id_objeto = $id_sitio;
		$sitio->id_idioma = $id_idioma;
		if (!$sitio->find(true))
			Fachada_Sistema::crear_version(&$sitio, $id_idioma);
		return $sitio->toArray();
	}

    /**
 	 * Cambia los datos bsicos de un sitio
     *
     * @param   int $id_sitio identificador del sitio
     * @param   string $nombre_pagina
     * @param   string $metatags
     * @param   string $metakeywords
     *
	 * @author  Maria Luisa Manyoma
     * @access  public
     */    	
    function modificar_datos_sitio ($id_sitio, $nombre_pagina, $metatags, $metakeywords)
    {
		$id_idioma = $_SESSION['sis_idioma']['id_idioma'];
		$sitio = new Sis_portal_versiones;
		$sitio->whereAdd("id_objeto = '$id_sitio'");
		$sitio->whereAdd("id_idioma = '$id_idioma'");
		$sitio->find(true);
		$sitio->nombre_pagina = $nombre_pagina;
		$sitio->metatags = $metatags;
		$sitio->metakeywords = $metakeywords;
		$bandera = $sitio->update(); 
		if($bandera > 0)
			Util::log('Sistema','Modificar datos del Sitio','Se modificaron los datos del sitio con exito');
		else 
			Util::log('Sistema','Modificar datos del Sitio','Error al modificar los datos del sitio');
			
		Generador_sistema::generar_tags();
	}

    /**
 	 * Busca grupos de usuarios
     *
     * @param int    $from Indica desde donde mostrar los regsitros.
     * @param string $nombre Nombre de los usuarios
	 * @param int    $id_sitio Identificador del sitio contenedor
	 * @param int    $id_usuario Identificador de un usuario del grupo
     *
	 * @author  John A. Vargas
	 * @return array Arreglo asociativo con la lista de grupos y los datos de paginacin
     * @access public
	 * @static
     */    
	 function buscar_grupos($from, $nombre, $id_sitio, $id_usuario)
	 {
	 	$grupo = new Sis_grupos;

		// Datos de contacto
		if ($nombre != '') { 
			$grupo->whereAdd(" LOWER(nombre) LIKE LOWER('%$nombre%')");	
		}
		
		if ($id_usuario != '') {
			$grupo_usuario = new Sis_grupos_usuarios;
			$grupo_usuario->id_usuario = $id_usuario;
			$grupo->joinAdd($grupo_usuario);
		}
			
		$grupo->whereAdd("id_contenedor = '$id_sitio'");
		$grupo->orderBy('nombre');
		
		// Paginar los resultados de bsqueda
		if ($from == '') $from = 0; 
		$data = DB_Pager::getData($from, NUM_REGISTROS, $grupo->count(), MAXPAGES);

		$grupo->limit($from, NUM_REGISTROS);
		$grupo->orderBy('nombre'); 
		$grupo->find(); 
	
		// Guardar los registros encontrados en una lista
		$lista_grupos = array();
		while ($grupo->fetch()) 
			array_push($lista_grupos, $grupo->toArray());

		return array('lista' => $lista_grupos, 'data' => $data);
	 }

    /**
 	 * Creacin de grupos
     *
     * @param string $nombre Nombre de los usuarios
     *
	 * @author  John A. Vargas
	 * @return int Identificador del nuevo grupo
     * @access public
	 * @static
     */    
	 function crear_grupo($nombre)
	 {
	 	// Obtenemos el identificador del sitio contenedor
	 	$id_sitio = $_SESSION['sitio']['id_objeto'];
		
		$grupo = new Sis_grupos;
		$grupo->id_contenedor = $id_sitio;
		$grupo->nombre = $nombre;
		return $grupo->insert();
	 }

    /**
 	 * Modificacin de grupos
     *
     * @param int $id_grupo Identificador del grupo
     * @param string $nombre Nombre de los usuarios
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */    
	 function modificar_grupo($id_grupo, $nombre)
	 {
	 	$grupo = new Sis_grupos;
		$grupo->get($id_grupo);
		$grupo->nombre = $nombre;
		$grupo->update();
	 }

    /**
 	 * Eliminacin de grupos
     *
     * @param int $id_grupo Identificador del grupo
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */    
	 function eliminar_grupo($id_grupo)
	 {
	 	$grupo = new Sis_grupos;
		$grupo->get($id_grupo);
		$grupo->delete();
	 }

    /**
 	 * Adiciona un usuario a un grupo
     *
	 * @param int $id_usuario Identificador del usuario
     * @param int $id_grupo Identificador del grupo
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */    
	 function adicionar_usuario($id_usuario, $id_grupo)
	 {
	 	$grupo_usuario = new Sis_grupos_usuarios;
		$grupo_usuario->id_usuario = $id_usuario;
		$grupo_usuario->id_grupo = $id_grupo;
		
		// Si el usuario no esta en el grupo se adiciona a l.
		if (!$grupo_usuario->find(true))
			$grupo_usuario->insert();
	 }

    /**
 	 * Saca un usuario de un grupo
     *
	 * @param int $id_usuario Identificador del usuario
     * @param int $id_grupo Identificador del grupo
     *
	 * @author  John A. Vargas
     * @access public
	 * @static
     */    
	 function sacar_usuario($id_usuario, $id_grupo)
	 {
	 	$grupo_usuario = new Sis_grupos_usuarios;
		$grupo_usuario->id_usuario = $id_usuario;
		$grupo_usuario->id_grupo = $id_grupo;
		
		// Si el usuario no esta en el grupo se adiciona a l.
		if ($grupo_usuario->find(true))
			$grupo_usuario->delete();
	 }

    /**
 	 * Extrae los estilos personalizados (iniciados con punto)
     *
	 * @param String $archivo_estilos Archivo de estilos del sitio
     *
	 * @author  Fernando Rengifo
	 * @modificado	Sonia M. Benavides
     * @access public
	 * @return String
     */    
	function extraer_clases_CSS( $archivo_estilos ){
		//$stylecss = array();
		$fontStyleNames = "";
		$fontStyleValues = "";
		
		while ( is_string($line = File::readLine($archivo_estilos) ) ) { 
		   if (eregi("^(.*)(\.)(.*)({)(.*)$",   $line,$match)){
			 $class = str_replace(".","",trim($match[0]));
			 $class = str_replace("{","",$class);	 
			 //$stylecss[trim($class)] = trim($class); 
			 if ( $fontStyleNames != "" ) {
			 	$fontStyleNames .= "; ";
				$fontStyleValues .= "; ";
			 	}
			 $fontStyleNames .=  trim($class);
			 $fontStyleValues .= trim($class);
		   }
		}

		File::close($archivo_estilos);
		
		//if( sizeof($stylecss) > 0 ) 
		if( $fontStyleNames != "" ) 
//			return "var FCK_editor_FontStyleNames  = '". $fontStyleNames ."' ;" . "var FCK_editor_FontStyleValues = '". $fontStyleValues ."' ; ";
			return $fontStyleNames;
//			return $stylecss;
		else
			return "";
	}// extraer_clases_CSS

}
?>