-- Trigger para la insercin o actualizacin de contactos
-- Evitar duplicados de cdula dado que le campo es unico con herencia.
CREATE OR REPLACE FUNCTION public.proc_unica_cedula_insert()
  RETURNS trigger AS
'
  DECLARE 
	fila sis_contactos%ROWTYPE;
  BEGIN
	SELECT * INTO fila 
	FROM sis_contactos
	WHERE identificacion = NEW.identificacion

	AND id_contacto <> NEW.id_contacto;

	IF fila.identificacion IS NOT NULL THEN
	   RAISE EXCEPTION \'Ya existe un contacto con esa identificacion\';
        END IF;
	
	RETURN NEW;
     END;
 '  LANGUAGE 'plpgsql';

CREATE TRIGGER unica_cedula_insert_sis_contactos 
BEFORE INSERT OR UPDATE
ON sis_contactos
FOR EACH ROW 
EXECUTE PROCEDURE proc_unica_cedula_insert();

CREATE TRIGGER unica_cedula_insert_cpa_afiliados
BEFORE INSERT OR UPDATE
ON cpa_afiliados
FOR EACH ROW 
EXECUTE PROCEDURE proc_unica_cedula_insert();
